/***************************************************************************
                          casemap.h  -  description
                             -------------------
    begin                : Tue Mar 13 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: casemap.h,v 1.16 2008/03/11 21:11:26 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2007-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides case mapping routines
    \version $Id: casemap.h,v 1.16 2008/03/11 21:11:26 ghostvoodooman Exp $
*/

#ifndef CASEMAP_H__
#define CASEMAP_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

using namespace std;

enum e_casemap
{
    CASE_ASCII = 1,     //!< Case mapping ASCII
    CASE_RFC1459,       //!< Case mapping according to RFC1459 (Scandinavian)
};                      //!< Case mapping

string strtolower(string str, e_casemap casemapping = CASE_ASCII);
string strtoupper(string str, e_casemap casemapping = CASE_ASCII);

#endif

