/***************************************************************************
                          conf.h  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: conf.h,v 1.44 2008/03/11 21:11:26 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Configuration file reader
    \version $Id: conf.h,v 1.44 2008/03/11 21:11:26 ghostvoodooman Exp $
*/

#ifndef CONF_H__
#define CONF_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

using namespace std;

bool conf_ssl_init();
void conf_init_pre_start();

/*!
    \brief Stores data from pass.txt
    \author VooDooMan
    \version 1
    \date 2005-08-02
*/
class c_pass
{
public:
    map<string,map<string,string> > sections;   // first is name of section, second is <key,value>

    bool init();
    string get_remote_password_md5(string user);
    void set_remote_password_md5(string user, string md5pass);
    void set_local_password_md5(string user, string md5pass);
    bool get_botnet12_compatibility(string user);
    void set_botnet12_compatibility(string user, bool set);
    bool get_disabled_user(string user);
    void set_disabled_user(string user, bool disabled);
    bool get_ssl_user(string user);
    void set_ssl_user(string user, bool use_ssl);
    string get_local_password_md5(string user);

    int get_zlib_level(string user);
    void set_zlib_level(string user, int level);

    void backup();
    void rehash();
};

#endif
