/***************************************************************************
                          c_dcc_request_whois.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_dcc_request_whois.h,v 1.15 2008/03/25 12:04:24 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_dcc_request_whois'
    \version $Id: c_dcc_request_whois.h,v 1.15 2008/03/25 12:04:24 ghostvoodooman Exp $
*/

#ifndef C_DCC_REQUEST_WHOIS_H__
#define C_DCC_REQUEST_WHOIS_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Stores DCC requests that are pending to establis, and waiting for whois result
    \author VooDooMan
    \version 1
    \date 2004
*/
class c_dcc_request_whois
{
public:
    my_time_t start;                   //!< Timestamp of initialisation

    string str;                     //!< Quoted message
    string nick;                    //!< Nick of user
    string host_mask;               //!< Hostmask of user

    bool got_whois;                 //!< "true" if we got WHOIS of user

    string ident;                   //!< Ident of user
    string host;                    //!< Host of user
    string full_name;               //!< Full name of user
    bool irc_op;                    //!< Is user an irc op?

    bool only_dns;                  //!< true if we just waiting for DNS resolution
    bool dns_done;                  //!< true if we were called irc_quoted_callback() anfter DNS lookup
    string resolv4_1;               //!< For only_dns == true: we are trying to resolve this IP
    string resolv4_2;               //!< For only_dns == true: we are trying to resolve this IP
    string resolv6_1;               //!< For only_dns == true: we are trying to resolve this IP
    string resolv6_2;               //!< For only_dns == true: we are trying to resolve this IP

    string comment;                 //!< Full string of request

    /*!
        \brief Cleans up
        \author VooDooMan
        \version 1
        \date 2005
    */
    void clear();

    c_dcc_request_whois();
};

#endif

