/***************************************************************************
                          dcc_loop.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop.cpp,v 1.18 2008/07/02 09:35:48 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop.cpp,v 1.18 2008/07/02 09:35:48 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#ifndef _MSC_VER
#   undef MY_STATIC
#   define MY_STATIC    /* broken, doesn't fit into 512 MiB RAM quota with -02 */
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"

#include "../sock.h"
#include "dcc_internal.h"
#include "../misc/shutdown.h"
#include "../utils/my_getpid.h"
#include "../ssl.h"
#include "../internal_state.h"
#include "../logic.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

MY_STATIC bool dcc_check_soft_locked_out(vector<c_dcc_client>::iterator& i, const string& eol);
MY_STATIC bool dcc_check_hard_locked_out(c_socket& s, const string& remote);
MY_STATIC void dcc_loop_misc1(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC bool dcc_loop_misc2(string& c, string& cmd, string& param1, string& param2, vector<c_dcc_client>::iterator& i, string& eol, bool& got_cmd);

MY_STATIC void dcc_loop_cmd_touch(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".touch")) {
        got_cmd=true;
        if(!param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,753)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=lang_get_string(1,(*i).lang,755)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            {
                // users
                deque<c_user>::iterator i1;
                for(int iii=0; iii<3; ++iii) {
                    deque<c_user>* x=NULL;
                    if(0==iii)
                        x=&r_users;
                    else if(1==iii)
                        x=&r_terminators;
                    else // 2
                        x=&r_user_templates;
                    for(i1=x->begin(); i1!=x->end(); ++i1) {
                        bool access=false;
                        {
                            vector<string>::iterator i3;
                            for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                                vector<string>::iterator i4;
                                for(i4=(*i1).groups.begin(); i4!=(*i1).groups.end(); ++i4) {
                                    if(!(*i3).compare(*i4)) {
                                        access=true;
                                        break;
                                    }
                                }
                                if(access)
                                    break;
                            }
                        }
                        if(access) {
                            if(!match(param1.c_str(),(*i1).name.c_str())) {
                                (*i1).last_changed=my_time(NULL);
                                disp=lang_get_string(1,(*i).lang,757);
                                disp+=" ";
                                disp+=(*i1).name+eol;
                                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                            }
                        }
                    }
                }
            }
            {
                // channel defs
                vector<c_channel_def>::iterator i1;
                for(i1=r_channel_defs.begin(); i1!=r_channel_defs.end(); ++i1) {
                    bool access=false;
                    {
                        vector<string>::iterator i3;
                        for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                            vector<string>::iterator i4;
                            for(i4=(*i1).groups.begin(); i4!=(*i1).groups.end(); ++i4) {
                                if(!(*i3).compare(*i4)) {
                                    access=true;
                                    break;
                                }
                            }
                            if(access)
                                break;
                        }
                    }
                    if(access) {
                        if(!match(param1.c_str(),(*i1).channel_name.c_str())) {
                            (*i1).last_changed=my_time(NULL);
                            disp=lang_get_string(1,(*i).lang,758);
                            disp+=" ";
                            disp+=(*i1).channel_name+eol;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                    }
                }
            }
            if(core_mod) {
                // procedures
                vector<c_procedure>::iterator i1;
                for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1) {
                    bool access=false;
                    {
                        vector<string>::iterator i3;
                        for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                            vector<string>::iterator i4;
                            for(i4=(*i1).groups.begin(); i4!=(*i1).groups.end(); ++i4) {
                                if(!(*i3).compare(*i4)) {
                                    access=true;
                                    break;
                                }
                            }
                            if(access)
                                break;
                        }
                    }
                    if(access) {
                        if(!match(param1.c_str(),(*i1).get_name().c_str())) {
                            (*i1).last_changed=my_time(NULL);
                            disp=lang_get_string(1,(*i).lang,759);
                            disp+=" ";
                            disp+=(*i1).name+eol;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                    }
                }
            }
            if(core_mod) {
                // functions
                map<string,c_function*>::iterator i1;
                for(i1=core_mod->r_functions.functions.begin(); i1!=core_mod->r_functions.functions.end(); ++i1) {
                    bool access=false;
                    {
                        vector<string>::iterator i3;
                        for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                            vector<string>::iterator i4;
                            for(i4=(*i1).second->groups.begin(); i4!=(*i1).second->groups.end(); ++i4) {
                                if(!(*i3).compare(*i4)) {
                                    access=true;
                                    break;
                                }
                            }
                            if(access)
                                break;
                        }
                    }
                    if(access) {
                        if(!match(param1.c_str(),(*i1).second->declaration.c_str())) {
                            (*i1).second->set_last_changed(my_time(NULL));
                            disp=lang_get_string(1,(*i).lang,760);
                            disp+=" ";
                            disp+=(*i1).second->declaration+eol;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                    }
                }
            }
            if(core_mod) {
                // private
                bool access=false;
                {
                    vector<string>::iterator i3;
                    for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                        vector<string>::iterator i4;
                        for(i4=r_private.groups.begin(); i4!=r_private.groups.end(); ++i4) {
                            if(!(*i3).compare(*i4)) {
                                access=true;
                                break;
                            }
                        }
                        if(access)
                            break;
                    }
                    if(access) {
                        if(!match(param1.c_str(),"PRIVATE")) {
                            r_private.last_changed=my_time(NULL);
                            disp=lang_get_string(1,(*i).lang,761)+eol;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                    }
                }
            }

            disp=lang_get_string(1,(*i).lang,756)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_whois(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".whois")) {
        got_cmd=true;
        if(!param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,8)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=lang_subst(lang_get_string(1,(*i).lang,6),param1)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            list<string> lines;
            int num=logic_partyline_whois((*i).lang,param1,lines);
            list<string>::iterator i1;
            for(i1=lines.begin(); i1!=lines.end(); ++i1) {
                dcc_send_msg((*i).socket,*i1,ec,(*i).ssl);
                dcc_send_msg((*i).socket,eol,ec,(*i).ssl);
            }

            disp=lang_subst(lang_get_string(1,(*i).lang,7),tos(num))+eol;
            disp=lang_subst(disp,param1);
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_plus_user(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".+user")) {
        got_cmd=true;
        if((*i).access_to_plususer) {
            if(param1.compare("") || param2.compare("")) {
                disp=lang_get_string(1,(*i).lang,29)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,32)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user=1;
            }
        } else {
            disp=lang_get_string(1,(*i).lang,183)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_edituser(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".edituser")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,87)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=lang_get_string(1,(*i).lang,88)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            deque<c_user>::iterator i1;
            for(i1=r_users.begin(); i1!=r_users.end(); ++i1) {
                disp=(*i1).name+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }

            disp=lang_get_string(1,(*i).lang,89)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_user=1;
        }
    }
}

MY_STATIC void dcc_loop_cmd_plus_proc(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".+proc")) {
        (*i).it_is_func=false;
        got_cmd=true;
        if((*i).access_to_plusproc) {
            if(param1.compare("") || param2.compare("")) {
                disp=lang_get_string(1,(*i).lang,377)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).edit_proc=1000;
            }
        } else {
            disp=lang_get_string(1,(*i).lang,192)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_plus_func(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".+func")) {
        (*i).it_is_func=true;
        got_cmd=true;
        if((*i).access_to_plusproc) {
            if(param1.compare("") || param2.compare("")) {
                disp=lang_get_string(1,(*i).lang,377)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).edit_proc=1000;
            }
        } else {
            disp=lang_get_string(1,(*i).lang,192)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_edit_proc_func(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".editproc") || !cmd.compare(".editfunc")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,134)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=lang_get_string(1,(*i).lang,135)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            {
                vector<c_procedure>::iterator i1;
                c_module* core_mod=get_module("core",true);
                if(core_mod) {
                    for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1) {
                        bool access=false;
                        vector<string>::iterator i2;
                        for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                            vector<string>::iterator i3;
                            for(i3=(*i1).groups.begin(); i3!=(*i1).groups.end(); ++i3) {
                                if(!(*i3).compare(*i2) || !(*i2).compare("*")) {
                                    access=true;
                                    break;
                                }
                            }
                            if(access)
                                break;
                        }

                        if(access) {
                            disp=(*i1).name+eol;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                    }
                }
            }

            {
                map<string,c_function*>::iterator i1;
                c_module* core_mod=get_module("core",true);
                if(core_mod) {
                    for(i1=core_mod->r_functions.functions.begin(); i1!=core_mod->r_functions.functions.end(); ++i1) {
                        bool access=false;
                        vector<string>::iterator i2;
                        for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                            vector<string>::iterator i3;
                            for(i3=(*i1).second->groups.begin(); i3!=(*i1).second->groups.end(); ++i3) {
                                if(!(*i3).compare(*i2) || !(*i2).compare("*")) {
                                    access=true;
                                    break;
                                }
                            }
                            if(access)
                                break;
                        }

                        if(access) {
                            disp=(*i1).second->declaration+eol;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                    }
                }
            }

            disp=lang_get_string(1,(*i).lang,136)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_proc=1;
        }
    }
}

MY_STATIC void dcc_loop_cmd_edit_chan(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".editchan")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,220)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).edit_chan=1;
        }
    }
}

MY_STATIC void dcc_loop_cmd_plus_chan(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".+chan")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,235)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).edit_chan=100;
        }
    }
}

MY_STATIC bool dcc_loop_cmd_quit(string& cmd, string& UNUSEDARG(param1), string& UNUSEDARG(param2), string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    if(!cmd.compare(".quit")) {
        string disp;
        int ec=0;

        got_cmd=true;
        if((*i).partyline_channel.compare(""))
            botnet_partyline_leave_channel((*i).as_in_logic,(*i).partyline_channel);
        (*i).partyline_channel="";
        disp=lang_get_string(1,(*i).lang,71)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        if(dcc_killing_user_socket && (*i).socket==*dcc_killing_user_socket)
            dcc_killing_user_socket=NULL;

        log_clients((*i).client_id,"User quit");

        if((*i).ssl) {
            ssl_put_to_garbage((*i).ssl);
            (*i).ssl=NULL;
            (*i).socket.clear();
        } else {
            sock_linger_push((*i).socket);
            (*i).socket.clear();
        }
        (*i).destroy();
        dcc_clients.erase(i);
        return true;
    }
    return false;
}

MY_STATIC void dcc_loop_cmd_backup(string& cmd, string& UNUSEDARG(param1), string& UNUSEDARG(param2), string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".backup")) {
        got_cmd=true;
        if((*i).access_to_backup) {
            c_module* core_mod=get_module("core",true);
            logic_partyline_backup(core_mod,(*i).as_in_logic);
            e_shutdown_reason sr=bot_get_shutdown_state();
            if(E_SD_UPGRADE==sr) {
                disp=lang_get_string(1,(*i).lang,641)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,74)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        } else {
            disp=lang_get_string(1,(*i).lang,188)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_rehash(string& cmd, string& UNUSEDARG(param1), string& UNUSEDARG(param2), string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".rehash")) {
        got_cmd=true;
        if((*i).access_to_rehash) {
            disp=lang_get_string(1,(*i).lang,348)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            sock_flush_later((*i).socket);
            lang_rehash();
            disp=logic_partyline_rehash((*i).lang,eol,(*i).as_in_logic);
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=lang_get_string(1,(*i).lang,347)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_apply(string& cmd, string& UNUSEDARG(param1), string& UNUSEDARG(param2), string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".apply")) {
        got_cmd=true;
        if((*i).access_to_apply) {
            string log="Apply by ";
            log+=(*i).as_in_logic;
            log_bot(log);

            irc_rehashed();
            dcc_apply((*i).as_in_logic);
            botnet_logic_rehashed();

            logic_on_internal_event("@apply@",(*i).as_in_logic,"","","",PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"","");
        } else {
            disp=lang_get_string(1,(*i).lang,682)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_filesystem(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".filesystem")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,628)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).access_to_filesystem) {
                (*i).filesystem=1;
            } else {
                disp=lang_get_string(1,(*i).lang,275)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_upgrade(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".upgrade")) {
        got_cmd=true;
        if(!param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,629)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).access_to_upgrade) {
                bool ok=true;
                for(unsigned int i1=0; i1<param1.length(); ++i1) {
                    bool ok2=false;
                    if(param1[i1]>='a' && param1[i1]<='z')
                        ok2=true;
                    if(param1[i1]>='A' && param1[i1]<='Z')
                        ok2=true;
                    if(param1[i1]>='0' && param1[i1]<='9')
                        ok2=true;
                    if(param1[i1]=='.' || param1[i1]=='_' || param1[i1]=='-')
                        ok2=true;
                    if(!ok2) {
                        ok=false;
                        break;
                    }
                }
                if(ok)
                    dcc_upgrade(i,eol,param1);
                else {
                    disp=lang_get_string(1,(*i).lang,665)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                }
            } else {
                disp=lang_get_string(1,(*i).lang,627)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_msg(string& cmd, string& UNUSEDARG(param1), string& UNUSEDARG(param2), string& UNUSEDARG(eol), vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    if(!cmd.compare(".msg")) {
        got_cmd=true;
        (*i).msg=1;
    }
}

MY_STATIC void dcc_loop_cmd_rproc(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".rproc")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,614)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=lang_get_string(1,(*i).lang,135)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            vector<string>::iterator i1;
            for(i1=(*i).access_to_procs.begin(); i1!=(*i).access_to_procs.end(); ++i1) {
                if(!(*i1).compare("*"))
                    continue;
                disp=*i1+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }

            disp=lang_get_string(1,(*i).lang,616)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_rproc=1;
        }
    }
}

MY_STATIC void dcc_loop_cmd_getfile(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".getfile")) {
        got_cmd=true;
        if((*i).access_to_filesystem) {
            int dcc_group=stoi(param2);
            int res=dcc_send_file(true,param1,irc_get_nick((*i).as_in_logic),dcc_group);
            switch(res) {
                case DCC_NO_SUCH_FILE:
                    disp=lang_get_string(1,"en",334);
                    break;
                case DCC_ACCESS_DENIED:
                    disp=lang_get_string(1,"en",335);
                    break;
                case DCC_IO_ERROR:
                    disp=lang_get_string(1,"en",336);
                    break;
            }
            if(!disp.empty()) {
                disp+=eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        } else {
            disp=lang_get_string(1,(*i).lang,275)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_partyline(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".partyline")) {
        got_cmd=true;
        if(param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,203)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            string chan=param1;
            if(chan.empty())
                chan="partyline";
            if(chan.compare((*i).partyline_channel)) {
                if(!(*i).partyline_channel.empty())
                    botnet_partyline_leave_channel((*i).as_in_logic,(*i).partyline_channel);
                (*i).partyline_channel=chan;
                string users=botnet_partyline_join_channel((*i).as_in_logic,(*i).partyline_channel);
                users=lang_get_string(1,(*i).lang,206)+" "+users+eol;
                ec=0;
                dcc_send_msg((*i).socket,users,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_leave(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".leave")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,204)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).partyline_channel.compare("")) {
                botnet_partyline_leave_channel((*i).as_in_logic,(*i).partyline_channel);
                (*i).partyline_channel="";
            } else {
                disp=lang_get_string(1,(*i).lang,205)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_restart(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".restart")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,270)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).access_to_restart) {
                dcc_killing_user_eol=eol;
                dcc_killing_user_socket=&((*i).socket);
                dcc_killing_ssl=(*i).is_ssl_client;
                if(dcc_killing_ssl)
                    dcc_killing_ssl_hnd=(*i).ssl;

                char* tmp=MY_NEW char[(*i).as_in_logic.length()+128];
                sprintf(tmp,"%s%s",".restart command by ",(*i).as_in_logic.c_str());
                log_bot(tmp);

                logic_on_internal_event("@restart@",(*i).as_in_logic,"","","",PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"","");

                disp=(string)tmp;
                disp+=eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                MY_DELETE_A(tmp);
                tmp=NULL;

                bot_shutdown_action(E_SD_RESTART,(*i).as_in_logic);
                dcc_killing_user_lang=(*i).lang;

                log_free_locks();

                c_module* core_mod=get_module("core",true);
                logic_partyline_backup(core_mod,(*i).as_in_logic);
            } else {
                disp=lang_get_string(1,(*i).lang,272)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_die(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".die")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,271)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).access_to_die) {
                dcc_killing_user_eol=eol;
                dcc_killing_user_socket=&((*i).socket);
                dcc_killing_ssl=(*i).is_ssl_client;
                if(dcc_killing_ssl)
                    dcc_killing_ssl_hnd=(*i).ssl;

                char* tmp=MY_NEW char[(*i).as_in_logic.length()+128];
                sprintf(tmp,"%s%s",".die command by ",(*i).as_in_logic.c_str());
                log_bot(tmp);

                logic_on_internal_event("@die@",(*i).as_in_logic,"","","",PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"","");

                disp=(string)tmp;
                disp+=eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                MY_DELETE_A(tmp);
                tmp=NULL;

                bot_shutdown_action(E_SD_DIE,(*i).as_in_logic);
                dcc_killing_user_lang=(*i).lang;

                c_module* core_mod=get_module("core",true);
                logic_partyline_backup(core_mod,(*i).as_in_logic);
            } else {
                disp=lang_get_string(1,(*i).lang,273)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_help(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".help")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,372)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            vector<string> help;
            for(int ii=355; ii<=371; ++ii) // !!!
                help.push_back(lang_get_string(1,(*i).lang,ii));
            help.push_back(lang_get_string(1,(*i).lang,396));
            help.push_back(lang_get_string(1,(*i).lang,410));
            help.push_back(lang_get_string(1,(*i).lang,418));
            help.push_back(lang_get_string(1,(*i).lang,454));
            help.push_back(lang_get_string(1,(*i).lang,453));
            help.push_back(lang_get_string(1,(*i).lang,535));
            help.push_back(lang_get_string(1,(*i).lang,566));
            help.push_back(lang_get_string(1,(*i).lang,571));
            help.push_back(lang_get_string(1,(*i).lang,579));
            help.push_back(lang_get_string(1,(*i).lang,615));
            help.push_back(lang_get_string(1,(*i).lang,636));
            help.push_back(lang_get_string(1,(*i).lang,643));
            help.push_back(lang_get_string(1,(*i).lang,645));
            help.push_back(lang_get_string(1,(*i).lang,679));
            help.push_back(lang_get_string(1,(*i).lang,725));
            help.push_back(lang_get_string(1,(*i).lang,754));
            help.push_back(lang_get_string(1,(*i).lang,764));
            sort(help.begin(),help.end());
            vector<string>::iterator i1;
            disp=lang_get_string(1,(*i).lang,354)+eol;
            for(i1=help.begin(); i1!=help.end(); ++i1)
                disp+=*i1+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_showbots(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".showbots")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,644)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=botnet_showbots((*i).lang,eol);
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_info(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".info")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,765)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp=get_bot_version()+eol;
            disp+=lang_get_string(1,(*i).lang,766)+eol;
            disp=lang_subst(disp,irc_nick);
            disp=lang_subst(disp,logic_get_host_bot_user_name());
            if(core_mod && core_mod->get_conf())
                disp=lang_subst(disp,core_mod->get_conf()->getvar("botname"));
            else
                disp=lang_subst(disp,"?");
            disp=lang_subst(disp,tos(my_getpid()));
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_broadcastping(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".broadcastping")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,646)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            my_time_t now;
            my_time(&now);

            string c="\x01" "BROADCAST_PING\x01 ";
            c+=tos(now);
            c+=" ";
            c+=(*i).as_in_logic;

            // clean up flood buffers
            vector<c_flood_history>::iterator i4;
        l_flood:
            for(i4=(*i).msg_flood_hist.begin(); i4!=(*i).msg_flood_hist.end(); ++i4)
                if(now-(*i4).time>(*i).partyline_msg_flood.seconds) {
                    (*i).msg_flood_hist.erase(i4);
                    goto l_flood;
                }

            c_flood_history entry;
            entry.time=now;
            entry.bytes=c.length();
            entry.msg=c;

            (*i).msg_flood_hist.push_back(entry);
            unsigned int entries=0;
            for(i4=(*i).msg_flood_hist.begin(); i4!=(*i).msg_flood_hist.end(); ++i4)
                entries++;
            if((*i).partyline_msg_flood.lines!=0 && entries>=(*i).partyline_msg_flood.lines) {
                disp=lang_subst(lang_get_string(1,(*i).lang,207),tos((*i).partyline_msg_flood.seconds))+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,647);
                disp+=" ";
                disp+=make_nice_time(now);
                disp+=eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                botnet_partyline_message((*i).as_in_logic,"",c);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_execute(string& c, string& cmd, string& param1, string& UNUSEDARG(param2), string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".execute")) {
        got_cmd=true;
        if(param1.empty() || c.find(" ",0)==string::npos) {
            disp=lang_get_string(1,(*i).lang,653)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            string proc=c;
            proc.erase(0,proc.find(" ",0)+1);

            string p=proc;
            if(p.find("(",0)!=string::npos)
                p.erase(p.find("(",0),p.length()-p.find("(",0));

            bool access=false;
            {
                vector<c_procedure>::iterator i1;
                c_module* core_mod=get_module("core",true);
                if(core_mod) {
                    for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1) {
                        vector<string>::iterator i2;
                        for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                            vector<string>::iterator i3;
                            for(i3=(*i1).groups.begin(); i3!=(*i1).groups.end(); ++i3) {
                                if(!(*i3).compare(*i2) || !(*i2).compare("*")) {
                                    string wo_decl=(*i1).name;
                                    if(wo_decl.find("(",0)!=string::npos)
                                        wo_decl.erase(wo_decl.find("(",0),wo_decl.length()-wo_decl.find("(",0));

                                    if(!p.compare(wo_decl)) {
                                        access=true;
                                        break;
                                    }
                                }
                            }
                            if(access)
                                break;
                        }
                    }
                }

                if(!access) {
                    map<string,c_function*>::iterator i1;
                    c_module* core_mod=get_module("core",true);
                    if(core_mod) {
                        for(i1=core_mod->r_functions.functions.begin(); i1!=core_mod->r_functions.functions.end(); ++i1) {
                            vector<string>::iterator i2;
                            for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                                vector<string>::iterator i3;
                                for(i3=(*i1).second->groups.begin(); i3!=(*i1).second->groups.end(); ++i3) {
                                    if(!(*i3).compare(*i2) || !(*i2).compare("*")) {
                                        string wo_decl=(*i1).second->get_name();
                                        if(wo_decl.find("(",0)!=string::npos)
                                            wo_decl.erase(wo_decl.find("(",0),wo_decl.length()-wo_decl.find("(",0));

                                        if(!p.compare(wo_decl)) {
                                            access=true;
                                            break;
                                        }
                                    }
                                }
                                if(access)
                                    break;
                            }
                            if(access)
                                break;
                        }
                    }
                }
            }
            if(access) {
                c_module* core_mod=get_module("core",true);
                if(core_mod) {
                    proc+=";";
                    var_keeper->set_current_session(core_mod->get_session());
                    c_temp_local local;
                    c_var_array* vars=NULL;
                    unsigned new_local_id=local.get_params(vars);
                    string debug="<dcc/telnet>:1 -> ";
                    debug+=proc;
                    string code_str=proc;
                    {
                        string next_expression;

                        stack<c_eval_iteration> st;

                        c_eval_iteration ste(core_mod,vars,debug);
                        ste.proc_eval=true;
                        ste.state=0;
                        ste.return_to_state=0;
                        ste.local_id=new_local_id;
                        st.push(ste);

                        eval_function(core_mod,code_str,vars,core_mod->r_functions,debug,st);
                        eval_loop(st);
                        var_keeper->set_current_session(SESSION_RESERVED_ID);
                    }
                }
                // TODO: display return value
            } else {
                disp=lang_get_string(1,(*i).lang,654)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_replication(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".replication")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,419)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).access_to_replication) {
                (*i).replication=1;
            } else {
                disp=lang_get_string(1,(*i).lang,420)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_chpass(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;
    bool got=false;

    if(!cmd.compare(".chpass")) {
        got_cmd=true;
        if(!param1.compare("") || !param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,637)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            unsigned char signature[16];

            MD5Context md5c;
            MD5Init(&md5c);
            MD5Update(&md5c,(unsigned char *)param2.c_str(),(unsigned int)param2.length());
            MD5Final(signature,&md5c);

            char sig[128];
            sig[0]=0;
            for(int i1=0; i1<16; ++i1) {
                char tmp[16];
                sprintf(tmp,"%02X",signature[i1]);
                strcat(sig,tmp);
            }

            got=false;
            if((*i).as_in_logic.compare(param1)) { // !=
                vector<string>::iterator i1;
                for(i1=(*i).access_to_users.begin(); i1!=(*i).access_to_users.end(); ++i1) {
                    if(!(*i1).compare(param1)) {
                        got=true;
                        e_shutdown_reason sr=bot_get_shutdown_state();
                        if(E_SD_UPGRADE==sr) {
                            disp=lang_get_string(1,(*i).lang,642)+eol;
                            ec=0;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        } else
                            dcc_set_password(param1,sig);
                        break;
                    }
                }
            } else {
                got=true;
                e_shutdown_reason sr=bot_get_shutdown_state();
                if(E_SD_UPGRADE==sr) {
                    disp=lang_get_string(1,(*i).lang,642)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                } else
                    dcc_set_password(param1,sig);
            }
            if(!got) {
                disp=lang_get_string(1,(*i).lang,638)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,639)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_pass(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;
    bool got=false;

    if(!cmd.compare(".pass")) {
        got_cmd=true;
        if(!param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,726)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            got=false;
            {
                vector<string>::iterator i1;
                for(i1=(*i).access_to_users.begin(); i1!=(*i).access_to_users.end(); ++i1) {
                    if(!(*i1).compare(param1)) {
                        got=true;
                        e_shutdown_reason sr=bot_get_shutdown_state();
                        if(E_SD_UPGRADE==sr) {
                            disp=lang_get_string(1,(*i).lang,642)+eol;
                            ec=0;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        } else
                            (*i).edit_pass=1;
                        break;
                    }
                }
            }
            if(!got) {
                disp=lang_get_string(1,(*i).lang,638)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).edit_pasc_user=param1;
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_terminator(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".terminator")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,455)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).terminator=1;
        }
    }
}

MY_STATIC void dcc_loop_cmd_plus_group(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;
    bool got=false;

    if(!cmd.compare(".+group")) {
        got_cmd=true;
        if(!param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,397)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            vector<string>::iterator i1;
            got=false;
            if(!param1.compare("*"))
                got=true;
            map<string,string> vars;
            for(i1=r_all_groups.begin(); !got && i1!=r_all_groups.end(); ++i1) {
                if(!(*i1).compare(param1)) {
                    got=true;
                    break;
                }
            }
            if(!got) {
                r_all_groups.push_back(param1);
                logic_partyline_plus_group((*i).as_in_logic,param1);
                dcc_loop_get_rights(i);
                disp=lang_get_string(1,(*i).lang,399)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,398)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_private(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".private")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,411)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!(*i).access_to_private) {
                disp=lang_get_string(1,(*i).lang,412)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).private_edit=1;
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_lang(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".lang")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,450)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).language=1;
        }
    }
}

MY_STATIC void dcc_loop_cmd_stat(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;
    bool got=false;

    if(!cmd.compare(".stat") || !cmd.compare(".stats")) {
        got_cmd=true;
        if(param1.compare("") || param2.compare("")) {
            disp=lang_get_string(1,(*i).lang,534)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            list<string> lines;
            stats_display(lines,(*i).lang);
            list<string>::iterator i1;
            disp.clear();
            for(i1=lines.begin(); i1!=lines.end(); ++i1) {
                disp+=*i1;
                disp+=eol;
            }
            disp+=eol;

            {
                string staff;
                vector<string> subst;
                string _539=lang_get_string(1,(*i).lang,539);
                string _540=lang_get_string(1,(*i).lang,540);
                string _557=lang_get_string(1,(*i).lang,557);
                string _550=lang_get_string(1,(*i).lang,550);
                string _551=lang_get_string(1,(*i).lang,551);

                vector<c_online_channel>::iterator i2;
                for(i2=irc_channels.begin(); i2!=irc_channels.end(); ++i2) {
                    staff+=_539+eol;
                    subst.push_back(irc_get_mode((*i2).name,irc_nick));
                    subst.push_back((*i2).name);

                    vector<c_online_user>::iterator i3;
                    for(i3=(*i2).users.begin(); i3!=(*i2).users.end(); ++i3) {
                        staff+="   "+_540+"%s = ";
                        subst.push_back((*i3).mode);
                        subst.push_back((*i3).nick);

                        if((*i3).got_whois) {
                            staff+="%s";
                            subst.push_back((*i3).in_logic_as);
                        } else
                            staff+=_557;
                        staff+=eol;

                        // display dynamic modes
                        c_user u;
                        vector<c_channel> chs;

                        logic_partyline_get_user((*i3).in_logic_as,u,chs);

                        vector<c_channel>::iterator i4;
                        for(i4=chs.begin(); i4!=chs.end(); ++i4) {
                            if(!cmp_strings_case_insensitive((*i4).channel_name,(*i2).name)) {
                                if(!(*i4).dynamic_plus_modes.empty()) {
                                    staff+="      "+_550+eol;
                                    subst.push_back((*i4).dynamic_plus_modes);
                                }
                                if(!(*i4).dynamic_minus_modes.empty()) {
                                    staff+="      "+_551+eol;
                                    subst.push_back((*i4).dynamic_minus_modes);
                                }
                                break;
                            }
                        }
                    }
                }

                disp+=lang_subst_multi(staff,subst);
            }

            disp+=eol;
            disp+=lang_get_string(1,(*i).lang,717);
            disp+=eol;
            {
                vector<c_dcc_client>::iterator i1;
                for(i1=dcc_clients.begin(); i1!=dcc_clients.end(); ++i1) {
                    if(TCID_INVALID!=(*i1).connect_id)
                        continue;
                    string msg;
                    msg+=(*i1).local;
                    if((*i1).local_port==0) {
                        msg+=" -> ";
                        msg+=(*i1).remote;
                        msg+=":";
                        msg+=tos((*i1).remote_port);
                    } else {
                        msg+=":";
                        msg+=tos((*i1).local_port);
                        msg+=" <- ";
                        msg+=(*i1).remote;
                    }
                    if((*i1).telnet)
                        msg+=" telnet";
                    else
                        msg+=" DCC";
                    if((*i1).send)
                        msg+=" SEND";
                    if((*i1).send_from_filesystem) {
                        msg+=" SEND ";
                        msg+=lang_get_string(1,(*i).lang,719);
                    }
                    if((*i1).ssl_connection)
                        msg+="/SSL";
                    msg+=" ";
                    if((*i1).replication_partner) {
                        msg+=lang_get_string(1,(*i).lang,720);
                        msg+=" ";
                    }
                    if((*i1).got_passwd>=3) {
                        msg+=lang_get_string(1,(*i).lang,721);
                        msg+=" \"";
                        msg+=(*i1).as_in_logic;
                        msg+="\"";
                    } else {
                        msg+=lang_get_string(1,(*i).lang,722);
                        msg+=" (\"";
                        msg+=(*i1).as_in_logic;
                        msg+="\")";
                    }
                    msg+=" (";
                    msg+=lang_get_string(1,(*i).lang,723);
                    msg+=" \"";
                    msg+=(*i1).supposed_to_be;
                    msg+="\") ";
                    if((*i1).send || (*i1).send_from_filesystem) {
                        if((*i1).send)
                            msg+=(*i1).dcc_send.original_name;
                        else
                            msg+=(*i1).send_file.public_name;
                        msg+=" ";
                        MY_LONG_LONG pos=0;
                        int my_errno;
                        got=false;
                        if((*i1).dcc_send.f) {
                            if((pos=my_ftell((*i1).dcc_send.f,my_errno))==-1) {
                                // problem when receiving file from remote (win32) workaround
                                pos=0;
                                if((*i1).dcc_send.received && (*i1).dcc_send.size && (*i1).dcc_send.received<(*i1).dcc_send.size) {
                                    pos=static_cast<long>((*i1).dcc_send.received);
                                    got=true;
                                }
                            } else
                                got=true;
                        }
                        if(got)
                            msg+=tos(pos);
                        else
                            msg+="?";
                        msg+="/";
                        msg+=tos((*i1).dcc_send.size);
                        if(got) {
                            msg+=" ";
                            if((*i1).dcc_send.size) {
                                double ratio=pos*100./(*i1).dcc_send.size;
                                msg+=tos(static_cast<long>(ratio));
                            } else
                                msg+="?";
                            msg+="%";
                            if((*i1).send)
                                msg+=" received";
                            else
                                msg+=" sent";
                        }
                    }
                    if(msg.length() && msg[msg.length()-1]==' ')
                        msg.erase(msg.length()-1,1);
                    msg+=eol;
                    disp+=msg;
                }
            }
            disp+=lang_get_string(1,(*i).lang,718);
            disp+=eol;

            {
                disp+=lang_get_string(1,(*i).lang,746);
                disp+=eol;
                string days=lang_get_string(1,(*i).lang,751);
                vector<c_module*>::iterator i1;
                for(i1=modules.begin(); i1!=modules.end(); ++i1) {
                    disp+=lang_subst(lang_get_string(1,(*i).lang,747),(*i1)->get_mod_name());
                    disp+=eol;
                    vector<c_timer*>::iterator i2;
                    for(i2=(*i1)->r_timers.begin(); i2!=(*i1)->r_timers.end(); ++i2) {
                        if(!(*i2)->bot_unlink_timer) {
                            disp+="    ";
                            map<string,string> subst;
                            subst.insert(make_pair("%name;",(*i2)->name));
                            my_time_t next=(*i2)->again_at;
                            subst.insert(make_pair("%next;",make_nice_time(next,false)));
                            my_time_t now=my_time(NULL);
                            my_time_t togo=next;
                            if(togo>now)
                                togo-=now;
                            else
                                togo=0;
                            subst.insert(make_pair("%togo;",make_nice_time_days_only(togo,days.c_str())));
                            subst.insert(make_pair("%cmd;",(*i2)->expression));
                            if(!(*i2)->once) {
                                subst.insert(make_pair("%every;",make_nice_time_days_only((*i2)->duration,days.c_str())));
                                disp+=lang_subst(lang_get_string(1,(*i).lang,748),subst);
                            } else {
                                disp+=lang_subst(lang_get_string(1,(*i).lang,749),subst);
                            }
                            disp+=eol;
                        } else {
                            disp+="    ";
                            map<string,string> subst;
                            subst.insert(make_pair("%name;",(*i2)->name));
                            subst.insert(make_pair("%cmd;",(*i2)->expression));
                            disp+=lang_subst(lang_get_string(1,(*i).lang,762),subst);
                            disp+=eol;
                        }
                    }
                }
                disp+=lang_get_string(1,(*i).lang,750);
                disp+=eol;
            }

            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
}

MY_STATIC void dcc_loop_cmd_part(string& c, string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;
    bool got=false;

    if(!cmd.compare(".part")) {
        got_cmd=true;
        if(!param1.compare("")) {
            disp=lang_get_string(1,(*i).lang,567)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            vector<string>::iterator i1;
            got=false;
            for(i1=(*i).access_to_channel.begin(); i1!=(*i).access_to_channel.end(); ++i1)
                if(!cmp_strings_case_insensitive(param1,*i1)) {
                    got=true;
                    break;
                }
            if(!got) {
                disp=lang_get_string(1,(*i).lang,568)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                got=false;
                vector<c_online_channel>::iterator i1;
                for(i1=irc_channels.begin(); i1!=irc_channels.end(); ++i1) {
                    if(!cmp_strings_case_insensitive(param1,(*i1).name)) {
                        got=true;
                        irc_channels.erase(i1);

                        if(!param2.empty()) {
                            param2=c;
                            // erase .part
                            if(param2.find(" ",0))
                                param2.erase(0,param2.find(" ",0)+1);
                            // erase #channelname
                            if(param2.find(" ",0))
                                param2.erase(0,param2.find(" ",0)+1);
                            // now we got reason
                        }

                        map<string,string> subst;
                        pair<string,string> p;
                        if(!param2.empty()) {
                            p.first="%reason;";
                            p.second=param2;
                            subst.insert(p);
                        }
                        p.first="%uname;";
                        p.second=(*i).as_in_logic;
                        subst.insert(p);

                        string reason;
                        if(!param2.empty()) {
                            reason=core_conf_getvar("irc_part_msg_on_.part_w_reason");
                        } else {
                            reason=core_conf_getvar("irc_part_msg_on_.part_wo_reason");
                        }
                        reason=lang_subst(reason,subst);

                        irc_part(param1.c_str(),reason.c_str());
                        break;
                    }
                }
                disp.clear();
                if(!got) {
                    disp=lang_get_string(1,(*i).lang,569)+eol;
                } else {
                    disp=lang_get_string(1,(*i).lang,570)+eol;
                }
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_join(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;
    bool got=false;

    if(!cmd.compare(".join")) {
        got_cmd=true;
        if(!param1.compare("")) {
            disp=lang_get_string(1,(*i).lang,572)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            vector<string>::iterator i1;
            got=false;
            for(i1=(*i).access_to_channel.begin(); i1!=(*i).access_to_channel.end(); ++i1)
                if(!cmp_strings_case_insensitive(param1,*i1)) {
                    got=true;
                    break;
                }
            if(!got) {
                disp=lang_get_string(1,(*i).lang,568)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                got=false;
                vector<c_online_channel>::iterator i1;
                for(i1=irc_channels.begin(); i1!=irc_channels.end(); ++i1)
                    if(!cmp_strings_case_insensitive(param1,(*i1).name)) {
                        got=true;
                        break;
                    }
                disp.clear();
                if(!got) {
                    irc_join(param1.c_str(),param2.c_str());
                    disp=lang_get_string(1,(*i).lang,574)+eol;
                } else {
                    disp=lang_get_string(1,(*i).lang,573)+eol;
                }
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC void dcc_loop_cmd_dynbans(string& cmd, string& param1, string& param2, string& eol, vector<c_dcc_client>::iterator& i, bool& got_cmd)
{
    string disp;
    int ec=0;

    if(!cmd.compare(".dynbans")) {
        got_cmd=true;
        if(!param1.compare("") || !param2.empty()) {
            disp=lang_get_string(1,(*i).lang,580)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).dynbanc_channel=param1;
            (*i).dynbans=1;
            // the privilege check will be done in loop function
        }
    }
}

MY_STATIC void dcc_loop_server()
{
    enum
    {
        TIMEOUT_SECS = 20,  //!< Timeout seconds
    };

    int ec=0;
    bool got=false;

    vector<c_dcc_server>::iterator i2;
    for(i2=dcc_servers.begin(); i2!=dcc_servers.end(); ++i2) {
        if(!(*i2).active)
            continue;
        if((*i2).socket.cmp()) {
            c_socket s;
            if(!(*i2).using_ipv6)
                s=sock_accept((*i2).socket,"",true);
            else
                s=sock_accept6((*i2).socket,"",true);
            if(s.cmp()) {
                string comment="DCC client connecting to ";
                comment+=(*i2).bind_ip;
                sock_comment(s,comment);

                if(!(*i2).server_type.compare("chat"))
                    stats_dcc_chat_new_connection();
                if(!(*i2).server_type.compare("send"))
                    stats_dcc_send_new_connection();
                if((*i2).server_type.empty())
                    stats_dcc_chat_new_connection();

                ec=0;
                in_addr addr;
#if defined(_WIN32) || defined(_WIN64)
                addr.S_un.S_addr=static_cast<unsigned int>(-1);
#else
                addr.s_addr=static_cast<unsigned int>(-1);
#endif
                in_addr6_ addr6;
                memset(&addr6,0,sizeof(addr6));
                ec=0;
                char remote[512];
                strcpy(remote,"<unknown>");
                if(!(*i2).using_ipv6) {
                    addr=sock_get_remote_addr(s,ec);
                    char* tmp=remote;
                    if(!ec)
                        my_inet_ntop(AF_INET,&addr,tmp,sizeof(remote)-1);
                    logic_on_internal_event("@connection@","DCC4",tmp,(*i2).bind_ip,tos((*i2).port),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"Remote client connected.","");
                } else {
                    my_inet_pton(AF_INET6,s.host,&addr6);
                    strcpy(remote,s.host);
                    logic_on_internal_event("@connection@","DCC6",s.host,(*i2).bind_ip,tos((*i2).port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"Remote client connected.","");
                }
                comment+=" form ";
                comment+=remote;
                sock_comment(s,comment);
                if(dcc_check_hard_locked_out(s,remote))
                    continue;
                if(!ec) {
                    bool awaiting_send=false;
                    {
                        vector<c_dcc_send_file>::iterator i;
                        for(i=dcc_awaiting_send.begin(); i!=dcc_awaiting_send.end(); ++i) {
                            if(!(*i).using_ipv6) {
#if defined(_WIN32) || defined(_WIN64)
                                if(addr.S_un.S_un_b.s_b1==(*i).remote_ip.S_un.S_un_b.s_b1 && addr.S_un.S_un_b.s_b2==(*i).remote_ip.S_un.S_un_b.s_b2 && addr.S_un.S_un_b.s_b3==(*i).remote_ip.S_un.S_un_b.s_b3 && addr.S_un.S_un_b.s_b4==(*i).remote_ip.S_un.S_un_b.s_b4) {
#else
                                if(((char*)&addr.s_addr)[0]==((char*)&(*i).remote_ip.s_addr)[0] && ((char*)&addr.s_addr)[1]==((char*)&(*i).remote_ip.s_addr)[1] && ((char*)&addr.s_addr)[2]==((char*)&(*i).remote_ip.s_addr)[2] && ((char*)&addr.s_addr)[3]==((char*)&(*i).remote_ip.s_addr)[3]) {
#endif
                                    awaiting_send=true;
                                    break;
                                }
                            } else {
                                bool equal=true;
                                for(unsigned i1=0; i1<sizeof((*i).remote_ip6); ++i1) {
                                    if(((unsigned char*)&(*i).remote_ip6)[i1]!=((unsigned char*)&addr6)[i1]) {
                                        equal=false;
                                        break;
                                    }
                                }
                                if(equal) {
                                    awaiting_send=true;
                                    break;
                                }
                            }
                        }
                    }

                    got=false;
                    if(!awaiting_send) {
                        vector<c_dcc_awaiting_user>::iterator i;
                        if(!(*i2).using_ipv6) {
#if defined(_WIN32) || defined(_WIN64)
                            if(addr.S_un.S_un_b.s_b1==127 && addr.S_un.S_un_b.s_b2==0 && addr.S_un.S_un_b.s_b3==0 && addr.S_un.S_un_b.s_b4==1) {
#else
                            if(((char*)&addr.s_addr)[0]==127 && ((char*)&addr.s_addr)[1]==0 && ((char*)&addr.s_addr)[2]==0 && ((char*)&addr.s_addr)[3]==1) {
#endif
                                c_dcc_awaiting_user user;

                                user.nick="";
                                user.ident="";
                                user.host="127.0.0.1";
                                user.fullname="";

                                user.using_ipv6=false;
                                user.addr4=addr;
                                my_time(&user.start_time);
                                strcpy(user.user_name_as_in_logic,core_conf_getvar("127.0.0.1_dcc_user").c_str());
                                dcc_awaiting_users.push_back(user);
                            }
                        } else {
                            if(addr6.bytes[0]==0 && addr6.bytes[1]==0 && addr6.bytes[2]==0 && addr6.bytes[3]==0 &&
                                addr6.bytes[4]==0 && addr6.bytes[5]==0 && addr6.bytes[6]==0 && addr6.bytes[7]==0 &&
                                addr6.bytes[8]==0 && addr6.bytes[9]==0 && addr6.bytes[10]==0 && addr6.bytes[11]==0 &&
                                addr6.bytes[12]==0 && addr6.bytes[13]==0 && addr6.bytes[14]==0 && addr6.bytes[15]==1) {
                                c_dcc_awaiting_user user;

                                user.nick="";
                                user.ident="";
                                user.host="::1";
                                user.fullname="";

                                user.using_ipv6=true;
#if defined(_WIN32) || defined(_WIN64)
                                user.addr4.S_un.S_addr=static_cast<unsigned int>(-1);
#else
                                user.addr4.s_addr=static_cast<unsigned int>(-1);
#endif
                                memcpy(&user.addr6,&addr6,sizeof(user.addr6));
                                my_time(&user.start_time);
                                strcpy(user.user_name_as_in_logic,core_conf_getvar("127.0.0.1_dcc_user").c_str());
                                dcc_awaiting_users.push_back(user);
                            }
                        }
                    l1:
                        for(i=dcc_awaiting_users.begin(); i!=dcc_awaiting_users.end(); ++i) {
                            if(RR_SCHEDULED==(*i).resolv_result) {
                                (*i).resolv_result=threads_resolve4((*i).dcc_host.c_str(),(*i).addr4,RT_RESOLVE_SCHEDULE);
                            }
                            if(RR_FAILURE==(*i).resolv_result) {
                                dcc_awaiting_users.erase(i);
                                goto l1;
                            }
                            if(RR_OK!=(*i).resolv_result)
                                continue;
                            my_time_t now;
                            my_time(&now);
                            if((*i).start_time+TIMEOUT_SECS<=now) {
                                dcc_awaiting_users.erase(i);
                                goto l1;
                            }
                            if(!(*i).using_ipv6 && !(*i2).using_ipv6) {
#if defined(_WIN32) || defined(_WIN64)
                                if((*i).addr4.S_un.S_addr==addr.S_un.S_addr) {
#else
                                if((*i).addr4.s_addr==addr.s_addr) {
#endif
                                    c_dcc_client c;
                                    c.server_socket=(*i2).socket;

                                    c.local=(*i2).bind_ip;
                                    c.remote=remote;
                                    c.local_port=(*i2).port;
                                    c.remote_port=0;

                                    char tmp[256];
#if defined(_WIN32) || defined(_WIN64)
                                    my_inet_ntop(AF_INET,&(addr.S_un.S_addr),tmp,sizeof(tmp)-1);
#else
                                    my_inet_ntop(AF_INET,&(addr.s_addr),tmp,sizeof(tmp)-1);
#endif
                                    c.remote=tmp;

                                    c.nick=(*i).nick;
                                    c.ident=irc_get_ident((*i).nick);
                                    c.host=irc_get_host((*i).nick);
                                    c.fullname=irc_get_fullname((*i).nick);

                                    c.chat=true;
                                    c.send=false;
                                    c.telnet=false;
                                    c.send_from_filesystem=false;
                                    c.socket=s;
                                    c.got_passwd=0;
                                    c.new_user=0;
                                    c.edit_user=0;
                                    c.edit_pass=0;
                                    c.filesystem=0;
                                    c.as_in_logic=(*i).user_name_as_in_logic;
                                    c.got_user_name=(c.as_in_logic.empty()?false:true);
                                    if(!(*i2).server_type.empty()) {
                                        if(!(*i2).server_type.compare("chat")) {
                                            string gr="101 ";
                                            gr+=irc_nick;
                                            gr+="\n";
                                            ec=0;
                                            size_t sent=sock_send(c.socket,gr.c_str(),gr.length(),ec);
                                            stats_dcc_chat_bytes_sent(sent);
                                        }
                                        if(!(*i2).server_type.compare("send")) {
                                            c.dcc_send.is_file_server_proto=true;
                                            c.chat=false;
                                            c.send=true;
                                        }
                                    }

                                    c.client_id=++dcc_last_client_id;
                                    log_clients(c.client_id,c.socket.comment);

                                    my_time(&c.session_start);
                                    if(c.chat)
                                        c.connect_time=dcc_push_bad_login(c.remote);
                                    dcc_clients.push_back(c);
                                    dcc_check_limit();
                                    got=true;
                                    dcc_awaiting_users.erase(i);
                                    goto l1;
                                }
                            } else if((*i).using_ipv6 && (*i2).using_ipv6) {
                                if((*i).addr6.bytes[0]==addr6.bytes[0] && (*i).addr6.bytes[1]==addr6.bytes[1] &&
                                    (*i).addr6.bytes[2]==addr6.bytes[2] && (*i).addr6.bytes[3]==addr6.bytes[3] &&
                                    (*i).addr6.bytes[4]==addr6.bytes[4] && (*i).addr6.bytes[5]==addr6.bytes[5] &&
                                    (*i).addr6.bytes[6]==addr6.bytes[6] && (*i).addr6.bytes[7]==addr6.bytes[7] &&
                                    (*i).addr6.bytes[8]==addr6.bytes[8] && (*i).addr6.bytes[9]==addr6.bytes[9] &&
                                    (*i).addr6.bytes[10]==addr6.bytes[10] &&(*i).addr6.bytes[11]==addr6.bytes[11] &&
                                    (*i).addr6.bytes[12]==addr6.bytes[12] &&(*i).addr6.bytes[13]==addr6.bytes[13] &&
                                    (*i).addr6.bytes[14]==addr6.bytes[14] &&(*i).addr6.bytes[15]==addr6.bytes[15]) {
                                    c_dcc_client c;
                                    c.server_socket=(*i2).socket;

                                    c.local=(*i2).bind_ip;
                                    c.remote=remote;
                                    c.local_port=(*i2).port;
                                    c.remote_port=0;

                                    char tmp[256];
                                    my_inet_ntop(AF_INET6,&addr6,tmp,sizeof(tmp)-1);
                                    c.remote=tmp;

                                    c.chat=true;
                                    c.send=false;
                                    c.telnet=false;
                                    c.send_from_filesystem=false;
                                    c.socket=s;
                                    c.got_passwd=0;
                                    c.new_user=0;
                                    c.edit_user=0;
                                    c.edit_pass=0;
                                    c.filesystem=0;
                                    c.as_in_logic=(*i).user_name_as_in_logic;
                                    c.got_user_name=(c.as_in_logic.empty()?false:true);
                                    if(!(*i2).server_type.empty()) {
                                        if(!(*i2).server_type.compare("chat")) {
                                            string gr="101 ";
                                            gr+=irc_nick;
                                            gr+="\n";
                                            ec=0;
                                            size_t sent=sock_send(c.socket,gr.c_str(),gr.length(),ec);
                                            stats_dcc_chat_bytes_sent(sent);
                                        }
                                        if(!(*i2).server_type.compare("send")) {
                                            c.dcc_send.is_file_server_proto=true;
                                            c.chat=false;
                                            c.send=true;
                                        }
                                    }

                                    c.client_id=++dcc_last_client_id;
                                    log_clients(c.client_id,c.socket.comment);

                                    my_time(&c.session_start);
                                    if(c.chat)
                                        c.connect_time=dcc_push_bad_login(c.remote);
                                    dcc_clients.push_back(c);
                                    dcc_check_limit();
                                    got=true;
                                    dcc_awaiting_users.erase(i);
                                    goto l1;
                                }
                            }
                        }
                    } else {
                        got=false;
                    }
                    if(!got) {
                        vector<c_dcc_send_file>::iterator i;
                        got=false;
                l2:
                        for(i=dcc_awaiting_send.begin(); i!=dcc_awaiting_send.end(); ++i) {
                            my_time_t now;
                            my_time(&now);
                            if((*i).start_time+TIMEOUT_SECS<=now) {
                                dcc_awaiting_send.erase(i);
                                goto l2;
                            }
                            if(!(*i).using_ipv6 && !(*i2).using_ipv6) {
#if defined(_WIN32) || defined(_WIN64)
                                if((*i).remote_ip.S_un.S_addr==addr.S_un.S_addr) {
#else
                                if((*i).remote_ip.s_addr==addr.s_addr) {
#endif
                                    c_dcc_client c;
                                    c.server_socket=(*i2).socket;

                                    c.local=(*i2).bind_ip;
                                    c.remote=remote;
                                    c.local_port=(*i2).port;
                                    c.remote_port=0;

                                    char tmp[256];
#if defined(_WIN32) || defined(_WIN64)
                                    my_inet_ntop(AF_INET,&(addr.S_un.S_addr),tmp,sizeof(tmp)-1);
#else
                                    my_inet_ntop(AF_INET,&(addr.s_addr),tmp,sizeof(tmp)-1);
#endif
                                    c.remote=tmp;

                                    c.chat=false;
                                    c.send=false;
                                    c.telnet=false;
                                    c.send_file=*i;
                                    c.send_from_filesystem=true;
                                    c.socket=s;
                                    c.got_passwd=0;
                                    c.new_user=0;
                                    c.edit_user=0;
                                    c.edit_pass=0;
                                    c.filesystem=0;
                                    c.as_in_logic=(*i).user_name_as_in_logic;
                                    c.got_user_name=(c.as_in_logic.empty()?false:true);
                                    c.resume_pos=(*i).resume_pos;

                                    c.client_id=++dcc_last_client_id;
                                    log_clients(c.client_id,c.socket.comment);

                                    my_time(&c.session_start);
                                    /*if(c.chat)
                                        c.connect_time=dcc_push_bad_login(c.remote);*/
                                    dcc_clients.push_back(c);
                                    dcc_check_limit();
                                    got=true;
                                    dcc_awaiting_send.erase(i);
                                    goto l2;
                                }
                            } else if((*i).using_ipv6 && (*i2).using_ipv6) {
                                if((*i).remote_ip6.bytes[0]==addr6.bytes[0] && (*i).remote_ip6.bytes[1]==addr6.bytes[1] &&
                                (*i).remote_ip6.bytes[2]==addr6.bytes[2] && (*i).remote_ip6.bytes[3]==addr6.bytes[3] &&
                                (*i).remote_ip6.bytes[4]==addr6.bytes[4] && (*i).remote_ip6.bytes[5]==addr6.bytes[5] &&
                                (*i).remote_ip6.bytes[6]==addr6.bytes[6] && (*i).remote_ip6.bytes[7]==addr6.bytes[7] &&
                                (*i).remote_ip6.bytes[8]==addr6.bytes[8] && (*i).remote_ip6.bytes[9]==addr6.bytes[9] &&
                                (*i).remote_ip6.bytes[10]==addr6.bytes[10] &&(*i).remote_ip6.bytes[11]==addr6.bytes[11] &&
                                (*i).remote_ip6.bytes[12]==addr6.bytes[12] &&(*i).remote_ip6.bytes[13]==addr6.bytes[13] &&
                                (*i).remote_ip6.bytes[14]==addr6.bytes[14] &&(*i).remote_ip6.bytes[15]==addr6.bytes[15]) {
                                        c_dcc_client c;
                                        c.server_socket=(*i2).socket;

                                        c.local=(*i2).bind_ip;
                                        c.remote=remote;
                                        c.local_port=(*i2).port;
                                        c.remote_port=0;

                                        char tmp[256];
                                        my_inet_ntop(AF_INET6,&addr6,tmp,sizeof(tmp)-1);
                                        c.remote=tmp;

                                        c.chat=false;
                                        c.send=false;
                                        c.telnet=false;
                                        c.send_file=*i;
                                        c.send_from_filesystem=true;
                                        c.socket=s;
                                        c.got_passwd=0;
                                        c.new_user=0;
                                        c.edit_user=0;
                                        c.edit_pass=0;
                                        c.filesystem=0;
                                        c.as_in_logic=(*i).user_name_as_in_logic;
                                        c.got_user_name=(c.as_in_logic.empty()?false:true);
                                        c.resume_pos=(*i).resume_pos;

                                        c.client_id=++dcc_last_client_id;
                                        log_clients(c.client_id,c.socket.comment);

                                        my_time(&c.session_start);
                                        dcc_clients.push_back(c);
                                        dcc_check_limit();
                                        got=true;
                                        dcc_awaiting_send.erase(i);
                                        goto l2;
                                }
                            }
                        }
                    }
                    if(!got)
                        sock_close(s,__FILE__,__LINE__);
                }
            }
        }
    }
}

MY_STATIC void dcc_loop_telnet()
{
    string disp;
    int ec=0;

    vector<c_telnet_server>::iterator i3;
    for(i3=telnet_servers.begin(); i3!=telnet_servers.end(); ++i3) {
        if(!(*i3).active)
            continue;
        if((*i3).socket.cmp()) {
            c_socket s;
            bool async=true;

            if(!(*i3).pure_ssl)
                async=true;
            if((*i3).telnet_addr!=static_cast<uint32>(-1))
                s=sock_accept((*i3).socket,"",async);
            else
                s=sock_accept6((*i3).socket,"",async);
            if(s.cmp()) {
                sock_set_nonblocking(s,true);
                string comment;
                if(!(*i3).pure_ssl)
                    comment="Telnet client connecting to ";
                else
                    comment="SSL client connecting to ";
                comment+=(*i3).bind_ip;
                sock_comment(s,comment);

                stats_dcc_chat_new_connection();

                c_dcc_client c;
                c.client_id=++dcc_last_client_id;
                c.server_socket=(*i3).socket;

                c.is_ssl_client=(*i3).pure_ssl;

                char remote[512];
                strcpy(remote,"<unknown>");
                {
                    ec=0;
                    in_addr addr;
#if defined(_WIN32) || defined(_WIN64)
                    addr.S_un.S_addr=static_cast<unsigned int>(-1);
#else
                    addr.s_addr=static_cast<unsigned int>(-1);
#endif
                    in_addr6_ addr6;
                    memset(&addr6,0,sizeof(addr6));
                    ec=0;
                    if(!(*i3).using_ipv6) {
                        addr=sock_get_remote_addr(s,ec);
                        char* tmp=remote;
                        if(!ec)
                            my_inet_ntop(AF_INET,&addr,tmp,sizeof(remote)-1);
                        if(!(*i3).pure_ssl)
                            logic_on_internal_event("@connection@","telnet4",tmp,(*i3).bind_ip,tos((*i3).port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"Remote client connected.","");
                        else
                            logic_on_internal_event("@connection@","ssl4",tmp,(*i3).bind_ip,tos((*i3).port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"Remote client connected.","");
                    } else {
                        my_inet_pton(AF_INET6,s.host,&addr6);
                        strcpy(remote,s.host);
                        if(!(*i3).pure_ssl)
                            logic_on_internal_event("@connection@","telnet6",s.host,(*i3).bind_ip,tos((*i3).port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"Remote client connected.","");
                        else
                            logic_on_internal_event("@connection@","ssl6",s.host,(*i3).bind_ip,tos((*i3).port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"Remote client connected.","");
                    }
                }

                comment+=" form ";
                comment+=remote;
                sock_comment(s,comment);

                if(dcc_check_hard_locked_out(s,remote))
                    continue;

                if(c.is_ssl_client) {
                    c.ssl=MY_NEW c_ssl(s,&(*i3).socket,ssl_conf.get_server_cert(),ssl_conf.get_server_key());
                }

                c.local=(*i3).bind_ip;
                c.remote=remote;
                c.local_port=(*i3).port;
                c.remote_port=0;

                c.chat=true;
                c.send=false;
                c.telnet=true;
                c.send_from_filesystem=false;
                c.socket=s;
                c.got_passwd=0;
                c.new_user=0;
                c.edit_user=0;
                c.edit_pass=0;
                c.filesystem=0;
                c.as_in_logic="";
                c.got_user_name=false;
                c.replication_partner=false;

                c.lang="en";
                if(!c.is_ssl_client) {
                    disp=lang_get_string(1,c.lang,167)+"\r\n"; // always telnet! so \r\n
                    ec=0;
                    size_t sent=sock_send(c.socket,disp.c_str(),disp.length(),ec);
                    stats_dcc_chat_bytes_sent(sent);
                } else {
                    disp=lang_get_string(1,c.lang,768)+"\r\n"; // always telnet! so \r\n
                    disp+=lang_get_string(1,c.lang,167)+"\r\n"; // always telnet! so \r\n
                    string err_str;
                    if(c.ssl->get_error(err_str)) {
                        c.client_id=++dcc_last_client_id;
                        log_clients(c.client_id,c.socket.comment);
                        log_ssl(err_str);
                        log_clients(c.client_id,err_str);
                        MY_DELETE(c.ssl);
                        c.ssl=NULL;
                        continue;
                    } else {
                        c.ssl->write(disp.c_str(),disp.length());
                        stats_dcc_chat_bytes_sent(disp.length());
                    }
                }

                log_clients(c.client_id,c.socket.comment);

                my_time(&c.session_start);
                c.connect_time=dcc_push_bad_login(c.remote);
                dcc_clients.push_back(c);
                dcc_check_limit();
            }
        }
    }
}

/*!
    \brief Check for pending connections and handles existing ones
    \author VooDooMan
    \version 1
    \date 2004
*/
void dcc_loop()
{
    string disp;
    int ec=0;

    dcc_cleanup_same_ip();

    e_shutdown_reason sr=bot_get_shutdown_state();
    if(E_SD_UPGRADE==sr && last_new_instance_join+NEW_INSTANCE_TIMEOUT_AFTER_LAST_JOIN<my_time(NULL)) {
        bot_shutdown_action(E_SD_DIE,bot_get_shutdown_reason());
    }

    {
        vector<c_dcc_client_to_resume>::iterator i1;
again__:
        for(i1=dcc_to_resume.begin(); i1!=dcc_to_resume.end(); ++i1) {
            if((*i1).start_time+10<my_time(NULL)) {
                // client probably doesn't support resume
                // so connect

                c_dcc_client_to_resume res=*i1;
                dcc_to_resume.erase(i1);

                string ip_addr;
                if(!res.using_ipv6)
                    ip_addr=res.ip_addr4;
                else
                    ip_addr=res.ip_addr6;
                unsigned short port=res.port;

                string dcc_bind_ip=core_conf_getvar("dcc_bind_ip");
                if(dcc_bind_ip.empty())
                    dcc_bind_ip="0.0.0.0";
                string dcc_bind_ip6=core_conf_getvar("dcc_bind_ip6");
                if(dcc_bind_ip6.empty())
                    dcc_bind_ip6="::";

                string comment_="DCC client initialised with string ";
                comment_+=(*i1).comment;

                c_dcc_client c;

                if(!res.using_ipv6)
                    c.connect_id=threads_connect(dcc_bind_ip,ip_addr,port,comment_,true);
                else
                    c.connect_id=threads_connect(dcc_bind_ip6,ip_addr,port,comment_,true);
                c.socket.clear();

                if(!res.using_ipv6)
                    c.local=dcc_bind_ip;
                else
                    c.local=dcc_bind_ip6;
                c.remote=ip_addr;
                c.local_port=0;
                c.remote_port=port;

                c.nick=(*i1).nick;
                c.ident=irc_get_ident((*i1).nick);
                c.host=irc_get_host((*i1).nick);
                c.fullname=irc_get_fullname((*i1).nick);

                c.resume_pos=0;

                c.chat=false;
                c.send=true;
                c.send_from_filesystem=false;

                c.server_socket.clear();
                c.telnet=false;
                c.got_passwd=0;
                c.new_user=0;
                c.edit_user=0;
                c.edit_pass=0;
                c.filesystem=0;
                c.as_in_logic=res.user_name;
                c.got_user_name=(c.as_in_logic.empty()?false:true);

                c.dcc_send.size=res.file_size;
                c.dcc_send.original_name=res.file_name;
                c.dcc_send.is_file_server_proto=false;

                c.client_id=++dcc_last_client_id;
                log_clients(c.client_id,comment_);
                log_clients(c.client_id,((string)"Connecting to [")+ip_addr+"]:"+tos(port));

                my_time(&c.session_start);
                c.connect_time=dcc_push_bad_login(c.remote);
                dcc_clients.push_back(c);
                dcc_check_limit();

                goto again__;
            }
        }
    }

    {
        vector<c_dcc_client>::iterator i;
        char dcc_eol[]="\n";
        char telnet_eol[]="\r\n";
    again:
        for(i=dcc_clients.begin(); i!=dcc_clients.end(); ++i) {
            if(TCID_INVALID!=(*i).connect_id) {
                ec=0;
                bool got=threads_get_connect((*i).connect_id,ec,(*i).socket);
                if(got && ((*i).socket.cmp()==false || ec)) {
                    string log=GET_STR_DEBUG_INFO_EX("Error while calling threads_get_connect()");
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&(*i).socket);
                    MY_DELETE_A(errstr);
                    if((*i).dcc_send.f)
                        fclose((*i).dcc_send.f);
                    (*i).dcc_send.f=NULL;
                    (*i).destroy();
                    dcc_clients.erase(i);
                    return;
                }
                if(got) {
                    (*i).connect_id=TCID_INVALID;
                    continue;
                }
                continue;
            }
            if(!(*i).socket.cmp()) {
                (*i).destroy();
                dcc_clients.erase(i);
                goto again;
            }
            if((*i).replication_partner) {
                if(!(*i).telnet_botnet_called) {
                    if((*i).telnet_buffer_pos) {
                        unsigned int i1;
                        for(i1=0; i1<(*i).telnet_buffer_pos; ++i1)
                            if((*i).telnet_buffer[i1]=='\r' || (*i).telnet_buffer[i1]=='\n')
                                break;
                        if((*i).telnet_buffer[i1]=='\r' || (*i).telnet_buffer[i1]=='\n')
                            i1++;
                        if((*i).telnet_buffer[i1]=='\r' || (*i).telnet_buffer[i1]=='\n')
                            i1++;
                        unsigned int begin=i1;
                        (*i).telnet_buffer_pos-=begin;

                        botnet_received_data_from_telnet((*i).socket,(*i).as_in_logic,&(*i).telnet_buffer[begin],(*i).telnet_buffer_pos,(*i).ssl,(*i).remote);
                        // overwrite sensitive data before it gets released to the system
                        memset((*i).telnet_buffer,0,sizeof((*i).telnet_buffer));
                        //
                        (*i).telnet_buffer_pos=0;
                        (*i).telnet_botnet_called=true;
                    } else {
                        // overwrite sensitive data before it gets released to the system
                        memset((*i).telnet_buffer,0,sizeof((*i).telnet_buffer));
                        //
                        botnet_received_data_from_telnet((*i).socket,(*i).as_in_logic,NULL,0,(*i).ssl,(*i).remote);
                        (*i).telnet_botnet_called=true;
                    }
                    if((*i).ssl_connection && !(*i).ssl) {
                        // TODO SSL
                        /*
                        (*i).ssl=MY_NEW c_ssl((*i).socket,&(*i).server_socket,ssl_conf.server_cert,ssl_conf.server_key);
                        */
                    }
                }
                if((*i).socket.cmp()==false) {
                    if((*i).ssl_connection) {
                        MY_DELETE((*i).ssl);
                    }
                    (*i).destroy();
                    dcc_clients.erase(i);
                    goto again;
                }
                continue;
            }

            string eol=(*i).telnet?telnet_eol:dcc_eol;
            if((*i).chat) {
                if(!(*i).session_start)
                    my_time(&(*i).session_start);
                if((*i).got_passwd!=3 && (*i).session_start+DCC_AUTH_TIMEOUT<my_time(NULL)) {
                    // pre-auth timeout: drop
                    string log="Pre-authentication timeout (";
                    log+=tos(static_cast<int>(DCC_AUTH_TIMEOUT));
                    log+=" seconds), closing connection";
                    log_clients((*i).client_id,log);
                    if((*i).ssl) {
                        ssl_put_to_garbage((*i).ssl);
                        (*i).ssl=NULL;
                        (*i).socket.clear();
                    } else {
                        sock_linger_push((*i).socket);
                        (*i).socket.clear();
                    }
                    (*i).destroy();
                    dcc_clients.erase(i);
                    goto again;
                }

                if((*i).lang.empty())
                    (*i).lang="en";

                if((*i).ssl) {
                    size_t in=0, out=0;
                    (*i).ssl->get_cache_stats(in,out);
                    if(out>SSL_CLIENT_MAXIMUM_QUEUE) {
                        log_clients((*i).client_id,"Maximum send queue reached. The buffer was cleared.");
                        (*i).ssl->clear_send_queue();
                        disp.clear();
                        disp+=eol;
                        disp+=eol;
                        disp+=lang_get_string(1,(*i).lang,772)+eol;
                        (*i).ssl->write(disp.c_str(),disp.length());
                    }
                }

                int dcc_always_want_nick=static_cast<int>(core_conf_getvar_int("dcc_always_want_nick"));
                if(dcc_always_want_nick && (*i).got_user_name) {
                    (*i).got_user_name=false;
                    (*i).supposed_to_be=(*i).as_in_logic;
                    (*i).as_in_logic="";

                    disp=lang_get_string(1,(*i).lang,167)+eol;
                    if(!(*i).is_ssl_client) {
                        ec=0;
                        size_t sent=sock_send((*i).socket,disp.c_str(),disp.length(),ec);
                        stats_dcc_chat_bytes_sent(sent);
                    } else {
                        string err_str;
                        if((*i).ssl->get_error(err_str))
                            log_ssl(err_str);
                        else {
                            (*i).ssl->write(disp.c_str(),disp.length());
                            stats_dcc_chat_bytes_sent(disp.length());
                        }
                    }
                }
                if(!dcc_always_want_nick)
                    (*i).supposed_to_be=(*i).as_in_logic;

                {
                    ec=0;
                    char buff[5*1024+1];
                    bool closed=false;
                    int max_len=sizeof(buff)-1;
                    if((*i).got_passwd<=1 && (*i).telnet) {
                        max_len=1;
                        if((*i).in_buff.length()>128) {
                            // drop
                            log_clients((*i).client_id,"Supplied user name longer than 128 bytes, closing connection");
                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }
                    }
                    size_t len=0;
                    if(!(*i).is_ssl_client) {
                        len=sock_read((*i).socket,buff,max_len,ec,closed);
                    } else if((*i).ssl) {
                        string err_str;
                        if((*i).ssl->get_error(err_str)) {
                            MY_DELETE((*i).ssl);
                            (*i).ssl=NULL;
                            len=0;
                            log_ssl(err_str);
                            log_clients((*i).client_id,err_str);
                            ec=MY_SSL_ERROR;
                        } else {
                            len=(*i).ssl->read(buff,max_len);
                            if(len) {
                                sock_set_last_io((*i).socket,my_time(NULL),'r');
                            }
                        }
                    }
                    if(ec==0) {
                        buff[len]=0;
                        stats_dcc_chat_bytes_received(len);
                    }
                    if(closed || ec) {
                        memset(buff,0,sizeof(buff)); // clear the buffer from sensitive data before it gets released
                        if(!(*i).partyline_channel.empty())
                            botnet_partyline_leave_channel((*i).as_in_logic,(*i).partyline_channel);
                        (*i).partyline_channel="";
                        if(dcc_killing_user_socket && (*i).socket==*dcc_killing_user_socket)
                            dcc_killing_user_socket=NULL;
                        if(closed)
                            log_clients((*i).client_id,"EOF from client");
                        else {
                            char* err=NULL;
                            string log=(string)(err=sock_error(ec,c_sock_log::TYPE_ERRNO));
                            MY_DELETE_A(err);
                            log_clients((*i).client_id,log);
                        }
                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    if(len) {
                        (*i).last_input=my_time(NULL);
                        if((*i).got_passwd==1 && (*i).telnet) {
                            size_t i2=len;
                            if(i2 && '\r'==buff[i2-1])
                                i2--;
                            if(i2 && '\n'==buff[i2-1])
                                i2--;
                            if(i2 && '\r'==buff[i2-1])
                                i2--;
                            if(i2 && '\n'==buff[i2-1])
                                i2--;
                            disp.clear();
                            size_t i1;
                            for(i1=0; i1<i2; ++i1)
                                disp+="\b";
                            for(i1=0; i1<i2; ++i1)
                                disp+="*";
                            for(i1=0; i1<i2; ++i1)
                                disp+="\b";
                            ec=0;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        }
                        (*i).in_buff+=buff;
                        (*i).telnet_buffer_pos=len;
                        if((*i).telnet_buffer_pos>sizeof((*i).telnet_buffer))
                            (*i).telnet_buffer_pos=sizeof((*i).telnet_buffer);
                        memcpy((*i).telnet_buffer,buff,(*i).telnet_buffer_pos);
                    }
                    memset(buff,0,sizeof(buff)); // clear the buffer from sensitive data before it gets released
                }

                if((*i).as_in_logic.empty()) {
                    string ln=dcc_get_line((*i).in_buff);
                    if(!ln.empty() && match("### *",ln.c_str())) {
                        (*i).as_in_logic=ln;
                        {
                            string log="Client provided user name \"";
                            log+=(*i).as_in_logic;
                            log+="\"";
                            log_clients((*i).client_id,log);
                        }
                        (*i).got_passwd=0;

                        if((*i).is_ssl_client) {
                            bool ok=false;
                            if(!conf_pass.get_ssl_user((*i).as_in_logic)) {
                                ok=false;
                            } else {
                                c_ssl_bot bot;
                                bot.botname=(*i).as_in_logic;
                                ok=ssl_conf.get_ssl_bot(bot);
                                if(ok)
                                    (*i).ssl->set_expected_cert_file(bot.cert);
                            }
                            if(!ok) {
                                disp=lang_get_string(1,(*i).lang,769)+eol;
                                string err_str;
                                if((*i).ssl->get_error(err_str))
                                    log_ssl(err_str);
                                else {
                                    (*i).ssl->write(disp.c_str(),disp.length());
                                    stats_dcc_chat_bytes_sent(disp.length());
                                }
                                string log="User \"";
                                log+=(*i).as_in_logic;
                                log+="\" not allowed to login via SSL, because s/he don't have set client's certificate.";
                                log_clients((*i).client_id,log);
                                log_ssl(log);

                                c_user_to_lock_out u;
                                u.timestamp=my_time(NULL);
                                u.remote=(*i).remote;
                                dcc_users_to_lock_out.push_back(u);

                                if((*i).ssl) {
                                    ssl_put_to_garbage((*i).ssl);
                                    (*i).ssl=NULL;
                                    (*i).socket.clear();
                                } else {
                                    sock_linger_push((*i).socket);
                                    (*i).socket.clear();
                                }
                                goto cont;
                            }
                        }

                        string pswd=dcc_get_password((*i).as_in_logic);
                        if(!pswd.compare("disabled")) {
                            disp=lang_get_string(1,"en",724)+eol;
                            ec=0;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                            logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"Account is disabled. Closing connection.",(*i).supposed_to_be);

                            string log="Account is disabled. Closing connection ("+(*i).as_in_logic+")";
                            log_clients((*i).client_id,log);

                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            (*i).destroy();
                            dcc_clients.erase(i);
                            break;
                        }
                        if(pswd.empty()) {
                            // do not have password set yet
                            if((*i).supposed_to_be.compare((*i).as_in_logic)) { // !=
                                // it is different user! SPOOFING!
                                disp=lang_get_string(1,"en",698)+eol;
                                ec=0;
                                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                                logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"First login of this user; however user spplied another user name as they supposed to be (spoofing? - msg2 contains guessed name of user). No password set. Closing connection.",(*i).supposed_to_be);

                                string log="First login of this user; however user spplied another user name as they supposed to be (spoofing?). No password set. Closing connection ("+(*i).as_in_logic+")";
                                log_clients((*i).client_id,log);

                                if((*i).ssl) {
                                    ssl_put_to_garbage((*i).ssl);
                                    (*i).ssl=NULL;
                                    (*i).socket.clear();
                                } else {
                                    sock_linger_push((*i).socket);
                                    (*i).socket.clear();
                                }
                                (*i).destroy();
                                dcc_clients.erase(i);
                                break;
                            }
                        }
                    }
                }
                if((*i).got_passwd==0) {
                    if(dcc_check_soft_locked_out(i,eol))
                        break;

                    (*i).new_user=0;
                    (*i).edit_user=0;
                    (*i).edit_pass=0;
                    (*i).edit_proc=0;
                    (*i).edit_chan=0;
                    (*i).filesystem=0;
                    (*i).edit_chan=0;
                    (*i).filesystem=0;
                    (*i).msg=0;
                    (*i).private_edit=0;
                    (*i).replication=0;
                    (*i).terminator=0;
                    (*i).language=0;

                    if(logic_is_replication_partner((*i).as_in_logic)) {
                        (*i).chat=false;
                        (*i).replication_partner=true;
                        (*i).telnet_botnet_called=false;
                        if(!conf_pass.get_ssl_user((*i).as_in_logic))
                            continue;
                        if(!(*i).ssl) {
                            c_ssl_bot bot;
                            bot.botname=(*i).as_in_logic;
                            if(!ssl_conf.get_ssl_bot(bot)) {
                                bot.botname=(*i).as_in_logic;
                                bot.cert="";
                                bot.key="";
                            }

                            (*i).replication_partner=true;
                            (*i).ssl_connection=true;
                            char dummy[1024];
                            size_t len;
                            sock_set_nonblocking((*i).socket,true);

                            do {
                                len=0;
                                if((*i).socket.cmp())
                                    len=recv((*i).socket.deref(__FILE__,__LINE__),dummy,sizeof(dummy),0);
                            } while((signed)len>0);

                            sock_set_nonblocking((*i).socket,true);

                            ec=0;
                            bool closed=false;
                            do
                                len=sock_read((*i).socket,dummy,sizeof(dummy),ec,closed);
                            while((signed)len>0);

                            sock_set_nonblocking((*i).socket,true);
                            char tmp=0x01;
                            if((*i).socket.cmp())
                                send((*i).socket.deref(__FILE__,__LINE__),&tmp,1,0);

                            log_clients((*i).client_id,"SSL BOTNET connection");

                            (*i).ssl=MY_NEW c_ssl((*i).socket,&(*i).server_socket,ssl_conf.get_server_cert(),ssl_conf.get_server_key());
                            (*i).ssl->set_expected_cert_file(bot.cert);

                            botnet_received_data_from_telnet((*i).socket,(*i).as_in_logic,(*i).telnet_buffer,0,(*i).ssl,(*i).remote);
                            (*i).telnet_buffer_pos=0;
                            (*i).telnet_botnet_called=true;
                            (*i).destroy();
                            dcc_clients.erase(i);

                            goto again;
                        } else {
                            c_ssl_bot bot;
                            bot.botname=(*i).as_in_logic;
                            if(ssl_conf.get_ssl_bot(bot)) {
                                // OK, found
                                (*i).replication_partner=true;
                                (*i).ssl_connection=true;
                                char dummy[1024];
                                size_t len;

                                do
                                    len=(*i).ssl->read(dummy,sizeof(dummy));
                                while((signed)len>0);

                                log_clients((*i).client_id,"Pure-SSL BOTNET connection");

                                (*i).ssl->set_expected_cert_file(bot.cert);

                                botnet_received_data_from_telnet((*i).socket,(*i).as_in_logic,(*i).telnet_buffer,0,(*i).ssl,(*i).remote);
                                (*i).telnet_buffer_pos=0;
                                (*i).telnet_botnet_called=true;
                                char tmp=0x01;
                                (*i).ssl->write(&tmp,1);
                                (*i).destroy();
                                dcc_clients.erase(i);

                                goto again;
                            }
                        }
                        continue;
                    }

                    if((*i).as_in_logic.empty())
                        continue;

                    string pswd=dcc_get_password((*i).as_in_logic);
                    if(!pswd.compare("disabled")) {
                        logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"Account is disabled. Closing connection.",(*i).supposed_to_be);

                        string log="Account is disabled. Closing connection ("+(*i).as_in_logic+")";
                        log_clients((*i).client_id,log);

                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        break;
                    }
                    (*i).lang="en";
                    disp.clear();
                    if((*i).is_ssl_client)
                        disp=lang_get_string(1,(*i).lang,771)+eol;
                    disp+=lang_subst(lang_get_string(1,(*i).lang,1),core_conf_getvar("botname"))+eol+lang_subst(lang_get_string(1,(*i).lang,640),BOT_VERSION)+eol+lang_subst(lang_get_string(1,(*i).lang,2),core_conf_getvar("admin"))+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    if(!pswd.compare(""))
                        disp=lang_get_string(1,(*i).lang,3)+eol;
                        else
                        disp=lang_get_string(1,(*i).lang,4)+eol;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    (*i).got_passwd++;
                    (*i).in_buff="";
                    continue; // very important
                }
                if((*i).got_passwd==1) {
                    string pswd=dcc_get_password((*i).as_in_logic);
                    string p=dcc_get_line((*i).in_buff);
                    if(p.empty() || !match("### *",p.c_str()))
                        continue;

                    if((*i).telnet) {
                        // erase password
                        disp="\r";
                        disp.append(p.length(),'*');
                        disp+="\r\n";
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    }

                    disp=eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                    if(!logic_access_to_partyline((*i).as_in_logic)) {
                        // overwrite sensitive data before it gets released to the system
                        for(size_t i1=0; i1<p.length(); ++i1)
                            p[i1]='X';
                        //
                        c_user_to_lock_out u;
                        u.timestamp=my_time(NULL);
                        u.remote=(*i).remote;
                        dcc_users_to_lock_out.push_back(u);

                        disp=lang_get_string(1,(*i).lang,5)+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                        logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"No access to partyline.","");

                        string log="No access to partyline ("+(*i).as_in_logic+")";
                        log_clients((*i).client_id,log);

                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }

                    unsigned char signature[16];

                    MD5Context md5c;
                    MD5Init(&md5c);
                    MD5Update(&md5c,(unsigned char *)p.c_str(),(unsigned int)p.length());
                    MD5Final(signature,&md5c);

                    // overwrite sensitive data before it gets released to the system
                    for(size_t ii1=0; ii1<p.length(); ++ii1)
                        p[ii1]='X';
                    //

                    char sig[128];
                    sig[0]=0;
                    for(int i1=0; i1<16; ++i1) {
                        char tmp[16];
                        sprintf(tmp,"%02X",signature[i1]);
                        strcat(sig,tmp);
                    }

                    if(!pswd.empty() && cmp_strings_case_insensitive(pswd,sig)!=0) {
                        c_user_to_lock_out u;
                        u.timestamp=my_time(NULL);
                        u.remote=(*i).remote;
                        dcc_users_to_lock_out.push_back(u);

                        disp=lang_get_string(1,(*i).lang,5)+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                        logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"Bad password.","");

                        string log="Bad password ("+(*i).as_in_logic+")";
                        log_clients((*i).client_id,log);

                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        break;
                    }

                    if(pswd.empty()) {
                        // we got a new password set now!
                        if((*i).telnet) {
                            disp=lang_subst(lang_get_string(1,(*i).lang,689),core_conf_getvar("admin"))+eol;
                            ec=0;
                            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                            logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"First login of this user. No password set. Closing telnet connection.","");

                            string log="First login of this user. No password set. Closing telnet connection ("+(*i).as_in_logic+")";
                            log_clients((*i).client_id,log);

                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            (*i).destroy();
                            dcc_clients.erase(i);
                            break;
                        } else {
                            e_shutdown_reason sr=bot_get_shutdown_state();
                            if(E_SD_UPGRADE==sr) {
                                disp=lang_get_string(1,(*i).lang,642)+eol;
                                ec=0;
                                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                            } else {
                                dcc_set_password((*i).as_in_logic,sig);

                                logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"First login of this user. New password set.","");
                            }
                        }
                    }

                    (*i).got_passwd++;
                    logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,"User successfully logged in.","");
                }
                if((*i).got_passwd==2) {
                    dcc_pop_bad_login((*i).remote,(*i).connect_time);

                    {
                        string log="Login OK for user ";
                        log+=(*i).as_in_logic;
                        log_clients((*i).client_id,log);
                    }

                    FILE* in=fopen("motd.txt","r");
                    char ln[1024*10+1];
                    while(in && !feof(in)) {
                        if(fgets(ln,1024*10-1,in)==NULL)
                            break;
                        ln[1024*10]=0;
                        if(ln[0] && ln[strlen(ln)-1]=='\r')
                            ln[strlen(ln)-1]=0;
                        if(ln[0] && ln[strlen(ln)-1]=='\n')
                            ln[strlen(ln)-1]=0;
                        if(ln[0] && ln[strlen(ln)-1]=='\r')
                            ln[strlen(ln)-1]=0;
                        if(ln[0] && ln[strlen(ln)-1]=='\n')
                            ln[strlen(ln)-1]=0;
                        disp=(string)ln+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    }
                    if(in)
                        fclose(in);
                    (*i).got_passwd++;
                    dcc_loop_get_rights(i);

                    dcc_check_for_filesystem((*i).as_in_logic);

                    (*i).partyline_channel="";
                }

                if((*i).got_passwd!=3)
                    continue;

                if(dcc_is_flood(i,eol))
                    continue;

                dcc_loop_new_user(i,eol);
                dcc_loop_edit_user1(i,eol);
                dcc_loop_edit_user2(i,eol);
                dcc_loop_edit_rproc(i,eol);
                dcc_loop_edit_proc(i,eol);
                dcc_loop_edit_chan(i,eol);
                dcc_loop_filesystem(i,eol);
                dcc_loop_msg(i,eol);
                dcc_loop_private(i,eol);
                dcc_loop_replication(i,eol);
                dcc_loop_terminator(i,eol);
                dcc_loop_language(i,eol);
                dcc_loop_edit_dynbans(i,eol);
                dcc_loop_edit_pass(i,eol);

                dcc_loop_misc1(i,eol);

                if((*i).new_user ||
                    (*i).edit_user ||
                    (*i).edit_proc ||
                    (*i).edit_chan ||
                    (*i).filesystem ||
                    (*i).msg ||
                    (*i).private_edit ||
                    (*i).replication ||
                    (*i).terminator ||
                    (*i).language)
                    continue;

                string c=dcc_get_line((*i).in_buff);
                string cmd, param1, param2;
                int pos=0;
                for(unsigned int i1=0; i1<c.length(); ++i1) {
                    if((pos==0 || pos==1 || pos==2) && c[i1]==0x20) {
                        pos++;
                        continue;
                    }
                    if(pos==0)
                        cmd+=c[i1];
                    if(pos==1)
                        param1+=c[i1];
                    if(pos==2)
                        param2+=c[i1];
                }

                bool got_cmd=false;
                if(dcc_loop_misc2(c,cmd,param1,param2,i,eol,got_cmd))
                    goto again;

                if(c.length())
                    got_cmd|=mod_dispatch("partyline",(*i).as_in_logic,(*i).partyline_channel,c,false,0,NULL,"origin","@dcc@@telnet@",NULL);
                if(!got_cmd && c.length()>0 && (c[0]=='.' || !(*i).partyline_channel.compare(""))) {
                    disp=lang_get_string(1,(*i).lang,449)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                }
                if(c.length()>0 && c[0]!='.' && (*i).partyline_channel.compare("") && (*i).new_user==0 && (*i).edit_user==0 && (*i).edit_proc==0 && ((*i).chat || (*i).telnet) && !(*i).replication_partner && (*i).got_passwd==3) {
                    // don't allow users to send magic control messages
                    if(c.length() && c[0]<0x20) // if it begins with character code lower than 0x20
                        c=(string)" "+c; // prepend it by SPACE

                    if(!c.empty())
                        botnet_partyline_message((*i).as_in_logic,(*i).partyline_channel,c);
                }
            }
            if((*i).send) {
        read_more:
                ec=0;
                char buff[1024*10];
                bool closed=false;
                size_t len=0;
                if((*i).dcc_send.f || (*i).dcc_send.is_file_server_proto) {
                    len=sock_read((*i).socket,buff,sizeof(buff),ec,closed);
                    stats_dcc_send_bytes_received(len);
                }

                bool timeout=false;
                if((*i).dcc_send.last_packet==0)
                    my_time(&(*i).dcc_send.last_packet);
                if((*i).dcc_send.last_packet+core_conf_getvar_int("dcc_send_timeout")<my_time(NULL))
                    timeout=true;
                if(closed || ec || timeout) {
                    if(closed)
                        log_clients((*i).client_id,"EOF from client");
                    else if(ec) {
                        char* err=NULL;
                        string log=(string)(err=sock_error(ec,c_sock_log::TYPE_ERRNO));
                        MY_DELETE_A(err);
                        log_clients((*i).client_id,log);
                    } else
                        log_clients((*i).client_id,"Timeout");

                    if((*i).ssl) {
                        ssl_put_to_garbage((*i).ssl);
                        (*i).ssl=NULL;
                        (*i).socket.clear();
                    } else {
                        sock_linger_push((*i).socket);
                        (*i).socket.clear();
                    }
                    (*i).destroy();
                    dcc_clients.erase(i);
                    goto again;
                }

                if((*i).dcc_send.is_file_server_proto && len>0) {
                    (*i).dcc_send.is_file_server_proto=false;
                    // 120 clientnickname filesize filename
                    string msg;
                    size_t i1;
                    for(i1=0; i1<sizeof(buff) && i1<len && buff[i1]!=0 && buff[i1]!='\n' && buff[i1]!='\r'; ++i1)
                        msg+=buff[i1];
                    string code, nick, size, name;
                    int pos=0;
                    for(i1=0; i1<msg.length(); ++i1) {
                        if(msg[i1]==0x20 && pos!=3) {
                            pos++;
                            continue;
                        }
                        if(pos==0)
                            code+=msg[i1];
                        if(pos==1)
                            nick+=msg[i1];
                        if(pos==2)
                            size+=msg[i1];
                        if(pos==3)
                            name+=msg[i1];
                    }
                    string user_name=logic_find_user(nick,irc_get_ident(nick),irc_get_host(nick),irc_get_fullname(nick),irc_is_ircop(nick));
                    if(code.compare("120") || !logic_access_to_filesystem(user_name)) {
                        if(code.compare("120"))
                            log_clients((*i).client_id,"Expected response with code \"120\". Closing connection");
                        else
                            log_clients((*i).client_id,"No access to filesystem. Closing connection");
                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    (*i).dcc_send.original_name=name;
                    (*i).dcc_send.size=stoll(size);
                    if(filesys_check_add_file_raw(name,user_name)!=0) {
                        log_clients((*i).client_id,"Access to file denied");
                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    string resp="121 ";
                    resp+=irc_nick;
                    resp+=" 0\n";
                    ec=0;
                    dcc_send_msg((*i).socket,resp,ec,(*i).ssl);
                    continue;
                }
                if((*i).dcc_send.is_file_server_proto && len==0)
                    continue;
                if(closed || ec || timeout || ((*i).dcc_send.received+(*i).resume_pos)==(*i).dcc_send.size) {
                    if(closed)
                        log_clients((*i).client_id,"EOF from client");
                    else if(ec) {
                        char* err=NULL;
                        string log=(string)(err=sock_error(ec,c_sock_log::TYPE_ERRNO));
                        MY_DELETE_A(err);
                        log_clients((*i).client_id,log);
                    } else if(timeout)
                        log_clients((*i).client_id,"Timeout");
                    else
                        log_clients((*i).client_id,"Closing connection");
                    if((*i).ssl) {
                        ssl_put_to_garbage((*i).ssl);
                        (*i).ssl=NULL;
                        (*i).socket.clear();
                    } else {
                        sock_linger_push((*i).socket);
                        (*i).socket.clear();
                    }
                    if(ec) {
                        string log=GET_STR_DEBUG_INFO_EX("Error while calling sock_read()");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&((*i).socket));
                        MY_DELETE_A(errstr);
                    }

                    if((*i).dcc_send.f!=NULL) {
                        fclose((*i).dcc_send.f);
                        (*i).dcc_send.f=NULL;

                        if(((*i).dcc_send.received+(*i).resume_pos)!=(*i).dcc_send.size) {
                            string fn=(*i).dcc_send.tmp_file_name;
                            while(fn.find("/",0)!=string::npos)
                                fn.erase(0,fn.find("/",0)+1);
                            while(fn.find("\\",0)!=string::npos)
                                fn.erase(0,fn.find("\\",0)+1);

                            filesys_add_file_raw(fn,(*i).dcc_send.original_name,(*i).as_in_logic,false,(*i).resume_pos!=0);
                            logic_filesys_got_new((*i).as_in_logic,(*i).nick,(*i).ident,(*i).host,fn);
                        } else {
                            string fn=(*i).dcc_send.tmp_file_name;
                            while(fn.find("/",0)!=string::npos)
                                fn.erase(0,fn.find("/",0)+1);
                            while(fn.find("\\",0)!=string::npos)
                                fn.erase(0,fn.find("\\",0)+1);

                            filesys_add_file_raw(fn,(*i).dcc_send.original_name,(*i).as_in_logic,true,(*i).resume_pos!=0);
                            logic_filesys_got_new((*i).as_in_logic,(*i).nick,(*i).ident,(*i).host,fn);
                        }
                    }

                    (*i).destroy();
                    dcc_clients.erase(i);
                    goto again;
                }
                (*i).dcc_send.received+=len;
                if((*i).dcc_send.f==NULL && (*i).resume_pos==0) {
                    char fn[1024];
                    my_time_t now=my_time(NULL);
                    sprintf(fn,"%s",make_nice_time(now,false).c_str());
                    for(unsigned int i1=0; i1<strlen(fn); ++i1) {
                        bool ok=false;
                        if(fn[i1]>='a' && fn[i1]<='z')
                            ok=true;
                        if(fn[i1]>='A' && fn[i1]<='Z')
                            ok=true;
                        if(fn[i1]>='0' && fn[i1]<='9')
                            ok=true;
                        if(!ok)
                            fn[i1]='_';
                    }
                    string new_fn="." FILE_SLASH "filesystem" FILE_SLASH;
                    new_fn+=fn;
                    new_fn+="_";
                    new_fn+=(*i).as_in_logic;
                    new_fn+=".dat";
                    strcpy((*i).dcc_send.tmp_file_name,new_fn.c_str());
                    (*i).dcc_send.f=fopen((*i).dcc_send.tmp_file_name,"wb");
                    if(!(*i).dcc_send.f) {
                        log_clients((*i).client_id,"fopen() error");
                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                } else
                    if((*i).dcc_send.f==NULL && (*i).resume_pos!=0) {
                        string internal;
                        filesys_dcc_get_resume_info((*i).as_in_logic,(*i).dcc_send.original_name,internal);
                        if(internal.empty()) {
                            // error!
                            string err="Internal error while trying to DCC RESUME (receive file): function filesys_dcc_get_resume_info() returned an emty string as internal name of file. Closing DCC SEND connection. ";
                            err+=GET_STR_DEBUG_INFO;
                            log_debug(err);
                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            log_clients((*i).client_id,err);
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }
                        string new_fn="." FILE_SLASH "filesystem" FILE_SLASH;
                        new_fn+=internal;
                        strcpy((*i).dcc_send.tmp_file_name,new_fn.c_str());
                        (*i).dcc_send.f=fopen((*i).dcc_send.tmp_file_name,"ab");
                        if(!(*i).dcc_send.f) {
                            string err="fopen() error; errno=";
                            err+=tos(errno);
                            errno=0;
                            err+="; ";
                            err+=GET_STR_DEBUG_INFO;
                            log_clients((*i).client_id,err);
                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }
                        int my_errno;
                        if(0!=my_fseek((*i).dcc_send.f,(*i).resume_pos,SEEK_SET,my_errno) || 0!=my_errno) {
                            string err="my_fseek() error; errno=";
                            err+=tos(my_errno);
                            err+="; ";
                            err+=GET_STR_DEBUG_INFO;
                            log_clients((*i).client_id,err);
                            log_clients((*i).client_id,"Closing connection");

                            if((*i).dcc_send.f)
                                fclose((*i).dcc_send.f);
                            (*i).dcc_send.f=NULL;
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }
                    } else {
                        my_time_t now=my_time(NULL);
                        if(len)
                            (*i).dcc_send.last_packet=now;
                        if(len)
                            (*i).dcc_send.response_sent=false;
                        bool closed=false;
                        size_t in_queue=sock_get_receive_size((*i).socket,closed);
                        if((in_queue==0 && len==0 && (*i).dcc_send.received%512==0 && !(*i).dcc_send.response_sent) || ((*i).dcc_send.received+(*i).resume_pos)==(*i).dcc_send.size) {
                            (*i).dcc_send.response_sent=true;
                            uint32 s=(uint32)((*i).dcc_send.received+(*i).resume_pos);

#if !defined(WORDS_BIGENDIAN)
                            // switch bytes: BIG endian (network byte order)
                            s=swap_bytes(s);
#endif
                            size_t sent=sock_send((*i).socket,(char*)&s,4,ec);
                            stats_dcc_send_bytes_sent(sent);
                        }
                        if(((*i).dcc_send.received+(*i).resume_pos)==(*i).dcc_send.size) {
                            if(len)
                                fwrite(buff,1,len,(*i).dcc_send.f);

                            fclose((*i).dcc_send.f);
                            (*i).dcc_send.f=NULL;

                            string fn=(*i).dcc_send.tmp_file_name;
                            while(fn.find("/",0)!=string::npos)
                                fn.erase(0,fn.find("/",0)+1);
                            while(fn.find("\\",0)!=string::npos)
                                fn.erase(0,fn.find("\\",0)+1);

                            filesys_add_file_raw(fn,(*i).dcc_send.original_name,(*i).as_in_logic,true,(*i).resume_pos!=0);
                            logic_filesys_got_new((*i).as_in_logic,(*i).nick,(*i).ident,(*i).host,fn);

                            log_clients((*i).client_id,"Closing connection");

                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }
                    }
                    if(len) {
                        fwrite(buff,1,len,(*i).dcc_send.f);
                        goto read_more;
                    }
            }

            if((*i).send_from_filesystem) {
                if((*i).dcc_send.f==NULL) {
                    (*i).dcc_send.f=fopen((*i).send_file.file_name.c_str(),"rb");
                    if((*i).dcc_send.f==NULL) {
                        string str=GET_STR_DEBUG_INFO;
                        str+=" occurred error: ";
                        str+="cannot open filesystem file to send. Filename: ";
                        str+=(*i).send_file.file_name;
                        log_debug(str);

                        log_clients((*i).client_id,str);

                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    int my_errno;
                    MY_LONG_LONG sz=-1;
                    if(0!=my_fseek((*i).dcc_send.f,0,SEEK_END,my_errno) || 0!=my_errno) {
                        string err="my_fseek() error; errno=";
                        err+=tos(my_errno);
                        err+="; ";
                        err+=GET_STR_DEBUG_INFO;
                        log_clients((*i).client_id,err);
                        log_clients((*i).client_id,"Closing connection");

                        if((*i).dcc_send.f)
                            fclose((*i).dcc_send.f);
                        (*i).dcc_send.f=NULL;
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    sz=my_ftell((*i).dcc_send.f,my_errno);
                    if(-1==sz || 0!=my_errno) {
                        string err="my_fseek() error; errno=";
                        err+=tos(my_errno);
                        err+="; ";
                        err+=GET_STR_DEBUG_INFO;
                        log_clients((*i).client_id,err);
                        log_clients((*i).client_id,"Closing connection");

                        if((*i).dcc_send.f)
                            fclose((*i).dcc_send.f);
                        (*i).dcc_send.f=NULL;
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    (*i).dcc_send.size=sz;
                    my_fseek((*i).dcc_send.f,0,SEEK_SET,my_errno);
                    if(0!=my_errno) {
                        string err="my_fseek() error; errno=";
                        err+=tos(my_errno);
                        err+="; ";
                        err+=GET_STR_DEBUG_INFO;
                        log_clients((*i).client_id,err);
                        log_clients((*i).client_id,"Closing connection");

                        if((*i).dcc_send.f)
                            fclose((*i).dcc_send.f);
                        (*i).dcc_send.f=NULL;
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    } else {
                        if((*i).resume_pos!=0) {
                            if((*i).resume_pos>=sz) {
                                string err="DCC RESUME position on EOF, or beyond EOF";
                                err+="; ";
                                err+=GET_STR_DEBUG_INFO;
                                log_clients((*i).client_id,err);
                                log_clients((*i).client_id,"Closing connection");

                                if((*i).dcc_send.f)
                                    fclose((*i).dcc_send.f);
                                (*i).dcc_send.f=NULL;
                                (*i).destroy();
                                dcc_clients.erase(i);
                                goto again;
                            }
                            my_fseek((*i).dcc_send.f,(*i).resume_pos,SEEK_SET,my_errno);
                            if(0!=my_errno) {
                                string err="my_fseek() error; errno=";
                                err+=tos(my_errno);
                                err+="; ";
                                err+=GET_STR_DEBUG_INFO;
                                log_clients((*i).client_id,err);
                                log_clients((*i).client_id,"Closing connection");

                                if((*i).dcc_send.f)
                                    fclose((*i).dcc_send.f);
                                (*i).dcc_send.f=NULL;
                                (*i).destroy();
                                dcc_clients.erase(i);
                                goto again;
                            }
                            (*i).dcc_send.response_sent=true; // there is "response_sent" used as if response were received
                        }
                    }
                }
                // there is "response_sent" used as if response were received
    send_next:
                int my_errno;
                MY_LONG_LONG pos=my_ftell((*i).dcc_send.f,my_errno);
                if(-1==pos || 0!=my_errno) {
                    string err="my_fseek() error; errno=";
                    err+=tos(my_errno);
                    err+="; ";
                    err+=GET_STR_DEBUG_INFO;
                    log_clients((*i).client_id,err);
                    log_clients((*i).client_id,"Closing connection");

                    if((*i).dcc_send.f)
                        fclose((*i).dcc_send.f);
                    (*i).dcc_send.f=NULL;
                    (*i).destroy();
                    dcc_clients.erase(i);
                    goto again;
                }

                if((*i).dcc_send.response_sent || 0==pos) {
                    (*i).dcc_send.response_sent=false;
                    ec=0;
                    size_t len, sent;
                    {
                        size_t chunk_size=static_cast<size_t>(core_conf_getvar_int("dcc_send_chunk_size"));
                        chunk_size/=512;
                        chunk_size*=512;
                        if(chunk_size<=0)
                            chunk_size=512;

                        char* buff=MY_NEW char[chunk_size];
                        len=fread(buff,1,chunk_size,(*i).dcc_send.f);
                        sent=sock_send((*i).socket,buff,len,ec);
                        MY_DELETE_A(buff);
                        buff=NULL;
                    }
                    stats_dcc_send_bytes_sent(sent);
                    (*i).dcc_send.received+=len;
                    if(len)
                        my_time(&(*i).dcc_send.last_packet);
                    if(ec) {
                        {
                            char* err=NULL;
                            string l=(string)(err=sock_error(ec,c_sock_log::TYPE_ERRNO));
                            MY_DELETE_A(err);
                            log_clients((*i).client_id,l);
                        }
                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        string log=GET_STR_DEBUG_INFO_EX("Error while calling sock_send()");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&((*i).socket));
                        MY_DELETE_A(errstr);
                        if((*i).dcc_send.f)
                            fclose((*i).dcc_send.f);
                        (*i).dcc_send.f=NULL;
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                } else {
                try_get_next:
                    ec=0;
                    uint32 tmp=0;
                    bool closed=false;
                    size_t len=0;
                    if(sock_get_receive_size((*i).socket,closed)>=sizeof(tmp) && !closed)
                        len=sock_read((*i).socket,(char*)&tmp,sizeof(tmp),ec,closed);
                    if(len) {
                        my_time(&(*i).dcc_send.last_packet);
                        stats_dcc_send_bytes_received(len);
                    }
                    if(ec || closed) {
                        if(closed)
                            log_clients((*i).client_id,"EOF from client");
                        else {
                            char* err=NULL;
                            string l=(string)(err=sock_error(ec,c_sock_log::TYPE_ERRNO));
                            MY_DELETE_A(err);
                            log_clients((*i).client_id,l);
                        }
                        if((*i).ssl) {
                            ssl_put_to_garbage((*i).ssl);
                            (*i).ssl=NULL;
                            (*i).socket.clear();
                        } else {
                            sock_linger_push((*i).socket);
                            (*i).socket.clear();
                        }
                        string log=GET_STR_DEBUG_INFO_EX("Error while calling sock_read()");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&((*i).socket));
                        MY_DELETE_A(errstr);
                        if((*i).dcc_send.f)
                            fclose((*i).dcc_send.f);
                        (*i).dcc_send.f=NULL;
                        (*i).destroy();
                        dcc_clients.erase(i);
                        goto again;
                    }
                    if(len==4) {
#if !defined(WORDS_BIGENDIAN)
                        // switch bytes: BIG endian (network byte order)
                        tmp=swap_bytes(tmp);
#endif

                        uint32 pos_tmp=tmp;
                        MY_LONG_LONG pos=pos_tmp;

                        uint32 max_tmp;
                        memset(&max_tmp,0xff,sizeof(max_tmp));
                        MY_LONG_LONG max=max_tmp;

                        int my_errno;
                        MY_LONG_LONG p=my_ftell((*i).dcc_send.f,my_errno);
                        if(-1==p || 0!=my_errno || p>max)
                            p=0;
                        if(pos>p) {
                            if(-1==p || 0!=my_errno) {
                                string err="my_ftell() error; errno=";
                                err+=tos(my_errno);
                                err+="; ";
                                err+=GET_STR_DEBUG_INFO;
                                log_clients((*i).client_id,err);
                            } else if(p>max) {
                                string err="Limitation on size of the file (";
                                err+=tos(max);
                                err+=" bytes) for DCC reached";
                                err+="; ";
                                err+=GET_STR_DEBUG_INFO;
                                log_clients((*i).client_id,err);
                            }
                            log_clients((*i).client_id,"Closing connection");
                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            if((*i).dcc_send.f)
                                fclose((*i).dcc_send.f);
                            (*i).dcc_send.f=NULL;
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }

                        if(pos==(*i).send_file.size) {
                            filesys_set_file_was_read((*i).as_in_logic,(*i).send_file.public_name);
                            log_clients((*i).client_id,"Closing connection");
                            if((*i).ssl) {
                                ssl_put_to_garbage((*i).ssl);
                                (*i).ssl=NULL;
                                (*i).socket.clear();
                            } else {
                                sock_linger_push((*i).socket);
                                (*i).socket.clear();
                            }
                            if((*i).dcc_send.f)
                                fclose((*i).dcc_send.f);
                            (*i).dcc_send.f=NULL;
                            (*i).destroy();
                            dcc_clients.erase(i);
                            goto again;
                        }

                        if(pos==p) {
                            (*i).dcc_send.response_sent=true;
                            goto send_next;
                        }
                        goto try_get_next;
                    }
                }
                if((*i).dcc_send.last_packet==0)
                    my_time(&(*i).dcc_send.last_packet);
                if((*i).dcc_send.last_packet+core_conf_getvar_int("dcc_send_timeout")<my_time(NULL)) {
                    // timeout
                    if((*i).dcc_send.f!=NULL)
                        fclose((*i).dcc_send.f);
                    (*i).dcc_send.f=NULL;
                    filesys_set_file_was_read((*i).as_in_logic,(*i).send_file.public_name);
                    log_clients((*i).client_id,"Timeout");
                    if((*i).ssl) {
                        ssl_put_to_garbage((*i).ssl);
                        (*i).ssl=NULL;
                        (*i).socket.clear();
                    } else {
                        sock_linger_push((*i).socket);
                        (*i).socket.clear();
                    }
                    if((*i).dcc_send.f)
                        fclose((*i).dcc_send.f);
                    (*i).dcc_send.f=NULL;
                    (*i).destroy();
                    dcc_clients.erase(i);
                    goto again;
                }
            }
        cont:
            continue;
        }
    }

    dcc_loop_server();

    dcc_loop_telnet();
}

/*!
    \brief Check whether IP is locked out due to bad logins, and closes the connection
    \version 1
    \date 2008-01-01
    \author VooDooMan
    \param i Client descriptor
    \param eol EOL sequence
    \retval true Locked out, connection has been put to linger, removed client descriptor from vector, and increased lock out count
    \retval false Not locked out
*/
MY_STATIC bool dcc_check_soft_locked_out(vector<c_dcc_client>::iterator& i, const string& eol)
{
    int ec=0;

    int secs=static_cast<int>(core_conf_getvar_int("lockout_duration"));
    vector<c_user_to_lock_out>::iterator i1;
lock_a:
    for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1) {
        if((*i1).timestamp+secs<my_time(NULL)) {
            dcc_users_to_lock_out.erase(i1);
            goto lock_a;
        }
    }
    int num=0;
    for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1)
        if(!(*i1).remote.compare((*i).remote))
            num++;
    int max=static_cast<int>(core_conf_getvar_int("lockout_count"));
    if(max!=0 && num>=max+1) { // +1 because we got one temporary bad login as presumption
        // increase lock-out count first, for purposes of hard-lock out counting
        c_user_to_lock_out u;
        u.timestamp=my_time(NULL);
        u.remote=(*i).remote;
        dcc_users_to_lock_out.push_back(u);

        string disp=lang_get_string(1,"en",612)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        logic_on_internal_event("@connection_login@",(*i).as_in_logic,(*i).remote,(*i).local,tos((*i).local_port).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"IP is locked out due to number of bad logins. Closing connection.",(*i).supposed_to_be);

        string log="IP is locked out due to number of bad logins. Closing connection. User name \"";
        log+=(*i).as_in_logic;
        log+="\", supposed to be \"";
        log+=(*i).supposed_to_be;
        log+="\" connecting from ";
        log+=(*i).remote;
        log+=" to local ";
        log+=(*i).local;
        log+=":";
        log+=tos((*i).local_port);
        log_bot(log);

        log_clients((*i).client_id,log);

        if((*i).ssl) {
            ssl_put_to_garbage((*i).ssl);
            (*i).ssl=NULL;
            (*i).socket.clear();
        } else {
            sock_linger_push((*i).socket);
            (*i).socket.clear();
        }
        (*i).destroy();
        dcc_clients.erase(i);
        return true;
    }

    return false;
}

/*!
    \brief Check whether IP is "hard" locked out due to bad logins, and closes the connection
    \version 1
    \date 2008-01-01
    \author VooDooMan
    \param s Socket descriptor
    \param remote Remote address
    \retval true Locked out, connection has been closed, and 's' socket is invalid now
    \retval false Not locked out
*/
MY_STATIC bool dcc_check_hard_locked_out(c_socket& s, const string& remote)
{
    int secs=static_cast<int>(core_conf_getvar_int("lockout_duration"));
    vector<c_user_to_lock_out>::iterator i1;
lock_a:
    for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1) {
        if((*i1).timestamp+secs<my_time(NULL)) {
            dcc_users_to_lock_out.erase(i1);
            goto lock_a;
        }
    }
    int num=0;
    for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1)
        if(!(*i1).remote.compare(remote))
            num++;
    int max=static_cast<int>(core_conf_getvar_int("lockout_count"));
    if(max!=0 && num>=max+HARD_LOCKOUT_LIMIT_ADJUST+1) { // +1 because we got one temporary bad login as presumption
        logic_on_internal_event("@connection_login@","",remote,"","",PRIVATE_EVENT_SEVERITY_CODE_WARNING,"IP is locked out due to number of bad logins. Ignoring connection.","");

        string log="IP is locked out due to number of bad logins. Ignoring connection. (";
        log+=remote;
        log+=") Comment: ";
        log+=s.comment;
        log_bot(log);

        log_clients(0,log);

        sock_close(s,__FILE__,__LINE__);
        s.clear();
        return true;
    }

    return false;
}

/*!
    \brief Pushes temporary bad login (presumption until good login is made, to prevent abuse)
    \version 1
    \date 2008-01-01
    \author VooDooMan
    \param remote Remote address
    \return Returns entry timestamp
*/
my_time_t dcc_push_bad_login(const string& remote)
{
    c_user_to_lock_out u;
    u.timestamp=my_time(NULL);
    u.remote=remote;
    dcc_users_to_lock_out.push_back(u);

    return u.timestamp;
}

/*!
    \brief Pops back temporary bad login (presumption until good login is made, to prevent abuse), called when a good login was made
    \version 1
    \date 2008-01-01
    \author VooDooMan
    \param remote Remote address
    \param timestamp Entry timestamp
*/
void dcc_pop_bad_login(const string& remote, my_time_t timestamp)
{
    vector<c_user_to_lock_out>::iterator i1;
    for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1) {
        if((*i1).timestamp==timestamp && !(*i1).remote.compare(remote)) {
            dcc_users_to_lock_out.erase(i1);
            break; // only once!
        }
    }
}

MY_STATIC void dcc_loop_misc1(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;

    {
        int dcc_chat_ping_interval=static_cast<int>(core_conf_getvar_int("dcc_chat_ping_interval"));
        if(dcc_chat_ping_interval && sock_get_last_io((*i).socket)+dcc_chat_ping_interval<=my_time(NULL)) {
            my_time_t last_read=(*i).last_input;

            disp=lang_get_string(1,(*i).lang,611);

            long diff=(long)my_difftime(my_time(NULL),last_read);
            long days=diff/(24*60*60);
            diff%=24*60*60;
            long hrs=diff/(60*60);
            diff%=60*60;
            long mins=diff/(60);
            diff%=60;
            long secs=diff;

            string idle=lang_get_string(1,(*i).lang,695);
            idle=lang_subst(idle,tos(days));
            idle=lang_subst(idle,tos(hrs));
            idle=lang_subst(idle,tos(mins));
            idle=lang_subst(idle,tos(secs));

            disp+=" ";
            disp+=idle;
            disp+=eol;

            {
                string ts="[";
                ts+=make_nice_time(my_time(NULL));
                ts+="] ";
                disp=ts+disp;
            }

            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }

    if((*i).last_filesys_lookup==0 || (*i).last_filesys_lookup+30<my_time(NULL)) {
        my_time(&(*i).last_filesys_lookup);
        vector<c_dcc_notify> notify;
        filesys_dcc_check_for_notifies((*i).as_in_logic,(*i).u,(*i).chs,"",notify,true,(*i).lang,eol);
        if(!notify.empty()) {
            filesys_dcc_drop_notifies((*i).as_in_logic,false);

            string files;
            string msgs;
            string incomplete_files;

            vector<c_dcc_notify>::iterator i1;
            for(i1=notify.begin(); i1!=notify.end(); ++i1) {
                if((*i1).unpublished) {
                    if(!files.empty())
                        files+=", ";
                    files+="\"";
                    files+=(*i1).name;
                    files+="\"";
                }
                if((*i1).incomplete) {
                    if(!incomplete_files.empty())
                        incomplete_files+=", ";
                    incomplete_files+="\"";
                    incomplete_files+=(*i1).name;
                    incomplete_files+="\"";
                }
                if((*i1).notify_owner || (*i1).notify_user || (*i1).secure_notify_owner || (*i1).secure_notify_user)
                    msgs+=(*i1).message;
            }
            if(!msgs.empty()) {
                disp=msgs+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
    }
}

MY_STATIC bool dcc_loop_misc2(string& c, string& cmd, string& param1, string& param2, vector<c_dcc_client>::iterator& i, string& eol, bool& got_cmd)
{
    string::size_type len=cmd.length();
    if(len>=2 && '.'==cmd[0]) {
        switch(cmd[1]) {
            case 't':
                if(len>=3) switch(cmd[2]) {
                    case 'o':
                        dcc_loop_cmd_touch(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'e':
                        dcc_loop_cmd_terminator(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'w':
                dcc_loop_cmd_whois(cmd,param1,param2,eol,i,got_cmd);
                break;
            case '+':
                if(len>=3) switch(cmd[2]) {
                    case 'u':
                        dcc_loop_cmd_plus_user(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'p':
                        dcc_loop_cmd_plus_proc(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'f':
                        dcc_loop_cmd_plus_func(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'c':
                        dcc_loop_cmd_plus_chan(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'g':
                        dcc_loop_cmd_plus_group(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'e':
                if(len>=6) switch(cmd[5]) {
                    case 'u':
                        dcc_loop_cmd_edituser(cmd,param1,param2,eol,i,got_cmd);
                        if(!got_cmd)
                            dcc_loop_cmd_execute(c,cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'p':
                    case 'f':
                        dcc_loop_cmd_edit_proc_func(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'c':
                        dcc_loop_cmd_edit_chan(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'q':
                if(dcc_loop_cmd_quit(cmd,param1,param2,eol,i,got_cmd))
                    return true;
                break;
            case 'b':
                if(len>=3) switch(cmd[2]) {
                    case 'a':
                        dcc_loop_cmd_backup(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'r':
                        dcc_loop_cmd_broadcastping(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'a':
                dcc_loop_cmd_apply(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'f':
                dcc_loop_cmd_filesystem(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'u':
                dcc_loop_cmd_upgrade(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'm':
                dcc_loop_cmd_msg(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'r':
                if(len>=4) switch(cmd[3]) {
                    case 'r':
                        dcc_loop_cmd_rproc(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 's':
                        dcc_loop_cmd_restart(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'p':
                        dcc_loop_cmd_replication(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'h':
                        dcc_loop_cmd_rehash(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'g':
                dcc_loop_cmd_getfile(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'p':
                if(len>=4) switch(cmd[3]) {
                    case 'r':
                        dcc_loop_cmd_partyline(cmd,param1,param2,eol,i,got_cmd);
                        if(!got_cmd)
                            dcc_loop_cmd_part(c,cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 's':
                        dcc_loop_cmd_pass(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'i':
                        dcc_loop_cmd_private(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'l':
                if(len>=3) switch(cmd[2]) {
                    case 'e':
                        dcc_loop_cmd_leave(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'a':
                        dcc_loop_cmd_lang(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'd':
                if(len>=3) switch(cmd[2]) {
                    case 'i':
                        dcc_loop_cmd_die(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 'y':
                        dcc_loop_cmd_dynbans(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'h':
                dcc_loop_cmd_help(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 's':
                if(len>=3) switch(cmd[2]) {
                    case 'h':
                        dcc_loop_cmd_showbots(cmd,param1,param2,eol,i,got_cmd);
                        break;
                    case 't':
                        dcc_loop_cmd_stat(cmd,param1,param2,eol,i,got_cmd);
                        break;
                }
                break;
            case 'i':
                dcc_loop_cmd_info(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'c':
                dcc_loop_cmd_chpass(cmd,param1,param2,eol,i,got_cmd);
                break;
            case 'j':
                dcc_loop_cmd_join(cmd,param1,param2,eol,i,got_cmd);
                break;
        }
    }

    return false;
}

