/***************************************************************************
                          dcc_loop_edit_chan.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_chan.cpp,v 1.15 2008/03/25 12:04:25 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_chan.cpp,v 1.15 2008/03/25 12:04:25 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process edit channel definitions commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_chan(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).edit_chan==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_chan==1) {
        disp=lang_get_string(1,(*i).lang,232)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        vector<string>::iterator i1;
        for(i1=(*i).access_to_chan_defs.begin(); i1!=(*i).access_to_chan_defs.end(); ++i1) {
            disp=*i1+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        disp=lang_get_string(1,(*i).lang,233)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_chan++;
    }
    if((*i).edit_chan==2) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            (*i).edit_chan=0;
            return;
        }

        got=false;
        vector<string>::iterator i1;
        for(i1=(*i).access_to_chan_defs.begin(); i1!=(*i).access_to_chan_defs.end(); ++i1) {
            if(!p.compare(*i1)) {
                got=logic_partyline_get_channel_def(*i1,(*i).user_channel_def);
                break;
            }
        }

        if(!got) {
            disp=lang_get_string(1,(*i).lang,234)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan=1;
        } else
            (*i).edit_chan=10;
    }

    // on_mode
    if((*i).edit_chan==10) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,223)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,224)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==11) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_mode)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_mode="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_mode=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }
    // on_key
    if((*i).edit_chan==12) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,240)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,241)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==13) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_key)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_key="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_key=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }
    // on_limit
    if((*i).edit_chan==14) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,242)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,243)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==15) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_limit)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_limit="";
            (*i).edit_chan=200;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_limit=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }
    // on_topic
    if((*i).edit_chan==16) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,244)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,245)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==17) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_topic)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan=500;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_topic="";
            (*i).edit_chan=500;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan=500;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_topic=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan=500;
            }
    }

    // allow_dynamic
    if((*i).edit_chan==20) {
        disp=lang_get_string(1,(*i).lang,226)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<c_dynamic_rule>::iterator i1;
        for(i1=(*i).user_channel_def.allow_dynamic.begin(); i1!=(*i).user_channel_def.allow_dynamic.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+(*i1).group+";"+(*i1).plus_modes+";"+(*i1).minus_modes+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,227)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_chan++;
    }
    if((*i).edit_chan==21) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_chan=600;
            return;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,211)+eol;

            vector<string>::iterator i1;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                disp+=*i1+eol;

            (*i).user_channel_allow_dynamic.group="";
            (*i).user_channel_allow_dynamic.plus_modes="";
            (*i).user_channel_allow_dynamic.minus_modes="";

            disp+=lang_get_string(1,(*i).lang,715)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_chan=22;
            return;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<c_dynamic_rule>::iterator i1;
            for(i1=(*i).user_channel.allow_dynamic.begin(); i1!=(*i).user_channel.allow_dynamic.end(); ++i1, ++i2)
                if(i2==line) {
                    bool access=false;
                    map<string,string> vars;
                    vector<string>::iterator i3;
                    for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                        if(!(*i3).compare((*i1).group) || !(*i3).compare("*")) {
                            access=true;
                            break;
                        }
                    if(access)
                        (*i).user_channel.allow_dynamic.erase(i1);
                    else {
                        disp=lang_get_string(1,(*i).lang,121)+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    }
                    break;
                }
            (*i).edit_chan=20;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,227)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_chan=20;
        }
    }
    if((*i).edit_chan==22) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            (*i).edit_chan=20;
            return;
        }

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
            if(!p.compare(*i1))
                got=true;
        if(got)
            disp=lang_get_string(1,(*i).lang,228)+eol;
            else
            disp=lang_get_string(1,(*i).lang,214)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        //p=(string)"\""+p+"\"";
        if(got) {
            (*i).user_channel_allow_dynamic.group=p;
            (*i).edit_chan++;
        } else {
            // nothing!
        }

        return;
    }
    if((*i).edit_chan==23) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare("."))
            p="";
        //p=(string)"\""+p+"\"";
        (*i).user_channel_allow_dynamic.plus_modes=p;

        ec=0;

        disp=lang_get_string(1,(*i).lang,238)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_chan++;
    }
    if((*i).edit_chan==24) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare("."))
            p="";
        //p=(string)"\""+p+"\"";
        (*i).user_channel_allow_dynamic.minus_modes=p;

        (*i).user_channel_def.allow_dynamic.push_back((*i).user_channel_allow_dynamic);

        (*i).edit_chan=20;
    }

    if((*i).edit_chan==50) {
        disp=lang_get_string(1,(*i).lang,229)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==51) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,229)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).edit_chan=0;
                disp=lang_get_string(1,(*i).lang,230)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                logic_partyline_remove_channel_def((*i).user_channel_def.channel_name);
                (*i).user_channel_def.last_changed=my_time(NULL);
                logic_partyline_add_channel_def((*i).user_channel_def);

                disp=lang_get_string(1,(*i).lang,231)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_chan=0;
        }
    }

    if((*i).edit_chan==100) {
        disp=lang_get_string(1,(*i).lang,236)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_chan++;
    }
    if((*i).edit_chan==101) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            (*i).edit_chan=0;
            return;
        }

        bool got=logic_partyline_get_channel_def(p,(*i).user_channel_def);

        if(got) {
            disp=lang_get_string(1,(*i).lang,237)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan=0;
        } else {
            (*i).user_channel_def.clear();
            (*i).user_channel_def.channel_name=p;

            //(*i).edit_chan=10;
            (*i).edit_chan=1000;
            return;
        }
    }

    if((*i).edit_chan==1000) {
        disp=lang_get_string(1,(*i).lang,699)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<c_channel_def>::iterator i1;
        for(i1=r_channel_defs.begin(); i1!=r_channel_defs.end(); ++i1) {
            bool got_access=false;
            vector<string>::iterator i2;
            for(i2=(*i).access_to_channel.begin(); i2!=(*i).access_to_channel.end(); ++i2) {
                if(!(*i2).compare("*") || !cmp_strings_case_insensitive((*i1).channel_name,*i2)) {
                    got_access=true;
                    break;
                }
            }
            if(got_access) {
                disp=(*i1).channel_name;
                disp+=eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }

        disp=lang_get_string(1,(*i).lang,700)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }

    if((*i).edit_chan==1001) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare("n")) {
            (*i).edit_chan=10;
            return;
        }

        if(p.find(".show ",0)==0) {
            string ch=p;
            if(ch.find(" ",0)!=string::npos)
                ch.erase(0,ch.find(" ",0)+1);

            disp=logic_partyline_get_chandef_listing(ch,(*i).lang,eol,(*i).access_to_channel);

            if(disp.empty()) {
                disp=lang_get_string(1,(*i).lang,701)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan=1000;
                return;
            }
            // got access
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan=1000;
            return;
        }

        bool got=logic_partyline_get_channel_def(p,(*i).user_channel_def);

        if(!got) {
            disp=lang_get_string(1,(*i).lang,703)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan=1000;
            return;
        }

        disp=lang_get_string(1,(*i).lang,704)+eol;

        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_ctcp)) {
            disp+="    on_ctcp ";
            disp+=(*i).user_channel_def.on_ctcp;
            disp+=eol;
            (*i).user_channel_def.on_ctcp="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_dynamic_ban)) {
            disp+="    on_dynamic_ban ";
            disp+=(*i).user_channel_def.on_dynamic_ban;
            disp+=eol;
            (*i).user_channel_def.on_dynamic_ban="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_ircop)) {
            disp+="    on_ircop ";
            disp+=(*i).user_channel_def.on_ircop;
            disp+=eol;
            (*i).user_channel_def.on_ircop="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_key)) {
            disp+="    on_key ";
            disp+=(*i).user_channel_def.on_key;
            disp+=eol;
            (*i).user_channel_def.on_key="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_limit)) {
            disp+="    on_limit ";
            disp+=(*i).user_channel_def.on_limit;
            disp+=eol;
            (*i).user_channel_def.on_limit="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_mode)) {
            disp+="    on_mode ";
            disp+=(*i).user_channel_def.on_mode;
            disp+=eol;
            (*i).user_channel_def.on_mode="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_notice)) {
            disp+="    on_notice ";
            disp+=(*i).user_channel_def.on_notice;
            disp+=eol;
            (*i).user_channel_def.on_notice="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_part)) {
            disp+="    on_part ";
            disp+=(*i).user_channel_def.on_part;
            disp+=eol;
            (*i).user_channel_def.on_part="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_privmsg)) {
            disp+="    on_privmsg ";
            disp+=(*i).user_channel_def.on_privmsg;
            disp+=eol;
            (*i).user_channel_def.on_privmsg="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_server_msg)) {
            disp+="    on_server_msg ";
            disp+=(*i).user_channel_def.on_server_msg;
            disp+=eol;
            (*i).user_channel_def.on_server_msg="";
        }
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_topic)) {
            disp+="    on_topic ";
            disp+=(*i).user_channel_def.on_topic;
            disp+=eol;
            (*i).user_channel_def.on_topic="";
        }
        disp+=lang_get_string(1,(*i).lang,705)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,706)+eol;
        vector<string>::iterator i2;
    erase_groups_again:
        for(i2=(*i).user_channel_def.groups.begin(); i2!=(*i).user_channel_def.groups.end(); ++i2) {
            got=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare("*"))
                    got=true;
                if(!(*i2).compare(*i3))
                    got=true;
                if(got)
                    break;
            }
            if(!got) {
                disp+=*i2;
                disp+=eol;
                (*i).user_channel_def.groups.erase(i2);
                goto erase_groups_again;
            }
        }
        disp+=lang_get_string(1,(*i).lang,705)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,707)+eol;
        vector<c_dynamic_rule>::iterator i4;
    erase_groups_again_2:
        for(i4=(*i).user_channel_def.allow_dynamic.begin(); i4!=(*i).user_channel_def.allow_dynamic.end(); ++i4) {
            got=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare("*"))
                    got=true;
                if(!(*i4).group.compare(*i3))
                    got=true;
                if(got)
                    break;
            }
            if(!got) {
                disp+=(*i4).group;
                disp+=eol;
                (*i).user_channel_def.allow_dynamic.erase(i4);
                goto erase_groups_again_2;
            }
        }
        disp+=lang_get_string(1,(*i).lang,705)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,709)+eol;
        vector<string>::iterator i5;
    erase_groups_again_3:
        for(i5=(*i).user_channel_def.dynbans_editors.begin(); i5!=(*i).user_channel_def.dynbans_editors.end(); ++i5) {
            got=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare("*"))
                    got=true;
                if(!(*i5).compare(*i3))
                    got=true;
                if(got)
                    break;
            }
            if(!got) {
                disp+=*i5;
                disp+=eol;
                (*i).user_channel_def.dynbans_editors.erase(i5);
                goto erase_groups_again_3;
            }
        }
        disp+=lang_get_string(1,(*i).lang,705)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        if(!(*i).access_to_replication) {
            (*i).user_channel_def.replication.clear();
            disp=lang_get_string(1,(*i).lang,708)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        (*i).edit_chan++;
        return;
    }

    if((*i).edit_chan==1002) {
        disp=lang_get_string(1,(*i).lang,582)+eol;

        map<string,string>::iterator i5;
        for(i5=(*i).user_channel_def.dynamic_bans.begin(); i5!=(*i).user_channel_def.dynamic_bans.end(); ++i5)
            disp+=(string)"    dynamic_ban "+(*i5).first+" "+(*i5).second+eol;

        disp+=lang_get_string(1,(*i).lang,710)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
        return;
    }

    if((*i).edit_chan==1003) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;

        if(!p.compare("y")) {
            got=true;
            (*i).user_channel_def.dynamic_bans.clear();
            disp=lang_get_string(1,(*i).lang,711)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        if(!p.compare("n")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,712)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        if(!got)
            (*i).edit_chan--;
        else
            (*i).edit_chan++;

        return;
    }

    if((*i).edit_chan==1004) {
        (*i).edit_chan=10;
        return;
    }

    if((*i).edit_chan==200) {
        disp=lang_get_string(1,(*i).lang,239)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_channel_def.groups.begin(); i1!=(*i).user_channel_def.groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            map<string,string> vars;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+(*i1)+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_chan++;
    }
    if((*i).edit_chan==201) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_chan=20;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_groups.begin()==(*i).access_grant_groups.end()) {
                disp=lang_get_string(1,(*i).lang,127)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan=200;
                return;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan=202;
                return;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            map<string,string> vars;
            vector<string>::iterator i1;
            bool access=false;
            for(i1=(*i).user_channel_def.groups.begin(); i1!=(*i).user_channel_def.groups.end(); ++i1, ++i2) {
                vector<string>::iterator i3;
                for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_channel_def.groups.erase(i1);
                        break;
                    }
                }
                if(access)
                    break;
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_chan=200;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_chan==202) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_channel_def.groups.push_back(p);
        }
        (*i).edit_chan=200;
        return;
    }

    // on_ircop
    if((*i).edit_chan==500) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,447)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,448)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==501) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_ircop)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_ircop="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_ircop=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    // on_privmsg
    if((*i).edit_chan==502) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,575)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,576)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==503) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_privmsg)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_privmsg="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_privmsg=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    // on_notice
    if((*i).edit_chan==504) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,603)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,604)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==505) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_notice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_notice="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_notice=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    // on_part
    if((*i).edit_chan==506) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,577)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,578)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==507) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_part)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_part="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_part=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    // on_ctcp
    if((*i).edit_chan==508) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,608)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,609)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==509) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_ctcp)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_ctcp="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_ctcp=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    // on_dynamic_ban
    if((*i).edit_chan==510) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,675)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,676)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==511) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_dynamic_ban)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_dynamic_ban="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_dynamic_ban=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    // on_server_msg
    if((*i).edit_chan==512) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,677)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,678)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,225)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_chan++;
    }
    if((*i).edit_chan==513) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel_def.on_server_msg)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare("..")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,132)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).user_channel_def.on_server_msg="";
            (*i).edit_chan++;
        } else
            if(!p.compare(".")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,57)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_chan++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel_def.on_server_msg=p;
                else {
                    (*i).edit_chan--;
                    return;
                }
                (*i).edit_chan++;
            }
    }

    if((*i).edit_chan==514) {
        (*i).edit_chan=200;
        return;
    }

    // dynamic bans editors
    if((*i).edit_chan==600) {
        disp=lang_get_string(1,(*i).lang,587)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_channel_def.dynbans_editors.begin(); i1!=(*i).user_channel_def.dynbans_editors.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+(*i1);
            disp+=" (";
            vector<string>::iterator i3;
            bool access=false;
            map<string,string> vars;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            disp+=access?lang_get_string(1,(*i).lang,120):lang_get_string(1,(*i).lang,121);
            disp+=")";
            disp+=eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,588)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_chan++;
        return;
    }
    if((*i).edit_chan==601) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_chan=50;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,211)+eol;

            vector<string>::iterator i1;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                disp+=*i1+eol;

            disp+=lang_get_string(1,(*i).lang,715)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_chan=602;
            return;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            for(i1=(*i).user_channel_def.dynbans_editors.begin(); i1!=(*i).user_channel_def.dynbans_editors.end(); ++i1, ++i2)
                if(i2==line) {
                    bool access=false;
                    map<string,string> vars;
                    vector<string>::iterator i3;
                    for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                        if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                            access=true;
                            break;
                        }
                    if(access)
                        (*i).user_channel_def.dynbans_editors.erase(i1);
                    else {
                        disp=lang_get_string(1,(*i).lang,121)+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    }
                    break;
                }
            (*i).edit_chan=600;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,588)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_chan=600;
        }
    }
    if((*i).edit_chan==602) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            (*i).edit_chan=600;
            return;
        }

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
            if(!p.compare(*i1))
                got=true;
        if(got)
            disp=lang_get_string(1,(*i).lang,228)+eol;
            else
            disp=lang_get_string(1,(*i).lang,214)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        //p=(string)"\""+p+"\"";
        if(got) {
            (*i).user_channel_def.dynbans_editors.push_back(p);
            (*i).edit_chan=600;
        } else {
            // nothing!
        }
        return;
    }
}

