/***************************************************************************
                          dcc_loop_edit_dynbans.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_dynbans.cpp,v 1.15 2008/07/02 09:35:48 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_dynbans.cpp,v 1.15 2008/07/02 09:35:48 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process edit channel's dynamic bans in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_dynbans(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).dynbans==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    ec=0;

    if((*i).dynbans==1) {
        c_channel_def chd;
        bool got=logic_partyline_get_channel_def((*i).dynbanc_channel,chd);
        bool access=false;
        if(got) {
            vector<string>::iterator i1;
            for(i1=chd.dynbans_editors.begin(); i1!=chd.dynbans_editors.end(); ++i1) {
                deque<c_user>::iterator i2;
                for(i2=r_users.begin(); i2!=r_users.end(); ++i2) {
                    if(!(*i2).name.compare((*i).as_in_logic)) {
                        vector<string>::iterator i3;
                        for(i3=(*i2).groups.begin(); i3!=(*i2).groups.end(); ++i3) {
                            if(!(*i1).compare(*i3) || !(*i3).compare("*")) {
                                access=true;
                                break;
                            }
                        }
                    }
                    if(access)
                        break;
                }
                if(access)
                    break;
            }
        }
        if(!got || !access) {
            (*i).dynbans=0;
            disp=lang_get_string(1,(*i).lang,581)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }

        (*i).dynbans++;
        return;
    }

    if((*i).dynbans==2) {
        c_channel_def chd;
        bool got=logic_partyline_get_channel_def((*i).dynbanc_channel,chd);
        if(!got) {
            // huh?!
            (*i).dynbans=0;
            return;
        }

        disp=lang_get_string(1,(*i).lang,582)+eol;
        map<string,string>::iterator i1;
        for(i1=chd.dynamic_bans.begin(); i1!=chd.dynamic_bans.end(); ++i1) {
            disp+=lang_get_string(1,(*i).lang,583);
            disp+=" ";
            disp+=(*i1).first;
            disp+=" ";
            disp+=lang_get_string(1,(*i).lang,584);
            disp+=(*i1).second;
            disp+=eol;
        }
        disp+=lang_get_string(1,(*i).lang,585);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).dynbans++;
        return;
    }

    if((*i).dynbans==3) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        got=false;

        vector<c_channel_def>::iterator iii;
        for(iii=r_channel_defs.begin(); iii!=r_channel_defs.end(); ++iii) {
            if(!cmp_strings_case_insensitive((*iii).channel_name,(*i).dynbanc_channel)) {
                got=true;
                break;
            }
        }

        if(!got) {
            // huh?!
            (*i).dynbans=0;
            return;
        }

        if(p.length()>=3 && p[0]=='.' && p[1]=='-' && p[2]==0x20) {
            string mask=p;
            if(mask.find(" ",0)!=string::npos)
                mask.erase(0,mask.find(" ",0)+1);

            //mask=(string)"\""+mask+"\"";

            map<string,string>::iterator i1;
        erase_again:
            for(i1=(*iii).dynamic_bans.begin(); i1!=(*iii).dynamic_bans.end(); ++i1) {
                if(!(*i1).first.compare(mask)) {
                    (*iii).dynamic_bans.erase(i1);
                    goto erase_again;
                }
            }

            (*i).dynbans=2;
            return;
        }

        if(p.length()>=3 && p[0]=='.' && p[1]=='+' && p[2]==0x20) {
            string mask=p;
            if(mask.find(" ",0)!=string::npos)
                mask.erase(0,mask.find(" ",0)+1);

            if(mask.find(" ",0)==string::npos)
                mask+=" ";

            string reason=mask;
            if(mask.find(" ",0)!=string::npos)
                mask.erase(mask.find(" ",0),mask.length()-mask.find(" ",0));
            if(reason.find(" ",0)!=string::npos)
                reason.erase(0,reason.find(" ",0)+1);

            //mask=(string)"\""+mask+"\"";

            map<string,string>::iterator i1;
        erase_ban_again:
            for(i1=(*iii).dynamic_bans.begin(); i1!=(*iii).dynamic_bans.end(); ++i1) {
                if(!(*i1).first.compare(mask)) {
                    (*iii).dynamic_bans.erase(i1);
                    goto erase_ban_again;
                }
            }

            pair<string,string> p;
            p.first=mask;
            p.second=reason;
            (*iii).dynamic_bans.insert(p);

            (*i).dynbans=2;
            return;
        }

        if(!p.compare(".")) {
            disp=lang_get_string(1,(*i).lang,586)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).dynbans=0;
            return;
        }

        (*i).dynbans=2;
        return;
    }
}

