/***************************************************************************
                          dcc_loop_edit_pass.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_pass.cpp,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_pass.cpp,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process .pass command
    \author VooDooMan
    \version 1
    \date 2005-08-03
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_pass(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).edit_pass==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_pass==1) {
        bool cur;

        disp=lang_get_string(1,(*i).lang,728)+eol;

        disp+="    ";
        cur=conf_pass.get_disabled_user((*i).edit_pasc_user);
        if(!cur)
            disp+=lang_get_string(1,(*i).lang,734);
        else
            disp+=lang_get_string(1,(*i).lang,735);
        disp+=eol;

        disp+=lang_get_string(1,(*i).lang,729)+eol;

        disp+="    ";
        cur=conf_pass.get_ssl_user((*i).edit_pasc_user);
        if(cur)
            disp+=lang_get_string(1,(*i).lang,734);
        else
            disp+=lang_get_string(1,(*i).lang,735);
        disp+=eol;

        disp+=lang_get_string(1,(*i).lang,730)+eol;
        disp+=lang_get_string(1,(*i).lang,731)+eol;
        disp+=lang_get_string(1,(*i).lang,740)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_pass+=1;
    }
    if((*i).edit_pass==2) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".2")) {
            (*i).edit_pass=200;
            got=true;
        }
        if(!p.compare(".3")) {
            (*i).edit_pass=300;
            got=true;
        }
        if(!p.compare(".4")) {
            (*i).edit_pass=400;
            got=true;
        }
        if(!p.compare(".5")) {
            (*i).edit_pass=500;
            got=true;
        }
        if(!p.compare(".finish")) {
            (*i).edit_pass=0;
            got=true;
        }
        if(!got) {
            (*i).edit_pass-=1;
            return;
        }
    }

    // .2 = Allow user to log in? [y/n]
    if((*i).edit_pass==200) {
        disp=lang_get_string(1,(*i).lang,736)+eol;
        disp+=lang_get_string(1,(*i).lang,733);
        disp+=" ";
        bool cur=!conf_pass.get_disabled_user((*i).edit_pasc_user);
        if(cur)
            disp+=lang_get_string(1,(*i).lang,734);
        else
            disp+=lang_get_string(1,(*i).lang,735);
        disp+=eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_pass+=1;
    }
    if((*i).edit_pass==201) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        bool set=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            set=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            set=false;
        }
        set=!set;
        if(got) {
            conf_pass.set_disabled_user((*i).edit_pasc_user,set);
            conf_pass.backup();
            (*i).edit_pass=1;
            return;
        } else {
            (*i).edit_pass-=1;
            return;
        }
    }

    // .3 = Allow only SSL connections to telnet for user? [y/n]
    if((*i).edit_pass==300) {
        disp=lang_get_string(1,(*i).lang,737)+eol;
        disp+=lang_get_string(1,(*i).lang,733);
        disp+=" ";
        bool cur=conf_pass.get_ssl_user((*i).edit_pasc_user);
        if(cur)
            disp+=lang_get_string(1,(*i).lang,734);
        else
            disp+=lang_get_string(1,(*i).lang,735);
        disp+=eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_pass+=1;
    }
    if((*i).edit_pass==301) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        bool set=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            set=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            set=false;
        }
        set=set;
        if(got) {
            conf_pass.set_ssl_user((*i).edit_pasc_user,set);
            conf_pass.backup();
            (*i).edit_pass=1;
            return;
        } else {
            (*i).edit_pass-=1;
            return;
        }
    }

    // .4 = Enter local password to use with this user:
    if((*i).edit_pass==400) {
        disp=lang_get_string(1,(*i).lang,738)+eol;
        disp+=eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_pass+=1;
    }
    if((*i).edit_pass==401) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        unsigned char signature[16];

        MD5Context md5c;
        MD5Init(&md5c);
        MD5Update(&md5c,(unsigned char *)p.c_str(),(unsigned int)p.length());
        MD5Final(signature,&md5c);

        char sig[128];
        sig[0]=0;
        for(int i1=0; i1<16; ++i1) {
            char tmp[16];
            sprintf(tmp,"%02X",signature[i1]);
            strcat(sig,tmp);
        }

        conf_pass.set_local_password_md5((*i).edit_pasc_user,sig);
        conf_pass.backup();
        (*i).edit_pass=1;
    }

    // .5 = Enter remote password to use with this user:
    if((*i).edit_pass==500) {
        disp=lang_get_string(1,(*i).lang,739)+eol;
        disp+=eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_pass+=1;
    }
    if((*i).edit_pass==501) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        unsigned char signature[16];

        MD5Context md5c;
        MD5Init(&md5c);
        MD5Update(&md5c,(unsigned char *)p.c_str(),(unsigned int)p.length());
        MD5Final(signature,&md5c);

        char sig[128];
        sig[0]=0;
        for(int i1=0; i1<16; ++i1) {
            char tmp[16];
            sprintf(tmp,"%02X",signature[i1]);
            strcat(sig,tmp);
        }

        conf_pass.set_remote_password_md5((*i).edit_pasc_user,sig);
        conf_pass.backup();
        (*i).edit_pass=1;
    }
}

