/***************************************************************************
                          dcc_loop_edit_proc.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_proc.cpp,v 1.15 2008/03/25 12:04:25 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_proc.cpp,v 1.15 2008/03/25 12:04:25 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process new / edit procedure commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_proc(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).edit_proc==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_proc==1) {
        (*i).edit_proc_addbefore_line=-1;
        (*i).edit_proc_addafter_line=-1;
        (*i).proc_error="";
        (*i).proc_to_delete="";
        (*i).plus_proc=false;

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.find("(",0)!=string::npos)
            p.erase(p.find("(",0),p.length()-p.find("(",0));

        got=false;
        {
            vector<c_procedure>::iterator i1;
            c_module* core_mod=get_module("core",true);
            if(core_mod) {
                for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1) {
                    bool access=false;
                    vector<string>::iterator i2;
                    for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                        vector<string>::iterator i3;
                        for(i3=(*i1).groups.begin(); i3!=(*i1).groups.end(); ++i3) {
                            if(!(*i3).compare(*i2) || !(*i2).compare("*")) {
                                access=true;
                                break;
                            }
                        }
                        if(access)
                            break;
                    }

                    if(access) {
                        string wo_decl=(*i1).name;
                        if(wo_decl.find("(",0)!=string::npos)
                            wo_decl.erase(wo_decl.find("(",0),wo_decl.length()-wo_decl.find("(",0));

                        if(!p.compare(wo_decl)) {
                            got=true;
                            (*i).it_is_func=false;

                            (*i).proc_name=(*i1).name;
                            logic_list_proc((*i).proc_name,(*i).proc_commands,(*i).proc_decl,(*i).proc_groups,(*i).proc_repl,(*i).remote_call);
                            vector<string>::iterator i3;
                            map<string,string> vars;
                            /*for(i3=(*i).proc_groups.begin(); i3!=(*i).proc_groups.end(); ++i3)
                                *i3=var_eval_string(*i3,vars);*/
                            list<string>::iterator i2=(*i).proc_commands.end();
                            i2--;
                            (*i).proc_commands.erase(i2); // erase trailing "}"
                            (*i).edit_proc++;

                            break;
                        }
                    }
                }
            }
        }

        if(!got) {
            map<string,c_function*>::iterator i1;
            c_module* core_mod=get_module("core",true);
            if(core_mod) {
                for(i1=core_mod->r_functions.functions.begin(); i1!=core_mod->r_functions.functions.end(); ++i1) {
                    bool access=false;
                    vector<string>::iterator i2;
                    for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                        vector<string>::iterator i3;
                        for(i3=(*i1).second->groups.begin(); i3!=(*i1).second->groups.end(); ++i3) {
                            if(!(*i3).compare(*i2) || !(*i2).compare("*")) {
                                access=true;
                                break;
                            }
                        }
                        if(access)
                            break;
                    }

                    if(access) {
                        string wo_decl=(*i1).second->get_name();
                        if(wo_decl.find("(",0)!=string::npos)
                            wo_decl.erase(wo_decl.find("(",0),wo_decl.length()-wo_decl.find("(",0));

                        if(!p.compare(wo_decl)) {
                            got=true;
                            (*i).it_is_func=true;

                            (*i).proc_name=(*i1).second->get_name();
                            logic_list_func((*i).proc_name,(*i).proc_commands,(*i).proc_decl,(*i).proc_groups,(*i).proc_repl,(*i).remote_call);
                            vector<string>::iterator i3;
                            map<string,string> vars;
                            /*for(i3=(*i).proc_groups.begin(); i3!=(*i).proc_groups.end(); ++i3)
                                *i3=var_eval_string(*i3,vars);*/
                            (*i).edit_proc++;

                            break;
                        }
                    }
                }
            }
        }

        if(!got) {
            disp=lang_get_string(1,(*i).lang,137)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
    }
    if((*i).edit_proc==2) {
        disp=lang_get_string(1,(*i).lang,138)+eol;
        disp=lang_subst(disp,(*i).proc_name);
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        list<string>::iterator i1;
        for(i1=(*i).proc_commands.begin(); i1!=(*i).proc_commands.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+*i1+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,139)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        if(!(*i).proc_error.empty()) {
            disp=(*i).proc_error;
            (*i).proc_error="";
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        (*i).edit_proc++;
    }
    if((*i).edit_proc==3) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_proc=6;
            return;
        }

        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }

        if(!p1.compare(".addbefore")) {
            got=true;
            int line=stoi(p2);
            (*i).edit_proc_addbefore_line=line;

            disp=lang_get_string(1,(*i).lang,140)+eol;
            disp=lang_subst(disp,tos(line));
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_proc++;
        }
        if(!p1.compare(".addafter")) {
            got=true;
            int line=stoi(p2);
            (*i).edit_proc_addafter_line=line;

            disp=lang_get_string(1,(*i).lang,141)+eol;
            disp=lang_subst(disp,tos(line));
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_proc++;
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            list<string>::iterator i1;
            for(i1=(*i).proc_commands.begin(); i1!=(*i).proc_commands.end(); ++i1, ++i2) {
                if(i2==line) {
                    (*i).proc_commands.erase(i1);
                    break;
                }
            }
            (*i).edit_proc=2;
        }
        if(!p1.compare(".replace")) {
            got=true;
            int line=stoi(p2);
            (*i).edit_proc_replace_line=line;

            disp=lang_get_string(1,(*i).lang,141)+eol;
            disp=lang_subst(disp,tos(line));
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_proc=5;
        }
        if(!p.compare(".groups")) {
            got=true;

            (*i).edit_proc=7;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,139)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_proc==4) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        bool before=(*i).edit_proc_addbefore_line!=-1;
        int line;
        if(before)
            line=(*i).edit_proc_addbefore_line;
            else
            line=(*i).edit_proc_addafter_line;
        int i2=1;
        list<string>::iterator i1;
        got=false;
        for(i1=(*i).proc_commands.begin(); i1!=(*i).proc_commands.end(); ++i1, ++i2) {
            if(before && i2==line) {
                (*i).proc_commands.insert(i1,p);
                got=true;
                break;
            }
            if(!before && i2==line+1) {
                (*i).proc_commands.insert(i1,p);
                got=true;
                break;
            }
        }
        if(!got)
            (*i).proc_commands.push_back(p);
        (*i).edit_proc=2;
    }
    if((*i).edit_proc==5) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        int line=(*i).edit_proc_replace_line;
        int i2=1;
        list<string>::iterator i1;
        for(i1=(*i).proc_commands.begin(); i1!=(*i).proc_commands.end(); ++i1, ++i2) {
            if(i2==line) {
                *i1=p;
                break;
            }
        }
        (*i).edit_proc=2;
    }
    if((*i).edit_proc==6) {
        disp=lang_get_string(1,(*i).lang,142)+eol;
        disp=lang_subst(disp,(*i).proc_name);
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        if(!(*i).it_is_func) {
            int error_line;
            string error_reason;
            try {
                logic_parse_proc(error_reason,error_line,(*i).proc_commands,false,(*i).proc_decl,(*i).proc_groups,(*i).proc_repl,(*i).remote_call);
            } catch(c_proc_exc& e) {
                error_line=-1;
                error_reason=e.get_msg();
            }

            if(error_line!=0) {
                disp=lang_get_string(1,(*i).lang,143)+eol;
                disp=lang_subst(disp,tos(error_line));
                if(!error_reason.empty()) {
                    string d=lang_get_string(1,(*i).lang,144)+eol;
                    disp+=lang_subst(d,error_reason);
                }
                (*i).proc_error=disp;
                (*i).edit_proc=2;
            } else {
                {
                erase_again_1:
                    list<string>::iterator i1;
                    for(i1=(*i).proc_commands.begin(); i1!=(*i).proc_commands.end(); ++i1) {
                        string cmd=*i1;
                        while(cmd.length() && (0x20==cmd[0] || '\t'==cmd[0]))
                            cmd.erase(0,1);
                        vector<string> parts;
                        explode(cmd,0x20,parts,false);
                        if(!parts.empty() && (*(parts.begin())).find("member_of_group",0)==0) {
                            (*i).proc_commands.erase(i1);
                            goto erase_again_1;
                        }
                        if(!parts.empty() && (*(parts.begin())).find("replication",0)==0) {
                            (*i).proc_commands.erase(i1);
                            goto erase_again_1;
                        }
                        if(!parts.empty() && (*(parts.begin())).find("remote_bot_call",0)==0) {
                            (*i).proc_commands.erase(i1);
                            goto erase_again_1;
                        }
                    }
                }
                {
                    // for .+proc
                    if(!(*i).proc_to_delete.empty()) {
                        c_module* core_mod=get_module("core",true);
                        if(core_mod) {
                            {
                                vector<c_procedure>::iterator i1;
                                for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1)
                                    if(!(*i1).name.compare((*i).proc_to_delete)) {
                                        core_mod->r_procedures.erase(i1);
                                        break;
                                    }
                            }
                            {
                                string proc_to_delete=(*i).proc_to_delete;
                                if(proc_to_delete.find("(",0)!=string::npos)
                                    proc_to_delete.erase(proc_to_delete.find("(",0),proc_to_delete.length()-proc_to_delete.find("(",0));
                                map<string,c_function*>::iterator i1;
                                for(i1=core_mod->r_functions.functions.begin(); i1!=core_mod->r_functions.functions.end(); ++i1)
                                    if(!(*i1).first.compare(proc_to_delete)) {
                                        core_mod->r_functions.functions.erase(i1);
                                        break;
                                    }
                            }
                        }
                    }
                }

                /*if(!(*i).plus_proc)
                    (*i).proc_commands.push_back("}"); // add removed bracket*/
                (*i).proc_commands.push_front((string)"last_changed "+tos(static_cast<unsigned long>(my_time(NULL))));
                {
                    /*
                    vector<string>::iterator i1;
                    for(i1=(*i).proc_groups.begin(); i1!=(*i).proc_groups.end(); ++i1)
                        (*i1)=(string)"\""+(*i1)+"\"";
                    */
                }
                try {
                    logic_parse_proc(error_reason,error_line,(*i).proc_commands,true,(*i).proc_decl,(*i).proc_groups,(*i).proc_repl,(*i).remote_call);
                } catch(c_proc_exc& e) {
                    error_line=-1;
                    error_reason=e.get_msg();
                }
                disp=lang_get_string(1,(*i).lang,73)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_proc=0;
            }
        } else {
            int error_line;
            string error_reason;
            logic_parse_func(error_reason,error_line,(*i).proc_commands,false,(*i).proc_decl,(*i).proc_groups,(*i).proc_repl,(*i).remote_call);

            if(error_line!=0) {
                disp=lang_get_string(1,(*i).lang,143)+eol;
                disp=lang_subst(disp,tos(error_line));
                if(!error_reason.empty()) {
                    string d=lang_get_string(1,(*i).lang,144)+eol;
                    disp+=lang_subst(d,error_reason);
                }
                (*i).proc_error=disp;
                (*i).edit_proc=2;
            } else {
                {
                erase_again_2:
                    list<string>::iterator i1;
                    for(i1=(*i).proc_commands.begin(); i1!=(*i).proc_commands.end(); ++i1) {
                        string cmd=*i1;
                        while(cmd.length() && (0x20==cmd[0] || '\t'==cmd[0]))
                            cmd.erase(0,1);
                        vector<string> parts;
                        explode(cmd,0x20,parts,false);
                        if(!parts.empty() && (*(parts.begin())).find('#',0)==0) {
                            (*i).proc_commands.erase(i1);
                            goto erase_again_2;
                        }
                    }
                }
                {
                    // for .+proc
                    if(!(*i).proc_to_delete.empty()) {
                        c_module* core_mod=get_module("core",true);
                        if(core_mod) {
                            {
                                vector<c_procedure>::iterator i1;
                                for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1)
                                    if(!(*i1).name.compare((*i).proc_to_delete)) {
                                        core_mod->r_procedures.erase(i1);
                                        break;
                                    }
                            }
                            {
                                string proc_to_delete=(*i).proc_to_delete;
                                if(proc_to_delete.find("(",0)!=string::npos)
                                    proc_to_delete.erase(proc_to_delete.find("(",0),proc_to_delete.length()-proc_to_delete.find("(",0));
                                map<string,c_function*>::iterator i1;
                                for(i1=core_mod->r_functions.functions.begin(); i1!=core_mod->r_functions.functions.end(); ++i1)
                                    if(!(*i1).first.compare(proc_to_delete)) {
                                        core_mod->r_functions.functions.erase(i1);
                                        break;
                                    }
                            }
                        }
                    }
                }

                /*if(!(*i).plus_proc)
                    (*i).proc_commands.push_back("}"); // add removed bracket*/
                {
                    /*
                    vector<string>::iterator i1;
                    for(i1=(*i).proc_groups.begin(); i1!=(*i).proc_groups.end(); ++i1)
                        (*i1)=(string)"\""+(*i1)+"\"";
                    */
                }
                logic_parse_func(error_reason,error_line,(*i).proc_commands,true,(*i).proc_decl,(*i).proc_groups,(*i).proc_repl,(*i).remote_call);
                disp=lang_get_string(1,(*i).lang,73)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_proc=0;
            }
        }
    }
    // groups
    if((*i).edit_proc==7) {
        disp=lang_get_string(1,(*i).lang,145)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).proc_groups.begin(); i1!=(*i).proc_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_proc++;
    }
    if((*i).edit_proc==8) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_proc=2;
            return;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_groups.begin()==(*i).access_grant_groups.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_proc=2;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_proc=9;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            bool access=false;
            for(i1=(*i).proc_groups.begin(); i1!=(*i).proc_groups.end(); ++i1, ++i2) {
                vector<string>::iterator i3;
                for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).proc_groups.erase(i1);
                        break;
                    }
                }
                if(access)
                    break;
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_proc=7;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_proc==9) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        /*if(p.compare("*"))
            p=(string)"\""+p+"\"";*/
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).proc_groups.push_back(p);
        }
        (*i).edit_proc=7;
    }

    // .+proc
    if((*i).edit_proc==1000) {
        (*i).edit_proc_addbefore_line=-1;
        (*i).edit_proc_addafter_line=-1;
        (*i).proc_error="";
        (*i).proc_to_delete="";
        (*i).proc_name="";
        (*i).proc_decl="";
        (*i).plus_proc=true;
        (*i).proc_groups.clear();
        (*i).proc_repl.clear();
        disp=lang_get_string(1,(*i).lang,373)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_proc++;
        return;
    }
    if((*i).edit_proc==1001) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        (*i).proc_name=p;
        (*i).proc_decl=p;

        string wo_decl=p;
        if(wo_decl.find("(",0)!=string::npos)
            wo_decl.erase(wo_decl.find("(",0),wo_decl.length()-wo_decl.find("(",0));
        else {
            disp=lang_get_string(1,(*i).lang,374)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_proc=1000;
            return;
        }

        vector<c_procedure>::iterator i1;
        got=false;
        c_module* core_mod=get_module("core",true);
        if(core_mod) {
            for(i1=core_mod->r_procedures.begin(); i1!=core_mod->r_procedures.end(); ++i1) {
                string pn=(*i1).name;
                if(pn.find("(",0)!=string::npos)
                    pn.erase(pn.find("(",0),pn.length()-pn.find("(",0));
                if(!pn.compare(wo_decl)) {
                    got=true;
                    break;
                }
            }
        }

        bool got2=false;
        map<string,c_function*>::iterator i2;
        if(core_mod) {
            for(i2=core_mod->r_functions.functions.begin(); i2!=core_mod->r_functions.functions.end(); ++i2) {
                string pn=(*i2).second->get_name();
                if(pn.find("(",0)!=string::npos)
                    pn.erase(pn.find("(",0),pn.length()-pn.find("(",0));
                if(!pn.compare(wo_decl)) {
                    got2=true;
                    break;
                }
            }
        }

        if(got) {
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                if(!(*i3).compare("*")) {
                    access=true;
                    break;
                }
                vector<string>::iterator i4;
                for(i4=(*i1).groups.begin(); i4!=(*i1).groups.end(); ++i4) {
                    if(!(*i4).compare(*i3) || !(*i3).compare("*")) {
                        access=true;
                        break;
                    }
                }
                if(access)
                    break;
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_proc=0;
                return;
            } else {
                (*i).it_is_func=false;
                (*i).proc_to_delete=(*i1).name;
                disp=lang_subst(lang_get_string(1,(*i).lang,375),(*i).proc_to_delete)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_proc=1500;
                return;
            }
        } else {
            if(got2) {
                bool access=false;
                vector<string>::iterator i3;
                for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                    if(!(*i3).compare("*")) {
                        access=true;
                        break;
                    }
                    vector<string>::iterator i4;
                    for(i4=(*i1).groups.begin(); i4!=(*i1).groups.end(); ++i4) {
                        if(!(*i4).compare(*i3) || !(*i3).compare("*")) {
                            access=true;
                            break;
                        }
                    }
                    if(access)
                        break;
                }
                if(!access) {
                    disp=lang_get_string(1,(*i).lang,123)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    (*i).edit_proc=0;
                    return;
                } else {
                    (*i).it_is_func=true;
                    (*i).proc_to_delete=(*i1).name;
                    disp=lang_subst(lang_get_string(1,(*i).lang,375),(*i).proc_to_delete)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    (*i).edit_proc=1500;
                    return;
                }
            } else
                (*i).edit_proc++;
        }
        return;
    }

    if((*i).edit_proc==1002) {
        disp=lang_get_string(1,(*i).lang,376)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_proc++;

        (*i).proc_commands.clear();
        return;
    }
    if((*i).edit_proc==1003) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("."))
            (*i).proc_commands.push_back(p);
        else {
            (*i).edit_proc=2;
            return;
        }
    }

    if((*i).edit_proc==1500) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_subst(lang_get_string(1,(*i).lang,375),(*i).proc_name)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).edit_proc=0;
                return;
            } else {
                (*i).edit_proc=1002;
                return;
            }
        }
    }
}

