/***************************************************************************
                          dcc_loop_edit_rproc.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_rproc.cpp,v 1.16 2008/07/02 09:35:48 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_rproc.cpp,v 1.16 2008/07/02 09:35:48 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process edit remote procedure call ability (.rproc) command in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2005
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_rproc(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).edit_rproc==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_rproc==1) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_to_procs.begin(); i1!=(*i).access_to_procs.end(); ++i1)
            if(!(*i1).compare(p)) {
                got=true;
                (*i).proc_name=*i1;
                break;
            }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,137)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        (*i).rproc.clear();
        c_module* core_mod=get_module("core",true);
        if(core_mod) {
            vector<c_procedure>::iterator i2;
            for(i2=core_mod->r_procedures.begin(); i2!=core_mod->r_procedures.end(); ++i2) {
                if(!(*i2).name.compare((*i).proc_name)) {
                    (*i).rproc=(*i2).rproc;
                    break;
                }
            }
        }
        (*i).edit_rproc++;
    }
    if((*i).edit_rproc==2) {
        disp=lang_get_string(1,(*i).lang,617)+eol;
        disp=lang_subst(disp,(*i).proc_name);
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<c_rproc>::iterator i1;
        for(i1=(*i).rproc.begin(); i1!=(*i).rproc.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+(*i1).remote_bot+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,618)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_rproc++;
    }
    if((*i).edit_rproc==3) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            disp=lang_get_string(1,(*i).lang,426)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_rproc=100;
            return;
        }

        if(!p.compare(".add")) {
            disp=lang_get_string(1,(*i).lang,619)+eol;

            deque<c_user>::iterator i1;
            for(i1=r_users.begin(); i1!=r_users.end(); ++i1)
                disp+=(*i1).name+eol;

            disp+=lang_get_string(1,(*i).lang,429)+eol;

            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_rproc=200;
            return;
        }

        string p1, p2;
        {
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos=1;
                    continue;
                }
                if(pos==0)
                    p1+=p[i1];
                if(pos==1)
                    p2+=p[i1];
            }
        }
        if(!p1.compare(".remove")) {
            int line=0;

            vector<c_rproc>::iterator i1;
            for(i1=(*i).rproc.begin(); i1!=(*i).rproc.end(); ++i1)
                if(++line==stoi(p2)) {
                    (*i).rproc.erase(i1);
                    break;
                }
            (*i).edit_rproc=2;
            return;
        }

        (*i).edit_rproc=2;
        return;
    }

    // commmit?
    if((*i).edit_rproc==100) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,426)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                disp=lang_get_string(1,(*i).lang,70)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                (*i).proc_name="";
                (*i).rproc.clear();
                (*i).edit_rproc=0;
                return;
            } else {
                vector<string>::iterator i1;
                got=false;
                for(i1=(*i).access_to_procs.begin(); i1!=(*i).access_to_procs.end(); ++i1)
                    if(!(*i1).compare((*i).proc_name)) {
                        got=true;
                        break;
                    }
                if(!got) {
                    disp=lang_get_string(1,(*i).lang,121)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                } else {
                    c_module* core_mod=get_module("core",true);
                    if(core_mod) {
                        vector<c_procedure>::iterator i2;
                        for(i2=core_mod->r_procedures.begin(); i2!=core_mod->r_procedures.end(); ++i2) {
                            if(!(*i2).name.compare((*i).proc_name)) {
                                (*i2).rproc=(*i).rproc;
                                break;
                            }
                        }
                    }

                    disp=lang_get_string(1,(*i).lang,427)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                }

                (*i).proc_name="";
                (*i).rproc.clear();
                (*i).edit_rproc=0;
                return;
            }
            // NOTREACH
        }
    }

    // .add
    if((*i).edit_rproc==200) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        got=false;
        deque<c_user>::iterator i1;
        for(i1=r_users.begin(); i1!=r_users.end(); ++i1) {
            if(!(*i1).name.compare(p)) {
                got=true;
                break;
            }
        }

        if(!got) {
            disp=lang_get_string(1,(*i).lang,428)+eol;

            deque<c_user>::iterator i1;
            for(i1=r_users.begin(); i1!=r_users.end(); ++i1)
                disp+=(*i1).name+eol;

            disp+=lang_get_string(1,(*i).lang,429)+eol;

            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }

        c_rproc r;
        r.remote_bot=p;
        (*i).rproc.push_back(r);

        (*i).edit_rproc=2;
        return;
    }
}

