/***************************************************************************
                          dcc_loop_edit_user1.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_user1.cpp,v 1.16 2008/07/02 09:35:48 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_user1.cpp,v 1.16 2008/07/02 09:35:48 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

MY_STATIC void dcc_loop_edit_user1_a(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_edit_user1_b(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_edit_user1_c(vector<c_dcc_client>::iterator& i, string& eol);

/*!
    \brief Should be called in a loop to process edit user / new user commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 2
    \date 2005
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_user1(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).edit_user==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_user==1) {
        (*i).edit_user=-100;
        (*i).edit_user_from_template=false;
    }
    if((*i).edit_user==-100) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        /*
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_to_users.begin(); i1!=(*i).access_to_users.end(); ++i1)
            if(!p.compare(*i1)) {
                got=true;
                break;
            }
        */
        deque<c_user>::iterator i1;
        got=false;
        for(i1=r_users.begin(); i1!=r_users.end(); ++i1)
            if(!(*i1).name.compare(p)) {
                got=true;
                break;
            }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,90)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_name=p;
            c_user u;
            vector<c_channel> chs;
            logic_partyline_get_user(p,u,chs);

            vector<string>::iterator i1;

            {
                (*i).user_member_of.clear();
                (*i).user_hosts.clear();
                (*i).user_dcc_hosts.clear();
                (*i).user_fullnames.clear();
                (*i).user_meta.clear();
                (*i).user_access_to_groups.clear();
                (*i).user_access_grant_groups.clear();
                (*i).user_access_to_proc_groups.clear();
                (*i).user_access_grant_proc_groups.clear();
                (*i).user_access_usage_proc_groups.clear();
                (*i).user_access_to_channel.clear();
                (*i).user_access_grant_channel.clear();
                (*i).user_channels.clear();
                (*i).user_channel.clear();
            }

            for(i1=u.groups.begin(); i1!=u.groups.begin(); ++i1)
                (*i).user_member_of.push_back(*i1);

            vector<string>::iterator i2;
            for(i2=u.hostmask.begin(); i2!=u.hostmask.end(); ++i2)
                (*i).user_hosts.push_back(*i2);

            vector<c_dcc_host>::iterator i3;
            for(i3=u.dcc_hosts.begin(); i3!=u.dcc_hosts.end(); ++i3) {
                (*i).user_dcc_hosts.push_back(*i3);
            }

            for(i2=u.fullname.begin(); i2!=u.fullname.end(); ++i2)
                (*i).user_fullnames.push_back(*i2);

            map<string,string>::iterator i6;
            for(i6=u.meta.begin(); i6!=u.meta.end(); ++i6)
                (*i).user_meta.insert(*i6);

            for(i2=u.access_to_group.begin(); i2!=u.access_to_group.end(); ++i2)
                (*i).user_access_to_groups.push_back(*i2);

            for(i2=u.access_grant_group.begin(); i2!=u.access_grant_group.end(); ++i2)
                (*i).user_access_grant_groups.push_back(*i2);

            for(i2=u.access_to_proc.begin(); i2!=u.access_to_proc.end(); ++i2)
                (*i).user_access_to_proc_groups.push_back(*i2);

            for(i2=u.access_grant_procedure.begin(); i2!=u.access_grant_procedure.end(); ++i2)
                (*i).user_access_grant_proc_groups.push_back(*i2);

            for(i2=u.access_usage_procedure.begin(); i2!=u.access_usage_procedure.end(); ++i2)
                (*i).user_access_usage_proc_groups.push_back(*i2);

            for(i2=u.access_to_channel.begin(); i2!=u.access_to_channel.end(); ++i2)
                (*i).user_access_to_channel.push_back(*i2);

            for(i2=u.access_grant_channel.begin(); i2!=u.access_grant_channel.end(); ++i2)
                (*i).user_access_grant_channel.push_back(*i2);

            (*i).user_channels.clear();
            vector<c_channel>::iterator i4;
            for(i4=chs.begin(); i4!=chs.end(); ++i4)
                (*i).user_channels.push_back(*i4);

            (*i).user_partyline_msg_flood=u.partyline_msg_flood;

            (*i).user_access_to_backup=u.access_to_backup;
            (*i).user_access_to_die=u.access_to_die;
            (*i).user_access_to_filesystem=u.access_to_filesystem;
            (*i).user_access_to_partyline=u.access_to_partyline;
            (*i).user_access_to_plusproc=u.access_to_plusproc;
            (*i).user_access_to_plususer=u.access_to_plususer;
            (*i).user_access_to_rehash=u.access_to_rehash;
            (*i).user_access_to_restart=u.access_to_restart;
            (*i).user_access_grant_backup=u.access_grant_backup;
            (*i).user_access_grant_die=u.access_grant_die;
            (*i).user_access_grant_filesystem=u.access_grant_filesystem;
            (*i).user_access_grant_partyline=u.access_grant_partyline;
            (*i).user_access_grant_plusproc=u.access_grant_plusproc;
            (*i).user_access_grant_plususer=u.access_grant_plususer;
            (*i).user_access_grant_rehash=u.access_grant_rehash;
            (*i).user_access_to_replication=u.access_to_replication;
            (*i).user_access_grant_replication=u.access_grant_replication;
            (*i).user_access_grant_restart=u.access_grant_restart;

            (*i).user_access_grant_private=u.access_grant_private;
            (*i).user_access_to_private=u.access_to_private;

            (*i).user_access_to_upgrade=u.access_to_upgrade;
            (*i).user_access_grant_upgrade=u.access_grant_upgrade;

            (*i).user_access_to_apply=u.access_to_apply;
            (*i).user_access_grant_apply=u.access_grant_apply;

            (*i).user_access_to_can_send_all_users=u.access_to_can_send_all_users;
            (*i).user_access_grant_can_send_all_users=u.access_grant_can_send_all_users;

            vector<string>::iterator i5;
            for(i5=u.groups.begin(); i5!=u.groups.end(); ++i5)
                (*i).user_member_of.push_back(*i5);

            (*i).edit_user++;
        }
    }
    if((*i).edit_user==-99) {
        vector<c_channel>::iterator i1;
        for(i1=r_channels.begin(); i1!=r_channels.end(); ++i1) {
            vector<c_channel>::iterator i2;
            got=false;
            for(i2=(*i).user_channels.begin(); i2!=(*i).user_channels.end(); ++i2) {
                if(!cmp_strings_case_insensitive((*i2).channel_name,(*i1).channel_name)) {
                    got=true;
                    break;
                }
            }
            if(!got) {
                c_channel ch;
                ch.channel_name=(*i1).channel_name;
                ch.username=(*i).user_name;
                ch.on_deop="";
                ch.on_ban="";
                ch.on_unban="";
                ch.on_kick="";
                ch.on_op="";
                ch.on_voice="";
                ch.on_devoice="";
                ch.on_join="";
                ch.on_banned="";
                ch.on_flood="";
                ch.on_privmsg="";
                ch.on_notice="";
                ch.on_except="";
                ch.on_unexcept="";
                ch.on_invite="";
                ch.on_uninvite="";
                ch.on_not_invited="";
                ch.on_not_in_reop="";
                ch.on_other_mode="";
                ch.on_other_mode_mask="";
                ch.msg_flood.lines=0;
                ch.notice_flood.lines=0;
                ch.repeat_flood.lines=0;
                ch.nick_flood.lines=0;
                ch.join_flood.lines=0;
                ch.mode_flood.lines=0;
                ch.ctcp_flood.lines=0;
                ch.allow_dynamic.clear();
                ch.configured=false;
                ch.can_send_unknown_users=false;
                (*i).user_channels.push_back(ch);
            }
        }

        (*i).edit_user=2;
        return;
    }

    // Type ".groups" if you want to edit group membership
    if((*i).edit_user==1200) {
        disp=lang_get_string(1,(*i).lang,485)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_member_of.begin(); i1!=(*i).user_member_of.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+*i1;
            disp+=" (";
            vector<string>::iterator i3;
            bool access=false;
            map<string,string> vars;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            disp+=access?lang_get_string(1,(*i).lang,120):lang_get_string(1,(*i).lang,121);
            disp+=")";
            disp+=eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,484)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
        return;
    }
    if((*i).edit_user==1201) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
            return;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,486)+eol;
            vector<string>::iterator i1;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                disp+=*i1+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=1202;
            return;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            for(i1=(*i).user_member_of.begin(); i1!=(*i).user_member_of.end(); ++i1, ++i2)
                if(i2==line) {
                    vector<string>::iterator i3;
                    bool access=false;
                    map<string,string> vars;
                    for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                        if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                            access=true;
                            break;
                        }
                    if(!access) {
                        disp=lang_get_string(1,(*i).lang,121)+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        (*i).edit_user=1200;
                        return;
                    }
                    (*i).user_member_of.erase(i1);
                    break;
                }
            (*i).edit_user=1200;
            return;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,484)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==1202) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
            if(!(*i1).compare(p)) {
                got=true;
                break;
            }

        if(got) {
            //p=(string)"\""+p+"\"";
            (*i).user_member_of.push_back(p);
        } else {
            disp=lang_get_string(1,(*i).lang,487)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        (*i).edit_user=1200;
        return;
    }

    // Type ".meta"
    if((*i).edit_user==1300) {
        disp=lang_get_string(1,(*i).lang,561)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        map<string,string> vars;

        map<string,string>::iterator i1;
        for(i1=(*i).user_meta.begin(); i1!=(*i).user_meta.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": \"";
            disp+=(*i1).first+"\" ";
            disp+="= \"";
            disp+=(*i1).second;
            disp+="\"";
            disp+=eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,562)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==1301) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,563)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=1302;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            map<string,string>::iterator i1;
            for(i1=(*i).user_meta.begin(); i1!=(*i).user_meta.end(); ++i1, ++i2)
                if(i2==line) {
                    (*i).user_meta.erase(i1);
                    break;
                }
            (*i).edit_user=1300;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,562)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==1302) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        pair<string,string> pr;
        bool equal=false;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(!equal && p[i1]=='=') {
                equal=true;
                continue;
            }
            if(!equal)
                pr.first+=p[i1];
            else
                pr.second+=p[i1];
        }
        /*pr.first=(string)"\""+pr.first+"\"";
        pr.second=(string)"\""+pr.second+"\"";*/
        (*i).user_meta.insert(pr);
        (*i).edit_user=1300;
    }

    if((*i).edit_user==2) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,91)+eol;
        disp+=lang_get_string(1,(*i).lang,92)+eol;
        disp+=lang_get_string(1,(*i).lang,93)+eol;
        disp+=lang_get_string(1,(*i).lang,94)+eol;
        disp+=lang_get_string(1,(*i).lang,95)+eol;
        disp+=lang_get_string(1,(*i).lang,744)+eol;

        disp+=lang_get_string(1,(*i).lang,591)+eol;

        disp+=lang_get_string(1,(*i).lang,172)+eol;
        disp+=lang_get_string(1,(*i).lang,483)+eol;
        disp+=lang_get_string(1,(*i).lang,560)+eol;

        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        int i3=1;
        vector<c_channel>::iterator i2;
        for(i2=(*i).user_channels.begin(); i2!=(*i).user_channels.end(); ++i2, ++i3) {
            disp=lang_get_string(1,(*i).lang,101)+eol;
            disp=lang_subst(disp,tos(i3));
            disp=lang_subst(disp,(*i2).channel_name);
            vector<string>::iterator i3;
            bool access=false;

            for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
                if(!cmp_strings_case_insensitive(*i3,(*i2).channel_name)) {
                    access=true;
                    break;
                }
            }

            for(i3=(*i).access_to_groups.begin(); !access && i3!=(*i).access_to_groups.end(); ++i3) {
                if(!(*i3).compare("*")) {
                    access=true;
                    break;
                }
                vector<string>::iterator i4;
                for(i4=(*i2).groups.begin(); i4!=(*i2).groups.end(); ++i4) {
                    if(!(*i3).compare(*i4) || !(*i3).compare("*")) {
                        access=true;
                        break;
                    }
                }
                if(access)
                    break;
            }
            disp+="    ";
            if(access)
                disp+=lang_get_string(1,(*i).lang,464);
            else
                disp+=lang_get_string(1,(*i).lang,466);
            disp+=" ";
            if((*i2).configured)
                disp+=lang_get_string(1,(*i).lang,467);
            else
                disp+=lang_get_string(1,(*i).lang,465);

            disp+=eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        disp=lang_get_string(1,(*i).lang,160)+eol;

        if((*i).user_hosts.begin()==(*i).user_hosts.end())
            disp+=lang_get_string(1,(*i).lang,547)+eol;
        if((*i).user_fullnames.begin()==(*i).user_fullnames.end())
            disp+=lang_get_string(1,(*i).lang,548)+eol;

        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==3) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".host")) {
            got=true;
            (*i).edit_user=100;
        }
        if(!p.compare(".dcchost")) {
            got=true;
            (*i).edit_user=200;
        }
        if(!p.compare(".fn")) {
            got=true;
            (*i).edit_user=300;
        }
        if(!p.compare(".pl")) {
            got=true;
            (*i).edit_user=400;
        }
        if(!p.compare(".atg")) {
            got=true;
            (*i).edit_user=500;
        }
        /*
        if(!p.compare(".aug")) {
            got=true;
            (*i).edit_user=600;
        }
        */
        if(!p.compare(".agg")) {
            got=true;
            (*i).edit_user=3000;
        }
        /*
        if(!p.compare(".atp")) {
            got=true;
            (*i).edit_user=700;
        }
        if(!p.compare(".agp")) {
            got=true;
            (*i).edit_user=800;
        }
        */
        if(!p.compare(".aup")) {
            got=true;
            (*i).edit_user=1400;
        }
        /*
        if(!p.compare(".atc")) {
            got=true;
            (*i).edit_user=900;
        }
        if(!p.compare(".auc")) {
            got=true;
            (*i).edit_user=1000;
        }
        */
        if(!p.compare(".commands")) {
            got=true;
            (*i).edit_user=1100;
        }
        if(!p.compare(".groups")) {
            got=true;
            (*i).edit_user=1200;
        }
        if(!p.compare(".meta")) {
            got=true;
            (*i).edit_user=1300;
        }
        vector<c_channel>::iterator i1;
        int i2=1;
        for(i1=(*i).user_channels.begin(); i1!=(*i).user_channels.end(); ++i1, ++i2) {
            string pp=(string)"."+tos(i2);
            if(!p.compare(pp)) {

                vector<string>::iterator i3;
                bool access=false;

                for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
                    if(!cmp_strings_case_insensitive(*i3,(*i1).channel_name)) {
                        access=true;
                        break;
                    }
                }

                for(i3=(*i).access_to_groups.begin(); !access && i3!=(*i).access_to_groups.end(); ++i3) {
                    if(!(*i3).compare("*")) {
                        access=true;
                        break;
                    }
                    vector<string>::iterator i4;
                    for(i4=(*i1).groups.begin(); i4!=(*i1).groups.end(); ++i4) {
                        if(!(*i3).compare(*i4) || !(*i3).compare("*")) {
                            access=true;
                            break;
                        }
                    }
                    if(access)
                        break;
                }
                if(!access) {
                    disp=lang_get_string(1,(*i).lang,121)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    got=false;
                } else {
                    got=true;
                    (*i).edit_user=2000;
                    (*i).edit_channel_num=i2;
                    break;
                }
            }
        }
        if(!p.compare(".finish")) {
            got=true;

            disp=lang_get_string(1,(*i).lang,161)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_user++;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,106)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=2;
        }
    }

    dcc_loop_edit_user1_a(i,eol);
    dcc_loop_edit_user1_b(i,eol);
    dcc_loop_edit_user1_c(i,eol);
}

MY_STATIC void dcc_loop_edit_user1_a(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_user==4) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,161)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("y") || !p.compare("Y")) {

                // check whether we have access
                vector<string>::iterator i1;
                got=false;
                for(i1=(*i).access_to_users.begin(); i1!=(*i).access_to_users.end(); ++i1) {
                    if(!(*i).user_name.compare(*i1)) {
                        got=true;
                        break;
                    }
                }
                if((*i).edit_user_from_template)
                    got=true; // always have access if it is from template
                if(!got) {
                    disp=lang_get_string(1,(*i).lang,743)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                }
                vector<c_replication> repl;
                {
                    c_user u;
                    vector<c_channel> chs;
                    logic_partyline_get_user((*i).user_name,u,chs);
                    repl=u.replication;
                    if(!(*i).edit_user_from_template) {
                        vector<c_channel> new_chans;
                        vector<c_channel>::iterator i1;
                        for(i1=chs.begin(); i1!=chs.end(); ++i1) {
                            bool got_access=false;
                            vector<c_channel>::iterator i2;
                            bool got_chan=false;
                            for(i2=(*i).user_channels.begin(); i2!=(*i).user_channels.end(); ++i2) {
                                if((*i2).channel_name.compare((*i1).channel_name)) // !=
                                    continue;
                                got_chan=true;
                                vector<string>::iterator i3;
                                for(i3=(*i1).groups.begin(); i3!=(*i1).groups.end(); ++i3) {
                                    vector<string>::iterator i4;
                                    for(i4=(*i).access_to_groups.begin(); i4!=(*i).access_to_groups.end(); ++i4) {
                                        if(!(*i4).compare(*i3)) {
                                            got_access=true;
                                            break;
                                        }
                                    }
                                    if(got_access)
                                        break;
                                }
                                if(!got_access) {
                                    disp=lang_get_string(1,(*i).lang,742)+eol;
                                    disp=lang_subst(disp,(*i2).channel_name);
                                    ec=0;
                                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                                    new_chans.push_back(*i1);
                                } else {
                                    if(!(*i).access_to_can_send_unknown_users) {
                                        (*i2).can_send_unknown_users=(*i1).can_send_unknown_users;
                                    }
                                    new_chans.push_back(*i2);
                                }
                            }
                            if(!got_chan)
                                new_chans.push_back(*i1);
                        }
                        (*i).user_channels=new_chans;
                    }

                    if(!got) {
                        vector<string>::iterator i1;

                        {
                            (*i).user_member_of.clear();
                            (*i).user_hosts.clear();
                            (*i).user_dcc_hosts.clear();
                            (*i).user_fullnames.clear();
                            (*i).user_meta.clear();
                            (*i).user_access_to_groups.clear();
                            (*i).user_access_grant_groups.clear();
                            (*i).user_access_to_proc_groups.clear();
                            (*i).user_access_grant_proc_groups.clear();
                            (*i).user_access_usage_proc_groups.clear();
                            (*i).user_access_to_channel.clear();
                            (*i).user_access_grant_channel.clear();
                            //(*i).user_channels.clear();
                            (*i).user_channel.clear();
                        }

                        for(i1=u.groups.begin(); i1!=u.groups.begin(); ++i1)
                            (*i).user_member_of.push_back(*i1);

                        vector<string>::iterator i2;
                        for(i2=u.hostmask.begin(); i2!=u.hostmask.end(); ++i2)
                            (*i).user_hosts.push_back(*i2);

                        vector<c_dcc_host>::iterator i3;
                        for(i3=u.dcc_hosts.begin(); i3!=u.dcc_hosts.end(); ++i3) {
                            (*i).user_dcc_hosts.push_back(*i3);
                        }

                        for(i2=u.fullname.begin(); i2!=u.fullname.end(); ++i2)
                            (*i).user_fullnames.push_back(*i2);

                        map<string,string>::iterator i6;
                        for(i6=u.meta.begin(); i6!=u.meta.end(); ++i6)
                            (*i).user_meta.insert(*i6);

                        for(i2=u.access_to_group.begin(); i2!=u.access_to_group.end(); ++i2)
                            (*i).user_access_to_groups.push_back(*i2);

                        for(i2=u.access_grant_group.begin(); i2!=u.access_grant_group.end(); ++i2)
                            (*i).user_access_grant_groups.push_back(*i2);

                        for(i2=u.access_to_proc.begin(); i2!=u.access_to_proc.end(); ++i2)
                            (*i).user_access_to_proc_groups.push_back(*i2);

                        for(i2=u.access_grant_procedure.begin(); i2!=u.access_grant_procedure.end(); ++i2)
                            (*i).user_access_grant_proc_groups.push_back(*i2);

                        for(i2=u.access_usage_procedure.begin(); i2!=u.access_usage_procedure.end(); ++i2)
                            (*i).user_access_usage_proc_groups.push_back(*i2);

                        for(i2=u.access_to_channel.begin(); i2!=u.access_to_channel.end(); ++i2)
                            (*i).user_access_to_channel.push_back(*i2);

                        for(i2=u.access_grant_channel.begin(); i2!=u.access_grant_channel.end(); ++i2)
                            (*i).user_access_grant_channel.push_back(*i2);

                        /*
                        (*i).user_channels.clear();
                        vector<c_channel>::iterator i4;
                        for(i4=chs.begin(); i4!=chs.end(); ++i4)
                            (*i).user_channels.push_back(*i4);
                        */

                        (*i).user_partyline_msg_flood=u.partyline_msg_flood;

                        (*i).user_access_to_backup=u.access_to_backup;
                        (*i).user_access_to_die=u.access_to_die;
                        (*i).user_access_to_filesystem=u.access_to_filesystem;
                        (*i).user_access_to_partyline=u.access_to_partyline;
                        (*i).user_access_to_plusproc=u.access_to_plusproc;
                        (*i).user_access_to_plususer=u.access_to_plususer;
                        (*i).user_access_to_rehash=u.access_to_rehash;
                        (*i).user_access_to_restart=u.access_to_restart;
                        (*i).user_access_grant_backup=u.access_grant_backup;
                        (*i).user_access_grant_die=u.access_grant_die;
                        (*i).user_access_grant_filesystem=u.access_grant_filesystem;
                        (*i).user_access_grant_partyline=u.access_grant_partyline;
                        (*i).user_access_grant_plusproc=u.access_grant_plusproc;
                        (*i).user_access_grant_plususer=u.access_grant_plususer;
                        (*i).user_access_grant_rehash=u.access_grant_rehash;
                        (*i).user_access_to_replication=u.access_to_replication;
                        (*i).user_access_grant_replication=u.access_grant_replication;
                        (*i).user_access_grant_restart=u.access_grant_restart;

                        (*i).user_access_grant_private=u.access_grant_private;
                        (*i).user_access_to_private=u.access_to_private;

                        (*i).user_access_to_upgrade=u.access_to_upgrade;
                        (*i).user_access_grant_upgrade=u.access_grant_upgrade;

                        (*i).user_access_to_apply=u.access_to_apply;
                        (*i).user_access_grant_apply=u.access_grant_apply;

                        (*i).user_access_to_can_send_all_users=u.access_to_can_send_all_users;
                        (*i).user_access_grant_can_send_all_users=u.access_grant_can_send_all_users;

                        vector<string>::iterator i5;
                        for(i5=u.groups.begin(); i5!=u.groups.end(); ++i5)
                            (*i).user_member_of.push_back(*i5);
                    }
                }

                if((*i).user_hosts.begin()==(*i).user_hosts.end() || (*i).user_fullnames.begin()==(*i).user_fullnames.end()) {
                    disp=lang_get_string(1,(*i).lang,549)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    (*i).edit_user=2;
                    return;
                }

                bool was_host_bot=false;
                my_time_t orig_last_changed=my_time(NULL);
                if(!(*i).edit_user_from_template) {
                    c_user u;
                    vector<c_channel> chs;
                    logic_partyline_get_user((*i).user_name,u,chs);
                    repl=u.replication;
                    was_host_bot=u.host_bot;
                    orig_last_changed=u.last_changed;
                }

                c_user u;

                u.name=(*i).user_name;

                for(i1=(*i).user_member_of.begin(); i1!=(*i).user_member_of.end(); ++i1) {
                    u.groups.push_back(*i1);
                }
                for(i1=(*i).user_hosts.begin(); i1!=(*i).user_hosts.end(); ++i1)
                    u.hostmask.push_back(*i1);
                vector<c_dcc_host>::iterator i2;
                for(i2=(*i).user_dcc_hosts.begin(); i2!=(*i).user_dcc_hosts.end(); ++i2)
                    u.dcc_hosts.push_back(*i2);
                for(i1=(*i).user_fullnames.begin(); i1!=(*i).user_fullnames.end(); ++i1)
                    u.fullname.push_back(*i1);
                u.access_to_partyline=(*i).user_access_to_partyline;
                u.access_grant_partyline=(*i).user_access_grant_partyline;
                u.access_to_backup=(*i).user_access_to_backup;
                u.access_to_rehash=(*i).user_access_to_rehash;
                u.access_grant_backup=(*i).user_access_grant_backup;
                u.access_grant_rehash=(*i).user_access_grant_rehash;

                u.access_to_plususer=(*i).user_access_to_plususer;
                u.access_grant_plususer=(*i).user_access_grant_plususer;

                u.access_to_plusproc=(*i).user_access_to_plusproc;
                u.access_grant_plusproc=(*i).user_access_grant_plusproc;

                u.access_to_restart=(*i).user_access_to_restart;
                u.access_grant_restart=(*i).user_access_grant_restart;
                u.access_to_die=(*i).user_access_to_die;
                u.access_grant_die=(*i).user_access_grant_die;

                u.access_to_filesystem=(*i).user_access_to_filesystem;
                u.access_grant_filesystem=(*i).user_access_grant_filesystem;

                u.access_to_private=(*i).user_access_to_private;
                u.access_grant_private=(*i).user_access_grant_private;

                u.access_to_upgrade=(*i).user_access_to_upgrade;
                u.access_grant_upgrade=(*i).user_access_grant_upgrade;

                u.access_to_apply=(*i).user_access_to_apply;
                u.access_grant_apply=(*i).user_access_grant_apply;

                u.access_to_replication=(*i).user_access_to_replication;
                u.access_grant_replication=(*i).user_access_grant_replication;

                u.access_to_can_send_all_users=(*i).user_access_to_can_send_all_users;
                u.access_grant_can_send_all_users=(*i).user_access_grant_can_send_all_users;

                u.access_to_can_send_unknown_users=(*i).user_access_to_can_send_unknown_users;
                u.access_grant_can_send_unknown_users=(*i).user_access_grant_can_send_unknown_users;

                for(i1=(*i).user_access_to_groups.begin(); i1!=(*i).user_access_to_groups.end(); ++i1)
                    u.access_to_group.push_back(*i1);
                for(i1=(*i).user_access_grant_groups.begin(); i1!=(*i).user_access_grant_groups.end(); ++i1)
                    u.access_grant_group.push_back(*i1);
                for(i1=(*i).user_access_to_proc_groups.begin(); i1!=(*i).user_access_to_proc_groups.end(); ++i1)
                    u.access_to_proc.push_back(*i1);
                for(i1=(*i).user_access_grant_proc_groups.begin(); i1!=(*i).user_access_grant_proc_groups.end(); ++i1)
                    u.access_grant_procedure.push_back(*i1);
                for(i1=(*i).user_access_usage_proc_groups.begin(); i1!=(*i).user_access_usage_proc_groups.end(); ++i1)
                    u.access_usage_procedure.push_back(*i1);
                for(i1=(*i).user_access_to_channel.begin(); i1!=(*i).user_access_to_channel.end(); ++i1)
                    u.access_to_channel.push_back(*i1);
                for(i1=(*i).user_access_grant_channel.begin(); i1!=(*i).user_access_grant_channel.end(); ++i1)
                    u.access_grant_channel.push_back(*i1);

                map<string,string>::iterator i6;
                for(i6=(*i).user_meta.begin(); i6!=(*i).user_meta.end(); ++i6)
                    u.meta.insert(*i6);

                vector<c_channel> chs;
                vector<c_channel>::iterator i3;
                for(i3=(*i).user_channels.begin(); i3!=(*i).user_channels.end(); ++i3) {
                    if(!(*i3).configured)
                        continue;
                    (*i3).username=(*i).user_name;
                    chs.push_back(*i3);
                }

                u.partyline_msg_flood=(*i).user_partyline_msg_flood;

                my_time(&u.last_changed);
                if(!got)
                    u.last_changed=orig_last_changed;
                logic_partyline_remove_user(u.name);
                u.host_bot=was_host_bot;
                u.host_unknown=false;
                u.is_template=false;

                u.replication=repl;

                logic_partyline_add_user(u,chs);

                disp=lang_get_string(1,(*i).lang,163)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,162)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=0;
        }
    }
    // Type ".host" if you want to edit host masks
    if((*i).edit_user==100) {
        disp=lang_get_string(1,(*i).lang,107)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_hosts.begin(); i1!=(*i).user_hosts.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+*i1+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,108)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==101) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            if((*i).user_hosts.begin()==(*i).user_hosts.end()) {
                disp=lang_get_string(1,(*i).lang,109)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).edit_user=2;
            }
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,110)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=102;
            return;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            for(i1=(*i).user_hosts.begin(); i1!=(*i).user_hosts.end(); ++i1, ++i2)
                if(i2==line) {
                    (*i).user_hosts.erase(i1);
                    break;
                }
            (*i).edit_user=100;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,108)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==102) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        (*i).user_hosts.push_back(p);
        (*i).edit_user=100;
    }

    // Type ".dcchost"
    if((*i).edit_user==200) {
        disp=lang_get_string(1,(*i).lang,111)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<c_dcc_host>::iterator i1;
        for(i1=(*i).user_dcc_hosts.begin(); i1!=(*i).user_dcc_hosts.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+tos((*i1).group)+";"+(*i1).host+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,108)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==201) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,112)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=202;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<c_dcc_host>::iterator i1;
            for(i1=(*i).user_dcc_hosts.begin(); i1!=(*i).user_dcc_hosts.end(); ++i1, ++i2)
                if(i2==line) {
                    (*i).user_dcc_hosts.erase(i1);
                    break;
                }
            (*i).edit_user=200;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,108)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==202) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        (*i).user_dcc_host.group=stoi(p);
        disp=lang_get_string(1,(*i).lang,113)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==203) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        (*i).user_dcc_host.host=p;
        (*i).user_dcc_hosts.push_back((*i).user_dcc_host);
        (*i).edit_user=200;
    }

    // Type ".fn"
    if((*i).edit_user==300) {
        disp=lang_get_string(1,(*i).lang,114)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_fullnames.begin(); i1!=(*i).user_fullnames.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+*i1+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,115)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,784)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==301) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            if((*i).user_fullnames.begin()==(*i).user_fullnames.end()) {
                ec=0;
                disp=lang_get_string(1,(*i).lang,115)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,784)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,546)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                return;
            } else {
                got=true;
                (*i).edit_user=2;
            }
        }
        if(!got && !p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,116)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=302;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; !got && i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!got && !p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            for(i1=(*i).user_fullnames.begin(); i1!=(*i).user_fullnames.end(); ++i1, ++i2)
                if(i2==line) {
                    (*i).user_fullnames.erase(i1);
                    break;
                }
            (*i).edit_user=300;
        }
        if(!got) {
            ec=0;

            disp=lang_get_string(1,(*i).lang,115)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            disp=lang_get_string(1,(*i).lang,784)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        return;
    }
    if((*i).edit_user==302) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        string res;
        bool in_esc=false;
        bool bad_esc=false;
        for(string::size_type i1=0; i1<p.length(); ++i1) {
            if(!in_esc) {
                if('\\'==p[i1])
                    in_esc=true;
                else
                    res=(string)""+p[i1];
            } else {
                if('.'==p[i1])
                    res+=".";
                else if('\\'==p[i1])
                    res+="\\";
                else {
                    res+=(string)""+p[i1];
                    bad_esc=true;
                }
                in_esc=false;
            }
        }

        if(in_esc || bad_esc) {
            disp=lang_get_string(1,(*i).lang,785)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        (*i).user_fullnames.push_back(p);
        (*i).edit_user=300;
    }

    // Type ".pl"
    if((*i).edit_user==400) {
        if(!(*i).access_grant_partyline) {
            disp=lang_get_string(1,(*i).lang,118)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=2;
        } else {
            disp=lang_get_string(1,(*i).lang,117)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        }
    }
    if((*i).edit_user==401) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            (*i).user_access_to_partyline=true;
            got=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            (*i).user_access_to_partyline=false;
            got=true;
        }
        (*i).edit_user++;
        if(!got)
            (*i).edit_user=400;
    }
    if((*i).edit_user==402) {
        disp=lang_get_string(1,(*i).lang,200)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==403) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_partyline_msg_flood.lines=stoui(lines);
            (*i).user_partyline_msg_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
            got=true;
        }
        if(!got)
            (*i).edit_user=402;
    }
    if((*i).edit_user==404) {
        (*i).edit_user=2;
    }
}

MY_STATIC void dcc_loop_edit_user1_b(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    // Type ".atg"
    if((*i).edit_user==500) {
        disp=lang_get_string(1,(*i).lang,119)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_to_groups.begin(); i1!=(*i).user_access_to_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==501) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_groups.begin()==(*i).access_grant_groups.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=500;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=502;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            bool access=false;
            for(i1=(*i).user_access_to_groups.begin(); i1!=(*i).user_access_to_groups.end(); ++i1, ++i2) {
                vector<string>::iterator i3;
                for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_to_groups.erase(i1);
                        break;
                    }
                }
                if(access)
                    break;
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=500;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==502) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_to_groups.push_back(p);
        }
        (*i).edit_user=500;
    }
    // Type ".aug"
    if((*i).edit_user==600) {
        disp=lang_get_string(1,(*i).lang,716)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_grant_groups.begin(); i1!=(*i).user_access_grant_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==601) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_groups.begin()==(*i).access_grant_groups.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=600;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=602;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            bool access=false;
            vector<string>::iterator i1;
            vector<string>::iterator i3;
            for(i1=(*i).user_access_grant_groups.begin(); i1!=(*i).user_access_grant_groups.end(); ++i1, ++i2) {
                for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_grant_groups.erase(i1);
                        break;
                    }
                }
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=600;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==602) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_usage_proc_groups.push_back(p);
        }
        (*i).edit_user=600;
    }
    // Type ".agg"
    if((*i).edit_user==3000) {
        disp=lang_get_string(1,(*i).lang,745)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_grant_groups.begin(); i1!=(*i).user_access_grant_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==3001) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_groups.begin()==(*i).access_grant_groups.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=3000;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=3002;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            bool access=false;
            vector<string>::iterator i1;
            vector<string>::iterator i3;
            for(i1=(*i).user_access_grant_groups.begin(); i1!=(*i).user_access_grant_groups.end(); ++i1, ++i2) {
                for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_grant_groups.erase(i1);
                        break;
                    }
                }
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=3000;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==3002) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_groups.begin(); i3!=(*i).access_grant_groups.end(); ++i3)
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_grant_groups.push_back(p);
        }
        (*i).edit_user=3000;
    }
    // Type ".atp"
    if((*i).edit_user==700) {
        disp=lang_get_string(1,(*i).lang,126)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_to_proc_groups.begin(); i1!=(*i).user_access_to_proc_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==701) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_proc_groups.begin()==(*i).access_grant_proc_groups.end()) {
                disp=lang_get_string(1,(*i).lang,127)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=700;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=702;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            bool access=false;
            for(i1=(*i).user_access_to_proc_groups.begin(); i1!=(*i).user_access_to_proc_groups.end(); ++i1, ++i2) {
                vector<string>::iterator i3;
                for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_to_proc_groups.erase(i1);
                        break;
                    }
                }
                if(access)
                    break;
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=700;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==702) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_to_proc_groups.push_back(p);
        }
        (*i).edit_user=700;
    }
    // Type ".agp"
    if((*i).edit_user==800) {
        disp=lang_get_string(1,(*i).lang,128)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_grant_proc_groups.begin(); i1!=(*i).user_access_grant_proc_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==801) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_proc_groups.begin()==(*i).access_grant_proc_groups.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=800;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=802;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            bool access=false;
            vector<string>::iterator i1;
            vector<string>::iterator i3;
            for(i1=(*i).user_access_grant_proc_groups.begin(); i1!=(*i).user_access_grant_proc_groups.end(); ++i1, ++i2) {
                for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
                    if((!(*i1).compare(*i3) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_grant_proc_groups.erase(i1);
                        break;
                    }
                }
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=800;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==802) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3)
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_grant_proc_groups.push_back(p);
        }
        (*i).edit_user=800;
    }
}

MY_STATIC void dcc_loop_edit_user1_c(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    // Type ".aup"
    if((*i).edit_user==1400) {
        disp=lang_get_string(1,(*i).lang,128)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_usage_proc_groups.begin(); i1!=(*i).user_access_usage_proc_groups.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==1401) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_proc_groups.begin()==(*i).access_grant_proc_groups.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=1400;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=1402;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            bool access=false;
            vector<string>::iterator i1;
            vector<string>::iterator i3;
            for(i1=(*i).user_access_usage_proc_groups.begin(); i1!=(*i).user_access_usage_proc_groups.end(); ++i1, ++i2) {
                for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3) {
                    if((!(*i1).compare(*i3) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_usage_proc_groups.erase(i1);
                        break;
                    }
                }
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=1400;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==1402) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_proc_groups.begin(); i3!=(*i).access_grant_proc_groups.end(); ++i3)
            if(!p.compare(*i3) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_usage_proc_groups.push_back(p);
        }
        (*i).edit_user=1400;
    }

    // Type ".atc"
    if((*i).edit_user==900) {
        disp=lang_get_string(1,(*i).lang,126)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_to_channel.begin(); i1!=(*i).user_access_to_channel.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==901) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_channel.begin()==(*i).access_grant_channel.end()) {
                disp=lang_get_string(1,(*i).lang,127)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=900;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=902;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<string>::iterator i1;
            bool access=false;
            for(i1=(*i).user_access_to_channel.begin(); i1!=(*i).user_access_to_channel.end(); ++i1, ++i2) {
                vector<string>::iterator i3;
                for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
                    if((!(*i3).compare(*i1) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_to_channel.erase(i1);
                        break;
                    }
                }
                if(access)
                    break;
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=900;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==902) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
            if(!(*i3).compare(p) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_to_groups.push_back(p);
        }
        (*i).edit_user=900;
    }
    // Type ".auc"
    if((*i).edit_user==1000) {
        disp=lang_get_string(1,(*i).lang,128)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<string>::iterator i1;
        for(i1=(*i).user_access_grant_channel.begin(); i1!=(*i).user_access_grant_channel.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            bool access=false;
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
                if(!(*i3).compare(*i1) || !(*i3).compare("*")) {
                    access=true;
                    break;
                }
            }
            string tmp2;
            if(access)
                tmp2=lang_get_string(1,(*i).lang,120);
            else
                tmp2=lang_get_string(1,(*i).lang,121);
            disp+=tos(i2,3,'0')+": "+*i1+" = "+tmp2+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,122)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==1001) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,124)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            disp.clear();
            vector<string>::iterator i3;
            for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3)
                disp+=*i3+eol;
            if((*i).access_grant_channel.begin()==(*i).access_grant_channel.end()) {
                disp=lang_get_string(1,(*i).lang,124)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=1000;
            } else {
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                disp=lang_get_string(1,(*i).lang,125)+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).edit_user=1002;
            }
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            bool access=false;
            vector<string>::iterator i1;
            vector<string>::iterator i3;
            for(i1=(*i).user_access_grant_channel.begin(); i1!=(*i).user_access_grant_channel.end(); ++i1, ++i2) {
                for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
                    if((!(*i1).compare(*i3) || !(*i3).compare("*")) && i2==line) {
                        access=true;
                        (*i).user_access_grant_channel.erase(i1);
                        break;
                    }
                }
            }
            if(!access) {
                disp=lang_get_string(1,(*i).lang,123)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).edit_user=1000;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,122)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==1002) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i3;
        bool access=false;
        for(i3=(*i).access_grant_channel.begin(); i3!=(*i).access_grant_channel.end(); ++i3) {
            if(!(*i3).compare(p) || !(*i3).compare("*")) {
                access=true;
                break;
            }
        }
        if(!access) {
            disp=lang_get_string(1,(*i).lang,123)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).user_access_to_groups.push_back(p);
        }
        (*i).edit_user=1000;
    }
    // edituser / edit channel
    if((*i).edit_user==2000) {
        string chan;
        vector<c_channel>::iterator i1;
        int i2=1;
        for(i1=(*i).user_channels.begin(); i1!=(*i).user_channels.end(); ++i1, ++i2)
            if(i2==(*i).edit_channel_num) {
                chan=(*i1).channel_name;
                break;
            }
        if(!chan.compare("")) {
            (*i).edit_user=2;
            log_debug(GET_STR_DEBUG_INFO_EX("OOPS: Occurred error: cannot find channel to edit! (#1) huh?!"));
            return;
        }
        (*i).user_channel.channel_name=chan;
        (*i).user_channel.on_deop=(*i1).on_deop;
        (*i).user_channel.on_ban=(*i1).on_ban;
        (*i).user_channel.on_unban=(*i1).on_unban;
        (*i).user_channel.on_kick=(*i1).on_kick;
        (*i).user_channel.on_op=(*i1).on_op;
        (*i).user_channel.on_voice=(*i1).on_voice;
        (*i).user_channel.on_devoice=(*i1).on_devoice;
        (*i).user_channel.on_join=(*i1).on_join;
        (*i).user_channel.on_banned=(*i1).on_banned;
        (*i).user_channel.on_flood=(*i1).on_flood;
        (*i).user_channel.on_privmsg=(*i1).on_privmsg;
        (*i).user_channel.on_notice=(*i1).on_notice;
        (*i).user_channel.on_other_mode=(*i1).on_other_mode;
        (*i).user_channel.on_other_mode_mask=(*i1).on_other_mode_mask;

        (*i).user_channel.msg_flood=(*i1).msg_flood;
        (*i).user_channel.notice_flood=(*i1).notice_flood;
        (*i).user_channel.repeat_flood=(*i1).repeat_flood;
        (*i).user_channel.nick_flood=(*i1).nick_flood;
        (*i).user_channel.join_flood=(*i1).join_flood;
        (*i).user_channel.mode_flood=(*i1).mode_flood;
        (*i).user_channel.ctcp_flood=(*i1).ctcp_flood;

        (*i).user_channel.allow_dynamic.clear();
        vector<c_dynamic_rule>::iterator i3;
        for(i3=(*i1).allow_dynamic.begin(); i3!=(*i1).allow_dynamic.end(); ++i3)
            (*i).user_channel.allow_dynamic.push_back(*i3);

        disp=lang_get_string(1,(*i).lang,129)+eol;
        disp=lang_subst(disp,chan);
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    // on_deop
    if((*i).edit_user==2001) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,55)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,75)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_deop);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,544)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2002) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_deop)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_deop="";
                (*i).edit_user++;
            } else {
                if(!p.compare("!")) {
                    vector<c_channel>::iterator i1;
                    for(i1=(*i).user_channels.begin(); i1!=(*i).user_channels.end(); ++i1)
                        if(!(*i1).channel_name.compare((*i).user_channel.channel_name)) {
                            (*i1).configured=false;
                            (*i).edit_user=2;
                            return;
                        }
                } else {
                    if(got)
                        disp=lang_get_string(1,(*i).lang,57)+eol;
                        else
                        disp=lang_get_string(1,(*i).lang,58)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    if(got)
                        (*i).user_channel.on_deop=p;
                        else {
                            (*i).edit_user--;
                            return;
                        }
                    (*i).edit_user++;
                }
            }
        }
    }
    // on_ban
    if((*i).edit_user==2003) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,59)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,76)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_ban);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2004) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_ban)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_ban="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_ban=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_unban
    if((*i).edit_user==2005) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,60)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,77)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_unban);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
}

