/***************************************************************************
                          dcc_loop_edit_user2.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_edit_user2.cpp,v 1.16 2008/07/02 09:35:48 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_edit_user2.cpp,v 1.16 2008/07/02 09:35:48 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

MY_STATIC void dcc_loop_edit_user2_a(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_edit_user2_b(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_edit_user2_c(vector<c_dcc_client>::iterator& i, string& eol);

/*!
    \brief Should be called in a loop to process edit user / new user commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_edit_user2(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).edit_user==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_user==2006) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_unban)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_unban="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_unban=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_kick
    if((*i).edit_user==2007) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,61)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,78)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_kick);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2008) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_kick)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_kick="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_kick=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_op
    if((*i).edit_user==2009) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,62)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,79)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_op);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2010) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_op)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_op="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_op=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_voice
    if((*i).edit_user==2011) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,63)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,80)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_voice);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2012) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_voice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_voice="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_voice=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_devoice
    if((*i).edit_user==2013) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,64)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,81)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_devoice);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2014) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_devoice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_devoice="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_devoice=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_creator (obsolete)
    if((*i).edit_user==2015) {
        (*i).edit_user=2019;
    }
    // on_join
    if((*i).edit_user==2019) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,67)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,84)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_join);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }

    dcc_loop_edit_user2_a(i,eol);
    dcc_loop_edit_user2_b(i,eol);
    dcc_loop_edit_user2_c(i,eol);
}

MY_STATIC void dcc_loop_edit_user2_a(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_user==2020) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_join)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_join="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_join=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_banned
    if((*i).edit_user==2021) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,68)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,85)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_banned);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2022) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_banned)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_banned="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_banned=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_flood
    if((*i).edit_user==2023) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,146)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,147)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_flood);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2024) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_flood)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_flood="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_flood=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }
    // on_privmsg
    if((*i).edit_user==2025) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,164)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,165)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_privmsg);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2026) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_privmsg)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_privmsg="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_privmsg=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }

    // on_notice
    if((*i).edit_user==2027) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,601)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,602)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_privmsg);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2028) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_notice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user++;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_notice="";
                (*i).edit_user++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_notice=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user++;
            }
        }
    }

    // on_other_mode
    if((*i).edit_user==2029) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,564)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,565)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_privmsg);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2030) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_other_mode)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=10000;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=10000;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_other_mode="";
                (*i).edit_user=10000;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_other_mode=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user=10000;
            }
        }
    }
    // on_other_mode_mask
    if((*i).edit_user==10000) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,786)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,787)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,133)+eol;
        disp=lang_subst(disp,(*i).user_channel.on_privmsg);
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==10001) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_other_mode_mask)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=2031;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).edit_user=2031;
        } else {
            if(!p.compare("..")) {
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).user_channel.on_other_mode_mask="";
                (*i).edit_user=2031;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_other_mode_mask=p;
                    else {
                        (*i).edit_user--;
                        return;
                    }
                (*i).edit_user=2031;
            }
        }
    }
    // msg_flood
    if((*i).edit_user==2031) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,153)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2032) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.msg_flood.lines=stoui(lines);
            (*i).user_channel.msg_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
        }
    }
    // notice_flood
    if((*i).edit_user==2033) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,154)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2034) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.notice_flood.lines=stoui(lines);
            (*i).user_channel.notice_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
        }
    }
    // repeat_flood
    if((*i).edit_user==2035) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,155)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2036) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.repeat_flood.lines=stoui(lines);
            (*i).user_channel.repeat_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
        }
    }
    // nick_flood
    if((*i).edit_user==2037) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,156)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2038) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.nick_flood.lines=stoui(lines);
            (*i).user_channel.nick_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
        }
    }
}

MY_STATIC void dcc_loop_edit_user2_b(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    // join_flood
    if((*i).edit_user==2039) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,157)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2040) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.join_flood.lines=stoui(lines);
            (*i).user_channel.join_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
        }
    }
    // mode_flood
    if((*i).edit_user==2041) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,159)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2042) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user=2100;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.mode_flood.lines=stoui(lines);
            (*i).user_channel.mode_flood.seconds=sto_time(seconds);
            (*i).edit_user=2100;
            return;
        }
    }
    // ctcp_flood
    if((*i).edit_user==2100) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,385)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==2101) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).edit_user++;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.ctcp_flood.lines=stoui(lines);
            (*i).user_channel.ctcp_flood.seconds=sto_time(seconds);
            (*i).edit_user++;
        }
    }
    // can_send_unknown
    if((*i).edit_user==2102) {
        if(!(*i).access_grant_can_send_unknown_users) {
            (*i).edit_user=2104;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,475)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
        return;
    }
    if((*i).edit_user==2103) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,475)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).user_channel.can_send_unknown_users=false;
            } else {
                (*i).user_channel.can_send_unknown_users=true;
            }
            (*i).edit_user++;
        }
        return;
    }

    // allow_dynamic
    if((*i).edit_user==2104) {
        disp=lang_get_string(1,(*i).lang,218)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp.clear();
        int i2=1;
        vector<c_dynamic_rule>::iterator i1;
        for(i1=(*i).user_channel.allow_dynamic.begin(); i1!=(*i).user_channel.allow_dynamic.end(); ++i1, ++i2) {
            disp+=lang_get_string(1,(*i).lang,593);
            disp+=tos(i2,3,'0')+": "+(*i1).group+";"+(*i1).plus_modes+";"+(*i1).minus_modes+eol;
        }
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,219)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    if((*i).edit_user==2105) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=true;
            (*i).edit_user=2109;
        }
        if(!p.compare(".add")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,211)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            vector<string>::iterator i1;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1) {
                disp=*i1+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }

            (*i).user_channel_allow_dynamic.group="";
            (*i).user_channel_allow_dynamic.plus_modes="";
            (*i).user_channel_allow_dynamic.minus_modes="";

            (*i).edit_user=2106;
            return;
        }
        string p1, p2;
        int pos=0;
        for(unsigned int i1=0; i1<p.length(); ++i1) {
            if(p[i1]==0x20) {
                pos=1;
                continue;
            }
            if(pos==0)
                p1+=p[i1];
            if(pos==1)
                p2+=p[i1];
        }
        if(!p1.compare(".remove")) {
            got=true;
            int line=stoi(p2);

            int i2=1;
            vector<c_dynamic_rule>::iterator i1;
            for(i1=(*i).user_channel.allow_dynamic.begin(); i1!=(*i).user_channel.allow_dynamic.end(); ++i1, ++i2)
                if(i2==line) {
                    (*i).user_channel.allow_dynamic.erase(i1);
                    break;
                }
            (*i).edit_user=2104;
        }
        if(!got) {
            disp=lang_get_string(1,(*i).lang,219)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
    }
    if((*i).edit_user==2106) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
            if(!p.compare(*i1) || !(*i1).compare("*")) {
                got=true;
                break;
            }
        if(got)
            disp=lang_get_string(1,(*i).lang,212)+eol;
            else
            disp=lang_get_string(1,(*i).lang,214)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        //p=(string)"\""+p+"\"";
        if(got)
            (*i).user_channel_allow_dynamic.group=p;

        (*i).edit_user++;
    }
    //if((*i).edit_user==2042) {
    if((*i).edit_user==2107) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare("."))
            p="";
        //p=(string)"\""+p+"\"";
        (*i).user_channel_allow_dynamic.plus_modes=p;

        ec=0;

        disp=lang_get_string(1,(*i).lang,213)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).edit_user++;
    }
    //if((*i).edit_user==2043) {
    if((*i).edit_user==2108) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare("."))
            p="";
        //p=(string)"\""+p+"\"";
        (*i).user_channel_allow_dynamic.minus_modes=p;

        (*i).user_channel.allow_dynamic.push_back((*i).user_channel_allow_dynamic);

        (*i).edit_user=2104;
    }
    //
    if((*i).edit_user==2109) {
        string chan;
        vector<c_channel>::iterator i1;
        int i2=1;
        for(i1=(*i).user_channels.begin(); i1!=(*i).user_channels.end(); ++i1, ++i2)
            if(i2==(*i).edit_channel_num) {
                chan=(*i1).channel_name;
                break;
            }
        if(!chan.compare("")) {
            (*i).edit_user=2;
            log_debug(GET_STR_DEBUG_INFO_EX("OOPS: Occurred error: cannot find channel to edit! (#2) huh?!"));
            return;
        }
        (*i1).on_deop=(*i).user_channel.on_deop;
        (*i1).on_ban=(*i).user_channel.on_ban;
        (*i1).on_unban=(*i).user_channel.on_unban;
        (*i1).on_kick=(*i).user_channel.on_kick;
        (*i1).on_op=(*i).user_channel.on_op;
        (*i1).on_voice=(*i).user_channel.on_voice;
        (*i1).on_devoice=(*i).user_channel.on_devoice;
        (*i1).on_join=(*i).user_channel.on_join;
        (*i1).on_banned=(*i).user_channel.on_banned;
        (*i1).on_flood=(*i).user_channel.on_flood;
        (*i1).on_privmsg=(*i).user_channel.on_privmsg;
        (*i1).on_notice=(*i).user_channel.on_notice;
        (*i1).on_other_mode=(*i).user_channel.on_other_mode;
        (*i1).on_other_mode_mask=(*i).user_channel.on_other_mode_mask;

        (*i1).msg_flood=(*i).user_channel.msg_flood;
        (*i1).notice_flood=(*i).user_channel.notice_flood;
        (*i1).repeat_flood=(*i).user_channel.repeat_flood;
        (*i1).nick_flood=(*i).user_channel.nick_flood;
        (*i1).join_flood=(*i).user_channel.join_flood;
        (*i1).mode_flood=(*i).user_channel.mode_flood;
        (*i1).ctcp_flood=(*i).user_channel.ctcp_flood;
        (*i1).configured=true;

        (*i1).allow_dynamic.clear();
        vector<c_dynamic_rule>::iterator i3;
        for(i3=(*i).user_channel.allow_dynamic.begin(); i3!=(*i).user_channel.allow_dynamic.end(); ++i3)
            (*i1).allow_dynamic.push_back(*i3);

        (*i1).can_send_unknown_users=(*i).user_channel.can_send_unknown_users;

        (*i).edit_user=2;
    }
    // type .commands
    if((*i).edit_user==1100) {
        if(!(*i).access_grant_backup) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,173)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,168)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        ++(*i).edit_user;
    }
    if((*i).edit_user==1101) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_backup=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_backup=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1102) {
        if(!(*i).access_grant_rehash) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,174)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,169)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1103) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_rehash=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_rehash=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1104) {
        if(!(*i).access_grant_backup) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,170)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1105) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_backup=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_backup=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1106) {
        if(!(*i).access_grant_rehash) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,171)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1107) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_rehash=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_rehash=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1108) {
        if(!(*i).access_grant_plususer) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,191)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,189)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1109) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_plususer=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_plususer=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1110) {
        if(!(*i).access_grant_plususer) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,190)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1111) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_plususer=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_plususer=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1112) {
        if(!(*i).access_grant_plusproc) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,199)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,197)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1113) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_plusproc=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_plusproc=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1114) {
        if(!(*i).access_grant_plususer) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,198)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1115) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_plusproc=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_plusproc=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1116) {
        ec=0;

        if(!(*i).access_grant_replication) {
            (*i).edit_user+=2;

            disp=lang_get_string(1,(*i).lang,216)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            return;
        }

        disp=lang_get_string(1,(*i).lang,215)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1117) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_replication=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_replication=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1118) {
        ec=0;

        if(!(*i).access_grant_replication) {
            (*i).edit_user+=2;

            disp=lang_get_string(1,(*i).lang,216)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            return;
        }

        disp=lang_get_string(1,(*i).lang,600)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1119) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_replication=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_replication=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
}

MY_STATIC void dcc_loop_edit_user2_c(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    if((*i).edit_user==1120) {
        ec=0;

        if(!(*i).access_grant_restart) {
            (*i).edit_user+=2;

            disp=lang_get_string(1,(*i).lang,262)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            return;
        }

        disp=lang_get_string(1,(*i).lang,260)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1121) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_restart=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_restart=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1122) {
        ec=0;

        if(!(*i).access_grant_restart) {
            (*i).edit_user+=2;

            return;
        }

        disp=lang_get_string(1,(*i).lang,261)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1123) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_restart=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_restart=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1124) {
        ec=0;

        if(!(*i).access_grant_die) {
            (*i).edit_user+=2;

            disp=lang_get_string(1,(*i).lang,269)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            return;
        }

        disp=lang_get_string(1,(*i).lang,267)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1125) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_die=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_die=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1126) {
        ec=0;

        if(!(*i).access_grant_die) {
            (*i).edit_user+=2;

            return;
        }

        disp=lang_get_string(1,(*i).lang,268)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1127) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_die=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_die=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1128) {
        ec=0;

        if(!(*i).access_grant_filesystem) {
            (*i).edit_user+=2;

            disp=lang_get_string(1,(*i).lang,278)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            return;
        }

        disp=lang_get_string(1,(*i).lang,276)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1129) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_filesystem=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_filesystem=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }
    if((*i).edit_user==1130) {
        ec=0;

        if(!(*i).access_grant_filesystem) {
            (*i).edit_user+=2;

            return;
        }

        disp=lang_get_string(1,(*i).lang,277)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1131) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_filesystem=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_filesystem=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1132) {
        ec=0;

        if(!(*i).access_grant_private) {
            (*i).edit_user+=2;

            disp=lang_get_string(1,(*i).lang,409)+eol; // !!!
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            return;
        }

        disp=lang_get_string(1,(*i).lang,406)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1133) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_private=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_private=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1134) {
        ec=0;

        if(!(*i).access_grant_private) {
            (*i).edit_user+=2;
            return;
        }

        disp=lang_get_string(1,(*i).lang,407)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1135) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_private=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_private=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1136) {
        ec=0;

        if(!(*i).access_grant_upgrade) {
            (*i).edit_user+=2;
            return;
        }

        disp=lang_get_string(1,(*i).lang,625)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1137) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_upgrade=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_upgrade=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1138) {
        ec=0;

        if(!(*i).access_grant_upgrade) {
            (*i).edit_user+=2;
            return;
        }

        disp=lang_get_string(1,(*i).lang,626)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1139) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_upgrade=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_upgrade=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    //--------------
    if((*i).edit_user==1140) {
        ec=0;

        if(!(*i).access_grant_apply) {
            (*i).edit_user+=2;
            return;
        }

        disp=lang_get_string(1,(*i).lang,680)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1141) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_apply=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_apply=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1142) {
        ec=0;

        if(!(*i).access_grant_apply) {
            (*i).edit_user+=2;
            return;
        }

        disp=lang_get_string(1,(*i).lang,681)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1143) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_apply=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_apply=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    //---------------
    if((*i).edit_user==1144) {
        if(!(*i).access_grant_can_send_all_users) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,477)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1145) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_can_send_all_users=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_can_send_all_users=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1146) {
        if(!(*i).access_grant_can_send_all_users) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,478)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1147) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_can_send_all_users=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_can_send_all_users=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    //---------------
    if((*i).edit_user==1148) {
        if(!(*i).access_grant_can_send_unknown_users) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,481)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1149) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_can_send_unknown_users=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_can_send_unknown_users=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1150) {
        if(!(*i).access_grant_can_send_unknown_users) {
            (*i).edit_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,482)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).edit_user++;
    }
    if((*i).edit_user==1151) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_can_send_unknown_users=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_can_send_unknown_users=false;
        }
        got?(*i).edit_user++:(*i).edit_user--;
    }

    if((*i).edit_user==1152) {
        (*i).edit_user=2;
    }
}

