/***************************************************************************
                          dcc_loop_language.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_language.cpp,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_language.cpp,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process .lang commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_language(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).language==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).language==1) {
        disp=lang_get_string(1,(*i).lang,451)+eol;
        vector<string> langs;
        lang_get_langs(1,langs);
        vector<string>::iterator i1;
        for(i1=langs.begin(); i1!=langs.end(); ++i1) {
            disp+=lang_subst(lang_get_string(1,*i1,452),*i1)+eol;
            disp+="    ";
            disp+=lang_get_string(1,*i1,0)+eol;
        }
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).language++;
        return;
    }

    if((*i).language==2) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string> langs;
        lang_get_langs(1,langs);
        vector<string>::iterator i1;
        got=false;
        for(i1=langs.begin(); i1!=langs.end(); ++i1) {
            if(!(*i1).compare(p)) {
                (*i).lang=*i1;
                got=true;
                break;
            }
        }
        if(!got)
            (*i).language--;
        else {
            (*i).language=0;
            disp=lang_get_string(1,(*i).lang,463)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        return;
    }
}

