/***************************************************************************
                          dcc_loop_msg.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_msg.cpp,v 1.16 2008/07/02 09:35:49 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_msg.cpp,v 1.16 2008/07/02 09:35:49 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process message/filesystem commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_msg(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).msg==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).msg==1) {
        (*i).fs.file.clear();
        (*i).fs.name="";
        (*i).fs.new_access.clear();
        (*i).msg_expiration=0;

        (*i).msg_content="";

        disp=lang_get_string(1,(*i).lang,315)+eol;
        deque<c_user>::iterator i1;
        for(i1=r_users.begin(); i1!=r_users.end(); ++i1)
            disp+=(*i1).name+eol;
        disp+=lang_get_string(1,(*i).lang,316)+eol;
        disp+=lang_get_string(1,(*i).lang,338)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }

    if((*i).msg==2) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            (*i).msg++;
            disp=lang_get_string(1,(*i).lang,337)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        bool all_users=!p.compare("*");
        string all_channel;
        if(p.length()>=2 && p[0]=='*') {
            p.erase(0,1);
            got=false;
            vector<string>::iterator i1;
            for(i1=(*i).access_to_channel.begin(); i1!=(*i).access_to_channel.end(); ++i1)
                if(!cmp_strings_case_insensitive(*i1,p)) {
                    got=true;
                    break;
                }
            if(got) {
                all_channel=p;
            } else {
                all_channel="";
                all_users=false;
                disp=lang_get_string(1,(*i).lang,323)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).msg=0;
                return;
            }
        }

        if(!all_users && all_channel.empty()) {
            disp=lang_get_string(1,(*i).lang,304)+eol;
            disp+=lang_get_string(1,(*i).lang,315)+eol;
            deque<c_user>::iterator i1;
            for(i1=r_users.begin(); i1!=r_users.end(); ++i1) {
                disp+=(*i1).name+eol;
                if(!(*i1).name.compare(p)) {
                    (*i).fs.new_access.clear();
                    (*i).fs.new_access.user_name=p;

                    c_user u;
                    vector<c_channel> chs;
                    logic_partyline_get_user(p,u,chs);
                    bool unknown_user=u.host_unknown;
                    logic_partyline_get_user((*i).as_in_logic,u,chs);
                    vector<c_channel>::iterator i2;
                    bool can=(*i).access_to_can_send_unknown_users;
                    if(!unknown_user)
                        can=true;
                    if(unknown_user && !can) {
                        disp=lang_get_string(1,(*i).lang,480)+eol;
                        ec=0;
                        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                        return;
                    }
                    (*i).fs.new_access.user_name=p;
                    (*i).fs.file.access.push_back((*i).fs.new_access);
                    (*i).fs.new_access.clear();
                    disp=lang_get_string(1,(*i).lang,339)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    return;
                }
            }
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        if(!all_channel.empty()) {
            vector<c_channel>::iterator i1;
            got=false;
            map<string,string> vars;
            for(i1=r_channels.begin(); i1!=r_channels.end(); ++i1) {
                if(!(*i).as_in_logic.compare((*i1).username) && !cmp_strings_case_insensitive((*i1).channel_name,all_channel) && !(*i1).host_unknown && (*i1).can_send_unknown_users) {
                    (*i).fs.new_access.clear();
                    (*i).fs.new_access.all_on_channel=all_channel;
                    got=true;
                    break;
                }
            }

            if(!got) {
                (*i).fs.new_access.clear();
                (*i).fs.new_access.all_on_channel=all_channel;
                (*i).fs.file.access.push_back((*i).fs.new_access);

                disp=lang_get_string(1,(*i).lang,339)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                return;
            }
            (*i).msg=2000;
            return;
        }
        if(all_users) {
            if(!(*i).access_to_can_send_all_users) {
                disp=lang_get_string(1,(*i).lang,479)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                return;
            }

            c_access a;
            a.all_users=true;
            (*i).fs.file.access.clear();
            (*i).fs.file.access.push_back(a);
            (*i).msg++;

            disp=lang_get_string(1,(*i).lang,337)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        return;
    }

    if((*i).msg==3) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare(".")) {
            if(stoi(core_conf_getvar("dcc_max_message_size"))!=0 && (*i).msg_content.length()+p.length()>stoull(core_conf_getvar("dcc_max_message_size"))) {
                disp=lang_get_string(1,(*i).lang,613)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).msg_content+=p;
                (*i).msg_content+="\n";
            }
        } else {
            (*i).msg++;
        }
        return;
    }

    // attr's
    if((*i).msg==4) {
        disp=lang_get_string(1,(*i).lang,340)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }

    if((*i).msg==5) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,340)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
            } else {
                vector<c_access>::iterator i1;
                for(i1=(*i).fs.file.access.begin(); i1!=(*i).fs.file.access.end(); ++i1)
                    (*i1).notify_owner=true;
            }
            (*i).msg++;
            return;
        }
    }

    if((*i).msg==6) {
        disp=lang_get_string(1,(*i).lang,341)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }

    if((*i).msg==7) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,341)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                vector<c_access>::iterator i1;
                for(i1=(*i).fs.file.access.begin(); i1!=(*i).fs.file.access.end(); ++i1)
                    (*i1).secure=false;
            } else {
                vector<c_access>::iterator i1;
                for(i1=(*i).fs.file.access.begin(); i1!=(*i).fs.file.access.end(); ++i1)
                    (*i1).secure=true;
            }
            (*i).msg++;
            return;
        }
    }

    if((*i).msg==8) {
        (*i).msg++;
        return;
    }

    if((*i).msg==9) {
        disp=lang_get_string(1,(*i).lang,473)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }

    if((*i).msg==10) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,473)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).msg=1000;
                return;
            } else {
                disp=lang_get_string(1,(*i).lang,436)+eol; // !!!
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).msg++;
                return;
            }
        }
    }
    if((*i).msg==11) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        int x=stoi(p);
        if(x==0) {
            (*i).fs.file.expiration=0;
            disp=lang_get_string(1,(*i).lang,441)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).msg=1000;
            return;
        }
        if(x<1970) {
            disp=lang_get_string(1,(*i).lang,436)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        (*i).filesystem_expiration.tm_year=x;
        disp=lang_get_string(1,(*i).lang,437)+eol; // !!!
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }
    if((*i).msg==12) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        int x=stoi(p);
        if(x<1 || x>12) {
            disp=lang_get_string(1,(*i).lang,437)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        (*i).filesystem_expiration.tm_mon=x;
        disp=lang_get_string(1,(*i).lang,438)+eol; // !!!
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }
    if((*i).msg==13) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        int x=stoi(p);
        if(x<1 || x>31) {
            disp=lang_get_string(1,(*i).lang,438)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        (*i).filesystem_expiration.tm_mday=x;
        disp=lang_get_string(1,(*i).lang,439)+eol; // !!!
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }
    if((*i).msg==14) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        int x=stoi(p);
        if(x<0 || x>23) {
            disp=lang_get_string(1,(*i).lang,439)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        (*i).filesystem_expiration.tm_hour=x;
        disp=lang_get_string(1,(*i).lang,440)+eol; // !!!
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }
    if((*i).msg==15) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        int x=stoi(p);
        if(x<0 || x>59) {
            disp=lang_get_string(1,(*i).lang,440)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        }
        (*i).filesystem_expiration.tm_min=x;
        (*i).filesystem_expiration.tm_isdst=-1;
        (*i).filesystem_expiration.tm_sec=0;
        (*i).filesystem_expiration.tm_wday=0;
        (*i).filesystem_expiration.tm_yday=0;

        (*i).filesystem_expiration.tm_mon-=1;
        (*i).filesystem_expiration.tm_year-=1900;

        my_time_t ex=mktime(&(*i).filesystem_expiration);
        if(ex==-1) {
            disp=lang_get_string(1,(*i).lang,442)+eol; // !!!
            disp+=lang_get_string(1,(*i).lang,436)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).msg=11;
            return;
        }
        if(ex<my_time(NULL)) {
            disp=lang_get_string(1,(*i).lang,443)+eol; // !!!
            disp+=lang_get_string(1,(*i).lang,436)+eol; // !!!
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).msg=11;
            return;
        }

        (*i).msg_expiration=ex;

        disp=lang_get_string(1,(*i).lang,433)+eol;
        if(ex==0)
            disp+=lang_get_string(1,(*i).lang,434)+eol;
        else {
            disp+=make_nice_time(ex)+eol;
        }

        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg=1000;
        return;
    }

    if((*i).msg==1000) {
        disp=lang_get_string(1,(*i).lang,342)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }

    if((*i).msg==1001) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        (*i).fs.file.public_name=p;
        (*i).fs.file.expiration=(*i).msg_expiration;

        disp=lang_get_string(1,(*i).lang,343)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }

    if((*i).msg==1002) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,343)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            disp.clear();
            if(!p.compare("n") || !p.compare("N")) {
                disp=lang_get_string(1,(*i).lang,344)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).fs.file.clear();
                (*i).fs.name="";
                (*i).fs.new_access.clear();
                (*i).msg=0;
            } else {
l1:
                vector<c_access>::iterator i1;

                bool read=true;
                bool notify_user=true;
                bool old_secure=false;
                bool notify_owner=false;

                for(i1=(*i).fs.file.access.begin(); i1!=(*i).fs.file.access.end(); ++i1) {
                    read|=(*i1).read;
                    notify_user|=(*i1).notify_user;
                    notify_owner|=(*i1).notify_owner;
                    old_secure|=(*i1).secure;
                }

                // erase duplicates
                for(i1=(*i).fs.file.access.begin(); i1!=(*i).fs.file.access.end(); ++i1) {
                    vector<c_access>::iterator i2;
                    for(i2=(*i).fs.file.access.begin(); i2!=(*i).fs.file.access.end(); ++i2) {
                        if(i1==i2)
                            continue;
                        if((!(*i2).user_name.compare((*i1).user_name) || (*i2).all_users) && !(*i2).user_name.empty()) {
                            (*i).fs.file.access.erase(i2);
                            goto l1;
                        }
                    }
                }

                for(i1=(*i).fs.file.access.begin(); i1!=(*i).fs.file.access.end(); ++i1) {
                    (*i1).read=read;
                    (*i1).notify_user=notify_user;
                    (*i1).notify_owner=notify_owner;
                    (*i1).secure=old_secure;
                }

                c_access a;
                a.del=true;
                a.owner=true;
                a.read=true;
                a.secure=old_secure;
                a.user_name=(*i).as_in_logic;
                (*i).fs.file.access.push_back(a);

                bool force_secure=false;
                string internal_name=filesys_dcc_add_message((*i).as_in_logic,(*i).fs.file,(*i).msg_content,force_secure);

                if(!old_secure && force_secure)
                    disp+=lang_get_string(1,(*i).lang,346)+eol;

                disp+=lang_get_string(1,(*i).lang,345)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

                (*i).fs.file.clear();
                (*i).fs.name="";
                (*i).fs.new_access.clear();
                (*i).msg_content="";
                (*i).msg=0;

                logic_filesys_got_new((*i).as_in_logic,"","","",internal_name);
            }
            (*i).msg=0;
            return;
        }
    }

    // also unknown users?
    if((*i).msg==2000) {
        disp=lang_get_string(1,(*i).lang,476)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).msg++;
        return;
    }
    if((*i).msg==2001) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,476)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).fs.new_access.also_unknown=false;
            } else {
                (*i).fs.new_access.also_unknown=true;;
            }
            (*i).fs.file.access.push_back((*i).fs.new_access);
            (*i).fs.new_access.clear();
            disp=lang_get_string(1,(*i).lang,339)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).msg=2;
            return;
        }
        return;
    }
}

