/***************************************************************************
                          dcc_loop_new_user.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_new_user.cpp,v 1.16 2008/07/02 09:35:49 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_new_user.cpp,v 1.16 2008/07/02 09:35:49 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

MY_STATIC void dcc_loop_new_user_a(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_new_user_b(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_new_user_c(vector<c_dcc_client>::iterator& i, string& eol);
MY_STATIC void dcc_loop_new_user_d(vector<c_dcc_client>::iterator& i, string& eol);

/*!
    \brief Should be called in a loop to process new user commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_new_user(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).new_user==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).new_user==-1) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            got=false;
            vector<string>::iterator i1;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                if(!p.compare(*i1)) {
                    got=true;
                    //p=(string)"\""+p+"\"";
                    (*i).user_member_of.push_back(p);
                    break;
                }
            if(got) {
                disp=lang_subst(lang_get_string(1,(*i).lang,104),p)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_subst(lang_get_string(1,(*i).lang,47),p)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        } else {
            disp=lang_subst(lang_get_string(1,(*i).lang,34),p)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=2;
        }
    }

    if((*i).new_user==1) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(logic_partyline_user_exists(p)) {
            disp=lang_subst(lang_get_string(1,(*i).lang,33),p)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            (*i).new_user=-100;
            (*i).user_name=p;
            return;
        }
    }
    if((*i).new_user==-100) {
        disp=lang_get_string(1,(*i).lang,386)+eol;
        deque<c_user>::iterator i1;
        got=false;
        for(i1=r_user_templates.begin(); i1!=r_user_templates.end(); ++i1) {
            vector<string>::iterator i3;
            bool got_this=false;
            for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                vector<string>::iterator i2;
                for(i2=(*i1).groups.begin(); i2!=(*i1).groups.end(); ++i2) {
                    if(!(*i2).compare(*i3)) {
                        got_this=true;
                        break;
                    }
                }
                if(got_this)
                    break;
            }
            if(got_this) {
                got=true;
                disp+=(*i1).name+eol;
            }
        }
        if(!got) {
            disp+=lang_get_string(1,(*i).lang,387)+eol;
            (*i).new_user=-150;
        } else
            (*i).new_user++;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        return;
    }
    if((*i).new_user==-99) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            disp=lang_subst(lang_get_string(1,(*i).lang,389),p)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=-150;
            (*i).edit_user_from_template=false;
            return;
        }

        deque<c_user>::iterator i1;
        got=false;
        for(i1=r_user_templates.begin(); i1!=r_user_templates.end(); ++i1) {
            vector<string>::iterator i3;
            bool got_this=false;
            for(i3=(*i).access_to_groups.begin(); i3!=(*i).access_to_groups.end(); ++i3) {
                vector<string>::iterator i2;
                for(i2=(*i1).groups.begin(); i2!=(*i1).groups.end(); ++i2) {
                    if(!(*i2).compare(*i3)) {
                        got_this=true;
                        break;
                    }
                }
                if(got_this)
                    break;
            }
            if(!got_this)
                continue;
            if(!(*i1).name.compare(p)) {
                got=true;
                break;
            }
        }
        if(!got) {
            disp=lang_subst(lang_get_string(1,(*i).lang,388),p)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=-100;
            return;
        } else {
            c_user u;
            vector<c_channel> chs;
            logic_partyline_get_user_template(p,u,chs);

            u.is_template=false;
            u.host_bot=false;
            u.host_unknown=false;

            {
                (*i).user_member_of.clear();
                (*i).user_hosts.clear();
                (*i).user_dcc_hosts.clear();
                (*i).user_fullnames.clear();
                (*i).user_meta.clear();
                (*i).user_access_to_groups.clear();
                (*i).user_access_grant_groups.clear();
                (*i).user_access_to_proc_groups.clear();
                (*i).user_access_grant_proc_groups.clear();
                (*i).user_access_usage_proc_groups.clear();
                (*i).user_access_to_channel.clear();
                (*i).user_access_grant_channel.clear();
                (*i).user_channels.clear();
                (*i).user_channel.clear();
            }

            vector<string>::iterator i1;

            for(i1=u.groups.begin(); i1!=u.groups.end(); ++i1)
                (*i).user_member_of.push_back(*i1);

            vector<string>::iterator i2;
            for(i2=u.hostmask.begin(); i2!=u.hostmask.end(); ++i2)
                (*i).user_hosts.push_back(*i2);

            vector<c_dcc_host>::iterator i3;
            for(i3=u.dcc_hosts.begin(); i3!=u.dcc_hosts.end(); ++i3) {
                (*i).user_dcc_hosts.push_back(*i3);
            }

            for(i2=u.fullname.begin(); i2!=u.fullname.end(); ++i2)
                (*i).user_fullnames.push_back(*i2);

            map<string,string>::iterator i5;
            for(i5=u.meta.begin(); i5!=u.meta.end(); ++i5)
                (*i).user_meta.insert(*i5);

            for(i2=u.access_to_group.begin(); i2!=u.access_to_group.end(); ++i2)
                (*i).user_access_to_groups.push_back(*i2);

            for(i2=u.access_grant_group.begin(); i2!=u.access_grant_group.end(); ++i2)
                (*i).user_access_grant_groups.push_back(*i2);

            for(i2=u.access_to_proc.begin(); i2!=u.access_to_proc.end(); ++i2)
                (*i).user_access_to_proc_groups.push_back(*i2);

            for(i2=u.access_grant_procedure.begin(); i2!=u.access_grant_procedure.end(); ++i2)
                (*i).user_access_grant_proc_groups.push_back(*i2);

            for(i2=u.access_usage_procedure.begin(); i2!=u.access_usage_procedure.end(); ++i2)
                (*i).user_access_usage_proc_groups.push_back(*i2);

            for(i2=u.access_to_channel.begin(); i2!=u.access_to_channel.end(); ++i2)
                (*i).user_access_to_channel.push_back(*i2);

            for(i2=u.access_grant_channel.begin(); i2!=u.access_grant_channel.end(); ++i2)
                (*i).user_access_grant_channel.push_back(*i2);

            (*i).user_channels.clear();
            vector<c_channel>::iterator i4;
            for(i4=chs.begin(); i4!=chs.end(); ++i4) {
                (*i4).configured=true;
                (*i4).is_template=false;
                (*i).user_channels.push_back(*i4);
            }

            (*i).user_access_to_backup=u.access_to_backup;
            (*i).user_access_to_die=u.access_to_die;
            (*i).user_access_to_filesystem=u.access_to_filesystem;
            (*i).user_access_to_partyline=u.access_to_partyline;
            (*i).user_access_to_plusproc=u.access_to_plusproc;
            (*i).user_access_to_plususer=u.access_to_plususer;
            (*i).user_access_to_rehash=u.access_to_rehash;
            (*i).user_access_to_restart=u.access_to_restart;
            (*i).user_access_grant_backup=u.access_grant_backup;
            (*i).user_access_grant_die=u.access_grant_die;
            (*i).user_access_grant_filesystem=u.access_grant_filesystem;
            (*i).user_access_grant_partyline=u.access_grant_partyline;
            (*i).user_access_grant_plusproc=u.access_grant_plusproc;
            (*i).user_access_grant_plususer=u.access_grant_plususer;
            (*i).user_access_grant_rehash=u.access_grant_rehash;
            (*i).user_access_to_replication=u.access_to_replication;
            (*i).user_access_grant_replication=u.access_grant_replication;
            (*i).user_access_grant_restart=u.access_grant_restart;

            (*i).user_access_to_private=u.access_to_private;
            (*i).user_access_grant_private=u.access_grant_private;

            (*i).user_partyline_msg_flood=u.partyline_msg_flood;

            (*i).user_access_to_can_send_all_users=u.access_to_can_send_all_users;
            (*i).user_access_grant_can_send_all_users=u.access_grant_can_send_all_users;

            (*i).user_access_to_can_send_unknown_users=u.access_to_can_send_unknown_users;
            (*i).user_access_grant_can_send_unknown_users=u.access_grant_can_send_unknown_users;

            (*i).user_access_to_upgrade=u.access_to_upgrade;
            (*i).user_access_grant_upgrade=u.access_grant_upgrade;

            (*i).user_access_to_apply=u.access_to_apply;
            (*i).user_access_grant_apply=u.access_grant_apply;

            (*i).new_user=0;
            (*i).edit_user=2;
            (*i).edit_user_from_template=true;
            return;
        }
    }
    if((*i).new_user==-150) {
        (*i).user_fullnames.clear();
        (*i).user_meta.clear();
        (*i).user_hosts.clear();
        (*i).user_dcc_hosts.clear();
        (*i).user_fullnames.clear();
        (*i).user_access_grant_partyline=false;
        (*i).user_channels.clear();
        (*i).user_channel.clear();
        (*i).user_member_of.clear();
        (*i).user_access_to_backup=false;
        (*i).user_access_grant_backup=false;
        (*i).user_access_to_rehash=false;
        (*i).user_access_grant_rehash=false;
        (*i).user_access_to_plususer=false;
        (*i).user_access_grant_plususer=false;

        (*i).user_access_to_plusproc=false;
        (*i).user_access_grant_plusproc=false;

        (*i).user_access_to_replication=false;
        (*i).user_access_grant_replication=false;

        (*i).user_access_to_restart=false;
        (*i).user_access_grant_restart=false;
        (*i).user_access_to_die=false;
        (*i).user_access_grant_die=false;

        (*i).user_access_to_filesystem=false;
        (*i).user_access_grant_filesystem=false;

        (*i).user_access_to_upgrade=false;
        (*i).user_access_grant_upgrade=false;

        (*i).user_access_to_apply=false;
        (*i).user_access_grant_apply=false;

        (*i).user_access_to_private=false;
        (*i).user_access_grant_private=false;

        (*i).user_access_to_can_send_all_users=false;
        (*i).user_access_grant_can_send_all_users=false;

        (*i).new_user=-300;
        return;
    }
    if((*i).new_user==-200) {
        disp=lang_get_string(1,(*i).lang,102)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        vector<string>::iterator i1;
        disp.clear();
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
            disp+=*i1+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        disp=lang_get_string(1,(*i).lang,103)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).user_member_of.clear();
        (*i).new_user=-1;
        return;
    }

    if((*i).new_user==-300) {
        (*i).new_user=-200;
        return;
    }

    if((*i).new_user==2) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            (*i).user_hosts.push_back(p);
            disp=lang_get_string(1,(*i).lang,35)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).user_hosts.begin()==(*i).user_hosts.end()) {
                disp=lang_get_string(1,(*i).lang,105)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,36)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user++;
            }
        }
    }
    if((*i).new_user==3) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,36)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).new_user=6;
                disp=lang_get_string(1,(*i).lang,39)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,37)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user++;
            }
        }
    }
    if((*i).new_user==4) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            (*i).user_dcc_host.group=stoi(p);
            disp=lang_get_string(1,(*i).lang,38)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if((*i).user_fullnames.begin()==(*i).user_fullnames.end()) {
                disp=lang_get_string(1,(*i).lang,545)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                disp=lang_get_string(1,(*i).lang,39)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user=6;
            }
        }
    }
    if((*i).new_user==5) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            //p=(string)"\""+p+"\"";
            (*i).user_dcc_host.host=p;
            (*i).user_dcc_hosts.push_back((*i).user_dcc_host);
            disp=lang_get_string(1,(*i).lang,37)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=4;
        } else {
            disp=lang_get_string(1,(*i).lang,39)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        }
    }
    if((*i).new_user==6) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            //p=(string)"\""+p+"\"";
            (*i).user_fullnames.push_back(p);
            disp=lang_get_string(1,(*i).lang,40)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if((*i).access_grant_partyline) {
                disp=lang_get_string(1,(*i).lang,43)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user++;
            } else {
                (*i).new_user=100;
            }
        }
    }
    if((*i).new_user==7) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,43)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).user_access_to_partyline=false;
                //(*i).new_user=100;
                (*i).new_user=1000;
                (*i).user_partyline_msg_flood.lines=0;
                (*i).user_partyline_msg_flood.seconds=0;
                return;
            } else {
                (*i).user_access_to_partyline=true;
                //(*i).new_user=200;
                (*i).new_user=1100;
                return;
            }
        }
    }

    //---
    if((*i).new_user==8) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            vector<string>::iterator i1;
            got=false;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                if(!p.compare(*i1))
                    got=true;
            if(got)
                disp=lang_get_string(1,(*i).lang,46)+eol;
                else
                disp=lang_get_string(1,(*i).lang,47)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_access_to_groups.push_back(p);
        } else {
            disp=lang_get_string(1,(*i).lang,48)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            vector<string>::iterator i1;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1) {
                disp=*i1+eol;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            disp=lang_get_string(1,(*i).lang,45)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        }
    }
    if((*i).new_user==9) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            vector<string>::iterator i1;
            got=false;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                if(!p.compare(*i1))
                    got=true;
            if(got)
                disp=lang_get_string(1,(*i).lang,46)+eol;
                else
                disp=lang_get_string(1,(*i).lang,47)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            //p=(string)"\""+p+"\"";
            if(got)
                (*i).user_access_grant_groups.push_back(p);
        } else {
            (*i).new_user++;
        }
    }
    if((*i).new_user==10) {
        (*i).new_user++;
    }
    if((*i).new_user==11) {
        disp=lang_get_string(1,(*i).lang,590)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        vector<string>::iterator i1;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1) {
            disp=*i1+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        disp=lang_get_string(1,(*i).lang,45)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).new_user=1200;
        return;
    }

    if((*i).new_user==12) {
        (*i).new_user++;
    }
    if((*i).new_user==13) {
        disp=lang_get_string(1,(*i).lang,53)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).new_user++;
    }

    dcc_loop_new_user_a(i,eol);
    dcc_loop_new_user_b(i,eol);
    dcc_loop_new_user_c(i,eol);
    dcc_loop_new_user_d(i,eol);
}

MY_STATIC void dcc_loop_new_user_a(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    if((*i).new_user==14) {
        vector<c_channel_def>::iterator i1;
        for(i1=r_channel_defs.begin(); i1!=r_channel_defs.end(); ++i1) {
            got=false;
            vector<string>::iterator i2;
            for(i2=(*i).access_to_groups.begin(); i2!=(*i).access_to_groups.end(); ++i2) {
                vector<string>::iterator i3;
                for(i3=(*i1).groups.begin(); i3!=(*i1).groups.end(); ++i3)
                    if(!(*i3).compare(*i2)) {
                        got=true;
                        break;
                    }
            }
            if(got) {
                c_channel ch;
                ch.username=(*i).user_name;
                ch.channel_name=(*i1).channel_name;
                ch.on_deop="";
                ch.on_ban="";
                ch.on_unban="";
                ch.on_kick="";
                ch.on_op="";
                ch.on_voice="";
                ch.on_devoice="";
                ch.on_join="";
                ch.on_banned="";
                ch.on_flood="";
                ch.on_privmsg="";
                ch.on_notice="";
                ch.on_except="";
                ch.on_unexcept="";
                ch.on_invite="";
                ch.on_uninvite="";
                ch.on_not_invited="";
                ch.on_not_in_reop="";
                ch.on_reop="";
                ch.on_other_mode="";
                ch.on_other_mode_mask="";
                ch.msg_flood.lines=0;
                ch.notice_flood.lines=0;
                ch.repeat_flood.lines=0;
                ch.nick_flood.lines=0;
                ch.join_flood.lines=0;
                ch.mode_flood.lines=0;
                ch.ctcp_flood.lines=0;
                ch.allow_dynamic.clear();
                ch.configured=false;
                ch.can_send_unknown_users=false;
                (*i).user_channels.push_back(ch);
                disp=(*i1).channel_name+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
        }
        (*i).new_user++;
    }

    if((*i).new_user==15) {
        int num_not_configured_channels=0;

        string channel="";

        vector<c_channel>::iterator i2;
        for(i2=(*i).user_channels.begin(); i2!=(*i).user_channels.end(); ++i2)
            if(!(*i2).configured) {
                num_not_configured_channels++;
                if(!channel.compare(""))
                    channel=(*i2).channel_name;
            }
        (*i).num_not_configured_channels=num_not_configured_channels;
        (*i).user_channel.clear();
        (*i).user_channel.username=(*i).user_name;
        (*i).user_channel.channel_name=channel;

        (*i).user_channel_allow_dynamic.group="";
        (*i).user_channel_allow_dynamic.plus_modes="";
        (*i).user_channel_allow_dynamic.minus_modes="";

        (*i).user_channel.configured=false;
        (*i).user_channel.can_send_unknown_users=false;

        (*i).new_user++;

        // end!
        if(num_not_configured_channels==0)
            (*i).new_user=38;
        (*i).num_not_configured_channels=num_not_configured_channels;
    }
    // on_deop
    if((*i).new_user==16) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,55)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,75)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,541)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==17) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_deop)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(!p.compare("!")) {
                vector<c_channel>::iterator i2;
                for(i2=(*i).user_channels.begin(); i2!=(*i).user_channels.end(); ++i2)
                    if(!(*i2).channel_name.compare((*i).user_channel.channel_name)) {
                        (*i).user_channels.erase(i2);
                        break;
                    }
                if((*i).num_not_configured_channels>0) {
                    (*i).new_user=15;
                    return;
                } else {
                    disp=lang_get_string(1,(*i).lang,69)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                    (*i).new_user=39;
                    return;
                }
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                    else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).user_channel.on_deop=p;
                    else {
                        (*i).new_user--;
                        return;
                    }
                (*i).new_user++;
            }
        }
    }
    // on_ban
    if((*i).new_user==18) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,59)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,76)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==19) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_ban)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_ban=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_unban
    if((*i).new_user==20) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,60)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,77)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==21) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_unban)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_unban=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_kick
    if((*i).new_user==22) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,61)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,78)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==23) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_kick)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_kick=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_op
    if((*i).new_user==24) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,62)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,79)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==25) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_op)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_op=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_voice
    if((*i).new_user==26) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,63)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,80)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==27) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_voice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_voice=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_devoice
    if((*i).new_user==28) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,64)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,81)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==29) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_devoice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_devoice=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_creator (obsolete)
    if((*i).new_user==30) {
        (*i).new_user=34;
    }
    // on_join
    if((*i).new_user==34) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,67)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,84)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
}

MY_STATIC void dcc_loop_new_user_b(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    if((*i).new_user==35) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_join)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_join=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_banned
    if((*i).new_user==36) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,68)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,85)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==37) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_banned)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=40;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_banned=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user=40;
        }
    }

    if((*i).new_user==38) {
        vector<c_channel>::iterator i2;
        for(i2=(*i).user_channels.begin(); i2!=(*i).user_channels.end(); ++i2)
            if(!(*i2).channel_name.compare((*i).user_channel.channel_name)) {
                *i2=(*i).user_channel;
                (*i2).configured=true;
            }

        if((*i).num_not_configured_channels>0) {
            (*i).new_user=15;
        } else {
                disp=lang_get_string(1,(*i).lang,69)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user++;
            }
    }
    if((*i).new_user==39) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N") && p.compare("t") && p.compare("T")) {
            disp=lang_get_string(1,(*i).lang,69)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                disp=lang_get_string(1,(*i).lang,70)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).new_user=0;
            } else {
                (*i).new_user=0;
                // commit !!!
                if(logic_partyline_user_exists((*i).user_name)) {
                    disp=lang_get_string(1,(*i).lang,72)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                } else {
                    c_user u;

                    u.name=(*i).user_name;

                    u.host_unknown=false;
                    u.host_bot=false;

                    u.is_template=!p.compare("t") || !p.compare("T");

                    vector<string>::iterator i1;
                    for(i1=(*i).user_member_of.begin(); i1!=(*i).user_member_of.end(); ++i1) {
                        u.groups.push_back(*i1);
                    }
                    for(i1=(*i).user_hosts.begin(); i1!=(*i).user_hosts.end(); ++i1)
                        u.hostmask.push_back(*i1);
                    vector<c_dcc_host>::iterator i2;
                    for(i2=(*i).user_dcc_hosts.begin(); i2!=(*i).user_dcc_hosts.end(); ++i2)
                        u.dcc_hosts.push_back(*i2);
                    for(i1=(*i).user_fullnames.begin(); i1!=(*i).user_fullnames.end(); ++i1)
                        u.fullname.push_back(*i1);

                    map<string,string>::iterator i5;
                    for(i5=(*i).user_meta.begin(); i5!=(*i).user_meta.end(); ++i5)
                        u.meta.insert(*i5);

                    u.access_to_partyline=(*i).user_access_to_partyline;
                    u.access_grant_partyline=(*i).user_access_grant_partyline;
                    u.access_to_backup=(*i).user_access_to_backup;
                    u.access_to_rehash=(*i).user_access_to_rehash;
                    u.access_grant_backup=(*i).user_access_grant_backup;
                    u.access_grant_rehash=(*i).user_access_grant_rehash;
                    u.access_to_plususer=(*i).user_access_to_plususer;
                    u.access_grant_plususer=(*i).user_access_grant_plususer;

                    u.access_to_plusproc=(*i).user_access_to_plusproc;
                    u.access_grant_plusproc=(*i).user_access_grant_plusproc;

                    u.access_to_replication=(*i).user_access_to_replication;
                    u.access_grant_replication=(*i).user_access_grant_replication;

                    u.access_to_restart=(*i).user_access_to_restart;
                    u.access_grant_restart=(*i).user_access_grant_restart;
                    u.access_to_die=(*i).user_access_to_die;
                    u.access_grant_die=(*i).user_access_grant_die;

                    u.access_to_filesystem=(*i).user_access_to_filesystem;
                    u.access_grant_filesystem=(*i).user_access_grant_filesystem;

                    u.access_to_upgrade=(*i).user_access_to_upgrade;
                    u.access_grant_upgrade=(*i).user_access_grant_upgrade;

                    u.access_to_apply=(*i).user_access_to_apply;
                    u.access_grant_apply=(*i).user_access_grant_apply;

                    u.access_to_can_send_all_users=(*i).user_access_to_can_send_all_users;
                    u.access_grant_can_send_all_users=(*i).user_access_grant_can_send_all_users;

                    u.access_to_can_send_unknown_users=(*i).user_access_to_can_send_unknown_users;
                    u.access_grant_can_send_unknown_users=(*i).user_access_grant_can_send_unknown_users;

                    u.access_to_private=(*i).user_access_to_private;
                    u.access_grant_private=(*i).user_access_grant_private;

                    for(i1=(*i).user_access_to_groups.begin(); i1!=(*i).user_access_to_groups.end(); ++i1)
                        u.access_to_group.push_back(*i1);
                    for(i1=(*i).user_access_grant_groups.begin(); i1!=(*i).user_access_grant_groups.end(); ++i1)
                        u.access_grant_group.push_back(*i1);
                    for(i1=(*i).user_access_to_proc_groups.begin(); i1!=(*i).user_access_to_proc_groups.end(); ++i1)
                        u.access_to_proc.push_back(*i1);
                    for(i1=(*i).user_access_grant_proc_groups.begin(); i1!=(*i).user_access_grant_proc_groups.end(); ++i1)
                        u.access_grant_procedure.push_back(*i1);
                    for(i1=(*i).user_access_usage_proc_groups.begin(); i1!=(*i).user_access_usage_proc_groups.end(); ++i1)
                        u.access_usage_procedure.push_back(*i1);
                    for(i1=(*i).user_access_to_channel.begin(); i1!=(*i).user_access_to_channel.end(); ++i1)
                        u.access_to_channel.push_back(*i1);
                    for(i1=(*i).user_access_grant_channel.begin(); i1!=(*i).user_access_grant_channel.end(); ++i1)
                        u.access_grant_channel.push_back(*i1);
                    vector<c_channel> chs;
                    vector<c_channel>::iterator i3;
                    for(i3=(*i).user_channels.begin(); i3!=(*i).user_channels.end(); ++i3) {
                        if(!(*i3).configured)
                            continue;
                        chs.push_back(*i3);
                    }

                    u.partyline_msg_flood=(*i).user_partyline_msg_flood;

                    my_time(&u.last_changed);
                    logic_partyline_add_user(u,chs);
                    disp=lang_get_string(1,(*i).lang,73)+eol;
                    ec=0;
                    dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                }
            }
        }
    }
    // on_flood
    if((*i).new_user==40) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,146)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,147)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==41) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_flood)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_flood=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_privmsg
    if((*i).new_user==42) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,164)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,165)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==43) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_privmsg)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=500;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user=500;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_privmsg=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user=500;
        }
    }

    // msg_flood
    if((*i).new_user==44) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,148)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==45) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.msg_flood.lines=stoui(lines);
            (*i).user_channel.msg_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // notice_flood
    if((*i).new_user==46) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,149)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==47) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.notice_flood.lines=stoui(lines);
            (*i).user_channel.notice_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // repeat_flood
    if((*i).new_user==48) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,150)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==49) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.repeat_flood.lines=stoui(lines);
            (*i).user_channel.repeat_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // nick_flood
    if((*i).new_user==50) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,151)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==51) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.nick_flood.lines=stoui(lines);
            (*i).user_channel.nick_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // join_flood
    if((*i).new_user==52) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,152)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==53) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.join_flood.lines=stoui(lines);
            (*i).user_channel.join_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // mode_flood
    if((*i).new_user==54) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,158)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==55) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.mode_flood.lines=stoui(lines);
            (*i).user_channel.mode_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // ctcp_flood
    if((*i).new_user==56) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,384)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==57) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare(".")) {
            (*i).new_user--;
        } else {
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_channel.ctcp_flood.lines=stoui(lines);
            (*i).user_channel.ctcp_flood.seconds=sto_time(seconds);
            (*i).new_user++;
        }
    }
    // can_send_unknown
    if((*i).new_user==58) {
        if(!(*i).access_grant_can_send_unknown_users) {
            (*i).user_channel.can_send_unknown_users=false;
            (*i).new_user=300;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,475)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==59) {
        string p=dcc_get_line((*i).in_buff);
        if(p.empty())
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,475)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).user_channel.can_send_unknown_users=false;
            } else {
                (*i).user_channel.can_send_unknown_users=true;
            }
            (*i).new_user=300;
        }
        return;
    }

    if((*i).new_user==100) {
        if(!(*i).access_grant_backup) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,168)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==101) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_backup=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_backup=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==102) {
        if(!(*i).access_grant_rehash) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,169)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==103) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_rehash=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_rehash=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==104) {
        if(!(*i).access_grant_backup) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,170)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==105) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_backup=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_backup=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
}

MY_STATIC void dcc_loop_new_user_c(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    if((*i).new_user==106) {
        if(!(*i).access_grant_rehash) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,171)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==107) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_rehash=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_rehash=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==108) {
        if(!(*i).access_grant_plususer) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,189)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==109) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_plususer=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_plususer=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==110) {
        if(!(*i).access_grant_plususer) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,190)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==111) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_plususer=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_plususer=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==112) {
        if(!(*i).access_grant_plusproc) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,197)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==113) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_plusproc=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_plusproc=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==114) {
        if(!(*i).access_grant_plusproc) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,198)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==115) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_plusproc=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_plusproc=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==116) {
        if(!(*i).access_grant_replication) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,210)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==117) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_replication=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_replication=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==118) {
        if(!(*i).access_grant_replication) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,600)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==119) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_replication=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_replication=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==120) {
        if(!(*i).access_grant_restart) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,260)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==121) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_restart=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_restart=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==122) {
        if(!(*i).access_grant_restart) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,261)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==123) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_restart=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_restart=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==124) {
        if(!(*i).access_grant_die) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,267)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==125) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_die=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_die=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==126) {
        if(!(*i).access_grant_die) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,268)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==127) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_die=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_die=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==128) {
        if(!(*i).access_grant_filesystem) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,276)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==129) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_filesystem=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_filesystem=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }
    if((*i).new_user==130) {
        if(!(*i).access_grant_filesystem) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,277)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==131) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_filesystem=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_filesystem=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==132) {
        (*i).new_user++;
    }

    if((*i).new_user==133) {
        if(!(*i).access_grant_private) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,406)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==134) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_private=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_private=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==135) {
        if(!(*i).access_grant_private) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,407)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==136) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_private=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_private=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==137) {
        if(!(*i).access_grant_upgrade) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,625)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==138) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_upgrade=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_upgrade=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==139) {
        if(!(*i).access_grant_upgrade) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,626)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==140) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_upgrade=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_upgrade=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    //---
    if((*i).new_user==141) {
        if(!(*i).access_grant_apply) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,680)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==142) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_apply=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_apply=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==143) {
        if(!(*i).access_grant_apply) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,681)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==144) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_apply=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_apply=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==145) {
        (*i).new_user++;
        return;
    }

    //---------------
    if((*i).new_user==146) {
        if(!(*i).access_grant_can_send_all_users) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,477)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==147) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_to_can_send_all_users=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_to_can_send_all_users=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==148) {
        if(!(*i).access_grant_can_send_all_users) {
            (*i).new_user+=2;
            return;
        }
        ec=0;

        disp=lang_get_string(1,(*i).lang,478)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==149) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare("y") || !p.compare("Y")) {
            got=true;
            (*i).user_access_grant_can_send_all_users=true;
        }
        if(!p.compare("n") || !p.compare("N")) {
            got=true;
            (*i).user_access_grant_can_send_all_users=false;
        }
        got?(*i).new_user++:(*i).new_user--;
    }

    if((*i).new_user==150) {
        disp=lang_get_string(1,(*i).lang,44)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        vector<string>::iterator i1;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1) {
            disp=*i1+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }
        disp=lang_get_string(1,(*i).lang,45)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user=8;
        return;
    }

    if((*i).new_user==200) {
        disp=lang_get_string(1,(*i).lang,201)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).new_user++;
    }
    if((*i).new_user==201) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        got=false;
        if(!p.compare(".")) {
            got=false;
        } else {
            got=true;
            if(!p.compare("0"))
                p="0 0";
            string lines, seconds;
            int pos=0;
            for(unsigned int i1=0; i1<p.length(); ++i1) {
                if(p[i1]==0x20) {
                    pos++;
                    continue;
                }
                if(pos==0)
                    lines+=p[i1];
                if(pos==1)
                    seconds+=p[i1];
            }
            (*i).user_partyline_msg_flood.lines=stoui(lines);
            (*i).user_partyline_msg_flood.seconds=sto_time(seconds);
            (*i).new_user++;
            return;
        }
        if(!got)
            (*i).new_user=200;
        return;
    }
    if((*i).new_user==202) {
        (*i).new_user=100;
    }

    if((*i).new_user==300) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,211)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i1;
        for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1) {
            disp=*i1+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=lang_get_string(1,(*i).lang,125)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).user_channel_allow_dynamic.group="";
        (*i).user_channel_allow_dynamic.plus_modes="";
        (*i).user_channel_allow_dynamic.minus_modes="";

        (*i).new_user++;
        return;
    }
    if((*i).new_user==301) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            vector<string>::iterator i1;
            got=false;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                if(!p.compare(*i1))
                    got=true;
            if(got)
                disp=lang_get_string(1,(*i).lang,212)+eol;
                else
                disp=lang_get_string(1,(*i).lang,214)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            //p=(string)"\""+p+"\"";
            if(got) {
                (*i).user_channel_allow_dynamic.group=p;
                (*i).new_user++;
            }
        } else {
            (*i).new_user=304;
        }
    }
    if((*i).new_user==302) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare("."))
            p="";
        //p=(string)"\""+p+"\"";
        (*i).user_channel_allow_dynamic.plus_modes=p;

        ec=0;

        disp=lang_get_string(1,(*i).lang,213)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).new_user++;
    }
    if((*i).new_user==303) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(!p.compare("."))
            p="";
        //p=(string)"\""+p+"\"";
        (*i).user_channel_allow_dynamic.minus_modes=p;

        (*i).user_channel.allow_dynamic.push_back((*i).user_channel_allow_dynamic);

        (*i).new_user=300;
    }
    if((*i).new_user==304) {
        (*i).new_user=38;
    }
}

MY_STATIC void dcc_loop_new_user_d(vector<c_dcc_client>::iterator& i, string& eol)
{
    string disp;
    int ec=0;
    bool got=false;

    // on_notice
    if((*i).new_user==500) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,601)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,602)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==501) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_notice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_notice=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }

    // on_except
    if((*i).new_user==502) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,246)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,247)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==503) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_except)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_except=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_unexcept
    if((*i).new_user==504) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,248)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,249)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==505) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_unexcept)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_unexcept=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_invite
    if((*i).new_user==506) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,250)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,251)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==507) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_invite)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_invite=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_uninvite
    if((*i).new_user==508) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,252)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,253)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==509) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_uninvite)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_uninvite=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    // on_not_invited
    if((*i).new_user==510) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,254)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,255)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==511) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_not_invited)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_not_invited=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }

    // on_not_in_reop
    if((*i).new_user==512) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,594)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,595)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==513) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_not_in_reop)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_not_in_reop=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }

    // on_reop
    if((*i).new_user==514) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,596)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,597)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==515) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_reop)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_reop=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }

    // on_other_mode
    if((*i).new_user==516) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,564)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,565)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==517) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_other_mode)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_other_mode=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    if((*i).new_user==518) {
        (*i).new_user=10000;
    }

    // on_other_mode_mask
    if((*i).new_user==10000) {
        ec=0;

        disp=lang_get_string(1,(*i).lang,786)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,787)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_subst(lang_get_string(1,(*i).lang,54),(*i).user_channel.channel_name)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,56)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).new_user++;
    }
    if((*i).new_user==517) {
        if(!dcc_can_unassign(i,eol,(*i).user_channel.on_other_mode_mask)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,57)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            if(got)
                disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                disp=lang_get_string(1,(*i).lang,58)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_channel.on_other_mode_mask=p;
                else {
                    (*i).new_user--;
                    return;
                }
            (*i).new_user++;
        }
    }
    if((*i).new_user==10002) {
        (*i).new_user=44;
    }

    if((*i).new_user==1000 || (*i).new_user==1100) {
        if((*i).access_grant_partyline) {
            disp=lang_get_string(1,(*i).lang,542)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).new_user++;
        } else {
            (*i).new_user+=2;
        }
    }
    if((*i).new_user==1001 || (*i).new_user==1101) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,542)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                (*i).user_access_grant_partyline=false;
                (*i).new_user++;
                return;
            } else {
                (*i).user_access_grant_partyline=true;
                (*i).new_user++;
                return;
            }
        }
    }
    if((*i).new_user==1002) {
        (*i).new_user=100;
        return;
    }
    if((*i).new_user==1102) {
        (*i).new_user=200;
        return;
    }

    // access_usage_proc
    if((*i).new_user==1200) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;
        if(p.compare(".")) {
            vector<string>::iterator i1;
            got=false;
            for(i1=(*i).access_grant_groups.begin(); i1!=(*i).access_grant_groups.end(); ++i1)
                if(!p.compare(*i1))
                    got=true;
            if(got)
                disp=lang_get_string(1,(*i).lang,46)+eol;
                else
                disp=lang_get_string(1,(*i).lang,47)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            if(got)
                (*i).user_access_usage_proc_groups.push_back(p);
        } else {
            (*i).new_user=12;
            return;
        }
    }
}

