/***************************************************************************
                          dcc_loop_private.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_private.cpp,v 1.15 2008/03/25 12:04:26 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_private.cpp,v 1.15 2008/03/25 12:04:26 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to .private command
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_private(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).private_edit==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).private_edit==1) {
        (*i).private_=r_private;

        ec=0;
        disp=lang_get_string(1,(*i).lang,413)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,414)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==2) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_privmsg)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_privmsg="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_privmsg=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    if((*i).private_edit==3) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,605)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,607)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==4) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_notice)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_notice="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_notice=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    if((*i).private_edit==5) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,415)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,416)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==6) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_ctcp)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_ctcp="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_ctcp=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    if((*i).private_edit==7) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,667)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,668)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==8) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_filesys_got_new)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_filesys_got_new="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_filesys_got_new=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    if((*i).private_edit==9) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,669)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,670)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==10) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_fnc)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_fnc="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_fnc=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    if((*i).private_edit==11) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,671)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,672)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==12) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_broadcast)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_broadcast="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_broadcast=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    if((*i).private_edit==13) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,673)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,674)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==14) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_server_msg)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_server_msg="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_server_msg=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    // on_internal_event
    if((*i).private_edit==15) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,696)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        vector<string>::iterator i3;
        for(i3=(*i).access_usage_proc.begin(); i3!=(*i).access_usage_proc.end(); ++i3) {
            if(!(*i3).compare("*"))
                continue;
            disp=*i3+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        }

        disp=(string)"----------------"+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,697)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        disp=lang_get_string(1,(*i).lang,130)+eol;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==16) {
        if(!dcc_can_unassign(i,eol,(*i).private_.on_internal_event)) {
            ec=0;
            disp=lang_get_string(1,(*i).lang,592)+eol;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
            return;
        }

        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        vector<string>::iterator i1;
        got=false;
        for(i1=(*i).access_usage_proc.begin(); i1!=(*i).access_usage_proc.end(); ++i1)
            if(!(*i1).compare(p))
                got=true;
        if(!p.compare(".")) {
            got=true;
            disp=lang_get_string(1,(*i).lang,131)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).private_edit++;
        } else {
            if(!p.compare("..")) {
                (*i).private_.on_internal_event="";
                got=true;
                disp=lang_get_string(1,(*i).lang,132)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                (*i).private_edit++;
            } else {
                if(got)
                    disp=lang_get_string(1,(*i).lang,57)+eol;
                else
                    disp=lang_get_string(1,(*i).lang,58)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
                if(got)
                    (*i).private_.on_internal_event=p;
                else {
                    (*i).private_edit--;
                    return;
                }
                (*i).private_edit++;
            }
        }
    }

    // commit?
    if((*i).private_edit==17) {
        ec=0;
        disp=lang_get_string(1,(*i).lang,417)+eol; // !!!
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).private_edit++;
        return;
    }
    if((*i).private_edit==18) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,417)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        } else {
            if(!p.compare("n") || !p.compare("N")) {
                disp=lang_get_string(1,(*i).lang,70)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            } else {
                (*i).private_.last_changed=my_time(NULL);
                r_private=(*i).private_;
                disp=lang_get_string(1,(*i).lang,231)+eol;
                ec=0;
                dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            }
            (*i).private_edit=0;
            return;
        }
    }
}

