/***************************************************************************
                          dcc_loop_terminator.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: dcc_loop_terminator.cpp,v 1.15 2008/03/25 12:04:27 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Handles DCC / telnet communication
    \version $Id: dcc_loop_terminator.cpp,v 1.15 2008/03/25 12:04:27 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "dcc_internal.h"
#include "../utils/precomp.h"

/*!
    \brief Should be called in a loop to process .terminator commands in DCC CHAT/telnet connections
    \author VooDooMan
    \version 1
    \date 2004
    \param i Descriptor of remote connection
    \param eol End-of-line string
*/
void dcc_loop_terminator(vector<c_dcc_client>::iterator i, string& eol)
{
    if((*i).terminator==0)
        return;

    string disp;
    int ec=0;
    bool got=false;

    if((*i).terminator==1) {
        disp=lang_get_string(1,(*i).lang,456)+eol;

        vector<string>::iterator i1;
        for(i1=(*i).access_to_users_also_terminators.begin(); i1!=(*i).access_to_users_also_terminators.end(); ++i1) {
            c_user u;
            vector<c_channel> chs;
            logic_partyline_get_user(*i1,u,chs);

            if(u.terminator)
                disp+=lang_get_string(1,(*i).lang,458);
            else
                disp+=lang_get_string(1,(*i).lang,457);

            disp+=*i1+eol;
        }

        disp+=lang_get_string(1,(*i).lang,459)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

        (*i).terminator++;
        return;
    }

    if((*i).terminator==2) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(!p.compare(".")) {
            disp=lang_get_string(1,(*i).lang,460)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);

            (*i).terminator=0;
            return;
        }

        got=false;
        vector<string>::iterator i1;
        for(i1=(*i).access_to_users_also_terminators.begin(); i1!=(*i).access_to_users_also_terminators.end(); ++i1) {
            if(!(*i1).compare(p)) {
                got=true;
                break;
            }
        }

        if(!got) {
            disp=lang_get_string(1,(*i).lang,461)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            (*i).terminator=1;
            return;
        }

        (*i).terminator_user=p;
        (*i).terminator++;
        return;
    }

    if((*i).terminator==3) {
        disp=lang_get_string(1,(*i).lang,462)+eol;
        ec=0;
        dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
        (*i).terminator++;
        return;
    }

    if((*i).terminator==4) {
        string p=dcc_get_line((*i).in_buff);
        if(!p.compare(""))
            return;

        if(p.compare("y") && p.compare("n") && p.compare("Y") && p.compare("N")) {
            disp=lang_get_string(1,(*i).lang,462)+eol;
            ec=0;
            dcc_send_msg((*i).socket,disp,ec,(*i).ssl);
            return;
        } else {
            c_user u;
            vector<c_channel> chs;
            logic_partyline_get_user((*i).terminator_user,u,chs);
            logic_partyline_remove_user((*i).terminator_user);
            u.last_changed=my_time(NULL);

            if(!p.compare("y") || !p.compare("Y")) {
                u.terminator=true;
            } else {
                u.terminator=false;
            }
            logic_partyline_add_user(u,chs); // this func automatically clears/sets for channels terminator flag according to user.terminator flag, cool, isn't it? :)

            (*i).terminator=1;
            return;
        }
    }
}

