/***************************************************************************
                          debug2.h  -  description
                             -------------------
    begin                : Wed Oct 11 2006
    copyright            : (C) 2006-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: debug2.cpp,v 1.32 2008/07/02 09:35:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2006-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Performs wildcard matching speed tests
    \version $Id: debug2.cpp,v 1.32 2008/07/02 09:35:46 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>
#include <iostream>

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

#include "debug2.h"

#include "logic.h"
#include "threads.h"
#include "shared.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

MY_STATIC size_t do_test()
{
    deque<c_user>::reverse_iterator i1=r_users.rbegin();
    if(r_users.rend()==i1)
        return 0;

    vector<string>::iterator i2=(*i1).hostmask.begin();
    if((*i1).hostmask.end()==i2)
        return 0;
    string hm=*i2;

    i2=(*i1).fullname.begin();
    if((*i1).fullname.end()==i2)
        return 0;
    string fnm=*i2;

    size_t i3;
    string h;
    for(i3=0; i3<hm.length(); ++i3) {
        switch(hm[i3]) {
            case '#':
                h+="3";
                break;
            case '?':
                h+="x";
                break;
            case '*':
                h+="abcdefgh";
                break;
            default:
                h+=(string)""+hm[i3];
        }
    }

    string fn;
    for(i3=0; i3<fnm.length(); ++i3) {
        switch(fnm[i3]) {
            case '#':
                fn+="3";
                break;
            case '?':
                fn+="x";
                break;
            case '*':
                fn+="abcdefgh";
                break;
            default:
                fn+=(string)""+fnm[i3];
        }
    }

    string nick;
    for(i3=0; i3<h.length(); ++i3) {
        if('!'==h[i3])
            break;
        nick+=(string)""+h[i3];
    }
    i3++;

    string ident;
    for(; i3<h.length(); ++i3) {
        if('@'==h[i3])
            break;
        ident+=(string)""+h[i3];
    }
    i3++;

    string host;
    for(; i3<h.length(); ++i3) {
        host+=(string)""+h[i3];
    }

    threads_loop();

    {
        my_time_t now=my_time(NULL);
        while(my_time(NULL)==now) {
            ;
        }
    }

    size_t cnt=0;

    bool was_dns=true;

    my_time_t start=my_time(NULL);
    my_time_t last=start;
    while(my_time(NULL)<=start+30) {
        was_dns=true;
        string user=logic_find_user(nick,ident,host,fn,false,was_dns);
        cnt++;
        if(my_time(NULL)!=last) {
            last=my_time(NULL);
            threads_loop();
        }
    }

    return cnt;
}

void debug2_do_tests()
{
    size_t cnt;

    cout << "Executing for 30 seconds." << endl;

    cnt=do_test();

    cout << "Executed " << cnt << " times" << endl;

#ifdef _DEBUG
    // DEBUG: set breakpoint here!
    int x=0;
    x++;
#endif
}

