/***************************************************************************
                          c_expression.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_expression.cpp,v 1.17 2008/08/23 15:10:43 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_expression'
    \version $Id: c_expression.cpp,v 1.17 2008/08/23 15:10:43 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_expression.h"
#include "../microcode/c_micro_symbol_variable_table.h"
#include "../microcode/c_micro_symbol_variable_mapping.h"
#include "../microcode/c_micro_func_call.h"
#include "../microcode/c_micro_ternary.h"
#include "../microcode/c_micro_return.h"
#include "../microcode/c_micro_log_or.h"
#include "../microcode/c_micro_log_and.h"
#include "../microcode/c_micro_jump.h"
#include "../runtime/c_eval_iteration.h"
#include "../microcode/c_micro_str_eval.h"
#include "../var/c_var_string.h"
#include "../var/c_var_unset.h"
#include "../microcode/c_micro_update.h"
#include "../microcode/c_micro_index.h"
#include "../microcode/c_micro_make_index_stream.h"
#include "../microcode/c_micro_assign.h"
#include "../microcode/c_micro_assign.h"
#include "../microcode/c_micro_bit_and.h"
#include "../microcode/c_micro_bit_or.h"
#include "../microcode/c_micro_bit_xor.h"
#include "../microcode/c_micro_cast_bool.h"
#include "../microcode/c_micro_cast_int.h"
#include "../microcode/c_micro_cast_string.h"
#include "../microcode/c_micro_commit_vars.h"
#include "../microcode/c_micro_concat.h"
#include "../microcode/c_micro_debug.h"
#include "../microcode/c_micro_div.h"
#include "../microcode/c_micro_equal.h"
#include "../microcode/c_micro_error.h"
#include "../microcode/c_micro_error_concat.h"
#include "../microcode/c_micro_error_divzero.h"
#include "../microcode/c_micro_error_except.h"
#include "../microcode/c_micro_error_except2.h"
#include "../microcode/c_micro_error_func.h"
#include "../microcode/c_micro_error_func_argc.h"
#include "../microcode/c_micro_error_func_builtin.h"
#include "../microcode/c_micro_error_func_internal_1.h"
#include "../microcode/c_micro_error_func_internal_2.h"
#include "../microcode/c_micro_error_func_internal_3.h"
#include "../microcode/c_micro_error_func_unknown.h"
#include "../microcode/c_micro_error_index.h"
#include "../microcode/c_micro_error_index_base_invalid.h"
#include "../microcode/c_micro_error_index_is_invalid.h"
#include "../microcode/c_micro_error_index_not_int.h"
#include "../microcode/c_micro_error_index_unset.h"
#include "../microcode/c_micro_error_invnum.h"
#include "../microcode/c_micro_error_keeper.h"
#include "../microcode/c_micro_error_lvalue.h"
#include "../microcode/c_micro_error_memory.h"
#include "../microcode/c_micro_error_notnum.h"
#include "../microcode/c_micro_error_notstring.h"
#include "../microcode/c_micro_error_symbol_index.h"
#include "../microcode/c_micro_error_unset.h"
#include "../microcode/c_micro_error_var_except.h"
#include "../microcode/c_micro_func_call.h"
#include "../microcode/c_micro_greater.h"
#include "../microcode/c_micro_greater_or_equal.h"
#include "../microcode/c_micro_identical.h"
#include "../microcode/c_micro_index.h"
#include "../microcode/c_micro_isset.h"
#include "../microcode/c_micro_jump.h"
#include "../microcode/c_micro_less.h"
#include "../microcode/c_micro_less_or_equal.h"
#include "../microcode/c_micro_log_and.h"
#include "../microcode/c_micro_log_or.h"
#include "../microcode/c_micro_make_index_stream.h"
#include "../microcode/c_micro_minus.h"
#include "../microcode/c_micro_mod.h"
#include "../microcode/c_micro_mul.h"
#include "../microcode/c_micro_not.h"
#include "../microcode/c_micro_not_equal.h"
#include "../microcode/c_micro_not_identical.h"
#include "../microcode/c_micro_one_compl.h"
#include "../microcode/c_micro_plus.h"
#include "../microcode/c_micro_post_decrement.h"
#include "../microcode/c_micro_post_increment.h"
#include "../microcode/c_micro_pre_decrement.h"
#include "../microcode/c_micro_pre_increment.h"
#include "../microcode/c_micro_return.h"
#include "../microcode/c_micro_set_lvalue.h"
#include "../microcode/c_micro_shift_left.h"
#include "../microcode/c_micro_shift_right.h"
#include "../microcode/c_micro_str_eval.h"
#include "../microcode/c_micro_symbol_table.h"
#include "../microcode/c_micro_symbol_variable_mapping.h"
#include "../microcode/c_micro_symbol_variable_table.h"
#include "../microcode/c_micro_ternary.h"
#include "../microcode/c_micro_update.h"
#include "expression/oper_prec.h"
#include "c_opers.h"
#include "../irc.h"

#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

void microcode_perform_updates(stack<c_eval_iteration>& st);
void microcode_update_variable(stack<c_eval_iteration>& st, var_sym_index_t id, const string& var_name);

c_expression::~c_expression()
{
    clean_up();
}

void c_expression::clean_up()
{
    next_exp="";
    clear_microcode();
}

bool c_expression::update_conditional(c_module* this_module, c_micro_error*& error, c_micro_symbol_table* symbols, c_micro* micro)
{
    var_sym_index_t res=micro->get_output();

    if(res!=VAR_SYM_INDEX_NONE && res!=VAR_SYM_INDEX_INVALID && res!=VAR_SYM_INDEX_DISCARD) {
        c_var_base* resv=NULL;
        bool lv;
        if(!symbols->get_var_table()->get(res,resv,lv,error))
            return false;

        const vector<var_sym_index_t>* outputs=NULL;

        if(typeid(c_micro_log_and)==typeid(*micro)) {
            outputs=&(dynamic_cast<c_micro_log_and*>(micro)->get_all_outputs());
        }
        if(typeid(c_micro_log_or)==typeid(*micro)) {
            outputs=&(dynamic_cast<c_micro_log_or*>(micro)->get_all_outputs());
        }

        vector<var_sym_index_t>::const_iterator i1;
        for(i1=outputs->begin(); i1!=outputs->end(); ++i1) {
            var_sym_index_t res2=*i1;
            if(res2==VAR_SYM_INDEX_NONE) {
                continue;
            }
            if(res!=res2) {
                c_var_base* resv2=resv->copy();
                if(!symbols->get_var_table()->set(res2,resv2,lv,error,micro->get_type(),false,this_module,"",debug))
                    return false;
            }
        }
    }
    return true;
}

bool c_expression::perform(c_module* this_module, c_var_array* vars, c_micro_error*& error, var_sym_index_t& sym_return, stack<c_eval_iteration>& st, c_micro_symbol_table* symbols)
{
    sym_return=VAR_SYM_INDEX_INVALID;

    error=NULL;

    for(;;) {
again:

        {
            enum {
                INSTR_CNT_TO_PROCESS_IRC = 200U,
            };
            static unsigned cnt=0;
            if((cnt++) % INSTR_CNT_TO_PROCESS_IRC == 0) {
                irc_loop_heavy_time_consuming_operation("Still executing script...");
                my_sleep(-1);
            }
        }

        if(error) {
            var_oops(st.top().this_module_,__FILE__,__my_func__,error->get_msg(),debug);
            MY_DELETE(error);
            error=NULL;
        }

        map<instruct_id_t, c_micro*>::iterator mi=microcode.find(st.top().instruct_id);
        if(microcode.end()==mi) {
            st.top().is_return_=false;
            st.top().return_value=NULL;
            st.top().ok_fn=true;
            st.top().this_module_->drop_tmp_references();
            return true;
        }
        c_micro* m=(*mi).second;
        e_micro_type type=m->get_type();

#if 1==DEBUG_MICROCODE_EXEC_ECHO
        cout << "#" << st.top().instruct_id << " Microcode class: " << typeid(*m).name() << endl;
#endif

        switch(type) {
            case MICRO_STR_EVAL:
                {
                    c_micro_str_eval* mm=dynamic_cast<c_micro_str_eval*>(m);
                    const string& str=mm->get_input();
                    string res=var_eval_string_simple(st.top().this_module_,str,st.top().vars_,debug);
                    c_var_string* out=MY_NEW c_var_string(res);

                    if(symbols->get_var_table()->is_ro(mm->get_output())) {
                        var_oops(this_module,__FILE__,__my_func__,GET_STR_DEBUG_INFO_EX("Attemp to write to read-only variable"),debug);
                    }

                    if(!symbols->get_var_table()->set(mm->get_output(),out,false,error,mm->get_type(),false,this_module,"",debug)) {
                        MY_DELETE(out);
                        return false;
                    }

                    result=mm->get_output();
                }
                break;
            case MICRO_TERNARY:
                {
                    if(!m->perform(symbols,error,this_module,debug))
                        return false;
                    c_micro_ternary* mm=dynamic_cast<c_micro_ternary*>(m);
                    bool jump;
                    if(!mm->get_jump_over(symbols,error,jump))
                        return false;
                    if(jump) {
                        st.top().instruct_id=mm->get_false_jump();
                        goto again;
                    }
                }
                break;
            case MICRO_FUNC_CALL:
                {
                    st.top().instruct_id++;
                    c_micro_func_call* mm=dynamic_cast<c_micro_func_call*>(m);
                    error=NULL;
                    size_t s=st.size();
                    bool rc=mm->make_iteration(st,symbols,error,this_module,debug,vars,next_exp);
                    if(error) {
                        if(st.size()>s) {
                            if(st.top().fn_destroy) {
                                if(st.top().fn_destroy_mc)
                                    st.top().fn->clear_microcode();
                                st.top().fn->destroy(true);
                            }
                            st.pop();
                        }
                        return false;
                    }
                    if(rc)
                        return true;
                    result=mm->get_output();
                    goto iteration_again;
                }
                break;
            case MICRO_COMMIT_VARS:
                {
                    c_micro_symbol_variable_mapping* mapping=st.top().symbol_table_->get_variable_mapping();
                    const map<var_sym_index_t, string>& map_=mapping->get_var_mapping();

                    map<var_sym_index_t, string>::const_iterator i1;
                    for(i1=map_.begin(); i1!=map_.end(); ++i1) {
                        if(!(*i1).second.empty() && '$'==(*i1).second[0]) {
                            microcode_update_variable(st,(*i1).first,(*i1).second);
                        }
                    }
                }
                break;
            case MICRO_RETURN:
                {
                    microcode_perform_updates(st);
                    if(!m->perform(symbols,error,this_module,debug))
                        return false;
                    c_micro_return* mm=dynamic_cast<c_micro_return*>(m);
                    c_var_base* return_val=NULL;
                    sym_return=mm->get_return();
                    bool dummy_b;
                    if(VAR_SYM_INDEX_INVALID!=sym_return)
                        if(!symbols->get_var_table()->get(sym_return,return_val,dummy_b,error))
                            return false;
                    if(!return_val)
                        return_val=MY_NEW c_var_unset();
                    st.top().is_return_=true;
                    st.top().return_value=return_val;
                    st.top().retval=sym_return;
                    st.top().ok_fn=true;
                    st.top().this_module_->drop_tmp_references();
                    result=sym_return;
                    return true;
                }
                break;
            case MICRO_LOG_OR:
                {
                    c_micro_log_or* mm=dynamic_cast<c_micro_log_or*>(m);
                    if(!mm->is_just_check_first()) {
                        if(!m->perform(symbols,error,this_module,debug))
                            return false;
                        result=mm->get_output();
                        bool skip;
                        if(!mm->get_conditional(symbols,error,skip))
                            return false;
                        MY_ASSERT(mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID);
                        if(skip && mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID) {
                            st.top().instruct_id=mm->get_cond_eval_jump();
                            if(!update_conditional(this_module,error,symbols,mm))
                                return false;
                            goto again;
                        }
                    } else {
                        bool skip;
                        if(!mm->check_first(symbols,error,skip,this_module,debug))
                            return false;
                        result=mm->get_output();
                        MY_ASSERT(mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID);
                        if(skip && mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID) {
                            st.top().instruct_id=mm->get_cond_eval_jump();
                            if(!update_conditional(this_module,error,symbols,mm))
                                return false;
                            goto again;
                        }
                    }
                }
                break;
            case MICRO_LOG_AND:
                {
                    c_micro_log_and* mm=dynamic_cast<c_micro_log_and*>(m);
                    if(!mm->is_just_check_first()) {
                        if(!m->perform(symbols,error,this_module,debug))
                            return false;
                        result=mm->get_output();
                        bool skip;
                        if(!mm->get_conditional(symbols,error,skip))
                            return false;
                        MY_ASSERT(mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID);
                        if(skip && mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID) {
                            st.top().instruct_id=mm->get_cond_eval_jump();
                            if(!update_conditional(this_module,error,symbols,mm))
                                return false;
                            goto again;
                        }
                    } else {
                        bool skip;
                        if(!mm->check_first(symbols,error,skip,this_module,debug))
                            return false;
                        result=mm->get_output();
                        MY_ASSERT(mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID);
                        if(skip && mm->get_cond_eval_jump()!=INSTRUCT_ID_INVALID) {
                            st.top().instruct_id=mm->get_cond_eval_jump();
                            if(!update_conditional(this_module,error,symbols,mm))
                                return false;
                            goto again;
                        }
                    }
                }
                break;
            case MICRO_JUMP:
                {
                    if(!m->perform(symbols,error,this_module,debug))
                        return false;
                    c_micro_jump* mm=dynamic_cast<c_micro_jump*>(m);
                    MY_ASSERT(mm->get_jump_id()!=INSTRUCT_ID_INVALID);
                    st.top().instruct_id=mm->get_jump_id();
                    goto iteration_again;
                }
                break;
            case MICRO_UPDATE:
                {
                    c_micro_update* mm=dynamic_cast<c_micro_update*>(m);
                    deque<pair<var_id_t, string> >::iterator i1;
                    for(i1=st.top().updates.begin(); i1!=st.top().updates.end(); ++i1) {
                        if(mm->get_var()==(*i1).first)
                            break;
                    }
                    if(st.top().updates.end()==i1)
                        st.top().updates.push_back(make_pair(mm->get_var(),mm->get_var_name()));
                }
                break;
            default:
                if(!m->perform(symbols,error,this_module,debug))
                    return false;
                result=m->get_output();
                break;
        }
        ++st.top().instruct_id;
iteration_again:
        continue;
    }
    // NOTREACH
}

instruct_id_t c_expression::add_micro(c_micro* instr)
{
#if 1==DEBUG_MICROCODE_ADD_ECHO
    cout << "#" << next_id << " Added microcode class " << typeid(*instr).name() << endl;
#endif

    MY_ASSERT(instr);
#ifdef _DEBUG
    {
        map<instruct_id_t, c_micro*>::iterator i1;
        for(i1=microcode.begin(); i1!=microcode.end(); ++i1)
            if((*i1).second==instr)
                MY_ASSERT(0);
    }
#endif
    microcode.insert(make_pair(next_id,instr));
    return next_id++;
}

void c_expression::assign(c_module* this_module, const string& exp, const string& debug_, c_micro_symbol_variable_mapping& symbols, const string& next_expression, const string& debug_prefix)
{
    next_exp=next_expression;
    debug=debug_;
    try {
        c_tree_microcode tmc(exp,*this,symbols);
        tmc.process();

        vector<string> warns=tmc.get_warnings();

        if(tmc.has_error() || !warns.empty()) {
            if(warns.empty())
                warns.push_back(tmc.get_human_error());
            vector<string>::iterator i1;
            for(i1=warns.begin(); i1!=warns.end(); ++i1) {
                string user_error=exp;
                while(!user_error.empty() && (
                    '\x20'==user_error[0]
                    || '\r'==user_error[0]
                    || '\n'==user_error[0]
                    || '\t'==user_error[0]
                    )
                ) {
                    user_error.erase(0,1);
                }
                if(user_error.empty()) {
                    user_error="(an empty expression), ";
                    user_error+=debug_;
                }
                user_error=debug_prefix+user_error;

                if(tmc.has_error() && warns.end()-1==i1)
                    var_fatal(this_module,__FILE__,__my_func__,*i1,user_error);
                else {
                    var_oops(this_module,"Compile warning",*i1,user_error);
                }
            }
            if(tmc.has_error()) {
                ok=false;
                return;
            }
        }
        result=tmc.get_first_variable();
    } catch(c_var_exception& e) {
        e.print_oops_to_log(debug);
        ok=false;
        return;
    }
    ok=true;
}

c_expression::c_expression(c_module* this_module, const string& exp, const string& debug_, c_micro_symbol_variable_mapping& symbols, const string& next_expression)
{
    clear_microcode();
    next_id=0;
    assign(this_module,exp,debug_,symbols,next_expression,"");
    next_exp=next_expression;
}

void c_expression::clear_microcode()
{
    for(map<instruct_id_t, c_micro*>::iterator i=microcode.begin(); i!=microcode.end(); ++i)
        MY_DELETE((*i).second);
    microcode.clear();
    next_id=0;
}

c_expression::c_expression(const c_expression& orig)
{
    ok=orig.ok;
    debug=orig.debug;

    map<instruct_id_t, c_micro*>::const_iterator i1;
    for(i1=orig.microcode.begin(); i1!=orig.microcode.end(); ++i1)
        microcode.insert(make_pair((*i1).first,(*i1).second->copy()));

    next_id=orig.next_id;

    result=orig.result;

    next_exp=orig.next_exp;
}

c_expression& c_expression::operator=(const c_expression& orig)
{
    ok=orig.ok;
    debug=orig.debug;

    microcode=orig.microcode;

    next_id=orig.next_id;

    result=orig.result;

    next_exp=orig.next_exp;

    return *this;
}

void c_expression::optimize_output(const vector<var_sym_index_t>& inputs)
{
    map<instruct_id_t, c_micro*>::iterator i1;
    for(i1=microcode.begin(); i1!=microcode.end(); ++i1)
        (*i1).second->optimize_output(inputs);
}

void c_expression::add_inputs(vector<var_sym_index_t>& inputs)
{
    map<instruct_id_t, c_micro*>::iterator i1;
    for(i1=microcode.begin(); i1!=microcode.end(); ++i1)
        (*i1).second->add_inputs(inputs);
}

instruct_id_t c_expression::get_next_id()
{
    return next_id;
}

