/***************************************************************************
                          c_fn_cmd_continue.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_continue.cpp,v 1.14 2008/03/11 21:11:35 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_continue'
    \version $Id: c_fn_cmd_continue.cpp,v 1.14 2008/03/11 21:11:35 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_continue.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_continue::copy()
{
    c_fn_cmd_continue* x=MY_NEW c_fn_cmd_continue(_debug,_id);
    x->begin_iteration_command_id=begin_iteration_command_id;
    return x;
}

c_fn_cmd_continue::c_fn_cmd_continue(const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    begin_iteration_command_id=JUMP_ID_INVALID;
}

bool c_fn_cmd_continue::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_ID(begin_iteration_command_id);
    return false;
}

long c_fn_cmd_continue::get_begin_iteration_command_id()
{
    return begin_iteration_command_id;
}

void c_fn_cmd_continue::set_begin_iteration_command_id(long id)
{
    begin_iteration_command_id=id;
}

e_cmd_type c_fn_cmd_continue::get_type()
{
    return CMD_CONTINUE;
}

c_fn_cmd_continue::~c_fn_cmd_continue()
{
    clean_up();
    ;
}

c_fn_cmd_continue::c_fn_cmd_continue(const c_fn_cmd_continue& orig)
    : c_fn_cmd(orig)
{
    begin_iteration_command_id=orig.begin_iteration_command_id;
}

c_fn_cmd_continue& c_fn_cmd_continue::operator=(const c_fn_cmd_continue& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    begin_iteration_command_id=orig.begin_iteration_command_id;

    return *this;
}

void c_fn_cmd_continue::clean_up()
{
    ;
}

void c_fn_cmd_continue::add_inputs(vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

void c_fn_cmd_continue::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

