/***************************************************************************
                          c_fn_cmd_do.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_do.cpp,v 1.14 2008/03/11 21:11:35 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_do'
    \version $Id: c_fn_cmd_do.cpp,v 1.14 2008/03/11 21:11:35 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_do.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_do::copy()
{
    c_fn_cmd_do* x=MY_NEW c_fn_cmd_do(_debug,_id);
    x->end_loop_id=end_loop_id;
    return x;
}

c_fn_cmd_do::c_fn_cmd_do(const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    end_loop_id=JUMP_ID_INVALID;
}

bool c_fn_cmd_do::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_ID(end_loop_id);
    return false;
}

void c_fn_cmd_do::set_end_loop_id(long id)
{
    end_loop_id=id;
}

long c_fn_cmd_do::get_end_loop_id()
{
    return end_loop_id;
}

e_cmd_type c_fn_cmd_do::get_type()
{
    return CMD_DO;
}

c_fn_cmd_do::~c_fn_cmd_do()
{
    clean_up();
    ;
}

c_fn_cmd_do::c_fn_cmd_do(const c_fn_cmd_do& orig)
    : c_fn_cmd(orig)
{
    end_loop_id=orig.end_loop_id;
}

c_fn_cmd_do& c_fn_cmd_do::operator=(const c_fn_cmd_do& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    end_loop_id=orig.end_loop_id;

    return *this;
}

void c_fn_cmd_do::clean_up()
{
    ;
}

void c_fn_cmd_do::add_inputs(vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

void c_fn_cmd_do::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

