/***************************************************************************
                          c_fn_cmd_do_while.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_do_while.cpp,v 1.14 2008/03/11 21:11:35 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_do_while'
    \version $Id: c_fn_cmd_do_while.cpp,v 1.14 2008/03/11 21:11:35 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_do_while.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_do_while::copy()
{
    return MY_NEW c_fn_cmd_do_while(MY_NEW c_expression(*_exp),_again_jump_id,_debug,_id);
}

c_fn_cmd_do_while::c_fn_cmd_do_while(c_expression* exp, long again_jump_id, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    _exp=exp;
    _again_jump_id=again_jump_id;
}

bool c_fn_cmd_do_while::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_ID(_again_jump_id);
    CHECK_EXP(_exp);
    return false;
}

c_expression* c_fn_cmd_do_while::get_exp()
{
    return _exp;
}

long c_fn_cmd_do_while::get_again_jump_id()
{
    return _again_jump_id;
}

e_cmd_type c_fn_cmd_do_while::get_type()
{
    return CMD_DO_WHILE;
}

c_fn_cmd_do_while::~c_fn_cmd_do_while()
{
    clean_up();
    _exp->clean_up();
    MY_DELETE(_exp);
}

c_fn_cmd_do_while::c_fn_cmd_do_while(const c_fn_cmd_do_while& orig)
    : c_fn_cmd(orig)
{
    _exp=MY_NEW c_expression(*orig._exp);
    _again_jump_id=orig._again_jump_id;
}

c_fn_cmd_do_while& c_fn_cmd_do_while::operator=(const c_fn_cmd_do_while& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    _exp=MY_NEW c_expression(*orig._exp);
    _again_jump_id=orig._again_jump_id;

    return *this;
}

void c_fn_cmd_do_while::clean_up()
{
    _exp->clean_up();
}

void c_fn_cmd_do_while::add_inputs(vector<var_sym_index_t>& inputs)
{
    _exp->add_inputs(inputs);
}

void c_fn_cmd_do_while::optimize_output(const vector<var_sym_index_t>& inputs)
{
    _exp->optimize_output(inputs);
}

