/***************************************************************************
                          c_fn_cmd_exp.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_exp.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_exp'
    \version $Id: c_fn_cmd_exp.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_exp.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

e_cmd_type c_fn_cmd_exp::get_type()
{
    return CMD_EXP;
}

c_fn_cmd* c_fn_cmd_exp::copy()
{
    return MY_NEW c_fn_cmd_exp(MY_NEW c_expression(*_exp),_sub_exp,_debug,_id);
}

c_fn_cmd_exp::c_fn_cmd_exp(c_expression* exp, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    _exp=exp;
    _sub_exp="";
}

c_fn_cmd_exp::c_fn_cmd_exp(c_expression* exp, const string& sub_exp, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    _exp=exp;
    _sub_exp=sub_exp;
}

c_expression* c_fn_cmd_exp::get_exp()
{
    return _exp;
}

const string& c_fn_cmd_exp::get_sub_exp()
{
    return _sub_exp;
}

bool c_fn_cmd_exp::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_EXP(_exp);
    return false;
}

c_fn_cmd_exp::~c_fn_cmd_exp()
{
    clean_up();
    _exp->clean_up();
    MY_DELETE(_exp);
}

c_fn_cmd_exp::c_fn_cmd_exp(const c_fn_cmd_exp& orig)
    : c_fn_cmd(orig)
{
    _exp=MY_NEW c_expression(*orig._exp);
    _sub_exp=orig._sub_exp;
}

c_fn_cmd_exp& c_fn_cmd_exp::operator=(const c_fn_cmd_exp& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    _exp=MY_NEW c_expression(*orig._exp);
    _sub_exp=orig._sub_exp;

    return *this;
}

void c_fn_cmd_exp::clean_up()
{
    _exp->clean_up();
}

void c_fn_cmd_exp::add_inputs(vector<var_sym_index_t>& inputs)
{
    _exp->add_inputs(inputs);
}

void c_fn_cmd_exp::optimize_output(const vector<var_sym_index_t>& inputs)
{
    _exp->optimize_output(inputs);
}

