/***************************************************************************
                          c_fn_cmd_for_cond.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_for_cond.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_for_cond'
    \version $Id: c_fn_cmd_for_cond.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_for_cond.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_for_cond::copy()
{
    c_fn_cmd_for_cond* x=MY_NEW c_fn_cmd_for_cond(MY_NEW c_expression(*exp_cond),_debug,_id);
    x->false_jump_id=false_jump_id;
    x->iterative_exp_id=iterative_exp_id;
    return x;
}

c_fn_cmd_for_cond::c_fn_cmd_for_cond(c_expression* cond, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    exp_cond=cond;
    iterative_exp_id=false_jump_id=JUMP_ID_INVALID;
}

void c_fn_cmd_for_cond::set_false_jump_id(long id)
{
    false_jump_id=id;
}

long c_fn_cmd_for_cond::get_false_jump_id()
{
    return false_jump_id;
}

c_expression* c_fn_cmd_for_cond::get_exp()
{
    return exp_cond;
}

bool c_fn_cmd_for_cond::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_ID(false_jump_id);
    CHECK_ID(iterative_exp_id);
    CHECK_EXP(exp_cond);
    return false;
}

void c_fn_cmd_for_cond::set_iterative_exp_id(long id)
{
    iterative_exp_id=id;
}

long c_fn_cmd_for_cond::get_iterative_exp_id()
{
    return iterative_exp_id;
}

e_cmd_type c_fn_cmd_for_cond::get_type()
{
    return CMD_FOR_COND;
}

c_fn_cmd_for_cond::~c_fn_cmd_for_cond()
{
    clean_up();
    exp_cond->clean_up();
    MY_DELETE(exp_cond);
}

c_fn_cmd_for_cond::c_fn_cmd_for_cond(const c_fn_cmd_for_cond& orig)
    : c_fn_cmd(orig)
{
    exp_cond=MY_NEW c_expression(*orig.exp_cond);
    false_jump_id=orig.false_jump_id;
    iterative_exp_id=orig.iterative_exp_id;
}

c_fn_cmd_for_cond& c_fn_cmd_for_cond::operator=(const c_fn_cmd_for_cond& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    exp_cond=MY_NEW c_expression(*orig.exp_cond);
    false_jump_id=orig.false_jump_id;
    iterative_exp_id=orig.iterative_exp_id;

    return *this;
}

void c_fn_cmd_for_cond::clean_up()
{
    exp_cond->clean_up();
}

void c_fn_cmd_for_cond::add_inputs(vector<var_sym_index_t>& inputs)
{
    exp_cond->add_inputs(inputs);
}

void c_fn_cmd_for_cond::optimize_output(const vector<var_sym_index_t>& inputs)
{
    exp_cond->optimize_output(inputs);
}

