/***************************************************************************
                          c_fn_cmd_global.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_global.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_global'
    \version $Id: c_fn_cmd_global.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_global.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_global::copy()
{
    return MY_NEW c_fn_cmd_global(_vars,_debug,_id);
}

c_fn_cmd_global::c_fn_cmd_global(const vector<string>& var_names, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    _vars=var_names;
}

bool c_fn_cmd_global::sanity_check(string& msg)
{
    CHECK_ID(_id);
    return false;
}

vector<string> c_fn_cmd_global::get_var_names()
{
    return _vars;
}

e_cmd_type c_fn_cmd_global::get_type()
{
    return CMD_GLOBAL;
}

c_fn_cmd_global::~c_fn_cmd_global()
{
    clean_up();
    ;
}

c_fn_cmd_global::c_fn_cmd_global(const c_fn_cmd_global& orig)
    : c_fn_cmd(orig)
{
    _vars=orig._vars;
}

c_fn_cmd_global& c_fn_cmd_global::operator=(const c_fn_cmd_global& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    _vars=orig._vars;

    return *this;
}

void c_fn_cmd_global::clean_up()
{
    ;
}

void c_fn_cmd_global::add_inputs(vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

void c_fn_cmd_global::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

