/***************************************************************************
                          c_fn_cmd_goto.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_goto.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_goto'
    \version $Id: c_fn_cmd_goto.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_goto.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_goto::copy()
{
    c_fn_cmd_goto* x=MY_NEW c_fn_cmd_goto(_tag,_debug,_id);
    x->label_id=label_id;
    return x;
}

c_fn_cmd_goto::c_fn_cmd_goto(const string& tag, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    _tag=tag;
    label_id=JUMP_ID_INVALID;
}

bool c_fn_cmd_goto::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_ID(label_id);
    return false;
}

const string& c_fn_cmd_goto::get_tag()
{
    return _tag;
}

long c_fn_cmd_goto::get_label_id()
{
    return label_id;
}

void c_fn_cmd_goto::set_label_id(long id)
{
    label_id=id;
}

e_cmd_type c_fn_cmd_goto::get_type()
{
    return CMD_GOTO;
}

c_fn_cmd_goto::~c_fn_cmd_goto()
{
    clean_up();
    ;
}

c_fn_cmd_goto::c_fn_cmd_goto(const c_fn_cmd_goto& orig)
    : c_fn_cmd(orig)
{
    _tag=orig._tag;
    label_id=orig.label_id;
}

c_fn_cmd_goto& c_fn_cmd_goto::operator=(const c_fn_cmd_goto& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    _tag=orig._tag;
    label_id=orig.label_id;

    return *this;
}

void c_fn_cmd_goto::clean_up()
{
    ;
}

void c_fn_cmd_goto::add_inputs(vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

void c_fn_cmd_goto::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

