/***************************************************************************
                          c_fn_cmd_jump.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_fn_cmd_jump.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_fn_cmd_jump'
    \version $Id: c_fn_cmd_jump.cpp,v 1.14 2008/03/11 21:11:36 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_fn_cmd_jump.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_fn_cmd* c_fn_cmd_jump::copy()
{
    return MY_NEW c_fn_cmd_jump(jump_to_id,_debug,_id);
}

c_fn_cmd_jump::c_fn_cmd_jump(long jump_to, const string& debug, long id)
    : c_fn_cmd(debug,id)
{
    jump_to_id=jump_to;
}

long c_fn_cmd_jump::get_jump_to_id()
{
    return jump_to_id;
}

void c_fn_cmd_jump::set_jump_to_id(long id)
{
    jump_to_id=id;
}

bool c_fn_cmd_jump::sanity_check(string& msg)
{
    CHECK_ID(_id);
    CHECK_ID(jump_to_id);
    return false;
}

e_cmd_type c_fn_cmd_jump::get_type()
{
    return CMD_JMP;
}

c_fn_cmd_jump::~c_fn_cmd_jump()
{
    clean_up();
    ;
}

c_fn_cmd_jump::c_fn_cmd_jump(const c_fn_cmd_jump& orig)
    : c_fn_cmd(orig)
{
    jump_to_id=orig.jump_to_id;
}

c_fn_cmd_jump& c_fn_cmd_jump::operator=(const c_fn_cmd_jump& orig)
{
    _id=orig._id;
    _debug=orig._debug;

    jump_to_id=orig.jump_to_id;

    return *this;
}

void c_fn_cmd_jump::clean_up()
{
    ;
}

void c_fn_cmd_jump::add_inputs(vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

void c_fn_cmd_jump::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

