/***************************************************************************
                          c_foreach_refs.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_foreach_refs.h,v 1.14 2008/03/11 21:11:37 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_foreach_refs'
    \version $Id: c_foreach_refs.h,v 1.14 2008/03/11 21:11:37 ghostvoodooman Exp $
*/

#ifndef C_FN_CMD_FOREACH_REFS_H__
#define C_FN_CMD_FOREACH_REFS_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../var/c_var_array.h"

/*!
    \brief Stores information referenced foreach() $e variables
    \author VooDooMan
    \version 1
    \date 2005
*/
class c_foreach_refs
{
    vector<string> val_vars;                //!< List of referenced variables

public:
    /*!
        \brief Sets new referenced variable
        \author VooDooMan
        \version 1
        \date 2005
        \param val_var Name of variable
    */
    void push(const string& val_var);

    /*!
        \brief Deletes referenced variable
        \author VooDooMan
        \version 1
        \date 2005
        \param vars Caller's variables
    */
    void pop(c_var_array* vars);
};

#endif

