/***************************************************************************
                          c_func_arg.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_func_arg.h,v 1.14 2008/03/11 21:11:37 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_func_arg'
    \version $Id: c_func_arg.h,v 1.14 2008/03/11 21:11:37 ghostvoodooman Exp $
*/

#ifndef C_FUNC_ARG_H__
#define C_FUNC_ARG_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../microcode_shared.h"
#include "../var/c_var_array.h"

class c_var_base;

/*!
    \brief Stores function's argument
    \author VooDooMan
    \version 1
    \date 2005
*/
class c_func_arg
{
public:
    string arg_expression;              //!< Name of argument/variable
    bool reference;                     //!< true if it is a reference

    c_var_base* value;                  //!< Value
    var_sym_index_t value_sym;          //!< Index of variable in symbol table

    /*!
        \brief Cleans up
        \author VooDooMan
        \version 1
        \date 2005
    */
    void clear();

    c_func_arg();

    c_func_arg(const c_func_arg& orig);

    /*!
        \brief Process the reference
        \author VooDooMan
        \version 1
        \date 2005
        \param function_vars Function's variables
        \param parent_vars Caller's variables
    */
    void process_reference(c_var_array* function_vars, c_var_array* parent_vars);
};

#endif

