/***************************************************************************
                          identd.h  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: identd.h,v 1.44 2008/03/11 21:11:28 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Emulates Ident daemon
    \version $Id: identd.h,v 1.44 2008/03/11 21:11:28 ghostvoodooman Exp $
*/

#ifndef IDENTD_H__
#define IDENTD_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

bool identd_startup(in_addr bind, unsigned short port); // returns false for error
bool identd_startup(char* bind_ipv6, unsigned short port);
bool identd_check(const string& ident_string, unsigned short local_port, unsigned short remote_port); // returns true if response was sent
void identd_shutdown();
void identd4_shutdown();
void identd6_shutdown();
void identd_renew();

#endif
