/***************************************************************************
                          internal_state.h  -  description
                             -------------------
    begin                : Sun Mar 9 2008
    copyright            : (C) 2005-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: internal_state.h,v 1.6 2008/08/23 15:10:40 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides externals of internal state information
    \version $Id: internal_state.h,v 1.6 2008/08/23 15:10:40 ghostvoodooman Exp $
*/

#ifndef INTERNAL_STATE_H__
#define INTERNAL_STATE_H__

#include "compat.h"

struct c_005;
class c_module;
struct c_msg_to_server;
class c_pass;
class c_pattern_cache;
class c_php_modifiers;
struct c_private;
struct c_socket;
class c_ssl;
class c_ssl_conf;
class c_var_array;
class c_dcc_client_to_resume;
class c_dcc_client;
class c_dcc_request_whois;
class c_dcc_send_file;
class c_dcc_server;
struct c_delay_command;
class c_delay_link;
class c_channel_def;
class c_channel;
class c_irc_server;
struct c_online_channel;
class c_telnet_server;
class c_user_to_lag;
class c_user_to_lock_out;
class c_var_keeper;
class c_dcc_awaiting_user;
class c_tmp_file;
struct c_nick_to_lag;

typedef MY_U_LONG_LONG log_client_id_t;     //!< Client ID
typedef unsigned long session_id_t;         //!< Session ID type (for variables)

extern bool dcc_killing_ssl;
extern bool into_whois_burst;
extern bool irc_follow_redirs;
extern bool irc_keepalive_sent;
extern bool irc_nick_confirmed;
extern bool irc_ssl;
extern bool overwrite_pid;
extern bool protect_pid;
extern bool was_whois_burst;
extern c_005 irc_isupport;
extern c_module* core_mod;
extern c_msg_to_server last_msg;
extern c_pass conf_pass;
extern c_pattern_cache g_pcre;
extern c_php_modifiers g_php_modifiers;
extern c_private r_private;
extern c_socket irc_socket;
extern c_socket* dcc_killing_user_socket;
extern c_ssl* dcc_killing_ssl_hnd;
extern c_ssl_conf ssl_conf;
extern c_var_array* super_global;
extern string botnet_botname;
extern int conf_umask;
extern int last_nick_idx;
extern log_client_id_t dcc_last_client_id;
extern map<int,string> severity_codes;
extern session_id_t last_session;
//extern ssl_handle irc_ssl_connection;
extern string binary_name;
extern string dcc_killing_user_eol;
extern string dcc_killing_user_lang;
extern string event_id;
extern string ident_string;
extern string irc_fullname;
extern string irc_host;
extern string irc_ident;
extern string irc_ip4;
extern string irc_ip6;
extern string irc_nick;
extern string irc_recommended_server;
extern string irc_server_host;
extern string irc_ssl_section;
extern string irc_unique_id;
extern my_time_t irc_last_keepalive_detection;
extern my_time_t last_autobackup;
extern my_time_t last_new_instance_join;
extern unsigned char tolowertab[];
extern unsigned char tolowertab_rfc1459[];
extern unsigned char tolowertab_ascii[];
extern unsigned char touppertab[];
extern unsigned short irc_recommended_port;
extern unsigned short irc_server_port;
extern vector<c_dcc_client_to_resume> dcc_to_resume;
extern vector<c_dcc_client> dcc_clients;
extern vector<c_dcc_request_whois> dcc_request_whois;
extern vector<c_dcc_send_file> dcc_awaiting_send;
extern vector<c_dcc_server> dcc_servers;
extern vector<c_delay_command> delay_commands;
extern vector<c_delay_link> botnet_delay_link;
extern vector<string> r_all_groups;
extern vector<c_channel_def> r_channel_defs;
extern vector<c_channel> r_channel_templates;
extern vector<c_channel> r_channel_terminators;
extern vector<c_channel> r_channels;
extern vector<c_irc_server> irc_servers;
extern vector<c_irc_server>::iterator irc_server_iterator;
extern vector<c_module*> modules;
extern vector<c_online_channel> irc_channels;
extern vector<c_telnet_server> telnet_servers;
extern vector<c_user_to_lag> users_to_lag;
extern vector<c_user_to_lock_out> dcc_users_to_lock_out;
extern vector<session_id_t> sessions;
extern vector<string> irc_nicks;
extern c_var_keeper* var_keeper;
extern bool log_cumul;
extern vector<c_dcc_awaiting_user> dcc_awaiting_users;
extern list<string> msgs_from_server;
extern vector<c_tmp_file> tmp_files_garbage;
extern vector<c_nick_to_lag> nicks_to_lag;

#include "casemap.h"

extern e_casemap irc_casemapping;

#endif

