/***************************************************************************
                          c_flood_history.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_flood_history.h,v 1.15 2008/03/25 12:04:27 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_flood_history'
    \version $Id: c_flood_history.h,v 1.15 2008/03/25 12:04:27 ghostvoodooman Exp $
*/

#ifndef C_FLOOD_HISTORY_H__
#define C_FLOOD_HISTORY_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Stores statistics entry for flood detection
    \author VooDooMan
    \version 1
    \date 2004
*/
class c_flood_history
{
public:
    my_time_t time;                        //!< Time of origin of this entry
    size_t bytes;                       //!< Number of bytes in the message
    string msg;                         //!< Received message (only used for repeat_flood)

    c_flood_history();
};

#endif

