/***************************************************************************
                          c_online_channel.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_online_channel.h,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_online_channel'
    \version $Id: c_online_channel.h,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $
*/

#ifndef C_ONLINE_CHANNEL_H__
#define C_ONLINE_CHANNEL_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "c_online_user.h"

/*!
    \brief Stores channels information on wich the bot is
    \author VooDooMan
    \version 2
    \date 2004, 2008-03-09
*/
struct c_online_channel
{
    string name;                                //!< Name of channel

    string modes;                               //!< Channel modes
    string topic;                               //!< Channel's topic
    string key;                                 //!< Channel's key (or an empty string for none)
    string limit;                               //!< Channel's limit (or an empty string for none)

    bool b_excepts_sent;                        //!< Have we sent "MODE #channel +e" yet?
    bool b_invites_sent;                        //!< Have we sent "MODE #channel +I" yet?
    bool b_bans_sent;                           //!< Have we send "MODE #channel +b" yet?
    bool b_reops_sent;                          //!< Have we sent "MODE #channel +R" yet?

    vector<c_online_user> users;                //!< List of users on this channel

    vector<string> bans;                        //!< List of ban masks
    bool got_excepts;                           //!< Have we got exceptions (+e) of bans? (MODE \#channel +e) - NOTE: even if irc network doesn't support +e exceptions, this is set to true if error response was sent by server to command MODE \#channel +e
    vector<string> excepts;                     //!< If got_excepts == true: list of +e exceptions - NOTE: clear, if irc network doesn't support +e exceptions to bans

    bool got_invites;                           //!< Have we got invitations (+I)?
    vector<string> invites;                     //!< List of invitations (+I)

    bool got_reops;                             //!< Have we got reop hints (+R)?
    vector<string> reops;                       //!< List of reop hints (+R)

    map<char,string> other_modes;               //!< Other modes (for exotic IRC servers)

    c_online_channel();

    c_online_channel(const string& channel_name);
};

#endif

