/***************************************************************************
                          irc_bot.h  -  description
                             -------------------
    begin                : Fri Sep 7 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: irc_bot.h,v 1.12 2008/03/11 21:11:29 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Header file for main file containing entry point
    \version $Id: irc_bot.h,v 1.12 2008/03/11 21:11:29 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#ifndef IRC_BOT_H__
#define IRC_BOT_H__

/*!
    \def RC_BOT_DIE
    \brief Bot requests to die (exit code)
*/
#define RC_BOT_DIE              (0U)
/*!
    \def RC_BOT_ERROR
    \brief Bot requests restart due to internal error (exit code)
*/
#define RC_BOT_ERROR            (1U)
/*!
    \def RC_BOT_RESTART
    \brief Bot requests restart from parent process (exit code)
*/
#define RC_BOT_RESTART          (2U)
/*!
    \def RC_BOT_SELF_TEST_ERROR
    \brief Bot requests restart from parent process (exit code)
*/
#define RC_BOT_SELF_TEST_ERROR  (3U)

//

long get_wall_clock();
void my_sleep(int ms);
string get_bot_version();
void closeall(int fd);
void do_work();
void do_idle();

#endif  // IRC_BOT_H__

