/***************************************************************************
                          jenkins_hash.h  -  description
                             -------------------
    begin                : Thu Oct 12 2006
    copyright            : (C) 2006-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: jenkins_hash.h,v 1.32 2008/11/24 12:09:23 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2006-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements interface to Jenkins hash algorithm
    \version $Id: jenkins_hash.h,v 1.32 2008/11/24 12:09:23 ghostvoodooman Exp $
*/

#ifndef JENKINS_H__
#define JENKINS_H__

#include "utils/prologue.h"

#include "utils/my_inttypes.h"

#if !defined(HAVE_CONFIG_H)
#   define uint32_t     uint32
#   define uint8_t      unsigned char
#   define uint16_t     unsigned short
#endif

#if BITS==64
    // 64 bit
#   if defined(WORDS_BIGENDIAN)
#       define jenkins_hash     hash
#   else
#       define jenkins_hash     hash3
#   endif
    typedef  unsigned long  long ub8;   /* unsigned 8-byte quantities */
    typedef  unsigned       int  ub4;   /* unsigned 4-byte quantities */
    ub8 hash(register const unsigned char *k, register ub8  length, register ub8  level);
    ub8 hash3(register const unsigned char *k, register ub8  length, register ub8  level);
#else
    // 32 bit
#   if defined(WORDS_BIGENDIAN)
#       define jenkins_hash     hashbig
#   else
#       define jenkins_hash     hashlittle
#   endif
    uint32_t hashlittle( const void *key, size_t length, uint32_t initval);
    uint32_t hashbig( const void *key, size_t length, uint32_t initval);
#endif

#endif

