/***************************************************************************
                          c_logger.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_logger.cpp,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_logger'
    \version $Id: c_logger.cpp,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "c_logger.h"
#include "../compat.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_logger::c_logger(const string& dir_global_logs, const string& dir_module_logs, const string& custom_log_name, int default_scope, c_conf* global_conf, c_conf* module_conf)
    : dir_global_logs_(dir_global_logs), dir_module_logs_(dir_module_logs), custom_name(custom_log_name), default_scope_(default_scope), glob_conf(global_conf), mod_conf(module_conf),
    was_rotation(false)
{
    if(dir_global_logs_.length() && dir_global_logs_[dir_global_logs_.length()-1]!=FILE_SLASH_CH)
        dir_global_logs_+=FILE_SLASH;
    if(dir_module_logs_.length() && dir_module_logs_[dir_module_logs_.length()-1]!=FILE_SLASH_CH)
        dir_module_logs_+=FILE_SLASH;
}

c_logger::c_logger(const c_logger& orig)
{
    dir_global_logs_=orig.dir_global_logs_;
    dir_module_logs_=orig.dir_module_logs_;
    custom_name=orig.custom_name;
    default_scope_=orig.default_scope_;

    // do NOT copy-construct these 2 classes! just copy the pointers!
    glob_conf=orig.glob_conf;
    mod_conf=orig.mod_conf;

    was_rotation=orig.was_rotation;
}

void c_logger::init(const string& dir_global_logs, const string& dir_module_logs, const string& custom_log_name, int default_scope, c_conf* global_conf, c_conf* module_conf)
{
    dir_global_logs_=dir_global_logs;
    dir_module_logs_=dir_module_logs;
    custom_name=custom_log_name;

    if(dir_global_logs_.length() && dir_global_logs_[dir_global_logs_.length()-1]!=FILE_SLASH_CH)
        dir_global_logs_+=FILE_SLASH;
    if(dir_module_logs_.length() && dir_module_logs_[dir_module_logs_.length()-1]!=FILE_SLASH_CH)
        dir_module_logs_+=FILE_SLASH;

    default_scope_=default_scope;

    glob_conf=global_conf;
    mod_conf=module_conf;
}

