/***************************************************************************
                          log2.h  -  description
                             -------------------
    begin                : Mon Dec 25 2006
    copyright            : (C) 2006-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: log2.h,v 1.31 2008/03/11 21:11:29 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2006-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Defines enums and function prototypes for cumulative logs
    \version $Id: log2.h,v 1.31 2008/03/11 21:11:29 ghostvoodooman Exp $
*/

#ifndef LOG2_H__
#define LOG2_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"
#include "compat.h"

enum e_log_type
{
    E_LOG_CUSTOM,               //!< Module's custom (user's) log
    E_LOG_DEBUG,                //!< Debug log
    E_LOG_CHAN,                 //!< Channel log
    E_LOG_BOT,                  //!< Bot log
    E_LOG_IDENTD,               //!< IdentD log
    E_LOG_SSL,                  //!< SSL log
    E_LOG_IRC,                  //!< IRC log
    E_LOG_SOCKET,               //!< Debug log entry type
    E_LOG_BOTNET_DEBUG,         //!< Botnet debug log entry type
    E_LOG_BOTNET,               //!< Botnet log entry type
    E_LOG_IRC_BCAST,            //!< IRC oper broadcast log entry type
    E_LOG_CLIENTS,              //!< Cilents log entry type
    E_LOG_DEBUG_RPT,            //!< MY_RPTx macros log entry type
};

void log_init_cumulative_log();
MY_U_LONG_LONG log_get_next_event_id();
void log_cumulative(const MY_U_LONG_LONG event_id, const e_log_type type, const string& channel, const string& log);

#endif

