/***************************************************************************
                          c_private.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_private.h,v 1.15 2008/03/25 12:04:27 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_private'
    \version $Id: c_private.h,v 1.15 2008/03/25 12:04:27 ghostvoodooman Exp $
*/

#ifndef C_PRIVATE_H__
#define C_PRIVATE_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../botnet/c_replication.h"

/*!
    \brief Stores informations about what to do when someone sends query message
    \author VooDooMan
    \version 1
    \date 2004
*/
struct c_private
{
    vector<c_replication> replication;              //!< Informations of replication
    my_time_t last_changed;                            //!< Time of last change

    vector<string> groups;                          //!< Group membership

    string on_privmsg;                              //!< Event for private query
    string on_notice;                               //!< Event for private notice
    string on_ctcp;                                 //!< Event for private CTCP message
    string on_filesys_got_new;                      //!< Event to trigger when filesystem got new file / message
    string on_fnc;                                  //!< Event for Force Nick Change (for IRCnet)
    string on_broadcast;                            //!< Event for broadcast messages from IRC operators
    string on_server_msg;                           //!< Event for server messages
    string on_internal_event;                       //!< Event for server messages

    /*!
        \brief Cleans up
        \author VooDooMan
        \version 1
        \date 2005
    */
    void clear();

    c_private() { last_changed=0; }
};

#endif

