/***************************************************************************
                          c_smtp.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_smtp.h,v 1.14 2008/03/11 21:11:39 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_smtp'
    \version $Id: c_smtp.h,v 1.14 2008/03/11 21:11:39 ghostvoodooman Exp $
*/

#ifndef C_SMTP_H__
#define C_SMTP_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Stores data for sending an e-mail via SMTP protocol
    \author VooDooMan
    \version 1
    \date 2004
*/
class c_smtp
{
public:
    string server;                                  //!< Server's host
    unsigned short port;                            //!< Port (usually 25)
    string helo;                                    //!< "HELO xxx" string
    string mail_from;                               //!< "MAIL FROM: xxx" string
    string rcpt_to;                                 //!< "RCPT TO: xxx" string
    string data;                                    //!< Lines of message headers and body delimited with CR+LF
    list<string> data_lines;                        //!< Lines of message headers and body as array

    c_smtp();

    void clear();
};

#endif

