/***************************************************************************
                          c_user.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_user.cpp,v 1.14 2008/03/11 21:11:39 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_user'
    \version $Id: c_user.cpp,v 1.14 2008/03/11 21:11:39 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_user.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_user::c_user()
{
    host_unknown=false;
    is_template=false;
    access_to_can_send_all_users=false;
    access_grant_can_send_all_users=false;
    access_grant_partyline=false;
    access_to_backup=false;
    access_grant_backup=false;
    access_to_rehash=false;
    access_grant_rehash=false;
    access_to_plususer=false;
    access_grant_plususer=false;
    access_to_plusproc=false;
    access_grant_plusproc=false;
    access_to_replication=false;
    access_grant_replication=false;
    access_to_restart=false;
    access_grant_restart=false;
    access_to_die=false;
    access_grant_die=false;
    access_to_partyline=false;
    last_changed=0;
    replication_partner=false;
    access_to_private=false;
    access_grant_private=false;
    terminator=false;
    access_to_can_send_unknown_users=false;
    access_grant_can_send_unknown_users=false;
    access_to_upgrade=access_grant_upgrade=false;
}

void c_user::clear()
{
    name="";
    host_unknown=false;
    is_template=false;
    hostmask.clear();
    fullname.clear();
    meta.clear();
    access_to_can_send_all_users=false;
    access_grant_can_send_all_users=false;
    access_to_group.clear();
    access_to_proc.clear();
    access_usage_procedure.clear();
    access_grant_procedure.clear();
    access_grant_group.clear();
    access_to_channel.clear();
    access_grant_channel.clear();
    access_grant_partyline=false;
    access_to_backup=false;
    access_grant_backup=false;
    access_to_rehash=false;
    access_grant_rehash=false;
    access_to_plususer=false;
    access_grant_plususer=false;
    access_to_plusproc=false;
    access_grant_plusproc=false;
    access_to_replication=false;
    access_grant_replication=false;
    access_to_restart=false;
    access_grant_restart=false;
    access_to_die=false;
    access_grant_die=false;
    access_to_partyline=false;
    groups.clear();
    dcc_hosts.clear();
    replication.clear();
    last_changed=0;
    replication_partner=false;
    access_to_private=false;
    access_grant_private=false;
    terminator=false;
    access_to_can_send_unknown_users=false;
    access_grant_can_send_unknown_users=false;
    access_to_upgrade=access_grant_upgrade=false;
}

