/***************************************************************************
                          logic_internal.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: logic_internal.h,v 1.15 2008/03/25 12:04:28 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Interface for compile and events
    \version $Id: logic_internal.h,v 1.15 2008/03/25 12:04:28 ghostvoodooman Exp $
*/

#ifndef C_LOGIC_INTERNAL_H__
#define C_LOGIC_INTERNAL_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../irc.h"

/*!
    \brief Stores information about usage of CTCP requests for nicks. Used for flood protection.
    \author VooDooMan
    \version 1
    \date 2004
*/
struct c_nick_to_lag
{
    string nick;                                //!< Nick of user
    int cnt;                                    //!< Number of CTCP requests
    my_time_t last_try;                            //!< Timestamp of last try from nick

    c_nick_to_lag() {
        cnt=0;
        last_try=0;
    }
};

string logic_eval_str(c_module* this_module, const string& str, const string& debug);
int logic_get_priority(const string& class_);
string logic_eval(c_module* this_module, const string& str, c_var_array* vars, const string& debug);
void logic_core_execute(const string& proc, vector<string>& args, const string& debug, size_t num_mandatory_args, const string& eid);
void logic_core_execute(const string& proc, vector<c_var_base*>& args, const string& debug, size_t num_mandatory_args, const string& eid);
string logic_get_severity_text(int code);
string logic_kill_EOLs(const string& str);

#endif

