/***************************************************************************
                          md5.h  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: md5.h,v 1.44 2008/03/11 21:11:31 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Based on code by Colin Plumb in 1993 and John Walker (public domain)
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)
  (re-coded from C to C++)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements MD5 algorithm
    \version $Id: md5.h,v 1.44 2008/03/11 21:11:31 ghostvoodooman Exp $
*/

#ifndef MD5_H__
#define MD5_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "utils/my_inttypes.h"

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

/*!
    \brief Stores MD5 context for computing
    \author VooDooMan
    \version 1
    \date 2004
*/
struct MD5Context
{
        uint32 buf[4];
        uint32 bits[2];
        unsigned char in[64];

      MD5Context()
      {
         memset(this,0,sizeof(*this));
      }
};

void MD5Init(MD5Context *ctx);
void MD5Update(MD5Context *ctx, unsigned char *buf, unsigned len);
void MD5Final(unsigned char digest[16], MD5Context *ctx);
void MD5Transform(uint32 buf[4], uint32 in[16]);

/*
 * This is needed to make RSAREF happy on some MS-DOS compilers.
 */
typedef struct MD5Context MD5_CTX_;

void byteReverse(unsigned char *buf, unsigned longs);

#endif /* !MD5_H */
