/***************************************************************************
                          heap_debug.h  -  description
                             -------------------
    begin                : Sun Jul 29 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: heap_debug.h,v 1.14 2008/11/24 12:09:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2005-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides interface of helper functions for debugging heap
    \version $Id: heap_debug.h,v 1.14 2008/11/24 12:09:46 ghostvoodooman Exp $
*/

#ifndef HEAP_DEBUG_H__
#define HEAP_DEBUG_H__

#include "../utils/prologue.h"

#include <new>              // size_t

void* my_malloc__(const char* fn, int ln, std::size_t size);
void* my_ex_malloc__(const char* fn, int ln, size_t size, bool sensitive, bool sparse);
void* my_realloc__(const char* fn, int ln, void* p, std::size_t size);
void my_free__(const char* fn, int ln, void* p);

void* operator new(std::size_t size, const char* fn, int ln);
void* operator new[](std::size_t size, const char* fn, int ln);

void operator delete(void* p, const char* fn, int ln);
void operator delete[](void* p, const char* fn, int ln);

#endif

