/***************************************************************************
                          heap_debug2.h  -  description
                             -------------------
    begin                : Mon Jul 30 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: heap_debug2.h,v 1.15 2008/11/24 12:09:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2005-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides interface of helper functions for debugging heap
    \version $Id: heap_debug2.h,v 1.15 2008/11/24 12:09:46 ghostvoodooman Exp $
*/

#ifndef HEAP_DEBUG2_H__
#define HEAP_DEBUG2_H__

#include "../utils/prologue.h"

#include <string>
#include <new>  // size_t

void heap_debug_init();
void heap_debug_dump(std::string& log);
void heap_debug_done(std::string& log);
void heap_debug_get_stats(MY_U_LONG_LONG& tran_cnt, MY_U_LONG_LONG& recreation_period, MY_U_LONG_LONG& errors, std::size_t& largest, std::size_t& total_bytes, MY_U_LONG_LONG& blocks_cnt, MY_U_LONG_LONG& recreation_cnt);

/*!
    \brief Implements reference counting if heap map recreation is possible
    \version 1
    \author VooDooMan
    \date 2008-03-13
*/
class c_heap_map_recreation_impossible
{
    static size_t m_ref_cnt;                    //!< If zero, it is possible

public:
    c_heap_map_recreation_impossible();
    ~c_heap_map_recreation_impossible();

    /*!
        \brief Retrieves status of heap map recreation possibility
        \version 1
        \author VooDooMan
        \date 2008-03-13
        \retval true Possible
        \retval false impossible
    */
    static bool is_possible();
};

#endif

