/***************************************************************************
                          hp_std.hh  -  description
                             -------------------
    begin                : Thu Oct 16 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: hp_std.hh,v 1.1 2008/11/24 12:09:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements HP-style placement-new constructors and destructor
            (they have gone from the STL standard)
    \author Kasper Peeters, VooDooMan, and possibly HP
    \version $Id: hp_std.hh,v 1.1 2008/11/24 12:09:46 ghostvoodooman Exp $
*/

//---------------------------------------------------------------------------

#ifndef HP_STD_HH__
#define HP_STD_HH__

#include "../utils/prologue.h"

// HP-style construct/destroy have gone from the standard,
// so here is a copy.

namespace hp_std
{

    template <class T1, class T2>
    MY_WISH_INLINE
    void constructor(T1* p, T2& val)
    {
        ::new ((void *) p) T1(val);
    }

    template <class T1>
    MY_WISH_INLINE
    void constructor(T1* p)
    {
        ::new ((void *) p) T1;
    }

#ifdef _MSC_VER
//  disable MSVC warning: warning C4100: 'p' : unreferenced formal parameter
//      (when class has no destructor)
#   pragma warning( push )
#   pragma warning( disable : 4100 )
#endif

    template <class T1>
    MY_WISH_INLINE
    void destructor(T1* p)
    {
        p->~T1();
    }

#ifdef _MSC_VER
//  disable MSVC warning: warning C4100: 'p' : unreferenced formal parameter
//      (when class has no destructor)
#   pragma warning( pop )
#endif

}

#endif

