/***************************************************************************
                          microcode.h  -  description
                             -------------------
    begin                : Thu Mar 16 2006
    copyright            : (C) 2006-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: microcode.h,v 1.37 2008/03/11 21:11:31 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2006-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides classes for microcode of functions
    \version $Id: microcode.h,v 1.37 2008/03/11 21:11:31 ghostvoodooman Exp $
*/

#ifndef MICROCODE_H__
#define MICROCODE_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include "utils.h"      // because we want to enable mem leak detection

#include "params.h"

#include <stdlib.h>
#if defined(HAVE_MALLOC_H)
#    include <malloc.h>
#endif

using namespace std;

#include "utils.h"      // because we want to enable mem leak detection

#include "shared.h"
#include "modules.h"
#include "microcode_shared.h"
#include "variable.h"
#include "utils/assert.h"
#include "var_except.h"
#include "var_keeper.h"
#include "microcode/c_micro_error.h"
#include "microcode/c_micro_error_keeper.h"
#include "microcode/c_micro_func_call.h"

class c_micro_symbol_table;

string get_oper_name(e_micro_type oper);

void microcode_perform_updates(stack<c_eval_iteration>& st);

void microcode_update_variable(stack<c_eval_iteration>& st, var_sym_index_t id, const string& var_name);

#endif

