/***************************************************************************
                          c_micro_array.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_array.cpp,v 1.14 2008/03/11 21:11:40 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_array'
    \version $Id: c_micro_array.cpp,v 1.14 2008/03/11 21:11:40 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_micro_array.h"
#include "../var/c_var_base.h"
#include "c_micro_symbol_variable_table.h"
#include "c_micro_error_unset.h"
#include "c_micro_symbol_variable_mapping.h"
#include "../var_except.h"
#include "c_micro_error_var_except.h"
#include "c_micro_error_except.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

bool c_micro_array::perform(c_micro_symbol_table* symbols, c_micro_error*& error, c_module* this_module, const string& debug)
{
    if(symbols->get_var_table()->is_ro(output_)) {
        var_oops(this_module,__FILE__,__my_func__,GET_STR_DEBUG_INFO_EX("Attemp to write to read-only variable"),debug);
    }

    c_var_array* value=MY_NEW c_var_array();
    if(!symbols->get_var_table()->set(output_,value,output_must_be_lvalue,error,get_type(),false,this_module,"",debug))
        return false;

    vector<pair<var_sym_index_t, var_sym_index_t> >::iterator i1;
    for(i1=args_.begin(); i1!=args_.end(); ++i1) {
        c_index_base* index_=NULL;
        c_var_base* val=NULL;
        bool dummy=false;
        if((*i1).first!=VAR_SYM_INDEX_INVALID) {
            c_var_base* index=NULL;
            if(!symbols->get_var_table()->get((*i1).first,index,dummy,error))
                return false;
            index_=index->make_index();
        } else {
            index_=value->get_new_int_index();
        }
        if(!symbols->get_var_table()->get((*i1).second,val,dummy,error)) {
            MY_DELETE(index_);
            return false;
        }
        try {
            value->set(this_module,index_,val->copy(),false,debug);
        } catch(c_var_exception e) {
            MY_DELETE(index_);
            error=MY_NEW c_micro_error_except((*i1).first,get_type(),symbols->get_variable_mapping()->get_var_name(output_));
            return false;
        }
    }

    return true;
}

c_micro_array::c_micro_array(const c_micro_array& orig)
    : c_micro(orig)
{
    args_=orig.args_;
    output_=orig.output_;
}

c_micro* c_micro_array::copy()
{
    return MY_NEW c_micro_array(*this);
}

var_sym_index_t c_micro_array::get_output()
{
    return output_;
}

void c_micro_array::add_inputs(vector<var_sym_index_t>& inputs)
{
    vector<pair<var_sym_index_t, var_sym_index_t> >::iterator i1;
    for(i1=args_.begin(); i1!=args_.end(); ++i1) {
        inputs.push_back((*i1).first);
        inputs.push_back((*i1).second);
    }
}

void c_micro_array::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

