/***************************************************************************
                          c_micro_assign.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_assign.cpp,v 1.14 2008/03/11 21:11:40 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_assign'
    \version $Id: c_micro_assign.cpp,v 1.14 2008/03/11 21:11:40 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_micro_assign.h"
#include "../var/c_var_base.h"
#include "c_micro_symbol_variable_table.h"
#include "c_micro_error_unset.h"
#include "c_micro_symbol_variable_mapping.h"
#include "../var_except.h"
#include "c_micro_error_var_except.h"
#include "../var/c_var_unset.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

bool c_micro_assign::perform(c_micro_symbol_table* symbols, c_micro_error*& error, c_module* this_module, const string& debug)
{
    c_var_base* value=NULL;
    bool lvalue;
    if(!symbols->get_var_table()->get(input_,value,lvalue,error))
        return false;
    if(!value)
        value=MY_NEW c_var_unset(); // it could be "return NULL;" from previous iteration
    if(!value /*|| value->get_var_type()==VARTYPE_UNSET*/) { // because it could be $x=NULL;
        error=MY_NEW c_micro_error_unset(input_,get_type(),symbols->get_variable_mapping()->get_var_name(input_));
        return false;
    }

    if(VAR_SYM_INDEX_DISCARD==output_)
        return true;

    if(symbols->get_var_table()->is_ro(output_)) {
        var_oops(this_module,__FILE__,__my_func__,GET_STR_DEBUG_INFO_EX("Attemp to write to read-only variable"),debug);
    } else {
        /*
        c_var_base* output=NULL;
        bool dummy_b;
        if(!symbols->get_var_table()->get(output_,output,dummy_b,error)) {
            return false;
        }
        */

        value=value->copy();

        if(!symbols->get_var_table()->set(output_,value,output_must_be_lvalue,error,get_type(),false,this_module,"",debug)) {
            MY_DELETE(value);
            return false;
        }
    }

    return true;
}

c_micro_assign::c_micro_assign(const c_micro_assign& orig)
    : c_micro(orig)
{
    input_=orig.input_;
    output_=orig.output_;
}

c_micro* c_micro_assign::copy()
{
    return MY_NEW c_micro_assign(*this);
}

var_sym_index_t c_micro_assign::get_output()
{
    return output_;
}

void c_micro_assign::add_inputs(vector<var_sym_index_t>& inputs)
{
    inputs.push_back(input_);
}

void c_micro_assign::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
    /*
    if(output_!=VAR_SYM_INDEX_NONE && output_!=VAR_SYM_INDEX_DISCARD &&
        output_!=VAR_SYM_INDEX_INVALID) {

        vector<var_sym_index_t>::const_iterator i1;
        for(i1=inputs.begin(); i1!=inputs.end(); ++i1) {
            if(*i1==output_)
                return;
        }
    } else
        return;

    // no reference
    output_=VAR_SYM_INDEX_DISCARD;
    */
}

