/***************************************************************************
                          c_micro_concat.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_concat.cpp,v 1.14 2008/03/11 21:11:40 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_concat'
    \version $Id: c_micro_concat.cpp,v 1.14 2008/03/11 21:11:40 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_micro_concat.h"
#include "../var/c_var_base.h"
#include "c_micro_symbol_variable_table.h"
#include "c_micro_error_unset.h"
#include "c_micro_symbol_variable_mapping.h"
#include "../var_except.h"
#include "c_micro_error_var_except.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

bool c_micro_concat::perform(c_micro_symbol_table* symbols, c_micro_error*& error, c_module* this_module, const string& debug)
{
    c_var_base* value1=NULL, *value2=NULL;
    bool lvalue;
    if(!symbols->get_var_table()->get(input1_,value1,lvalue,error))
        return false;
    if(!symbols->get_var_table()->get(input2_,value2,lvalue,error))
        return false;
    //
    if(!value1) {
        error=MY_NEW c_micro_error_unset(input1_,get_type(),symbols->get_variable_mapping()->get_var_name(input1_));
        return false;
    }
    if(!value2) {
        error=MY_NEW c_micro_error_unset(input2_,get_type(),symbols->get_variable_mapping()->get_var_name(input2_));
        return false;
    }
    c_var_base* out=NULL;
    try {
        out=&((*value1).concat(*value2));
    } catch(c_var_except* e) {
        error=MY_NEW c_micro_error_var_except(get_type(),e,input1_,symbols->get_variable_mapping()->get_var_name(input1_),input2_,symbols->get_variable_mapping()->get_var_name(input2_));
        return false;
    }
    if(!symbols->get_var_table()->set(output_,out,output_must_be_lvalue,error,get_type(),false,this_module,"",debug)) {
        return false;
    }
    /*
    if(!value1 || value1->get_var_type()==VARTYPE_UNSET) {
        error=MY_NEW c_micro_error_unset(input1_,get_type(),symbols->get_variable_mapping()->get_var_name(input1_));
        return false;
    }
    if(!value2 || value2->get_var_type()==VARTYPE_UNSET) {
        error=MY_NEW c_micro_error_unset(input2_,get_type(),symbols->get_variable_mapping()->get_var_name(input2_));
        return false;
    }

    if(value1->get_var_type()!=VARTYPE_STRING && value1->get_var_type()!=VARTYPE_INT && value1->get_var_type()!=VARTYPE_BOOL) {
        error=MY_NEW c_micro_error_concat(input1_,get_type(),symbols->get_variable_mapping()->get_var_name(input1_),value1->get_var_type_as_string());
        return false;
    }
    if(value2->get_var_type()!=VARTYPE_STRING && value2->get_var_type()!=VARTYPE_INT && value2->get_var_type()!=VARTYPE_BOOL) {
        error=MY_NEW c_micro_error_concat(input2_,get_type(),symbols->get_variable_mapping()->get_var_name(input2_),value2->get_var_type_as_string());
        return false;
    }

    bool created1=false, created2=false;

    if(value1->get_var_type()!=VARTYPE_STRING) {
        c_var_string* s=NULL;
        try {
            s=MY_NEW c_var_string(value1->to_string(this_module));
        } catch(c_var_exception e) {
            e.print_oops_to_log(debug);
            error=MY_NEW c_micro_error_except(input1_,get_type(),symbols->get_variable_mapping()->get_var_name(input1_));
            return false;
        }
        created1=true;
        value1=s;
    }
    if(value2->get_var_type()!=VARTYPE_STRING) {
        c_var_string* s=NULL;
        try {
            s=MY_NEW c_var_string(value2->to_string(this_module));
        } catch(c_var_exception e) {
            e.print_oops_to_log(debug);
            error=MY_NEW c_micro_error_except(input2_,get_type(),symbols->get_variable_mapping()->get_var_name(input2_));
            return false;
        }
        created2=true;
        value2=s;
    }

    c_var_string* s1=dynamic_cast<c_var_string*>(value1);
    c_var_string* s2=dynamic_cast<c_var_string*>(value2);
    c_var_string* so=MY_NEW c_var_string(s1->get()+s2->get());

    if(created1)
        MY_DELETE(value1);
    if(created2)
        MY_DELETE(value2);

    if(symbols->get_var_table()->is_ro(output_)) {
        var_oops(this_module,__FILE__,__my_func__,GET_STR_DEBUG_INFO_EX("Attemp to write to read-only variable"),debug);
    }

    if(!symbols->get_var_table()->set(output_,so,output_must_be_lvalue,error,get_type(),false,this_module,"",debug)) {
        MY_DELETE(so);
        return false;
    }
    */
    return true;
}

c_micro_concat::c_micro_concat(const c_micro_concat& orig)
    : c_micro(orig)
{
    input1_=orig.input1_;
    input2_=orig.input2_;
    output_=orig.output_;
    output_must_be_lvalue=orig.output_must_be_lvalue;
}

c_micro* c_micro_concat::copy()
{
    return MY_NEW c_micro_concat(*this);
}

var_sym_index_t c_micro_concat::get_output()
{
    return output_;
}

void c_micro_concat::add_inputs(vector<var_sym_index_t>& inputs)
{
    inputs.push_back(input1_);
    inputs.push_back(input2_);
}

void c_micro_concat::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
}

