/***************************************************************************
                          c_micro_error_except2.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_error_except2.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_error_except2'
    \version $Id: c_micro_error_except2.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $
*/

#ifndef C_MICRO_ERROR_EXCEPT2_H__
#define C_MICRO_ERROR_EXCEPT2_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "c_micro_error.h"
#include "../microcode_shared.h"

/*!
    \brief Error reporter class: exception thrown while processing operator with two operands
    \author VooDooMan
    \version 1
    \date 2006-03-16
*/
class c_micro_error_except2 : public c_micro_error
{
    var_sym_index_t index1_;                        //!< Left-hand side variable index
    var_sym_index_t index2_;                        //!< Right-hand side variable index
    e_micro_type oper_;                             //!< Operator
    string var_name1_;                              //!< Left-hand side variable name
    string var_name2_;                              //!< Right-hand side variable name

public:

    /*!
        \brief Constructor
        \author VooDooMan
        \version 1
        \date 2006-03-16
        \param index1 Erronous index (left-hand side)
        \param index2 Erronous index (right-hand side)
        \param oper Erroneous operator
        \param var_name1 Erronous variable name (left-hand side)
        \param var_name2 Erronous variable name (right-hand side)
    */
    c_micro_error_except2(var_sym_index_t index1, var_sym_index_t index2, e_micro_type oper, const string& var_name1, const string& var_name2)
        : c_micro_error(), index1_(index1), index2_(index2), oper_(oper), var_name1_(var_name1), var_name2_(var_name2)
    {
        ;
    }

    virtual ~c_micro_error_except2() { ; }

    string get_msg();
};

#endif

