/***************************************************************************
                          c_micro_error_func_builtin.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_error_func_builtin.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_error_func_builtin'
    \version $Id: c_micro_error_func_builtin.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $
*/

#ifndef C_MICRO_ERROR_FUNC_BUILTIN_H__
#define C_MICRO_ERROR_FUNC_BUILTIN_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"

#include "../params.h"

#include "c_micro_error.h"

#include "c_micro_error_func.h"

/*!
    \brief Error reporter base class: invalid built-in function call
    \author VooDooMan
    \version 1
    \date 2006-04-05
*/
class c_micro_error_func_builtin : public c_micro_error_func
{
protected:

    string error_message_;

public:

    /*!
        \brief Constructor
        \author VooDooMan
        \version 1
        \date 2006-04-05
        \param func_name Name of function
        \param message Error message
    */
    c_micro_error_func_builtin(const string& func_name, const string& message)
        : c_micro_error_func(func_name), error_message_(message)
    {
        ;
    }

    virtual ~c_micro_error_func_builtin() { ; }

    string get_msg();
};

#endif

