/***************************************************************************
                          c_micro_error_index_base_invalid.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_error_index_base_invalid.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_error_index_base_invalid'
    \version $Id: c_micro_error_index_base_invalid.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $
*/

#ifndef C_MICRO_ERROR_INDEX_BASE_INVALID_H__
#define C_MICRO_ERROR_INDEX_BASE_INVALID_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "c_micro_error_index.h"

/*!
    \brief Error reporter class: invalid index base variable (not ARRAY, nor STRING)
    \author VooDooMan
    \version 1
    \date 2006-03-31
*/
class c_micro_error_index_base_invalid : public c_micro_error_index
{
public:

    /*!
        \brief Constructor
        \author VooDooMan
        \version 1
        \date 2006-03-31
        \param base Base variable ID
        \param index Erronous index
        \param var_name_base Erronous variable name of base variable
        \param var_name_index Erronous variable name of index variable
    */
    c_micro_error_index_base_invalid(var_sym_index_t base, var_sym_index_t index, const string& var_name_base, const string& var_name_index)
        : c_micro_error_index(base,index,var_name_base,var_name_index)
    {
        ;
    }

    virtual ~c_micro_error_index_base_invalid() { ; }

    string get_msg();
};

#endif

