/***************************************************************************
                          c_micro_error_notstring.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_error_notstring.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_error_notstring'
    \version $Id: c_micro_error_notstring.h,v 1.14 2008/03/11 21:11:42 ghostvoodooman Exp $
*/

#ifndef C_MICRO_ERROR_NOTSTRING_H__
#define C_MICRO_ERROR_NOTSTRING_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "c_micro_error.h"
#include "../microcode_shared.h"

/*!
    \brief Error reporter class: it is not string, int, nor bool
    \author VooDooMan
    \version 1
    \date 2006-03-16
*/
class c_micro_error_notstring : public c_micro_error
{
    var_sym_index_t index_;                         //!< Erroneous index
    e_micro_type oper_;                             //!< Operator
    string var_name_;                               //!< Variable name
    string var_type_;                               //!< Erronous variable type

public:

    /*!
        \brief Constructor
        \author VooDooMan
        \version 1
        \date 2006-03-16
        \param index Erronous index
        \param oper Erroneous operator
        \param var_name Erronous variable name
        \param var_type Type of erroneous variable
    */
    c_micro_error_notstring(var_sym_index_t index, e_micro_type oper, const string& var_name, const string& var_type)
        : c_micro_error(), index_(index), oper_(oper), var_name_(var_name), var_type_(var_type)
    {
        ;
    }

    virtual ~c_micro_error_notstring() { ; }

    string get_msg();
};

#endif

