/***************************************************************************
                          c_micro_error_var_except.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_error_var_except.cpp,v 1.15 2008/11/24 12:09:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_error_var_except'
    \version $Id: c_micro_error_var_except.cpp,v 1.15 2008/11/24 12:09:46 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "c_micro_error_var_except.h"
#include "../var_except.h"
#include "../compat.h"
#include "../microcode.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_micro_error_var_except::c_micro_error_var_except(e_micro_type oper, c_var_except* e, var_sym_index_t input1, const string& var_name1)
    : c_micro_error(), oper_(oper)
{
    index_=VAR_SYM_INDEX_INVALID;
    MY_ASSERT(e);
    if(e) {
        except_msg=e->get_msg();
        if(e->get_bad_arg_num()==1) {
            index_=input1;
            var_name_=var_name1;
        } else {
            index_=VAR_SYM_INDEX_INVALID;
            var_name_="(N/A, operand#: ";
            var_name_+=tos(e->get_bad_arg_num());
            var_name_+=")";
        }
    } else {
        except_msg="(Internal error - PLEASE REPORT THIS PROBLEM, it is BUG! 'e'==NULL #1, class '";
        except_msg+=typeid(*this).name();
        except_msg+="'::";
        except_msg+=__my_func__;
        except_msg+=")";
        MY_ASSERT_NOTREACH();
    }
    MY_DELETE(e);
}

c_micro_error_var_except::c_micro_error_var_except(e_micro_type oper, c_var_except* e, var_sym_index_t input1, const string& var_name1, var_sym_index_t input2, const string& var_name2)
    : c_micro_error(), oper_(oper)
{
    index_=VAR_SYM_INDEX_INVALID;
    MY_ASSERT(e);
    if(e) {
        except_msg=e->get_msg();
        if(e->get_bad_arg_num()==1) {
            index_=input1;
            var_name_=var_name1;
        } else if(e->get_bad_arg_num()==2) {
            index_=input2;
            var_name_=var_name2;
        } else {
            index_=VAR_SYM_INDEX_INVALID;
            var_name_="(N/A, operand#: ";
            var_name_+=tos(e->get_bad_arg_num());
            var_name_+=")";
        }
    } else {
        except_msg="(Internal error - PLEASE REPORT THIS PROBLEM, it is BUG! 'e'==NULL #2, class '";
        except_msg+=typeid(*this).name();
        except_msg+="'::";
        except_msg+=__my_func__;
        except_msg+=")";
        MY_ASSERT_NOTREACH();
    }
    MY_DELETE(e);
}

string c_micro_error_var_except::get_msg()
{
    string msg="User error: Operator evaluation error for '";
    msg+=get_oper_name(oper_);
    msg+="' operator; Variable '";
    msg+=var_name_;
    msg+="'; ";
    msg+=except_msg;
    msg+="; Index #";
    msg+=tos(index_);
    msg+=" in symbol table for variables";
    return msg;
}

