/***************************************************************************
                          c_micro_error_var_except.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_error_var_except.h,v 1.14 2008/03/11 21:11:43 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_error_var_except'
    \version $Id: c_micro_error_var_except.h,v 1.14 2008/03/11 21:11:43 ghostvoodooman Exp $
*/

#ifndef C_MICRO_ERROR_VAR_EXCEPT_H__
#define C_MICRO_ERROR_VAR_EXCEPT_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "c_micro_error.h"
#include "../microcode_shared.h"
#include "../var_except.h"

/*!
    \brief Error reporter class: 'c_var_except' (or descendant class) exception was thrown
    \author VooDooMan
    \version 1
    \date 2007-01-15
*/
class c_micro_error_var_except : public c_micro_error
{
    var_sym_index_t index_;                         //!< Erroneous index
    e_micro_type oper_;                             //!< Operator
    string var_name_;                               //!< Variable name

    string except_msg;

public:

    /*!
        \brief Constructor (for use in operation with one operand)
        \author VooDooMan
        \version 1
        \date 2007-01-15
        \param oper Erroneous operator
        \param e Exception class that have been thrown (will be MY_DELETE'd)
        \param input1 Erronous index
        \param var_name1 Erronous variable name
        \warning Argument 'e' will be MY_DELETE'd
    */
    c_micro_error_var_except(e_micro_type oper, c_var_except* e, var_sym_index_t input1, const string& var_name1);

    /*!
        \brief Constructor (for use in operation with two operands)
        \author VooDooMan
        \version 1
        \date 2007-01-15
        \param oper Erroneous operator
        \param e Exception class that have been thrown (will be MY_DELETE'd)
        \param input1 (possibly) Erronous index
        \param var_name1 (possibly) Erronous variable name
        \param input2 (possibly) Erronous index
        \param var_name2 (possibly) Erronous variable name
        \warning Argument 'e' will be MY_DELETE'd
    */
    c_micro_error_var_except(e_micro_type oper, c_var_except* e, var_sym_index_t input1, const string& var_name1, var_sym_index_t input2, const string& var_name2);

    ~c_micro_error_var_except() { ; }

    string get_msg();
};

#endif

