/***************************************************************************
                          microcode_shared.h  -  description
                             -------------------
    begin                : Fri Mar 24 2006
    copyright            : (C) 2006-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: microcode_shared.h,v 1.32 2008/03/11 21:11:31 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2006-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Defines global shared definitions for microcode of functions
    \version $Id: microcode_shared.h,v 1.32 2008/03/11 21:11:31 ghostvoodooman Exp $
*/

#ifndef MICROCODE_SHARED_H__
#define MICROCODE_SHARED_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

/*!
    \def VAR_SYM_INDEX_NONE
    \brief Magic used as index, "no variable"; used e.g. as "$ar[]=$x;" for "variable" between '[' and ']', that is "no variable"
*/
#define VAR_SYM_INDEX_NONE      (-3L)

/*!
    \def VAR_SYM_INDEX_DISCARD
    \brief Magic used as index, its value will be discarded
*/
#define VAR_SYM_INDEX_DISCARD   (-2L)

/*!
    \def VAR_SYM_INDEX_INVALID
    \brief Magic used as index, invalid index
*/
#define VAR_SYM_INDEX_INVALID   (0L)

#define VAR_SYM_INDEX_IS_VALID(x)   ((x)>(VAR_SYM_INDEX_INVALID))

typedef long var_sym_index_t;                   //!< Index of symbol for variables

/*!
    \def INSTRUCT_ID_INVALID
    \brief Magic as invalid index
*/
#define INSTRUCT_ID_INVALID     (-1L)

typedef long instruct_id_t;                     //!< Microcode instruction ID

/*!
    \brief Type of class enumerator
    \author VooDooMan
    \version 1
    \date 2006-03-16
*/
enum e_micro_type
{
    MICRO_NA = -1,
    MICRO_INVALID = 0,
    MICRO_DEBUG,
    MICRO_POST_INCREMENT,
    MICRO_POST_DECREMENT,
    MICRO_PRE_INCREMENT,
    MICRO_PRE_DECREMENT,
    MICRO_PLUS,
    MICRO_MINUS,
    MICRO_MUL,
    MICRO_DIV,
    MICRO_NOT,
    MICRO_EQUAL,
    MICRO_NOT_EQUAL,
    MICRO_IDENTICAL,
    MICRO_NOT_IDENTICAL,
    MICRO_CONCAT,
    MICRO_MOD,
    MICRO_BIT_AND,
    MICRO_BIT_OR,
    MICRO_BIT_XOR,
    MICRO_SHIFT_LEFT,
    MICRO_SHIFT_RIGHT,
    MICRO_GREATER,
    MICRO_LESS,
    MICRO_GREATER_OR_EQUAL,
    MICRO_LESS_OR_EQUAL,
    MICRO_ONE_COMPLEMENT,
    MICRO_CAST_INT,
    MICRO_CAST_STRING,
    MICRO_CAST_BOOL,
    MICRO_LOG_OR,
    MICRO_LOG_AND,
    MICRO_TERNARY,
    MICRO_FUNC_CALL,
    MICRO_ARRAY,
    MICRO_ISSET,
    MICRO_RETURN,
    MICRO_ASSIGN,
    MICRO_INDEX,
    MICRO_JUMP,
    MICRO_LVALUE,
    MICRO_MAKE_INDEX_STREAM,
    MICRO_UPDATE,
    MICRO_STR_EVAL,
    MICRO_COMMIT_VARS,
};

#endif
