/***************************************************************************
                          c_lock_releaser.cpp  -  description
                             -------------------
    begin                : Sun Aug 19 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_lock_releaser.cpp,v 1.13 2008/06/29 17:37:54 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements class for automatic releasing of lock files
    \version $Id: c_lock_releaser.cpp,v 1.13 2008/06/29 17:37:54 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <stdio.h>  // for 'FILE' type

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

#include "c_lock_releaser.h"
#include "shutdown.h"
#include "../internal_state.h"

#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_lock_releaser::c_lock_releaser()
    : m_posix_lock_file(-1)
    , m_pid(NULL)
{
}

void c_lock_releaser::assign(int posix_lock_file, FILE* pid)
{
    MY_ASSERT(-1==m_posix_lock_file);
    MY_ASSERT(NULL==m_pid);
    m_posix_lock_file=posix_lock_file;
    m_pid=pid;
}

void c_lock_releaser::release()
{
    e_shutdown_reason sr=bot_get_shutdown_state_wo_mutex();
    if(m_pid)
        fclose(m_pid);
    m_pid=NULL;
    if(m_posix_lock_file!=-1) {
        close(m_posix_lock_file);
        if(!protect_pid && E_SD_RESTART!=sr)
            unlink("logs" FILE_SLASH "irc_bot.lock");
    }
    m_posix_lock_file=-1;
    if(!protect_pid && overwrite_pid && E_SD_RESTART!=sr)
        unlink("logs" FILE_SLASH "irc_bot.pid");
}

c_lock_releaser::~c_lock_releaser()
{
    release();
}

