/***************************************************************************
                          c_lock_releaser.h  -  description
                             -------------------
    begin                : Sun Aug 19 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_lock_releaser.h,v 1.12 2008/03/11 21:11:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements class for automatic releasing of lock files
    \version $Id: c_lock_releaser.h,v 1.12 2008/03/11 21:11:46 ghostvoodooman Exp $
*/

#ifndef C_LOCK_RELEASER_H__
#define C_LOCK_RELEASER_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <stdio.h>  // for 'FILE' type

/*!
    \brief Automatic lock releasing class (via destructor, or explicitly)
    \version 1
    \author VooDooMan
    \date 2007-08-19
*/
class c_lock_releaser
{
public:

    c_lock_releaser();

    /*!
        \brief Assigns lock file handles to this class
        \version 1
        \author VooDooMan
        \date 2007-08-19
        \param posix_lock_file On POSIX systems, there is low-level file handle for .lock file; '-1' for none
        \param pid There is file handle for .pid file; 'NULL' for none
        \warning Cannot be called twice, or assertion failure
    */
    void assign(int posix_lock_file, FILE* pid);

    /*!
        \brief Releases locks
        \version 1
        \author VooDooMan
        \date 2007-08-19
    */
    void release();

    ~c_lock_releaser();

private:
    int m_posix_lock_file;  //!< Low-level file handle for .lock file (on POSIX); or '-1' for none
    FILE* m_pid;            //!< File handle for .pid file; or 'NULL'
};

#endif

