/***************************************************************************
                          c_script_timeout_protector_locker.cpp  -  description
                             -------------------
    begin                : Sun Jun 15 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_script_timeout_protector_locker.cpp,v 1.4 2008/06/16 06:04:50 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements class for locking and unlocking protection against script timeout
    \version $Id: c_script_timeout_protector_locker.cpp,v 1.4 2008/06/16 06:04:50 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_script_timeout_protector_locker.h"

#include "../utils/precomp.h"

int c_script_timeout_protector_locker::m_lock_cnt=0;

c_script_timeout_protector_locker::c_script_timeout_protector_locker()
{
    MY_ASSERT(m_lock_cnt>=0);

    ++m_lock_cnt;
}

c_script_timeout_protector_locker::~c_script_timeout_protector_locker()
{
    MY_ASSERT(m_lock_cnt>=1);

    --m_lock_cnt;
}

c_script_timeout_protector_unlocker::c_script_timeout_protector_unlocker()
{
    MY_ASSERT(c_script_timeout_protector_locker::m_lock_cnt>=1);

    --c_script_timeout_protector_locker::m_lock_cnt;
}

c_script_timeout_protector_unlocker::~c_script_timeout_protector_unlocker()
{
    MY_ASSERT(c_script_timeout_protector_locker::m_lock_cnt>=0);

    ++c_script_timeout_protector_locker::m_lock_cnt;
}

