/***************************************************************************
                          shutdown.h  -  description
                             -------------------
    begin                : Sat Aug 18 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: shutdown.h,v 1.12 2008/03/11 21:11:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2007-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides shutdown of bot controlling mechanism
    \version $Id: shutdown.h,v 1.12 2008/03/11 21:11:46 ghostvoodooman Exp $
*/

#ifndef SHUTDOWN_H__
#define SHUTDOWN_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>

using namespace std;

enum e_shutdown_reason
{
    E_SD_NONE = 0,      //!< Bot is not dying
    E_SD_DIE,           //!< Bot wants to die
    E_SD_RESTART,       //!< Bot wants to restart itself
    E_SD_UPGRADE,       //!< Bot wants to upgrade itself
};                      //!< Bot killing state

bool bot_shutdown_action(e_shutdown_reason reason, const string& who);
e_shutdown_reason bot_get_shutdown_state();
string bot_get_shutdown_reason();
bool bot_shutting_down();
void bot_cancel_upgrade();
void bot_cancel_shutdown();

e_shutdown_reason bot_get_shutdown_state_wo_mutex();

#endif

