/***************************************************************************
                          modules.h  -  description
                             -------------------
    begin                : Fri Oct 21 2005
    copyright            : (C) 2005-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: modules.h,v 1.39 2008/03/25 12:04:22 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2005-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides messaging to/from/between modules and handles modules
    \version $Id: modules.h,v 1.39 2008/03/25 12:04:22 ghostvoodooman Exp $
*/

//---------------------------------------------------------------------------

#ifndef MODULES_H__
#define MODULES_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include <stdio.h>
#include <stdarg.h>

using namespace std;

#include "utils.h"      // because we want to enable mem leak detection

#include "params.h"
#include "compat.h"
#include "utils.h"
#include "variable.h"

class c_module;
class c_conf;
class c_logger;

#include "utils/assert.h"

c_module* get_module(const string& name, bool must_be_loaded);
c_conf* get_core_conf();
c_logger* get_core_logger();

void unload_module(const string& mod_name);

bool mod_dispatch(const string& type, const string& user, const string& channel, const string& line, bool before, int dummy, ...);
bool mod_dispatch2(const string& type, const string& user, const string& channel, const string& line, bool before, c_var_array* meta, int dummy, ...);

void mod_loop(bool shutdown = false);
void mod_loop2();

void update_groups();

void modules_init();
unsigned modules_maintenance(bool force = false);
void modules_done();

#endif

