/***************************************************************************
                          c_tracked_msg_to_server.h  -  description
                             -------------------
    begin                : Sun Dec 02 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_tracked_msg_to_server.h,v 1.12 2008/03/11 21:11:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_tracked_msg_to_server'
    \version $Id: c_tracked_msg_to_server.h,v 1.12 2008/03/11 21:11:46 ghostvoodooman Exp $
*/

#ifndef C_TRACKED_MSG_TO_SERVER_H__
#define C_TRACKED_MSG_TO_SERVER_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../utils.h"
#include "../params.h"

/*!
    \brief Contains a message to be sent to IRC server
    \author VooDooMan
    \version 1
    \date 2007-12-02
*/
class c_tracked_msg_to_server
{
public:
    enum e_kind
    {
        PIECE_IGNORE,   //!< Do not adjust this
        PIECE_NICK,     //!< This entry is a nick to be adjusted
        PIECE_CHANNEL,  //!< This entry is a channel to be adjusted if it contains a nick that left a channel
    };

    c_tracked_msg_to_server(const string& first_piece);
    c_tracked_msg_to_server();

    c_tracked_msg_to_server& add_piece(const string& piece);
    c_tracked_msg_to_server& add_nick(const string& nick);
    c_tracked_msg_to_server& add_channel(const string& channel);

    c_tracked_msg_to_server& add_multi(const vector<pair<e_kind,string> >& pieces);

    bool process_nick_change(const string& old_nick, const string new_nick);
    bool process_nick_change_chan(const string& channel, const string& part_nick);

    string get_msg() const;

    bool is_nick(const string& nick) const;

    bool empty();

    bool operator==(const c_tracked_msg_to_server& right)
    {
        return m_pieces==right.m_pieces;
    }

private:
    vector<pair<e_kind,string> > m_pieces;  //!< Message broken into pieces (.second: text to be adjusted according to .first)
};

#endif // C_TRACKED_MSG_TO_SERVER_H__

