/***************************************************************************
                          params_prologue.h  -  description
                             -------------------
    begin                : Mon Aug 8 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: params_prologue.h,v 1.14 2008/11/24 12:09:23 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Parameters for compilation - prologue section
    \version $Id: params_prologue.h,v 1.14 2008/11/24 12:09:23 ghostvoodooman Exp $
*/

#ifndef PARAMS_H__PROLOGUE__
#define PARAMS_H__PROLOGUE__

// sanity check
#if defined(_DEBUG) && defined(NDEBUG)
#   error "please, specify whether you want to enable debugging support, or not ('_DEBUG' and 'NDEBUG' cannot be specifieed both)"
#endif

#ifndef WANT_DEBUG
#   if defined(_DEBUG) && !defined(NDEBUG)
#       define WANT_DEBUG       1
#   else
#       if defined(NDEBUG) && !defined(_DEBUG)
#           define WANT_DEBUG   0
#       endif
#   endif
#   ifndef WANT_DEBUG
#       define WANT_DEBUG       1   // fallback to debug
#   endif
#endif

#ifdef WANT_DEBUG
#   if 1==WANT_DEBUG
#       ifdef _DEBUG
#           undef _DEBUG
#       endif
#       ifdef NDEBUG
#           undef NDEBUG
#       endif

#       define _DEBUG

#   elif 0==WANT_DEBUG
#       ifdef _DEBUG
#           undef _DEBUG
#       endif
#       ifdef NDEBUG
#           undef NDEBUG
#       endif

#       define NDEBUG

#   else
#       error "invalid 'WANT_DEBUG' value; should be '0' or '1'"
#   endif
#endif

// sanity check
#if defined(_DEBUG) && defined(NDEBUG)
#   error "please, specify whether you want to enable debugging support, or not ('_DEBUG' and 'NDEBUG' cannot be specifieed both)"
#endif

#if !defined(_DEBUG) && !defined(NDEBUG)
#   define _DEBUG       // TODO: FIXME: fallback to debug because this is a BETA SW, if user has not specifeid either one
#endif

// sanity check
#if defined(_DEBUG) && defined(NDEBUG)
#   error "please, specify whether you want to enable debugging support, or not ('_DEBUG' and 'NDEBUG' cannot be specifieed both)"
#endif

// ipv6 related things follow

#ifdef WANT_IPv6
#   if 1==WANT_IPv6
#       ifdef IPv6
#           undef IPv6
#       endif
#       define IPv6
#   elif 0==WANT_IPv6
#       ifdef IPv6
#           undef IPv6
#       endif
#   else
#       error "'WANT_IPv6' can have values '0' or '1' only"
#   endif
#endif

// darwin kernel issues: sanity check
#if defined(SOCKET_BIND_WILDCARD)
#   if (0!=SOCKET_BIND_WILDCARD) && (1!=SOCKET_BIND_WILDCARD)
#       error "'SOCKET_BIND_WILDCARD' can have values '0' or '1' only"
#   endif
#else
#   define SOCKET_BIND_WILDCARD     0
#endif

#if defined(__BORLANDC__)
#   if defined(REPORT_LEAKS) && REPORT_LEAKS == 1
#       error "Borland's compiler doesn't like overloaded delete and delete[] operators with more than one argument, thus violates ANSI standard. Please disable memory leak and heap errors detection by defining REPORT_LEAKS to 0 (zero)."
#   endif
#   if defined(REPORT_LEAKS)
#       undef REPORT_LEAKS
#   endif
#   define REPORT_LEAKS                 0
#endif

#if !defined(PORTABLE_LONG_LONG)
#   if defined(_MSC_VER) || defined(__BORLANDC__)
#       define PORTABLE_LONG_LONG   __int64
#   else
#       define PORTABLE_LONG_LONG   long long
#   endif

#   if defined(_MSC_VER)
#       define SIZEOF_LONG_LONG     8
#   elif defined(__BORLANDC__)
#       if sizeof(long) == 8
#           define SIZEOF_LONG      8
#       elif sizeof(long) == 4
#           define SIZEOF_LONG      4
#       endif
#       if sizeof(PORTABLE_LONG_LONG) == 8
#           define SIZEOF_LONG_LONG 8
#       elif sizeof(PORTABLE_LONG_LONG) == 4
            *** your compiler doesn't have 8 bytes long integer ***
#       endif
#   endif

#   if defined(SIZEOF_LONG) && ( SIZEOF_LONG == 8 )
#       define MY_LONG_LONG     signed long
#       define MY_U_LONG_LONG   unsigned long
#       define MY_LONG_LONG_STR "l"
#   elif defined(SIZEOF_LONG_LONG) && ( SIZEOF_LONG_LONG == 8 )
#       define MY_LONG_LONG     signed PORTABLE_LONG_LONG
#       define MY_U_LONG_LONG   unsigned PORTABLE_LONG_LONG
#       define MY_LONG_LONG_STR "ll"
#   else
        *** your compiler doesn't have 8 bytes long integer ***
#   endif
#endif

#ifndef _GNU_SOURCE
#   define _GNU_SOURCE
#endif

#if defined(_MSC_VER)
#   if defined(_CRT_SECURE_NO_WARNINGS)
#       undef _CRT_SECURE_NO_WARNINGS
#   endif
#   define _CRT_SECURE_NO_WARNINGS  1   /* MS Visual Stodio 8 ugly warnings against POSIX standard vs. ISO C++ standard functions */
#endif

#endif


