/***************************************************************************
                          modifiers.cpp  -  description
                             -------------------
    begin                : Wed Feb 06 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: modifiers.cpp,v 1.8 2008/03/11 21:11:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Maps PHP-like pattern modifiers to PCRE library's options
    \version $Id: modifiers.cpp,v 1.8 2008/03/11 21:11:46 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <map>

using namespace std;

#include <pcre.h>

#include "../utils/memleak.h"
#include "../params.h"

#include "modifiers.h"

#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_php_modifiers g_php_modifiers;

c_php_modifiers::c_php_modifiers()
{
    m_map.insert(make_pair('i',PCRE_CASELESS));
    m_map.insert(make_pair('m',PCRE_MULTILINE));
    m_map.insert(make_pair('s',PCRE_DOTALL));
    m_map.insert(make_pair('x',PCRE_EXTENDED));
    //m_map.insert(make_pair('e',PREG_REPLACE_EVAL)); // TODO: FIXME
    m_map.insert(make_pair('A',PCRE_ANCHORED));
    m_map.insert(make_pair('D',PCRE_DOLLAR_ENDONLY));
    m_map.insert(make_pair('U',PCRE_UNGREEDY));
    m_map.insert(make_pair('X',PCRE_EXTRA));
    m_map.insert(make_pair('u',PCRE_UTF8));
}

bool c_php_modifiers::append(char modifier, int& options) const
{
    map<char,int>::const_iterator i1=m_map.find(modifier);
    if(m_map.end()==i1)
        return false;
    options|=(*i1).second;
    return true;
}

