/***************************************************************************
                          modifiers.h  -  description
                             -------------------
    begin                : Wed Feb 06 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: modifiers.h,v 1.8 2008/03/11 21:11:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Maps PHP-like pattern modifiers to PCRE library's options
    \version $Id: modifiers.h,v 1.8 2008/03/11 21:11:46 ghostvoodooman Exp $
*/

#ifndef MODIFIERS_H__
#define MODIFIERS_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <map>

using namespace std;

#include "../utils/memleak.h"
#include "../params.h"

/*!
    \brief Implements PHP-like modifiers to PCRE
    \version 1
    \date 2008-02-01
    \author VooDooMan
*/
class c_php_modifiers
{
    map<char,int> m_map;    //!< Maps modifier (as a character) to PCRE option

public:

    c_php_modifiers();

    /*!
        \brief Bitwise-or appends option according to modifier
        \version 1
        \author VooDooMan
        \date 2008-02-07
        \param modifier Modifier character
        \param options This will be bitwisely-or appended, when result code is 'true'; otherwise leaves intact
        \retval true Okay, 'options' were updated
        \retval false Unknown modifier
    */
    bool append(char modifier, int& options) const;
};

#endif

