/***************************************************************************
                          pattern_hash_map.h  -  description
                             -------------------
    begin                : Wed Feb 06 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: pattern_hash_map.h,v 1.8 2008/03/11 21:11:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief PCRE patters cache (hash_map implementation, if compiler support it, else map)
    \version $Id: pattern_hash_map.h,v 1.8 2008/03/11 21:11:46 ghostvoodooman Exp $
*/

#ifndef PATTERN_HASH_MAP_H__
#define PATTERN_HASH_MAP_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"
#include "../params.h"

#include "../utils.h"

#if defined(HAVE_EXT_HASH_MAP) || defined(HAVE_GNUCXX_HASHMAP)
#   if defined(WANT_HASHMAP) && WANT_HASHMAP == 0
#   else
#       include <ext/hash_map>
using __gnu_cxx::hash_map;
#       define MY_USE_HASH_MAP      1
#   endif
#endif

#if defined(_MSC_VER)
#   include <hash_map>
using stdext::hash_map;
#   if _MSC_VER>=1400
using namespace stdext;
#   endif
#   define MY_USE_HASH_MAP      1
#endif

#if defined(__BORLANDC__)
#   include <Stlport/hash_map>
#   define MY_USE_HASH_MAP      1
#endif

#endif

