/***************************************************************************
                          eval_proc.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: eval_proc.cpp,v 1.24 2008/08/23 15:10:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements evaluation of procedure
    \version $Id: eval_proc.cpp,v 1.24 2008/08/23 15:10:46 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <iostream>

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "../sock_shared.h"

#include "../runtime/c_eval_iteration.h"
#include "../mod/c_module.h"
#include "c_proc_exc.h"
#include "../logic.h"
#include "../irc.h"
#include "../match.h"
#include "../eval.h"
#include "../botnet.h"
#include "../var/c_var_string.h"
#include "../var/c_var_int.h"
#include "../stats.h"
#include "../irc/c_online_channel.h"
#include "../irc/c_irc_server.h"
#include "../sock.h"
#include "../log.h"
#include "../identd.h"
#include "../dcc.h"
#include "../runtime/c_delay_link.h"
#include "../runtime/c_delay_command.h"
#include "../var/c_var_bool.h"
#include "../microcode/c_micro_symbol_variable_mapping.h"
#include "../microcode/c_micro_symbol_variable_table.h"
#include "../misc/shutdown.h"
#include "../internal_state.h"
#include "../misc/c_script_timeout_protector_locker.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

extern deque<c_msg_to_server> msgs_to_server;

MY_STATIC void eval_evaluate_proc__op(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__deop(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__deop_ban_mask(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__voice(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__devoice(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__kick(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__msg(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__msgq(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_in(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_n_in(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_match(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_match_case_insensitive(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_n_match(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_n_match_case_insensitive(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_group(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__return(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__work(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__timer(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__kill_timers(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__remote_execute(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__smtp(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__net_send(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__log(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__join(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__part(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__disconnect(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__try_connect(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__irc_server(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__irc_server_ex(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bot_nick(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__delete_irc_servers(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__delete_nicks(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__change_nick(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bot_ident(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bot_ident_ipv6(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bot_fullname(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bot_auth(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__allow_redirect(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__if_error(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__wait_if_error(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__real_label(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__real_goto(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__sleep(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__restart(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__raw(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__admin_msg(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__notice(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__noticeq(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__unban_mask(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__ban_mask(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__dynamic_ban(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__process_on_banned(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__check_dynamic_bans(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__dcc_server(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__dcc_server_ipv6(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__telnet_server(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__telnet_server_ipv6(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__ssl_server(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__ident(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__host(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_chan_mode(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__topic(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_chan_topic(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__script(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__link(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__chan_mode(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__load_module(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__unload_module(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bind(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__unbind(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__load_bin_module(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__set(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_nick_mode(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_bot_nick(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_event_id(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_current_irc_server(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__get_bot_name(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__bind_ex(stack<c_eval_iteration>& st);
MY_STATIC void eval_evaluate_proc__unbind_ex(stack<c_eval_iteration>& st);

/*!
    \brief Walks thru evaluation stack and checks is bottom-most frame is core module's entry point
    \version 1
    \author VooDooMan
    \date 2007-12-03
    \param st Evaluation stack
    \return Returns 'true' if it is entry point
*/
bool is_core_module_entrypoint(stack<c_eval_iteration>& st)
{
    if(st.empty())
        return false;

    for(c_eval_iteration* i1=&(st.top()); NULL!=i1; i1=i1->parent) {
        if(i1->is_core_module_entrypoint)
            return true;
        MY_ASSERT(i1 != i1->parent);
    }

    return false;
}

void eval_evaluate_proc(stack<c_eval_iteration>& st)
{
    {
        enum {
            CMD_CNT_TO_PROCESS_IRC = 200U,
        };
        static unsigned cnt=0;
        if((cnt++) % CMD_CNT_TO_PROCESS_IRC == 0) {
            irc_loop_heavy_time_consuming_operation("Still executing script...");
            my_sleep(-1);
        }
    }

    st.top().state=3999;

    string mod_name;
    if(st.top().this_module_)
        mod_name=st.top().this_module_->get_mod_name();

    //bool is_return=false, skip_block=false, redirect_checkpoint=false, after_redirect=false;
    st.top().is_return_=false;
    st.top().skip_block=false;
    st.top().redirect_checkpoint=false;
    st.top().after_redirect=false;
    st.top().goto_line=-1;

    {
        e_shutdown_reason sr=bot_get_shutdown_state();
        if(E_SD_DIE==sr || E_SD_RESTART==sr) {
            if(is_core_module_entrypoint(st))
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_BOT_SHUTDOWN_REQUEST,st.top().proc_cmd.get_debug());
        }
    }

#if 1==DEBUG_PROCFUNC_CMDS_ECHO
    cout << st.top().proc_cmd.get_debug() << endl;
#endif
    switch(st.top().proc_cmd.get_command()) {
        case _op:
            eval_evaluate_proc__op(st);
            break;
        case _deop:
            eval_evaluate_proc__deop(st);
            break;
        case _deop_ban_mask:
            eval_evaluate_proc__deop_ban_mask(st);
            break;
        case _voice:
            eval_evaluate_proc__voice(st);
            break;
        case _devoice:
            eval_evaluate_proc__devoice(st);
            break;
        case _kick:
            eval_evaluate_proc__kick(st);
            break;
        case _msg:
            eval_evaluate_proc__msg(st);
            break;
        case _msgq:
            eval_evaluate_proc__msgq(st);
            break;
        case _if_in:
            eval_evaluate_proc__if_in(st);
            break;
        case _if_n_in:
            eval_evaluate_proc__if_n_in(st);
            break;
        case _if_match:
            eval_evaluate_proc__if_match(st);
            break;
        case _if_match_case_insensitive:
            eval_evaluate_proc__if_match_case_insensitive(st);
            break;
        case _if_n_match:
            eval_evaluate_proc__if_n_match(st);
            break;
        case _if_n_match_case_insensitive:
            eval_evaluate_proc__if_n_match_case_insensitive(st);
            break;
        case _if_group:
            // fall thru
        case _if_n_group:
            eval_evaluate_proc__if_group(st);
            break;
        case _return:
            eval_evaluate_proc__return(st);
            break;
        case _end_bracket:
            /*
            if(st.top().proc_cmd.get_num_args()!=0)
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());
            */

            break;
        case _work:
            eval_evaluate_proc__work(st);
            break;
        case _timer_once:
            // fall thru
        case _timer_every:
            eval_evaluate_proc__timer(st);
            break;
        case _kill_timers:
            eval_evaluate_proc__kill_timers(st);
            break;
        case _execute:
            if(st.top().proc_cmd.get_num_args()!=1)
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

            {
                c_function* f=MY_NEW c_function();
                string error_msg;
                string code="function __execute_pseudofunction_from_procedure__(){\n";
                code+=st.top().proc_cmd.get_str_arg(0);
                code+=";\n}";

                bool okay=true;

                bool error=false;
                bool need_more=false;
                string v="#version 2\n";
                f->parse_command(st.top().this_module_,v,error,error_msg,need_more,st.top().proc_cmd.get_debug(),"");
                if(error || !need_more) {
                    f->clear_microcode();
                    f->destroy_symbols();
                    f->destroy(true,true);
                    MY_DELETE(f);
                    f=NULL;
                    okay=false;
                } else
                    f->parse_command(st.top().this_module_,code,error,error_msg,need_more,st.top().proc_cmd.get_debug(),"");
                if(error || need_more || !f->is_okay()) {
                    if(f) {
                        f->clear_microcode();
                        f->destroy_symbols();
                        f->destroy(true,true);
                        MY_DELETE(f);
                        f=NULL;
                    }
                    okay=false;
                }
                if(!okay) {
                    /*
                    var_oops(st.top().this_module_,__FILE__,__my_func__,GET_STR_DEBUG_INFO_EX("WARNING: 'execute' command parse error"),st.top().proc_cmd.get_debug());
                    */
                    if(f) {
                        f->clear_microcode();
                        f->destroy_symbols();
                        f->destroy(true,true);
                        MY_DELETE(f);
                        f=NULL;
                    }
                    error_msg=((string)"'execute' command parse error: ")+error_msg;
                    c_eval_runtime_error ee(st.top().this_module_,st.top().proc_cmd.get_debug(),GET_STR_DEBUG_INFO_EX(error_msg),__FILE__,__my_func__);
                    ee.report(false);
                } else {
                    c_eval_iteration ste(st.top().this_module_,st.top().vars_,st.top().proc_cmd.get_debug());
                    ste.fn_destroy=true;
                    ste.fn_destroy_mc=true;
                    ste.fn=f;
                    //ste.fn->create_symbols();
                    ste.fn_destroy=true;
                    ste.symbol_table_=ste.fn->make_symbol_table(ste.fn->symbol_table);
                    //ste.symbol_table_=ste.fn->symbol_table;
                    ste.symbol_table_->update_symbols_from_vars(st.top().vars_);
                    ste.proc_eval=true;
                    ste.state=1000;
                    ste.return_to_state=3001;
                    ste.local_id=st.top().local_id;
                    ste.parent=&(st.top());
                    st.push(ste);
                    return;
                }
                return;
            }
            break;
        case _remote_execute:
            eval_evaluate_proc__remote_execute(st);
            break;
        case _smtp:
            eval_evaluate_proc__smtp(st);
            break;
        case _net_send:
            eval_evaluate_proc__net_send(st);
            break;
        case _log:
            eval_evaluate_proc__log(st);
            break;
        case _join:
            eval_evaluate_proc__join(st);
            break;
        case _part:
            eval_evaluate_proc__part(st);
            break;
        case _disconnect:
            eval_evaluate_proc__disconnect(st);
            break;
        case _try_connect:
            eval_evaluate_proc__try_connect(st);
            {
                e_shutdown_reason sr=bot_get_shutdown_state();
                if(E_SD_DIE==sr || E_SD_RESTART==sr)
                    return;
            }
            break;
        case _irc_server:
            eval_evaluate_proc__irc_server(st);
            break;
        case _irc_server_ex:
            eval_evaluate_proc__irc_server_ex(st);
            break;
        case _bot_nick:
            eval_evaluate_proc__bot_nick(st);
            break;
        case _delete_irc_servers:
            eval_evaluate_proc__delete_irc_servers(st);
            break;
        case _delete_nicks:
            eval_evaluate_proc__delete_nicks(st);
            break;
        case _change_nick:
            eval_evaluate_proc__change_nick(st);
            break;
        case _bot_ident:
            eval_evaluate_proc__bot_ident(st);
            break;
        case _bot_ident_ipv6:
            eval_evaluate_proc__bot_ident_ipv6(st);
            break;
        case _bot_fullname:
            eval_evaluate_proc__bot_fullname(st);
            break;
        case _bot_auth:
            eval_evaluate_proc__bot_auth(st);
            break;
        case _allow_redirect:
            eval_evaluate_proc__allow_redirect(st);
            break;
        case _if_error:
            eval_evaluate_proc__if_error(st);
            break;
        case _wait_if_error:
            eval_evaluate_proc__wait_if_error(st);
            break;
        case _label:
            /*
            if(st.top().proc_cmd.get_num_args()!=0)
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());
            */
            break;
        case _real_label:
            eval_evaluate_proc__real_label(st);
            break;
        case _goto:
            /*
            if(st.top().proc_cmd.get_num_args()!=0)
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());
            */
            st.top().goto_line=st.top().proc_cmd.get_goto_line();
            break;
        case _real_goto:
            eval_evaluate_proc__real_goto(st);
            break;
        case _sleep_:
            eval_evaluate_proc__sleep(st);
            break;
        case _restart:
            eval_evaluate_proc__restart(st);
            break;
        case _raw:
            eval_evaluate_proc__raw(st);
            break;
        case _admin_msg:
            eval_evaluate_proc__admin_msg(st);
            break;
        case _notice:
            eval_evaluate_proc__notice(st);
            break;
        case _noticeq:
            eval_evaluate_proc__noticeq(st);
            break;
        case _unban_mask:
            eval_evaluate_proc__unban_mask(st);
            break;
        case _ban_mask:
            eval_evaluate_proc__ban_mask(st);
            break;
        case _dynamic_ban:
            eval_evaluate_proc__dynamic_ban(st);
            break;
        case _process_on_banned:
            eval_evaluate_proc__process_on_banned(st);
            break;
        case _check_dynamic_bans:
            eval_evaluate_proc__check_dynamic_bans(st);
            break;
        case _dcc_server:
            eval_evaluate_proc__dcc_server(st);
            break;
        case _dcc_server_ipv6:
            eval_evaluate_proc__dcc_server_ipv6(st);
            break;
        case _telnet_server:
            eval_evaluate_proc__telnet_server(st);
            break;
        case _telnet_server_ipv6:
            eval_evaluate_proc__telnet_server_ipv6(st);
            break;
        case _ssl_server:
            eval_evaluate_proc__ssl_server(st);
            break;
        case _ident:
            eval_evaluate_proc__ident(st);
            break;
        case _host:
            eval_evaluate_proc__host(st);
            break;
        case _get_chan_mode:
            eval_evaluate_proc__get_chan_mode(st);
            break;
        case _topic:
            eval_evaluate_proc__topic(st);
            break;
        case _get_chan_topic:
            eval_evaluate_proc__get_chan_topic(st);
            break;
        case _script:
            eval_evaluate_proc__script(st);
            break;
        case _link:
            eval_evaluate_proc__link(st);
            break;
        case _chan_mode:
            eval_evaluate_proc__chan_mode(st);
            break;
        case _rem:
            /*
            if(st.top().proc_cmd.get_num_args()!=1)
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());
            */

            break;
        case _load_module:
            eval_evaluate_proc__load_module(st);
            break;
        case _unload_module:
            eval_evaluate_proc__unload_module(st);
            break;
        case _bind:
            eval_evaluate_proc__bind(st);
            break;
        case _unbind:
            eval_evaluate_proc__unbind(st);
            break;
        case _bind_ex:
            eval_evaluate_proc__bind_ex(st);
            break;
        case _unbind_ex:
            eval_evaluate_proc__unbind_ex(st);
            break;
        case _load_bin_module:
            eval_evaluate_proc__load_bin_module(st);
            break;
        case _eval:
            if(st.top().proc_cmd.get_num_args()!=2)
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

            {
                string ret_var=st.top().proc_cmd.get_str_arg(1);

                c_function f(st.top().symbol_table_);
                string error_msg;
                string code="function __eval_pseudofunction_from_procedure__(){\n";
                code+=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
                code+="\n}";

                c_var_base* retval=NULL;

                bool error=false;
                bool need_more=false;
                string v="#version 2\n";
                f.parse_command(st.top().this_module_,v,error,error_msg,need_more,st.top().proc_cmd.get_debug(),"");
                if(error || !need_more)
                    retval=MY_NEW c_var_bool(false);
                else
                    f.parse_command(st.top().this_module_,code,error,error_msg,need_more,st.top().proc_cmd.get_debug(),"");
                if(error || need_more || !f.is_okay())
                    if(!retval)
                        retval=MY_NEW c_var_bool(false);
                if(retval) {
                    /*
                    var_oops(st.top().this_module_,__FILE__,__my_func__,GET_STR_DEBUG_INFO_EX("WARNING: eval() built-in function parse error"),st.top().proc_cmd.get_debug());
                    */
                    error_msg=((string)"eval() built-in function parse error: ")+error_msg;
                    c_eval_runtime_error ee(st.top().this_module_,st.top().proc_cmd.get_debug(),error_msg,__FILE__,__my_func__);
                    ee.report(false);
                } else {
                    c_eval_iteration ste(st.top().this_module_,st.top().vars_,st.top().proc_cmd.get_debug());
                    ste.symbol_table_=st.top().symbol_table_;
                    ste.proc_eval_ret_var=st.top().proc_cmd.get_str_arg(1);
                    ste.vars_=st.top().vars_;
                    ste.this_module_=st.top().this_module_;
                    ste.fn_destroy_mc=true;
                    ste.fn=MY_NEW c_function(f);
                    f.destroy(true);
                    ste.fn->create_symbols();
                    ste.symbol_table_->get_variable_mapping()->instantiate_consts(ste.symbol_table_->get_var_table());
                    ste.symbol_table_->get_var_table()->sanitize_index(ste.symbol_table_->get_variable_mapping()->get_capacity());
                    ste.fn_destroy=true;
                    ste.proc_eval=true;
                    ste.state=1000;
                    ste.return_to_state=3001;
                    ste.local_id=st.top().local_id;
                    ste.parent=&(st.top());
                    st.push(ste);
                    return;
                }
            }
            break;
        case _set:
            eval_evaluate_proc__set(st);
            break;
        case _get_nick_mode:
            eval_evaluate_proc__get_nick_mode(st);
            break;
        case _get_bot_nick:
            eval_evaluate_proc__get_bot_nick(st);
            break;
        case _get_event_id:
            eval_evaluate_proc__get_event_id(st);
            break;
        case _get_current_irc_server:
            eval_evaluate_proc__get_current_irc_server(st);
            break;
        case _get_bot_name:
            eval_evaluate_proc__get_bot_name(st);
            break;
        default:
            THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_INV_COMMAND,st.top().proc_cmd.get_debug());
    }
}

MY_STATIC void eval_evaluate_proc__op(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())) || (stoi(core_conf_getvar("smart_mode"))!=0 && irc_get_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug())).find((string)""+irc_isupport.get_prefix1('o'),0)!=string::npos))
        return;
    irc_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__deop(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())) || (stoi(core_conf_getvar("smart_mode"))!=0 && irc_get_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug())).find((string)""+irc_isupport.get_prefix1('o'),0)==string::npos))
        return;
    irc_deop(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__deop_ban_mask(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())))
        return;
    irc_deop_ban_mask(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__voice(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())) || (stoi(core_conf_getvar("smart_mode"))!=0 && irc_get_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug())).find('+',0)!=string::npos))
        return;
    irc_voice(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__devoice(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())) || (stoi(core_conf_getvar("smart_mode"))!=0 && irc_get_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug())).find('+',0)==string::npos))
        return;
    irc_devoice(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__kick(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug())))
        return;
    irc_kick(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()));
}

MY_STATIC void eval_evaluate_proc__msg(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_privmsg(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__msgq(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_privmsg(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug())+"\x01"+logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug())+"\x01"),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__if_in(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()).find(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),0)==string::npos) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__if_n_in(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()).find(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),0)!=string::npos) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__if_match(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()).compare(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()))) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__if_match_case_insensitive(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(irc_cmp_strings_case_insensitive(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()))) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__if_n_match(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()).compare(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()))) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__if_n_match_case_insensitive(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_cmp_strings_case_insensitive(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()))) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__if_group(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        bool skip=st.top().proc_cmd.get_command()==_if_group;
        bool got=false;
        string obj=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string grp=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        {
            vector<c_channel>::iterator i1;
            for(i1=r_channels.begin(); i1!=r_channels.end(); ++i1) {
                if((*i1).username.compare(obj))
                    continue;
                vector<string>::iterator i2;
                for(i2=(*i1).groups.begin(); i2!=(*i1).groups.end(); ++i2) {
                    if(st.top().proc_cmd.get_command()==_if_group) {
                        if(!(*i2).compare(grp)) {
                            skip=false;
                            got=true;
                            break;
                        }
                    } else {
                        if(!(*i2).compare(grp)) {
                            skip=true;
                            got=true;
                            break;
                        }
                    }
                }
                if(got)
                    break;
            }
        }
        if(!got) {
            deque<c_user>::iterator i1;
            for(i1=r_users.begin(); i1!=r_users.end(); ++i1) {
                if((*i1).name.compare(obj))
                    continue;
                vector<string>::iterator i2;
                for(i2=(*i1).groups.begin(); i2!=(*i1).groups.end(); ++i2) {
                    if(st.top().proc_cmd.get_command()==_if_group) {
                        if(!(*i2).compare(grp)) {
                            skip=false;
                            got=true;
                            break;
                        }
                    } else {
                        if(!(*i2).compare(grp)) {
                            skip=true;
                            got=true;
                            break;
                        }
                    }
                }
                if(got)
                    break;
            }
        }
        if(!got) {
            vector<c_procedure>::iterator i1;
            for(i1=st.top().this_module_->r_procedures.begin(); i1!=st.top().this_module_->r_procedures.end(); ++i1) {
                if((*i1).name.compare(obj))
                    continue;
                vector<string>::iterator i2;
                for(i2=(*i1).groups.begin(); i2!=(*i1).groups.end(); ++i2) {
                    if(st.top().proc_cmd.get_command()==_if_group) {
                        if(!(*i2).compare(grp)) {
                            skip=false;
                            got=true;
                            break;
                        }
                    } else {
                        if(!(*i2).compare(grp)) {
                            skip=true;
                            got=true;
                            break;
                        }
                    }
                }
                if(got)
                    break;
            }
        }
        if(skip) {
            st.top().goto_line=st.top().proc_cmd.get_goto_line();
        }
    }
}

MY_STATIC void eval_evaluate_proc__return(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());
    st.top().is_return_=true;
}

MY_STATIC void eval_evaluate_proc__work(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(st.top().this_module_->get_mod_name().compare("core")) { // !=
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_INV_WORK,st.top().proc_cmd.get_debug());
    }

    {
        c_script_timeout_protector_unlocker stp_unlock;

        var_keeper->work_issued(st.top().this_module_->get_session(),true);

        do_work();

        var_keeper->work_issued(st.top().this_module_->get_session(),false);
    }
}

MY_STATIC void eval_evaluate_proc__timer(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_timer* t=MY_NEW c_timer();
        t->once=st.top().proc_cmd.get_command()==_timer_once;
        t->name=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        my_time(&t->set_at);
        my_time(&t->again_at);
        t->duration=st.top().proc_cmd.get_int_arg(1);
        if(t->duration<=0)
            t->duration=1;
        t->again_at+=t->duration;

        t->debug=st.top().proc_cmd.get_debug();

        t->expression=st.top().proc_cmd.get_str_arg(2);

        {
            session_id_t old_session=var_keeper->get_current_session();
            var_keeper->set_current_session(SESSION_RESERVED_ID);
            t->vars=var_keeper->register_mod_global(st.top().vars_,__FILE__,__my_func__,__LINE__);
            t->vars->set_all_as_persistent();
            var_keeper->set_current_session(old_session);
        }
        st.top().this_module_->r_timers.push_back(t);
    }
}

MY_STATIC void eval_evaluate_proc__kill_timers(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string name=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        vector<c_timer*>::iterator i1;
    kt_l:
        for(i1=st.top().this_module_->r_timers.begin(); i1!=st.top().this_module_->r_timers.end(); ++i1) {
            if(!match(name.c_str(),(*i1)->name.c_str())) {
                if((*i1)->bot_unlink_timer)
                    botnet_kill_timer(*i1);
                if((*i1)->vars) {
                    var_keeper->free_global((*i1)->vars,true);
                }
                (*i1)->vars=NULL;
                MY_DELETE(*i1);
                st.top().this_module_->r_timers.erase(i1);
                goto kt_l;
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__remote_execute(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string call_string=st.top().proc_cmd.get_str_arg(1);
        string cs=call_string;
        unsigned int i2;
        for(i2=0; i2<cs.length(); ++i2)
            if(cs[i2]=='(')
                break;
        cs.erase(i2,cs.length()-i2); // erase everything after '('

        string name_only=cs;

        cs=st.top().proc_cmd.get_str_arg(1);
        for(i2=0; i2<cs.length(); ++i2)
            if(cs[i2]=='(')
                break;
        cs.erase(0,i2+1);
        if(cs.length()>0 && cs[cs.length()-1]==')')
            cs.erase(cs.length()-1,1);
        cs+=",";

        vector<c_var_base*> params;
        bool str=false;
        string p;
        for(i2=0; i2<cs.length() && cs.compare(","); ++i2) {
            if(cs[i2]=='"') {
                p+="\"";

                str=!str;
                continue;
            }
            if(!str && cs[i2]==',') {
                p=logic_eval(st.top().this_module_,p,st.top().vars_,st.top().proc_cmd.get_debug());
                params.push_back(MY_NEW c_var_string(p));
                p="";
                continue;
            }
            if(!str && cs[i2]==')') {
                if(p.compare("")) {
                    p=logic_eval(st.top().this_module_,p,st.top().vars_,st.top().proc_cmd.get_debug());
                    params.push_back(MY_NEW c_var_string(p));
                }
                break;
            }
            p+=cs[i2];
        }

        string result=botnet_remote_procedure_call(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),name_only,params,st.top().this_module_);

        vector<c_var_base*>::iterator i_arg=params.begin();
        while(i_arg!=params.end()) {
            if(*i_arg)
                MY_DELETE(*i_arg);
            params.erase(i_arg);
            i_arg=params.begin();
        }

        {
            c_index_base* idx=MY_NEW c_index_str(st.top().proc_cmd.get_str_arg(2));
            c_var_string* val=MY_NEW c_var_string(result);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__smtp(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=6)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string fn="." FILE_SLASH "sendmail" FILE_SLASH;
        fn+=toshex(rand());
        fn+=toshex(rand());
        fn+=toshex(rand());
        fn+=toshex(rand());
        fn+=".sendmail";
        FILE* f=fopen(fn.c_str(),"wb");
        if(f) {
            fprintf(f,"0.0.0.0\r\n");
            fprintf(f,"%s\r\n",logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()).c_str());
            fprintf(f,"%u\r\n",static_cast<unsigned>(st.top().proc_cmd.get_int_arg(1)));
            fprintf(f,"HELO %s\r\n",logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()).c_str());
            fprintf(f,"MAIL FROM: %s\r\n",logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug()).c_str());
            fprintf(f,"RCPT TO: %s\r\n",logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(4),st.top().vars_,st.top().proc_cmd.get_debug()).c_str());
            fprintf(f,"DATA\r\n");
            string data=st.top().proc_cmd.get_str_arg(5);
            data="\""+data+"\"";
            fprintf(f,"%s\r\n.\r\n",logic_eval(st.top().this_module_,data,st.top().vars_,st.top().proc_cmd.get_debug()).c_str());
            fclose(f);

            string params=fn;
            params=(string)"\""+params+"\"";

            fn="";
            c_conf* core_conf=get_core_conf();
            if(core_conf)
                fn=utils_convert_unix_path(core_conf->getvar("sendmail"));
            if(fn.empty()) {
#if defined(_WIN32) || defined(_WIN64) || defined(_WIN64)
                fn="." FILE_SLASH "sendmail" FILE_SLASH "vdc_sendmail.exe";
#else
                fn="." FILE_SLASH "sendmail" FILE_SLASH "vdc_sendmail";
#endif
            }
            c_tmp_file t;
            t.script=false;
            cout << "Executing in CWD: " << fn << " " << params << endl;
            t.h=exec_async_exec(fn.c_str(),params.c_str(),"");
            t.start_up_time=my_time(NULL);
            t.has_been_run=true;
            st.top().this_module_->tmp_files.push_back(t);

            stats_mail_sent();
        }
    }
}

MY_STATIC void eval_evaluate_proc__net_send(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
#if defined(_WIN32) || defined(_WIN64)
        string fn="net";
        string param1=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string param2=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());

        while(param1.find("\"",0)!=string::npos)
            param1.erase(param1.find("\"",0),1);
        while(param2.find("\"",0)!=string::npos)
            param2.erase(param2.find("\"",0),1);

        while(param1.find("%",0)!=string::npos)
            param1.erase(param1.find("%",0),1);
        while(param2.find("%",0)!=string::npos)
            param2.erase(param2.find("%",0),1);

        string params=(string)"send \""+param1+"\" \""+param2+"\"";
        c_tmp_file t;
        t.script=false;
        cout << "Executing in CWD: " << fn << " " << params << endl;
        t.h=exec_async_exec(fn.c_str(),params.c_str(),"");
        t.start_up_time=my_time(NULL);
        t.has_been_run=true;
        st.top().this_module_->tmp_files.push_back(t);
#endif
    }
}

MY_STATIC void eval_evaluate_proc__log(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(st.top().this_module_->get_logger())
        st.top().this_module_->get_logger()->log_print1(E_LOG_CUSTOM,LOG_SCOPE_MODULE,"",logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()));
}

MY_STATIC void eval_evaluate_proc__join(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        /*
        bool on_channel=false;
        vector<c_online_channel>::iterator i2;
        for(i2=irc_channels.begin(); i2!=irc_channels.end(); ++i2)
            if(!irc_cmp_strings_case_insensitive((*i2).name,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()))) {
                on_channel=true;
                break;
            }

        if(!on_channel)*/
            irc_join(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()));
    }
}

MY_STATIC void eval_evaluate_proc__part(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        /*
        bool on_channel=false;
        vector<c_online_channel>::iterator i2;
        for(i2=irc_channels.begin(); i2!=irc_channels.end(); ++i2)
            if(!irc_cmp_strings_case_insensitive((*i2).name,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()))) {
                on_channel=true;
                break;
            }

        if(on_channel)*/
            irc_part(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()));
    }
}

MY_STATIC void eval_evaluate_proc__disconnect(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_disconnect();
}

MY_STATIC void eval_evaluate_proc__try_connect(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_disconnect();
    do_idle();
    if(!irc_socket.cmp()) {
        if(irc_recommended_port==0) {
            if(irc_server_iterator==irc_servers.end()) {
                irc_server_iterator=irc_servers.begin();
                if(irc_server_iterator==irc_servers.end()) {
                    log_bot(GET_STR_DEBUG_INFO_EX("No server in the list! Fatal error."));
                    THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NO_SERVER,st.top().proc_cmd.get_debug());
                }
            }
            irc_server_host=(*irc_server_iterator).host;
            irc_server_port=(*irc_server_iterator).port;
            string bind_ip=(*irc_server_iterator).ex?(*irc_server_iterator).bind_ip:((string)"0.0.0.0");

            string ssl="";
            vector<string>::iterator fi;
            for(fi=(*irc_server_iterator).flags.begin(); fi!=(*irc_server_iterator).flags.end(); ++fi) {
                if((*fi).find("@irc_ssl=",0)==0) {
                    ssl=*fi;
                    if(ssl.length() && ssl[0]=='@')
                        ssl.erase(0,1);
                    if(ssl.length() && ssl[ssl.length()-1]=='@')
                        ssl.erase(ssl.length()-1,1);
                }
            }
            irc_ssl_section=ssl;

            irc_connect(bind_ip,(*irc_server_iterator).host,(*irc_server_iterator).port,irc_ssl_section);
            eval_cleanup_timeout();
            irc_server_iterator++;
            do_idle();
        } else {
                unsigned short p=irc_recommended_port;
                irc_recommended_port=0;
                irc_connect("0.0.0.0",irc_recommended_server,p,irc_ssl_section);
                eval_cleanup_timeout();
                do_idle();
            }
    }
}

MY_STATIC void eval_evaluate_proc__irc_server(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_irc_server s;
        s.ex=false;
        s.host=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        s.port=(unsigned short)st.top().proc_cmd.get_int_arg(1);
        if(s.port==0)
            s.port=6667;
        s.flags.clear();
        irc_servers.push_back(s);
        irc_server_iterator=irc_servers.begin();
    }
}

MY_STATIC void eval_evaluate_proc__irc_server_ex(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_irc_server s;
        s.ex=true;
        s.host=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
        s.bind_ip=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        s.port=(unsigned short)st.top().proc_cmd.get_int_arg(3);
        if(s.port==0)
            s.port=6667;
        s.irc_type=st.top().proc_cmd.get_str_arg(0);
        c_proc_command::parse_irc_type_flags(s.flags,s.irc_type);
        irc_servers.push_back(s);
        irc_server_iterator=irc_servers.begin();
    }
}

MY_STATIC void eval_evaluate_proc__bot_nick(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        vector<string>::const_iterator ii=st.top().proc_cmd.strings.begin();
        while(ii!=st.top().proc_cmd.strings.end()) {
            irc_nicks.push_back(logic_eval(st.top().this_module_,*ii,st.top().vars_,st.top().proc_cmd.get_debug()));
            ii++;
        }
    }
}

MY_STATIC void eval_evaluate_proc__delete_irc_servers(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string mask=st.top().proc_cmd.get_str_arg(0);
        mask=logic_eval(st.top().this_module_,mask,st.top().vars_,st.top().proc_cmd.get_debug());

        vector<c_irc_server>::iterator ii;
    again_erase1:
        for(ii=irc_servers.begin(); ii!=irc_servers.end(); ++ii) {
            string id="[";
            id+=(*ii).host;
            id+="]:";
            id+=tos((*ii).port);

            if(!match(mask.c_str(),id.c_str())) {
                irc_servers.erase(ii);
                goto again_erase1;
            }
        }
        irc_server_iterator=irc_servers.end();
    }
}

MY_STATIC void eval_evaluate_proc__delete_nicks(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string mask=st.top().proc_cmd.get_str_arg(0);
        mask=logic_eval(st.top().this_module_,mask,st.top().vars_,st.top().proc_cmd.get_debug());

        vector<string>::iterator ii;
    again_erase2:
        for(ii=irc_nicks.begin(); ii!=irc_nicks.end(); ++ii) {
            string id=*ii;;

            if(!match(mask.c_str(),id.c_str())) {
                irc_nicks.erase(ii);
                goto again_erase2;
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__change_nick(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        if(!logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()).compare(irc_nick))
            return;

        string msg="NICK ";
        msg+=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        irc_putserv(c_tracked_msg_to_server(msg),true,HIGH_PRIORITY);
    }
}

MY_STATIC void eval_evaluate_proc__bot_ident(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        irc_ident=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        if(stoi(core_conf_getvar("disable_ident_daemon"))!=0)
            return;
    identd_fail:
        in_addr a;
        memset(&a,0,sizeof(a));
        identd4_shutdown();
        bool ok=identd_startup(a,113);
        ident_string=": USERID : UNIX :";
        ident_string+=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        if(!ok && stoi(core_conf_getvar("important_ident_daemon"))!=0) {
            do_idle();
            e_shutdown_reason sr=bot_get_shutdown_state();
            if(E_SD_DIE==sr || E_SD_RESTART==sr) {
                return;
            }
            my_sleep(500);
            goto identd_fail;
        }
    }
}

MY_STATIC void eval_evaluate_proc__bot_ident_ipv6(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        irc_ident=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        if(stoi(core_conf_getvar("disable_ident_daemon"))!=0)
            return;
    identd_fail6:
        char local[256];
        strcpy(local,"::");
        identd6_shutdown();
        bool ok=identd_startup(local,113);
        ident_string=": USERID : UNIX :";
        ident_string+=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        if(!ok && stoi(core_conf_getvar("important_ident_daemon"))!=0) {
            do_idle();
            e_shutdown_reason sr=bot_get_shutdown_state();
            if(E_SD_DIE==sr || E_SD_RESTART==sr) {
                return;
            }
            my_sleep(500);
            goto identd_fail6;
        }
    }
}

MY_STATIC void eval_evaluate_proc__bot_fullname(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_fullname=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
}

MY_STATIC void eval_evaluate_proc__bot_auth(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        /*last_nick_idx=0;
        vector<string>::const_iterator ii=irc_nicks.begin();
        for(; ii!=irc_nicks.end(); ++ii, ++last_nick_idx) {
            if(irc_auth((*ii).c_str(),irc_fullname)==0)
                break;
        }*/
    }
}

MY_STATIC void eval_evaluate_proc__allow_redirect(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_set_redir(st.top().proc_cmd.get_int_arg(0)!=0);
}

MY_STATIC void eval_evaluate_proc__if_error(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    st.top().redirect_checkpoint=true;
    if(irc_socket.cmp()) {
        st.top().goto_line=st.top().proc_cmd.get_goto_line();
    }
}

MY_STATIC void eval_evaluate_proc__wait_if_error(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    try {
        e_shutdown_reason sr=bot_get_shutdown_state(); // forward, because of goto

        int got_nick=0;

        my_time_t first_try=my_time(NULL);
        int auth_state=0;
        vector<string>::iterator ii;
        bool error=false;

    l2:
        {
            my_time_t now=my_time(NULL);
            while(msgs_from_server.empty()) {
                if(now+10<=my_time(NULL))
                    break;
                my_sleep(10);
                if(irc_loop_putserv()) {
                    int reason=irc_loop_process_input();
                    irc_disconnect();
                    eval_cleanup_timeout();
                    if(reason==2)
                        goto throttled;
                    eval_cleanup_timeout();
                    break;
                }
                logic_loop_identd();
                do_idle();
            }
        }

        ii=irc_nicks.begin();
        for(int i1=1; ii!=irc_nicks.end(); ++ii, ++i1) {
            if(i1<=last_nick_idx)
                continue;
            got_nick=1;
            irc_nick=*ii;
            last_nick_idx++;
            break;
        }
        if(got_nick==0) {
            last_nick_idx=0;
            got_nick=2;
            goto l2;
        }
        if(got_nick==2) {
            last_nick_idx=0;
            log_bot("I don't have any nicks! I am dying now!");
            log_irc(false,"I don't have any nicks! I am dying now!");
            irc_disconnect();

            bot_shutdown_action(E_SD_DIE,"SELF");
            throw (int)0;
        }

        first_try=my_time(NULL);
        auth_state=0;
    l1:
        my_time(&irc_last_keepalive_detection);    // do not check for timeout by this method
        sr=bot_get_shutdown_state();
        if(E_SD_DIE==sr || E_SD_RESTART==sr) {
            throw (int)0;
        }
        if(first_try+60*3<my_time(NULL)) {         // check for timeout here
            //continue;
            st.top().skip_block=false;
            eval_cleanup_timeout();
            return;
        }
        if(auth_state==0) {
            //irc_put("PASS *",HIGH_PRIORITY);
            auth_state++;
        }
        if(auth_state==1) {
            string msg="USER ";
            if(!irc_ident.compare("*")) {
                irc_ident=str_to_lower(irc_nick);
            erase_again:
                for(unsigned int ii=0; ii<irc_ident.length(); ++ii)
                    if(irc_ident[ii]<'a' || irc_ident[ii]>'z') {
                        irc_ident.erase(ii,1);
                        goto erase_again;
                    }
                if(irc_ident.empty())
                    irc_ident=str_to_lower(irc_nick);
            }
            msg+=irc_ident;
            msg+=" 0 \"";
            msg+=irc_server_host;
            msg+="\" :";
            msg+=irc_fullname;
            irc_put(msg,HIGH_PRIORITY);

            auth_state++;

            if(irc_loop_putserv()) {
                irc_disconnect();
                //continue;
                st.top().skip_block=false;
                eval_cleanup_timeout();
                return;
            }
        }
        my_sleep(50);
        error=false;
        while(msgs_to_server.begin()!=msgs_to_server.end() /*&& last_msg.wait_for_response*/) {
            my_sleep(1);
            if(irc_loop_putserv()) {
                int reason=irc_loop_process_input();
                irc_disconnect();
                eval_cleanup_timeout();
                if(reason==2)
                    goto throttled;
                eval_cleanup_timeout();
                break;
            }
            logic_loop_identd();
            irc_loop_process_input();
            do_idle();
        }
        if(error) {
            eval_cleanup_timeout();
            return;
        }
        logic_loop_identd();
        do_idle();
        if(irc_loop_process_input()==2) {
            irc_disconnect();
    throttled:
            last_nick_idx=0;

            log_bot("Reconnecting too fast: sleeping for 60 seconds...");
            log_irc(false,"Reconnecting too fast: sleeping for 60 seconds...");

            utils_deep_sleep(60);

            irc_connect("0.0.0.0",irc_server_host,irc_server_port,irc_ssl_section);
            st.top().after_redirect=true;
            throw (int)0;
        }

        if(!irc_socket.cmp() && last_msg.response[0]==0) {
            last_nick_idx=0;
            st.top().skip_block=false;
            eval_cleanup_timeout();
            return;
        }
        size_t i1_;
        for(i1_=0; i1_<strlen(last_msg.response); ++i1_)
            if(last_msg.response[i1_]==0x20)
                break;
        int resp=-1;
        char redirect[1024*2];
        if(last_msg.response[i1_]==0x20 &&
            last_msg.response[i1_+1]>='0' && last_msg.response[i1_+1]<='9' &&
            last_msg.response[i1_+2]>='0' && last_msg.response[i1_+2]<='9' &&
            last_msg.response[i1_+3]>='0' && last_msg.response[i1_+3]<='9') {
                resp=(last_msg.response[i1_+1]-'0')*100+(last_msg.response[i1_+2]-'0')*10+(last_msg.response[i1_+3]-'0');
                redirect[0]=0;
                if(strlen(last_msg.response)<sizeof(redirect))
                    strcpy(redirect,last_msg.response);
                last_msg.response[0]=0;
            }

        if(-1==resp) {
            if(auth_state==4) {
                auth_state++;
            }
            if(auth_state==3) {
                for(int i1=0; i1<100; ) {
                    do_idle();
                    my_sleep(50);
                    i1+=50;
                    if(irc_loop_putserv()) {
                        irc_disconnect();
                        break;
                    }
                    irc_loop_process_input();
                }
                if(irc_loop_putserv()) {
                    irc_disconnect();
                    eval_cleanup_timeout();
                    return;
                }
                string nick="NICK ";
                nick+=irc_nick;
                irc_put(nick,HIGH_PRIORITY);
                auth_state++;
            }
            if(auth_state==2) {
                auth_state++;
                for(int i1=0; i1<1*1000; ) {
                    do_idle();
                    my_sleep(50);
                    i1+=50;
                    if(irc_loop_putserv()) {
                        irc_disconnect();
                        break;
                    }
                    irc_loop_process_input();
                }
            }
            if(irc_loop_putserv()) {
                irc_loop_process_input();
                irc_disconnect();
                last_nick_idx=0;
                eval_cleanup_timeout();
                return;
            }
            logic_loop_identd();
            do_idle();
            goto l1;
        }
        if(resp>=400 && resp<=599) {
            // error reply
            if(resp==433 || resp==437) {
                // nick already in use / temporarily unavailable
                int got_nick=0;
            l3:
                vector<string>::iterator ii=irc_nicks.begin();
                for(int i1=1; ii!=irc_nicks.end(); ++ii, ++i1) {
                    if(i1<=last_nick_idx)
                        continue;
                    got_nick=1;
                    irc_nick=*ii;
                    last_nick_idx++;
                    break;
                }
                if(got_nick==0) {
                    last_nick_idx=0;
                    got_nick=2;
                    goto l3;
                }
                if(got_nick==2) {
                    last_nick_idx=0;
                    log_bot("I don't have any nicks! I am dying now!");
                    log_irc(false,"I don't have any nicks! I am dying now!");
                    irc_disconnect();

                    bot_shutdown_action(E_SD_DIE,"SELF");
                    throw (int)0;
                }
                if(got_nick==1) {
                    string nick="NICK ";
                    nick+=irc_nick;
                    irc_put(nick,HIGH_PRIORITY);
                    //auth_state=2;
                    if(irc_loop_putserv()) {
                        irc_disconnect();
                        eval_cleanup_timeout();
                        return;
                    }
                    irc_loop_process_input();
                    goto l1;
                }
                // give up
                THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_RESTART,st.top().proc_cmd.get_debug());
            }
        } else {
            if(resp==10) {
                // redirect
                string msg="Received redirect message: ";
                msg+=redirect;
                log_bot(msg);
                log_irc(false,msg);
                if(irc_follow_redirs) {
                    log_bot("Redirecting...");
                    log_irc(false,"Redirecting...");
                    string msg=redirect;
                    //:irc.server.com 010 BotNick0 irc2.server.com 6669 :Please use this Server/Port instead
                    if(msg.find(" ")!=string::npos)
                        msg.erase(0,msg.find(" ")+1); // erase server name
                    if(msg.find(" ")!=string::npos)
                        msg.erase(0,msg.find(" ")+1); // erase numeric reply
                    if(msg.find(" ")!=string::npos)
                        msg.erase(0,msg.find(" ")+1); // erase my nick
                    irc_recommended_server="";
                    while(msg.length()>0 && msg[0]!=0x20) {
                        irc_recommended_server+=msg[0];
                        msg.erase(0,1);
                    }
                    msg.erase(0,1);
                    string port;
                    while(msg.length()>0 && msg[0]!=0x20) {
                        port+=msg[0];
                        msg.erase(0,1);
                    }
                    irc_recommended_port=stous(port);

                    last_nick_idx=0;

                    {
                        irc_disconnect();
                        unsigned short p=irc_recommended_port;
                        irc_recommended_port=0;
                        irc_connect("0.0.0.0",irc_recommended_server,p,irc_ssl_section);
                        eval_cleanup_timeout();

                        identd_renew();

                        st.top().after_redirect=true;
                        throw (int)0;
                    }
                } else {
                    irc_disconnect(); // try another server, coz redirects are dissabled (better said, continue to wait_if_error { content }
                    last_nick_idx=0;
                    //continue;
                    st.top().skip_block=false;
                    eval_cleanup_timeout();
                    return;
                }
            }
            if(first_try+60*3<my_time(NULL)) {
                last_nick_idx=0;
                //continue; // go to wait_if_error { content }
                st.top().skip_block=false;
                eval_cleanup_timeout();
                return;
            }
            bool got=false;
            if(resp>=1 && resp<=5)
                got=true;
            if(resp>=251 && resp<=255)
                got=true;
            if(resp==372 || resp==375)
                got=true;
            if(got)
                identd_shutdown();
            if(resp==20) {
                // wait
                for(int i1=0; i1<500; ) {
                    do_idle();
                    my_sleep(50);
                    i1+=50;
                }
                goto l1;
            }
            if(!got) {
                logic_loop_identd();
                irc_loop_process_input();
                goto l1;
            }
            st.top().goto_line=st.top().proc_cmd.get_goto_line();
            eval_cleanup_timeout();
            return;
        }
        throw (int)0;
    } catch(int UNUSEDARG(e)) {
        eval_cleanup_timeout();
    }
}

MY_STATIC void eval_evaluate_proc__real_label(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());
}

MY_STATIC void eval_evaluate_proc__real_goto(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    st.top().goto_line=st.top().proc_cmd.get_goto_line();
}

MY_STATIC void eval_evaluate_proc__sleep(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    int seconds=st.top().proc_cmd.get_int_arg(0);

    string log="Sleeping for ";
    log+=tos(seconds);
    log+=" second(s)...";
    log_irc_ex(E_LOG_IRC_EX_INF,log);

    utils_deep_sleep(seconds);
}

MY_STATIC void eval_evaluate_proc__restart(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=0)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_disconnect();
    THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_RESTART,st.top().proc_cmd.get_debug());
}

MY_STATIC void eval_evaluate_proc__raw(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_put(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__admin_msg(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string type=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        string msg=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());

        if(type.find("@telnet@",0)!=string::npos) {
            if(mask.find("@",0)==string::npos) {
                // local message
                dcc_broadcast(mask,msg,"","");
            } else {
                // BOTNET broadcast message
                string user, bot;

                user=mask;
                user.erase(user.find("@",0),user.length()-user.find("@",0));

                bot=mask;
                bot.erase(0,bot.find("@",0)+1);

                botnet_admin_msg(user,bot,msg);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__notice(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_notice(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__noticeq(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_notice(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug())+"\x01"+logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug())+"\x01"),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__unban_mask(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug())))
        return;
    {
        vector<c_online_channel>::iterator i1;
        for(i1=irc_channels.begin(); i1!=irc_channels.end(); ++i1) {
            if(irc_cmp_strings_case_insensitive((*i1).name,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug())))
                continue;
            vector<string>::iterator i2;
            for(i2=(*i1).bans.begin(); i2!=(*i1).bans.end(); ++i2)
                if(!(*i2).compare(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()))) {
                    (*i1).bans.erase(i2);
                    break;
                }
            break;
        }
    }
    irc_unban(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()));
}

MY_STATIC void eval_evaluate_proc__ban_mask(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    if(!irc_got_op(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug())))
        return;
    irc_ban(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()));
}

MY_STATIC void eval_evaluate_proc__dynamic_ban(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        vector<c_channel_def>::iterator i1;
        for(i1=r_channel_defs.begin(); i1!=r_channel_defs.end(); ++i1) {
            if(!irc_cmp_strings_case_insensitive((*i1).channel_name,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()))) {
                string prefix=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
                if(prefix.compare("+") && prefix.compare("-"))
                    break;

                pair<string,string> p;
                p.first=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
                p.second=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug());
                p.first=(string)"\""+p.first+"\"";
                p.second=(string)"\""+p.second+"\"";

                map<string,string>::iterator i2;
            erase_dyn_ban:
                for(i2=(*i1).dynamic_bans.begin(); i2!=(*i1).dynamic_bans.end(); ++i2) {
                    if(!p.first.compare((*i2).first)) {
                        (*i1).dynamic_bans.erase(i2);
                        goto erase_dyn_ban;
                    }
                }

                if(!prefix.compare("+")) {
                    (*i1).dynamic_bans.insert(p);
                }
                if(!prefix.compare("-")) {
                    // it is erased (see above)
                }
                break;
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__process_on_banned(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string chan=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        vector<c_online_channel>::iterator i1;
        for(i1=irc_channels.begin(); i1!=irc_channels.end(); ++i1) {
            if(!irc_cmp_strings_case_insensitive((*i1).name,chan)) {
                logic_on_banned(chan, mask,(*i1).excepts,(*i1).invites,(*i1).bans);
                break;
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__check_dynamic_bans(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string result="0";
        string reason="";

        bool was_dns=true;

        vector<c_channel_def>::iterator i1;
        for(i1=r_channel_defs.begin(); i1!=r_channel_defs.end(); ++i1) {
            if(!irc_cmp_strings_case_insensitive((*i1).channel_name,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()))) {
                string nick=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
                string ident=irc_get_ident(nick);
                string host=irc_get_host(nick);

                map<string,string>::iterator i2;
                for(i2=(*i1).dynamic_bans.begin(); i2!=(*i1).dynamic_bans.end(); ++i2) {
                    string mask=(*i2).first;
                    if(logic_check_mask(mask,nick+"!"+ident+"@"+host,"*","*",was_dns)) {
                        result="1";
                        reason=(*i2).second;
                        break;
                    }
                }
                break;
            }
        }
        if(!was_dns)
            result+="2";

        {
            c_index_base* idx=MY_NEW c_index_str(st.top().proc_cmd.get_str_arg(3));
            c_var_string* val=MY_NEW c_var_string(result);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
        {
            c_index_base* idx=MY_NEW c_index_str(st.top().proc_cmd.get_str_arg(2));
            c_var_string* val=MY_NEW c_var_string(reason);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
        eval_cleanup_timeout();
    }
}

MY_STATIC void eval_evaluate_proc__dcc_server(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    dcc_make_server(4,st.top().proc_cmd.get_int_arg(0),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),(unsigned short)st.top().proc_cmd.get_int_arg(2),st.top().proc_cmd.get_str_arg(3));
}

MY_STATIC void eval_evaluate_proc__dcc_server_ipv6(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    dcc_make_server(6,st.top().proc_cmd.get_int_arg(0),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),(unsigned short)st.top().proc_cmd.get_int_arg(2),st.top().proc_cmd.get_str_arg(3));
}

MY_STATIC void eval_evaluate_proc__telnet_server(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    dcc_make_telnet_server(4,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),(unsigned short)st.top().proc_cmd.get_int_arg(1));
}

MY_STATIC void eval_evaluate_proc__telnet_server_ipv6(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    dcc_make_telnet_server(6,logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),(unsigned short)st.top().proc_cmd.get_int_arg(1));
}

MY_STATIC void eval_evaluate_proc__ssl_server(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    dcc_make_telnet_server(st.top().proc_cmd.get_int_arg(0),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),(unsigned short)st.top().proc_cmd.get_int_arg(2),true);
}

MY_STATIC void eval_evaluate_proc__ident(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        pair<string,string> p;
        p.first=st.top().proc_cmd.get_str_arg(1);
        p.second=irc_get_ident(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()));
        {
            c_index_base* idx=MY_NEW c_index_str(p.first);
            c_var_string* val=MY_NEW c_var_string(p.second);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__host(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        pair<string,string> p;
        p.first=st.top().proc_cmd.get_str_arg(1);
        p.second=irc_get_host(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()));
        {
            c_index_base* idx=MY_NEW c_index_str(p.first);
            c_var_string* val=MY_NEW c_var_string(p.second);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__get_chan_mode(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        pair<string,string> p;
        p.first=st.top().proc_cmd.get_str_arg(1);
        string topic;
        p.second=irc_get_chan_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),topic);
        {
            c_index_base* idx=MY_NEW c_index_str(p.first);
            c_var_string* val=MY_NEW c_var_string(p.second);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__topic(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string msg="TOPIC ";
        msg+=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        msg+=" :";
        msg+=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        irc_putserv(c_tracked_msg_to_server(msg),true,HIGH_PRIORITY);
    }
}

MY_STATIC void eval_evaluate_proc__get_chan_topic(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        pair<string,string> p;
        p.first=st.top().proc_cmd.get_str_arg(1);
        string topic;
        irc_get_chan_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug()),topic);
        p.second=topic;
        {
            c_index_base* idx=MY_NEW c_index_str(p.first);
            c_var_string* val=MY_NEW c_var_string(p.second);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__script(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=4)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string cs=st.top().proc_cmd.get_str_arg(3);
        if(cs.length()>0 && cs[0]=='(')
            cs.erase(0,1);

        vector<string> params;
        bool str=false;
        string p;
        unsigned int i2;
        for(i2=0; i2<cs.length(); ++i2) {
            if(cs[i2]=='"') {
                str=!str;
                continue;
            }
            if(!str && cs[i2]==',') {
                if(p.length()>0 && p[0]=='$') {
                    try {
                        c_index_str idx(p);
                        c_var_base* val=st.top().vars_->get(st.top().this_module_,&idx,false,st.top().proc_cmd.get_debug());
                        if(val) {
                            p=val->to_string(st.top().this_module_);
                        } else {
                            p="";
                        }
                    } catch(c_var_exception e) {
                        //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                        c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                        ee.report(true);
                        p="";
                    }
                }
                params.push_back(p);
                p="";
                continue;
            }
            if(!str && cs[i2]==')') {
                if(p.compare("")) {
                    if(p.length()>0 && p[0]=='$') {
                        try {
                            c_index_str idx(p);
                            c_var_base* val=st.top().vars_->get(st.top().this_module_,&idx,false,st.top().proc_cmd.get_debug());
                            if(val) {
                                p=val->to_string(st.top().this_module_);
                            } else {
                                p="";
                            }
                        } catch(c_var_exception e) {
                            //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                            c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                            ee.report(true);
                            p="";
                        }
                    }
                    params.push_back(p);
                }
                break;
            }
            p+=cs[i2];
        }

        vector<c_var_base*> prs;
        vector<string>::iterator i3;
        for(i3=params.begin(); i3!=params.end(); ++i3) {
            c_var_string* p=MY_NEW c_var_string(*i3);
            prs.push_back(p);
        }

        vector<string> flags;
        string type=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        if(type.find("@")!=string::npos) {
            string fl=type;
            type.erase(type.find("@"),type.length()-type.find("@"));
            fl.erase(0,fl.find("@")+1);
            explode(fl,',',flags,true);
        }

        st.top().this_module_->exec_script(type,st.top().proc_cmd.get_int_arg(1),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),prs,flags);

        vector<c_var_base*>::iterator i4;
        for(i4=prs.begin(); i4!=prs.end(); ++i4)
            if(*i4)
                MY_DELETE(*i4);
    }
}

MY_STATIC void eval_evaluate_proc__link(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=6)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string host=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug());
        if(host.find(":",0)==string::npos) {
            in_addr ip;
            e_resolv_result res=threads_resolve4(host.c_str(),ip,RT_RESOLVE_SCHEDULE);
            if(RR_SCHEDULED==res) {
                c_delay_link dl;
                dl.botname=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
                dl.localip=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
                dl.bot_host=host;
                dl.botport=(unsigned short)st.top().proc_cmd.get_int_arg(4);
                dl.remote_MD5_password=dcc_get_password(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()));
                dl.bot_link_type=st.top().proc_cmd.get_str_arg(0);
                dl.unlink_proc=st.top().proc_cmd.get_str_arg(5);
                //dl.vars=MY_NEW c_var_array(*st.top().vars_);
                var_keeper->set_current_local(var_keeper->register_local(dl.vars,st.top().vars_,__FILE__,__my_func__,__LINE__));
                dl.this_module=st.top().this_module_;
                botnet_delay_link.push_back(dl);
                return;
            }
            uint32 ip_;
            memcpy(&ip_,&ip,sizeof(ip_));
            if(ip_) {
                char tmp[128+1];
                tmp[0]=0;
                my_inet_ntop(AF_INET,&ip_,tmp,128);
                botnet_link(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),tmp,(unsigned short)st.top().proc_cmd.get_int_arg(4),dcc_get_password(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())),st.top().proc_cmd.get_str_arg(0),st.top().proc_cmd.get_str_arg(5),st.top().vars_,st.top().this_module_);
            }
        } else {
            botnet_link(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),host,(unsigned short)st.top().proc_cmd.get_int_arg(4),dcc_get_password(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug())),st.top().proc_cmd.get_str_arg(0),st.top().proc_cmd.get_str_arg(5),st.top().vars_,st.top().this_module_);
        }
    }
}

MY_STATIC void eval_evaluate_proc__chan_mode(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    irc_chan_mode(logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug()),logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug()),st.top().proc_cmd.get_int_arg(0));
}

MY_STATIC void eval_evaluate_proc__load_module(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string name=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        c_delay_command c;
        c.type=c_delay_command::DELAY_LOAD;
        c.mod_name=name;
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__unload_module(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string name=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        c_delay_command c;
        c.type=c_delay_command::DELAY_UNLOAD;
        c.mod_name=name;
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__bind(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=6)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_delay_command c;
        c.type=c_delay_command::DELAY_BIND;
        c.mod_name=st.top().this_module_->get_mod_name();
        c.type_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        c.user_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        c.channel_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
        c.line_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug());
        c.before=TO_BOOL(st.top().proc_cmd.get_int_arg(4));
        c.func=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(5),st.top().vars_,st.top().proc_cmd.get_debug());
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__unbind(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=6)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_delay_command c;
        c.type=c_delay_command::DELAY_UNBIND;
        c.mod_name=st.top().this_module_->get_mod_name();
        c.type_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        c.user_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        c.channel_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
        c.line_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug());
        c.before=TO_BOOL(st.top().proc_cmd.get_int_arg(4));
        c.func=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(5),st.top().vars_,st.top().proc_cmd.get_debug());
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__bind_ex(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=6)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_delay_command c;
        c.type=c_delay_command::DELAY_BIND_EX;
        c.mod_name=st.top().this_module_->get_mod_name();
        c.type_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        c.user_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        c.channel_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
        c.line_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug());
        c.before=TO_BOOL(st.top().proc_cmd.get_int_arg(4));
        c.func=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(5),st.top().vars_,st.top().proc_cmd.get_debug());
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__unbind_ex(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=6)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_delay_command c;
        c.type=c_delay_command::DELAY_UNBIND_EX;
        c.mod_name=st.top().this_module_->get_mod_name();
        c.type_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        c.user_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        c.channel_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(2),st.top().vars_,st.top().proc_cmd.get_debug());
        c.line_mask=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(3),st.top().vars_,st.top().proc_cmd.get_debug());
        c.before=TO_BOOL(st.top().proc_cmd.get_int_arg(4));
        c.func=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(5),st.top().vars_,st.top().proc_cmd.get_debug());
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__load_bin_module(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string name=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string so_name=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        c_delay_command c;
        c.type=c_delay_command::DELAY_LOAD_BIN;
        c.mod_name=name;
        c.so_name=so_name;
        c.debug=st.top().proc_cmd.get_debug();

        delay_commands.push_back(c);
    }
}

MY_STATIC void eval_evaluate_proc__set(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string retval=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string ret_var=st.top().proc_cmd.get_str_arg(1);

        {
            c_index_base* idx=MY_NEW c_index_str(ret_var);
            c_var_string* val=MY_NEW c_var_string(retval);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__get_nick_mode(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=3)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string channel=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(0),st.top().vars_,st.top().proc_cmd.get_debug());
        string nick=logic_eval(st.top().this_module_,st.top().proc_cmd.get_str_arg(1),st.top().vars_,st.top().proc_cmd.get_debug());
        string res_var=st.top().proc_cmd.get_str_arg(2);
        string res=irc_get_mode(channel,nick);
        {
            c_index_base* idx=MY_NEW c_index_str(res_var);
            c_var_string* val=MY_NEW c_var_string(res);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__get_bot_nick(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string res_var=st.top().proc_cmd.get_str_arg(0);
        string res;
        if(irc_nick_confirmed)
            res=irc_nick;
        else
            res="0";

        {
            c_index_base* idx=MY_NEW c_index_str(res_var);
            c_var_string* val=MY_NEW c_var_string(res);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__get_event_id(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string res_var=st.top().proc_cmd.get_str_arg(0);
        string res=event_id;
        {
            c_index_base* idx=MY_NEW c_index_str(res_var);
            c_var_string* val=MY_NEW c_var_string(res);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

MY_STATIC void eval_evaluate_proc__get_current_irc_server(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=2)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        c_index_base* idx=MY_NEW c_index_str(st.top().proc_cmd.get_str_arg(0));
        c_var_string* val=MY_NEW c_var_string(irc_server_host);
        try {
            c_index_base* idx2=idx->copy();
            st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
            c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
            if(test) {
                // it is read-only, so delete
                MY_DELETE(val);
                val=NULL;
            } else {
                // ok to set
                st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
            }
        } catch(c_var_exception e) {
            //e.print_oops_to_log(st.top().proc_cmd.get_debug());
            c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
            ee.report(true);
            if(val)
                MY_DELETE(val);
        }
    }
    {
        c_index_base* idx=MY_NEW c_index_str(st.top().proc_cmd.get_str_arg(1));
        c_var_int* val=MY_NEW c_var_int(irc_server_port);
        try {
            c_index_base* idx2=idx->copy();
            st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
            c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
            if(test) {
                // it is read-only, so delete
                MY_DELETE(val);
                val=NULL;
            } else {
                // ok to set
                st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
            }
        } catch(c_var_exception e) {
            //e.print_oops_to_log(st.top().proc_cmd.get_debug());
            c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
            ee.report(true);
            if(val)
                MY_DELETE(val);
        }
    }
}

MY_STATIC void eval_evaluate_proc__get_bot_name(stack<c_eval_iteration>& st)
{
    if(st.top().proc_cmd.get_num_args()!=1)
        THROW_C_PROC_EXC(st.top().this_module_,st.top().proc_cmd.get_command(),c_proc_exc::E_NUM_ARGS,st.top().proc_cmd.get_debug());

    {
        string res_var=st.top().proc_cmd.get_str_arg(0);
        extern string botnet_botname;
        string res=botnet_botname;
        {
            c_index_base* idx=MY_NEW c_index_str(res_var);
            c_var_string* val=MY_NEW c_var_string(res);
            try {
                c_index_base* idx2=idx->copy();
                st.top().vars_->unset(st.top().this_module_,idx2,st.top().proc_cmd.get_debug());
                c_var_base* test=st.top().vars_->get(st.top().this_module_,idx,false,"");
                if(test) {
                    // it is read-only, so delete
                    MY_DELETE(val);
                    val=NULL;
                } else {
                    // ok to set
                    st.top().vars_->set(st.top().this_module_,idx,val,false,st.top().proc_cmd.get_debug());
                }
            } catch(c_var_exception e) {
                //e.print_oops_to_log(st.top().proc_cmd.get_debug());
                c_eval_runtime_error ee(st.top().this_module_,e,__FILE__,__my_func__);
                ee.report(true);
                if(val)
                    MY_DELETE(val);
            }
        }
    }
}

