/***************************************************************************
                          c_delay_command.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_delay_command.h,v 1.15 2008/08/23 15:10:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_delay_command'
    \version $Id: c_delay_command.h,v 1.15 2008/08/23 15:10:46 ghostvoodooman Exp $
*/

#ifndef C_DELAY_COMMAND_H__
#define C_DELAY_COMMAND_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Stores delayed command
    \author VooDooMan
    \version 1
    \date 2005
*/
struct c_delay_command
{
    enum e_type
    {
        DELAY_LOAD,             //!< Load module
        DELAY_UNLOAD,           //!< Unload module
        DELAY_BIND,             //!< Bind event ("bind")
        DELAY_UNBIND,           //!< Unbind event ("unbind")
        DELAY_LOAD_BIN,         //!< Load binary module
        DELAY_BIND_EX,          //!< Bind event with mask or regexp ("bind_ex")
        DELAY_UNBIND_EX,        //!< Unbind event with mask or regexp ("unbind_ex")
    };                          //!< Commnad type

    e_type type;                //!< Command type

    string mod_name;            //!< Module name

    string type_mask;           //!< Event's type mask
    string user_mask;           //!< Event's user mask
    string channel_mask;        //!< Event's channel mask
    string line_mask;           //!< Event's line mask
    bool before;                //!< If to throw before processing
    string func;                //!< Name of function as handler

    string so_name;             //!< Shared object/DLL name for binary module

    string debug;               //!< Debug string
};

#endif

