/***************************************************************************
                          c_eval_iteration.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_eval_iteration.cpp,v 1.16 2008/06/08 08:43:14 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_eval_iteration'
    \version $Id: c_eval_iteration.cpp,v 1.16 2008/06/08 08:43:14 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_eval_iteration.h"
#include "../func/c_function.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

void c_eval_iteration::clear()
{
    symbol_table_=NULL;
    vars_=NULL;
    is_return_=false;
    this_module_=NULL;

    self_test=false;

    symbol_table_to_destroy=NULL;

    fn_args.clear();
    arg_names.clear();
    end_func_call=NULL;

    while(!foreach_stack.empty())
        foreach_stack.pop();
    cases.clear();
    child_vars=NULL;

    c=NULL;
    c2=NULL;
    c_if=NULL;
    c_exp=NULL;
    c3=NULL;

    fn_exp=NULL;

    micro_error=NULL;

    skip_block=false;

    id=0;

    fn_destroy=false;
    fn_destroy_mc=false;
    instruct_id=0;

    exception_reported=false;

    return_value=NULL;
    result=VAR_SYM_INDEX_INVALID;

    processed=false;

    fn=NULL;

    retval_store_to=VAR_SYM_INDEX_INVALID;

    loop_was_broken=loop_was_continued=false;

    func_call_ok=true;

    save_return_value=false;

    local_id=0;

    parent=NULL;

    last_exp=NULL;
    error_debug_string.clear();

    is_core_module_entrypoint=false;

    m_last_pcre_exec_return_code=PREG_NO_ERROR;

    proc_eval=false;
}

c_eval_iteration::c_eval_iteration(c_module* this_module, c_var_array* vars, const string& UNUSEDARG(debug))
    : proc_cmd(this_module, -1, -1, "Internal error: Uninitialised procedure command within 'c_eval_iteration' class construction #2")
{
    clear();

    this_module_=this_module;

    vars_=vars;
    symbol_table_=NULL;

    fn_exp=NULL;
}

c_eval_iteration::c_eval_iteration(c_module* this_module, c_micro_symbol_table* symbol_table, c_var_array* vars, const string& UNUSEDARG(next_expression), c_expression* exp)
    : proc_cmd(this_module, -1, -1, "Internal error: Uninitialised procedure command within 'c_eval_iteration' class construction #1")
{
    clear();

    this_module_=this_module;

    vars_=vars;
    symbol_table_=symbol_table;

    fn_exp=exp;
}

