/***************************************************************************
                          c_eval_iteration.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_eval_iteration.h,v 1.15 2008/07/02 09:35:51 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_eval_iteration'
    \version $Id: c_eval_iteration.h,v 1.15 2008/07/02 09:35:51 ghostvoodooman Exp $
*/

#ifndef S_EVAL_ITERATION_H__
#define S_EVAL_ITERATION_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

class c_micro_symbol_table;
class c_micro_error;
class c_function;

#include "../func/c_foreach.h"
#include "../func/c_foreach_refs.h"
#include "../func/c_fn_cmd_switch.h"
#include "../func/c_fn_cmd_foreach.h"
#include "../func/c_func_arg.h"
#include "../func/c_fn_cmd_if.h"
#include "../func/c_fn_cmd_exp.h"
#include "../func/c_fn_cmd_case.h"
#include "../proc/c_procedure.h"
#include "../script_consts/script_consts.h"

class c_fn_cmd_case;
class c_fn_cmd_exp;
class c_fn_cmd_foreach;
class c_fn_cmd_if;

struct c_eval_iteration     //!< Used for iterative evaluation operation
{
    c_micro_symbol_table* symbol_table_;
    c_micro_symbol_table* symbol_table_to_destroy;
    c_var_array* vars_;
    bool is_return_;

    bool self_test;

    c_module* this_module_;

    c_var_base* return_value;
    var_sym_index_t result;
    bool save_return_value;

    c_micro_error* micro_error;
    bool exception_reported;
    instruct_id_t instruct_id;

    int state;
    bool processed;
    int return_to_state;

    // function call
    string func_name;
    var_sym_index_t retval;
    var_sym_index_t retval_store_to;
    string error;
    bool func_call_ok;
    map<string,c_function*>::iterator f;
    vector<c_func_arg> fn_args;
    vector<string> arg_names;
    c_function* fn;
    c_expression* fn_exp;
    bool fn_destroy;    //!< Temporary function helper
    bool fn_destroy_mc; //!< Destroy microcode as well (temporary pseudo-function was generated)
    c_eval_iteration* end_func_call;
    bool ok_fn;
    bool eval_func;

    // function
    stack<c_foreach> foreach_stack;
    c_foreach_refs refs;
    bool loop_was_broken;
    bool loop_was_continued;
    long id;
    map<long,c_fn_cmd*>::iterator i1_fn, i1_fn2;
    c_fn_cmd_switch* sw_c;
    vector<long> cases;
    vector<long>::iterator ci;
    c_var_base* sw_res;
    c_foreach b_fn;
    //

    // procedure: BEGIN
    // vars
    // debug
    // this_module
    c_procedure proc;
    deque<c_proc_command>::iterator proc_iter;
    deque<c_proc_command>::iterator redirect_checkpoint_iter;
    c_proc_command proc_cmd;
    int goto_line;
    bool after_redirect;
    bool redirect_checkpoint;
    bool do_redirect;
    bool r_checkpoint;
    // 'eval' command
    bool proc_eval;
    string proc_eval_ret_var;
    // fn

    bool proc_execute;
    string func_call_string;
    string proc_eval_code;
    // proc: END

    // again_state_1008
    bool fall_thru;

    e_exp_result iterative_result;

    // again_state_100
    c_var_array* child_vars;

    c_fn_cmd_switch* c;
    c_fn_cmd_foreach* c2;
    var_sym_index_t res_1004;
    c_micro_error* error_1004;
    bool is_return_1004;

    bool skip_block;

    c_fn_cmd_if* c_if;
    c_fn_cmd_exp* c_exp;

    deque<pair<var_id_t, string> > updates;

    c_fn_cmd_case* c3;

    unsigned local_id;                  //!< Local variables root node ID

    c_eval_iteration* parent;

    c_fn_cmd* last_exp;
    string error_debug_string;

    bool is_core_module_entrypoint;

    int m_last_pcre_exec_return_code;

    c_eval_iteration(c_module* this_module, c_micro_symbol_table* symbol_table, c_var_array* vars, const string& next_expression, c_expression* exp);

    // constructor for procedures
    c_eval_iteration(c_module* this_module, c_var_array* vars, const string& debug);

    void clear();
};

#endif

