/***************************************************************************
                          c_timer.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_timer.h,v 1.15 2008/03/25 12:04:29 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_timer'
    \version $Id: c_timer.h,v 1.15 2008/03/25 12:04:29 ghostvoodooman Exp $
*/

#ifndef C_TIMER_H__
#define C_TIMER_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../var/c_var_array.h"

/*!
    \brief Stores active timers
    \author VooDooMan
    \version 1
    \date 2004
*/
class c_timer
{
public:
    bool once;                                      //!< Has to be timer event raised only once? If true, after raising MY_DELETE(i)t
    string name;                                    //!< Name of timer
    my_time_t set_at;                                  //!< Time when timer was set
    my_time_t again_at;                                //!< Time when timer should be raised
    long duration;                                  //!< Number of seconds between set_at and again_at

    bool bot_unlink_timer;                          //!< If this timer is intended for use when remote bot is unlinked
    bool bot_unlink_trigger;                        //!< Trigger this timer as soon as possible (remote bot has been unlinked)

    string expression;                              //!< Expression to execute

    c_var_array* vars;                              //!< Array of local variables, stored state at timer's set time

    string debug;                                   //!< Debug string, used in case of error

    bool erase;                                     //!< Erase this timer as soon as possible

    c_timer();

    c_timer(const c_timer& orig);

    ~c_timer();
};

#endif

