/***************************************************************************
                          c_tmp_file.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_tmp_file.h,v 1.15 2008/03/25 12:04:29 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_tmp_file'
    \version $Id: c_tmp_file.h,v 1.15 2008/03/25 12:04:29 ghostvoodooman Exp $
*/

#ifndef C_TMP_FILE_H__
#define C_TMP_FILE_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../exec.h"

/*!
    \brief Stores temporary values for process execution, for example, of script
    \author VooDooMan
    \version 1
    \date 2004
*/
class c_tmp_file
{
public:
    c_exec_handle* h;                               //!< Handle of process
    bool script;                                    //!< Is it a script process?

    int script_num;                                 //!< Number of script (if script==true) - for concurrency detection

    string script_type;                             //!< Type of script (e.g. "php")

    string command_line;                            //!< Command line
    string command_args;                            //!< Command arguments
    string command_dir;                             //!< Process's working directory
    bool has_been_run;                              //!< true if script has been run (for concurrency detection)

    my_time_t start_up_time;                           //!< Timestamp when script was run, or zero if it wasn't

    bool noremove;                                  //!< "noremove" flag: if 'true', do not remove temporary file after processing
    string filename;                                //!< Name of file with full path

    c_tmp_file();
};

#endif

