/***************************************************************************
                          script_consts.h  -  description
                             -------------------
    begin                : Wed Feb 06 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: script_consts.h,v 1.8 2008/03/11 21:11:48 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Defines constants for function scripting
    \version $Id: script_consts.h,v 1.8 2008/03/11 21:11:48 ghostvoodooman Exp $
*/

#ifndef script_consts_H__
#define script_consts_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../utils/memleak.h"

#include "../var/c_var_base.h"

#include "../params.h"

enum
{
    MY_SEEK_SET = 0,    //!< Constant for fseek() built-in function
    MY_SEEK_CUR = 1,    //!< Constant for fseek() built-in function
    MY_SEEK_END = 2,    //!< Constant for fseek() built-in function
};

enum
{
    MY_CASE_SERVER = 0,     //!< Constant for strtolower(), strtoupper() built-in functions
    MY_CASE_ASCII = 1,      //!< Constant for strtolower(), strtoupper() built-in functions
    MY_CASE_RFC1459 = 2,    //!< Constant for strtolower(), strtoupper() built-in functions
};

enum
{
    CRITICAL_PRIORITY = 1,  //!< Command is sent immediately
    HIGH_PRIORITY = 2,      //!< Command is put to high-priority queue
    LOW_PRIORITY = 3,       //!< Command is put to low-priority queue
};

#define LOGIC_TXT_CONST_LOW         "LOW"
#define LOGIC_TXT_CONST_HIGH        "HIGH"
#define LOGIC_TXT_CONST_CRITICAL    "CRITICAL"

enum
{
    PREG_GREP_INVERT =          0x0001, //!< 'preg_grep()' flag

    PREG_PATTERN_ORDER =        0x0002, //!< 'preg_match_all()' flag; 'preg_match()' flag
    PREG_SET_ORDER =            0x0004, //!< 'preg_match_all()' flag
    PREG_OFFSET_CAPTURE =       0x0008, //!< 'preg_match_all()' flag

    PREG_SPLIT_NO_EMPTY =       0x0010, //!< 'preg_split()' flag
    PREG_SPLIT_DELIM_CAPTURE =  0x0020, //!< 'preg_split()' flag
    PREG_SPLIT_OFFSET_CAPTURE = 0x0040, //!< 'preg_split()' flag
};

enum
{
    PREG_NO_ERROR = 0,          //!< No error occurred on last call to 'preg_*()' built-in function
};

/*!
    \brief Tries to translate built-in constant in processing of functions in internal scripts
    \author VooDooMan
    \version 1
    \date 2008-02-06
    \param str String to translate
    \param translated Returns variable if translation was successful, otherwise NULL
    \retval true Succeeded
    \retval false No such constant (nothing found); 'translated' == NULL
*/
bool script_function_translate_constant(const string& str, c_var_base* &translated);

/*!
    \brief Checks for built-in constant in processing of functions in internal scripts
    \author VooDooMan
    \version 1
    \date 2008-02-06
    \param str String to translate
    \retval true Succeeded
    \retval false No such constant (nothing found)
*/
bool script_function_translate_constant(const string& str);

string get_strerr_pcre_exec(int rc);

#endif

