/***************************************************************************
                          stats.h  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: stats.h,v 1.43 2008/03/11 21:11:31 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides some statistics
    \version $Id: stats.h,v 1.43 2008/03/11 21:11:31 ghostvoodooman Exp $
*/

#ifndef STATS_H__
#define STATS_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include <time.h>

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

using namespace std;

void stats_init();
void stats_irc_bytes_sent(size_t bytes);
void stats_irc_bytes_received(size_t bytes);
void stats_irc_new_connection(string irc_server_host, unsigned short irc_server_port);
void stats_dcc_chat_bytes_sent(size_t bytes);
void stats_dcc_chat_bytes_received(size_t bytes);
void stats_dcc_send_bytes_sent(size_t bytes);
void stats_dcc_send_bytes_received(size_t bytes);
void stats_dcc_chat_new_connection();
void stats_dcc_send_new_connection();
void stats_botnet_bytes_sent(size_t bytes);
void stats_botnet_bytes_received(size_t bytes);
void stats_dcc_send_bytes_received(size_t bytes);
void stats_botnet_new_connection();
void stats_botnet_proc_pushed();
void stats_botnet_proc_pulled();
void stats_botnet_user_pushed();
void stats_botnet_user_pulled();
void stats_botnet_chandef_pushed();
void stats_botnet_chandef_pulled();
void stats_botnet_private_pushed();
void stats_botnet_private_pulled();
void stats_botnet_partyline_event();
void stats_botnet_auth_ok();
void stats_botnet_auth_error();
void stats_botnet_auth_proto_error();
void stats_mail_sent();
void stats_identd_new_connection();
void stats_identd_bytes_sent(size_t bytes);
void stats_identd_bytes_received(size_t bytes);

void stats_display(list<string>& lines, string lang, bool only_heap_debug = false);

MY_U_LONG_LONG stats_uptime();
MY_U_LONG_LONG stats_cpu_time();

#endif

