/***************************************************************************
                          assert.h  -  description
                             -------------------
    begin                : Thu Dec 28 2006
    copyright            : (C) 2006-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: assert.h,v 1.15 2008/11/24 12:09:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides assert for debugging
    \version $Id: assert.h,v 1.15 2008/11/24 12:09:46 ghostvoodooman Exp $
*/

#ifndef ASSERT_H__
#define ASSERT_H__

#include "prologue.h"

int dump_core();
int report_assertion_failure(const char* file, const char* func, int line, const char* exp);

#if 1==DEBUG_WANT_ASSERTS
#   define MY_ASSERT(exp) (void)((exp) || (report_assertion_failure(__FILE__,__my_func__,__LINE__,#exp), dump_core()))
#else
#   define MY_ASSERT(exp) (void)((exp) || report_assertion_failure(__FILE__,__my_func__,__LINE__,#exp))
#endif

#define MY_ASSERT_NOTREACH()   \
    {   \
        enum {  \
            INTERNAL_ERROR__CODE_SHOULD_NOT_GO_HERE__PLEASE_REPORT_THIS_PROBLEM = 0,    \
        };  \
        MY_ASSERT(INTERNAL_ERROR__CODE_SHOULD_NOT_GO_HERE__PLEASE_REPORT_THIS_PROBLEM); \
    }

#define MY_ASSERT_TODO(str)    \
    {                       \
        enum {              \
            str = 0,        \
        };                  \
        MY_ASSERT(str);   \
    }


#ifdef assert
#   undef assert
#endif

#define assert BUG__WE_GOT_OUR_VERSION_OF_ASSERT__PLEASE_CORRECT *** choke me ***

#endif

