/***************************************************************************
                          my_inttypes.cpp  -  description
                             -------------------
    begin                : Tue Aug 14 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: my_inttypes.h,v 1.13 2008/03/11 21:11:48 ghostvoodooman Exp $ */

/************************************************************************
 *   IRC - Internet Relay Chat, common/match.c
 *   Copyright (C) 1990 Jarkko Oikarinen
 *   Copyright (C) 2004-2008 by Marian VooDooMan Meravy
 *     (ghostvoodooman -a.T= users (dot) sourceforge.net)
 *     (re-coded from C to C++)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*!
    \file
    \brief Provides various integer types
    \version $Id: my_inttypes.h,v 1.13 2008/03/11 21:11:48 ghostvoodooman Exp $
*/

#ifndef MY_INTTYPES_H__
#define MY_INTTYPES_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#if defined(HAVE_CONFIG_H)
#   if SIZEOF_LONG == 4
typedef unsigned long uint32;
typedef signed long sint32;
#   else
#       if SIZEOF_INT == 4
typedef unsigned int uint32;
typedef signed int sint32;
#       else
#           error Cannot define type 'uint32' to be 4 bytes long.
#       endif
#   endif
#else
#   ifdef __alpha
typedef unsigned int uint32;
typedef signed int sint32;
#   else
typedef unsigned long uint32;
typedef signed long sint32;
#   endif
#endif

#endif // MY_INTTYPES_H__

