/***************************************************************************
                          c_parse_flags.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: parse_flags.cpp,v 1.18 2008/06/16 06:04:51 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Flags parser
    \version $Id: parse_flags.cpp,v 1.18 2008/06/16 06:04:51 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "parse_flags.h"

#include "../utils/precomp.h"

vector<string> parse_flags(const string& irc_type)
{
    vector<string> flags;
    string current;
    bool in=false;
    for(unsigned i1=0; i1<irc_type.length(); ++i1) {
        if(!in && irc_type[i1]=='@') {
            in=true;
            current="@";
            continue;
        }
        if(in && irc_type[i1]=='@') {
            in=false;
            current+="@";
            flags.push_back(current);
            current="";
            continue;
        }
        if(in)
            current+=(string)""+(irc_type[i1]);
    }
    return flags;
}

