/***************************************************************************
                          c_var_unset.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_var_unset.cpp,v 1.16 2008/06/08 08:43:14 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_var_unset'
    \version $Id: c_var_unset.cpp,v 1.16 2008/06/08 08:43:14 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_var_unset.h"
#include "c_var_bool.h"
#include "../var_keeper.h"

#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_var_bool* c_var_unset::to_bool()
{
    return MY_NEW c_var_bool(is_true());
}

c_var_unset::c_var_unset()
    : c_var_base()
{
    var_keeper->include_into_locals(this);
}

c_var_unset::c_var_unset(const c_var_unset& orig)
    : c_var_base(orig)
{
    //var_keeper->include_into_locals(this);
}

c_var_unset::c_var_unset(const c_var_unset& orig, int)
    : c_var_base(orig)
{
}

e_vartype c_var_unset::get_var_type()
{
    return VARTYPE_UNSET;
}

e_vartype c_var_unset::get_var_type() const
{
    return VARTYPE_UNSET;
}

string c_var_unset::get_var_type_as_string()
{
    return (string)"UNSET";
}

c_var_unset* c_var_unset::copy()
{
    c_var_unset* res=MY_NEW c_var_unset(*this,0);
    res->set_persistent(false);
    res->set_read_only(false);
    res->reset_id();
    res->id=var_keeper->alloc(res);
    res->set_session(var_keeper->get_current_session());
    var_keeper->include_into_locals(res);
    return res;
}

string c_var_unset::dump(c_module* UNUSEDARG(this_module))
{
    return (string)"NULL";
}

void c_var_unset::dump_for_botnet(c_module* UNUSEDARG(this_module), char* &data, size_t& size)
{
    size=1+1;
    char* d=MY_NEW char[size];
    d[0]='U'; // 'U' stands for unset
    d[1]=0;
    data=d;
}

string c_var_unset::get_script_string(c_module* UNUSEDARG(this_module), const string& script_type)
{
    if(!script_type.compare("php") || !script_type.compare("php_2") || !script_type.compare("logic.txt")) {
        return (string)"NULL";
    }
    else if(!script_type.compare("perl")) {
        // TODO: Verify this:
        return (string)"0";
    }

    // error, not supported script
    return (string)"";
}

c_var_base* c_var_unset::copy(int)
{
    c_var_unset* res=MY_NEW c_var_unset(*this,0);
    res->set_persistent(false);
    res->set_read_only(false);
    res->reset_id();
    res->id=var_keeper->alloc(res);
    res->set_session(var_keeper->get_current_session());
    //var_keeper->include_into_locals(res);
    return res;
}

c_index_base* c_var_unset::make_index()
{
    // invalid index
    return NULL;
}

bool c_var_unset::is_true()
{
    return false;
}

bool c_var_unset::is_true() const
{
    return false;
}

string c_var_unset::to_string(c_module* UNUSEDARG(this_module))
{
    return (string)"";
}

string c_var_unset::to_string(c_module* UNUSEDARG(this_module)) const
{
    return (string)"";
}

c_var_unset::~c_var_unset()
{
}

bool c_var_unset::operator==(const string& UNUSEDARG(right)) const
{
    return false;
}

bool c_var_unset::operator==(const MY_LONG_LONG& UNUSEDARG(right)) const
{
    return false;
}

