/***************************************************************************
                          compat.h  -  description
                             -------------------
    begin                : Thu Jul 31 2005
    copyright            : (C) 2005-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: compat.h,v 1.25 2008/03/11 21:11:50 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2005-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides compatibility functions
    \version $Id: compat.h,v 1.25 2008/03/11 21:11:50 ghostvoodooman Exp $
*/

//---------------------------------------------------------------------------

#ifndef COMPAT_H__
#define COMPAT_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "params.h"

#if defined(HAVE_SIGNED_LONG_LONG) || defined(_MSC_VER) || defined(__BORLANDC__)
#   define MY_LONG_LONG     signed long long
#else
#   define MY_LONG_LONG     signed long
#endif

#if defined(HAVE_UNSIGNED_LONG_LONG) || defined(_MSC_VER) || defined(__BORLANDC__)
#   define MY_U_LONG_LONG   unsigned long long
#else
#   define MY_U_LONG_LONG   unsigned long
#endif

#if defined(_MSC_VER) && _MSC_VER>=1400
#   define _CRT_SECURE_NO_WARNINGS  1   /* MS Visual Stodio 8 ugly warnings against POSIX standard vs. ISO C++ standard functions */
#   pragma warning(disable : 4996)
#endif

#if defined(_MSC_VER) && defined(_DEBUG)
#   include <crtdbg.h>
#endif

#ifdef _MSC_VER
#define __func__ __FUNCTION__
#else

#if defined(HAVE___FUNCTION__)
#   define __func__ __FUNCTION__
#else
#   if defined(__BORLANDC__)
#       define __func__ __FUNC__
#   endif
#   if !defined(__func__)
#       define __func__ "<unknown-your_compiler_doesnt_support_this_feature>"
#   endif
#endif

#if !defined(HAVE___FILE__) && !defined(__FILE__)
#   define __FILE__ "<unknown-your_compiler_doesnt_support_this_feature>"
#endif

#if !defined(HAVE___LINE__) && !defined(__LINE__)
#   define __LINE__ (-1)
#endif

#endif

#include <stdlib.h>

#if defined(_WIN32) || defined(_WIN64)
#   define FILE_SLASH       "\\"
#   define FILE_SLASH_CH    '\\'
#else
#   define FILE_SLASH       "/"
#   define FILE_SLASH_CH    '/'
#endif

#if defined(_WIN32) || defined(_WIN64)
#   include <io.h>
#   include <process.h>
#endif

#ifndef _MSC_VER
#   if (defined(_WIN32) || defined(_WIN64)) && !defined(__CYGWIN__)
#       include <dir.h>
#   else
#       include <sys/types.h>
#       include <sys/stat.h>
#       include <unistd.h>
#       include <fcntl.h>
#   endif
#else
#    include <direct.h>
#    define mkdir _mkdir
#endif

#include <stdio.h>

#ifndef HAVE_SSIZE_T
#   define ssize_t signed long
#endif

#ifdef __BORLANDC__
typedef unsigned long uintptr_t;
#endif

#define MAXIMUM_SIGNED_INT          ((signed)(((unsigned)~-0)/2))
#define MAXIMUM_SIGNED_LONG_LONG    ((MY_LONG_LONG)(((MY_U_LONG_LONG)~-((MY_LONG_LONG)0))/2))

#if !defined(_MSC_VER)
#   define MY_RPT_INFO     1
#   define MY_RPT_ERROR    2
#else
#   define MY_RPT_INFO     _CRT_WARN
#   define MY_RPT_ERROR    _CRT_ERROR
#endif

#if defined(_MSC_VER)
#   define snprintf     _snprintf
#endif

#if !defined(_MSC_VER)
#   define _RPT0(x,str)                                 /* dummy */
#   define _RPT1(x,fmt,arg1)                            /* dummy */
#   define _RPT2(x,fmt,arg1,arg2)                       /* dummy */
#   define _RPT3(x,fmt,arg1,arg2,arg3)                  /* dummy */
#   define _RPT4(x,fmt,arg1,arg2,arg3,arg4)             /* dummy */
#   define MY_HAVE_MSVC                                 false
#   define MSVC_SET_DEBUG_OUTPUTS(enable_file)          /* dummy */
#else
#   define MY_HAVE_MSVC                                 true
#   define MSVC_SET_DEBUG_OUTPUTS(enable_file)     \
        _CrtSetReportMode(_CRT_WARN,_CRTDBG_MODE_DEBUG | (enable_file ? _CRTDBG_MODE_FILE : 0));    \
        _CrtSetReportMode(_CRT_ERROR,_CRTDBG_MODE_DEBUG | (enable_file ? _CRTDBG_MODE_FILE : 0));    \
        _CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_WNDW | _CRTDBG_MODE_DEBUG | _CRTDBG_MODE_FILE);
#endif

void utils_debug_report(int severity, const char* fl, const char* fn, int ln, const char* fmt, ...);

#define MY_RPT0(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__) \
    utils_debug_report(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__)

#define MY_RPT1(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__) \
    utils_debug_report(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__)

#define MY_RPT2(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__,__rptX_arg2__) \
    utils_debug_report(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__,__rptX_arg2__)

#define MY_RPT3(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__,__rptX_arg2__,__rptX_arg3__) \
    utils_debug_report(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__,__rptX_arg2__,__rptX_arg3__)

#define MY_RPT4(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__,__rptX_arg2__,__rptX_arg3__,__rptX_arg4__) \
    utils_debug_report(__rptX_severity__,__rptX_file__,__rptX_func__,__rptX_line__,__rptX_fmt__,__rptX_arg1__,__rptX_arg2__,__rptX_arg3__,__rptX_arg4__)

#if !defined(_DEBUG)
#   undef  MY_RPT0
#   define MY_RPT0(x,file,func,line,str)                           /* disabled */

#   undef  MY_RPT1
#   define MY_RPT1(x,file,func,line,str,arg1)                      /* disabled */

#   undef  MY_RPT2
#   define MY_RPT2(x,file,func,line,str,arg1,arg2)                 /* disabled */

#   undef  MY_RPT3
#   define MY_RPT3(x,file,func,line,str,arg1,arg2,arg3)            /* disabled */

#   undef  MY_RPT4
#   define MY_RPT4(x,file,func,line,str,arg1,arg2,arg3,arg4)       /* disabled */
#endif

#if defined(__CYGWIN__)
#   ifndef WSAAPI
#       define WSAAPI       /* */
#   endif
#   ifndef AF_INET6
#       define AF_INET6     23
#   endif
typedef int socklen_t;
typedef unsigned long DWORD;
typedef unsigned short WORD;
/* getaddrinfo constants */
#define AI_PASSIVE    1
#define AI_CANONNAME    2
#define AI_NUMERICHOST    4

/* getaddrinfo error codes */
#define EAI_AGAIN    WSATRY_AGAIN
#define EAI_BADFLAGS    WSAEINVAL
#define EAI_FAIL    WSANO_RECOVERY
#define EAI_FAMILY    WSAEAFNOSUPPORT
#define EAI_MEMORY    WSA_NOT_ENOUGH_MEMORY
#define EAI_NODATA    WSANO_DATA
#define EAI_NONAME    WSAHOST_NOT_FOUND
#define EAI_SERVICE    WSATYPE_NOT_FOUND
#define EAI_SOCKTYPE    WSAESOCKTNOSUPPORT

#define NI_NOFQDN    0x01
#define NI_NUMERICHOST   0x02
#define NI_NAMEREQD   0x04
#define NI_NUMERICSERV   0x08
#define NI_DGRAM   0x10

#include <stdarg.h>

#define FORMAT_MESSAGE_FROM_SYSTEM 4096
#define FORMAT_MESSAGE_IGNORE_INSERTS 512
#define FORMAT_MESSAGE_MAX_WIDTH_MASK 255
#define LANG_NEUTRAL   0x00
#define SUBLANG_DEFAULT   0x01
typedef char* LPSTR;
#define MAKELANGID(p,s)   ((((WORD)(s))<<10)|(WORD)(p))
#ifndef WINBASEAPI
#ifdef __W32API_USE_DLLIMPORT__
#define WINBASEAPI DECLSPEC_IMPORT
#else
#define WINBASEAPI
#endif
#endif
#define WINAPI __stdcall
#ifndef CONST
#define CONST const
#endif

#if (defined(_WIN32) || defined(_WIN64)) && !defined(__CYGWIN__)
typedef CONST void *PCVOID,*LPCVOID;

extern "C" {
    struct addrinfo
    {
        int     ai_flags;
        int     ai_family;
        int     ai_socktype;
        int     ai_protocol;
        size_t  ai_addrlen;
        char   *ai_canonname;
        struct sockaddr  *ai_addr;
        struct addrinfo  *ai_next;
    };
    extern void WSAAPI freeaddrinfo (struct addrinfo*);
    extern int WSAAPI getaddrinfo (const char*,const char*,const struct addrinfo*,
                    struct addrinfo**);
    extern int WSAAPI getnameinfo(const struct sockaddr*,socklen_t,char*,DWORD,
                   char*,DWORD,int);
    WINBASEAPI DWORD WINAPI FormatMessageA(DWORD,PCVOID,DWORD,DWORD,LPSTR,DWORD,va_list*);
}

static __inline char*
gai_strerrorA(int ecode)
{
   static char message[1024+1];
   DWORD dwFlags = FORMAT_MESSAGE_FROM_SYSTEM
                 | FORMAT_MESSAGE_IGNORE_INSERTS
            | FORMAT_MESSAGE_MAX_WIDTH_MASK;
   DWORD dwLanguageId = MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT);
     FormatMessageA(dwFlags, NULL, ecode, dwLanguageId, (LPSTR)message, 1024, NULL);
   return message;
}
#define gai_strerror gai_strerrorA

#endif // (defined(_WIN32) || defined(_WIN64)) && !defined(__CYGWIN__)

#endif

#endif

