/***************************************************************************
                          numconv.hh  -  description
                             -------------------
    begin                : Sun Aug 19 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: numconv.hh,v 1.12 2008/03/11 21:11:50 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Implements templated number to string conversions
    \version $Id: numconv.hh,v 1.12 2008/03/11 21:11:50 ghostvoodooman Exp $
*/

#ifndef NUMCONV_HH__
#define NUMCONV_HH__

#include <string>
#include <sstream>

template<typename T>
std::string tos(const T& value)
{
    std::ostringstream s;
    s<<value;
    return s.str();
}

template<typename T>
std::string toshex(const T& value)
{
    std::ostringstream s;
    s<<std::hex<<value;
    return s.str();
}

template<typename T>
std::string tos(const T& value, int width, char pad)
{
    std::ostringstream s;
    s.width(width);
    s.fill(pad);
    s<<value;
    return s.str();
}

#endif

