/***************************************************************************
                          match.h  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2006 by VooDooMan
    email                : ghostvoodooman@users.sourceforge.net
 ***************************************************************************/

/* $Id: params.h,v 1.30 2008/03/11 21:11:50 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008  Marian VooDooMan Meravy
                         (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Parameters for compilation
*/

#ifndef _PARAMS_H_
#define _PARAMS_H_

// Un-comment following line to get IPv6 support for your bot
//#define IPv6

#if !defined(USE_OPENSSL)
// dummy define
#define USE_OPENSSL
#endif

#define MY_DELETE_A(x)        delete[] (x)
#define MY_NEW                new

struct in_addr6_
{
    unsigned char bytes[16];            //!< 16 bytes of IPv6 address
};

#define uint32 unsigned int

#if defined(_WIN32) || defined(_WIN64)
#   define UNUSEDARG_WIN(arg)     /* unused argument on _WIN32 */
#else
#   define UNUSEDARG_WIN(arg)     arg
#endif

#ifndef IPv6
#   define UNUSEDARG_NO_IPv6(arg)   /* unused argument: IPv6 is not beeing compiled */
#else
#   define UNUSEDARG_NO_IPv6(arg)   arg
#endif

#define FD_SETSIZE_MAX          (64)

#if !defined(RESOLV_APPEND_DOT)
#   define RESOLV_APPEND_DOT    1
#endif

#define UNUSEDARG               /* unused argument */

#endif

