/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2006  Marian VooDooMan Meravy
                         (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

#include <vector>
#include <string>
#include <time.h>

using namespace std;

#include <windows.h>

#include "stdafx.h"

#ifndef _WIN32
#   define _WIN32
#endif

#include "control.h"
#include "../irc_bot/src/exec.h"

#ifdef _WIN32
#   define FILE_SLASH "\\"
#   define FILE_SLASH_CH '\\'
#else
#   define FILE_SLASH_CH '/'
#endif

struct s_bot {
    s_exec_handle* h;
    char* startup_dir;
    char* fn;
    int seconds;
    time_t start;
    bool died;

    s_bot()
    {
        h=NULL;
        startup_dir=NULL;
        fn=NULL;
        seconds=0;
        start=0;
        died=false;
    }
};

std::vector<s_bot> bots;

void init(char* dir, int seconds)
{
    s_bot bot;

    bot.startup_dir=new char[strlen(dir)+16];
    strcpy(bot.startup_dir,dir);

    bot.fn=new char[strlen(dir)+1024];
    strcpy(bot.fn,dir);
    if(strlen(bot.fn) && bot.fn[strlen(bot.fn)-1]!=FILE_SLASH_CH)
        strcat(bot.fn,FILE_SLASH);
    strcat(bot.fn,"irc_bot.exe");

    bot.h=NULL;
    bot.seconds=seconds;

    bot.died=false;

    std::vector<s_bot>::iterator i1;
    for(i1=bots.begin(); i1!=bots.end(); i1++)
        if(!strcmp((*i1).fn,bot.fn)) {
            delete[] bot.startup_dir;
            delete[] bot.fn;
            return;
        }

    bot.start=0;

    bots.push_back(bot);
}

void start()
{
    std::vector<s_bot>::iterator i;
    for(i=bots.begin(); i!=bots.end(); i++) {
        if((*i).h || (*i).died)
            continue;
        /*if((*i).start==0)
            time(&(*i).start);*/
        if((*i).seconds==0)
            (*i).h=exec_async_exec2((*i).fn,"--service",(*i).startup_dir);
    }
}

void stop()
{
    std::vector<s_bot>::iterator i;
    for(i=bots.begin(); i!=bots.end(); i++)
        if((*i).h) {
            std::string fn=(*i).startup_dir;
            if(fn[fn.length()-1]!=FILE_SLASH_CH)
                fn+=FILE_SLASH;
            fn+="logs";
            fn+=FILE_SLASH;
            fn+="irc_bot.action";
            for(int i1=0; i1<1000; i1++) {
                FILE* f=fopen(fn.c_str(),"w");
                if(!f)
                    Sleep(1);
                else {
                    fputs("die\n",f);
                    fclose(f);
                    break;
                }
            }
        }

    time_t start=time(NULL);

l1:
    for(i=bots.begin(); i!=bots.end(); i++) {
        if((*i).h) {
            while(exec_process_active((*i).h)) {
                Sleep(1);
                if((unsigned)start+20<(unsigned)time(NULL))
                    break;
            }
            if(!exec_process_active((*i).h)) {
                exec_process_end((*i).h);
                delete[] (*i).startup_dir;
                delete[] (*i).fn;
                bots.erase(i);
                goto l1;
            }
        }
    }
    for(i=bots.begin(); i!=bots.end(); i++)
        if((*i).h) {
            exec_terminate_process((*i).h,1);
            delete[] (*i).startup_dir;
            delete[] (*i).fn;
        }
    bots.clear();
}

void loop()
{
again:
    time_t now=time(NULL);
    std::vector<s_bot>::iterator i;
    for(i=bots.begin(); i!=bots.end(); i++) {
        if((*i).start==0)
            (*i).start=now;
        if(!(*i).h && !(*i).died) {
            if((*i).start+(*i).seconds<=now) {
                (*i).h=exec_async_exec2((*i).fn,"--service",(*i).startup_dir);
                (*i).start=0;
            }
            continue;
        }
        if(!(*i).died && !exec_process_active((*i).h) && (*i).start+(*i).seconds<=now) {
            (*i).start=0;
            int ec=2;
            if((*i).h!=NULL)
                ec=exec_process_end((*i).h);
            (*i).h=NULL;
            switch(ec) {
                case 0:
                    (*i).died=true;
                    break;
                case 1:
                    (*i).died=true;
                    break;
                case 2:
                    (*i).h=exec_async_exec2((*i).fn,"--service",(*i).startup_dir);
                    break;
                default:
                    // looks like an unknown error (bug in bot?), so restart
                    (*i).h=exec_async_exec2((*i).fn,"--service",(*i).startup_dir);
                    break;
            }
        }
    }
}

