/***************************************************************************
                          botnet.cpp  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: botnet.cpp,v 1.86 2008/11/24 12:09:23 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides communication between bots linked into botnet
    \version $Id: botnet.cpp,v 1.86 2008/11/24 12:09:23 ghostvoodooman Exp $
*/

//---------------------------------------------------------------------------

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#ifndef _MSC_VER
#   undef MY_STATIC
#   define MY_STATIC    /* broken, doesn't fit into 512 MiB RAM quota with -02 */
#endif

#include "params.h"
#include "utils/memleak.h"
#include "utils/assert.h"
#include "compat.h"

#include "sock_shared.h"

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <stdio.h>
#if defined(HAVE_MALLOC_H)
#include <malloc.h>
#endif

#ifdef HAVE_SYS_TIME_H
#   include <sys/time.h>
#endif

#if !defined(_WIN32) && !defined(_WIN64) && !defined(__CYGWIN__)
#   include <sys/types.h>
#endif

#if defined(HAVE_UNISTD_H)
#   include <unistd.h>
#endif

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"
#include "sock.h"
#include "md5.h"
#include "dcc.h"
#include "log.h"
#include "conf.h"
#include "stats.h"
#include "ssl.h"
#include "lang.h"
#include "match.h"
#include "compat.h"
#include "variable.h"
#include "modules.h"
#include "compress.h"
#include "logic.h"
#include "threads.h"
#include "irc.h"
#include "sock_garbage.h"
#include "botnet.h"
#include "shared.h"
#include "func/c_function.h"
#include "mod/c_module.h"
#include "var/c_var_base.h"
#include "var/c_var_bool.h"
#include "var/c_var_int.h"
#include "var/c_var_string.h"
#include "var/c_var_array.h"
#include "runtime/c_delay_link.h"
#include "dcc/c_user_to_lock_out.h"
#include "proc/c_proc_exc.h"
#include "logic/logic_internal.h"

extern deque<c_user> r_terminators;
extern deque<c_user> r_user_templates;
extern deque<c_user> r_users;

#include "utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

using namespace std;

//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#pragma package(smart_init)
#endif

typedef unsigned char my_bool_t;
typedef uint32 my_botnet_time_t;

vector<c_delay_link> botnet_delay_link;

void botnet_partyline_message(string user, string channel, string msg, uint32 id);

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores user data to pull from remote bot
*/
class c_user_to_pull
{
public:
    string botname;                                     //!< Remote bot name
    c_user user;                                        //!< Pulled user data
    vector<c_channel> chans;                            //!< Pulled user's channels

    c_user_to_pull()
        : user()
    {
    }
};

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores user data to push to remote bot
*/
class c_user_to_push
{
public:
    string botname;                                     //!< Remote bot name
    c_user user;                                        //!< Pushed user data

    c_user_to_push()
        : user()
    { ; }
};

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores procedure data to pull from remote bot
*/
class c_proc_to_pull
{
public:
    string botname;                                     //!< Remote bot name
    string proc_name;                                   //!< Procedure name
    my_time_t last_changed;                                //!< Timestamp of procedure
    list<string> lines;                                 //!< Lines of commands
    vector<c_replication> replication;                  //!< Replication data
    vector<string> orig_groups;                         //!< Original groups which is procedure member of

    bool it_is_func;                                    //!< true for function

    c_proc_to_pull()
    {
        last_changed=0;
    }
};

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores procedure data to push to remote bot
*/
class c_proc_to_push
{
public:
    string botname;                                     //!< Remote bot name
    string proc_name;                                   //!< Name of procedure
    my_time_t last_changed;                                //!< Timestamp of procedure
    bool func;                                          //!< Is this a function?

    c_proc_to_push()
    {
        last_changed=0;
        func=false;
    }
};

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores channel definition to push to remote bot
*/
class c_chan_def_to_push
{
public:
    string botname;                                     //!< Remote bot name
    string chan_name;                                    //!< Name of the channel
    my_time_t last_changed;                                //!< Timestamp
    c_channel_def chd;                                    //!< Definitions for the channel

    c_chan_def_to_push()
        : chd()
    {
        last_changed=0;
    }
};

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores channel definition to pull from remote bot
*/
class c_chan_def_to_pull
{
public:
    string botname;             //!< Remote bot name
    string chan_name;           //!< Name of the channel
    my_time_t last_changed;        //!< Timestamp
    c_channel_def chd;          //!< Definitions for the channel

    c_chan_def_to_pull()
        : chd()
    {
        last_changed=0;
    }

    c_chan_def_to_pull(const c_chan_def_to_pull& orig)
        : botname(orig.botname)
        , chan_name(orig.chan_name)
        , last_changed(orig.last_changed)
        , chd(orig.chd)
    { ; }
};

string botnet_botname;                                      //!< Name of this bot

int botnet_penalty=-1;                                      //!< There will be penalty (in seconds) from configuration file

#define SUPPORTED_PROTO_VERSION     1009                    //!< Version of current (maximum) protocol

#if defined(__GNUC__)
#   define PACK_STRUCT __attribute__((packed))
#   define MSVC_ALIGN1
#elif defined(_MSC_VER)
#   define PACK_STRUCT
#   define MSVC_ALIGN1 __declspec(align(1))
#elif defined(__BORLANDC__)
#   define MSVC_ALIGN1
#   define PACK_STRUCT
#   pragma pack(1)
#   pragma align 1
#endif

#if defined(_MSC_VER)
#   pragma pack(push)
#   pragma pack(1)
#endif

/*!
    \brief Stores flood limit, for botnet
    \author VooDooMan
    \version 1
    \date 2007-08-03
*/
MSVC_ALIGN1 struct c_flood_32_packed
{
public:
    uint32 lines;               //!< Number of lines
    my_botnet_time_t seconds;   //!< Number of seconds

    void clear()
    {
        lines=0;
        seconds=0;
    }
} PACK_STRUCT;

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores control packet
*/
MSVC_ALIGN1 struct c_bot_control
{
/*!
    \def PACKET_TYPE_CONTROL
    \brief Type of packet is: CONTROL
*/
#define PACKET_TYPE_CONTROL     1
    uint32 packet_type;                                     //!< This must be PACKET_TYPE_CONTROL
    uint32 size;                                            //!< Used for decompressing
    uint32 supported_proto_version;                         //!< Highest supported protocol
    uint32 control;                                         //!< ID of control command
/*!
    \def CTRL_ERROR_001
    \brief Remote bot is using greater protocol version than me!

*/
#define CTRL_ERROR_001      1L

/*!
    \def CTRL_ERROR_002
    \brief Bad password - closing connection
*/
#define CTRL_ERROR_002      2L

/*!
    \def CTRL_LINKED
    \brief Okay, password is okay
*/
#define CTRL_LINKED         3L

/*!
    \def CTRL_PING
    \brief Ping
*/
#define CTRL_PING           4L

/*!
    \def CTRL_PONG
    \brief Pong
*/
#define CTRL_PONG           5L

    /*!
        \brief Data of control
        \author VooDooMan
        \version 1
        \date 2005
    */
    MSVC_ALIGN1 union u_control_data
    {
        /*!
            \brief Timestamp, valid for 'CTRL_PING'
            \author VooDooMan
            \version 1
            \date 2007-02-19
        */
        MSVC_ALIGN1 struct c_timestamp_ping_1
        {
            my_bool_t valid;                //!< 'true' if 'now' contains valid data
            my_botnet_time_t now;           //!< Timestamp of remote bot
        } PACK_STRUCT timestamp_ping_1;

        /*!
            \brief Timestamp, valid for 'CTRL_PONG'
            \author VooDooMan
            \version 1
            \date 2007-02-19
        */
        MSVC_ALIGN1 struct c_timestamp_pong_1
        {
            my_bool_t valid;                //!< 'true' if 'now' contains valid data
            my_botnet_time_t now;           //!< Timestamp of remote bot
            my_botnet_time_t pong_to;       //!< Timestamp got from CTRL_PING packet 'now' entry
        } PACK_STRUCT timestamp_pong_1;

        /*!
            \brief Timestamp, valid for 'CTRL_LINKED'
            \author VooDooMan
            \version 1
            \date 2007-02-19
        */
        MSVC_ALIGN1 struct c_timestamp_linked_1
        {
            my_bool_t valid;                //!< 'true' if 'now' contains valid data
            my_botnet_time_t now;           //!< Timestamp of remote bot
        } PACK_STRUCT timestamp_linked_1;

        char padding[1024*4-sizeof(uint32)*4];                     //!< Padding
    } control_data;

    c_bot_control()
    {
        memset(this,0,sizeof(*this));
    }

    void flip_header()
    {
        byteReverse((unsigned char*)this,4);
    }
    void flip_rest()
    {
        switch(control) {
            case CTRL_PING:
                byteReverse((unsigned char*)&control_data.timestamp_ping_1.now,1);
                break;
            case CTRL_PONG:
                byteReverse((unsigned char*)&control_data.timestamp_pong_1.now,1);
                byteReverse((unsigned char*)&control_data.timestamp_pong_1.pong_to,1);
                break;
            case CTRL_LINKED:
                byteReverse((unsigned char*)&control_data.timestamp_linked_1.now,1);
                break;
        }
    }

    void hard_clear()
    {
        memset(this,0,sizeof(*this));
    }
} PACK_STRUCT;

#ifdef __BORLANDC__
#if sizeof(c_bot_control)!=1024*4
#   error sizeof(c_bot_control) MUST be equal to 1024*4 bytes long in any case! use padding member for size correction!
#endif
#endif

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores command packet
*/
MSVC_ALIGN1 struct c_bot_command
{
/*!
    \def PACKET_TYPE_COMMAND
    \brief Type of packet is: COMMAND
*/
#define PACKET_TYPE_COMMAND     2
    uint32 packet_type;                                     //!< Must be PACKET_TYPE_COMMAND
    uint32 size;                                            //!< Used for decompressing
    uint32 version;                                         //!< Version of protocol
    uint32 command;                                         //!< ID of command
    /*!
        \brief Data of command
        \author VooDooMan
        \version 1
        \date 2004
    */
    MSVC_ALIGN1 union u_commnd_data
    {
/*!
    \def CMD_AUTH_1
    \brief Command: authentication
*/
#define CMD_AUTH_1      10001L
        /*!
            \brief Authentication
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_bot_auth_1
        {
            char botname[256];                              //!< Name of bot
            unsigned char digest[32+1];                     //!< MD5 signature (as password)
        } PACK_STRUCT bot_auth_1;
/*!
    \def CMD_CHECK_TIME_1
    \brief Command: check for object's time
*/
#define CMD_CHECK_TIME_1      10010002L
        /*!
            \brief Check for time
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_check_time_1
        {
            my_botnet_time_t now;                           //!< Current time
            my_bool_t user;                                 //!< Is object an user?
            my_bool_t procedure;                            //!< Is object a procedure?
            my_bool_t function;                             //!< Is object a function?
            my_bool_t channel_def;                          //!< Is object a definition for the channel?
            my_bool_t prv;                                  //!< Is object a private query definition?
            char object_name[1024];                         //!< Name of object
            my_botnet_time_t original_time;                 //!< Timestamp of object
        } PACK_STRUCT check_time_1;
/*!
    \def CMD_NO_REPL_1
    \brief Command: No replication for this object, please
*/
#define CMD_NO_REPL_1      10010003L
        /*!
            \brief No replication
            \author VooDooMan
            \version 2
            \date 2004, 2008-02-26
        */
        MSVC_ALIGN1 struct c_no_repl_1
        {
            my_bool_t user;                                 //!< Is object an user?
            my_bool_t procedure;                            //!< Is object a procedure?
            my_bool_t function;                             //!< Is object a function?
            my_bool_t channel_def;                          //!< Is object a definition for the channel?
            my_bool_t prv;                                  //!< Is object a private query definition?
            char object_name[1024];                         //!< Name of object
/*!
    \def REASON_NO_REPL_1_UP_TO_DATE
    \brief Reason: Object is up to date
*/
#   define REASON_NO_REPL_1_UP_TO_DATE      1

/*!
    \def REASON_NO_REPL_1_ACCESS_DENIED
    \brief Reason: Access denied
*/
#   define REASON_NO_REPL_1_ACCESS_DENIED   2
            uint32 reason;                                  //!< Reason

            // added: 2008-02-26
            my_bool_t repl_extension_2008_02_26;    //!< !=0: if this extension is supported by bot; ==0: if bot is an older version
            my_bool_t repl_CMD_NO_REPL_1_rejected;  //!< !=0: this is response to 'CMD_NO_REPL_1' packet (remote is trying to PUSH object); ==0: it's not

        } PACK_STRUCT no_repl_1;
/*!
    \def CMD_REPL_USER_01_1
    \brief Command: Replication of user part 01
*/
#define CMD_REPL_USER_01_1  10004L
        /*!
            \brief Replication of user part 01
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_01_1
        {
            char name[256];                                 //!< User name
            my_bool_t host_unknown;                         //!< Is this user an unknown user?
            my_bool_t host_bot;                             //!< Is this user a bot itself?
            my_bool_t is_template;                          //!< Is this an user template?
            my_bool_t terminator;                           //!< Is this user terminated?
            my_bool_t access_grant_partyline;               //!< Can this user grant/deny access to partyline to other user?
            my_bool_t access_to_backup;                     //!< Can this user use .backup command?
            my_bool_t access_grant_backup;                  //!< Can this user grant/deny access to .backup command to other user?
            my_bool_t access_to_rehash;                     //!< Can this user use .rehash command?
            my_bool_t access_grant_rehash;                  //!< Can this user grant/deny access to .rehash command to other user?
            my_bool_t access_to_partyline;                  //!< Has this user access to partyline?
            my_bool_t access_to_plususer;                   //!< Can this user use .+user command?
            my_bool_t access_grant_plususer;                //!< Can this user grant/deny access to .+user command to other user?
            my_bool_t access_to_plusproc;                   //!< Can this user use .+proc command?
            my_bool_t access_grant_plusproc;                //!< Can this user grant/deny access to .+proc command to other user?
            my_bool_t access_to_can_send_all_users;         //!< Can this user send message / file to all users?
            my_bool_t access_grant_can_send_all_users;      //!< Can this user grant right to other user to send message / file to all users?
            my_bool_t access_to_can_send_unknown_users;     //!< Can this user send message / file to unknown users on all bot's channels?
            my_bool_t access_grant_can_send_unknown_users;  //!< Can this grant right to other user to send message / file to unknown users on all bot's channels?
            c_flood_32_packed partyline_msg_flood;          //!< Message flood limit on partyline channels
            my_botnet_time_t last_changed;                  //!< Time of last change
        } PACK_STRUCT cmd_repl_user_01_1;
/*!
    \def CMD_REPL_USER_01B_1
    \brief Command: Replication of user part 01B
*/
#define CMD_REPL_USER_01B_1  30001L
        /*!
            \brief Replication of user part 01B
            \author VooDooMan
            \version 1
            \date 2006-01-16
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_01B_1
        {
            char name[256];                                 //!< User name
            my_bool_t access_to_restart;                    //!< If user has access to ".restart"
            my_bool_t access_grant_restart;                 //!< If user can grant access to ".restart"
            my_bool_t access_to_die;                        //!< If user has access to ".die"
            my_bool_t access_grant_die;                     //!< If user can grant access to ".die"
            my_bool_t access_to_replication;                //!< If user has access to ".replication"
            my_bool_t access_grant_replication;             //!< If user can grant access to ".replication"
            my_bool_t access_to_filesystem;                 //!< If user has access to filesystem
            my_bool_t access_grant_filesystem;              //!< If user has can grant access to filesystem
            my_bool_t access_to_private;                    //!< If user has access to ".private"
            my_bool_t access_grant_private;                 //!< If user can grant access to ".private"
        } PACK_STRUCT cmd_repl_user_01B_1;
/*!
    \def CMD_REPL_USER_02_1
    \brief Command: Replication of user part 02
*/
#define CMD_REPL_USER_02_1  10005L
        /*!
            \brief Replication of user part 02
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_02_1
        {
            char name[256];                                 //!< Name of user
            char hostmask[1024];                            //!< Host mask
        } PACK_STRUCT cmd_repl_user_02_1;
/*!
    \def CMD_REPL_USER_03_1
    \brief Command: Replication of user part 03
*/
#define CMD_REPL_USER_03_1  10006L
        /*!
            \brief Replication of user part 03
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_03_1
        {
            char name[256];                                 //!< Name of user
            char fullname[1024];                            //!< Full name mask
        } PACK_STRUCT cmd_repl_user_03_1;
/*!
    \def CMD_REPL_USER_04_1
    \brief Command:Replication of user part 04
*/
#define CMD_REPL_USER_04_1  10007L
        /*!
            \brief Replication of user part 04
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_04_1
        {
            char name[256];                                 //!< Name of user
            char access_to_group[256];                      //!< Has access to this group
        } PACK_STRUCT cmd_repl_user_04_1;
/*!
    \def CMD_REPL_USER_06_1
    \brief Command: Replication of user part 02
*/
#define CMD_REPL_USER_06_1  10009L
        /*!
            \brief Replication of user part 06
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_06_1
        {
            char name[256];                                 //!< Name of user
            char access_grant_proc[256];                    //!< Access access_grant_proc
        } PACK_STRUCT cmd_repl_user_06_1;
/*!
    \def CMD_REPL_USER_07_1
    \brief Command: Replication of user part 07
*/
#define CMD_REPL_USER_07_1  10010004L
        /*!
            \brief Replication of user part 07
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_07_1
        {
            char name[256];                                 //!< Name of user
            char access_grant_group[256];                   //!< Access access_grant_group
        } PACK_STRUCT cmd_repl_user_07_1;
/*!
    \def CMD_REPL_USER_10_1
    \brief Command: Replication of user part 10
*/
#define CMD_REPL_USER_10_1  10010005L
        /*!
            \brief Replication of user part 10
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_10_1
        {
            char name[256];                                 //!< Name of user
            char group[1024];                               //!< Name of group
        } PACK_STRUCT cmd_repl_user_10_1;
/*!
    \def CMD_REPL_USER_11_1
    \brief Command: Replication of user part 11
*/
#define CMD_REPL_USER_11_1  10010006L
        /*!
            \brief Replication of user part 11
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_11_1
        {
            char name[256];                                 //!< Name of user
            uint32 dcc_group;                               //!< DCC group ID
            char dcc_host[1024];                            //!< DCC host
        } PACK_STRUCT cmd_repl_user_11_1;
#define CMD_REPL_USER_11B_1  10010007L
        /*!
            \brief Replication of user part 11B
            \author VooDooMan
            \version 2
            \date 2005-11-07
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_11B_1
        {
            char name[256];                                 //!< Name of user
            char channel[1024];                             //!< Name of channel
            char group[1024];                               //!< Name of group user's channel is member of
        } PACK_STRUCT cmd_repl_user_11B_1;
/*!
    \def CMD_REPL_USER_12_1
    \brief Command: Replication of user part 12
*/
#define CMD_REPL_USER_12_1  10010008L
        /*!
            \brief Replication of user part 12
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_12_1
        {
            enum {
                EVENT_BYTES = 1024,
            };

            char name[256];                                 //!< Name of user
            char channel[EVENT_BYTES];                      //!< Name of channel
            char on_deop[EVENT_BYTES];                      //!< on_deop event
            char on_ban[EVENT_BYTES];                       //!< on_ban event
            char on_unban[EVENT_BYTES];                     //!< on_unban event
            char on_kick[EVENT_BYTES];                      //!< on_kick event
            char on_op[EVENT_BYTES];                        //!< on_op event
            char on_voice[EVENT_BYTES];                     //!< on_voice event
            char on_devoice[EVENT_BYTES];                   //!< on_devoice event
            char on_creator[EVENT_BYTES];                   //!< on_creator event (obsolete)
            char on_decreator[EVENT_BYTES];                 //!< on_decreator event (obsolete)
            char on_join[EVENT_BYTES];                      //!< on_join event
            char on_banned[EVENT_BYTES];                    //!< on_banned event
            char on_flood[EVENT_BYTES];                     //!< on_flood event
            char on_privmsg[EVENT_BYTES];                   //!< on_privmsg event
            char on_notice[EVENT_BYTES];                    //!< on_notice event
            char on_except[EVENT_BYTES];                    //!< on_except event
            char on_unexcept[EVENT_BYTES];                  //!< on_unexcept event
            char on_invite[EVENT_BYTES];                    //!< on_invite event
            char on_uninvite[EVENT_BYTES];                  //!< on_uninvete event
            char on_not_invited[EVENT_BYTES];               //!< on_not_invited event
            char on_not_in_reop[EVENT_BYTES];               //!< on_not_in_reop event
            char on_reop[EVENT_BYTES];                      //!< on_reop event
            uint32 msg_flood_l;                             //!< Message flood limit: number of lines
            my_botnet_time_t msg_flood_s;                   //!< Message flood limit: number of seconds
            uint32 notice_flood_l;                          //!< Notice flood limit: number of lines
            my_botnet_time_t notice_flood_s;                //!< Notice flood limit: number of seconds
            uint32 repeat_flood_l;                          //!< Repeat flood limit: number of lines
            my_botnet_time_t repeat_flood_s;                //!< Repeat flood limit: number of seconds
            uint32 nick_flood_l;                            //!< Nick flood limit: number of lines
            my_botnet_time_t nick_flood_s;                  //!< Nick flood limit: number of seconds
            uint32 join_flood_l;                            //!< Join flood limit: number of lines
            my_botnet_time_t join_flood_s;                  //!< Join flood limit: number of seconds
            uint32 mode_flood_l;                            //!< Mode flood limit: number of lines
            my_botnet_time_t mode_flood_s;                  //!< Mode flood limit: number of seconds
            uint32 ctcp_flood_l;                            //!< CTCP flood limit: number of lines
            my_botnet_time_t ctcp_flood_s;                  //!< CTCP flood limit: number of seconds
            char dynamic_plus_modes[128];                   //!< Dynamic plus modes
            char dynamic_minus_modes[128];                  //!< Dynamic minus modes
            my_bool_t can_send_unknown_users;               //!< Can user send messages / files to unknown users?

            // added 2008-03-08, 1.1.beta31-cvs6
            char on_other_mode[EVENT_BYTES];                //!< on_other_mode event
            char on_other_mode_mask[EVENT_BYTES];           //!< on_other_mode_mask event
        } PACK_STRUCT cmd_repl_user_12_1;
/*!
    \def CMD_REPL_USER_13_1
    \brief Command: Replication of user part 13
*/
#define CMD_REPL_USER_13_1  10010009L
        /*!
            \brief Replication of user part 13
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_13_1
        {
            char name[256];                                 //!< Name of user
            char channel[1024];                             //!< Name of channel
            char group[256];                                //!< Name of group
            char plus_modes[256];                           //!< Plus modes
            char minus_modes[256];                          //!< Minus modes
        } PACK_STRUCT cmd_repl_user_13_1;
/*!
    \def CMD_REPL_USER_14_1
    \brief Command: Replication of user part 14
*/
#define CMD_REPL_USER_14_1  10010010L
        /*!
            \brief Replication of user part 14
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_14_1
        {
            char name[256];                                 //!< Name of user
            char meta_key[1024];                            //!< Meta data - key
            char meta_val[1024];                            //!< Meta data - value
        } PACK_STRUCT cmd_repl_user_14_1;
/*!
    \def CMD_REPL_USER_15_1
    \brief Command: Replication of user part 15
*/
#define CMD_REPL_USER_15_1  10010011L
        /*!
            \brief Replication of user part 15
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_15_1
        {
            char name[256];                                 //!< Name of user
            char access_usage_proc[256];                    //!< Access access_usage_proc
        } PACK_STRUCT cmd_repl_user_15_1;
/*!
    \def CMD_REPL_USER_16_5
    \brief Command: Replication of user part 16
    \warning BOTNET protocol 5 or above!
*/
#define CMD_REPL_USER_16_5  50001L
        /*!
            \brief Replication of user part 16
            \author VooDooMan
            \version 1
            \date 2005
            \warning BOTNET protocol 5 or above!
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_16_5
        {
            char name[256];                                 //!< Name of user
            my_bool_t access_to_upgrade;                    //!< Has user access to .upgrade command?
            my_bool_t access_grant_upgrade;                 //!< Can this user grant accesst to .upgrade command to other user?
        } PACK_STRUCT cmd_repl_user_16_5;
/*!
    \def CMD_REPL_USER_17_9
    \brief Command: Replication of user part 17
    \warning BOTNET protocol 9 or above!
*/
#define CMD_REPL_USER_17_9  90001L
        /*!
            \brief Replication of user part 17
            \author VooDooMan
            \version 1
            \date 2005
            \warning BOTNET protocol 9 or above!
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_17_9
        {
            char name[256];                                 //!< Name of user
            my_bool_t access_to_apply;                      //!< Has user access to .apply command?
            my_bool_t access_grant_apply;                   //!< Can this user grant accesst to .apply command to other user?
        } PACK_STRUCT cmd_repl_user_17_9;
/*!
    \def CMD_REPL_USER_99_1
    \brief Command: Replication of user - commit
*/
#define CMD_REPL_USER_99_1  10010012L
        /*!
            \brief Replication of user - commit
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_user_99_1
        {
            char name[256];                                 //!< Name of user
        } PACK_STRUCT cmd_repl_user_99_1;
/*!
    \def CMD_PUSH_1
    \brief Command: push of object
*/
#define CMD_PUSH_1      10010013L
        /*!
            \brief Push of object
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_push_1
        {
            my_botnet_time_t now;                           //!< Current time
            my_bool_t user;                                 //!< Is object an user?
            my_bool_t procedure;                            //!< Is object a procedure?
            my_bool_t function;                             //!< Is object a function?
            my_bool_t channel_def;                          //!< Is object a channel definition?
            my_bool_t prv;                                  //!< Is object a private query definition?
            char object_name[1024];                         //!< Name of object
            my_botnet_time_t original_time;                 //!< Original timestamp
        } PACK_STRUCT cmd_push_1;
/*!
    \def CMD_PROC_1
    \brief Command: Push of procedure
*/
#define CMD_PROC_1      10010014L
        /*!
            \brief Replication of procedure
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_proc_1
        {
            char name[1024];                                //!< Procedure name
            my_bool_t init;                                 //!< Set to true for first line of procedure
            char line[1024*2];                              //!< Line of procedure
            my_botnet_time_t last_changed;                  //!< Original timestamp
            my_bool_t it_is_func;                           //!< true for function
        } PACK_STRUCT cmd_proc_1;
/*!
    \def CMD_PROC_END_1
    \brief Command: Commit the procedure
*/
#define CMD_PROC_END_1      10010015L
        /*!
            \brief Replication of procedure - the end - commit
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_proc_end_1
        {
            char name[1024];                                //!< Procedure name
        } PACK_STRUCT cmd_proc_end_1;
/*!
    \def CMD_PARTYLINE_1
    \brief Command: partyline event
*/
#define CMD_PARTYLINE_1     10023L
        /*!
            \brief Partyline event
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_partyline_1
        {
            uint32 id;                                      //!< ID of event
            char user[256];                                 //!< Name of user
            my_bool_t msg;                                  //!< Is this a message?
            char message[1024];                             //!< Message
            my_bool_t join;                                 //!< Is this a join?
            my_bool_t leave;                                //!< Is this a leave?
            char channel[1024];                             //!< Name of channel
            char botname[256];                              //!< Name of bot on which is user
        } PACK_STRUCT cmd_partyline_1;
/*!
    \def CMD_PARTYLINE_USER_1
    \brief Command: Partyline user listing
*/
#define CMD_PARTYLINE_USER_1     10024L
        /*!
            \brief Partyline - user listing entry
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_partyline_user_1
        {
            uint32 id;                                      //!< ID of message
            char user[256];                                 //!< Name of user
            char channel[1024];                             //!< Name of channel
            char botname[256];                              //!< Name of bot on which is user
        } PACK_STRUCT cmd_partyline_user_1;
/*!
    \def CMD_REPL_CHDEF_01_1
    \brief Command: Channel definiotions - part 1
*/
#define CMD_REPL_CHDEF_01_1  10025L
        /*!
            \brief Channel definitions - part 1
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_01_1
        {
            char name[256];                                 //!< Name of the channel
            char on_mode[1024];                             //!< on_mode event
            char on_key[1024];                              //!< on_key event
            char on_limit[1024];                            //!< on_limit event
            char on_topic[1024];                            //!< on_topic event
            char on_ircop[1024];                            //!< on_ircop event
            char on_ctcp[1024];                             //!< on_ctcp event
            char on_privmsg[1024];                          //!< on_privmsg event
            char on_notice[1024];                           //!< on_notice event
            char on_part[1024];                             //!< on_part event
            char on_dynamic_ban[1024];                      //!< on_dynamic_ban event
            char dynamic_plus_modes[128];                   //!< Dynamic "plus" (+ enabled) modes
            char dynamic_minus_modes[128];                  //!< Dynamic "minus" (- dissabled) modes
            my_botnet_time_t last_changed;                  //!< Timestamp
        } PACK_STRUCT cmd_repl_chdef_01_1;
/*!
    \def CMD_REPL_CHDEF_02_1
    \brief Command: Channel definiotions - part 2
*/
#define CMD_REPL_CHDEF_02_1  10026L
        /*!
            \brief Channel definitions - part 2
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_02_1
        {
            char name[256];                                 //!< Name of the channel
            char group[1024];                               //!< Name of the group
        } PACK_STRUCT cmd_repl_chdef_02_1;
/*!
    \def CMD_REPL_CHDEF_03_1
    \brief Command: Channel definiotions - part 3
*/
#define CMD_REPL_CHDEF_03_1  10027L
        /*!
            \brief Channel definitions - part 3
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_03_1
        {
            char name[256];                                 //!< Name of the channel
            char group[256];                                //!< Name of the group that set dynamic modes
            char plus_modes[256];                           //!< Dynamic "plus" modes
            char minus_modes[256];                          //!< Dynamic "minus" modes
        } PACK_STRUCT cmd_repl_chdef_03_1;
/*!
    \def CMD_REPL_CHDEF_04_1
    \brief Command: Channel definiotions - part 4
*/
#define CMD_REPL_CHDEF_04_1  10028L
        /*!
            \brief Channel definitions - part 4
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_04_1
        {
            char name[256];                                 //!< Name of the channel
            char mask[1024];                                //!< Dynamic ban mask
            char reason[1024];                              //!< Reason
        } PACK_STRUCT cmd_repl_chdef_04_1;
/*!
    \def CMD_REPL_CHDEF_05_1
    \brief Command: Channel definiotions - part 5
*/
#define CMD_REPL_CHDEF_05_1  10029L
        /*!
            \brief Channel definitions - part 5
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_05_1
        {
            char name[256];                                 //!< Name of the channel
            char group[1024];                               //!< Dynamic bans editor group
        } PACK_STRUCT cmd_repl_chdef_05_1;
/*!
    \def CMD_REPL_CHDEF_06_8
    \brief Command: Channel definition - part 06
    \warning BOTNET protocol 8 or above!
*/
#define CMD_REPL_CHDEF_06_8        80002L
        /*!
            \brief Channel definition - part 06
            \author VooDooMan
            \version 1
            \date 2005
            \warning BOTNET protocol 8 or above!
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_06_8
        {
            char name[256];                                 //!< Name of the channel
            char on_server_msg[1024];                        //!< Event on_server_msg
        } PACK_STRUCT cmd_repl_chdef_06_8;
/*!
    \def CMD_REPL_CHDEF_99_1
    \brief Command: Channel definiotions - end
*/
#define CMD_REPL_CHDEF_99_1  10030L
        /*!
            \brief Channel definitions - end - commit
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_chdef_99_1
        {
            char name[256];                                 //!< Name of the channel
        } PACK_STRUCT cmd_repl_chdef_99_1;
/*!
    \def CMD_REPL_PRV_01_1
    \brief Command: Private query definition - part 01
*/
#define CMD_REPL_PRV_01_1  10031L
        /*!
            \brief Private query definition - part 01
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_01_1
        {
            my_botnet_time_t last_changed;          //!< Original timestamp
        } PACK_STRUCT cmd_repl_prv_01_1;
/*!
    \def CMD_REPL_PRV_02_1
    \brief Command: Private query definition - part 02
*/
#define CMD_REPL_PRV_02_1  10032L
        /*!
            \brief Private query definition - part 02
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_02_1
        {
            char group[1024];                               //!< Name of group that is the object member of
        } PACK_STRUCT cmd_repl_prv_02_1;
/*!
    \def CMD_REPL_PRV_03_1
    \brief Command: Private query definition - part 03
*/
#define CMD_REPL_PRV_03_1  10033L
        /*!
            \brief Private query definition - part 03
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_03_1
        {
            char on_privmsg[1024];
            char on_notice[1024];
            char on_ctcp[1024];
        } PACK_STRUCT cmd_repl_prv_03_1;
/*!
    \def CMD_REPL_PRV_04_7
    \brief Command: Private query definition - part 04
    \warning BOTNET protocol 7 or above!
*/
#define CMD_REPL_PRV_04_7  70001L
        /*!
            \brief Private query definition - part 04
            \author VooDooMan
            \version 1
            \date 2005
            \warning BOTNET protocol 7 or above!
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_04_7
        {
            char on_filesys_got_new[1024];
            char on_fnc[1024];
        } PACK_STRUCT cmd_repl_prv_04_7;
/*!
    \def CMD_REPL_PRV_05_8
    \brief Command: Private query definition - part 05
    \warning BOTNET protocol 8 or above!
*/
#define CMD_REPL_PRV_05_8  80001L
        /*!
            \brief Private query definition - part 05
            \author VooDooMan
            \version 1
            \date 2005
            \warning BOTNET protocol 8 or above!
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_05_8
        {
            char on_broadcast[1024];
            char on_server_msg[1024];
        } PACK_STRUCT cmd_repl_prv_05_8;
/*!
    \def CMD_REPL_PRV_06_11
    \brief Command: Private query definition - part 06
    \warning BOTNET protocol 11 or above!
*/
#define CMD_REPL_PRV_06_11  110001L
        /*!
            \brief Private query definition - part 06
            \author VooDooMan
            \version 1
            \date 2005
            \warning BOTNET protocol 11 or above!
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_06_11
        {
            char on_internal_event[1024];
        } PACK_STRUCT cmd_repl_prv_06_11;
/*!
    \def CMD_REPL_PRV_99_1
    \brief Command: Private query definition - end
*/
#define CMD_REPL_PRV_99_1  10034L
        /*!
            \brief Private query definition - end - commit
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c_cmd_repl_prv_99_1
        {
        } PACK_STRUCT cmd_repl_prv_99_1;

/*!
    \def CMD_REMOTE_PROCEDURE_CALL_3
    \brief Command: Remote procedure call
*/
#define CMD_REMOTE_PROCEDURE_CALL_3  10010016L
        /*!
            \brief Remote procedure call
            \author VooDooMan
            \version 1
            \date 2005
        */
        MSVC_ALIGN1 struct c_cmd_remote_procedure_call_3
        {
            uint32 size;                            //!< Size of buffer
            char argc_array[63*1024];               //!< Binary zero-delimitered arguments passed one-by-one
        } PACK_STRUCT cmd_remote_procedure_call_3;

/*!
    \def CMD_CHALLENGE_13
    \brief Command: Challenge
*/
#define CMD_CHALLENGE_13        130001L
        /*!
            \brief Challenge
            \author VooDooMan
            \version 1
            \date 2005-08-02
        */
        MSVC_ALIGN1 struct c_bot_challenge_13
        {
            unsigned char magic[1024+1];            //!< Magic number
        } PACK_STRUCT bot_challenge_13;
/*!
    \def CMD_AUTH_13
    \brief Command: Auth
*/
#define CMD_AUTH_13             130002L
        /*!
            \brief Authentication
            \author VooDooMan
            \version 1
            \date 2005-08-02
        */
        MSVC_ALIGN1 struct c_bot_auth_13
        {
            unsigned char digest[32+1];             //!< MD5 digest
        } PACK_STRUCT bot_auth_13;

/*!
    \def CMD_UPDATE_1004
    \brief Command: Check for updates
*/
#define CMD_UPDATE_1004             10040001L
        /*!
            \brief Check for updates
            \author VooDooMan
            \version 1
            \date 2006-03-05
        */
        MSVC_ALIGN1 struct c_cmd_update_1004
        {
        } PACK_STRUCT cmd_update_1004;

        /*!
            \brief Padding
            \author VooDooMan
            \version 1
            \date 2004
        */
        MSVC_ALIGN1 struct c__padding
        {
            char padding[1024*64-sizeof(uint32)*4];         //!< Padding
        } PACK_STRUCT _padding;
    } command_data;

    void flip_header()
    {
        byteReverse((unsigned char*)this,4);
    }

    void flip()
    {
        // we don't want to flip first 4 uint32's because this is done by flip_header(), like it were CONTROL packet
        if(packet_type!=PACKET_TYPE_COMMAND)
            return;
        switch(command) {
            case CMD_AUTH_1:
                break;
            case CMD_CHECK_TIME_1:
                byteReverse((unsigned char*)&command_data.check_time_1.now,1);
                byteReverse((unsigned char*)&command_data.check_time_1.original_time,1);
                break;
            case CMD_NO_REPL_1:
                byteReverse((unsigned char*)&command_data.no_repl_1.reason,1);
                break;
            case CMD_REPL_USER_01_1:
                byteReverse((unsigned char*)&command_data.cmd_repl_user_01_1.partyline_msg_flood.lines,1);
                byteReverse((unsigned char*)&command_data.cmd_repl_user_01_1.partyline_msg_flood.seconds,1);
                byteReverse((unsigned char*)&command_data.cmd_repl_user_01_1.last_changed,1);
                break;
            case CMD_REPL_USER_01B_1:
                break;
            case CMD_REPL_USER_02_1:
                break;
            case CMD_REPL_USER_03_1:
                break;
            case CMD_REPL_USER_04_1:
                break;
            case CMD_REPL_USER_06_1:
                break;
            case CMD_REPL_USER_07_1:
                break;
            case CMD_REPL_USER_10_1:
                break;
            case CMD_REPL_USER_11_1:
                byteReverse((unsigned char*)&command_data.cmd_repl_user_11_1.dcc_group,1);
                break;
            case CMD_REPL_USER_11B_1:
                break;
            case CMD_REPL_USER_12_1:
                byteReverse((unsigned char*)&command_data.cmd_repl_user_12_1.msg_flood_l,14);
                break;
            case CMD_REPL_USER_13_1:
                break;
            case CMD_REPL_USER_14_1:
                break;
            case CMD_REPL_USER_15_1:
                break;
            case CMD_REPL_USER_16_5:
                break;
            case CMD_REPL_USER_17_9:
                break;
            case CMD_REPL_USER_99_1:
                break;
            case CMD_PUSH_1:
                byteReverse((unsigned char*)&command_data.cmd_push_1.now,1);
                byteReverse((unsigned char*)&command_data.cmd_push_1.original_time,1);
                break;
            case CMD_PROC_1:
                byteReverse((unsigned char*)&command_data.cmd_proc_1.last_changed,1);
                break;
            case CMD_PROC_END_1:
                break;
            case CMD_PARTYLINE_1:
                byteReverse((unsigned char*)&command_data.cmd_partyline_1.id,1);
                break;
            case CMD_PARTYLINE_USER_1:
                byteReverse((unsigned char*)&command_data.cmd_partyline_user_1.id,1);
                break;
            case CMD_REPL_CHDEF_01_1:
                byteReverse((unsigned char*)&command_data.cmd_repl_chdef_01_1.last_changed,1);
                break;
            case CMD_REPL_CHDEF_02_1:
                break;
            case CMD_REPL_CHDEF_03_1:
                break;
            case CMD_REPL_CHDEF_04_1:
                break;
            case CMD_REPL_CHDEF_05_1:
                break;
            case CMD_REPL_CHDEF_06_8:
                break;
            case CMD_REPL_CHDEF_99_1:
                break;
            case CMD_REPL_PRV_01_1:
                byteReverse((unsigned char*)&command_data.cmd_repl_prv_01_1.last_changed,1);
                break;
            case CMD_REPL_PRV_02_1:
                break;
            case CMD_REPL_PRV_03_1:
                break;
            case CMD_REPL_PRV_04_7:
                break;
            case CMD_REPL_PRV_05_8:
                break;
            case CMD_REPL_PRV_06_11:
                break;
            case CMD_REPL_PRV_99_1:
                break;
            case CMD_REMOTE_PROCEDURE_CALL_3:
                byteReverse((unsigned char*)&command_data.cmd_remote_procedure_call_3.size,1);
                break;
            case CMD_CHALLENGE_13:
                break;
            case CMD_AUTH_13:
                break;
            case CMD_UPDATE_1004:
                break;
            default:
                {
                    string d="OOPS: occurred error: The code shouldn't go here! It means that you should add 'case' for this packet: COMMAND 0x";
                    d+=tos(static_cast<unsigned long long>(command));
                    d=GET_STR_DEBUG_INFO_EX(d);
                    log_debug(d);
                }
                break;
        }
    }

    void hard_clear()
    {
        memset(this,0,sizeof(*this));
    }
} PACK_STRUCT;

#ifdef __BORLANDC__
#if sizeof(c_bot_command)!=1024*64
#   error sizeof(c_bot_command) MUST be equal to 1024*64 bytes long in any case! use padding member for size correction!
#endif
#endif

#if defined(_MSC_VER)
#   pragma pack(pop)
#endif

class c_bot;

MY_STATIC void botnet_regenerate_vector();

/*!
    \author VooDooMan
    \version 1
    \date 2007-02-18
    \brief Queue of botnet commands
*/
class c_command_queue
{
    typedef pair<bool,pair<void*,size_t> > data_t;  //!< One command: bool:true if packet needs to be updated, just before send, else it is already compressed and no update will be done; void*:compressed or uncompressed packet; size_t:Size of void* buffer
    deque<data_t> commands;                     //!< Queue of commands
    deque<unsigned long long> commands_id;      //!< ID of command packets
    bool got_error;                             //!< If we had an error

    string log;                                 //!< Last log message

    int zlib_level;                             //!< z-lib compression level

public:

    c_command_queue()
    {
        got_error=false;
    }

    ~c_command_queue();

    bool add_command(c_bot* bot, c_bot_command* cmd, int level);

    string get_error();
    void set_error(const string& err);

    bool get_next_packet(bool queue_empty, void* &data, size_t& len, unsigned long long& id);
};

/*!
    \author VooDooMan
    \version 2
    \date 2005
    \brief Stores informations about remote bot
*/
class c_bot
{
public:
    bool clean;                                             //!< Flag for cleaning: true==structure has been reset

    string botname;                                         //!< Name of remote bot
    string localip;                                         //!< Local IPv4 address
    string botip;                                           //!< IPv4 address of remote bot
    unsigned short botport;                                 //!< Port on remote side

    int supported_proto_version;                            //!< Highest supported protocol

    c_socket socket;                                        //!< Socket handle for connection
    threaded_connect_id connect_id;                         //!< Connect ID for thread
    my_time_t connect_start;                                   //!< Timestamp of establishing connection
    bool ssl_connection;                                    //!< Is this a SSL connection?
    bool pure_ssl;                                          //!< Is this a pure SSL connection?
    c_ssl* ssl;                                             //!< Descriptor of SSL connection
    my_time_t awaiting_ready;

    string remote_MD5_password;                             //!< Remote MD5 password
    string local_MD5_password;                              //!< Local MD5 password (only used when botnet12_compatibility==false)

    bool sent_bot_auth_1;                                   //!< Was an authentication sent?
    bool received_bot_auth_1;                               //!< Have we received an authentication?
    bool sent_at_least_one_ping;                            //!< Have we sent one ping as pre-handshake?
    bool got_at_least_one_pong;                             //!< Have we got at least one pong?

    c_bot_command command_receive_buffer;                   //!< Buffer for receiving COMMAND packet
    c_bot_control control_receive_buffer;                   //!< Buffer for receiving CONTROL packet
    size_t receive_buffer_pos;                              //!< Position in buffer
    char* rle_buffer;                                       //!< Buffer for RLE decompression
    size_t rle_buffer_len;                                  //!< Current lenght of rle_buffer
    bool flipped;                                           //!< true: we have flipper packet for big-endian machines already

    char buff_from_dcc[1024*5];                             //!< Buffer from DCC
    size_t buff_size_from_dcc;                              //!< Buffer size from DCC
    size_t buff_pos_from_dcc;                               //!< Position in buffer from DCC

    my_time_t last_try;                                        //!< Used for penalty
    bool waiting;                                           //!< waiting to last_try expires
    bool invoked_from_telnet;                               //!< Was this connection invoked from telnet?
    int got_bytes;                                          //!< For CR LF killing
    bool was_linked;                                        //!< For log message / used when linked connection broken
    bool auth_ok;                                           //!< Authenticated
    bool remote_pswd_ok;                                    //!< Remote password is okay

    // botnet12_compatibility==false
    bool got_challenge;                                     //!< Have we received challenge?
    bool challenge_sent;                                    //!< Have we sent challenge?
    string sent_challenge;                                  //!< Challenge string taht was sent
    bool response_okay;                                     //!< Have we received correct MD5 digest to challenge?
    my_time_t prelinking_wait_start;                           //!< Start of waiting before link confirmation
    bool prelink_ok;                                        //!< If got correct authentication
    //

    my_time_t next_ping;                                       //!< When will be the next ping?
    my_time_t start_awaiting_pong;                             //!< When we had started to await pong? (zero for none)

    c_timer* unlink_timer;
    c_var_array* vars;                                      //!< List of local variables at execution of "link" command (only valid if invoked_from_telnet == false)

    bool dirty;                                             //!< Have we tried yet to link and closed connection for error?

    bool botnet12_compatibility;                            //!< Set to true if BOTNET protocol 12 and below autentication compatibility is allowed

    my_time_t users_to_pull_last_update;                       //!< Time of last pull of users
    vector<c_user_to_pull> pulling_users;                   //!< List of pulling users

    my_time_t users_to_push_last_update;                       //!< Time of last push of users
    vector<c_user_to_push> pushing_users;                   //!< List of pushing users

    my_time_t procs_to_pull_last_update;                       //!< Time of last pull of procedures
    vector<c_proc_to_pull> pulling_procs;                   //!< List of pulling procedures

    my_time_t procs_to_push_last_update;                       //!< Time of last push of procedures
    vector<c_proc_to_push> pushing_procs;                   //!< List of pushing procedures

    my_time_t chans_to_pull_last_update;                       //!< Time of last pull of channel definitions
    vector<c_chan_def_to_pull> pulling_chans;               //!< List of pulling channel definitions

    my_time_t chans_to_push_last_update;                       //!< Time of last push of channel definitions
    vector<c_chan_def_to_push> pushing_chans;               //!< List of pushing channel definitions

    vector<string> rejected_objects;                        //!< List of object that should not be pushed due to remote reject (up-to-date/access denied)

    my_time_t last_proc_push;                                  //!< Timestamp of last tried to push / pushed procedure, or 0 (zero) for not yet

    my_time_t prv_to_push_last_update;                         //!< Time of last push of private query definition
    c_private prv_to_push;                                  //!< Last pushing private query definition
    c_private prv_to_pull;                                  //!< Last pulling private query definition
    bool prv_pulling;                                       //!< Are we pulling private query definition?

    bool sent_partyline_users;                              //!< Was list of users on partyline sent?

    multimap<string,pair<string,string> > chans_groups;     //!< For replication of user's channel's groups membership; first: user name; second.first: name of channel; second.second: name of group

    bool users_already_updated;                             //!< true, if remote bot is BOTNET version >= 1004 and it has been checked for updates
    bool procs_already_updated;                             //!< true, if remote bot is BOTNET version >= 1004 and it has been checked for updates
    bool chandefs_already_updated;                          //!< true, if remote bot is BOTNET version >= 1004 and it has been checked for updates
    bool prv_already_updated;                               //!< true, if remote bot is BOTNET version >= 1004 and it has been checked for updates

    MY_LONG_LONG remote_time_diff;                          //!< How many seconds is remote bot in the future?
    bool got_better_remote_time_diff;                       //!< 'true' if time diffrence was computed via CONTROL packet
    MY_LONG_LONG old_remote_time_diff;                      //!< Old value (used for reporting drastic value change, more than 'BOTNET_REPORT_DIFF_TIME_CHANGE_ABOVE' seconds)

    c_command_queue command_queue;                          //!< Queue of commands to send

    void clear() {                                          //!< Clears the structure
        clean=true;
        ssl_connection=false;
        pure_ssl=false;
        ssl=NULL;
        awaiting_ready=0;
        botname="";
        localip="";
        botip="";
        botport=0;
        supported_proto_version=0;
        socket.clear();
        local_MD5_password=remote_MD5_password="";
        sent_bot_auth_1=false;
        received_bot_auth_1=false;
        sent_at_least_one_ping=false;
        got_at_least_one_pong=false;
        receive_buffer_pos=0;
        memset(buff_from_dcc,0,sizeof(buff_from_dcc));
        buff_size_from_dcc=0;
        buff_pos_from_dcc=0;
        last_try=0;
        waiting=false;
        invoked_from_telnet=false;
        got_bytes=0;
        was_linked=false;
        auth_ok=false;
        remote_pswd_ok=false;
        next_ping=0;
        start_awaiting_pong=0;
        unlink_timer=NULL;
        if(vars) {
            var_keeper->free_global(vars,true);
        }
        vars=NULL;
        users_to_pull_last_update=0;
        pulling_users.clear();
        users_to_push_last_update=0;
        pushing_users.clear();
        procs_to_pull_last_update=0;
        pulling_procs.clear();
        procs_to_push_last_update=0;
        pushing_procs.clear();
        chans_to_pull_last_update=0;
        pulling_chans.clear();
        chans_to_push_last_update=0;
        pushing_chans.clear();
        sent_partyline_users=false;
        rejected_objects.clear();
        last_proc_push=0;

        got_challenge=response_okay=challenge_sent=false;
        sent_challenge="";

        rle_buffer=NULL;
        rle_buffer_len=0;
        flipped=false;

        botnet12_compatibility=false;

        chans_groups.clear();

        prelink_ok=false;
        prelinking_wait_start=0;

        connect_id=TCID_INVALID;
        connect_start=0;

        dirty=false;

        users_already_updated=false;
        procs_already_updated=false;
        chandefs_already_updated=false;
        prv_already_updated=false;

        remote_time_diff=0;
        got_better_remote_time_diff=false;
        old_remote_time_diff=0;
    }

    c_bot() {
        vars=NULL;
        clear();
    }

    c_bot(const c_bot& orig) {
        clear();

        memcpy(&command_receive_buffer,&orig.command_receive_buffer,sizeof(c_bot_command));
        memcpy(&control_receive_buffer,&orig.control_receive_buffer,sizeof(c_bot_control));
        if(orig.rle_buffer) {
            rle_buffer=(char*)my_malloc(orig.rle_buffer_len);
            if(rle_buffer) {
                memcpy(rle_buffer,orig.rle_buffer,orig.rle_buffer_len);
                rle_buffer_len=orig.rle_buffer_len;
            } else {
                rle_buffer_len=0;
            }
        } else {
            rle_buffer=NULL;
            rle_buffer_len=0;
        }

        clean=orig.clean;

        botname=orig.botname;
        localip=orig.localip;
        botip=orig.botip;
        botport=orig.botport;
        supported_proto_version=orig.supported_proto_version;
        socket=orig.socket;
        connect_id=orig.connect_id;
        connect_start=orig.connect_start;
        ssl_connection=orig.ssl_connection;
        pure_ssl=orig.pure_ssl;
        ssl=orig.ssl;
        awaiting_ready=orig.awaiting_ready;
        remote_MD5_password=orig.remote_MD5_password;
        local_MD5_password=orig.local_MD5_password;
        sent_bot_auth_1=orig.sent_bot_auth_1;
        received_bot_auth_1=orig.received_bot_auth_1;
        sent_at_least_one_ping=orig.sent_at_least_one_ping;
        got_at_least_one_pong=orig.got_at_least_one_pong;
        command_receive_buffer=orig.command_receive_buffer;
        receive_buffer_pos=orig.receive_buffer_pos;
        control_receive_buffer=orig.control_receive_buffer;
        flipped=orig.flipped;
        memcpy(buff_from_dcc,orig.buff_from_dcc,sizeof(buff_from_dcc));
        buff_size_from_dcc=orig.buff_size_from_dcc;
        buff_pos_from_dcc=orig.buff_pos_from_dcc;
        last_try=orig.last_try;
        waiting=orig.waiting;
        invoked_from_telnet=orig.invoked_from_telnet;
        got_bytes=orig.got_bytes;
        was_linked=orig.was_linked;
        auth_ok=orig.auth_ok;
        remote_pswd_ok=orig.remote_pswd_ok;

        got_challenge=orig.got_challenge;
        challenge_sent=orig.challenge_sent;
        sent_challenge=orig.sent_challenge;
        response_okay=orig.response_okay;
        prelinking_wait_start=orig.prelinking_wait_start;
        prelink_ok=orig.prelink_ok;

        next_ping=orig.next_ping;
        start_awaiting_pong=orig.start_awaiting_pong;
        unlink_timer=orig.unlink_timer;
        if(NULL==orig.vars)
            vars=NULL;
        else {
            vars=var_keeper->register_mod_global(orig.vars,__FILE__,__my_func__,__LINE__);
        }

        dirty=orig.dirty;
        botnet12_compatibility=orig.botnet12_compatibility;

        users_to_pull_last_update=orig.users_to_pull_last_update;
        pulling_users=orig.pulling_users;
        users_to_push_last_update=orig.users_to_push_last_update;
        pushing_users=orig.pushing_users;
        procs_to_pull_last_update=orig.procs_to_pull_last_update;
        pulling_procs=orig.pulling_procs;
        procs_to_push_last_update=orig.procs_to_push_last_update;
        pushing_procs=orig.pushing_procs;

        chans_to_pull_last_update=orig.chans_to_pull_last_update;
        pulling_chans=orig.pulling_chans;
        chans_to_push_last_update=orig.chans_to_push_last_update;
        pushing_chans=orig.pushing_chans;

        rejected_objects=orig.rejected_objects;

        sent_partyline_users=orig.sent_partyline_users;

        last_proc_push=orig.last_proc_push;
        prv_to_push_last_update=orig.prv_to_push_last_update;

        prv_to_push=orig.prv_to_push;
        prv_to_pull=orig.prv_to_pull;
        prv_pulling=orig.prv_pulling;

        sent_partyline_users=orig.sent_partyline_users;

        chans_groups=orig.chans_groups;

        users_already_updated=orig.users_already_updated;
        procs_already_updated=orig.procs_already_updated;
        chandefs_already_updated=orig.chandefs_already_updated;
        prv_already_updated=orig.prv_already_updated;

        remote_time_diff=orig.remote_time_diff;
        got_better_remote_time_diff=orig.got_better_remote_time_diff;
        old_remote_time_diff=orig.old_remote_time_diff;

        got_challenge=orig.got_challenge;
        response_okay=orig.response_okay;
        challenge_sent=orig.challenge_sent;
        sent_challenge=orig.sent_challenge;

        command_queue=orig.command_queue;
    }

    ~c_bot() {
        if(vars) {
            var_keeper->free_global(vars,true);
        }
        vars=NULL;
        // overwrite sensitive data before it gets released to the system
        memset(buff_from_dcc,0,sizeof(buff_from_dcc));
        if(rle_buffer)
            memset(rle_buffer,0,rle_buffer_len);
        //
        my_free(rle_buffer);
        rle_buffer=NULL;
        rle_buffer_len=0;
    }

    void garbage_socket()
    {
        // preserve comment (in case of doubled call of this method)
        string comment=socket.comment;
        if(ssl) {
            // ssl class has its own socket close handling in case of error
            socket.clear();
            sock_comment(socket,comment);
        }
        sock_garbage_push(connect_id,socket,ssl);
        sock_comment(socket,comment);
        dirty=true;
    }

    void before_delete()
    {
        garbage_socket();
    }

    enum e_action
    {
        E_REPL_NONE = 0,        //!< No replication should be done
        E_REPL_SHOULD_PUSH,     //!< Should push
        E_REPL_SHOULD_PULL,     //!< Should pull
    };                 //!< Action to be taken

    /*!
        \author VooDooMan
        \version 3
        \date 2007-02-18, 2007-08-03, 2007-08-19
        \brief Computes object oldness
        \param local_object Time of local object
        \param remote_object Time of remote object
        \param remote_time Remote bot's my_time() (current time on remote side)
        \param action Returns action to be taken
        \return Returns number of seconds the remote object is in the future (computation of local my_time() and remote my_time() is also performed), e.g.
    */
    MY_LONG_LONG botnet_obj_difftime(my_time_t local_object, my_botnet_time_t remote_object, my_botnet_time_t remote_time, e_action& action)
    {
        if(!got_better_remote_time_diff)
            remote_time_diff=my_difftime(remote_time,my_time(NULL));
            // ^^^ how many seconds is remote side in future?

        MY_LONG_LONG obj_diff=my_difftime(remote_object,local_object);
            // ^^^ how many seconds is remote's object in future?

        obj_diff-=remote_time_diff;
            // ^^^ and after corrcetion of time drift, we got how
            //       many seconds is remote object in the future

        action=E_REPL_NONE;
        if(obj_diff<-(double)BOTNET_OLDER_OBJECT_DIFF_TIME)
            action=E_REPL_SHOULD_PUSH; // remote object is in the past
        else if(obj_diff>(double)BOTNET_OLDER_OBJECT_DIFF_TIME)
            action=E_REPL_SHOULD_PULL; // remote object is in the future

        return obj_diff;
    }

    /*!
        \author VooDooMan
        \version 1
        \date 2007-02-19
        \brief Sets remote bot's time difference
        \param remote_time Remote bot's my_time() (current time on remote side)
    */
    void set_difftime(my_botnet_time_t remote_time)
    {
        my_time_t rt=remote_time;
        remote_time_diff=my_difftime(rt,my_time(NULL)); // how many seconds is remote side in future?
        if(!got_better_remote_time_diff || ::abs((signed long)(old_remote_time_diff-remote_time_diff))>BOTNET_REPORT_DIFF_TIME_CHANGE_ABOVE) {
            old_remote_time_diff=remote_time_diff;
            string log="Remote bot is ";
            log+=tos(remote_time_diff);
            log+=" second(s) in the future (negative value means it is in the past)";
            log_botnet(botnet_botname,botname,log);
            log_botnet_debug(botnet_botname,botname,-1,-1,log);
        }
        got_better_remote_time_diff=true;
    }

    /*!
        \author VooDooMan
        \version 2
        \date 2007-02-18, 2007-08-19
        \brief Adjusts "last_changed" time for correction (computes remote/local time difference)
        \param timestamp Timestamp of remote object supplied by remote side, upon return it will receive adjusted timestamp
    */
    void adjust_timestamp(my_time_t& timestamp)
    {
        MY_LONG_LONG orig=timestamp;
        orig-=remote_time_diff;
        timestamp=static_cast<my_time_t>(orig);
    }
};

static vector<c_bot*>* bots=NULL;       //!< List of connected bots

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores informations about partyline users
*/
class c_partyline_member
{
public:
    string user;                                            //!< Name of user
    string botname;                                         //!< Name of bot that user is on

    c_partyline_member()
    {
        user="";
        botname="";
    }
};

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores informations about partyline channel
*/
class c_botnet_channel
{
public:
    string channel_name;                                    //!< Name of channel
    vector<c_partyline_member> members;                     //!< List of members

    c_botnet_channel()
    {
        channel_name="";
        members.clear();
    }
};

vector<c_botnet_channel> botnet_channels;                   //!< List of partyline channels

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Stores informations about message
*/
class c_msg_id
{
public:
    my_botnet_time_t time;                                  //!< Time of message
    uint32 id;                                              //!< ID of message

    c_msg_id()
    {
        time=0;
        id=0;
    }
};

vector<c_msg_id> msg_ids;                                   //!< List of message ID's
vector<c_msg_id> msg_disp_ids;                              //!< List of displayed messages ID's

//---

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Cleans up message ID's
*/
void botnet_cleanup_ids()
{
    my_time_t now;
    my_time(&now);

    vector<c_msg_id>::iterator i1;

again:
    for(i1=msg_ids.begin(); i1!=msg_ids.end(); ++i1)
        if((my_time_t)(*i1).time+BOTNET_MSG_ID_LIFE<now) {
            msg_ids.erase(i1);
            goto again;
        }

again2:
    for(i1=msg_disp_ids.begin(); i1!=msg_disp_ids.end(); ++i1)
        if((my_time_t)(*i1).time+BOTNET_MSG_ID_LIFE<now) {
            msg_disp_ids.erase(i1);
            goto again2;
        }
}

/*!
    \author VooDooMan
    \version 1
    \date 2005
    \brief Checks whether we have message ID in vector already (we already displayed this message)
    \param id Message ID to test
    \retval true We got
    \retval false We don't got
*/
bool botnet_query_disp_id(uint32 id)
{
    vector<c_msg_id>::iterator i1;
    for(i1=msg_disp_ids.begin(); i1!=msg_disp_ids.end(); ++i1)
        if((*i1).id==id)
            return true;
    return false;
}

/*!
    \author VooDooMan
    \version 1
    \date 2005
    \brief Creates new unique ID for new message
    \retval Unique ID
*/
uint32 botnet_get_unique_id()
{
    uint32 id;
    for(;;) {
again:
        id=(rand()%0xffff) | ( (rand()%0xffff) << 16 );
        vector<c_msg_id>::iterator i1;

        for(i1=msg_ids.begin(); i1!=msg_ids.end(); ++i1) {
            if((*i1).id==id) {
                goto again;
            }
        }

        for(i1=msg_disp_ids.begin(); i1!=msg_disp_ids.end(); ++i1) {
            if((*i1).id==id) {
                goto again;
            }
        }

        break;
    }

    return id;
}

void botnet_on_unlink(string botname, string from_bot, int id);

/*!
    \brief Handles unlink procedure/function call, and partyline notification about BOTNET-split
    \version 1
    \date 2006-01-21
    \author VooDooMan
    \param bot Descriptor of remote bot
*/
void botnet_bot_unlinked(c_bot* bot)
{
    if(bot->was_linked) {
        bot->was_linked=false;
        botnet_on_unlink(bot->botname,botnet_botname,botnet_get_unique_id());
    }
    if(bot->unlink_timer)
        bot->unlink_timer->bot_unlink_trigger=true;
}

static my_time_t botnet_last_rehash_request=0;             //!< Timestamp of the last rehash request from other bot
static my_time_t botnet_last_backup_request=0;             //!< Timestamp of the last backup request from other bot
static my_time_t botnet_last_apply_request=0;              //!< Timestamp of the last apply request from other bot

static string botnet_last_rehash_by="";                 //!< Name of bot causing rehash
static string botnet_last_backup_by="";                 //!< Name of bot causing backup
static string botnet_last_apply_by="";                  //!< Name of bot causing apply

/*!
    \author VooDooMan
    \version 2
    \date 2004, 2007-02-19
    \brief Causes bot to schedule backup
    \param botname Name of the remote bot
*/
MY_STATIC void botnet_backup(const string& botname)
{
    if(botnet_last_backup_by.empty()) {
        botnet_last_backup_by=botname;
    } else {
        if(botnet_last_backup_by.compare(botname)) // !=
            botnet_last_backup_by="BOTNET";
    }
    botnet_last_backup_request=my_time(NULL);
}

/*!
    \author VooDooMan
    \version 2
    \date 2004, 2007-02-19
    \brief Causes bot to schedule rehash
    \param bot Bot handle
    \param botname Name of the remote bot
*/
MY_STATIC void botnet_rehash(c_bot* UNUSEDARG(bot), const string& botname)
{
    if(botnet_last_rehash_by.empty()) {
        botnet_last_rehash_by=botname;
    } else {
        if(botnet_last_rehash_by.compare(botname)) // !=
            botnet_last_rehash_by="BOTNET";
    }
    botnet_last_rehash_request=my_time(NULL);
}

/*!
    \author VooDooMan
    \version 1
    \date 2007-02-19
    \brief Causes bot to schedule apply
    \param bot Bot handle
    \param botname Name of the remote bot
*/
MY_STATIC void botnet_apply(c_bot* UNUSEDARG(bot), const string& botname)
{
    if(botnet_last_apply_by.empty()) {
        botnet_last_apply_by=botname;
    } else {
        if(botnet_last_apply_by.compare(botname)) // !=
            botnet_last_apply_by="BOTNET";
    }
    botnet_last_apply_request=my_time(NULL);
}

/*!
    \author VooDooMan
    \version 1
    \date 2005-08-02
    \brief Increases lockout count for remote bot
    \param remote_ip IPv4/6 address of remote bot
*/
void botnet_lockout(string remote_ip)
{
    c_user_to_lock_out u;
    u.timestamp=my_time(NULL);
    u.remote=remote_ip;
    dcc_users_to_lock_out.push_back(u);
}

bool botnet_send_command(c_bot* bot, c_bot_command* cmd);

/*!
    \author VooDooMan
    \version 1
    \date 2005
    \brief Sends to other bot remote procedure call request
    \param botname Name of remote bot
    \param proc_name_only Name of remote procedure only (without full declaration)
    \param args List of arguments
    \param this_module Module
    \return Returns string that should be passed to script as result for this command
*/
string botnet_remote_procedure_call(string botname, string proc_name_only, vector<c_var_base*>& args, c_module* this_module)
{
    bool got=false;
    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if(!(*i1)->botname.compare(botname) && (*i1)->auth_ok && (*i1)->remote_pswd_ok) {
            got=true;
            break;
        }
    }
    if(!got)
        return (string)"@not_linked@";
    if(!(*i1)->auth_ok || !(*i1)->remote_pswd_ok)
        return (string)"@not_linked@";
    if((*i1)->supported_proto_version<1001)
        return (string)"@remote_not_supported@";

    char* data=NULL;
    size_t size=0;

    if(!var_encode_for_botnet(this_module,data,size,args,proc_name_only)) {
        return (string)"@error@";
    }

    c_bot_command* c=MY_NEW c_bot_command;
    c->hard_clear();
    c->packet_type=PACKET_TYPE_COMMAND;
    c->size=sizeof(c);
    c->version=3;
    c->command=CMD_REMOTE_PROCEDURE_CALL_3;

    if(size>sizeof(c->command_data.cmd_remote_procedure_call_3.argc_array)) {
        MY_DELETE(c);
        MY_DELETE_A(data);
        data=NULL;
        return (string)"@args_too_long@";
    }

    memcpy(c->command_data.cmd_remote_procedure_call_3.argc_array,data,size);
    MY_DELETE_A(data);
    data=NULL;

    c->command_data.cmd_remote_procedure_call_3.size=static_cast<uint32>(size);

    botnet_send_command(*i1,c);
    MY_DELETE(c);

    return (string)"@ok@";
}

/*!
    \author VooDooMan
    \version 1
    \date 2005-11-12
    \brief Clears list of rejected objects associated with all bots (after rehash)
*/
void botnet_logic_rehashed()
{
    if(!bots)
        return;

    c_bot_command* c=MY_NEW c_bot_command;

    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        (*i1)->rejected_objects.clear();

        (*i1)->users_already_updated=false;
        (*i1)->procs_already_updated=false;
        (*i1)->chandefs_already_updated=false;
        (*i1)->prv_already_updated=false;
        if((*i1)->auth_ok && (*i1)->remote_pswd_ok && (*i1)->supported_proto_version>=1004) {
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_UPDATE_1004;

            botnet_send_command(*i1,c);
        }
    }

    MY_DELETE(c);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Links to new bot
    \param botname Name of remote bot
    \param localip Local IPv4 address
    \param botip Remote IPv4 address
    \param botport Port of remote bot
    \param remote_MD5_password Password as MD5
    \param bot_link_type Must be "telnet"
    \param unlink_proc Unlink procedure to call on unlink
    \param vars Variables to unlink procedure
    \param this_module Current module
*/
void botnet_link(string botname, string localip, string botip, unsigned short botport, string remote_MD5_password, string bot_link_type, string unlink_proc, c_var_array* vars, c_module* this_module)
{
    if(!bots)
        return;

    if(bot_link_type.compare("telnet") && bot_link_type.compare("telnet_ssl") && bot_link_type.compare("ssl")) {
        string log=GET_STR_DEBUG_INFO_EX("OOPS: occurred error: Unknown link type - assuming \"telnet\"");
        log_debug(log);
    }

    {
        MY_LONG_LONG secs=stoll(core_conf_getvar("lockout_duration"));
        vector<c_user_to_lock_out>::iterator i1;
    lock_a:
        for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1)
            if((*i1).timestamp+secs<my_time(NULL)) {
                dcc_users_to_lock_out.erase(i1);
                goto lock_a;
            }
        MY_LONG_LONG num=0;
        for(i1=dcc_users_to_lock_out.begin(); i1!=dcc_users_to_lock_out.end(); ++i1)
            if(!(*i1).remote.compare(botip))
                num++;
        MY_LONG_LONG max=stoll(core_conf_getvar("lockout_count"));
        if(max!=0 && num>=max) {
            logic_on_internal_event("@connection_login@",botname,botip,localip,tos(botport),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"IP is locked out due to number of bad logins. I will not link with this bot..","");

            string log="IP is locked out due to number of bad logins. I will not link with this bot. User name \"";
            log+=botname;
            log+="\" connecting to ";
            log+=botip;
            log+=":";
            log+=tos(botport);
            log+=" from local ";
            log+=localip;
            log_bot(log);
            log_botnet(botnet_botname,botname,log);

            return;
        }
    }

    bool botnet12_compatibility=false; //conf_pass.get_botnet12_compatibility(botname);
    string local_MD5_password=conf_pass.get_local_password_md5(botname);

    bool got=false;
    bool got_one=false;
    vector<c_bot*>::iterator i1;
//label:
    for(i1=bots->begin(); i1!=bots->end(); ++i1)
        if(!(*i1)->botname.compare(botname)) {
            // we already got link bot in the vector
            got_one=true;
            got=true;
            break;
        }
    if(got || got_one)
        return;

    c_bot* s=MY_NEW c_bot;
    s->clear();
    s->botnet12_compatibility=botnet12_compatibility;
    s->local_MD5_password=local_MD5_password;
    s->botname="";
    s->localip="";
    s->botip="";
    s->botport=0;
    s->socket.clear();
    s->remote_MD5_password="";
    s->sent_bot_auth_1=false;
    s->received_bot_auth_1=false;
    s->receive_buffer_pos=0;

    s->buff_size_from_dcc=0;

    s->botname=botname;
    s->localip=localip;
    s->botip=botip;
    s->botport=botport;
    s->socket.clear();
    s->remote_MD5_password=remote_MD5_password;

    s->command_receive_buffer.hard_clear();
    s->control_receive_buffer.hard_clear();
    s->receive_buffer_pos=0;

    if(this_module) {
        c_var_array* vars_=vars;
        {
            session_id_t old_session=var_keeper->get_current_session();
            var_keeper->set_current_session(SESSION_RESERVED_ID);
            vars_=var_keeper->register_mod_global(vars_,__FILE__,__my_func__,__LINE__);
            vars_->set_all_as_persistent();
            var_keeper->set_current_session(old_session);
        }

        c_timer* tm=MY_NEW c_timer();
        tm->bot_unlink_timer=true;
        tm->name=(string)"BOTNET: Bot '"+botname+"' unlink event";
        tm->debug=tm->name+"; "+unlink_proc;
        tm->expression=unlink_proc;
        tm->vars=vars_;
        this_module->r_timers.push_back(tm);

        s->unlink_timer=tm;
    }

    s->got_bytes=0;
    s->auth_ok=false;
    s->prelink_ok=false;
    s->remote_pswd_ok=false;
    s->was_linked=false;
    s->last_try=(my_time_t)((signed)-1);
    s->invoked_from_telnet=false;

    s->ssl_connection=!bot_link_type.compare("telnet_ssl");
    s->pure_ssl=!bot_link_type.compare("ssl");
    if(s->pure_ssl)
        s->ssl_connection=true;
    s->ssl=NULL;

    botnet_regenerate_vector();

    bots->push_back(s);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Sends command to linked bot
    \param bot Bot handle
    \param cmd Command to send
    \return true if I/O error occured
*/
bool botnet_send_command(c_bot* bot, c_bot_command* cmd)
{
    c_bot_command* data=MY_NEW c_bot_command;
    memcpy(data,cmd,sizeof(*cmd));

    if(bot->command_queue.add_command(bot,data,conf_pass.get_zlib_level(bot->botname))) {

        MY_DELETE(data);
        data=NULL;

        bot->garbage_socket();

        string log=bot->command_queue.get_error();

        log_debug(log);
        log_botnet(botnet_botname,bot->botname,log);
        return true;
    }

    MY_DELETE(data);
    data=NULL;

    return false;
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Sends control packet to linked bot
    \param bot Bot handle
    \param ctrl Control packet to send
    \return true if I/O error occured
    \warning On BIG-endian machines this code is destructive for argument "ctrl" - it flips bytes before sending
*/
bool botnet_send_control(c_bot* bot, c_bot_control* ctrl)
{
    if(CTRL_PING==ctrl->control) {
        ctrl->control_data.timestamp_ping_1.valid=1;
        ctrl->control_data.timestamp_ping_1.now=static_cast<my_botnet_time_t>(my_time(NULL)); // BUG: degrading number
    }
    if(CTRL_PONG==ctrl->control) {
        ctrl->control_data.timestamp_pong_1.valid=1;
        ctrl->control_data.timestamp_pong_1.now=static_cast<my_botnet_time_t>(my_time(NULL)); // BUG: degrading number
    }
    if(CTRL_LINKED==ctrl->control) {
        ctrl->control_data.timestamp_linked_1.valid=1;
        ctrl->control_data.timestamp_linked_1.now=static_cast<my_botnet_time_t>(my_time(NULL)); // BUG: degrading number
    }

    // NB: following two: NOT in reverse order!
    ctrl->flip_rest();
    ctrl->flip_header();

    if(!bot->socket.cmp())
        return true;
    int ec=0;

    unsigned long compressed=0;
    int zlib_rc;
    char* buf=compress_zlib_compress((void*)&(ctrl->control_data),sizeof(ctrl->control_data),compressed,conf_pass.get_zlib_level(bot->botname),zlib_rc);
    if(zlib_rc!=Z_OK) {
        if(buf)
            MY_DELETE_A(buf);
        buf=NULL;

        string log="zlib error: \"";
        log+=compress_zlib_get_str_rc(zlib_rc);
        log+="\" ";
        log=GET_STR_DEBUG_INFO_EX(log);

        int ec=0;
        char* errstr=NULL;
        log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
        MY_DELETE_A(errstr);

        bot->garbage_socket();

        log_debug(log);
        log_botnet(botnet_botname,bot->botname,log);
        return true;
    }
    ctrl->size=static_cast<uint32>(compressed);
    byteReverse((unsigned char*)&ctrl->size,1);
    size_t sent=0;
    if(!bot->ssl_connection) {
        sent=sock_send(bot->socket,(char*)ctrl,4*4,ec);
        stats_botnet_bytes_sent(sent);
        sent=sock_send(bot->socket,(const char*)buf,compressed,ec);
        stats_botnet_bytes_sent(sent);
    } else if(bot->ssl) {
        string err_str;
        if(bot->ssl->get_error(err_str)) {
            log_ssl(err_str);
            log_botnet(botnet_botname,bot->botname,err_str);
            bot->garbage_socket();
            ec=-1;
        } else {
            bot->ssl->write(ctrl,4*4);
            stats_botnet_bytes_sent(4*4);
            bot->ssl->write(buf,compressed);
            sent=compressed;
            stats_botnet_bytes_sent(compressed);
        }
    }
    MY_DELETE_A(buf);

    if(sent!=compressed || ec!=0) {
        string log=GET_STR_DEBUG_INFO_EX("Not all data had been sent");
        char* errstr=NULL;
        log_socket(ec,errstr=sock_error(ec),log,&bot->socket);
        MY_DELETE_A(errstr);
        return true;
    }
    string log=GET_STR_DEBUG_INFO_EX("Sent to remote bot");
    log_botnet_debug(botnet_botname,bot->botname,ctrl->packet_type,ctrl->control,log);
    return false;
}

/*!
    \brief Checks for possibly buffre overflow - string size in packet
    \author VooDooMan
    \version 1
    \date 2005
    \param str String
    \param max_size Maximum size of string
    \retval false Okay
    \retval true Possibly buffer overflow
*/
bool botnet_check_string_size(char* str, size_t max_size)
{
    bool ok=false;
    for(size_t i1=0; i1<max_size; ++i1) {
        if(str[i1]==0) {
            ok=true;
            break;
        }
    }
    return !ok;
}

/*!
    \brief Checks for possibly buffre overflow
    \author VooDooMan
    \version 1
    \date 2004
    \param cmd Received command
    \retval false Okay
    \retval true Possibly buffer overflow
*/
bool botnet_check_for_buffer_overflow(c_bot_command& cmd)
{
    if(cmd.packet_type!=PACKET_TYPE_COMMAND)
        return true;

    if(cmd.version>SUPPORTED_PROTO_VERSION)
        return true;

    switch(cmd.command) {
        case CMD_AUTH_1:
            if(botnet_check_string_size(cmd.command_data.bot_auth_1.botname,sizeof(cmd.command_data.bot_auth_1.botname)))
                return true;
            if(botnet_check_string_size((char*)cmd.command_data.bot_auth_1.digest,sizeof(cmd.command_data.bot_auth_1.digest)))
                return true;
            break;
        case CMD_CHECK_TIME_1:
            if(botnet_check_string_size(cmd.command_data.check_time_1.object_name,sizeof(cmd.command_data.check_time_1.object_name)))
                return true;
            break;
        case CMD_NO_REPL_1:
            if(botnet_check_string_size(cmd.command_data.no_repl_1.object_name,sizeof(cmd.command_data.no_repl_1.object_name)))
                return true;
            break;
        case CMD_REPL_USER_01_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_01_1.name,sizeof(cmd.command_data.cmd_repl_user_01_1.name)))
                return true;
            break;
        case CMD_REPL_USER_01B_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_01B_1.name,sizeof(cmd.command_data.cmd_repl_user_01B_1.name)))
                return true;
            break;
        case CMD_REPL_USER_02_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_02_1.name,sizeof(cmd.command_data.cmd_repl_user_02_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_02_1.hostmask,sizeof(cmd.command_data.cmd_repl_user_02_1.hostmask)))
                return true;
            break;
        case CMD_REPL_USER_03_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_03_1.name,sizeof(cmd.command_data.cmd_repl_user_03_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_03_1.fullname,sizeof(cmd.command_data.cmd_repl_user_03_1.fullname)))
                return true;
            break;
        case CMD_REPL_USER_04_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_04_1.name,sizeof(cmd.command_data.cmd_repl_user_04_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_04_1.access_to_group,sizeof(cmd.command_data.cmd_repl_user_04_1.access_to_group)))
                return true;
            break;
        case CMD_REPL_USER_06_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_06_1.name,sizeof(cmd.command_data.cmd_repl_user_06_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_06_1.access_grant_proc,sizeof(cmd.command_data.cmd_repl_user_06_1.access_grant_proc)))
                return true;
            break;
        case CMD_REPL_USER_07_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_07_1.name,sizeof(cmd.command_data.cmd_repl_user_07_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_07_1.access_grant_group,sizeof(cmd.command_data.cmd_repl_user_07_1.access_grant_group)))
                return true;
            break;
        case CMD_REPL_USER_10_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_10_1.name,sizeof(cmd.command_data.cmd_repl_user_10_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_10_1.group,sizeof(cmd.command_data.cmd_repl_user_10_1.group)))
                return true;
            break;
        case CMD_REPL_USER_11_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_11_1.name,sizeof(cmd.command_data.cmd_repl_user_11_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_11_1.dcc_host,sizeof(cmd.command_data.cmd_repl_user_11_1.dcc_host)))
                return true;
            break;
        case CMD_REPL_USER_11B_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_11B_1.name,sizeof(cmd.command_data.cmd_repl_user_11B_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_11B_1.channel,sizeof(cmd.command_data.cmd_repl_user_11B_1.channel)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_11B_1.group,sizeof(cmd.command_data.cmd_repl_user_11B_1.group)))
                return true;
            break;
        case CMD_REPL_USER_12_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.name,sizeof(cmd.command_data.cmd_repl_user_12_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.channel,sizeof(cmd.command_data.cmd_repl_user_12_1.channel)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_deop,sizeof(cmd.command_data.cmd_repl_user_12_1.on_deop)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_ban,sizeof(cmd.command_data.cmd_repl_user_12_1.on_ban)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_unban,sizeof(cmd.command_data.cmd_repl_user_12_1.on_unban)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_kick,sizeof(cmd.command_data.cmd_repl_user_12_1.on_kick)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_op,sizeof(cmd.command_data.cmd_repl_user_12_1.on_op)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_voice,sizeof(cmd.command_data.cmd_repl_user_12_1.on_voice)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_devoice,sizeof(cmd.command_data.cmd_repl_user_12_1.on_devoice)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_creator,sizeof(cmd.command_data.cmd_repl_user_12_1.on_creator)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_decreator,sizeof(cmd.command_data.cmd_repl_user_12_1.on_decreator)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_join,sizeof(cmd.command_data.cmd_repl_user_12_1.on_join)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_banned,sizeof(cmd.command_data.cmd_repl_user_12_1.on_banned)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_flood,sizeof(cmd.command_data.cmd_repl_user_12_1.on_flood)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_privmsg,sizeof(cmd.command_data.cmd_repl_user_12_1.on_privmsg)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_notice,sizeof(cmd.command_data.cmd_repl_user_12_1.on_notice)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_except,sizeof(cmd.command_data.cmd_repl_user_12_1.on_except)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_unexcept,sizeof(cmd.command_data.cmd_repl_user_12_1.on_unexcept)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_invite,sizeof(cmd.command_data.cmd_repl_user_12_1.on_invite)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_uninvite,sizeof(cmd.command_data.cmd_repl_user_12_1.on_uninvite)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_not_invited,sizeof(cmd.command_data.cmd_repl_user_12_1.on_not_invited)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_not_in_reop,sizeof(cmd.command_data.cmd_repl_user_12_1.on_not_in_reop)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_reop,sizeof(cmd.command_data.cmd_repl_user_12_1.on_reop)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_other_mode,sizeof(cmd.command_data.cmd_repl_user_12_1.on_other_mode)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.on_other_mode_mask,sizeof(cmd.command_data.cmd_repl_user_12_1.on_other_mode_mask)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.dynamic_plus_modes,sizeof(cmd.command_data.cmd_repl_user_12_1.dynamic_plus_modes)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_12_1.dynamic_minus_modes,sizeof(cmd.command_data.cmd_repl_user_12_1.dynamic_minus_modes)))
                return true;
            break;
        case CMD_REPL_USER_13_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_13_1.name,sizeof(cmd.command_data.cmd_repl_user_13_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_13_1.channel,sizeof(cmd.command_data.cmd_repl_user_13_1.channel)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_13_1.group,sizeof(cmd.command_data.cmd_repl_user_13_1.group)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_13_1.plus_modes,sizeof(cmd.command_data.cmd_repl_user_13_1.plus_modes)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_13_1.minus_modes,sizeof(cmd.command_data.cmd_repl_user_13_1.minus_modes)))
                return true;
            break;
        case CMD_REPL_USER_14_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_14_1.name,sizeof(cmd.command_data.cmd_repl_user_14_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_14_1.meta_key,sizeof(cmd.command_data.cmd_repl_user_14_1.meta_key)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_14_1.meta_val,sizeof(cmd.command_data.cmd_repl_user_14_1.meta_val)))
                return true;
            break;
        case CMD_REPL_USER_15_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_15_1.name,sizeof(cmd.command_data.cmd_repl_user_15_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_15_1.access_usage_proc,sizeof(cmd.command_data.cmd_repl_user_15_1.access_usage_proc)))
                return true;
            break;
        case CMD_REPL_USER_16_5:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_16_5.name,sizeof(cmd.command_data.cmd_repl_user_16_5.name)))
                return true;
            break;
        case CMD_REPL_USER_17_9:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_17_9.name,sizeof(cmd.command_data.cmd_repl_user_17_9.name)))
                return true;
            break;
        case CMD_REPL_USER_99_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_user_99_1.name,sizeof(cmd.command_data.cmd_repl_user_99_1.name)))
                return true;
            break;
        case CMD_PUSH_1:
            if(botnet_check_string_size(cmd.command_data.cmd_push_1.object_name,sizeof(cmd.command_data.cmd_push_1.object_name)))
                return true;
            break;
        case CMD_PROC_1:
            if(botnet_check_string_size(cmd.command_data.cmd_proc_1.name,sizeof(cmd.command_data.cmd_proc_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_proc_1.line,sizeof(cmd.command_data.cmd_proc_1.line)))
                return true;
            break;
        case CMD_PROC_END_1:
            if(botnet_check_string_size(cmd.command_data.cmd_proc_end_1.name,sizeof(cmd.command_data.cmd_proc_end_1.name)))
                return true;
            break;
        case CMD_PARTYLINE_1:
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_1.user,sizeof(cmd.command_data.cmd_partyline_1.user)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_1.message,sizeof(cmd.command_data.cmd_partyline_1.message)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_1.channel,sizeof(cmd.command_data.cmd_partyline_1.channel)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_1.botname,sizeof(cmd.command_data.cmd_partyline_1.botname)))
                return true;
            break;
        case CMD_PARTYLINE_USER_1:
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_user_1.user,sizeof(cmd.command_data.cmd_partyline_user_1.user)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_user_1.channel,sizeof(cmd.command_data.cmd_partyline_user_1.channel)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_partyline_user_1.botname,sizeof(cmd.command_data.cmd_partyline_user_1.botname)))
                return true;
            break;
        case CMD_REPL_CHDEF_01_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.name,sizeof(cmd.command_data.cmd_repl_chdef_01_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_mode,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_mode)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_key,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_key)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_limit,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_limit)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_topic,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_topic)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_ircop,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_ircop)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_ctcp,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_ctcp)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_privmsg,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_privmsg)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_notice,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_notice)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_part,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_part)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.on_dynamic_ban,sizeof(cmd.command_data.cmd_repl_chdef_01_1.on_dynamic_ban)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.dynamic_plus_modes,sizeof(cmd.command_data.cmd_repl_chdef_01_1.dynamic_plus_modes)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_01_1.dynamic_minus_modes,sizeof(cmd.command_data.cmd_repl_chdef_01_1.dynamic_minus_modes)))
                return true;
            break;
        case CMD_REPL_CHDEF_02_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_02_1.name,sizeof(cmd.command_data.cmd_repl_chdef_02_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_02_1.group,sizeof(cmd.command_data.cmd_repl_chdef_02_1.group)))
                return true;
            break;
        case CMD_REPL_CHDEF_03_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_03_1.name,sizeof(cmd.command_data.cmd_repl_chdef_03_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_03_1.group,sizeof(cmd.command_data.cmd_repl_chdef_03_1.group)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_03_1.plus_modes,sizeof(cmd.command_data.cmd_repl_chdef_03_1.plus_modes)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_03_1.minus_modes,sizeof(cmd.command_data.cmd_repl_chdef_03_1.minus_modes)))
                return true;
            break;
        case CMD_REPL_CHDEF_04_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_04_1.name,sizeof(cmd.command_data.cmd_repl_chdef_04_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_04_1.mask,sizeof(cmd.command_data.cmd_repl_chdef_04_1.mask)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_04_1.reason,sizeof(cmd.command_data.cmd_repl_chdef_04_1.reason)))
                return true;
            break;
        case CMD_REPL_CHDEF_05_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_05_1.name,sizeof(cmd.command_data.cmd_repl_chdef_05_1.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_05_1.group,sizeof(cmd.command_data.cmd_repl_chdef_05_1.group)))
                return true;
            break;
        case CMD_REPL_CHDEF_06_8:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_06_8.name,sizeof(cmd.command_data.cmd_repl_chdef_06_8.name)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_06_8.on_server_msg,sizeof(cmd.command_data.cmd_repl_chdef_06_8.on_server_msg)))
                return true;
        case CMD_REPL_CHDEF_99_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_chdef_99_1.name,sizeof(cmd.command_data.cmd_repl_chdef_99_1.name)))
                return true;
            break;
        case CMD_REPL_PRV_01_1:
            break;
        case CMD_REPL_PRV_02_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_02_1.group,sizeof(cmd.command_data.cmd_repl_prv_02_1.group)))
                return true;
            break;
        case CMD_REPL_PRV_03_1:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_03_1.on_privmsg,sizeof(cmd.command_data.cmd_repl_prv_03_1.on_privmsg)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_03_1.on_notice,sizeof(cmd.command_data.cmd_repl_prv_03_1.on_notice)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_03_1.on_ctcp,sizeof(cmd.command_data.cmd_repl_prv_03_1.on_ctcp)))
                return true;
            break;
        case CMD_REPL_PRV_04_7:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_04_7.on_filesys_got_new,sizeof(cmd.command_data.cmd_repl_prv_04_7.on_filesys_got_new)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_04_7.on_fnc,sizeof(cmd.command_data.cmd_repl_prv_04_7.on_fnc)))
                return true;
            break;
        case CMD_REPL_PRV_05_8:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_05_8.on_broadcast,sizeof(cmd.command_data.cmd_repl_prv_05_8.on_broadcast)))
                return true;
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_05_8.on_server_msg,sizeof(cmd.command_data.cmd_repl_prv_05_8.on_server_msg)))
                return true;
            break;
        case CMD_REPL_PRV_06_11:
            if(botnet_check_string_size(cmd.command_data.cmd_repl_prv_06_11.on_internal_event,sizeof(cmd.command_data.cmd_repl_prv_06_11.on_internal_event)))
                return true;
            break;
        case CMD_REPL_PRV_99_1:
            break;
        case CMD_REMOTE_PROCEDURE_CALL_3:
            // nothing do be done (arguments are in binary field, actually not text)
            break;
        case CMD_CHALLENGE_13:
            if(botnet_check_string_size((char*)cmd.command_data.bot_challenge_13.magic,sizeof(cmd.command_data.bot_challenge_13.magic)))
                return true;
            break;
        case CMD_AUTH_13:
            if(botnet_check_string_size((char*)cmd.command_data.bot_auth_13.digest,sizeof(cmd.command_data.bot_auth_13.digest)))
                return true;
            break;
        case CMD_UPDATE_1004:
            break;
        default:
            return true;
    }
    return false;
}

#if defined(_MSC_VER)
#   pragma warning(push)
#   pragma warning(disable:4702)    // warning C4702: unreachable code
#endif

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Receives command or control packet
    \param bot Remote bot's data
    \param packet_type Returns type of packet
    \param cmd If packet_type == PACKET_TYPE_COMMAND, this contains command packet
    \param control If packet_type == PACKET_TYPE_CONTROL, this contains control packet
    \return Returns status
    \retval 0 The buffer is empty
    \retval 1 Got data
    \retval 3 Got data, but connection closed
    \retval 4 Don't have data and connection closed
    \retval 5 Connection should be closed for error
*/
// returns 0 for empty buffer
// returns 1 for got data
// returns 3 for got data, but connection closed
// returns 4 for don't have data, and connection closed
// returns 5 connection should be closed for error
int botnet_receive(c_bot* bot, int& packet_type, c_bot_command* cmd, c_bot_control* control)
{
    int ec=0;
    bool closed=false;
    size_t len=0;

    if(bot->receive_buffer_pos<4*4) {
        bot->flipped=false;
        char* data=(char*)&bot->control_receive_buffer;

        if(!bot->ssl_connection) {
            len=sock_read(bot->socket,&data[bot->receive_buffer_pos],4*4-bot->receive_buffer_pos,ec,closed);
            stats_botnet_bytes_received(len);
            if(ec || closed) {
                char* errstr=NULL;
                log_socket(ec,errstr=sock_error(ec),GET_STR_DEBUG_INFO,&(bot->socket));
                MY_DELETE_A(errstr);
                bot->garbage_socket();
                return 4;
            }
            bot->receive_buffer_pos+=len;
        } else {
            len=0;
            if(bot->ssl) {
                string err_str;
                if(bot->ssl->get_error(err_str)) {
                    log_ssl(err_str);
                    log_botnet(botnet_botname,bot->botname,err_str);
                    string log=GET_STR_DEBUG_INFO_EX("SSL error");
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(MY_SSL_ERROR),log,&(bot->socket));
                    MY_DELETE_A(errstr);

                    bot->garbage_socket();
                    ec=-1;
                    closed=true;
                    return 4;
                }
                len=bot->ssl->read(&data[bot->receive_buffer_pos],4*4-bot->receive_buffer_pos);
                bot->receive_buffer_pos+=len;
            }
        }
    }

    if(bot->receive_buffer_pos==4*4 && !bot->flipped) {
        bot->control_receive_buffer.flip_header();
        memcpy(&bot->command_receive_buffer,&bot->control_receive_buffer,4*4);
        bot->flipped=true;
    }

    if(bot->receive_buffer_pos>=4*4) {
        bool control_=false;
        bool command_=false;

        control_=bot->control_receive_buffer.packet_type==PACKET_TYPE_CONTROL;
        command_=bot->control_receive_buffer.packet_type==PACKET_TYPE_COMMAND;

        // sanity check
        if((!control_ && !command_) || bot->command_receive_buffer.size>sizeof(bot->command_receive_buffer.command_data)*2) {
            int ec=0;
            bot->ssl=NULL;
            string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
            char* errstr=NULL;
            log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
            MY_DELETE_A(errstr);

            bot->garbage_socket();
            return 5;
        }

        {
            size_t partial_data_size=1024;
            char* partial_data=MY_NEW char[partial_data_size];

            for(;;) {
                len=0;
                if(bot->receive_buffer_pos<bot->control_receive_buffer.size+4*4) {
                    size_t want_bytes=bot->control_receive_buffer.size-bot->receive_buffer_pos+4*4;
                    if(want_bytes>partial_data_size)
                        want_bytes=partial_data_size;

                    if(!bot->ssl_connection) {
                        len=sock_read(bot->socket,partial_data,want_bytes,ec,closed);
                        stats_botnet_bytes_received(len);
                    } else {
                        string err_str;
                        if(bot->ssl->get_error(err_str)) {
                            log_ssl(err_str);
                            log_botnet(botnet_botname,bot->botname,err_str);
                            string log=GET_STR_DEBUG_INFO_EX("SSL error");
                            char* errstr=NULL;
                            log_socket(ec,errstr=sock_error(MY_SSL_ERROR),log,&(bot->socket));
                            MY_DELETE_A(errstr);

                            bot->garbage_socket();
                            ec=-1;
                            closed=true;
                            MY_DELETE_A(partial_data);
                            return 4;
                        }
                        len=bot->ssl->read(partial_data,want_bytes);
                        stats_botnet_bytes_received(len);
                    }
                }
                if(ec) {
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),GET_STR_DEBUG_INFO,&(bot->socket));
                    MY_DELETE_A(errstr);

                    bot->garbage_socket();
                    MY_DELETE_A(partial_data);
                    return 4;
                }
                if(bot->rle_buffer==NULL && len!=0) {
                    bot->rle_buffer_len=bot->receive_buffer_pos-4*4+len;
                    bot->rle_buffer=(char*)my_malloc(bot->rle_buffer_len);
                    if(!bot->rle_buffer) {
                        int ec=0;
                        string log=GET_STR_DEBUG_INFO_EX("my_malloc() failed");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
                        MY_DELETE_A(errstr);

                        bot->garbage_socket();
                        log=GET_STR_DEBUG_INFO_EX("OOPS: occurred error: my_malloc() failed");
                        log_debug(log);
                        log_botnet(botnet_botname,bot->botname,"my_malloc() failed!");
                        MY_DELETE_A(partial_data);
                        return 4;
                    }
                    memcpy(bot->rle_buffer,partial_data,len);
                } else if(len!=0) {
                    bot->rle_buffer=(char*)my_realloc(bot->rle_buffer,bot->rle_buffer_len+len);
                    if(!bot->rle_buffer) {
                        int ec=0;
                        string log=GET_STR_DEBUG_INFO_EX("OOPS: occurred error: my_realloc() failed");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
                        MY_DELETE_A(errstr);

                        bot->garbage_socket();
                        log_debug(log);
                        log_botnet(botnet_botname,bot->botname,"my_realloc() failed!");
                        MY_DELETE_A(partial_data);
                        return 4;
                    }
                    memcpy(&(bot->rle_buffer[bot->rle_buffer_len]),partial_data,len);
                    bot->rle_buffer_len+=(unsigned int)len;
                }
                bot->receive_buffer_pos+=len;

                if(bot->receive_buffer_pos==bot->control_receive_buffer.size+4*4) {
                    cmd->hard_clear();
                    control->hard_clear();

                    unsigned long uncompressed=0;
                    /*
                    unsigned char* tmp=MY_NEW unsigned char[sizeof(cmd->command_data)*2];
                    */
                    if(control_) {
                        uncompressed=sizeof(control->control_data);
                    }
                    if(command_) {
                        uncompressed=sizeof(cmd->command_data);
                    }
                    if(uncompressed==0) {
                        // this should never occur since we tested it before

                        int ec=0;
                        string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
                        MY_DELETE_A(errstr);

                        bot->garbage_socket();

                        log=GET_STR_DEBUG_INFO_EX("OOPS: occurred error: Internal error #1");
                        log_debug(log);
                        log_botnet(botnet_botname,bot->botname,"internal error!");
                        //MY_DELETE_A(tmp);
                        MY_DELETE_A(partial_data);
                        return 4;
                    }
                    unsigned long out_len=uncompressed;
                    int zlib_rc;
                    char* buf=compress_zlib_decompress((void*)bot->rle_buffer,bot->rle_buffer_len,out_len,zlib_rc);
                    if(zlib_rc!=Z_OK) {
                        if(buf)
                            MY_DELETE_A(buf);
                        buf=NULL;

                        string log="zlib error: \"";
                        log+=compress_zlib_get_str_rc(zlib_rc);
                        log+="\" ";
                        log=GET_STR_DEBUG_INFO_EX(log);

                        int ec=0;
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
                        MY_DELETE_A(errstr);

                        bot->garbage_socket();

                        log_debug(log);
                        log_botnet(botnet_botname,bot->botname,log);
                        MY_DELETE_A(partial_data);
                        return 5;
                    }
                    if(out_len!=uncompressed || NULL==buf) {
                        if(buf)
                            MY_DELETE_A(buf);
                        buf=NULL;

                        int ec=0;
                        string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error - Internal error #Z1");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
                        MY_DELETE_A(errstr);

                        bot->garbage_socket();

                        log_debug(log);
                        log_botnet(botnet_botname,bot->botname,log);
                        MY_DELETE_A(partial_data);
                        return 5;
                    }
                    if(command_) {
                        memcpy(cmd,&(bot->command_receive_buffer),4*4);

                        memcpy(&(cmd->command_data),buf,sizeof(cmd->command_data));
                        MY_DELETE_A(buf);
                        buf=NULL;

                        cmd->flip();

                        if(botnet_check_for_buffer_overflow(*cmd)) {
                            log_debug("Buffer overflow detected in commnad packet!");
                            log_botnet(botnet_botname,bot->botname,"Buffer overflow detected in commnad packet!");
                            MY_DELETE_A(partial_data);
                            return 4;
                        }

                        packet_type=PACKET_TYPE_COMMAND;
                        if(!botnet_check_for_buffer_overflow(*cmd)) {
                            MY_DELETE_A(partial_data);
                            if(closed)
                                return 3;
                            else
                                return 1;
                        } else {
                            int ec=0;
                            string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
                            char* errstr=NULL;
                            log_socket(ec,errstr=sock_error(ec),log,&(bot->socket));
                            MY_DELETE_A(errstr);

                            bot->garbage_socket();

                            log_debug("Buffer overflow detected in commnad packet!");
                            log_botnet(botnet_botname,bot->botname,"Buffer overflow detected in commnad packet!");
                            MY_DELETE_A(partial_data);
                            return 4;
                        }
                    }
                    if(control_) {
                        memcpy(control,&(bot->control_receive_buffer),4*4);

                        memcpy(&(control->control_data),buf,sizeof(control->control_data));
                        MY_DELETE_A(buf);
                        buf=NULL;

                        control->flip_rest();

                        /*
                        // ignore this, as it may be inaccurate
                        if(CTRL_PING==control->control && control->control_data.timestamp_ping_1.valid) {
                            bot->set_difftime(control->control_data.timestamp_ping_1.now);
                        }
                        */
                        if(CTRL_PONG==control->control && control->control_data.timestamp_pong_1.valid) {
                            if(control->control_data.timestamp_pong_1.pong_to) {
                                if(::abs((signed long)(my_difftime(my_time(NULL),control->control_data.timestamp_pong_1.pong_to)))<=BOTNET_ROUNDTRIP_DIFF_TIME_MAX)
                                    bot->set_difftime(control->control_data.timestamp_pong_1.now);
                            }
                        }
                        if(CTRL_LINKED==control->control && control->control_data.timestamp_linked_1.valid) {
                            bot->set_difftime(control->control_data.timestamp_linked_1.now);
                        }

                        packet_type=PACKET_TYPE_CONTROL;
                        MY_DELETE_A(partial_data);
                        if(closed)
                            return 3;
                        else
                            return 1;
                    }
                    if(buf) { // we want to be sure ;-)
                        MY_DELETE_A(buf);
                        buf=NULL;
                    }
                }
                if(len==0) {
                    MY_DELETE_A(partial_data);
                    return 0;
                }
            }
            // NOTREACH
        }
    }

    return 0;
}

#if defined(_MSC_VER)
#   pragma warning(pop)
#endif

/*!
    \brief Writes information to log files about PUSH replication
        of object, and triggers 'on_internal_event'
    \version 1
    \date 2008-02-26
    \author VooDooMan
    \param remote Remote bot descriptor
    \param obj Name of object
    \param obj_type Type of object
    \param obj_diff Diff in seconds of local and remote object
*/
MY_STATIC void botnet_log_replication_event_push(const c_bot* remote, const string& obj_type, const string& obj, const MY_LONG_LONG& obj_diff)
{
    string log="Remote bot is ";
    log+=tos(remote->remote_time_diff);
    log+=" second(s) in the future (negative value means it is in the past)";
    log_botnet(botnet_botname,remote->botname,log);
    log_botnet_debug(botnet_botname,remote->botname,-1,-1,log);

    log="Remote bot's (";
    log+=obj_type;
    log+=") \"";
    log+=obj;
    log+="\" is ";
    log+=tos(obj_diff);
    log+=" second(s) in the future (negative value means it is in the past)";
    log_botnet(botnet_botname,remote->botname,log);
    log_botnet_debug(botnet_botname,remote->botname,-1,-1,log);

    log="Replication: PUSH of object (";
    log+=obj_type;
    log+=") \"";
    log+=obj;
    log+="\"";
    log_botnet(botnet_botname,remote->botname,log);
    log_botnet_debug(botnet_botname,remote->botname,-1,-1,log);

    logic_on_internal_event("@botnet_replication@",remote->botname,obj_type,obj,"OK",PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,log,"PUSH");
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Pushes the private query definition to remote bot
    \param bot Remote bot's data
    \param prv Private definition to push
    \param obj_diff Diff in seconds of local and remote object
*/
void botnet_push_prv(c_bot* bot, c_private& prv, const MY_LONG_LONG& obj_diff)
{
    if(!bot)
        return;
    if(!bot->socket.cmp())
        return;

    {
        size_t to_receive=0, to_send=0;
        if(!bot->ssl_connection)
            sock_cache_stats(bot->socket,to_receive,to_send);
        else if(bot->ssl)
            bot->ssl->get_cache_stats(to_receive,to_send);
        if(to_send>=BOTNET_MAXIMUM_SOCKET_CACHE) {
            string log="I have cancelled pushing of object (private) to remote bot '";
            log+=bot->botname;
            log+="', because send queue exceeded 'BOTNET_MAXIMUM_SOCKET_CACHE' which is ";
            log+=tos(BOTNET_MAXIMUM_SOCKET_CACHE)+" bytes. You can adjust this limit in 'params.h' file and recompile bot.";
            log_botnet(botnet_botname,bot->botname,log);
            return;
        }
    }

    stats_botnet_private_pushed();

    if(r_private.last_changed==0)
        my_time(&r_private.last_changed);

    c_bot_command* c=MY_NEW c_bot_command;
    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_PRV_01_1;

        c->command_data.cmd_repl_prv_01_1.last_changed=static_cast<my_botnet_time_t>(prv.last_changed);
        botnet_send_command(bot,c);
    }

    {
        int data_size=sizeof(c->command_data.cmd_repl_prv_02_1.group); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=prv.groups.begin(); i2!=prv.groups.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_PRV_02_1; // !!!

            memset(data,0,data_size);
            strncpy(data,(*i2).c_str(),data_size-1);

            memcpy(c->command_data.cmd_repl_prv_02_1.group,data,data_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }

    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_PRV_03_1;

        size_t data_size=sizeof(c->command_data.cmd_repl_prv_03_1.on_privmsg); // !!!
        if(data_size>sizeof(c->command_data.cmd_repl_prv_03_1.on_notice))
            data_size=sizeof(c->command_data.cmd_repl_prv_03_1.on_notice);
        if(data_size>sizeof(c->command_data.cmd_repl_prv_03_1.on_ctcp))
            data_size=sizeof(c->command_data.cmd_repl_prv_03_1.on_ctcp);
        char* data=MY_NEW char[data_size+1];

        memset(data,0,data_size);
        strncpy(data,prv.on_privmsg.c_str(),data_size-1);
        memcpy(c->command_data.cmd_repl_prv_03_1.on_privmsg,data,data_size); // !!!

        memset(data,0,data_size);
        strncpy(data,prv.on_notice.c_str(),data_size-1);
        memcpy(c->command_data.cmd_repl_prv_03_1.on_notice,data,data_size); // !!!

        memset(data,0,data_size);
        strncpy(data,prv.on_ctcp.c_str(),data_size-1);
        memcpy(c->command_data.cmd_repl_prv_03_1.on_ctcp,data,data_size); // !!!

        MY_DELETE_A(data);

        botnet_send_command(bot,c);
    }

    if(bot->supported_proto_version>=7) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=7;
        c->command=CMD_REPL_PRV_04_7;

        size_t data_size=sizeof(c->command_data.cmd_repl_prv_04_7.on_filesys_got_new); // !!!
        if(data_size>sizeof(c->command_data.cmd_repl_prv_04_7.on_filesys_got_new))
            data_size=sizeof(c->command_data.cmd_repl_prv_04_7.on_filesys_got_new);
        if(data_size>sizeof(c->command_data.cmd_repl_prv_04_7.on_fnc))
            data_size=sizeof(c->command_data.cmd_repl_prv_04_7.on_fnc);
        char* data=MY_NEW char[data_size+1];

        memset(data,0,data_size);
        strncpy(data,prv.on_filesys_got_new.c_str(),data_size-1);
        memcpy(c->command_data.cmd_repl_prv_04_7.on_filesys_got_new,data,data_size); // !!!

        memset(data,0,data_size);
        strncpy(data,prv.on_fnc.c_str(),data_size-1);
        memcpy(c->command_data.cmd_repl_prv_04_7.on_fnc,data,data_size); // !!!

        MY_DELETE_A(data);

        botnet_send_command(bot,c);
    }

    if(bot->supported_proto_version>=8) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=8;
        c->command=CMD_REPL_PRV_05_8;

        size_t data_size=sizeof(c->command_data.cmd_repl_prv_05_8.on_broadcast); // !!!
        if(data_size>sizeof(c->command_data.cmd_repl_prv_05_8.on_broadcast))
            data_size=sizeof(c->command_data.cmd_repl_prv_05_8.on_broadcast);
        if(data_size>sizeof(c->command_data.cmd_repl_prv_05_8.on_server_msg))
            data_size=sizeof(c->command_data.cmd_repl_prv_05_8.on_server_msg);
        char* data=MY_NEW char[data_size+1];

        memset(data,0,data_size);
        strncpy(data,prv.on_broadcast.c_str(),data_size-1); // !!!
        memcpy(c->command_data.cmd_repl_prv_05_8.on_broadcast,data,data_size); // !!!

        memset(data,0,data_size);
        strncpy(data,prv.on_server_msg.c_str(),data_size-1); // !!!
        memcpy(c->command_data.cmd_repl_prv_05_8.on_server_msg,data,data_size); // !!!

        MY_DELETE_A(data);

        botnet_send_command(bot,c);
    }

    if(bot->supported_proto_version>=11) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=8;
        c->command=CMD_REPL_PRV_06_11;

        int data_size=sizeof(c->command_data.cmd_repl_prv_06_11.on_internal_event); // !!!
        char* data=MY_NEW char[data_size+1];

        memset(data,0,data_size);
        strncpy(data,prv.on_internal_event.c_str(),data_size-1); // !!!
        memcpy(c->command_data.cmd_repl_prv_06_11.on_internal_event,data,data_size); // !!!

        MY_DELETE_A(data);

        botnet_send_command(bot,c);
    }

    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_PRV_99_1;
        botnet_send_command(bot,c);
    }

    botnet_log_replication_event_push(bot,"private","private",obj_diff);

    MY_DELETE(c);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Pushes the user to remote bot
    \param bot Remote bot's data
    \param u User to push
    \param obj_diff Diff in seconds of local and remote object
*/
void botnet_push_user(c_bot* bot, c_user& u, const MY_LONG_LONG& obj_diff)
{
    if(!bot)
        return;
    if(!bot->socket.cmp())
        return;
    {
        size_t to_receive=0, to_send=0;
        if(!bot->ssl_connection)
            sock_cache_stats(bot->socket,to_receive,to_send);
        else if(bot->ssl)
            bot->ssl->get_cache_stats(to_receive,to_send);
        if(to_send>=BOTNET_MAXIMUM_SOCKET_CACHE) {
            string log="I have cancelled pushing of object (user) \"";
            log+=u.name;
            log+="\" to remote bot '";
            log+=bot->botname;
            log+="', because send queue exceeded 'BOTNET_MAXIMUM_SOCKET_CACHE' which is ";
            log+=tos(BOTNET_MAXIMUM_SOCKET_CACHE)+" bytes. You can adjust this limit in 'params.h' file and recompile bot.";
            log_botnet(botnet_botname,bot->botname,log);
            return;
        }
    }

    stats_botnet_user_pushed();

    if(u.last_changed==0)
        my_time(&u.last_changed);

    c_bot_command* c=MY_NEW c_bot_command;
    int name_size=sizeof(c->command_data.cmd_repl_user_01_1.name);
    char* name=MY_NEW char[name_size];
    memset(name,0,name_size);
    strncpy(name,u.name.c_str(),name_size-1);
    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_USER_01_1;

        memcpy(c->command_data.cmd_repl_user_01_1.name,name,name_size);

        c->command_data.cmd_repl_user_01_1.host_unknown=u.host_unknown;
        c->command_data.cmd_repl_user_01_1.host_bot=u.host_bot;
        c->command_data.cmd_repl_user_01_1.is_template=u.is_template;
        c->command_data.cmd_repl_user_01_1.terminator=u.terminator;
        c->command_data.cmd_repl_user_01_1.access_grant_partyline=u.access_grant_partyline;
        c->command_data.cmd_repl_user_01_1.access_to_backup=u.access_to_backup;
        c->command_data.cmd_repl_user_01_1.access_grant_backup=u.access_grant_backup;
        c->command_data.cmd_repl_user_01_1.access_to_rehash=u.access_to_rehash;
        c->command_data.cmd_repl_user_01_1.access_grant_rehash=u.access_grant_rehash;

        c->command_data.cmd_repl_user_01_1.access_to_plususer=u.access_to_plususer;
        c->command_data.cmd_repl_user_01_1.access_grant_plususer=u.access_grant_plususer;
        c->command_data.cmd_repl_user_01_1.access_to_plusproc=u.access_to_plusproc;
        c->command_data.cmd_repl_user_01_1.access_grant_plusproc=u.access_grant_plusproc;

        c->command_data.cmd_repl_user_01_1.access_to_partyline=u.access_to_partyline;
        c->command_data.cmd_repl_user_01_1.partyline_msg_flood.lines=u.partyline_msg_flood.lines;
        c->command_data.cmd_repl_user_01_1.partyline_msg_flood.seconds=static_cast<my_botnet_time_t>(u.partyline_msg_flood.seconds);   // BUG: degrading number
        c->command_data.cmd_repl_user_01_1.last_changed=static_cast<my_botnet_time_t>(u.last_changed);

        c->command_data.cmd_repl_user_01_1.access_to_can_send_all_users=u.access_to_can_send_all_users;
        c->command_data.cmd_repl_user_01_1.access_grant_can_send_all_users=u.access_grant_can_send_all_users;

        c->command_data.cmd_repl_user_01_1.access_to_can_send_unknown_users=u.access_to_can_send_unknown_users;
        c->command_data.cmd_repl_user_01_1.access_grant_can_send_unknown_users=u.access_grant_can_send_unknown_users;

        botnet_send_command(bot,c);
    }
    if(bot->supported_proto_version>=1003) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_USER_01B_1;

        memcpy(c->command_data.cmd_repl_user_01B_1.name,name,name_size);

        c->command_data.cmd_repl_user_01B_1.access_to_restart=u.access_to_restart;
        c->command_data.cmd_repl_user_01B_1.access_grant_restart=u.access_grant_restart;
        c->command_data.cmd_repl_user_01B_1.access_to_die=u.access_to_die;
        c->command_data.cmd_repl_user_01B_1.access_grant_die=u.access_grant_die;
        c->command_data.cmd_repl_user_01B_1.access_to_replication=u.access_to_replication;
        c->command_data.cmd_repl_user_01B_1.access_grant_replication=u.access_grant_replication;
        c->command_data.cmd_repl_user_01B_1.access_to_filesystem=u.access_to_filesystem;
        c->command_data.cmd_repl_user_01B_1.access_grant_filesystem=u.access_grant_filesystem;
        c->command_data.cmd_repl_user_01B_1.access_to_private=u.access_to_private;
        c->command_data.cmd_repl_user_01B_1.access_grant_private=u.access_grant_private;

        botnet_send_command(bot,c);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_02_1.hostmask); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.hostmask.begin(); i2!=u.hostmask.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_02_1; // !!!

            memcpy(c->command_data.cmd_repl_user_02_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_02_1.hostmask,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_03_1.fullname); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.fullname.begin(); i2!=u.fullname.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_03_1; // !!!

            memcpy(c->command_data.cmd_repl_user_03_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_03_1.fullname,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_04_1.access_to_group); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.access_to_group.begin(); i2!=u.access_to_group.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_04_1; // !!!

            memcpy(c->command_data.cmd_repl_user_04_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_04_1.access_to_group,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_06_1.access_grant_proc); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.access_grant_procedure.begin(); i2!=u.access_grant_procedure.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_06_1; // !!!

            memcpy(c->command_data.cmd_repl_user_06_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_06_1.access_grant_proc,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_07_1.access_grant_group); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.access_grant_group.begin(); i2!=u.access_grant_group.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_07_1; // !!!

            memcpy(c->command_data.cmd_repl_user_07_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_07_1.access_grant_group,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_10_1.group); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.groups.begin(); i2!=u.groups.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_10_1; // !!!

            memcpy(c->command_data.cmd_repl_user_10_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_10_1.group,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        int data_size=sizeof(c->command_data.cmd_repl_user_11_1.dcc_host); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<c_dcc_host>::iterator i2;
        for(i2=u.dcc_hosts.begin(); i2!=u.dcc_hosts.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_11_1; // !!!

            memcpy(c->command_data.cmd_repl_user_11_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).host.c_str(),data_size-2);
            strcat(data,"\"");

            c->command_data.cmd_repl_user_11_1.dcc_group=(*i2).group;
            memcpy(c->command_data.cmd_repl_user_11_1.dcc_host,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    {
        size_t data_size=c_bot_command::u_commnd_data::c_cmd_repl_user_12_1::EVENT_BYTES; // !!!

        char* data=MY_NEW char[data_size+1];

        int dpm_size=sizeof(c->command_data.cmd_repl_user_12_1.dynamic_plus_modes); // !!!
        int dmm_size=sizeof(c->command_data.cmd_repl_user_12_1.dynamic_plus_modes); // !!!

        char* plus=MY_NEW char[dpm_size];
        char* minus=MY_NEW char[dmm_size];

        vector<c_channel> chans;
        logic_botnet_get_user_channels(u.name,chans);

        vector<c_channel>::iterator i2;
        for(i2=chans.begin(); i2!=chans.end(); ++i2) {
            {
                size_t data_size=sizeof(c->command_data.cmd_repl_user_11B_1.group); // !!!
                if(data_size<sizeof(c->command_data.cmd_repl_user_11B_1.name))
                    data_size=sizeof(c->command_data.cmd_repl_user_11B_1.name);
                if(data_size<sizeof(c->command_data.cmd_repl_user_11B_1.channel))
                    data_size=sizeof(c->command_data.cmd_repl_user_11B_1.channel);
                char* data=MY_NEW char[data_size+16];
                memset(data,0,data_size+16);

                vector<string>::iterator i3;
                for(i3=(*i2).groups.begin(); i3!=(*i2).groups.end(); ++i3) {
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_COMMAND;
                    c->size=sizeof(c);
                    c->version=1;
                    c->command=CMD_REPL_USER_11B_1; // !!!

                    memcpy(c->command_data.cmd_repl_user_11B_1.name,name,name_size); // !!!

                    memset(data,0,data_size);
                    strcpy(data,"\"");
                    strncat(data,(*i2).channel_name.c_str(),data_size-2);
                    strcat(data,"\"");
                    memcpy(c->command_data.cmd_repl_user_11B_1.channel,data,data_size); // !!!

                    memset(data,0,data_size);
                    strcpy(data,"\"");
                    strncat(data,(*i3).c_str(),data_size-2);
                    strcat(data,"\"");
                    memcpy(c->command_data.cmd_repl_user_11B_1.group,data,data_size); // !!!

                    botnet_send_command(bot,c);
                }
                MY_DELETE_A(data);
            }
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_12_1; // !!!

            memcpy(c->command_data.cmd_repl_user_12_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).channel_name.c_str(),data_size-2);
            strcat(data,"\"");
            memcpy(c->command_data.cmd_repl_user_12_1.channel,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_deop.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_deop,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_ban.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_ban,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_unban.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_unban,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_kick.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_kick,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_op.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_op,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_voice.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_voice,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_devoice.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_devoice,data,data_size);

            memset(data,0,data_size);
            memcpy(c->command_data.cmd_repl_user_12_1.on_creator,data,data_size);

            memset(data,0,data_size);
            memcpy(c->command_data.cmd_repl_user_12_1.on_decreator,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_join.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_join,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_banned.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_banned,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_flood.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_flood,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_privmsg.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_privmsg,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_notice.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_notice,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_except.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_except,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_unexcept.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_unexcept,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_invite.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_invite,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_uninvite.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_uninvite,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_not_invited.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_not_invited,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_not_in_reop.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_not_in_reop,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_reop.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_reop,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_other_mode.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_other_mode,data,data_size);

            memset(data,0,data_size);
            strncpy(data,(*i2).on_other_mode_mask.c_str(),data_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.on_other_mode_mask,data,data_size);

            c->command_data.cmd_repl_user_12_1.msg_flood_l=(*i2).msg_flood.lines;
            c->command_data.cmd_repl_user_12_1.msg_flood_s=static_cast<my_botnet_time_t>((*i2).msg_flood.seconds);

            c->command_data.cmd_repl_user_12_1.notice_flood_l=(*i2).notice_flood.lines;
            c->command_data.cmd_repl_user_12_1.notice_flood_s=static_cast<my_botnet_time_t>((*i2).notice_flood.seconds);

            c->command_data.cmd_repl_user_12_1.repeat_flood_l=(*i2).repeat_flood.lines;
            c->command_data.cmd_repl_user_12_1.repeat_flood_s=static_cast<my_botnet_time_t>((*i2).repeat_flood.seconds);

            c->command_data.cmd_repl_user_12_1.nick_flood_l=(*i2).nick_flood.lines;
            c->command_data.cmd_repl_user_12_1.nick_flood_s=static_cast<my_botnet_time_t>((*i2).nick_flood.seconds);

            c->command_data.cmd_repl_user_12_1.join_flood_l=(*i2).join_flood.lines;
            c->command_data.cmd_repl_user_12_1.join_flood_s=static_cast<my_botnet_time_t>((*i2).join_flood.seconds);

            c->command_data.cmd_repl_user_12_1.mode_flood_l=(*i2).mode_flood.lines;
            c->command_data.cmd_repl_user_12_1.mode_flood_s=static_cast<my_botnet_time_t>((*i2).mode_flood.seconds);

            c->command_data.cmd_repl_user_12_1.ctcp_flood_l=(*i2).ctcp_flood.lines;
            c->command_data.cmd_repl_user_12_1.ctcp_flood_s=static_cast<my_botnet_time_t>((*i2).ctcp_flood.seconds);

            memset(plus,0,dpm_size);
            strncpy(plus,(*i2).dynamic_plus_modes.c_str(),dpm_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.dynamic_plus_modes,plus,sizeof(c->command_data.cmd_repl_user_12_1.dynamic_plus_modes));

            memset(minus,0,dmm_size);
            strncpy(minus,(*i2).dynamic_minus_modes.c_str(),dmm_size-1);
            memcpy(c->command_data.cmd_repl_user_12_1.dynamic_minus_modes,minus,sizeof(c->command_data.cmd_repl_user_12_1.dynamic_minus_modes));

            c->command_data.cmd_repl_user_12_1.can_send_unknown_users=(*i2).can_send_unknown_users;

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
        MY_DELETE_A(plus);
        MY_DELETE_A(minus);
    }
    {
        int g_size=sizeof(c->command_data.cmd_repl_user_13_1.group); // !!!
        char* g=MY_NEW char[g_size+1];

        int pm_size=sizeof(c->command_data.cmd_repl_user_13_1.plus_modes); // !!!
        char* pm=MY_NEW char[pm_size+1];

        int mm_size=sizeof(c->command_data.cmd_repl_user_13_1.minus_modes); // !!!
        char* mm=MY_NEW char[mm_size+1];

        int ch_size=sizeof(c->command_data.cmd_repl_user_13_1.channel); // !!!
        char* ch=MY_NEW char[ch_size+1];

        vector<c_channel> chans;
        logic_botnet_get_user_channels(u.name,chans);

        vector<c_channel>::iterator i3;
        for(i3=chans.begin(); i3!=chans.end(); ++i3) {
            vector<c_dynamic_rule>::iterator i2;
            for(i2=(*i3).allow_dynamic.begin(); i2!=(*i3).allow_dynamic.end(); ++i2) { // !!!
                c->hard_clear();
                c->packet_type=PACKET_TYPE_COMMAND;
                c->size=sizeof(c);
                c->version=1;
                c->command=CMD_REPL_USER_13_1; // !!!

                memcpy(c->command_data.cmd_repl_user_13_1.name,name,name_size); // !!!

                memset(ch,0,ch_size);
                strcpy(ch,"\"");
                strncat(ch,(*i3).channel_name.c_str(),ch_size-2);
                strcat(ch,"\"");
                memcpy(c->command_data.cmd_repl_user_13_1.channel,ch,sizeof(c->command_data.cmd_repl_user_13_1.channel));

                memset(g,0,g_size);
                strcpy(g,"\"");
                strncat(g,(*i2).group.c_str(),g_size-2);
                strcat(g,"\"");

                memset(pm,0,pm_size);
                strcpy(pm,"\"");
                strncat(pm,(*i2).plus_modes.c_str(),pm_size-2);
                strcat(pm,"\"");

                memset(mm,0,mm_size);
                strcpy(mm,"\"");
                strncat(mm,(*i2).minus_modes.c_str(),mm_size-2);
                strcat(mm,"\"");

                memcpy(c->command_data.cmd_repl_user_13_1.group,g,g_size); // !!!
                memcpy(c->command_data.cmd_repl_user_13_1.plus_modes,pm,pm_size); // !!!
                memcpy(c->command_data.cmd_repl_user_13_1.minus_modes,mm,mm_size); // !!!

                botnet_send_command(bot,c);
            }
        }
        MY_DELETE_A(g);
        MY_DELETE_A(pm);
        MY_DELETE_A(mm);
        MY_DELETE_A(ch);
    }

    {
        int meta_key_size=sizeof(c->command_data.cmd_repl_user_14_1.meta_key); // !!!
        char* k=MY_NEW char[meta_key_size+1];

        int meta_val_size=sizeof(c->command_data.cmd_repl_user_14_1.meta_val); // !!!
        char* v=MY_NEW char[meta_val_size+1];

        map<string,string>::iterator i3;
        for(i3=u.meta.begin(); i3!=u.meta.end(); ++i3) {
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_14_1; // !!!

            memcpy(c->command_data.cmd_repl_user_14_1.name,name,name_size); // !!!

            memset(k,0,meta_key_size);
            strcpy(k,"\"");
            strncat(k,(*i3).first.c_str(),meta_key_size-2);
            strcat(k,"\"");
            memcpy(c->command_data.cmd_repl_user_14_1.meta_key,k,sizeof(c->command_data.cmd_repl_user_14_1.meta_key));

            memset(v,0,meta_val_size);
            strcpy(v,"\"");
            strncat(v,(*i3).second.c_str(),meta_val_size-2);
            strcat(v,"\"");
            memcpy(c->command_data.cmd_repl_user_14_1.meta_val,v,sizeof(c->command_data.cmd_repl_user_14_1.meta_val));

            botnet_send_command(bot,c);
        }

        MY_DELETE_A(k);
        MY_DELETE_A(v);
    }

    {
        int data_size=sizeof(c->command_data.cmd_repl_user_15_1.access_usage_proc); // !!!
        char* data=MY_NEW char[data_size+1];

        vector<string>::iterator i2;
        for(i2=u.access_usage_procedure.begin(); i2!=u.access_usage_procedure.end(); ++i2) { // !!!
            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_USER_15_1; // !!!

            memcpy(c->command_data.cmd_repl_user_15_1.name,name,name_size); // !!!

            memset(data,0,data_size);
            strcpy(data,"\"");
            strncat(data,(*i2).c_str(),data_size-2);
            strcat(data,"\"");

            memcpy(c->command_data.cmd_repl_user_15_1.access_usage_proc,data,name_size); // !!!

            botnet_send_command(bot,c);
        }
        MY_DELETE_A(data);
    }
    if(bot->supported_proto_version>=5) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=5;
        c->command=CMD_REPL_USER_16_5;

        memcpy(c->command_data.cmd_repl_user_16_5.name,name,name_size);

        c->command_data.cmd_repl_user_16_5.access_to_upgrade=u.access_to_upgrade;
        c->command_data.cmd_repl_user_16_5.access_grant_upgrade=u.access_grant_upgrade;

        botnet_send_command(bot,c);
    }
    if(bot->supported_proto_version>=9) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=9;
        c->command=CMD_REPL_USER_17_9;

        memcpy(c->command_data.cmd_repl_user_17_9.name,name,name_size);

        c->command_data.cmd_repl_user_17_9.access_to_apply=u.access_to_apply;
        c->command_data.cmd_repl_user_17_9.access_grant_apply=u.access_grant_apply;

        botnet_send_command(bot,c);
    }

    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_USER_99_1; // !!!

        memcpy(c->command_data.cmd_repl_user_99_1.name,name,name_size); // !!!

        botnet_send_command(bot,c);
    }

    MY_DELETE_A(name);
    MY_DELETE(c);

    botnet_log_replication_event_push(bot,"user",u.name,obj_diff);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Pushes the procedure to remote bot
    \param bot Remote bot's data
    \param p Procedure to push
    \param obj_diff Diff in seconds of local and remote object
*/
void botnet_push_proc(c_bot* bot, c_procedure& p, const MY_LONG_LONG& obj_diff)
{
    if(!bot)
        return;
    if(!bot->socket.cmp())
        return;
    {
        size_t to_receive=0, to_send=0;
        if(!bot->ssl_connection)
            sock_cache_stats(bot->socket,to_receive,to_send);
        else if(bot->ssl)
            bot->ssl->get_cache_stats(to_receive,to_send);
        if(to_send>=BOTNET_MAXIMUM_SOCKET_CACHE) {
            string log="I have cancelled pushing of object (procedure) \"";
            log+=p.get_name();
            log+="\" to remote bot '";
            log+=bot->botname;
            log+="', because send queue exceeded 'BOTNET_MAXIMUM_SOCKET_CACHE' which is ";
            log+=tos(BOTNET_MAXIMUM_SOCKET_CACHE)+" bytes. You can adjust this limit in 'params.h' file and recompile bot.";
            log_botnet(botnet_botname,bot->botname,log);
            return;
        }
    }

    bot->last_proc_push=my_time(NULL);

    stats_botnet_proc_pushed();

    if(p.last_changed==0)
        my_time(&p.last_changed);

    list<string> commands;
    string decl;
    vector<string> groups;
    vector<c_replication> repls;
    vector<string> rproc;
    logic_list_proc(p.name,commands,decl,groups,repls,rproc);
    commands.pop_back(); // remove last line saying: '}'

    {
        vector<string>::iterator i2;
        for(i2=groups.begin(); i2!=groups.end(); ++i2) {
            string g="member_of_group \"";
            g+=*i2;
            g+="\"";
            commands.push_front(g);
        }
    }
    {
        vector<c_replication>::iterator i2;
        for(i2=repls.begin(); i2!=repls.end(); ++i2) {
            string g="replication ";
            g+=(*i2).partner;
            g+=" ";
            switch((*i2).type) {
                case REPL_PUSH:
                    g+="push";
                    commands.push_front(g);
                    break;
                case REPL_PULL:
                    g+="pull";
                    commands.push_front(g);
                    break;
                case REPL_PUSHPULL:
                    g+="pushpull";
                    commands.push_front(g);
                    break;
            }
        }
    }

    c_bot_command* c=MY_NEW c_bot_command;
    int name_size=sizeof(c->command_data.cmd_proc_1.name);
    char* name=MY_NEW char[name_size];
    memset(name,0,name_size);
    strncpy(name,p.name.c_str(),name_size-1);
    bool init=true;
    list<string>::iterator i1;
    for(i1=commands.begin(); i1!=commands.end(); ++i1) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_PROC_1;

        c->command_data.cmd_proc_1.it_is_func=false;

        c->command_data.cmd_proc_1.last_changed=static_cast<my_botnet_time_t>(p.last_changed);

        memcpy(c->command_data.cmd_proc_1.name,name,name_size);

        c->command_data.cmd_proc_1.init=init;
        init=false;

        if((*i1).length()<sizeof(c->command_data.cmd_proc_1.line))
            strcpy(c->command_data.cmd_proc_1.line,(*i1).c_str());

        botnet_send_command(bot,c);
    }

    c->hard_clear();
    c->packet_type=PACKET_TYPE_COMMAND;
    c->size=sizeof(c);
    c->version=1;
    c->command=CMD_PROC_END_1;

    memcpy(c->command_data.cmd_proc_1.name,name,name_size);

    botnet_send_command(bot,c);

    MY_DELETE(c);

    botnet_log_replication_event_push(bot,"procedure",p.name,obj_diff);

    MY_DELETE_A(name);
}

/*!
    \author VooDooMan
    \version 1
    \date 2005-11-18
    \brief Pushes the function to remote bot
    \param bot Remote bot's data
    \param p Function to push
    \param obj_diff Diff in seconds of local and remote object
*/
void botnet_push_func(c_bot* bot, c_function& p, const MY_LONG_LONG& obj_diff)
{
    if(!bot)
        return;
    if(!bot->socket.cmp())
        return;
    {
        size_t to_receive=0, to_send=0;
        if(!bot->ssl_connection)
            sock_cache_stats(bot->socket,to_receive,to_send);
        else if(bot->ssl)
            bot->ssl->get_cache_stats(to_receive,to_send);
        if(to_send>=BOTNET_MAXIMUM_SOCKET_CACHE) {
            string log="I have cancelled pushing of object (function) \"";
            log+=p.get_name();
            log+="\" to remote bot '";
            log+=bot->botname;
            log+="', because send queue exceeded 'BOTNET_MAXIMUM_SOCKET_CACHE' which is ";
            log+=tos(BOTNET_MAXIMUM_SOCKET_CACHE)+" bytes. You can adjust this limit in 'params.h' file and recompile bot.";
            log_botnet(botnet_botname,bot->botname,log);
            return;
        }
    }

    bot->last_proc_push=my_time(NULL);

    stats_botnet_proc_pushed();

    if(p.last_changed==0)
        my_time(&p.last_changed);

    list<string> commands;
    string decl;
    vector<string> groups;
    vector<c_replication> repls;
    vector<string> rproc;
    logic_list_func(p.declaration,commands,decl,groups,repls,rproc);

    c_bot_command* c=MY_NEW c_bot_command;
    int name_size=sizeof(c->command_data.cmd_proc_1.name);
    char* name=MY_NEW char[name_size];
    memset(name,0,name_size);
    strncpy(name,p.declaration.c_str(),name_size-1);
    bool init=true;
    list<string>::iterator i1;
    for(i1=commands.begin(); i1!=commands.end(); ++i1) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_PROC_1;

        c->command_data.cmd_proc_1.it_is_func=true;

        c->command_data.cmd_proc_1.last_changed=static_cast<my_botnet_time_t>(p.last_changed);

        memcpy(c->command_data.cmd_proc_1.name,name,name_size);

        c->command_data.cmd_proc_1.init=init;
        init=false;

        if((*i1).length()<sizeof(c->command_data.cmd_proc_1.line))
            strcpy(c->command_data.cmd_proc_1.line,(*i1).c_str());

        botnet_send_command(bot,c);
    }

    c->hard_clear();
    c->packet_type=PACKET_TYPE_COMMAND;
    c->size=sizeof(c);
    c->version=1;
    c->command=CMD_PROC_END_1;

    memcpy(c->command_data.cmd_proc_1.name,name,name_size);

    botnet_send_command(bot,c);

    MY_DELETE(c);

    botnet_log_replication_event_push(bot,"function",p.declaration,obj_diff);

    MY_DELETE_A(name);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Pushes channel definition to the remote bot
    \param bot Informations about remote connected bot
    \param chd Channel definition
    \param obj_diff Diff in seconds of local and remote object
*/
void botnet_push_chan(c_bot* bot, c_channel_def& chd, const MY_LONG_LONG& obj_diff)
{
    if(!bot)
        return;
    if(!bot->socket.cmp())
        return;
    {
        size_t to_receive=0, to_send=0;
        if(!bot->ssl_connection)
            sock_cache_stats(bot->socket,to_receive,to_send);
        else if(bot->ssl)
            bot->ssl->get_cache_stats(to_receive,to_send);
        if(to_send>=BOTNET_MAXIMUM_SOCKET_CACHE) {
            string log="I have cancelled pushing of object (channel) \"";
            log+=chd.channel_name;
            log+="\" to remote bot '";
            log+=bot->botname;
            log+="', because send queue exceeded 'BOTNET_MAXIMUM_SOCKET_CACHE' which is ";
            log+=tos(BOTNET_MAXIMUM_SOCKET_CACHE)+" bytes. You can adjust this limit in 'params.h' file and recompile bot.";
            log_botnet(botnet_botname,bot->botname,log);
            return;
        }
    }

    stats_botnet_chandef_pushed();

    if(chd.last_changed==0)
        my_time(&chd.last_changed);

    c_bot_command* c=MY_NEW c_bot_command;
    int name_size=sizeof(c->command_data.cmd_repl_chdef_01_1.name);
    char* name=MY_NEW char[name_size];
    memset(name,0,name_size);
    strcpy(name,"\"");
    strncat(name,chd.channel_name.c_str(),name_size-sizeof("\"\"")-1);
    strcat(name,"\"");

    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_CHDEF_01_1;

        c->command_data.cmd_repl_chdef_01_1.last_changed=static_cast<my_botnet_time_t>(chd.last_changed);

        memcpy(c->command_data.cmd_repl_chdef_01_1.name,name,name_size);

        size_t _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_mode);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_key))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_key);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_limit))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_limit);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_topic))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_topic);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_ircop))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_ircop);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_ctcp))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_ctcp);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_privmsg))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_privmsg);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_notice))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_notice);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_part))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_part);
        if(_size>sizeof(c->command_data.cmd_repl_chdef_01_1.on_dynamic_ban))
            _size=sizeof(c->command_data.cmd_repl_chdef_01_1.on_dynamic_ban);
        size_t _size2=sizeof(c->command_data.cmd_repl_chdef_01_1.dynamic_plus_modes);
        if(_size2>sizeof(c->command_data.cmd_repl_chdef_01_1.dynamic_minus_modes))
            _size2=sizeof(c->command_data.cmd_repl_chdef_01_1.dynamic_minus_modes);

        _size--;
        _size2--;

        strncpy(c->command_data.cmd_repl_chdef_01_1.on_mode,chd.on_mode.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_key,chd.on_key.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_limit,chd.on_limit.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_topic,chd.on_topic.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_ircop,chd.on_ircop.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_ctcp,chd.on_ctcp.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_privmsg,chd.on_privmsg.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_notice,chd.on_notice.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_part,chd.on_part.c_str(),_size-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.on_dynamic_ban,chd.on_dynamic_ban.c_str(),_size-1);

        strncpy(c->command_data.cmd_repl_chdef_01_1.dynamic_plus_modes,chd.dynamic_plus_modes.c_str(),_size2-1);
        strncpy(c->command_data.cmd_repl_chdef_01_1.dynamic_minus_modes,chd.dynamic_minus_modes.c_str(),_size2-1);

        botnet_send_command(bot,c);
    }
    {
        vector<string>::iterator i1;
        for(i1=chd.groups.begin(); i1!=chd.groups.end(); ++i1) {

            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_CHDEF_02_1;

            memcpy(c->command_data.cmd_repl_chdef_02_1.name,name,name_size);

            strcpy(c->command_data.cmd_repl_chdef_02_1.group,"\"");
            strncat(c->command_data.cmd_repl_chdef_02_1.group,(*i1).c_str(),sizeof(c->command_data.cmd_repl_chdef_02_1.group)-1-2);
            strcat(c->command_data.cmd_repl_chdef_02_1.group,"\"");

            botnet_send_command(bot,c);
        }
    }
    {
        vector<c_dynamic_rule>::iterator i1;
        for(i1=chd.allow_dynamic.begin(); i1!=chd.allow_dynamic.end(); ++i1) {

            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_CHDEF_03_1;

            memcpy(c->command_data.cmd_repl_chdef_03_1.name,name,name_size);

            strcpy(c->command_data.cmd_repl_chdef_03_1.group,"\"");
            strncat(c->command_data.cmd_repl_chdef_03_1.group,(*i1).group.c_str(),sizeof(c->command_data.cmd_repl_chdef_03_1.group)-1-2);
            strcat(c->command_data.cmd_repl_chdef_03_1.group,"\"");

            strcpy(c->command_data.cmd_repl_chdef_03_1.plus_modes,"\"");
            strncat(c->command_data.cmd_repl_chdef_03_1.plus_modes,(*i1).plus_modes.c_str(),sizeof(c->command_data.cmd_repl_chdef_03_1.plus_modes)-1-2);
            strcat(c->command_data.cmd_repl_chdef_03_1.plus_modes,"\"");

            strcpy(c->command_data.cmd_repl_chdef_03_1.minus_modes,"\"");
            strncat(c->command_data.cmd_repl_chdef_03_1.minus_modes,(*i1).minus_modes.c_str(),sizeof(c->command_data.cmd_repl_chdef_03_1.minus_modes)-1-2);
            strcat(c->command_data.cmd_repl_chdef_03_1.minus_modes,"\"");

            botnet_send_command(bot,c);
        }
    }
    {
        map<string,string>::iterator i1;
        for(i1=chd.dynamic_bans.begin(); i1!=chd.dynamic_bans.end(); ++i1) {

            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_CHDEF_04_1;

            memcpy(c->command_data.cmd_repl_chdef_04_1.name,name,name_size);

            strcpy(c->command_data.cmd_repl_chdef_04_1.mask,"\"");
            strncat(c->command_data.cmd_repl_chdef_04_1.mask,(*i1).first.c_str(),sizeof(c->command_data.cmd_repl_chdef_04_1.mask)-1-2);
            strcat(c->command_data.cmd_repl_chdef_04_1.mask,"\"");

            strcpy(c->command_data.cmd_repl_chdef_04_1.reason,"\"");
            strncat(c->command_data.cmd_repl_chdef_04_1.reason,(*i1).second.c_str(),sizeof(c->command_data.cmd_repl_chdef_04_1.reason)-1-2);
            strcat(c->command_data.cmd_repl_chdef_04_1.reason,"\"");

            botnet_send_command(bot,c);
        }
    }
    {
        vector<string>::iterator i1;
        for(i1=chd.dynbans_editors.begin(); i1!=chd.dynbans_editors.end(); ++i1) {

            c->hard_clear();
            c->packet_type=PACKET_TYPE_COMMAND;
            c->size=sizeof(c);
            c->version=1;
            c->command=CMD_REPL_CHDEF_05_1;

            memcpy(c->command_data.cmd_repl_chdef_05_1.name,name,name_size);

            strcpy(c->command_data.cmd_repl_chdef_05_1.group,"\"");
            strncat(c->command_data.cmd_repl_chdef_05_1.group,(*i1).c_str(),sizeof(c->command_data.cmd_repl_chdef_05_1.group)-1-2);
            strcat(c->command_data.cmd_repl_chdef_05_1.group,"\"");

            botnet_send_command(bot,c);
        }
    }
    if(bot->supported_proto_version>=8) {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=8;
        c->command=CMD_REPL_CHDEF_06_8;

        memcpy(c->command_data.cmd_repl_chdef_06_8.name,name,name_size);

        strncpy(c->command_data.cmd_repl_chdef_06_8.on_server_msg,chd.on_server_msg.c_str(),sizeof(c->command_data.cmd_repl_chdef_06_8.on_server_msg)-1);

        botnet_send_command(bot,c);
    }
    {
        c->hard_clear();
        c->packet_type=PACKET_TYPE_COMMAND;
        c->size=sizeof(c);
        c->version=1;
        c->command=CMD_REPL_CHDEF_99_1;

        memcpy(c->command_data.cmd_repl_chdef_99_1.name,name,name_size);

        botnet_send_command(bot,c);
    }

    MY_DELETE(c);
    MY_DELETE_A(name);

    botnet_log_replication_event_push(bot,"channel",chd.channel_name,obj_diff);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Generates the partyline output message
    \param origin_bot Name of bot from which is event
    \param cmd Original command from remote bot
*/
void botnet_partyline_event(const string& origin_bot, c_bot_command* cmd)
{
    string msg;

    char* ch=NULL;

    if(cmd->command==CMD_PARTYLINE_1) {
        uint32 id=cmd->command_data.cmd_partyline_1.id;

        char* u=MY_NEW char[sizeof(cmd->command_data.cmd_partyline_1.user)+1];
        strncpy(u,cmd->command_data.cmd_partyline_1.user,sizeof(cmd->command_data.cmd_partyline_1.user)-1);
        u[sizeof(cmd->command_data.cmd_partyline_1.user)-1]='\0';

        ch=MY_NEW char[sizeof(cmd->command_data.cmd_partyline_1.channel)+1];
        strncpy(ch,cmd->command_data.cmd_partyline_1.channel,sizeof(cmd->command_data.cmd_partyline_1.channel)-1);
        ch[sizeof(cmd->command_data.cmd_partyline_1.channel)-1]='\0';

        char* m=MY_NEW char[sizeof(cmd->command_data.cmd_partyline_1.message)+1];
        strncpy(m,cmd->command_data.cmd_partyline_1.message,sizeof(cmd->command_data.cmd_partyline_1.message)-1);
        m[sizeof(cmd->command_data.cmd_partyline_1.message)-1]='\0';

        if(strlen(m)>0 && m[0]==0x01) {
            if(strstr(m,"\x01" "BROADCAST_PING\x01 ")==m) {
                msg=m;

                char tmp[]="\x01" "BROADCAST_PONG\x01 ";
                strncpy(m,tmp,strlen(tmp)); // overwrite all, except the NULL terminator from that
                botnet_partyline_message(u,"",m);

                {
                    if(msg.find(" ",0)!=string::npos)
                        msg.erase(0,msg.find(" ",0)+1);
                    if(msg.find(" ",0)!=string::npos)
                        msg.erase(0,msg.find(" ",0)+1);
                    string user=msg;
                    if(user.find(" ",0)!=string::npos)
                        user.erase(user.find(" ",0),user.length()-user.find(" ",0));

                    string version="\x01" "BROADCAST_PONG\x02 VERSION ";
                    version+=user;
                    version+=" ";
                    version+="VooDoo_cIRCle"; // name
                    version+=" ";
                    version+=BOT_VERSION; // version numeric
                    version+=" ";
                    version+=BOT_VERSION_COMMENT; // version comment

                    botnet_partyline_message(u,"",version);
                }

                msg="";
            }
            if(strstr(m,"\x01" "BROADCAST_PONG\x01 ")==m) {
                msg=m;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                string time_=msg;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                if(time_.find(" ",0)!=string::npos)
                    time_.erase(time_.find(" ",0),time_.length()-time_.find(" ",0));
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(msg.find(" ",0),msg.length()-msg.find(" ",0));
                if(!botnet_query_disp_id(cmd->command_data.cmd_partyline_1.id)) {
                    dcc_user_pong(time_,msg,origin_bot);
                    c_msg_id i;
                    i.id=id;
                    i.time=static_cast<my_botnet_time_t>(my_time(NULL));
                    msg_disp_ids.push_back(i);
                }
                msg="";
            }
            if(strstr(m,"\x01" "BROADCAST_PONG\x02 VERSION ")==m) {
                msg=m;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                string user=msg;
                if(user.find(" ",0)!=string::npos)
                    user.erase(user.find(" ",0),user.length()-user.find(" ",0));
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);

                int ctx=0;
                string v1, v2, v3;
                for(unsigned i1=0; i1<msg.length(); ++i1) {
                    if(msg[i1]==0x20) {
                        ctx++;
                        continue;
                    }
                    if(ctx==0) {
                        v1+=(string)""+msg[i1];
                        continue;
                    }
                    if(ctx==1) {
                        v2+=(string)""+msg[i1];
                        continue;
                    }
                    if(ctx>=2) {
                        v3+=(string)""+msg[i1];
                        continue;
                    }
                }

                if(!botnet_query_disp_id(id)) {
                    dcc_user_pong(user,origin_bot,v1,v2,v3);
                    c_msg_id i;
                    i.id=id;
                    i.time=static_cast<my_botnet_time_t>(my_time(NULL));
                    msg_disp_ids.push_back(i);
                }
                msg="";
            }
            if(strstr(m,"\x01" "BROADCAST_ADMIN_MESSAGE\x01 ")==m) {
                msg=m;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);

                string reserved1=msg;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                if(reserved1.find(" ",0)!=string::npos)
                    reserved1.erase(reserved1.find(" ",0),reserved1.length()-reserved1.find(" ",0));

                string reserved2=msg;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                if(reserved2.find(" ",0)!=string::npos)
                    reserved2.erase(reserved2.find(" ",0),reserved2.length()-reserved2.find(" ",0));

                string dest_bot=msg;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                if(dest_bot.find(" ",0)!=string::npos)
                    dest_bot.erase(dest_bot.find(" ",0),dest_bot.length()-dest_bot.find(" ",0));

                string dest_user=msg;
                if(msg.find(" ",0)!=string::npos)
                    msg.erase(0,msg.find(" ",0)+1);
                if(dest_user.find(" ",0)!=string::npos)
                    dest_user.erase(dest_user.find(" ",0),dest_user.length()-dest_user.find(" ",0));

                if(!match(dest_bot.c_str(),botnet_botname.c_str()))
                    if(!botnet_query_disp_id(id)) {
                        dcc_broadcast(dest_user,msg,u,dest_bot);
                        c_msg_id i;
                        i.id=id;
                        i.time=static_cast<my_botnet_time_t>(my_time(NULL));
                        msg_disp_ids.push_back(i);
                    }

                msg="";
            }
        } else {
            if(cmd->command_data.cmd_partyline_1.msg) {
                msg="<";
                msg+=u;
                msg+="@";
                msg+=origin_bot;
                msg+="> ";
                msg+=m;
            }
            if(cmd->command_data.cmd_partyline_1.join) {
                msg=u;
                msg+="@";
                msg+=origin_bot;
                msg+=" has joined channel ";
                msg+=ch;
            }
            if(cmd->command_data.cmd_partyline_1.leave) {
                msg=u;
                msg+="@";
                msg+=origin_bot;
                msg+=" has left channel ";
                msg+=ch;
            }

            if(!botnet_query_disp_id(cmd->command_data.cmd_partyline_1.id)) {
                c_msg_id i;
                i.id=id;
                i.time=static_cast<my_botnet_time_t>(my_time(NULL));
                msg_disp_ids.push_back(i);
            } else {
                msg="";
            }
        }
        MY_DELETE_A(u);
        MY_DELETE_A(m);
    }
    if(cmd->command==CMD_PARTYLINE_USER_1) {
        uint32 id=cmd->command_data.cmd_partyline_user_1.id;

        char* u=MY_NEW char[sizeof(cmd->command_data.cmd_partyline_user_1.user)+1];
        strncpy(u,cmd->command_data.cmd_partyline_user_1.user,sizeof(cmd->command_data.cmd_partyline_user_1.user)-1);
        u[sizeof(cmd->command_data.cmd_partyline_user_1.user)-1]='\0';

        ch=MY_NEW char[sizeof(cmd->command_data.cmd_partyline_user_1.channel)+1];
        strncpy(ch,cmd->command_data.cmd_partyline_user_1.channel,sizeof(cmd->command_data.cmd_partyline_user_1.channel)-1);
        ch[sizeof(cmd->command_data.cmd_partyline_user_1.channel)-1]='\0';

        if(cmd->command_data.cmd_partyline_1.join) {
            msg=u;
            msg+="@";
            msg+=origin_bot;
            msg+=" has joined channel ";
            msg+=ch;
            msg+=" (after botnet-split)";
        }

        if(!botnet_query_disp_id(cmd->command_data.cmd_partyline_1.id)) {
            c_msg_id i;
            i.id=id;
            i.time=static_cast<my_botnet_time_t>(my_time(NULL));
            msg_disp_ids.push_back(i);
        } else {
            msg="";
        }

        MY_DELETE_A(u);
    }
    if(msg.compare("") && ch!=NULL)
        dcc_partyline_message(ch,msg);

    MY_DELETE_A(ch);
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Called on unlink of bot
    \param botname My name
    \param from_bot Name of remote bot
    \param id ID of message
*/
void botnet_on_unlink(string botname, string UNUSEDARG(from_bot), int UNUSEDARG(id))
{
    vector<c_botnet_channel>::iterator i1;
again2:
    for(i1=botnet_channels.begin(); i1!=botnet_channels.end(); ++i1) {
        vector<c_partyline_member>::iterator i2;
    again:
        for(i2=(*i1).members.begin(); i2!=(*i1).members.end(); ++i2) {
            if(!(*i2).botname.compare(botname)) {
                string msg=(*i2).user;
                msg+="@";
                msg+=botname;
                msg+=" has left channel ";
                msg+=(*i1).channel_name;
                msg+=" (botnet-split: ";
                msg+=botname;
                msg+=")";
                dcc_partyline_message((*i1).channel_name,msg);
                (*i1).members.erase(i2);
                goto again;
            }
        }
        if((*i1).members.empty()) {
            botnet_channels.erase(i1);
            goto again2;
        }
    }
}

/*!
    \brief Check wheter user (bot) can un/assign procedure for event (has access_usage_procedure right)
    \author VooDooMan
    \version 2
    \date 2005
    \param bot Bot rights
    \param proc_name Name of procedure
    \returns Returns true if can unassign
*/
MY_STATIC bool botnet_has_grant(c_user& bot, string proc_name)
{
    if(proc_name.empty())
        return true;

    if(proc_name.find("(",0)!=string::npos)
        proc_name.erase(proc_name.find("(",0),proc_name.length()-proc_name.find("(",0));

    vector<string>::iterator i1;
    for(i1=bot.access_usage_procedure.begin(); i1!=bot.access_usage_procedure.end(); ++i1) {
        if(!(*i1).compare("*"))
            return true;

        string name_only=*i1;
        if(name_only.find("(",0)!=string::npos)
            name_only.erase(name_only.find("(",0),name_only.length()-name_only.find("(",0));

        if(!name_only.compare(proc_name))
            return true;
    }

    return false;
}

#if defined(_MSC_VER)
#   pragma warning(push)
#   pragma warning(disable:4702)    // warning C4702: unreachable code
#endif

MY_STATIC bool botnet_cmd_switch_1(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd, int& result);
MY_STATIC bool botnet_cmd_switch_2(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);
MY_STATIC bool botnet_cmd_switch_3(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);
MY_STATIC bool botnet_cmd_switch_4(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);
MY_STATIC bool botnet_cmd_switch_5(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);
MY_STATIC bool botnet_cmd_switch_6(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);
MY_STATIC bool botnet_cmd_switch_7(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);
MY_STATIC bool botnet_cmd_switch_8(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd);

MY_STATIC bool botnet_has_access_usage_group(const string& group, const c_user& bot, const string& debug);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_to_group(c_user& user, const c_user& bot);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_group(c_user& user, const c_user& bot);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_usage_procedure(c_user& user, const c_user& bot);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_usage_procedure2(c_user& user, const c_user& bot);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_channel(c_user& user, const c_user& bot, const string& debug);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_channel2(c_user& user, const c_user& bot);
MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_procedure(c_user& user, const c_user& bot);
MY_STATIC void botnet_remove_groups_remote_bot_dont_have_access_to(vector<string>& quoted_new_groups, vector<string>& new_groups, const c_user& bot, const string& debug);
MY_STATIC void botnet_func_proc_remove_groups_remote_bot_dont_have_access_to(bool its_function, const string& name, list<string>& lines, vector<string>& new_groups, const c_user& bot, const string& debug);

/*!
    \author VooDooMan
    \version 4
    \date 2005, 2005-10-26, 2008-03-02
    \brief Process the communication with other bots, this should be called in loop
    \param shutdown Set to true to free memory before shutdown
*/
void botnet_loop(bool shutdown)
{
    static bool was_shutdown=false;
    if(was_shutdown) {
        return;
    }

    if(NULL==bots && !shutdown) {
        bots=MY_NEW vector<c_bot*>;
        return;
    }

    if(NULL==bots && shutdown)
        return;

    if(botnet_last_rehash_request && botnet_last_rehash_request+120<my_time(NULL)) {
        string log="Rehash by ";
        if(!botnet_last_rehash_by.compare(botnet_last_backup_by)) {
            log+=botnet_last_rehash_by;
            log+=" (BOTNET)";
        } else
            log+="(BOTNET, multiple bots)";
        log_botnet(botnet_botname,"",log);
        log_botnet_debug(botnet_botname,"",-1,-1,log);

        botnet_last_rehash_request=0;
        logic_botnet_backup(botnet_last_rehash_by);
        if(!botnet_last_rehash_by.compare(botnet_last_backup_by))
            logic_botnet_rehash(botnet_last_rehash_by);
        else
            logic_botnet_rehash("BOTNET");
        botnet_last_rehash_by="";

        botnet_last_backup_request=0;
        botnet_last_backup_by="";
    }

    if(botnet_last_backup_request && botnet_last_backup_request+120<my_time(NULL)) {
        string log="Backup by ";
        log+=botnet_last_backup_by;
        log+=" (BOTNET)";
        log_botnet(botnet_botname,"",log);
        log_botnet_debug(botnet_botname,"",-1,-1,log);

        botnet_last_backup_request=0;
        logic_botnet_backup(botnet_last_backup_by);
        botnet_last_backup_by="";
    }

    if(botnet_last_apply_request && botnet_last_apply_request+60<my_time(NULL)) {
        botnet_last_apply_request=0;

        string log="Apply by ";
        log+=botnet_last_apply_by;
        log+=" (BOTNET)";
        log_bot(log);
        log_botnet(botnet_botname,"",log);
        log_botnet_debug(botnet_botname,"",-1,-1,log);

        irc_rehashed();
        dcc_apply(botnet_last_apply_by);
        botnet_logic_rehashed();

        botnet_last_apply_by="";
    }

    {
        vector<c_bot*>::iterator i1;
        for(i1=bots->begin(); i1!=bots->end(); ++i1) {
            if((*i1)->dirty || ((*i1)->ssl_connection && !(*i1)->ssl) || (!(*i1)->ssl_connection && !(*i1)->socket.cmp()))
                continue;

            bool queue_empty=true;
            {
                size_t to_receive=0, to_send=0;
                sock_cache_stats((*i1)->socket,to_receive,to_send);
                if(to_send)
                    queue_empty=false;
                else {
                    to_receive=0;
                    to_send=0;
                    if((*i1)->ssl)
                        (*i1)->ssl->get_cache_stats(to_receive,to_send);
                    if(to_send)
                        queue_empty=false;
                }
            }

            void* data=NULL;
            size_t len=0;

        next_command:

            unsigned long long id=0;

            if((*i1)->command_queue.get_next_packet(queue_empty,data,len,id)) {
                (*i1)->garbage_socket();

                string log=(*i1)->command_queue.get_error();

                log_debug(log);
                log_botnet(botnet_botname,(*i1)->botname,log);
                continue;
            }

            if(data) {
                size_t sent=0;
                int ec=0;

                if(!(*i1)->ssl_connection) {
                    sent=sock_send((*i1)->socket,(const char*)data,len,ec);
                    stats_botnet_bytes_sent(sent);
                } else if((*i1)->ssl) {
                    string err_str;
                    if((*i1)->ssl->get_error(err_str)) {
                        (*i1)->garbage_socket();
                        ec=-1;
                        continue;
                    } else {
                        (*i1)->ssl->write(data,len);
                        stats_botnet_bytes_sent(len);
                        sent=len;
                    }
                }
                my_free(data);
                data=NULL;

                if(sent!=len || ec!=0) {
                    string log=GET_STR_DEBUG_INFO_EX("Not all data had been sent");
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&(*i1)->socket);
                    MY_DELETE_A(errstr);

                    (*i1)->garbage_socket();

                    continue;
                }
                string log=GET_STR_DEBUG_INFO_EX("Sent to remote bot ");
                log_botnet_debug(botnet_botname,(*i1)->botname,PACKET_TYPE_COMMAND,static_cast<uint32>(id),log);

                goto next_command;
            }
        }
    }

    {
        vector<c_delay_link>::iterator i1;
    again_link:
        for(i1=botnet_delay_link.begin(); i1!=botnet_delay_link.end(); ++i1) {
            in_addr ip;
            e_resolv_result res=threads_resolve4((*i1).bot_host.c_str(),ip,RT_RESOLVE_SCHEDULE);
            if(RR_SCHEDULED==res)
                continue;
            if(RR_FAILURE==res) {
                var_keeper->free_global((*i1).vars,true);
                (*i1).vars=NULL;
                botnet_delay_link.erase(i1);
                goto again_link;
            }
            if(RR_OK==res) {
                char tmp[128+1];
                tmp[0]=0;
                my_inet_ntop(AF_INET,&ip,tmp,128);
                botnet_link((*i1).botname,(*i1).localip,tmp,(*i1).botport,(*i1).remote_MD5_password,(*i1).bot_link_type,(*i1).unlink_proc,(*i1).vars,(*i1).this_module);
                var_keeper->free_global((*i1).vars,true);
                (*i1).vars=NULL;
                botnet_delay_link.erase(i1);
                goto again_link;
            }
        }
    }

    if(botnet_penalty==-1)
        botnet_penalty=stoi(core_conf_getvar("botnet_penalty"));

all_again:

    vector<c_bot*>::iterator i1;

    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        (*i1)->rejected_objects.clear();
    }

    static c_bot_command* s_cmd=MY_NEW c_bot_command;
    static c_bot_control* s_ctrl=MY_NEW c_bot_control;

    if(!s_cmd || !s_ctrl)
        return;
    if(shutdown) {
        MY_DELETE(s_cmd);
        s_cmd=NULL;
        MY_DELETE(s_ctrl);
        s_ctrl=NULL;

        vector<c_bot*>::iterator i1;
erase_again_2:
        for(i1=bots->begin(); i1!=bots->end(); ++i1) {
            (*i1)->garbage_socket();

            (*i1)->before_delete();
            MY_DELETE(*i1);
            bots->erase(i1);
            goto erase_again_2;
        }

        MY_DELETE(bots);
        bots=NULL;

        was_shutdown=true;

        return;
    }

erase_again_clean:

    // receive
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if((*i1)->dirty) {
            botnet_bot_unlinked(*i1);
            // do not autolink anymore
            (*i1)->garbage_socket();
            (*i1)->before_delete();
            MY_DELETE(*i1);
            bots->erase(i1);
            goto erase_again_clean;
        }
        if((*i1)->ssl) {
            (*i1)->ssl->process();

            string err_str;
            if(!(*i1)->dirty && (*i1)->ssl->get_error(err_str)) {
                log_ssl(err_str);
                log_botnet(botnet_botname,(*i1)->botname,err_str);
                string log=GET_STR_DEBUG_INFO_EX("SSL error");
                char* errstr=NULL;
                log_socket(0,errstr=sock_error(MY_SSL_ERROR),log,&((*i1)->socket));
                MY_DELETE_A(errstr);

                (*i1)->dirty=true;
                continue;
            }
        }
        if((*i1)->socket.cmp()==false)
            continue;
        if((*i1)->awaiting_ready || (*i1)->connect_start)
            continue;

        {
            size_t to_receive=0, to_send=0;
            if(!(*i1)->ssl_connection)
                sock_cache_stats((*i1)->socket,to_receive,to_send);
            else if((*i1)->ssl)
                (*i1)->ssl->get_cache_stats(to_receive,to_send);
            if(to_send>=BOTNET_KILL_CONNECTION_SOCKET_CACHE) {
                string log="I have killed connection to remote bot '";
                log+=(*i1)->botname;
                log+="', because send queue exceeded 'BOTNET_KILL_CONNECTION_SOCKET_CACHE' which is ";
                log+=tos(BOTNET_KILL_CONNECTION_SOCKET_CACHE)+" bytes. You can adjust this limit in 'params.h' file and recompile bot.";
                log_botnet(botnet_botname,(*i1)->botname,log);

                (*i1)->garbage_socket();

                goto erase_again_clean;
            }
        }

        if((*i1)->prelink_ok && (*i1)->remote_pswd_ok && (*i1)->prelinking_wait_start+BOTNET_PRELINK_WAIT<my_time(NULL)) {
            (*i1)->prelink_ok=false;
            (*i1)->auth_ok=true;

            c_bot_control* c=MY_NEW c_bot_control;
            c->hard_clear();
            c->packet_type=PACKET_TYPE_CONTROL;
            c->supported_proto_version=SUPPORTED_PROTO_VERSION;
            c->control=CTRL_LINKED;
            botnet_send_control(*i1,c);

            (*i1)->was_linked=true;

            string log1="LINKED";
            string log2="LINK connection established";

            log_botnet_debug(botnet_botname,(*i1)->botname,-1,-1,log1);
            log_botnet(botnet_botname,(*i1)->botname,log2);

            logic_on_internal_event("@botnet_link@",(*i1)->botname,"LINKED","","",PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,log2+(string)"; "+log1,"");
            MY_DELETE(c);

            // kill others
            {
                vector<c_bot*>::iterator i2;
            label:
                for(i2=bots->begin(); i2!=bots->end(); ++i2) {
                    if(i1==i2)
                        continue;
                    if(!(*i2)->botname.compare((*i1)->botname)) {
                        (*i2)->garbage_socket();
                        (*i2)->before_delete();
                        MY_DELETE(*i2);
                        bots->erase(i2);
                        goto label;
                    }
                }
                goto all_again;
            }
        }

        s_cmd->hard_clear();
        s_ctrl->hard_clear();

// returns 0 for empty buffer
// returns 1 for got data
// returns 3 for got data, but connection closed
// returns 4 for don't have data, and connection closed
// returns 5 connection should be closed for error
//int botnet_receive(c_bot& bot, int& packet_type, c_bot_command& cmd, c_bot_control& control)

        int packet_type;
        int result=botnet_receive(*i1,packet_type,s_cmd,s_ctrl);
        if(result==0)
            continue;
        if(result==5) {
            (*i1)->receive_buffer_pos=0;
            if((*i1)->rle_buffer) {
                my_free((*i1)->rle_buffer);
                (*i1)->rle_buffer=NULL;
                (*i1)->rle_buffer_len=0;
            }
            string log1=GET_STR_DEBUG_INFO_EX("Connection forced to close because of serious errors");
            string log2="closing LINK connection (error)";

            log_botnet_debug(botnet_botname,(*i1)->botname,-1,-1,log1);
            log_botnet(botnet_botname,(*i1)->botname,log2);

            logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

            int ec=0;
            string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
            char* errstr=NULL;
            log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
            MY_DELETE_A(errstr);

            (*i1)->garbage_socket();
            continue;
        }
        if(result==4) {
            (*i1)->receive_buffer_pos=0;
            if((*i1)->rle_buffer) {
                my_free((*i1)->rle_buffer);
                (*i1)->rle_buffer=NULL;
                (*i1)->rle_buffer_len=0;
            }
            string log1=GET_STR_DEBUG_INFO_EX("Connection closed before all data had been received");
            string log2="closing LINK connection (error)";

            log_botnet_debug(botnet_botname,(*i1)->botname,-1,-1,log1);
            log_botnet(botnet_botname,(*i1)->botname,log2);

            logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

            int ec=0;
            string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
            char* errstr=NULL;
            log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
            MY_DELETE_A(errstr);

            (*i1)->garbage_socket();
            continue;
        }
        if(result==3) {
            int ec=0;
            string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
            char* errstr=NULL;
            log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
            MY_DELETE_A(errstr);

            (*i1)->garbage_socket();
        }
        if(result==1 || result==3) {
            // if we got at least one PONG already, we have received packet, so waiting for PONG is not required (coz we got packet! thus we know that connection is alive!)
            if((*i1)->got_at_least_one_pong)
                (*i1)->start_awaiting_pong=0;

            (*i1)->receive_buffer_pos=0;
            if((*i1)->rle_buffer) {
                my_free((*i1)->rle_buffer);
                (*i1)->rle_buffer=NULL;
                (*i1)->rle_buffer_len=0;
            }

            if(packet_type==PACKET_TYPE_CONTROL) {
                log_botnet_debug(botnet_botname,(*i1)->botname,s_ctrl->packet_type,s_ctrl->control,"CONTROL from remote bot");
                (*i1)->supported_proto_version=s_ctrl->supported_proto_version;
                switch(s_ctrl->control) {
                    case CTRL_ERROR_001:        // remote is using greater protocol version than me!
                        {
                            stats_botnet_auth_proto_error();
                            int ec=0;
                            string log=GET_STR_DEBUG_INFO_EX("Remote side reports error");
                            char* errstr=NULL;
                            log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                            MY_DELETE_A(errstr);

                            (*i1)->garbage_socket();

                            string log1=GET_STR_DEBUG_INFO_EX("Connection closed: remote bot is using newer unsupported protocol");
                            string log2="closing LINK connection (unsupported protocol)";
                            log_botnet_debug(botnet_botname,(*i1)->botname,packet_type,s_ctrl->control,log1);
                            log_botnet(botnet_botname,(*i1)->botname,log2);

                            logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");
                        }

                        break;
                    case CTRL_ERROR_002:
                        {
                            botnet_lockout((*i1)->botip);

                            stats_botnet_auth_error();

                            int ec=0;
                            string log=GET_STR_DEBUG_INFO_EX("Remote side reports auth error");
                            char* errstr=NULL;
                            log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                            MY_DELETE_A(errstr);

                            (*i1)->garbage_socket();

                            string log1=GET_STR_DEBUG_INFO_EX("Connection closed: bad password");
                            string log2="BAD PASSWORD on my side (e.g. local_password)";

                            log_botnet_debug(botnet_botname,(*i1)->botname,packet_type,s_ctrl->control,log1);
                            log_botnet(botnet_botname,(*i1)->botname,log2);

                            logic_on_internal_event("@botnet_link@",(*i1)->botname,"BAD_PASSWORD_HERE","","",PRIVATE_EVENT_SEVERITY_CODE_CRITICAL_ERROR,log2+(string)"; "+log1,"");
                        }
                        break;
                    case CTRL_LINKED:
                        {
                            bool bad=false;
                            if(!(*i1)->botnet12_compatibility && (!(*i1)->got_challenge || !(*i1)->challenge_sent))
                                bad=true;
                            if((*i1)->botnet12_compatibility && !(*i1)->auth_ok)
                                bad=true;

                            if(bad) {
                                botnet_lockout((*i1)->botip);

                                c_bot_control* c=MY_NEW c_bot_control;
                                c->hard_clear();

                                c->packet_type=PACKET_TYPE_CONTROL;
                                c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                                c->control=CTRL_ERROR_002;

                                if(botnet_send_control(*i1,c)) {
                                    string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                                    string log2="closing LINK connection (error)";

                                    log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                                    log_botnet(botnet_botname,(*i1)->botname,log2);

                                    logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                                    int ec=0;
                                    string log=GET_STR_DEBUG_INFO_EX("Unable to send packet");
                                    char* errstr=NULL;
                                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                                    MY_DELETE_A(errstr);

                                    (*i1)->garbage_socket();
                                }

                                int ec=0;
                                string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
                                char* errstr=NULL;
                                log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                                MY_DELETE_A(errstr);

                                (*i1)->garbage_socket();

                                MY_DELETE(c);
                                continue;
                            } else {
                                dcc_set_bot_logged_in(&((*i1)->socket));
                            }
                        }

                        (*i1)->remote_pswd_ok=true;
                        if((*i1)->auth_ok && (*i1)->remote_pswd_ok) {
                            vector<c_bot*>::iterator i2;
                        label_2:
                            for(i2=bots->begin(); i2!=bots->end(); ++i2)
                                if(!(*i2)->botname.compare((*i1)->botname) && (*i2)->socket.hndl!=(*i1)->socket.hndl) {
                                    (*i2)->before_delete();
                                    MY_DELETE(*i2);
                                    bots->erase(i2);
                                    goto label_2;
                                }

                            stats_botnet_auth_ok();
                            (*i1)->was_linked=true;
                        }
                        break;
                    case CTRL_PING:
                        {
                            c_bot_control* c=MY_NEW c_bot_control;
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_CONTROL;
                            c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                            c->control=CTRL_PONG;
                            if(s_ctrl->control_data.timestamp_ping_1.valid)
                                c->control_data.timestamp_pong_1.pong_to=s_ctrl->control_data.timestamp_ping_1.now;
                            botnet_send_control(*i1,c);
                            MY_DELETE(c);

                            if(!(*i1)->botnet12_compatibility && !(*i1)->challenge_sent) {
                                unsigned size=1024-(rand()%(512-64));
                                string challenge;
                                unsigned i2;
                                for(i2=0; i2<size; ++i2) {
                                    char ch=(char)rand();
                                    if(ch==0)
                                        ch++;
                                    challenge+=ch;
                                }

                                c_bot_command* c=MY_NEW c_bot_command;
                                c->hard_clear();

                                c->packet_type=PACKET_TYPE_COMMAND;
                                c->size=sizeof(c);
                                c->version=13;
                                c->command=CMD_CHALLENGE_13;

                                memset(c->command_data.bot_challenge_13.magic,0,sizeof(c->command_data.bot_challenge_13.magic));
                                memcpy(c->command_data.bot_challenge_13.magic,challenge.c_str(),challenge.length());

                                if(botnet_send_command(*i1,c)) {
                                    // there could be also bot on the other side which is reconnceting after each challenge
                                    botnet_lockout((*i1)->botip);

                                    string log=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_COMMAND to remote bot");
                                    log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->command,log);
                                    log_botnet(botnet_botname,(*i1)->botname,"closing LINK connection (error)");

                                    int ec=0;
                                    log=GET_STR_DEBUG_INFO_EX("Unable to send packet error");
                                    char* errstr=NULL;
                                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                                    MY_DELETE_A(errstr);

                                    (*i1)->garbage_socket();
                                    continue;
                                }

                                (*i1)->challenge_sent=true;
                                (*i1)->sent_challenge=challenge;

                                MY_DELETE(c);
                            }
                        }
                        break;
                    case CTRL_PONG:
                        (*i1)->start_awaiting_pong=0;
                        (*i1)->got_at_least_one_pong=true;
                        break;
                    default:
                        {
                            string log=GET_STR_DEBUG_INFO_EX("Unknown PACKET_TYPE_CONTROL from remote bot");
                            log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_ctrl->control,log);
                        }
                        break;
                }
                /*MY_DELETE(s_cmd);
                MY_DELETE(s_ctrl);*/
                return;
            }
            if(packet_type==PACKET_TYPE_COMMAND) {
                if(s_cmd->version>SUPPORTED_PROTO_VERSION) {
                    c_bot_control* c=MY_NEW c_bot_control;
                    c->hard_clear();

                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_ERROR_001;

                    if(botnet_send_control(*i1,c)) {
                        string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                        string log2="closing LINK connection (error)";

                        log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                        log_botnet(botnet_botname,(*i1)->botname,log2);

                        logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                        int ec=0;
                        string log=GET_STR_DEBUG_INFO_EX("Unable to send packet error");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                        MY_DELETE_A(errstr);

                        (*i1)->garbage_socket();

                        MY_DELETE(c);

                        continue;
                    }
                    MY_DELETE(c);
                }
                //if(s_cmd->version==1 || 1) { // always true
                {
                    if((!(*i1)->auth_ok || !(*i1)->remote_pswd_ok) && s_cmd->command!=CMD_AUTH_1) {
                        if((*i1)->botnet12_compatibility) {
                            botnet_lockout((*i1)->botip);

                            c_bot_control* c=MY_NEW c_bot_control;
                            c->hard_clear();

                            c->packet_type=PACKET_TYPE_CONTROL;
                            c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                            c->control=CTRL_ERROR_002;

                            if(botnet_send_control(*i1,c)) {
                                string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                                string log2="closing LINK connection (error)";

                                log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                                log_botnet(botnet_botname,(*i1)->botname,log2);

                                logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                                int ec=0;
                                string log=GET_STR_DEBUG_INFO_EX("Unable to send packet error");
                                char* errstr=NULL;
                                log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                                MY_DELETE_A(errstr);

                                (*i1)->garbage_socket();
                            }

                            int ec=0;
                            string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
                            char* errstr=NULL;
                            log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                            MY_DELETE_A(errstr);

                            (*i1)->garbage_socket();

                            MY_DELETE(c);
                            continue;
                        }
                    }

                    bool processed=false;
                    processed=botnet_cmd_switch_1(i1,s_cmd,result);
                    if(!processed)
                        processed=botnet_cmd_switch_2(i1,s_cmd);
                    if(!processed)
                        processed=botnet_cmd_switch_3(i1,s_cmd);
                    if(!processed)
                        processed=botnet_cmd_switch_4(i1,s_cmd);
                    if(!processed)
                        processed=botnet_cmd_switch_5(i1,s_cmd);
                    if(!processed)
                        processed=botnet_cmd_switch_6(i1,s_cmd);
                    if(!processed)
                        processed=botnet_cmd_switch_7(i1,s_cmd);
                    if(!processed)
                        processed=botnet_cmd_switch_8(i1,s_cmd);

                    if(!processed) {
                        string log=GET_STR_DEBUG_INFO_EX("Unknown PACKET_TYPE_COMMAND from remote bot");
                        log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,log);
                    }

                    if(processed)
                        continue;
                }
            }
            if(packet_type!=PACKET_TYPE_COMMAND && packet_type!=PACKET_TYPE_CONTROL)
                log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,"invalid PACKET_TYPE from remote bot");
            else {
                if(packet_type==PACKET_TYPE_COMMAND)
                    log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,"COMMAND from remote bot");
                if(packet_type==PACKET_TYPE_CONTROL)
                    log_botnet_debug(botnet_botname,(*i1)->botname,s_ctrl->packet_type,s_ctrl->control,"CONTROL from remote bot");
            }
        }
    }
    /*MY_DELETE(s_cmd);
    MY_DELETE(s_ctrl);*/

l:
    // send
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if((*i1)->ssl) {
            (*i1)->ssl->process();

            string err_str;
            if(!(*i1)->dirty && (*i1)->ssl->get_error(err_str)) {
                log_ssl(err_str);
                log_botnet(botnet_botname,(*i1)->botname,err_str);
                string log=GET_STR_DEBUG_INFO_EX("SSL error");
                char* errstr=NULL;
                log_socket(0,errstr=sock_error(MY_SSL_ERROR),log,&((*i1)->socket));
                MY_DELETE_A(errstr);

                (*i1)->dirty=true;
                continue;
            }
        }
        if((*i1)->socket.cmp()==true && (*i1)->ssl_connection && (*i1)->awaiting_ready!=0 && !(*i1)->connect_start && !(*i1)->pure_ssl) {
            my_time_t now=my_time(NULL);
            //my_time_t x=(*i1)->awaiting_ready+10-now;
            if((*i1)->awaiting_ready+BOTNET_PING_TIMEOUT<now) {
                (*i1)->awaiting_ready=0;

                int ec=0;
                string log=GET_STR_DEBUG_INFO_EX("SSL error");
                char* errstr=NULL;
                log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                MY_DELETE_A(errstr);

                (*i1)->garbage_socket();
                continue;
            }

            my_sleep(1);

            char buff;
            sock_set_nonblocking((*i1)->socket,true);
            int ec=0;
            bool closed=false;
            size_t len=sock_read((*i1)->socket,&buff,1,ec,closed);
            if(ec || closed)
                len=0;
            if(((signed)len)<=0)
                continue;

            if(len==1 && buff==0x01) {
                (*i1)->awaiting_ready=0;
                if((*i1)->ssl)
                    ssl_put_to_garbage((*i1)->ssl);
                (*i1)->ssl=MY_NEW c_ssl((*i1)->socket,NULL,ssl_conf.get_client_cert(),ssl_conf.get_client_key());
            }
            continue;
        }
        if((*i1)->socket.cmp()==true && (*i1)->ssl_connection && (*i1)->awaiting_ready!=0 && !(*i1)->connect_start && (*i1)->pure_ssl) {
            my_time_t now=my_time(NULL);
            //my_time_t x=(*i1)->awaiting_ready+10-now;
            if((*i1)->awaiting_ready+BOTNET_PING_TIMEOUT<now) {
                (*i1)->awaiting_ready=0;

                int ec=0;
                string log=GET_STR_DEBUG_INFO_EX("SSL error");
                char* errstr=NULL;
                log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                MY_DELETE_A(errstr);

                (*i1)->garbage_socket();
                continue;
            }

            my_sleep(1);

            char buff;
            size_t len=(*i1)->ssl->read(&buff,1);
            if(((signed)len)<=0)
                continue;

            if(len==1 && buff==0x01) {
                (*i1)->awaiting_ready=0;
            }
            continue;
        }
        if((*i1)->socket.cmp()==false && TCID_INVALID==(*i1)->connect_id) {
            if((*i1)->was_linked) {
                log_botnet_debug(botnet_botname,(*i1)->botname,-1,-1,"LINK connection broken");
                log_botnet(botnet_botname,(*i1)->botname,"LINK connection broken");
                botnet_bot_unlinked(*i1);
                (*i1)->was_linked=false;
            }

            if((*i1)->invoked_from_telnet) {
                (*i1)->garbage_socket();
                (*i1)->before_delete();
                MY_DELETE(*i1);
                bots->erase(i1);
                goto l;
            }
            // init again
            if(!(*i1)->clean) {
                (*i1)->clean=true;
                (*i1)->got_challenge=(*i1)->response_okay=(*i1)->challenge_sent=false;
                (*i1)->sent_challenge="";
                (*i1)->prelink_ok=false;
                (*i1)->prelinking_wait_start=0;

                (*i1)->botnet12_compatibility=false; //conf_pass.get_botnet12_compatibility((*i1)->botname);
                (*i1)->local_MD5_password=conf_pass.get_local_password_md5((*i1)->botname);
                (*i1)->remote_MD5_password=conf_pass.get_remote_password_md5((*i1)->botname);

                (*i1)->sent_bot_auth_1=false;
                (*i1)->received_bot_auth_1=false;
                (*i1)->receive_buffer_pos=0;
                if((*i1)->rle_buffer) {
                    my_free((*i1)->rle_buffer);
                    (*i1)->rle_buffer=NULL;
                    (*i1)->rle_buffer_len=0;
                }
                (*i1)->buff_size_from_dcc=0;
                (*i1)->buff_pos_from_dcc=0;
                (*i1)->got_bytes=0;
                (*i1)->auth_ok=false;
                (*i1)->remote_pswd_ok=false;
                (*i1)->was_linked=false;
                my_time(&(*i1)->next_ping);
                (*i1)->next_ping+=BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                (*i1)->start_awaiting_pong=0;
                (*i1)->users_to_pull_last_update=0;
                (*i1)->pulling_users.clear();
                (*i1)->users_to_push_last_update=0;
                (*i1)->pushing_users.clear();
                (*i1)->procs_to_pull_last_update=0;
                (*i1)->pulling_procs.clear();
                (*i1)->procs_to_push_last_update=0;
                (*i1)->pushing_procs.clear();

                (*i1)->chans_to_pull_last_update=0;
                (*i1)->pulling_chans.clear();

                (*i1)->chans_to_push_last_update;
                (*i1)->pushing_chans.clear();

                (*i1)->rejected_objects.clear();

                (*i1)->prv_to_push_last_update=0;
                (*i1)->prv_to_push.clear();
                (*i1)->prv_to_pull.clear();
                (*i1)->prv_pulling=false;

                (*i1)->last_proc_push=0;

                (*i1)->sent_partyline_users=false;

                // bug fix
                (*i1)->sent_at_least_one_ping=false;

                bool save=(*i1)->dirty;
                (*i1)->garbage_socket();
                (*i1)->dirty=save;

                (*i1)->chans_groups.clear();
            }

            my_time_t now;
            my_time(&now);
            if((*i1)->last_try+botnet_penalty>now) {
                (*i1)->waiting=true;
                continue;
            }
            my_time(&(*i1)->last_try);

            {
                MY_LONG_LONG secs=stoll(core_conf_getvar("lockout_duration"));
                vector<c_user_to_lock_out>::iterator i2;
            lock_a:
                for(i2=dcc_users_to_lock_out.begin(); i2!=dcc_users_to_lock_out.end(); ++i2)
                    if((*i2).timestamp+secs<my_time(NULL)) {
                        dcc_users_to_lock_out.erase(i2);
                        goto lock_a;
                    }
                MY_LONG_LONG num=0;
                for(i2=dcc_users_to_lock_out.begin(); i2!=dcc_users_to_lock_out.end(); ++i2)
                    if(!(*i2).remote.compare((*i1)->botip))
                        num++;
                MY_LONG_LONG max=stoll(core_conf_getvar("lockout_count"));
                if(max!=0 && num>=max) {
                    logic_on_internal_event("@connection_login@",(*i1)->botname,(*i1)->botip,(*i1)->localip,tos((*i1)->botport).c_str(),PRIVATE_EVENT_SEVERITY_CODE_WARNING,"IP is locked out due to number of bad logins. I will not link with this bot..","");

                    string log="IP is locked out due to number of bad logins. I will not link with this bot. User name \"";
                    log+=(*i1)->botname;
                    log+="\" connecting to ";
                    log+=(*i1)->botip;
                    log+=":";
                    log+=tos((*i1)->botport);
                    log+=" from local ";
                    log+=(*i1)->localip;
                    log_bot(log);
                    log_botnet(botnet_botname,(*i1)->botname,log);

                    continue;
                }
            }
        } else {
            if(TCID_INVALID!=(*i1)->connect_id) {
                int ec=0;
                bool got=threads_get_connect((*i1)->connect_id,ec,(*i1)->socket);
                if(!got)
                    continue;
                (*i1)->connect_id=TCID_INVALID;
                if((*i1)->socket.cmp()==false) {
                    string slog=GET_STR_DEBUG_INFO_EX("Error while calling threads_get_connect()");
                    c_socket nul;
                    nul.comment=(string)"BOTNET connection to remote bot '"+(*i1)->botname+"'";
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),slog,&nul);
                    MY_DELETE_A(errstr);
                    errstr=NULL;
                    string blog=(string)"Error connecting to bot '"+(*i1)->botname+"'; socket error code: "+tos(ec)+", "+(errstr=sock_error(ec));
                    MY_DELETE_A(errstr);
                    log_botnet(botnet_botname,(*i1)->botname,blog,false);

                    botnet_bot_unlinked(*i1);
                    // do not autolink anymore
                    (*i1)->garbage_socket();
                    (*i1)->before_delete();
                    MY_DELETE(*i1);
                    bots->erase(i1);
                    goto erase_again_clean;
                }
                (*i1)->clean=false;
                if((*i1)->ssl_connection) {
                    sock_set_nonblocking((*i1)->socket,true);
                    if((*i1)->pure_ssl) {
                        sock_async((*i1)->socket);

                        (*i1)->ssl=MY_NEW c_ssl((*i1)->socket,NULL,ssl_conf.get_client_cert(),ssl_conf.get_client_key());
                    }
                }

                stats_botnet_new_connection();

                (*i1)->connect_start=my_time(NULL);
                continue;
            }
            if(0!=(*i1)->connect_start && !(*i1)->pure_ssl) {
                bool got_eol=false;
                sock_send_cache();
                size_t len=0;
                do {
                    char buff[1024];
                    int ec=0;
                    bool closed;
                    len=sock_read((*i1)->socket,buff,1024,ec,closed);
                    if((signed)len<0)
                        len=0;
                    stats_botnet_bytes_received(len);
                    if(ec)
                        len=0;
                    for(size_t ii=0; !got_eol && ii<len; ++ii)
                        if(buff[ii]=='\n') {
                            got_eol=true;
                            break;
                        }
                } while(len);
                if(got_eol) {
                    (*i1)->connect_start=0;
                } else {
                    if((*i1)->connect_start+BOTNET_LOGIN_GREETING_TIMEOUT<my_time(NULL))
                        (*i1)->connect_start=0;
                }
                if(0==(*i1)->awaiting_ready) {
                    int ec=0;
                    string nick=botnet_botname;
                    nick+="\r\n";
                    size_t sent=0;
                    if(!(*i1)->ssl_connection)
                        sent=sock_send((*i1)->socket,(char*)nick.c_str(),nick.length(),ec);
                    else
                        sent=send(((*i1)->socket.deref(__FILE__,__LINE__)),(char*)nick.c_str(),(int)nick.length(),0);
                    stats_botnet_bytes_sent(sent);
                    if(sent!=nick.length() || ec!=0) {
                        string log=GET_STR_DEBUG_INFO_EX("Not all the data were sent");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&(*i1)->socket);
                        MY_DELETE_A(errstr);

                        log=GET_STR_DEBUG_INFO_EX("Unable to send auth error");
                        errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                        MY_DELETE_A(errstr);

                        (*i1)->garbage_socket();
                        continue;
                    }

                    if((*i1)->ssl_connection)
                        (*i1)->awaiting_ready=my_time(NULL);
                }
                continue;
            }
            if(0!=(*i1)->connect_start && (*i1)->pure_ssl) {
                bool got_eol=false;
                size_t len=0;
                do {
                    char buff[1024];
                    len=(*i1)->ssl->read(buff,1024);
                    if((signed)len<0)
                        len=0;
                    stats_botnet_bytes_received(len);
                    for(size_t ii=0; !got_eol && ii<len; ++ii)
                        if(buff[ii]=='\n') {
                            got_eol=true;
                            break;
                        }
                } while(len);
                if(got_eol) {
                    (*i1)->connect_start=0;
                } else {
                    if((*i1)->connect_start+BOTNET_LOGIN_GREETING_TIMEOUT<my_time(NULL))
                        (*i1)->connect_start=0;
                }
                if(0==(*i1)->awaiting_ready) {
                    string nick=botnet_botname;
                    nick+="\r\n";
                    (*i1)->ssl->write((char*)nick.c_str(),nick.length());
                    stats_botnet_bytes_sent(nick.length());
                    (*i1)->awaiting_ready=my_time(NULL);
                }
                continue;
            }
            if((*i1)->socket.cmp()==false)
                continue;

            my_time_t now;
            my_time(&now);

            if((*i1)->next_ping<now) {
                c_bot_control* c=MY_NEW c_bot_control;
                c->hard_clear();
                c->packet_type=PACKET_TYPE_CONTROL;
                c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                c->control=CTRL_PING;
                botnet_send_control(*i1,c);
                (*i1)->next_ping=now+BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                if(!(*i1)->start_awaiting_pong)
                    (*i1)->start_awaiting_pong=now;
                MY_DELETE(c);
            }
            if((*i1)->start_awaiting_pong!=0) {
                if((*i1)->start_awaiting_pong+BOTNET_PING_TIMEOUT<now) {
                    // ping timeout
                    string log=GET_STR_DEBUG_INFO_EX("PING timeout");
                    log_botnet_debug(botnet_botname,(*i1)->botname,-1,-1,log);
                    log_botnet(botnet_botname,(*i1)->botname,"PING timeout");

                    int ec=0;
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                    MY_DELETE_A(errstr);

                    (*i1)->garbage_socket();
                    continue;
                }
            }

            if(!(*i1)->sent_at_least_one_ping) {
                // send dummy ping packet first
                c_bot_control* c=MY_NEW c_bot_control;
                c->hard_clear();
                c->packet_type=PACKET_TYPE_CONTROL;
                c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                c->control=CTRL_PING;
                botnet_send_control(*i1,c);
                (*i1)->next_ping=now+BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                if(!(*i1)->start_awaiting_pong)
                    (*i1)->start_awaiting_pong=now;
                MY_DELETE(c);

                (*i1)->sent_at_least_one_ping=true;
            }

            if(!(*i1)->sent_bot_auth_1 && (*i1)->got_at_least_one_pong && (*i1)->botnet12_compatibility) {
                c_bot_command* c=MY_NEW c_bot_command;
                c->hard_clear();

                c->packet_type=PACKET_TYPE_COMMAND;
                c->size=sizeof(c);
                c->version=1;
                c->command=CMD_AUTH_1;
                strncpy(c->command_data.bot_auth_1.botname,botnet_botname.c_str(),sizeof(c->command_data.bot_auth_1.botname)-1);

                unsigned char signature[32+1];

                strncpy((char*)signature,dcc_get_password(botnet_botname).c_str(),sizeof(signature)-1);
                signature[32]=0;

                MD5Context md5c;
                MD5Init(&md5c);
                MD5Update(&md5c,signature,sizeof(signature)-1);
                MD5Final(signature,&md5c);

                char sig[128];
                sig[0]=0;
                for(int i1_=0; i1_<16; ++i1_) {
                    char tmp[16];
                    sprintf(tmp,"%02X",signature[i1_]);
                    strcat(sig,tmp);
                }

                memset(c->command_data.bot_auth_1.digest,0,sizeof(c->command_data.bot_auth_1.digest));
                memcpy(c->command_data.bot_auth_1.digest,sig,sizeof(signature)-1);

                if(botnet_send_command(*i1,c)) {
                    string log=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_COMMAND to remote bot");
                    log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->command,log);
                    log_botnet(botnet_botname,(*i1)->botname,"closing LINK connection (error)");

                    int ec=0;
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                    MY_DELETE_A(errstr);

                    (*i1)->garbage_socket();
                    continue;
                }

                (*i1)->sent_bot_auth_1=true;

                MY_DELETE(c);
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && !(*i1)->users_already_updated) {
                my_time_t now;
                my_time(&now);
                //if(/*(*i1)->users_to_push_last_update+120<now*/ 1) { // commented out because we got last_proc_push functionality
                {
                    my_time(&(*i1)->users_to_push_last_update);

                    /*vector<c_bot*>::iterator i1;
                    for(i1=bots->begin(); i1!=bots->end(); ++i1) {*/
                    for(int _i1_=0; _i1_<1; ++_i1_) { // for continue command we use later
                        // procedures first!
                        if((*i1)->last_proc_push==0 || (*i1)->last_proc_push+BOTNET_PUSH_PROC_EVERY>my_time(NULL))
                            continue; // it is not the right time now! procedures first!
                        (*i1)->last_proc_push=0;

                        if((*i1)->supported_proto_version>=1004)
                            (*i1)->users_already_updated=true;

                        deque<c_user> users;
                        logic_get_push_users((*i1)->botname,users);
                        deque<c_user>::iterator i2;
                        for(i2=users.begin(); i2!=users.end(); ++i2) {
                            if((*i2).last_changed==0)
                                (*i2).last_changed=1;
                            {
                                bool reject=false;
                                string obj=(string)"USER "+(*i2).name;
                                vector<string>::iterator i2;
                                for(i2=(*i1)->rejected_objects.begin(); i2!=(*i1)->rejected_objects.end(); ++i2) {
                                    if(!(*i2).compare(obj)) {
                                        reject=true;
                                        break;
                                    }
                                }
                                if(reject)
                                    continue;
                            }
                            c_user_to_push u;
                            u.botname=(*i1)->botname;
                            u.user=*i2;

                            (*i1)->pushing_users.push_back(u);
                        }
                    }
                }
            }

            size_t to_receive=0, to_send=0;
            if(!(*i1)->ssl_connection)
                sock_cache_stats((*i1)->socket,to_receive,to_send);
            else if((*i1)->ssl)
                (*i1)->ssl->get_cache_stats(to_receive,to_send);
            bool push_request_okay=to_send<BOTNET_MAXIMUM_SOCKET_CACHE/2;

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && push_request_okay) {
                vector<c_user_to_push>::iterator i2=(*i1)->pushing_users.begin();
                if(i2!=(*i1)->pushing_users.end()) {
                    c_user_to_push& u=*i2;
                    c_bot_command* c=MY_NEW c_bot_command;
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_COMMAND;
                    c->size=sizeof(c);
                    c->version=1;
                    c->command=CMD_PUSH_1;
                    c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                    c->command_data.check_time_1.user=true;
                    c->command_data.check_time_1.procedure=false;
                    c->command_data.check_time_1.function=false;
                    c->command_data.check_time_1.channel_def=false;
                    c->command_data.check_time_1.prv=false;
                    char* user=c->command_data.check_time_1.object_name;
                    memset(user,0,sizeof(c->command_data.check_time_1.object_name));
                    strncpy(user,u.user.name.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                    c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(u.user.last_changed);
                    botnet_send_command(*i1,c);

                    MY_DELETE(c);

                    (*i1)->pushing_users.erase(i2);
                }
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && !(*i1)->procs_already_updated) {
                my_time_t now;
                my_time(&now);
                if((*i1)->procs_to_push_last_update+BOTNET_PUSH_PROC_LAST_UPDATE<now) {
                    {
                        my_time(&(*i1)->procs_to_push_last_update);

                        if((*i1)->supported_proto_version>=1004)
                            (*i1)->procs_already_updated=true;

                        {
                            (*i1)->last_proc_push=my_time(NULL);
                            vector<c_procedure> procs;
                            logic_get_push_procs((*i1)->botname,procs);
                            vector<c_procedure>::iterator i2;
                            for(i2=procs.begin(); i2!=procs.end(); ++i2) {
                                if((*i2).get_last_changed()==0)
                                    (*i2).set_last_changed(1);
                                {
                                    bool reject=false;
                                    if((*i2).get_minimal_botnet_version()>(*i1)->supported_proto_version)
                                        reject=true;
                                    string obj=(string)"PROC "+(*i2).get_name();
                                    vector<string>::iterator i2;
                                    for(i2=(*i1)->rejected_objects.begin(); i2!=(*i1)->rejected_objects.end(); ++i2) {
                                        if(!(*i2).compare(obj)) {
                                            reject=true;
                                            break;
                                        }
                                    }
                                    if(reject)
                                        continue;
                                }
                                c_proc_to_push p;
                                p.botname=(*i1)->botname;
                                p.proc_name=(*i2).get_name();
                                p.last_changed=(*i2).get_last_changed();
                                (*i1)->adjust_timestamp(p.last_changed);
                                p.func=false;
                                (*i1)->pushing_procs.push_back(p);
                            }
                        }
                    }
                    {
                        {
                            vector<c_function*> procs;
                            logic_get_push_funcs((*i1)->botname,procs);
                            vector<c_function*>::iterator i2;
                            for(i2=procs.begin(); i2!=procs.end(); ++i2) {
                                if((*i2)->get_last_changed()==0)
                                    (*i2)->set_last_changed(1);
                                {
                                    bool reject=false;
                                    if((*i2)->get_minimal_botnet_version()>(*i1)->supported_proto_version)
                                        reject=true;
                                    string obj=(string)"PROC "+(*i2)->get_name(); // function is like procedure
                                    vector<string>::iterator i2;
                                    for(i2=(*i1)->rejected_objects.begin(); i2!=(*i1)->rejected_objects.end(); ++i2) {
                                        if(!(*i2).compare(obj)) {
                                            reject=true;
                                            break;
                                        }
                                    }
                                    if(reject)
                                        continue;
                                }
                                c_proc_to_push p;
                                p.botname=(*i1)->botname;
                                p.proc_name=(*i2)->declaration;
                                p.last_changed=(*i2)->get_last_changed();
                                (*i1)->adjust_timestamp(p.last_changed);
                                p.func=true;
                                (*i1)->pushing_procs.push_back(p);
                            }
                        }
                    }
                }
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && push_request_okay) {
                vector<c_proc_to_push>::iterator i2=(*i1)->pushing_procs.begin();
                if(i2!=(*i1)->pushing_procs.end()) {
                    c_proc_to_push& p=*i2;
                    c_bot_command* c=MY_NEW c_bot_command;
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_COMMAND;
                    c->size=sizeof(c);
                    c->version=1;
                    c->command=CMD_PUSH_1;
                    c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                    c->command_data.check_time_1.user=false;
                    c->command_data.check_time_1.procedure=!p.func;
                    c->command_data.check_time_1.function=p.func;
                    c->command_data.check_time_1.channel_def=false;
                    c->command_data.check_time_1.prv=false;
                    char* proc=c->command_data.check_time_1.object_name;
                    memset(proc,0,sizeof(c->command_data.check_time_1.object_name));
                    strncpy(proc,p.proc_name.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                    c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(p.last_changed);
                    botnet_send_command(*i1,c);

                    MY_DELETE(c);

                    (*i1)->pushing_procs.erase(i2);
                }
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && !(*i1)->chandefs_already_updated) {
                my_time_t now;
                my_time(&now);
                if((*i1)->chans_to_push_last_update+BOTNET_CHANS_LAST_UPDATE<now) {
                    my_time(&(*i1)->chans_to_push_last_update);

                    if((*i1)->supported_proto_version>=1004)
                        (*i1)->chandefs_already_updated=true;

                    /*vector<c_bot*>::iterator i1;
                    for(i1=bots->begin(); i1!=bots->end(); ++i1) {*/
                    {
                        vector<c_channel_def> chans;
                        logic_get_push_chan_defs((*i1)->botname,chans);
                        vector<c_channel_def>::iterator i2;
                        for(i2=chans.begin(); i2!=chans.end(); ++i2) {
                            if((*i2).last_changed==0)
                                (*i2).last_changed=1;
                            {
                                bool reject=false;
                                string obj=(string)"CHAN "+(*i2).channel_name;
                                vector<string>::iterator i2;
                                for(i2=(*i1)->rejected_objects.begin(); i2!=(*i1)->rejected_objects.end(); ++i2) {
                                    if(!cmp_strings_case_insensitive((*i2),obj)) {
                                        reject=true;
                                        break;
                                    }
                                }
                                if(reject)
                                    continue;
                            }
                            c_chan_def_to_push ch;
                            ch.botname=(*i1)->botname;
                            ch.chan_name=(*i2).channel_name;
                            ch.last_changed=(*i2).last_changed;
                            (*i1)->pushing_chans.push_back(ch);
                        }
                    }
                }
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && push_request_okay) {
                vector<c_chan_def_to_push>::iterator i2=(*i1)->pushing_chans.begin();
                if(i2!=(*i1)->pushing_chans.end()) {
                    c_chan_def_to_push& ch=*i2;
                    c_bot_command* c=MY_NEW c_bot_command;
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_COMMAND;
                    c->size=sizeof(c);
                    c->version=1;
                    c->command=CMD_PUSH_1;
                    c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                    c->command_data.check_time_1.user=false;
                    c->command_data.check_time_1.procedure=false;
                    c->command_data.check_time_1.function=false;
                    c->command_data.check_time_1.channel_def=true;
                    c->command_data.check_time_1.prv=false;
                    char* chan=c->command_data.check_time_1.object_name;
                    memset(chan,0,sizeof(c->command_data.check_time_1.object_name));
                    strncpy(chan,ch.chan_name.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                    c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(ch.last_changed);
                    botnet_send_command(*i1,c);

                    MY_DELETE(c);

                    (*i1)->pushing_chans.erase(i2);
                }
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && !(*i1)->sent_partyline_users) {
                (*i1)->sent_partyline_users=true;
                vector<c_botnet_channel>::iterator i2;
                for(i2=botnet_channels.begin(); i2!=botnet_channels.end(); ++i2) {
                    vector<c_partyline_member>::iterator i3;
                    for(i3=(*i2).members.begin(); i3!=(*i2).members.end(); ++i3) {
                        c_bot_command* c=MY_NEW c_bot_command;
                        c->hard_clear();

                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_PARTYLINE_USER_1;

                        c->command_data.cmd_partyline_user_1.id=botnet_get_unique_id();

                        int user_size=sizeof(c->command_data.cmd_partyline_user_1.user);
                        int ch_size=sizeof(c->command_data.cmd_partyline_user_1.channel);
                        int bn_size=sizeof(c->command_data.cmd_partyline_user_1.botname);
                        strncpy(c->command_data.cmd_partyline_user_1.user,(*i3).user.c_str(),user_size-1);
                        strncpy(c->command_data.cmd_partyline_user_1.channel,(*i2).channel_name.c_str(),ch_size-1);
                        strncpy(c->command_data.cmd_partyline_user_1.botname,(*i3).botname.c_str(),bn_size-1);

                        botnet_send_command(*i1,c);

                        botnet_partyline_event(botnet_botname,c);

                        MY_DELETE(c);
                    }
                }
            }

            if((*i1)->auth_ok && (*i1)->remote_pswd_ok && !(*i1)->prv_already_updated) {
                my_time_t now;
                my_time(&now);
                if((*i1)->prv_to_push_last_update+BOTNET_PRV_PUSH_LAST_UPDATE<now) {
                    my_time(&(*i1)->prv_to_push_last_update);

                    if((*i1)->supported_proto_version>=1004)
                        (*i1)->prv_already_updated=true;

                    vector<c_replication>::iterator i2;
                    bool skip=true;
                    for(i2=r_private.replication.begin(); i2!=r_private.replication.end(); ++i2) {
                        if(!(*i2).partner.compare((*i1)->botname) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                            skip=false;
                            break;
                        }
                    }
                    {
                        bool reject=false;
                        string obj=(string)"PRIV";
                        vector<string>::iterator i2;
                        for(i2=(*i1)->rejected_objects.begin(); i2!=(*i1)->rejected_objects.end(); ++i2) {
                            if(!(*i2).compare(obj)) {
                                reject=true;
                                break;
                            }
                        }
                        if(reject)
                            skip=true;
                    }

                    if(!skip) {
                        (*i1)->prv_to_push=r_private;
                        if(r_private.last_changed==0)
                            r_private.last_changed=1;
                        c_bot_command* c=MY_NEW c_bot_command;
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_CHECK_TIME_1;
                        c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                        c->command_data.check_time_1.prv=true;
                        c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>((*i1)->prv_to_push.last_changed);
                        botnet_send_command(*i1,c);

                        MY_DELETE(c);
                    }
                }
            }
        }
        if((*i1)->socket.cmp()==false && TCID_INVALID==(*i1)->connect_id) {
            string comment="BOTNET connection to bot \"";
            comment+=(*i1)->botname;
            comment+="\" to IP ";
            comment+=(*i1)->botip;

            bool async=(*i1)->ssl_connection?false:true;
            async=true;
            (*i1)->connect_id=threads_connect((*i1)->localip,(*i1)->botip,(*i1)->botport,comment,async);
            (*i1)->connect_start=0;
        }
    }
}

#if defined(_MSC_VER)
#   pragma warning(pop)
#endif

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Called when remote bot connects via telnet
    \param socket Socket handle of connection
    \param botname Name of remote bot
    \param buff Buffer which can be read
    \param buff_size Size of buffer
    \param ssl SSL descriptor of connection
    \param remote_ip IP address of remote peer
*/
void botnet_received_data_from_telnet(c_socket& socket, string botname, char* buff, size_t buff_size, c_ssl* ssl, string remote_ip)
{
    if(!bots)
        return;

    stats_botnet_new_connection();
    stats_botnet_bytes_received(buff_size);

    {
        string log="Received connection: ";
        log+=socket.comment;
        log_botnet(botnet_botname,botname,log);
        log_botnet_debug(botnet_botname,botname,-1,-1,log);
    }

    bool botnet12_compatibility=false;//conf_pass.get_botnet12_compatibility(botname);
    string local_MD5_password=conf_pass.get_local_password_md5(botname);
    string remote_MD5_password=conf_pass.get_remote_password_md5(botname);

    vector<c_bot*>::iterator i1;
    bool got=false;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if(!(*i1)->botname.compare(botname))
            if((*i1)->socket==socket) {
                got=true;
                break;
            }
    }
    if(!got) {
        c_bot* s=MY_NEW c_bot;
        s->clear();
        s->clean=false;
        s->botnet12_compatibility=botnet12_compatibility;
        s->local_MD5_password=local_MD5_password;
        s->ssl_connection=ssl?true:false;
        s->ssl=ssl;
        s->botname="";
        s->localip="";
        s->botip=remote_ip;
        s->botport=0;
        s->socket.clear();
        s->remote_MD5_password="";
        s->sent_bot_auth_1=false;
        s->received_bot_auth_1=false;
        s->receive_buffer_pos=0;
        s->botname=botname;
        s->socket=socket;
        s->remote_MD5_password=dcc_get_password(botname);
        s->buff_size_from_dcc=0;
        if(buff_size) {
            s->buff_size_from_dcc=buff_size;
            if(s->buff_size_from_dcc>sizeof(s->buff_from_dcc))
                s->buff_size_from_dcc=sizeof(s->buff_from_dcc);
            memcpy(s->buff_from_dcc,buff,s->buff_size_from_dcc);
            s->buff_pos_from_dcc=0;
        }

        s->unlink_timer=NULL;

        s->got_bytes=0;
        s->auth_ok=false;
        s->prelink_ok=false;
        s->remote_pswd_ok=false;
        s->last_try=(my_time_t)((signed)-1);
        s->invoked_from_telnet=true;
        s->was_linked=false;

        botnet_regenerate_vector();

        bots->push_back(s);
    }
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Called from partyline, when user connected to this bot is joining partline channel
    \param user Name of user as in logic.txt
    \param channel Name of partyline channel
*/
string botnet_partyline_join_channel(string user, string channel)
{
    if(!bots)
        return (string)"";

    c_bot_command* c=MY_NEW c_bot_command;
    c->hard_clear();
    c->packet_type=PACKET_TYPE_COMMAND;
    c->size=sizeof(c);
    c->version=1;
    c->command=CMD_PARTYLINE_1;

    c->command_data.cmd_partyline_1.id=botnet_get_unique_id();

    c->command_data.cmd_partyline_1.msg=false;
    c->command_data.cmd_partyline_1.join=true;
    c->command_data.cmd_partyline_1.leave=false;

    int user_size=sizeof(c->command_data.cmd_partyline_1.user);
    int ch_size=sizeof(c->command_data.cmd_partyline_1.channel);
    int bn_size=sizeof(c->command_data.cmd_partyline_1.botname);
    strncpy(c->command_data.cmd_partyline_1.user,user.c_str(),user_size-1);
    strncpy(c->command_data.cmd_partyline_1.channel,channel.c_str(),ch_size-1);
    channel=c->command_data.cmd_partyline_1.channel; // reset channel name to maximal length (if exceedes)
    strncpy(c->command_data.cmd_partyline_1.botname,botnet_botname.c_str(),bn_size-1);

    bool got=false;
again:
    vector<c_botnet_channel>::iterator i2;
    for(i2=botnet_channels.begin(); i2!=botnet_channels.end(); ++i2)
        if(!(*i2).channel_name.compare(channel)) {
            got=true;
            break;
        }
    if(!got) {
        c_botnet_channel c;
        c.channel_name=channel;
        botnet_channels.push_back(c);
        goto again;
    }
    c_partyline_member me;
    char* ch=MY_NEW char[user_size+1];
    memset(ch,0,user_size+1);
    strncpy(ch,user.c_str(),user_size-1);
    me.user=ch;
    MY_DELETE_A(ch);
    me.botname=botnet_botname;
    (*i2).members.push_back(me);

    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if((*i1)->socket.cmp() && (*i1)->auth_ok && (*i1)->remote_pswd_ok) {
            botnet_send_command(*i1,c);
        }
    }

    botnet_partyline_event(botnet_botname,c);

    string users;
    vector<c_partyline_member>::iterator i3;
    for(i3=(*i2).members.begin(); i3!=(*i2).members.end(); ++i3) {
        if(users.compare(""))
            users+=", ";
        users+=(*i3).user;
        users+="@";
        users+=(*i3).botname;
    }

    MY_DELETE(c);

    return users;
}

/*!
    \author VooDooMan
    \version 1
    \date 2004
    \brief Called from partyline, when user connected to this bot is leaving partline channel
    \param user Name of user as in logic.txt
    \param channel Name of partyline channel
*/
void botnet_partyline_leave_channel(string user, string channel)
{
    if(!bots)
        return;

    c_bot_command* c=MY_NEW c_bot_command;
    c->hard_clear();
    c->packet_type=PACKET_TYPE_COMMAND;
    c->size=sizeof(c);
    c->version=1;
    c->command=CMD_PARTYLINE_1;

    c->command_data.cmd_partyline_1.id=botnet_get_unique_id();

    c->command_data.cmd_partyline_1.msg=false;
    c->command_data.cmd_partyline_1.join=false;
    c->command_data.cmd_partyline_1.leave=true;

    int user_size=sizeof(c->command_data.cmd_partyline_1.user);
    int ch_size=sizeof(c->command_data.cmd_partyline_1.channel);
    int bn_size=sizeof(c->command_data.cmd_partyline_1.botname);
    strncpy(c->command_data.cmd_partyline_1.user,user.c_str(),user_size-1);
    strncpy(c->command_data.cmd_partyline_1.channel,channel.c_str(),ch_size-1);
    strncpy(c->command_data.cmd_partyline_1.botname,botnet_botname.c_str(),bn_size-1);

    char* ch=MY_NEW char[ch_size+1];
    memset(ch,0,ch_size+1);
    strncpy(ch,channel.c_str(),ch_size-1);
    bool got=false;
    vector<c_botnet_channel>::iterator i2;
    for(i2=botnet_channels.begin(); i2!=botnet_channels.end(); ++i2)
        if(!(*i2).channel_name.compare(ch)) {
            got=true;
            break;
        }
    MY_DELETE_A(ch);
    if(got) {
        bool got2=false;
        vector<c_partyline_member>::iterator i3;
        for(i3=(*i2).members.begin(); i3!=(*i2).members.end(); ++i3)
            if(!(*i3).user.compare(user) && !(*i3).botname.compare(botnet_botname)) {
                got2=true;
                break;
            }
        if(got2)
            (*i2).members.erase(i3);
        if((*i2).members.empty())
            botnet_channels.erase(i2);
    }

    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if((*i1)->socket.cmp() && (*i1)->auth_ok && (*i1)->remote_pswd_ok) {
            botnet_send_command(*i1,c);
        }
    }

    botnet_partyline_event(botnet_botname,c);

    MY_DELETE(c);
}

/*!
    \author VooDooMan
    \version 1
    \date 2005
    \brief Called from partyline, when user connected to this bot is writing a message to partline channel
    \param user Name of user as in logic.txt
    \param channel Name of partyline channel
    \param msg Message
*/
void botnet_partyline_message(string user, string channel, string msg)
{
    botnet_partyline_message(user, channel, msg, botnet_get_unique_id());
}

/*!
    \author VooDooMan
    \version 3
    \date 2004, 2006-10-04
    \brief Called from partyline, when user connected to this bot is writing a message to partline channel
    \param user Name of user as in logic.txt
    \param channel Name of partyline channel
    \param msg Message
    \param id ID of message to be used
*/
void botnet_partyline_message(string user, string channel, string msg, uint32 id)
{
    if(!bots)
        return;

    if(msg.length()>512) {
        char m[512+1+16];
        strncpy(m,msg.c_str(),512);
        m[512]='\0';
        msg=m;
    }
    {
        vector<c_msg_id>::iterator i1;
        bool got=false;
        for(i1=msg_ids.begin(); i1!=msg_ids.end(); ++i1)
            if((*i1).id==id) {
                got=true;
                break;
            }
        if(!got) {
            c_msg_id i;
            i.id=id;
            i.time=static_cast<my_botnet_time_t>(my_time(NULL));
            msg_ids.push_back(i);
        }
    }

    c_bot_command* c=MY_NEW c_bot_command;
    c->hard_clear();
    c->packet_type=PACKET_TYPE_COMMAND;
    c->size=sizeof(c);
    c->version=1;
    c->command=CMD_PARTYLINE_1;

    c->command_data.cmd_partyline_1.id=id;

    c->command_data.cmd_partyline_1.msg=true;
    c->command_data.cmd_partyline_1.join=false;
    c->command_data.cmd_partyline_1.leave=false;

    int user_size=sizeof(c->command_data.cmd_partyline_1.user);
    int msg_size=sizeof(c->command_data.cmd_partyline_1.message);
    int ch_size=sizeof(c->command_data.cmd_partyline_1.channel);
    int bn_size=sizeof(c->command_data.cmd_partyline_1.botname);
    strncpy(c->command_data.cmd_partyline_1.user,user.c_str(),user_size-1);
    strncpy(c->command_data.cmd_partyline_1.channel,channel.c_str(),ch_size-1);
    strncpy(c->command_data.cmd_partyline_1.message,msg.c_str(),msg_size-1);
    strncpy(c->command_data.cmd_partyline_1.botname,botnet_botname.c_str(),bn_size-1);

    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if((*i1)->socket.cmp() && (*i1)->auth_ok && (*i1)->remote_pswd_ok) {
            botnet_send_command(*i1,c);
        }
    }

    botnet_partyline_event(botnet_botname,c);

    MY_DELETE(c);
}

/*!
    \author VooDooMan
    \version 1
    \date 2005
    \brief Used for partyline to show connected bots (.showbots)
    \param lang Output language
    \param eol End of line sequence
*/
string botnet_showbots(string lang, string eol)
{
    if(!bots)
        return (string)"";

    string res;
    res+=lang_get_string(1,lang,649)+eol;
    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1)
        if((*i1)->socket.cmp() && (*i1)->auth_ok && (*i1)->remote_pswd_ok) {
            res+=(*i1)->botname;
            res+=" ";
            res+=lang_get_string(1,lang,650)+eol;
        } else {
            res+=(*i1)->botname;
            res+=" ";
            res+=lang_get_string(1,lang,651)+eol;
        }

    res+=lang_get_string(1,lang,652)+eol;

    return res;
}

/*!
    \author VooDooMan
    \version 1
    \date 2005
    \brief Sends admin message (for command "admin_msg" in file "logic.txt")
    \param user_mask Mask of users as in logic.txt to receive message
    \param bot_mask Mask of names of bots to receive message
    \param msg Message
*/
void botnet_admin_msg(string user_mask, string bot_mask, string msg)
{
    string c="\x01" "BROADCAST_ADMIN_MESSAGE\x01 * * ";
    c+=bot_mask;
    c+=" ";
    c+=user_mask;
    c+=" ";
    c+=msg;

    botnet_partyline_message(botnet_botname,"",c);
}

/*!
    \brief Timer for unlinking bot removal request (timer will be destroyed), so invalidate pointer
    \version 1
    \date 2006-01-21
    \author VooDooMan
    \param timer Timer
*/
void botnet_kill_timer(c_timer* timer)
{
    if(!bots)
        return;

    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        if((*i1)->unlink_timer==timer)
            (*i1)->unlink_timer=NULL;
    }
}

/*!
    \brief Called when module is being unloaded, to invalidate delayed links
    \version 1
    \date 2006-01-21
    \author VooDooMan
    \param module Module
*/
void botnet_kill_module(c_module* module)
{
    vector<c_delay_link>::iterator i1;
again:
    for(i1=botnet_delay_link.begin(); i1!=botnet_delay_link.end(); ++i1) {
        if((*i1).this_module==module) {
            if((*i1).vars) {
                var_keeper->free_global((*i1).vars,true);
            }
            (*i1).vars=NULL;
            botnet_delay_link.erase(i1);
            goto again;
        }
    }
}

/*!
    \brief Destructor
    \author VooDooMan
    \version 1
    \date 2007-02-18
*/
c_command_queue::~c_command_queue()
{
    deque<data_t>::iterator i1;
    while((i1=commands.begin())!=commands.end()) {
        my_free((*i1).second.first);
        commands.pop_front();
    }
    commands_id.clear();
}

/*!
    \brief Adds command to queue
    \author VooDooMan
    \version 1
    \date 2007-02-18
    \param bot Remote bot descriptor
    \param cmd Command
    \param level z-lib level of compression
    \return Returns 'true' if we have an error
    \warning It's YOUR job to free argument 'cmd' after returning from this function
    \warning Could modify cmd->size
*/
bool c_command_queue::add_command(c_bot* bot, c_bot_command* cmd, int level)
{
    zlib_level=level;

    if(got_error)
        return true;

    if(!cmd)
        return false; // huh?!

    data_t packet;

    bool need_updating= ( CMD_PUSH_1==cmd->command || CMD_CHECK_TIME_1==cmd->command );
    if(bot->got_better_remote_time_diff)
        need_updating=false; // it is newer bot, >=1.1.beta26, so no packet needs to be updated

    if(need_updating) {
        // packet needs to be updated
        packet.first=true;
        packet.second.first=my_malloc(sizeof(*cmd));

        if(!packet.second.first) {
            got_error=true;

            log=GET_STR_DEBUG_INFO_EX("my_malloc() call failed");
            return true;
        }

        packet.second.second=sizeof(*cmd);
        memcpy(packet.second.first,cmd,sizeof(*cmd));

        commands.push_back(packet);
        commands_id.push_back(cmd->command);
        return false;
    } else {
        // packet will not be updated

        uint32 id=cmd->command;

        // these two: NOT in reverse order!
        cmd->flip();
        cmd->flip_header();

        unsigned long compressed=0;
        int zlib_rc;
        char* buf=compress_zlib_compress((void*)&(cmd->command_data),sizeof(cmd->command_data),compressed,level,zlib_rc);
        if(zlib_rc!=Z_OK) {
            if(buf)
                MY_DELETE_A(buf);
            buf=NULL;

            got_error=true;

            log="zlib error: \"";
            log+=compress_zlib_get_str_rc(zlib_rc);
            log+="\" ";
            log=GET_STR_DEBUG_INFO_EX(log);

            return true;
        }

        cmd->size=static_cast<uint32>(compressed);
        byteReverse((unsigned char*)&cmd->size,1);

        packet.first=false;

        packet.second.first=my_malloc(4*4+compressed);
        if(!packet.second.first) {
            got_error=true;

            log=GET_STR_DEBUG_INFO_EX("my_malloc() call failed");
            return true;
        }

        packet.second.second=4*4+compressed;

        memcpy(packet.second.first,cmd,4*4);
        memcpy(&(((unsigned char*)packet.second.first)[4*4]),buf,compressed);
        MY_DELETE_A(buf);
        packet.second.second=4*4+compressed;

        commands.push_back(packet);
        commands_id.push_back(id);
        return false;
    }
    // NOTREACH
}

/*!
    \brief Gets first error (for logs)
    \author VooDooMan
    \version 1
    \date 2007-02-18
*/
string c_command_queue::get_error()
{
    return log;
}

/*!
    \brief Sets first error (for logs)
    \author VooDooMan
    \version 1
    \date 2007-02-18
*/
void c_command_queue::set_error(const string& err)
{
    if(got_error)
        return;

    log=err;
    got_error=true;
}

/*!
    \brief Gets next packet
    \author VooDooMan
    \version 1
    \date 2007-02-18
    \param queue_empty Set to 'true' if sockets' sendQ is empty
    \param data Receives data to send, or NULL if none; needs to be deallocated by free()
    \param len Length of 'data' if data!=NULL
    \param id Receives command ID
    \return Returns 'true' for error
*/
bool c_command_queue::get_next_packet(bool queue_empty, void* &data, size_t& len, unsigned long long& id)
{
    data=NULL;
    len=0;
    id=0;

    if(got_error)
        return true;

    if(commands.empty())
        return false;

    data_t packet=*(commands.begin());
    if(packet.first && !queue_empty) {
        // packet needs to be updated, but sendQ is not empty: wait for its emptiness!
        return false;
    }

    if(packet.first) {
        // update packet
        c_bot_command* cmd=(c_bot_command*)packet.second.first;

        commands.pop_front();
        commands_id.pop_front();

        id=cmd->command;

        switch(cmd->command) {
            case CMD_PUSH_1:
                cmd->command_data.cmd_push_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                byteReverse((unsigned char*)&cmd->command_data.cmd_push_1.now,1);
                break;
            case CMD_CHECK_TIME_1:
                cmd->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                byteReverse((unsigned char*)&cmd->command_data.check_time_1.now,1);
                break;
        }

        // these two: NOT in reverse order!
        cmd->flip();
        cmd->flip_header();

        unsigned long compressed=0;
        int zlib_rc;
        char* buf=compress_zlib_compress((void*)&(cmd->command_data),sizeof(cmd->command_data),compressed,zlib_level,zlib_rc);
        if(zlib_rc!=Z_OK) {
            if(buf)
                MY_DELETE_A(buf);
            buf=NULL;

            my_free(cmd);

            got_error=true;

            log="zlib error: \"";
            log+=compress_zlib_get_str_rc(zlib_rc);
            log+="\" ";
            log=GET_STR_DEBUG_INFO_EX(log);

            return true;
        }

        cmd->size=static_cast<uint32>(compressed);
        byteReverse((unsigned char*)&cmd->size,1);

        packet.first=false;

        packet.second.first=my_malloc(4*4+compressed);
        if(!packet.second.first) {
            got_error=true;

            my_free(cmd);

            log=GET_STR_DEBUG_INFO_EX("my_malloc() call failed");
            return true;
        }

        packet.second.second=4*4+compressed;

        memcpy(packet.second.first,cmd,4*4);
        memcpy(&(((unsigned char*)packet.second.first)[4*4]),buf,compressed);
        MY_DELETE_A(buf);
        packet.second.second=4*4+compressed;

        my_free(cmd);

        data=packet.second.first;
        len=packet.second.second;

        return false;
    }

    data=packet.second.first;
    len=packet.second.second;
    commands.pop_front();
    id=*(commands_id.begin());
    commands_id.pop_front();

    return false;
}

MY_STATIC bool botnet_cmd_switch_1(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd, int& result)
{
    switch(s_cmd->command) {
        case CMD_AUTH_1:
            {
                if(!(*i1)->botnet12_compatibility) {
                    botnet_lockout((*i1)->botip);

                    auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                    c_bot_control* c=cp.get();
                    c->hard_clear();

                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_ERROR_002;

                    if(botnet_send_control(*i1,c)) {
                        string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                        string log2="closing LINK connection (error)";

                        log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                        log_botnet(botnet_botname,(*i1)->botname,log2);

                        logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                        int ec=0;
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log1,&((*i1)->socket));
                        MY_DELETE_A(errstr);

                        (*i1)->garbage_socket();
                    }

                    int ec=0;
                    string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error - \"botnet12_compatilibity\" turned off)");
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                    MY_DELETE_A(errstr);

                    (*i1)->garbage_socket();

                    return true;
                }

                unsigned char signature[32+1];
                signature[32]=0;

                if((*i1)->remote_MD5_password.length()==sizeof(signature)-1)
                    strcpy((char*)signature,(*i1)->remote_MD5_password.c_str());

                MD5Context md5c;
                MD5Init(&md5c);
                MD5Update(&md5c,signature,sizeof(signature)-1);
                MD5Final(signature,&md5c);

                char sig[128];
                sig[0]=0;
                for(int i1_=0; i1_<16; ++i1_) {
                    char tmp[16];
                    sprintf(tmp,"%02X",signature[i1_]);
                    strcat(sig,tmp);
                }

                bool equal=true;
                for(unsigned int i=0; i<sizeof(signature)-1; ++i)
                    if(s_cmd->command_data.bot_auth_1.digest[i]!=sig[i]) {
                        equal=false;
                        break;
                    }
                if(!equal) {
                    botnet_lockout((*i1)->botip);

                    c_user_to_lock_out u;
                    u.timestamp=my_time(NULL);
                    u.remote=(*i1)->botip;
                    dcc_users_to_lock_out.push_back(u);

                    string log1=GET_STR_DEBUG_INFO_EX("Incorrect password from remote bot");
                    string log2="BAD PASSWORD on the other side";

                    log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,log1);
                    log_botnet(botnet_botname,(*i1)->botname,log2);

                    logic_on_internal_event("@botnet_link@",(*i1)->botname,"BAD_PASSWORD_THERE","","",PRIVATE_EVENT_SEVERITY_CODE_CRITICAL_ERROR,log2+(string)"; "+log1,"");

                    if(result==1) {
                        auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                        c_bot_control* c=cp.get();
                        c->hard_clear();

                        c->packet_type=PACKET_TYPE_CONTROL;
                        c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                        c->control=CTRL_ERROR_002;

                        if(botnet_send_control(*i1,c)) {
                            string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                            string log2="closing LINK connection (error)";

                            log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                            log_botnet(botnet_botname,(*i1)->botname,log2);

                            logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                            int ec=0;
                            char* errstr=NULL;
                            log_socket(ec,errstr=sock_error(ec),log1,&((*i1)->socket));
                            MY_DELETE_A(errstr);

                            (*i1)->garbage_socket();
                        }

                        int ec=0;
                        string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                        MY_DELETE_A(errstr);

                        (*i1)->garbage_socket();

                    }
                    //result==3 : connection already closed, so do nothing
                    return true;
                } else {
                    if((*i1)->auth_ok) {
                        (*i1)->auth_ok=false;
                        (*i1)->prelink_ok=true;
                        (*i1)->prelinking_wait_start=my_time(NULL);
                    }
                }
            }
            return true;
        case CMD_CHALLENGE_13:
            {
                string data=(char*)s_cmd->command_data.bot_challenge_13.magic;
                // sanity check
                bool ok=true;
                if(data.length()<512 || data.length()>1024)
                    ok=false;
                else {
                    bool tmp[256];
                    unsigned i2;
                    for(i2=0; i2<256; ++i2)
                        tmp[i2]=false;
                    unsigned last=data[0];
                    unsigned very_very_last_increment=99999;
                    unsigned very_last_increment=9999;
                    unsigned last_increment=0;
                    unsigned cnt_progressions=0;
                    for(i2=0; i2<data.length(); ++i2) {
                        tmp[(unsigned char)(data[i2])]=true;
                        last_increment=((unsigned)(((char)data[i2])))-last;
                        if(very_last_increment==last_increment)
                            cnt_progressions++;
                        if(very_very_last_increment==last_increment)
                            cnt_progressions++;
                        if(very_last_increment==very_very_last_increment)
                            cnt_progressions++;
                        very_very_last_increment=very_last_increment;
                        very_last_increment=last_increment;
                        last=data[i2];
                    }
                    if(cnt_progressions>50)
                        ok=false;
                    else {
                        unsigned cnt=0;
                        for(i2=0; i2<256; ++i2)
                            if(tmp[i2])
                                cnt++;
                        if(cnt<32)
                            ok=false;
                    }
                }
                if(!ok || (*i1)->got_challenge) {
                    botnet_lockout((*i1)->botip);

                    auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                    c_bot_control* c=cp.get();
                    c->hard_clear();

                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_ERROR_002;

                    if(botnet_send_control(*i1,c)) {
                        string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                        string log2="closing LINK connection (error)";

                        log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                        log_botnet(botnet_botname,(*i1)->botname,log2);

                        logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                        int ec=0;
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log1,&((*i1)->socket));
                        MY_DELETE_A(errstr);

                        (*i1)->garbage_socket();
                    }

                    int ec=0;
                    string log;
                    if((*i1)->got_challenge)
                        log+=GET_STR_DEBUG_INFO_EX("BOTNET protocol error - already got challenge");
                    else
                        log+=GET_STR_DEBUG_INFO_EX("BOTNET protocol error - bogus challenge");
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                    MY_DELETE_A(errstr);
                    log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,log);
                    log_botnet(botnet_botname,(*i1)->botname,log);

                    (*i1)->garbage_socket();

                    return true;
                }
                char mypass[1024+1];
                strncpy(mypass,(*i1)->local_MD5_password.c_str(),1024-1);
                mypass[1024-1]=0;
                data.insert(128,mypass);
                MD5Context md5;
                MD5Init(&md5);
                MD5Update(&md5,(unsigned char*)data.c_str(),static_cast<unsigned>(data.length()));
                unsigned char digest[16];
                MD5Final(digest,&md5);

                char sig[64];
                sig[0]=0;
                for(int ii=0; ii<16; ++ii) {
                    char tmp[16];
                    sprintf(tmp,"%02X",digest[ii]);
                    strcat(sig,tmp);
                }

                auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                c_bot_command* c=cp.get();
                c->hard_clear();

                c->packet_type=PACKET_TYPE_COMMAND;
                c->size=sizeof(c);
                c->version=13;
                c->command=CMD_AUTH_13;

                memset(c->command_data.bot_auth_13.digest,0,sizeof(c->command_data.bot_auth_13.digest));
                memcpy(c->command_data.bot_auth_13.digest,sig,32);

                if(botnet_send_command(*i1,c)) {
                    string log=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_COMMAND to remote bot");
                    log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->command,log);
                    log_botnet(botnet_botname,(*i1)->botname,"closing LINK connection (error)");

                    int ec=0;
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                    MY_DELETE_A(errstr);

                    (*i1)->garbage_socket();
                    return true;
                }

                (*i1)->got_challenge=true;

            }
            return true;
        case CMD_AUTH_13:
            {
                string resp=(char*)s_cmd->command_data.bot_auth_13.digest;

                string data=(*i1)->sent_challenge;

                char remotepass[1024+1];
                strncpy(remotepass,(*i1)->remote_MD5_password.c_str(),1024-1);
                remotepass[1024-1]=0;
                data.insert(128,remotepass);
                MD5Context md5;
                MD5Init(&md5);
                MD5Update(&md5,(unsigned char*)data.c_str(),static_cast<unsigned>(data.length()));
                unsigned char digest[16];
                MD5Final(digest,&md5);

                char sig[64];
                sig[0]=0;
                unsigned ii;
                for(ii=0; ii<16; ++ii) {
                    char tmp[16];
                    sprintf(tmp,"%02X",digest[ii]);
                    strcat(sig,tmp);
                }

                // check digest
                bool ok=true;
                if(resp.length()!=32)
                    ok=false;
                else {
                    for(ii=0; ii<32; ++ii) {
                        if(sig[ii]!=resp[ii]) {
                            ok=false;
                            break;
                        }
                    }
                }

                (*i1)->auth_ok=(*i1)->remote_pswd_ok=(*i1)->response_okay=ok;
                if(!ok)
                    botnet_lockout((*i1)->botip);

                auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                c_bot_control* c=cp.get();
                c->hard_clear();

                c->packet_type=PACKET_TYPE_CONTROL;
                c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                c->control=CTRL_ERROR_002;

                if(ok) {
                    (*i1)->prelinking_wait_start=my_time(NULL);
                    (*i1)->auth_ok=false;
                    (*i1)->prelink_ok=true;
                }

                if(!ok) {
                    if(botnet_send_control(*i1,c)) {
                        // there could be also bot on the other side which is reconnceting after each challenge
                        if(ok)
                            botnet_lockout((*i1)->botip);

                        string log1=GET_STR_DEBUG_INFO_EX("Unable to send PACKET_TYPE_CONTROL to remote bot");
                        string log2="closing LINK connection (error)";

                        log_botnet_debug(botnet_botname,(*i1)->botname,c->packet_type,c->control,log1);
                        log_botnet(botnet_botname,(*i1)->botname,log2);

                        logic_on_internal_event("@botnet_link@",(*i1)->botname,"DELINKED","","",PRIVATE_EVENT_SEVERITY_CODE_ERROR,log2+(string)"; "+log1,"");

                        int ec=0;
                        char* errstr=NULL;
                        log_socket(ec,errstr=sock_error(ec),log1,&((*i1)->socket));
                        MY_DELETE_A(errstr);

                        (*i1)->garbage_socket();
                    }

                    int ec=0;
                    string log=GET_STR_DEBUG_INFO_EX("BOTNET protocol error");
                    char* errstr=NULL;
                    log_socket(ec,errstr=sock_error(ec),log,&((*i1)->socket));
                    MY_DELETE_A(errstr);

                    (*i1)->garbage_socket();
                }

            }
            return true;
        case CMD_REMOTE_PROCEDURE_CALL_3:
            {
                c_temp_local local;
                c_var_array* vars=NULL;
                /*unsigned new_local_id=*/local.get_params(vars);

                string proc_name_only;
                vector<c_var_base*> args;
                c_module* core_mod=get_module("core",true);
                if(core_mod) {
                    var_keeper->set_current_session(core_mod->get_session());
                    if(var_decode_for_botnet(core_mod,s_cmd->command_data.cmd_remote_procedure_call_3.argc_array,s_cmd->command_data.cmd_remote_procedure_call_3.size,args,proc_name_only)) {
                        bool access=false;
                        string decl;
                        c_module* mod=NULL;
                        if(proc_name_only.find("::")==string::npos)
                            mod=core_mod;
                        else {
                            string mod_name=proc_name_only;
                            proc_name_only.erase(0,proc_name_only.find("::")+2);
                            mod_name.erase(mod_name.find("::"),mod_name.length()-mod_name.find("::"));
                            mod=get_module(mod_name,true);
                        }
                        if(mod) {
                            vector<c_procedure>::iterator i3;
                            for(i3=mod->r_procedures.begin(); i3!=mod->r_procedures.end(); ++i3) {
                                if(!(*i3).name_only.compare(proc_name_only)) {
                                    decl=(*i3).name;
                                    vector<c_rproc>::iterator i2;
                                    for(i2=(*i3).rproc.begin(); i2!=(*i3).rproc.end(); ++i2)
                                        if(!(*i2).remote_bot.compare((*i1)->botname)) {
                                            access=true;
                                            break;
                                        }
                                    break;
                                }
                            }
                        }
                        if(!mod) {
                            vector<c_var_base*>::iterator i2=args.begin();
                            while(i2!=args.end()) {
                                if(*i2)
                                    MY_DELETE(*i2);
                                args.erase(i2);
                                i2=args.begin();
                            }
                            var_keeper->set_current_session(SESSION_RESERVED_ID);
                            return true;
                        }
                        if(decl.empty()) {
                            map<string,c_function*>::iterator i3=mod->r_functions.functions.find(proc_name_only);
                            if(i3!=mod->r_functions.functions.end()) {
                                decl=(*i3).second->declaration;
                                vector<string>::iterator i2;
                                for(i2=(*i3).second->remote_bot_call.begin(); i2!=(*i3).second->remote_bot_call.end(); ++i2)
                                    if(!(*i2).compare((*i1)->botname)) {
                                        access=true;
                                        break;
                                    }
                            }
                        }
                        if(!decl.empty() && access)
                            mod->execute(decl,args,"Remote bot call");

                        vector<c_var_base*>::iterator i2=args.begin();
                        while(i2!=args.end()) {
                            args.erase(i2);
                            i2=args.begin();
                        }
                    }
                }
                var_keeper->set_current_session(SESSION_RESERVED_ID);
            }
            return true;
    }
    return false;
}

/*!
    \brief Writes information to log files about rejected replication
        of object, and triggers 'on_internal_event'
    \version 1
    \date 2008-02-26
    \author VooDooMan
    \param remote Remote bot descriptor
    \param cmd_to_send BOTNET command to send
    \param obj Name of object
    \param command Command code from remote bot
*/
MY_STATIC void botnet_log_replication_event_reject(const c_bot* remote, const c_bot_command* cmd_to_send, const string& obj, long command)
{
    ostringstream log;

    log << "I have rejected ";
    switch(command) {
        case CMD_CHECK_TIME_1:
            // remote bot sent PULL request
            log << "PULL request";
            break;
        case CMD_PUSH_1:
            // remote bot sent PUSH request
            log << "PUSH request";
            break;
        default:
            {
                MY_ASSERT_NOTREACH();
                return;
            }
    }
    log << " of object ";

    string obj_type;

    if(cmd_to_send->command_data.no_repl_1.user)
        log << (obj_type="(user)").c_str();
    if(cmd_to_send->command_data.no_repl_1.procedure)
        log << (obj_type="(procedure)").c_str();
    if(cmd_to_send->command_data.no_repl_1.function)
        log << (obj_type="(function)").c_str();
    if(cmd_to_send->command_data.no_repl_1.channel_def)
        log << (obj_type="(channel)").c_str();
    if(cmd_to_send->command_data.no_repl_1.prv)
        log << (obj_type="(private)").c_str();
    else
        log << " \"" << obj << "\"";

    string reason;
    int severity=PRIVATE_EVENT_SEVERITY_CODE_WARNING;

    log << ", reason: ";
    if(cmd_to_send->command_data.no_repl_1.reason==REASON_NO_REPL_1_UP_TO_DATE) {
        log << (reason="up to date").c_str();
        severity=PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL;
    }
    if(cmd_to_send->command_data.no_repl_1.reason==REASON_NO_REPL_1_ACCESS_DENIED)
        log << (reason="access denied").c_str();

    log_botnet(botnet_botname,remote->botname,log.str());
    log_botnet_debug(botnet_botname,remote->botname,-1,-1,log.str());

    logic_on_internal_event("@botnet_replication@",remote->botname,obj_type,obj,reason,severity,log.str(),"LOCAL");
}

/*!
    \brief Writes information to log files about replication
        of object, and triggers 'on_internal_event'
    \version 1
    \date 2008-02-26
    \author VooDooMan
    \param remote Remote bot descriptor
    \param requested_cmd BOTNET command that requestes replication
    \param obj Name of object
    \param obj_diff Diff in seconds of local and remote object
*/
MY_STATIC void botnet_log_replication_event_pull_request_sent(const c_bot* remote, const c_bot_command* requested_cmd, const string& obj, const MY_LONG_LONG& obj_diff)
{
    string obj_type="<OOPS BUG: INTERNAL ERROR, PLEASE REPORT THIS PROBLEM>";

    switch(requested_cmd->command) {
        case CMD_CHECK_TIME_1:
            if(requested_cmd->command_data.no_repl_1.user)
                obj_type="user";
            if(requested_cmd->command_data.no_repl_1.procedure)
                obj_type="procedure";
            if(requested_cmd->command_data.no_repl_1.function)
                obj_type="function";
            if(requested_cmd->command_data.no_repl_1.channel_def)
                obj_type="channel";
            if(requested_cmd->command_data.no_repl_1.prv)
                obj_type="private";
            break;

        case CMD_PUSH_1:
            if(requested_cmd->command_data.cmd_push_1.user)
                obj_type="user";
            if(requested_cmd->command_data.cmd_push_1.procedure)
                obj_type="procedure";
            if(requested_cmd->command_data.cmd_push_1.function)
                obj_type="function";
            if(requested_cmd->command_data.cmd_push_1.channel_def)
                obj_type="channel";
            if(requested_cmd->command_data.cmd_push_1.prv)
                obj_type="private";
            break;

        default:
            {
                MY_ASSERT_NOTREACH();
                return;
            }
    }

    {
        ostringstream log;
        log << "Remote bot is " << tos(remote->remote_time_diff);
        log << " second(s) in the future (negative value means it is in the past)";
        log_botnet(botnet_botname,remote->botname,log.str());
        log_botnet_debug(botnet_botname,remote->botname,-1,-1,log.str());
    }

    {
        ostringstream log;
        log << "Remote bot's (" << obj_type << ") \"" << obj << "\" is ";
        log << tos(obj_diff);
        log << " second(s) in the future (negative value means it is in the past)";
        log_botnet(botnet_botname,remote->botname,log.str());
        log_botnet_debug(botnet_botname,remote->botname,-1,-1,log.str());
    }

    {
        ostringstream log;
        log << "Replication: PULL of object (" << obj_type << ") \"";
        log << obj << "\"";
        log_botnet(botnet_botname,remote->botname,log.str());
        log_botnet_debug(botnet_botname,remote->botname,-1,-1,log.str());

        logic_on_internal_event("@botnet_replication@",remote->botname,obj_type,obj,"OK",PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,log.str(),"PULL_REQUEST");
    }
}

MY_STATIC bool botnet_cmd_switch_2(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_CHECK_TIME_1:
            {
                // remote is trying to PULL
                string obj=s_cmd->command_data.check_time_1.object_name;
                string remote=(*i1)->botname;
                if(s_cmd->command_data.check_time_1.user) {
                    c_user u;
                    bool got2=false;
                    if(logic_botnet_get_user(obj,u))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=u.replication.begin(); i2!=u.replication.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if(got2 && !got) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(u.last_changed,s_cmd->command_data.check_time_1.original_time,s_cmd->command_data.check_time_1.now,action);
                    if(got2 && (c_bot::E_REPL_SHOULD_PUSH==action || s_cmd->command_data.check_time_1.original_time==0)) {
                        botnet_push_user(*i1,u,obj_diff);
                    }
                    return true;
                }
                if(s_cmd->command_data.check_time_1.procedure) {
                    bool got_func=false;
                    {
                        c_function f;
                        if(logic_botnet_get_func(obj,f))
                            got_func=true;
                    }
                    c_procedure p;
                    bool got2=false;
                    if(logic_botnet_get_proc(obj,p))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=p.replication.begin(); i2!=p.replication.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if((got2 && !got) || got_func) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(p.last_changed,s_cmd->command_data.check_time_1.original_time,s_cmd->command_data.check_time_1.now,action);
                    if(got2 && (c_bot::E_REPL_SHOULD_PUSH==action || s_cmd->command_data.check_time_1.original_time==0)) {
                        botnet_push_proc(*i1,p,obj_diff);
                    }
                    return true;
                }
                if(s_cmd->command_data.check_time_1.function) {
                    bool got_proc=false;
                    {
                        c_procedure f;
                        if(logic_botnet_get_proc(obj,f))
                            got_proc=true;
                    }
                    c_function p;
                    bool got2=false;
                    if(logic_botnet_get_func(obj,p))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=p.replications.begin(); i2!=p.replications.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if((got2 && !got) || got_proc) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(p.last_changed,s_cmd->command_data.check_time_1.original_time,s_cmd->command_data.check_time_1.now,action);
                    if(got2 && (c_bot::E_REPL_SHOULD_PUSH==action || s_cmd->command_data.check_time_1.original_time==0)) {
                        botnet_push_func(*i1,p,obj_diff);
                    }
                    return true;
                }
                if(s_cmd->command_data.check_time_1.channel_def) {
                    c_channel_def chd;
                    bool got2=false;
                    if(logic_botnet_get_channel_def(obj,chd))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=chd.replication.begin(); i2!=chd.replication.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if(got2 && !got) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(chd.last_changed,s_cmd->command_data.check_time_1.original_time,s_cmd->command_data.check_time_1.now,action);
                    if(got2 && (c_bot::E_REPL_SHOULD_PUSH==action || s_cmd->command_data.check_time_1.original_time==0)) {
                        botnet_push_chan(*i1,chd,obj_diff);
                    } else {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);
                    }
                    return true;
                }
                if(s_cmd->command_data.check_time_1.prv) {
                    bool got=false;
                    vector<c_replication>::iterator i2;
                    for(i2=r_private.replication.begin(); i2!=r_private.replication.end(); ++i2)
                        if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                            got=true;
                            break;
                        }
                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);
                    if(!got) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(r_private.last_changed,s_cmd->command_data.check_time_1.original_time,s_cmd->command_data.check_time_1.now,action);
                    if((c_bot::E_REPL_SHOULD_PUSH==action || s_cmd->command_data.check_time_1.original_time==0)) {
                        botnet_push_prv(*i1,r_private,obj_diff);
                    } else {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);
                    }
                    return true;
                }
            }
            //return false;
            // invalid check time specification, e.g. no func, nor proc, nor user, nor chandef,... etc
            // so return 'false'
    }
    return false;
}

MY_STATIC bool botnet_cmd_switch_3(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_NO_REPL_1:
            {
                char* obj=MY_NEW char[sizeof(s_cmd->command_data.no_repl_1.object_name)+1];
                obj[sizeof(s_cmd->command_data.no_repl_1.object_name)]=0;
                memcpy(obj,s_cmd->command_data.no_repl_1.object_name,sizeof(s_cmd->command_data.no_repl_1.object_name));

                string d;
                if(0!=s_cmd->command_data.no_repl_1.repl_extension_2008_02_26) {
                    if(0==s_cmd->command_data.no_repl_1.repl_CMD_NO_REPL_1_rejected)
                        d="Remote bot rejected PULL replication of object ";
                    else
                        d="Remote bot rejected PUSH replication of object ";
                } else
                    d="Remote bot rejected replication of object ";

                string obj_type="?";

                if(s_cmd->command_data.no_repl_1.user) {
                    obj_type="user";
                    d+="(user) ";
                    (*i1)->rejected_objects.push_back((string)"USER "+obj);
                }
                if(s_cmd->command_data.no_repl_1.procedure) {
                    obj_type="procedure";
                    d+="(procedure) ";
                    (*i1)->rejected_objects.push_back((string)"PROC "+obj);
                }
                if(s_cmd->command_data.no_repl_1.function) {
                    obj_type="function";
                    d+="(function) ";
                    (*i1)->rejected_objects.push_back((string)"PROC "+obj);
                    // function is like procedure
                }
                if(s_cmd->command_data.no_repl_1.channel_def) {
                    obj_type="channel";
                    d+="(channel) ";
                    (*i1)->rejected_objects.push_back((string)"CHAN "+obj);
                }
                if(s_cmd->command_data.no_repl_1.prv) {
                    obj_type="private";
                    d+="(private)"; // no trailing SPACE!!!
                    (*i1)->rejected_objects.push_back("PRIV");
                }

                if(!s_cmd->command_data.no_repl_1.prv) {
                    d+="\"";
                    d+=obj;
                    d+="\"";
                }
                d+=", reason: ";
                if(s_cmd->command_data.no_repl_1.reason==REASON_NO_REPL_1_UP_TO_DATE)
                    d+="up to date";
                if(s_cmd->command_data.no_repl_1.reason==REASON_NO_REPL_1_ACCESS_DENIED)
                    d+="access denied";
                log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,d);
                log_botnet(botnet_botname,(*i1)->botname,d);

                {
                    string reason="<INTERNAL ERROR, PLEASE REPORT THIS PROBLEM>";
                    if(s_cmd->command_data.no_repl_1.reason==REASON_NO_REPL_1_UP_TO_DATE)
                        reason="up to date";
                    if(s_cmd->command_data.no_repl_1.reason==REASON_NO_REPL_1_ACCESS_DENIED)
                        reason="access denied";

                    logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_WARNING,d,"REMOTE");
                }

                MY_DELETE_A(obj);
            }
            return true;
        case CMD_PUSH_1:
            {
                // remote is trying to PUSH
                string obj=s_cmd->command_data.cmd_push_1.object_name;
                string remote=(*i1)->botname;
                if(s_cmd->command_data.cmd_push_1.user) {
                    c_user us;
                    bool got2=false;
                    if(logic_botnet_get_user(obj,us))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=us.replication.begin(); i2!=us.replication.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PULL || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if(got2 && !got) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(us.last_changed,s_cmd->command_data.cmd_push_1.original_time,s_cmd->command_data.cmd_push_1.now,action);
                    if(!got2) {
                        c_user bot;
                        logic_botnet_get_user((*i1)->botname,bot);
                        if(s_cmd->command_data.cmd_push_1.user && bot.access_to_plususer) {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_CHECK_TIME_1;
                            c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                            c->command_data.check_time_1.user=true;
                            char* user=c->command_data.cmd_push_1.object_name;
                            memset(user,0,sizeof(c->command_data.cmd_push_1.object_name));
                            strncpy(user,obj.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                            c->command_data.check_time_1.original_time=0;
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                            return true;
                        } else {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_NO_REPL_1;
                            c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                            c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                            c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                            c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                            c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                            c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                            memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                            return true;
                        }
                    } else
                    if(c_bot::E_REPL_SHOULD_PULL==action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_CHECK_TIME_1;
                        c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                        c->command_data.check_time_1.user=true;
                        char* user=c->command_data.cmd_push_1.object_name;
                        memset(user,0,sizeof(c->command_data.cmd_push_1.object_name));
                        strncpy(user,us.name.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                        c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(us.last_changed);
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                        return true;
                    }
                    if(c_bot::E_REPL_SHOULD_PULL!=action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;

                        c->command_data.no_repl_1.repl_extension_2008_02_26=1;
                        c->command_data.no_repl_1.repl_CMD_NO_REPL_1_rejected=1;

                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                }
                if(s_cmd->command_data.cmd_push_1.procedure) {
                    bool got_func=false;
                    {
                        c_function f;
                        if(logic_botnet_get_func(obj,f))
                            got_func=true;
                    }
                    c_procedure p;
                    bool got2=false;
                    if(logic_botnet_get_proc(obj,p))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=p.replication.begin(); i2!=p.replication.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PULL || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if((got2 && !got) || got_func) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(p.last_changed,s_cmd->command_data.cmd_push_1.original_time,s_cmd->command_data.cmd_push_1.now,action);
                    if(!got2) {
                        c_user bot;
                        logic_botnet_get_user((*i1)->botname,bot);
                        if(bot.access_to_plusproc) {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_CHECK_TIME_1;
                            c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                            c->command_data.check_time_1.procedure=true;
                            char* proc=c->command_data.cmd_push_1.object_name;
                            memset(proc,0,sizeof(c->command_data.cmd_push_1.object_name));
                            strncpy(proc,obj.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                            c->command_data.check_time_1.original_time=0;
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                            return true;
                        } else {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_NO_REPL_1;
                            c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                            c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                            c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                            c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                            c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                            c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                            memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                            return true;
                        }
                    } else
                    if(c_bot::E_REPL_SHOULD_PULL==action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_CHECK_TIME_1;
                        c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                        c->command_data.check_time_1.procedure=true;
                        char* proc=c->command_data.cmd_push_1.object_name;
                        memset(proc,0,sizeof(c->command_data.cmd_push_1.object_name));
                        strncpy(proc,p.name.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                        c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(p.last_changed);
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                        return true;
                    }
                    if(c_bot::E_REPL_SHOULD_PULL!=action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;

                        c->command_data.no_repl_1.repl_extension_2008_02_26=1;
                        c->command_data.no_repl_1.repl_CMD_NO_REPL_1_rejected=1;

                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                }
                if(s_cmd->command_data.cmd_push_1.function) {
                    bool got_proc=false;
                    {
                        c_procedure f;
                        if(logic_botnet_get_proc(obj,f))
                            got_proc=true;
                    }
                    c_function p;
                    bool got2=false;
                    if(logic_botnet_get_func(obj,p))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=p.replications.begin(); i2!=p.replications.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PULL || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if((got2 && !got) || got_proc) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(p.last_changed,s_cmd->command_data.cmd_push_1.original_time,s_cmd->command_data.cmd_push_1.now,action);
                    if(!got2) {
                        c_user bot;
                        logic_botnet_get_user((*i1)->botname,bot);
                        if(bot.access_to_plusproc) {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_CHECK_TIME_1;
                            c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                            c->command_data.check_time_1.function=true;
                            char* proc=c->command_data.cmd_push_1.object_name;
                            memset(proc,0,sizeof(c->command_data.cmd_push_1.object_name));
                            strncpy(proc,obj.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                            c->command_data.check_time_1.original_time=0;
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                            return true;
                        } else {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_NO_REPL_1;
                            c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                            c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                            c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                            c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                            c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                            c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                            memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                            return true;
                        }
                    } else
                    if(c_bot::E_REPL_SHOULD_PULL==action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_CHECK_TIME_1;
                        c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                        c->command_data.check_time_1.function=true;
                        char* proc=c->command_data.cmd_push_1.object_name;
                        memset(proc,0,sizeof(c->command_data.cmd_push_1.object_name));
                        strncpy(proc,p.declaration.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                        c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(p.last_changed);
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                        return true;
                    }
                    if(c_bot::E_REPL_SHOULD_PULL!=action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;

                        c->command_data.no_repl_1.repl_extension_2008_02_26=1;
                        c->command_data.no_repl_1.repl_CMD_NO_REPL_1_rejected=1;

                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                }
                if(s_cmd->command_data.cmd_push_1.channel_def) {
                    c_channel_def chd;
                    bool got2=false;
                    if(logic_botnet_get_channel_def(obj,chd))
                        got2=true;
                    bool got=false;
                    if(got2) {
                        vector<c_replication>::iterator i2;
                        for(i2=chd.replication.begin(); i2!=chd.replication.end(); ++i2)
                            if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PULL || (*i2).type==REPL_PUSHPULL)) {
                                got=true;
                                break;
                            }
                    }
                    if(got2 && !got) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(chd.last_changed,s_cmd->command_data.cmd_push_1.original_time,s_cmd->command_data.cmd_push_1.now,action);
                    if(!got2) {
                        c_user bot;
                        logic_botnet_get_user((*i1)->botname,bot);
                        vector<string>::iterator i2;
                        bool access=false;
                        for(i2=bot.access_grant_group.begin(); i2!=bot.access_grant_group.end(); ++i2) {
                            vector<string>::iterator i3;
                            for(i3=chd.groups.begin(); i3!=chd.groups.end(); ++i3) {
                                if(!(*i2).compare(*i3) || (*i2).compare("*")) {
                                    access=true;
                                    break;
                                }
                            }
                            if(access)
                                break;
                        }
                        if(access) {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_CHECK_TIME_1;
                            c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                            c->command_data.check_time_1.channel_def=true;
                            char* user=c->command_data.cmd_push_1.object_name;
                            memset(user,0,sizeof(c->command_data.cmd_push_1.object_name));
                            strncpy(user,obj.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                            c->command_data.check_time_1.original_time=0;
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                            return true;
                        } else {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_NO_REPL_1;
                            c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                            c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                            c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                            c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                            c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                            c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                            memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                            return true;
                        }
                    } else
                    if(c_bot::E_REPL_SHOULD_PULL==action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_CHECK_TIME_1;
                        c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                        c->command_data.check_time_1.channel_def=true;
                        char* chan=c->command_data.cmd_push_1.object_name;
                        memset(chan,0,sizeof(c->command_data.cmd_push_1.object_name));
                        strncpy(chan,chd.channel_name.c_str(),sizeof(c->command_data.check_time_1.object_name)-1);
                        c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(chd.last_changed);
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                        return true;
                    }
                    if(c_bot::E_REPL_SHOULD_PULL!=action) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.cmd_push_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.cmd_push_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.cmd_push_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.cmd_push_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;

                        c->command_data.no_repl_1.repl_extension_2008_02_26=1;
                        c->command_data.no_repl_1.repl_CMD_NO_REPL_1_rejected=1;

                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                }
                if(s_cmd->command_data.cmd_push_1.prv) {
                    bool got=false;
                    vector<c_replication>::iterator i2;
                    for(i2=r_private.replication.begin(); i2!=r_private.replication.end(); ++i2)
                        if(!(*i2).partner.compare(remote) && ((*i2).type==REPL_PULL || (*i2).type==REPL_PUSHPULL)) {
                            got=true;
                            break;
                        }
                    if(!got) {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.no_repl_1.user=s_cmd->command_data.check_time_1.user;
                        c->command_data.no_repl_1.procedure=s_cmd->command_data.check_time_1.procedure;
                        c->command_data.no_repl_1.function=s_cmd->command_data.check_time_1.function;
                        c->command_data.no_repl_1.channel_def=s_cmd->command_data.check_time_1.channel_def;
                        c->command_data.no_repl_1.prv=s_cmd->command_data.check_time_1.prv;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.check_time_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                    my_time_t now;
                    my_time(&now);
                    c_bot::e_action action;
                    MY_LONG_LONG obj_diff=(*i1)->botnet_obj_difftime(r_private.last_changed,s_cmd->command_data.cmd_push_1.original_time,s_cmd->command_data.cmd_push_1.now,action);

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    if(s_cmd->command_data.cmd_push_1.prv && bot.access_to_private) {
                        if(c_bot::E_REPL_SHOULD_PULL==action) {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_CHECK_TIME_1;
                            c->command_data.check_time_1.now=static_cast<my_botnet_time_t>(my_time(NULL));
                            c->command_data.check_time_1.prv=true;
                            c->command_data.check_time_1.original_time=static_cast<my_botnet_time_t>(r_private.last_changed);
                            botnet_send_command(*i1,c);

                            (*i1)->prv_pulling=true;

                            botnet_log_replication_event_pull_request_sent(*i1,s_cmd,obj,obj_diff);

                            return true;
                        }
                        if(c_bot::E_REPL_SHOULD_PULL!=action) {
                            auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                            c_bot_command* c=cp.get();
                            c->hard_clear();
                            c->packet_type=PACKET_TYPE_COMMAND;
                            c->size=sizeof(c);
                            c->version=1;
                            c->command=CMD_NO_REPL_1;
                            c->command_data.check_time_1.user=false;
                            c->command_data.no_repl_1.procedure=false;
                            c->command_data.no_repl_1.function=false;
                            c->command_data.no_repl_1.channel_def=false;
                            c->command_data.no_repl_1.prv=true;
                            c->command_data.no_repl_1.reason=REASON_NO_REPL_1_UP_TO_DATE;

                            c->command_data.no_repl_1.repl_extension_2008_02_26=1;
                            c->command_data.no_repl_1.repl_CMD_NO_REPL_1_rejected=1;

                            memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                            botnet_send_command(*i1,c);

                            botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                            return true;
                        }
                    } else {
                        auto_ptr<c_bot_command> cp(MY_NEW c_bot_command);
                        c_bot_command* c=cp.get();
                        c->hard_clear();
                        c->packet_type=PACKET_TYPE_COMMAND;
                        c->size=sizeof(c);
                        c->version=1;
                        c->command=CMD_NO_REPL_1;
                        c->command_data.check_time_1.user=false;
                        c->command_data.no_repl_1.procedure=false;
                        c->command_data.no_repl_1.function=false;
                        c->command_data.no_repl_1.channel_def=false;
                        c->command_data.no_repl_1.prv=true;
                        c->command_data.no_repl_1.reason=REASON_NO_REPL_1_ACCESS_DENIED;
                        memcpy(c->command_data.no_repl_1.object_name,s_cmd->command_data.cmd_push_1.object_name,sizeof(c->command_data.no_repl_1.object_name));
                        botnet_send_command(*i1,c);

                        botnet_log_replication_event_reject(*i1,c,obj,s_cmd->command);

                        return true;
                    }
                }
            }
            return true;
    }
    return false;
}

MY_STATIC bool botnet_cmd_switch_4(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_REPL_USER_01_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_01_1.name);
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_01_1.name,n_size);
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    multimap<string,pair<string,string> >::iterator i2;
                    for(;;) {
                        i2=(*i1)->chans_groups.find(name);
                        if(i2!=(*i1)->chans_groups.end())
                            (*i1)->chans_groups.erase(i2);
                        else
                            break;
                    }
                }

                {
                again_erase_1:
                    vector<c_user_to_pull>::iterator i2;
                    for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                        if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                            (*i1)->pulling_users.erase(i2);
                            goto again_erase_1;
                        }
                    }

                    bool got=false;
                    deque<c_user>* ru=NULL;
                    for(int iii=0; iii<3; ++iii) {
                        if(0==iii)
                            ru=&r_users;
                        else if(1==iii)
                            ru=&r_terminators;
                        else
                            ru=&r_user_templates;
                        deque<c_user>::iterator i3;
                        for(i3=ru->begin(); i3!=ru->end(); ++i3) {
                            if(!(*i3).name.compare(name)) {
                                got=true;
                                vector<c_replication>::iterator i4;
                                for(i4=(*i3).replication.begin(); i4!=(*i3).replication.end(); ++i4) {
                                    if(!(*i4).partner.compare((*i1)->botname) && ((*i4).type==REPL_PULL || (*i4).type==REPL_PUSHPULL)) {
                                        c_user_to_pull u;
                                        u.botname=(*i1)->botname;
                                        u.user=*i3;
                                        (*i1)->pulling_users.push_back(u);
                                        got=true;
                                        break;
                                    }
                                }
                                if(got)
                                    break;
                            }
                        }
                        if(got)
                            break;
                    }
                    if(!got) {
                        c_user_to_pull u;
                        u.botname=(*i1)->botname;
                        u.user.name=name;
                        u.user.replication_partner=false;
                        u.user.meta.clear();

                        // we got a new user, so set them replication flags
                        c_replication r;
                        r.partner=(*i1)->botname;
                        r.type=REPL_PULL;
                        u.user.replication.push_back(r);

                        (*i1)->pulling_users.push_back(u);
                    }
                }

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    (*i2).user.host_unknown=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.host_unknown);
                    (*i2).user.host_bot=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.host_bot);
                    (*i2).user.is_template=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.is_template);
                    (*i2).user.terminator=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.terminator);
                    (*i2).user.access_grant_partyline=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_partyline);
                    (*i2).user.access_to_backup=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_backup);
                    (*i2).user.access_grant_backup=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_backup);
                    (*i2).user.access_to_rehash=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_rehash);
                    (*i2).user.access_grant_rehash=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_rehash);
                    (*i2).user.access_to_partyline=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_partyline);
                    (*i2).user.access_grant_partyline=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_partyline);

                    (*i2).user.access_to_plususer=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_plususer);
                    (*i2).user.access_grant_plususer=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_plususer);
                    (*i2).user.access_to_plusproc=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_plusproc);
                    (*i2).user.access_grant_plusproc=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_plusproc);

                    (*i2).user.access_to_can_send_all_users=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_can_send_all_users);
                    (*i2).user.access_grant_can_send_all_users=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_can_send_all_users);

                    (*i2).user.access_to_can_send_unknown_users=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_to_can_send_unknown_users);
                    (*i2).user.access_grant_can_send_unknown_users=TO_BOOL(s_cmd->command_data.cmd_repl_user_01_1.access_grant_can_send_unknown_users);

                    (*i2).user.last_changed=s_cmd->command_data.cmd_repl_user_01_1.last_changed;
                    (*i1)->adjust_timestamp((*i2).user.last_changed);

                    (*i2).user.hostmask.clear();
                    (*i2).user.fullname.clear();
                    (*i2).user.access_to_group.clear();
                    (*i2).user.access_to_proc.clear();
                    (*i2).user.access_grant_procedure.clear();
                    (*i2).user.access_grant_group.clear();
                    (*i2).user.access_to_channel.clear();
                    (*i2).user.access_grant_channel.clear();
                    (*i2).user.groups.clear();
                    (*i2).user.dcc_hosts.clear();

                    (*i2).user.partyline_msg_flood.lines=s_cmd->command_data.cmd_repl_user_01_1.partyline_msg_flood.lines;
                    (*i2).user.partyline_msg_flood.seconds=s_cmd->command_data.cmd_repl_user_01_1.partyline_msg_flood.seconds;
                }
            }
            return true;
        case CMD_REPL_USER_01B_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_01B_1.name);
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_01B_1.name,n_size);
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    multimap<string,pair<string,string> >::iterator i2;
                    for(;;) {
                        i2=(*i1)->chans_groups.find(name);
                        if(i2!=(*i1)->chans_groups.end())
                            (*i1)->chans_groups.erase(i2);
                        else
                            break;
                    }
                }

                {
                    bool got=false;
                    deque<c_user>* ru=NULL;
                    for(int iii=0; iii<3; ++iii) {
                        if(0==iii)
                            ru=&r_users;
                        else if(1==iii)
                            ru=&r_terminators;
                        else
                            ru=&r_user_templates;
                        deque<c_user>::iterator i3;
                        for(i3=ru->begin(); i3!=ru->end(); ++i3) {
                            if(!(*i3).name.compare(name)) {
                                got=true;
                                vector<c_replication>::iterator i4;
                                for(i4=(*i3).replication.begin(); i4!=(*i3).replication.end(); ++i4) {
                                    if(!(*i4).partner.compare((*i1)->botname) && ((*i4).type==REPL_PULL || (*i4).type==REPL_PUSHPULL)) {
                                        c_user_to_pull u;
                                        u.botname=(*i1)->botname;
                                        u.user=*i3;
                                        (*i1)->pulling_users.push_back(u);
                                        got=true;
                                        break;
                                    }
                                }
                                if(got)
                                    break;
                            }
                        }
                        if(got)
                            break;
                    }
                    if(!got) {
                        c_user_to_pull u;
                        u.botname=(*i1)->botname;
                        u.user.name=name;
                        u.user.replication_partner=false;
                        u.user.meta.clear();

                        // we got a new user, so set them replication flags
                        c_replication r;
                        r.partner=(*i1)->botname;
                        r.type=REPL_PULL;
                        u.user.replication.push_back(r);

                        (*i1)->pulling_users.push_back(u);
                    }
                }

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    (*i2).user.access_to_restart=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_to_restart);
                    (*i2).user.access_grant_restart=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_grant_restart);
                    (*i2).user.access_to_die=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_to_die);
                    (*i2).user.access_grant_die=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_grant_die);
                    (*i2).user.access_to_replication=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_to_replication);
                    (*i2).user.access_grant_replication=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_grant_replication);
                    (*i2).user.access_to_filesystem=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_to_filesystem);
                    (*i2).user.access_grant_filesystem=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_grant_filesystem);
                    (*i2).user.access_to_private=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_to_private);
                    (*i2).user.access_grant_private=TO_BOOL(s_cmd->command_data.cmd_repl_user_01B_1.access_grant_private);
                }
            }
            return true;
        case CMD_REPL_USER_02_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_02_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_02_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_02_1.hostmask); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_02_1.hostmask,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    (*i2).user.hostmask.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_03_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_03_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_03_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_03_1.fullname); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_03_1.fullname,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    (*i2).user.fullname.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_04_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_04_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_04_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_04_1.access_to_group); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_04_1.access_to_group,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    (*i2).user.access_to_group.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_06_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_06_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_06_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_06_1.access_grant_proc); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_06_1.access_grant_proc,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    (*i2).user.access_grant_procedure.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_07_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_07_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_07_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_07_1.access_grant_group); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_07_1.access_grant_group,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    (*i2).user.access_grant_group.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_10_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_10_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_10_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_10_1.group); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_10_1.group,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);

                    (*i2).user.groups.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_11_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_11_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_11_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_11_1.dcc_host); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_11_1.dcc_host,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);

                    c_dcc_host h;
                    h.host=data;
                    h.group=s_cmd->command_data.cmd_repl_user_11_1.dcc_group;
                    (*i2).user.dcc_hosts.push_back(h);
                }
            }
            return true;
        case CMD_REPL_USER_11B_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_11B_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_11B_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    string chan;
                    string group;
                    {
                        int d_size=sizeof(s_cmd->command_data.cmd_repl_user_11B_1.channel); // !!!
                        char* d=MY_NEW char[d_size+1];
                        memset(d,0,d_size+1);
                        memcpy(d,s_cmd->command_data.cmd_repl_user_11B_1.channel,d_size); // !!!
                        string data=d;
                        MY_DELETE_A(d);
                        d=NULL;

                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);

                        chan=data;
                    }
                    {
                        int d_size=sizeof(s_cmd->command_data.cmd_repl_user_11B_1.group); // !!!
                        char* d=MY_NEW char[d_size+1];
                        memset(d,0,d_size+1);
                        memcpy(d,s_cmd->command_data.cmd_repl_user_11B_1.group,d_size); // !!!
                        string data=d;
                        MY_DELETE_A(d);
                        d=NULL;

                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);

                        group=data;
                    }

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    if(botnet_has_access_usage_group(group,bot,(string)"PULLing user \""+(*i2).user.name+"\""))
                        (*i1)->chans_groups.insert(make_pair(name,make_pair(chan,group)));
                }
            }
            return true;
    }
    return false;
}

MY_STATIC bool botnet_cmd_switch_5(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_REPL_USER_12_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_12_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_12_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    vector<string> new_groups_chan;
                    {
                        map<string,string> vars;
                        string chan;
                        {
                            int n_size=sizeof(s_cmd->command_data.cmd_repl_user_12_1.channel); // !!!
                            char* n=MY_NEW char[n_size+1];
                            memset(n,0,n_size+1);
                            memcpy(n,s_cmd->command_data.cmd_repl_user_12_1.channel,n_size); // !!!

                            chan=n;
                            MY_DELETE_A(n);
                            n=NULL;

                            if(chan.length() && chan[0]=='"')
                                chan.erase(0,1);
                            if(chan.length() && chan[chan.length()-1]=='"')
                                chan.erase(chan.length()-1,1);
                        }
                        {
                            multimap<string,pair<string,string> >::iterator i3;
                            for(i3=(*i1)->chans_groups.begin(); i3!=(*i1)->chans_groups.end(); ++i3) {
                                if((*i3).first.compare(name))
                                    continue;
                                if((*i3).second.first.compare(chan))
                                    continue;
                                bool access=false;
                                vector<string>::iterator i2;
                                for(i2=bot.access_grant_group.begin(); i2!=bot.access_grant_group.end(); ++i2) {
                                    if(!(*i3).second.second.compare(*i2) || !(*i2).compare("*")) {
                                        access=true;
                                        break;
                                    }
                                }
                                if(access) {
                                    new_groups_chan.push_back((*i3).second.second);
                                } else {
                                    string d="I have partially rejected replication of object ";
                                    d+="(user) ";
                                    d+=s_cmd->command_data.cmd_repl_user_12_1.name;
                                    d+=", sub-object=channel: ";
                                    d+=s_cmd->command_data.cmd_repl_user_12_1.channel;
                                    d+=", member_of_group: ";
                                    d+=(*i3).second.second;
                                    d+=", reason: Remote bot doesn't have privilege access_grant_group";
                                    log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,d);
                                    log_botnet(botnet_botname,(*i1)->botname,d);
                                    {
                                        string obj_type="user";
                                        string obj=s_cmd->command_data.cmd_repl_user_12_1.name;
                                        string reason="not have: access_grant_group";

                                        logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_WARNING,d,"LOCAL");
                                    }
                                }
                            }
                        }
                    }

                    c_channel ch;
                    ch.username=s_cmd->command_data.cmd_repl_user_12_1.name;
                    ch.channel_name=s_cmd->command_data.cmd_repl_user_12_1.channel;

                    ch.groups=new_groups_chan;

                    {
                        string data=ch.channel_name;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        ch.channel_name=data;
                    }

                    ch.host_unknown=(*i2).user.host_unknown;
                    {
                        c_user old_user;
                        vector<c_channel> old_channels;
                        if(!(*i2).user.is_template) {
                            if(!(*i2).user.terminator)
                                logic_partyline_get_user((*i2).user.name,old_user,old_channels);
                            else
                                logic_partyline_get_user((*i2).user.name,old_user,old_channels);
                        } else {
                            logic_partyline_get_user_template((*i2).user.name,old_user,old_channels);
                        }
                        c_channel old_channel;
                        old_channel.clear();
                        vector<c_channel>::iterator i2;
                        for(i2=old_channels.begin(); i2!=old_channels.end(); ++i2)
                            if(!(*i2).channel_name.compare(ch.channel_name)) {
                                old_channel=*i2;
                                break;
                            }

                        ch.on_deop=old_channel.on_deop;
                        if(botnet_has_grant(bot,old_channel.on_deop) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_deop))
                            ch.on_deop=s_cmd->command_data.cmd_repl_user_12_1.on_deop;

                        ch.on_ban=old_channel.on_ban;
                        if(botnet_has_grant(bot,old_channel.on_ban) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_ban))
                            ch.on_ban=s_cmd->command_data.cmd_repl_user_12_1.on_ban;

                        ch.on_unban=old_channel.on_unban;
                        if(botnet_has_grant(bot,old_channel.on_unban) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_unban))
                            ch.on_unban=s_cmd->command_data.cmd_repl_user_12_1.on_unban;

                        ch.on_kick=old_channel.on_kick;
                        if(botnet_has_grant(bot,old_channel.on_kick) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_kick))
                            ch.on_kick=s_cmd->command_data.cmd_repl_user_12_1.on_kick;

                        ch.on_op=old_channel.on_op;
                        if(botnet_has_grant(bot,old_channel.on_op) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_op))
                            ch.on_op=s_cmd->command_data.cmd_repl_user_12_1.on_op;

                        ch.on_voice=old_channel.on_voice;
                        if(botnet_has_grant(bot,old_channel.on_voice) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_voice))
                            ch.on_voice=s_cmd->command_data.cmd_repl_user_12_1.on_voice;

                        ch.on_devoice=old_channel.on_devoice;
                        if(botnet_has_grant(bot,old_channel.on_devoice) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_devoice))
                            ch.on_devoice=s_cmd->command_data.cmd_repl_user_12_1.on_devoice;

                        ch.on_join=old_channel.on_join;
                        if(botnet_has_grant(bot,old_channel.on_join) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_join))
                            ch.on_join=s_cmd->command_data.cmd_repl_user_12_1.on_join;

                        ch.on_banned=old_channel.on_banned;
                        if(botnet_has_grant(bot,old_channel.on_banned) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_banned))
                            ch.on_banned=s_cmd->command_data.cmd_repl_user_12_1.on_banned;

                        ch.on_flood=old_channel.on_flood;
                        if(botnet_has_grant(bot,old_channel.on_flood) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_flood))
                            ch.on_flood=s_cmd->command_data.cmd_repl_user_12_1.on_flood;

                        ch.on_privmsg=old_channel.on_privmsg;
                        if(botnet_has_grant(bot,old_channel.on_privmsg) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_privmsg))
                            ch.on_privmsg=s_cmd->command_data.cmd_repl_user_12_1.on_privmsg;

                        ch.on_notice=old_channel.on_notice;
                        if(botnet_has_grant(bot,old_channel.on_notice) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_notice))
                            ch.on_notice=s_cmd->command_data.cmd_repl_user_12_1.on_notice;

                        ch.on_except=old_channel.on_except;
                        if(botnet_has_grant(bot,old_channel.on_except) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_except))
                            ch.on_except=s_cmd->command_data.cmd_repl_user_12_1.on_except;

                        ch.on_unexcept=old_channel.on_unexcept;
                        if(botnet_has_grant(bot,old_channel.on_unexcept) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_unexcept))
                            ch.on_unexcept=s_cmd->command_data.cmd_repl_user_12_1.on_unexcept;

                        ch.on_invite=old_channel.on_invite;
                        if(botnet_has_grant(bot,old_channel.on_invite) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_invite))
                            ch.on_invite=s_cmd->command_data.cmd_repl_user_12_1.on_invite;

                        ch.on_uninvite=old_channel.on_uninvite;
                        if(botnet_has_grant(bot,old_channel.on_uninvite) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_uninvite))
                            ch.on_uninvite=s_cmd->command_data.cmd_repl_user_12_1.on_uninvite;

                        ch.on_not_invited=old_channel.on_not_invited;
                        if(botnet_has_grant(bot,old_channel.on_not_invited) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_not_invited))
                            ch.on_not_invited=s_cmd->command_data.cmd_repl_user_12_1.on_not_invited;

                        ch.on_not_in_reop=old_channel.on_not_in_reop;
                        if(botnet_has_grant(bot,old_channel.on_not_in_reop) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_not_in_reop))
                            ch.on_not_in_reop=s_cmd->command_data.cmd_repl_user_12_1.on_not_in_reop;

                        ch.on_reop=old_channel.on_reop;
                        if(botnet_has_grant(bot,old_channel.on_reop) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_reop))
                            ch.on_reop=s_cmd->command_data.cmd_repl_user_12_1.on_reop;

                        ch.on_other_mode=old_channel.on_other_mode;
                        if(botnet_has_grant(bot,old_channel.on_other_mode) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_other_mode))
                            ch.on_other_mode=s_cmd->command_data.cmd_repl_user_12_1.on_other_mode;

                        ch.on_other_mode_mask=old_channel.on_other_mode_mask;
                        if(botnet_has_grant(bot,old_channel.on_other_mode_mask) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_user_12_1.on_other_mode_mask))
                            ch.on_other_mode_mask=s_cmd->command_data.cmd_repl_user_12_1.on_other_mode_mask;

                        ch.can_send_unknown_users=old_channel.can_send_unknown_users;
                        if(bot.access_grant_can_send_unknown_users)
                            ch.can_send_unknown_users=TO_BOOL(s_cmd->command_data.cmd_repl_user_12_1.can_send_unknown_users);
                    }

                    ch.msg_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.msg_flood_l;
                    ch.msg_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.msg_flood_s;

                    ch.notice_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.notice_flood_l;
                    ch.notice_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.notice_flood_s;

                    ch.repeat_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.repeat_flood_l;
                    ch.repeat_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.repeat_flood_s;

                    ch.nick_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.nick_flood_l;
                    ch.nick_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.nick_flood_s;

                    ch.join_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.join_flood_l;
                    ch.join_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.join_flood_s;

                    ch.mode_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.mode_flood_l;
                    ch.mode_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.mode_flood_s;

                    ch.ctcp_flood.lines=s_cmd->command_data.cmd_repl_user_12_1.ctcp_flood_l;
                    ch.ctcp_flood.seconds=s_cmd->command_data.cmd_repl_user_12_1.ctcp_flood_s;

                    ch.dynamic_plus_modes=s_cmd->command_data.cmd_repl_user_12_1.dynamic_plus_modes;
                    ch.dynamic_minus_modes=s_cmd->command_data.cmd_repl_user_12_1.dynamic_minus_modes;

                    {
                        c_user u2;
                        if(!logic_botnet_get_user((*i2).user.name,u2)) {
                            u2.access_to_backup=false;
                            u2.access_grant_backup=false;
                            u2.access_to_rehash=false;
                            u2.access_grant_rehash=false;
                            u2.access_to_plususer=false;
                            u2.access_grant_plususer=false;
                            u2.access_to_plusproc=false;
                            u2.access_grant_plusproc=false;
                        }
                        if(!bot.access_grant_backup) {
                            (*i2).user.access_to_backup=u2.access_to_backup;
                            (*i2).user.access_grant_backup=u2.access_grant_backup;
                        }
                        if(!bot.access_grant_rehash) {
                            (*i2).user.access_to_rehash=u2.access_to_rehash;
                            (*i2).user.access_grant_rehash=u2.access_grant_rehash;
                        }
                        if(!bot.access_grant_plususer) {
                            (*i2).user.access_to_plususer=u2.access_to_plususer;
                            (*i2).user.access_grant_plususer=u2.access_grant_plususer;
                        }
                        if(!bot.access_grant_plusproc) {
                            (*i2).user.access_to_plusproc=u2.access_to_plusproc;
                            (*i2).user.access_grant_plusproc=u2.access_grant_plusproc;
                        }
                    }

                    bool got2=false;
                    {
                        c_user us;
                        if(logic_botnet_get_user((*i2).user.name,us))
                            got2=true;
                    }

                    if(got2 || (!got2 && bot.access_to_plususer)) {
                erase_again:
                        vector<c_channel>* rc=NULL;
                        for(int iii=0; iii<3; ++iii) {
                            if(0==iii)
                                rc=&r_channels;
                            else if(1==iii)
                                rc=&r_channel_terminators;
                            else
                                rc=&r_channel_templates;
                            vector<c_channel>::iterator i3;
                            for(i3=rc->begin(); i3!=rc->end(); ++i3) {
                                if(!(*i3).username.compare(ch.username) && !(*i3).channel_name.compare(ch.channel_name)) {
                                    rc->erase(i3);
                                    goto erase_again;
                                }
                            }
                        }

                        if(!(*i2).user.is_template) {
                            ch.terminator=(*i2).user.terminator;
                            ch.configured=true;
                            (*i2).chans.push_back(ch);
                        } else {
                            ch.is_template=true;
                            ch.configured=true;
                            (*i2).chans.push_back(ch);
                        }
                    }
                }
            }
            return true;
        case CMD_REPL_USER_13_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_13_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_13_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                string chname;
                {
                    chname=s_cmd->command_data.cmd_repl_user_13_1.channel;
                    string data=chname;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    chname=data;
                }

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    bool got_ch=false;
                    vector<c_channel>::iterator i3;
                    vector<c_channel>* rc=NULL;
                    for(int iii=0; iii<3; ++iii) {
                        if(0==iii)
                            rc=&r_channels;
                        else if(1==iii)
                            rc=&r_channel_terminators;
                        else
                            rc=&r_channel_templates;
                        for(i3=rc->begin(); i3!=rc->end(); ++i3) {
                            if(!(*i3).username.compare((*i2).user.name) && !(*i3).channel_name.compare(chname)) {
                                got_ch=true;
                                break;
                            }
                        }
                        if(got_ch)
                            break;
                    }

                    if(got_ch) {
                        int g_size=sizeof(s_cmd->command_data.cmd_repl_user_13_1.group); // !!!
                        char* g=MY_NEW char[g_size+1];
                        memset(g,0,g_size+1);
                        memcpy(g,s_cmd->command_data.cmd_repl_user_13_1.group,g_size); // !!!
                        string group=g;
                        MY_DELETE_A(g);
                        g=NULL;

                        int pm_size=sizeof(s_cmd->command_data.cmd_repl_user_13_1.plus_modes); // !!!
                        char* pm=MY_NEW char[pm_size+1];
                        memset(pm,0,pm_size+1);
                        memcpy(pm,s_cmd->command_data.cmd_repl_user_13_1.plus_modes,pm_size); // !!!
                        string plus_modes=pm;
                        MY_DELETE_A(pm);
                        pm=NULL;

                        int mm_size=sizeof(s_cmd->command_data.cmd_repl_user_13_1.minus_modes); // !!!
                        char* mm=MY_NEW char[mm_size+1];
                        memset(mm,0,mm_size+1);
                        memcpy(mm,s_cmd->command_data.cmd_repl_user_13_1.minus_modes,mm_size); // !!!
                        string minus_modes=mm;
                        MY_DELETE_A(mm);
                        mm=NULL;

                        {
                            string data=group;
                            if(data.length() && data[0]=='"')
                                data.erase(0,1);
                            if(data.length() && data[data.length()-1]=='"')
                                data.erase(data.length()-1,1);
                            group=data;
                        }
                        {
                            string data=plus_modes;
                            if(data.length() && data[0]=='"')
                                data.erase(0,1);
                            if(data.length() && data[data.length()-1]=='"')
                                data.erase(data.length()-1,1);
                            plus_modes=data;
                        }
                        {
                            string data=minus_modes;
                            if(data.length() && data[0]=='"')
                                data.erase(0,1);
                            if(data.length() && data[data.length()-1]=='"')
                                data.erase(data.length()-1,1);
                            minus_modes=data;
                        }

                        c_dynamic_rule r;
                        r.group=group;
                        r.plus_modes=plus_modes;
                        r.minus_modes=minus_modes;

                        c_user bot;
                        logic_botnet_get_user((*i1)->botname,bot);

                        if(botnet_has_access_usage_group(r.group,bot,(string)"PULLing user \""+(*i2).user.name+"\""))
                            (*i3).allow_dynamic.push_back(r);
                    }
                }
            }
            return true;
        case CMD_REPL_USER_14_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_14_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_14_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    pair<string,string> p;
                    p.first=s_cmd->command_data.cmd_repl_user_14_1.meta_key;
                    p.second=s_cmd->command_data.cmd_repl_user_14_1.meta_val;
                    {
                        string data=p.first;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        p.first=data;
                    }
                    {
                        string data=p.second;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        p.second=data;
                    }
                    (*i2).user.meta.insert(p);
                }
            }
            return true;
    }
    return false;
}

MY_STATIC bool botnet_cmd_switch_6(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_REPL_USER_15_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_15_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_15_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_user_15_1.access_usage_proc); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_user_15_1.access_usage_proc,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    {
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                    }

                    (*i2).user.access_usage_procedure.push_back(data);
                }
            }
            return true;
        case CMD_REPL_USER_16_5:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_16_5.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_16_5.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    (*i2).user.access_to_upgrade=TO_BOOL(s_cmd->command_data.cmd_repl_user_16_5.access_to_upgrade);
                    (*i2).user.access_grant_upgrade=TO_BOOL(s_cmd->command_data.cmd_repl_user_16_5.access_grant_upgrade);
                }
            }
            return true;
        case CMD_REPL_USER_17_9:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_17_9.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_17_9.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    (*i2).user.access_to_apply=TO_BOOL(s_cmd->command_data.cmd_repl_user_17_9.access_to_apply);
                    (*i2).user.access_grant_apply=TO_BOOL(s_cmd->command_data.cmd_repl_user_17_9.access_grant_apply);
                }
            }
            return true;
        case CMD_REPL_USER_99_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_user_99_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_user_99_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;
                {
                    auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                    c_bot_control* c=cp.get();
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_PING;
                    botnet_send_control(*i1,c);
                    (*i1)->next_ping=my_time(NULL)+BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                    (*i1)->start_awaiting_pong=my_time(NULL);

                    string obj=(string)"USER "+name;
                    vector<c_bot*>::iterator i2;
                again_1:
                    for(i2=bots->begin(); i2!=bots->end(); ++i2) {
                        vector<string>::iterator i3;
                        for(i3=(*i2)->rejected_objects.begin(); i3!=(*i2)->rejected_objects.end(); ++i3) {
                            if(!(*i3).compare(obj)) {
                                (*i2)->rejected_objects.erase(i3);
                                goto again_1;
                            }
                        }
                    }
                }

                bool got=false;
                vector<c_user_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_users.begin(); i2!=(*i1)->pulling_users.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).user.name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);
                    if(bot.name.compare((*i2).user.name)) {
                        // it is not me!
                        // ... so clear host_bot flag
                        (*i2).user.host_bot=false;
                    }

                    {
                        c_user u2;
                        if(!logic_botnet_get_user((*i2).user.name,u2)) {
                            u2.access_to_backup=false;
                            u2.access_grant_backup=false;
                            u2.access_to_can_send_all_users=false;
                            u2.access_grant_can_send_all_users=false;
                            u2.access_to_can_send_unknown_users=false;
                            u2.access_grant_can_send_unknown_users=false;
                            u2.access_to_die=false;
                            u2.access_grant_die=false;
                            u2.access_to_filesystem=false;
                            u2.access_grant_filesystem=false;
                            u2.access_to_partyline=false;
                            u2.access_grant_partyline=false;
                            u2.access_to_plusproc=false;
                            u2.access_grant_plusproc=false;
                            u2.access_to_plususer=false;
                            u2.access_grant_plususer=false;
                            u2.access_to_private=false;
                            u2.access_grant_private=false;
                            u2.access_to_rehash=false;
                            u2.access_grant_rehash=false;
                            u2.access_to_replication=false;
                            u2.access_grant_replication=false;
                            u2.access_to_restart=false;
                            u2.access_grant_restart=false;
                            u2.access_to_upgrade=false;
                            u2.access_grant_upgrade=false;
                            u2.access_to_apply=false;
                            u2.access_grant_apply=false;
                        }
                        if(!bot.access_grant_backup) {
                            (*i2).user.access_to_backup=u2.access_to_backup;
                            (*i2).user.access_grant_backup=u2.access_grant_backup;
                        }
                        if(!bot.access_grant_can_send_all_users) {
                            (*i2).user.access_to_can_send_all_users=u2.access_to_can_send_all_users;
                            (*i2).user.access_grant_can_send_all_users=u2.access_grant_can_send_all_users;
                        }
                        if(!bot.access_grant_can_send_unknown_users) {
                            (*i2).user.access_to_can_send_unknown_users=u2.access_to_can_send_unknown_users;
                            (*i2).user.access_grant_can_send_unknown_users=u2.access_grant_can_send_unknown_users;
                        }
                        if(!bot.access_grant_die) {
                            (*i2).user.access_to_die=u2.access_to_die;
                            (*i2).user.access_grant_die=u2.access_grant_die;
                        }
                        if(!bot.access_grant_filesystem) {
                            (*i2).user.access_to_filesystem=u2.access_to_filesystem;
                            (*i2).user.access_grant_filesystem=u2.access_grant_filesystem;
                        }
                        if(!bot.access_grant_partyline) {
                            (*i2).user.access_to_partyline=u2.access_to_partyline;
                            (*i2).user.access_grant_partyline=u2.access_grant_partyline;
                        }
                        if(!bot.access_grant_plusproc) {
                            (*i2).user.access_to_plusproc=u2.access_to_plusproc;
                            (*i2).user.access_grant_plusproc=u2.access_grant_plusproc;
                        }
                        if(!bot.access_grant_plususer) {
                            (*i2).user.access_to_plususer=u2.access_to_plususer;
                            (*i2).user.access_grant_plususer=u2.access_grant_plususer;
                        }
                        if(!bot.access_grant_private) {
                            (*i2).user.access_to_private=u2.access_to_private;
                            (*i2).user.access_grant_private=u2.access_grant_private;
                        }
                        if(!bot.access_grant_rehash) {
                            (*i2).user.access_to_rehash=u2.access_to_rehash;
                            (*i2).user.access_grant_rehash=u2.access_grant_rehash;
                        }
                        if(!bot.access_grant_replication) {
                            (*i2).user.access_to_replication=u2.access_to_replication;
                            (*i2).user.access_grant_replication=u2.access_grant_replication;
                        }
                        if(!bot.access_grant_restart) {
                            (*i2).user.access_to_restart=u2.access_to_restart;
                            (*i2).user.access_grant_restart=u2.access_grant_restart;
                        }
                        if(!bot.access_grant_upgrade) {
                            (*i2).user.access_to_upgrade=u2.access_to_upgrade;
                            (*i2).user.access_grant_upgrade=u2.access_grant_upgrade;
                        }
                        if(!bot.access_grant_apply) {
                            (*i2).user.access_to_apply=u2.access_to_apply;
                            (*i2).user.access_grant_apply=u2.access_grant_apply;
                        }
                    }

                    botnet_user_remove_groups_remote_bot_dont_have_access_to_group((*i2).user,bot);
                    botnet_user_remove_groups_remote_bot_dont_have_access_grant_group((*i2).user,bot);
                    botnet_user_remove_groups_remote_bot_dont_have_access_usage_procedure((*i2).user,bot);
                    botnet_user_remove_groups_remote_bot_dont_have_access_usage_procedure2((*i2).user,bot);
                    botnet_user_remove_groups_remote_bot_dont_have_access_grant_procedure((*i2).user,bot);
                    botnet_user_remove_groups_remote_bot_dont_have_access_grant_channel((*i2).user,bot,(string)"PULLing user \""+(*i2).user.name+"\"");
                    botnet_user_remove_groups_remote_bot_dont_have_access_grant_channel2((*i2).user,bot);

                    bool got2=false;
                    {
                        c_user us;
                        if(logic_botnet_get_user((*i2).user.name,us))
                            got2=true;
                    }

                    if(got2 || (!got2 && bot.access_to_plususer)) {
                        if((*i2).user.last_changed==0)
                            (*i2).user.last_changed++;

                        c_replication r;
                        r.partner=bot.name;
                        r.type=REPL_PULL;
                        (*i2).user.replication.push_back(r);

                        logic_botnet_remove_user((*i2).user.name);
                        if(!(*i2).user.is_template) {
                            if(!(*i2).user.terminator)
                                r_users.push_back((*i2).user);
                            else
                                r_terminators.push_back((*i2).user);
                        } else
                            r_user_templates.push_back((*i2).user);

                        vector<c_channel>::iterator i3;
                        for(i3=(*i2).chans.begin(); i3!=(*i2).chans.end(); ++i3) {
                            if(!(*i2).user.is_template) {
                                if(!(*i2).user.terminator)
                                    r_channels.push_back(*i3);
                                else
                                    r_channel_terminators.push_back(*i3);
                            } else
                                r_channel_templates.push_back(*i3);
                        }

                        if(bot.access_to_apply) {
                            botnet_apply(*i1,(*i1)->botname);
                        }

                        if(bot.access_to_backup) {
                            botnet_backup((*i1)->botname);

                            if(bot.access_to_rehash && !bot.access_to_apply)
                                botnet_rehash(*i1,(*i1)->botname);
                        }

                        string d="pulling of object ";
                        d+="(user) \"";
                        d+=(*i2).user.name;
                        d+="\" successful";
                        log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,d);
                        log_botnet(botnet_botname,(*i1)->botname,d);

                        stats_botnet_user_pulled();

                        {
                            string obj_type="user";
                            string reason="OK";
                            string obj=(*i2).user.name;

                            logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,d,"PULL");
                        }
                    }

                    (*i1)->pulling_users.erase(i2);
                }
            }
            return true;
        case CMD_REPL_PRV_01_1:
            {
                if(!(*i1)->prv_pulling)
                    return true;

                (*i1)->prv_to_pull.clear();
                (*i1)->prv_to_pull.last_changed=s_cmd->command_data.cmd_repl_prv_01_1.last_changed;
                (*i1)->adjust_timestamp((*i1)->prv_to_pull.last_changed);
            }
            return true;
        case CMD_REPL_PRV_02_1:
            {
                if(!(*i1)->prv_pulling)
                    return true;

                (*i1)->prv_to_pull.groups.push_back(s_cmd->command_data.cmd_repl_prv_02_1.group);
            }
            return true;
        case CMD_REPL_PRV_03_1:
            {
                if(!(*i1)->prv_pulling)
                    return true;

                c_user bot;
                logic_botnet_get_user((*i1)->botname,bot);
                const c_private& old_prv=r_private;

                (*i1)->prv_to_pull.on_privmsg=old_prv.on_privmsg;
                if(botnet_has_grant(bot,old_prv.on_privmsg) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_03_1.on_privmsg))
                    (*i1)->prv_to_pull.on_privmsg=s_cmd->command_data.cmd_repl_prv_03_1.on_privmsg;

                (*i1)->prv_to_pull.on_notice=old_prv.on_notice;
                if(botnet_has_grant(bot,old_prv.on_notice) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_03_1.on_notice))
                    (*i1)->prv_to_pull.on_notice=s_cmd->command_data.cmd_repl_prv_03_1.on_notice;

                (*i1)->prv_to_pull.on_ctcp=old_prv.on_ctcp;
                if(botnet_has_grant(bot,old_prv.on_ctcp) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_03_1.on_ctcp))
                    (*i1)->prv_to_pull.on_ctcp=s_cmd->command_data.cmd_repl_prv_03_1.on_ctcp;

                // for older BOTNET protocols (e.g. older bots) keep this event current
                if((*i1)->supported_proto_version<7) {
                    (*i1)->prv_to_pull.on_filesys_got_new=old_prv.on_filesys_got_new;
                    (*i1)->prv_to_pull.on_fnc=old_prv.on_fnc;
                }
                if((*i1)->supported_proto_version<8) {
                    (*i1)->prv_to_pull.on_broadcast=old_prv.on_broadcast;
                    (*i1)->prv_to_pull.on_server_msg=old_prv.on_server_msg;
                }
            }
            return true;
        case CMD_REPL_PRV_04_7:
            {
                if(!(*i1)->prv_pulling)
                    return true;

                c_user bot;
                logic_botnet_get_user((*i1)->botname,bot);
                const c_private& old_prv=r_private;

                (*i1)->prv_to_pull.on_filesys_got_new=old_prv.on_filesys_got_new;
                if(botnet_has_grant(bot,old_prv.on_filesys_got_new) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_04_7.on_filesys_got_new))
                    (*i1)->prv_to_pull.on_filesys_got_new=s_cmd->command_data.cmd_repl_prv_04_7.on_filesys_got_new;

                (*i1)->prv_to_pull.on_fnc=old_prv.on_fnc;
                if(botnet_has_grant(bot,old_prv.on_fnc) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_04_7.on_fnc))
                    (*i1)->prv_to_pull.on_fnc=s_cmd->command_data.cmd_repl_prv_04_7.on_fnc;
            }
            return true;
        case CMD_REPL_PRV_05_8:
            {
                if(!(*i1)->prv_pulling)
                    return true;

                c_user bot;
                logic_botnet_get_user((*i1)->botname,bot);
                const c_private& old_prv=r_private;

                (*i1)->prv_to_pull.on_broadcast=old_prv.on_broadcast;
                if(botnet_has_grant(bot,old_prv.on_broadcast) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_05_8.on_broadcast))
                    (*i1)->prv_to_pull.on_broadcast=s_cmd->command_data.cmd_repl_prv_05_8.on_broadcast;

                (*i1)->prv_to_pull.on_server_msg=old_prv.on_server_msg;
                if(botnet_has_grant(bot,old_prv.on_server_msg) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_05_8.on_server_msg))
                    (*i1)->prv_to_pull.on_server_msg=s_cmd->command_data.cmd_repl_prv_05_8.on_server_msg;
            }
            return true;
        case CMD_REPL_PRV_06_11:
            {
                if(!(*i1)->prv_pulling)
                    return true;

                c_user bot;
                logic_botnet_get_user((*i1)->botname,bot);
                const c_private& old_prv=r_private;

                (*i1)->prv_to_pull.on_internal_event=old_prv.on_internal_event;
                if(botnet_has_grant(bot,old_prv.on_internal_event) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_prv_06_11.on_internal_event))
                    (*i1)->prv_to_pull.on_internal_event=s_cmd->command_data.cmd_repl_prv_06_11.on_internal_event;
            }
            return true;
        case CMD_REPL_PRV_99_1:
            {
                {
                    auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                    c_bot_control* c=cp.get();
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_PING;
                    botnet_send_control(*i1,c);
                    (*i1)->next_ping=my_time(NULL)+BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                    (*i1)->start_awaiting_pong=my_time(NULL);

                    string obj=(string)"PRIV";
                    vector<c_bot*>::iterator i2;
                again_4:
                    for(i2=bots->begin(); i2!=bots->end(); ++i2) {
                        vector<string>::iterator i3;
                        for(i3=(*i2)->rejected_objects.begin(); i3!=(*i2)->rejected_objects.end(); ++i3) {
                            if(!(*i3).compare(obj)) {
                                (*i2)->rejected_objects.erase(i3);
                                goto again_4;
                            }
                        }
                    }
                }
                if(!(*i1)->prv_pulling)
                    return true;

                c_user bot;
                logic_botnet_get_user((*i1)->botname,bot);

                if(bot.access_to_private) {
                    c_replication r;
                    r.partner=bot.name;
                    r.type=REPL_PULL;
                    (*i1)->prv_to_pull.replication.push_back(r);
                    r_private=(*i1)->prv_to_pull;

                    if(bot.access_to_apply) {
                        botnet_apply(*i1,(*i1)->botname);
                    }

                    if(bot.access_to_backup) {
                        botnet_backup((*i1)->botname);

                        if(bot.access_to_rehash && !bot.access_to_apply)
                            botnet_rehash(*i1,(*i1)->botname);
                    }

                    string d="pulling of object ";
                    d+="(private)"; // no trailing SPACE!!!
                    d+=" successful";

                    log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,d);
                    log_botnet(botnet_botname,(*i1)->botname,d);

                    stats_botnet_private_pulled();

                    {
                        string obj_type="private";
                        string reason="OK";
                        string obj="private";

                        logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,d,"PULL");
                    }
                }
            }
            return true;
        case CMD_PROC_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_proc_1.name);
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_proc_1.name,n_size);
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                bool ok=false;
                {
                    if(s_cmd->command_data.cmd_proc_1.init) {
                    again_erase_2:
                        vector<c_proc_to_pull>::iterator i2;
                        for(i2=(*i1)->pulling_procs.begin(); i2!=(*i1)->pulling_procs.end(); ++i2) {
                            if(!(*i2).botname.compare((*i1)->botname) && !(*i2).proc_name.compare(name)) {
                                (*i1)->pulling_procs.erase(i2);
                                goto again_erase_2;
                            }
                        }
                    }

                    bool got=false;
                    c_module* core_mod=get_module("core",true);
                    if(core_mod) {
                        if(!s_cmd->command_data.cmd_proc_1.it_is_func) {
                            bool got_proc=false;
                            {
                                c_procedure f;
                                if(logic_botnet_get_proc(name,f))
                                    got_proc=true;
                            }
                            if(got_proc) {
                                c_function p;
                                bool got2=false;
                                if(logic_botnet_get_func(name,p))
                                    got2=true;
                                if(got2) {
                                    vector<c_replication>::iterator i2;
                                    for(i2=p.replications.begin(); i2!=p.replications.end(); ++i2)
                                        if(!(*i2).partner.compare((*i1)->botname) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                                            ok=true;
                                            got=true;
                                            break;
                                        }
                                } else {
                                    c_user bot;
                                    logic_botnet_get_user((*i1)->botname,bot);
                                    if(bot.access_to_plusproc)
                                        ok=true;
                                }
                            } else
                                ok=false;
                        } else {
                            bool got_func=false;
                            {
                                c_function f;
                                if(logic_botnet_get_func(name,f))
                                    got_func=true;
                            }
                            if(got_func) {
                                c_procedure p;
                                bool got2=false;
                                if(logic_botnet_get_proc(name,p))
                                    got2=true;
                                if(got2) {
                                    vector<c_replication>::iterator i2;
                                    for(i2=p.replication.begin(); i2!=p.replication.end(); ++i2)
                                        if(!(*i2).partner.compare((*i1)->botname) && ((*i2).type==REPL_PUSH || (*i2).type==REPL_PUSHPULL)) {
                                            ok=true;
                                            got=true;
                                            break;
                                        }
                                } else {
                                    c_user bot;
                                    logic_botnet_get_user((*i1)->botname,bot);
                                    if(bot.access_to_plusproc)
                                        ok=true;
                                }
                            } else
                                ok=false;
                        }
                        if(got && ok) {
                            if(s_cmd->command_data.cmd_proc_1.it_is_func) {
                                c_function p_;
                                if(logic_botnet_get_func(name,p_)) {
                                    c_proc_to_pull p;
                                    p.botname=(*i1)->botname;
                                    p.proc_name=name;
                                    p.it_is_func=TO_BOOL(s_cmd->command_data.cmd_proc_1.it_is_func);
                                    if(s_cmd->command_data.cmd_proc_1.init) {
                                        p.lines.clear();
                                        p.replication=p_.replications;
                                        vector<string>::iterator i5;
                                        for(i5=p_.groups.begin(); i5!=p_.groups.end(); ++i5)
                                            p.orig_groups.push_back(*i5);
                                    }
                                    (*i1)->pulling_procs.push_back(p);
                                }
                            } else {
                                c_procedure p_;
                                if(logic_botnet_get_proc(name,p_)) {
                                    c_proc_to_pull p;
                                    p.botname=(*i1)->botname;
                                    p.proc_name=name;
                                    p.it_is_func=TO_BOOL(s_cmd->command_data.cmd_proc_1.it_is_func);
                                    if(s_cmd->command_data.cmd_proc_1.init) {
                                        p.lines.clear();
                                        p.replication=p_.replication;
                                        vector<string>::iterator i5;
                                        for(i5=p_.groups.begin(); i5!=p_.groups.end(); ++i5)
                                            p.orig_groups.push_back(*i5);
                                    }
                                    (*i1)->pulling_procs.push_back(p);
                                }
                            }
                        }
                    }
                    if(!got && ok) {
                        c_proc_to_pull p;
                        p.botname=(*i1)->botname;
                        p.proc_name=name;

                        p.it_is_func=TO_BOOL(s_cmd->command_data.cmd_proc_1.it_is_func);

                        // we got a new procedure, so set them replication flags
                        c_replication r;
                        r.partner=(*i1)->botname;
                        r.type=REPL_PULL;
                        p.replication.clear();
                        p.replication.push_back(r);
                        p.orig_groups.clear();

                        (*i1)->pulling_procs.push_back(p);
                    }
                }

                if(ok) {
                    bool got=false;
                    vector<c_proc_to_pull>::iterator i2;
                    for(i2=(*i1)->pulling_procs.begin(); i2!=(*i1)->pulling_procs.end(); ++i2) {
                        if(!(*i2).botname.compare((*i1)->botname) && !(*i2).proc_name.compare(name)) {
                            got=true;
                            break;
                        }
                    }
                    if(got) {
                        (*i2).last_changed=s_cmd->command_data.cmd_proc_1.last_changed;
                        if((*i2).last_changed==0)
                            (*i2).last_changed++;
                        string ln=s_cmd->command_data.cmd_proc_1.line;
                        (*i2).lines.push_back(ln);
                    }
                }
            }
            return true;
    }
    return false;
}

MY_STATIC bool botnet_cmd_switch_7(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_PROC_END_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_proc_end_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_proc_end_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;
                {
                    auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                    c_bot_control* c=cp.get();
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_PING;
                    botnet_send_control(*i1,c);
                    (*i1)->next_ping=my_time(NULL)+BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                    (*i1)->start_awaiting_pong=my_time(NULL);

                    string obj=(string)"PROC "+name;
                    vector<c_bot*>::iterator i2;
                again_2:
                    for(i2=bots->begin(); i2!=bots->end(); ++i2) {
                        vector<string>::iterator i3;
                        for(i3=(*i2)->rejected_objects.begin(); i3!=(*i2)->rejected_objects.end(); ++i3) {
                            if(!(*i3).compare(obj)) {
                                (*i2)->rejected_objects.erase(i3);
                                goto again_2;
                            }
                        }
                    }
                }

                bool got=false;
                vector<c_proc_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_procs.begin(); i2!=(*i1)->pulling_procs.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).proc_name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    bool got2=false;
                    if(!(*i2).it_is_func) {
                        c_procedure p;
                        if(logic_botnet_get_proc(name,p))
                            got2=true;
                    } else {
                        c_function p;
                        if(logic_botnet_get_func(name,p))
                            got2=true;
                    }

                    if(got2 || (!got2 && bot.access_to_plusproc)) {
                        if(!got2) {
                            c_replication r;
                            r.partner=(*i1)->botname;
                            r.type=REPL_PULL;
                            (*i2).replication.push_back(r);
                        }
                        string lch;
                        if(!(*i2).it_is_func) {
                            lch="last_changed ";
                            lch+=tos((*i2).last_changed);
                        } else {
                            lch="#last_changed ";
                            lch+=tos((*i2).last_changed);
                        }
                        (*i2).lines.push_back(lch);
                        int error_line;
                        string error_reason;
                        vector<string> rproc;
                        if(!(*i2).it_is_func) {
                            try {
                                logic_parse_proc(error_reason,error_line,(*i2).lines,false,(*i2).proc_name,(*i2).orig_groups,(*i2).replication,rproc);
                            } catch(c_proc_exc& e) {
                                error_line=-1;
                                error_reason=e.get_msg();
                            }
                        } else
                            logic_parse_func(error_reason,error_line,(*i2).lines,false,(*i2).proc_name,(*i2).orig_groups,(*i2).replication,rproc);

                        string d="pulling of object ";
                        if(!(*i2).it_is_func)
                            d+="(procedure) ";
                        else
                            d+="(function) ";
                        d+="\"";
                        d+=(*i2).proc_name;
                        d+="\"";

                        botnet_func_proc_remove_groups_remote_bot_dont_have_access_to((*i2).it_is_func,name,(*i2).lines,(*i2).orig_groups,bot,((string)"PULLing procedure/function \"")+(*i2).proc_name+"\"");

                        if(error_line!=0) {
                            // an compilation error
                        } else {
                            vector<string> rproc;
                            if(!(*i2).it_is_func) {
                                try {
                                    logic_parse_proc(error_reason,error_line,(*i2).lines,true,(*i2).proc_name,(*i2).orig_groups,(*i2).replication,rproc);
                                } catch(c_proc_exc& e) {
                                    error_line=-1;
                                    error_reason=e.get_msg();
                                }
                            } else
                                logic_parse_func(error_reason,error_line,(*i2).lines,true,(*i2).proc_name,(*i2).orig_groups,(*i2).replication,rproc);

                            if(bot.access_to_apply) {
                                botnet_apply(*i1,(*i1)->botname);
                            }

                            if(bot.access_to_backup) {
                                botnet_backup((*i1)->botname);

                                if(bot.access_to_rehash && !bot.access_to_apply)
                                    botnet_rehash(*i1,(*i1)->botname);
                            }

                            stats_botnet_proc_pulled();
                        }
                        if(error_line==0) {
                            d+=" successful";

                            {
                                string obj_type;
                                if(!(*i2).it_is_func)
                                    obj_type="procedure";
                                else
                                    obj_type="function";
                                string reason="OK";
                                string obj=(*i2).proc_name;

                                logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,d,"PULL");
                            }

                            if(!botnet_has_grant(bot,(*i2).proc_name)) {
                                string x="\"";
                                x+=(*i2).proc_name;
                                x+="\"";
                            }
                        } else {
                            d+=" error: ";
                            d+=error_reason;
                            d+=" on line #";
                            d+=tos(error_line);

                            {
                                string obj_type;
                                if(!(*i2).it_is_func)
                                    obj_type="procedure";
                                else
                                    obj_type="function";
                                string reason="compile error";
                                string obj=(*i2).proc_name;

                                logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_CRITICAL_ERROR,d,"PULL");
                            }
                        }

                        log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,d);
                        log_botnet(botnet_botname,(*i1)->botname,d);
                    }

                    (*i1)->pulling_procs.erase(i2);
                }
            }
            return true;
        case CMD_PARTYLINE_1:
            {
                int user_size=sizeof(s_cmd->command_data.cmd_partyline_1.user);
                int ch_size=sizeof(s_cmd->command_data.cmd_partyline_1.channel);
                int bn_size=sizeof(s_cmd->command_data.cmd_partyline_1.botname);

                char* x=MY_NEW char[ch_size+1];
                memset(x,0,ch_size+1);
                strncpy(x,s_cmd->command_data.cmd_partyline_1.channel,ch_size-1);
                bool got=false;
            again3:
                vector<c_botnet_channel>::iterator i2;
                for(i2=botnet_channels.begin(); i2!=botnet_channels.end(); ++i2)
                    if(!(*i2).channel_name.compare(x)) {
                        got=true;
                        break;
                    }
                string channel=x;
                if(!got && !channel.empty()) {
                    c_botnet_channel c;
                    c.channel_name=x;
                    botnet_channels.push_back(c);
                    goto again3;
                }
                c_partyline_member me;
                MY_DELETE_A(x);
                x=MY_NEW char[user_size+1];
                memset(x,0,user_size+1);
                strncpy(x,s_cmd->command_data.cmd_partyline_1.user,user_size-1);
                me.user=x;
                MY_DELETE_A(x);

                x=MY_NEW char[bn_size+1];
                memset(x,0,bn_size+1);
                strncpy(x,s_cmd->command_data.cmd_partyline_1.botname,bn_size-1);
                me.botname=x;
                MY_DELETE_A(x);

                bool got2=false;
                if(!channel.empty()) {
                    vector<c_partyline_member>::iterator i3;
                    for(i3=(*i2).members.begin(); i3!=(*i2).members.end(); ++i3)
                        if(!(*i3).user.compare(me.user)) {
                            got2=true;
                            break;
                        }
                    if(!got2)
                        (*i2).members.push_back(me);
                }

                botnet_cleanup_ids();
                bool got_id=false;
                vector<c_msg_id>::iterator i5;
                for(i5=msg_ids.begin(); i5!=msg_ids.end(); ++i5)
                    if((*i5).id==s_cmd->command_data.cmd_partyline_1.id) {
                        got_id=true;
                        break;
                    }

                if(!got_id) {
                    c_msg_id id;
                    id.time=static_cast<my_botnet_time_t>(my_time(NULL));
                    id.id=s_cmd->command_data.cmd_partyline_1.id;
                    msg_ids.push_back(id);

                    vector<c_bot*>::iterator i4;
                    for(i4=bots->begin(); i4!=bots->end(); ++i4) {
                        //if((*i4).botname.compare(me.botname) && (*i4).botname.compare((*i1)->botname))
                            botnet_send_command(*i4,s_cmd);
                    }

                    botnet_partyline_event(me.botname,s_cmd);

                    stats_botnet_partyline_event();
                }
            }
            return true;
        case CMD_PARTYLINE_USER_1:
            {
                int user_size=sizeof(s_cmd->command_data.cmd_partyline_user_1.user);
                int ch_size=sizeof(s_cmd->command_data.cmd_partyline_user_1.channel);
                int bn_size=sizeof(s_cmd->command_data.cmd_partyline_user_1.botname);

                char* x=MY_NEW char[ch_size+1];
                memset(x,0,ch_size+1);
                strncpy(x,s_cmd->command_data.cmd_partyline_user_1.channel,ch_size-1);
                bool got=false;
            again4:
                vector<c_botnet_channel>::iterator i2;
                for(i2=botnet_channels.begin(); i2!=botnet_channels.end(); ++i2)
                    if(!(*i2).channel_name.compare(x)) {
                        got=true;
                        break;
                    }
                if(!got) {
                    c_botnet_channel c;
                    c.channel_name=x;
                    botnet_channels.push_back(c);
                    goto again4;
                }
                c_partyline_member me;
                MY_DELETE_A(x);
                x=MY_NEW char[user_size+1];
                memset(x,0,user_size+1);
                strncpy(x,s_cmd->command_data.cmd_partyline_user_1.user,user_size-1);
                me.user=x;
                MY_DELETE_A(x);
                x=MY_NEW char[bn_size+1];
                memset(x,0,bn_size+1);
                strncpy(x,s_cmd->command_data.cmd_partyline_user_1.botname,bn_size-1);
                me.botname=x;
                MY_DELETE_A(x);
                bool got2=false;
                vector<c_partyline_member>::iterator i3;
                for(i3=(*i2).members.begin(); i3!=(*i2).members.end(); ++i3)
                    if(!(*i3).user.compare(me.user) && !(*i3).botname.compare(me.botname)) {
                        got2=true;
                        break;
                    }
                if(!got2)
                    (*i2).members.push_back(me);

                botnet_cleanup_ids();
                bool got_id=false;
                vector<c_msg_id>::iterator i5;
                for(i5=msg_ids.begin(); i5!=msg_ids.end(); ++i5)
                    if((*i5).id==s_cmd->command_data.cmd_partyline_user_1.id) {
                        got_id=true;
                        break;
                    }

                if(!got_id) {
                    c_msg_id id;
                    id.time=static_cast<my_botnet_time_t>(my_time(NULL));
                    id.id=s_cmd->command_data.cmd_partyline_user_1.id;
                    msg_ids.push_back(id);

                    vector<c_bot*>::iterator i4;
                    for(i4=bots->begin(); i4!=bots->end(); ++i4)
                        botnet_send_command(*i4,s_cmd);

                    botnet_partyline_event((*i1)->botname,s_cmd);

                    stats_botnet_partyline_event();
                }
            }
            return true;
        case CMD_REPL_CHDEF_01_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_01_1.name);
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_01_1.name,n_size);
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                {
                again_erase_4:
                    vector<c_chan_def_to_pull>::iterator i2;
                    for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                        if(!(*i2).botname.compare((*i1)->botname) && !cmp_strings_case_insensitive((*i2).chan_name,name)) {
                            (*i1)->pulling_chans.erase(i2);
                            goto again_erase_4;
                        }
                    }

                    bool got=false;
                    vector<c_channel_def>::iterator i3;
                    for(i3=r_channel_defs.begin(); i3!=r_channel_defs.end(); ++i3) {
                        if(!cmp_strings_case_insensitive((*i3).channel_name,name)) {
                            got=true;
                            vector<c_replication>::iterator i4;
                            for(i4=(*i3).replication.begin(); i4!=(*i3).replication.end(); ++i4) {
                                if(!(*i4).partner.compare((*i1)->botname) && ((*i4).type==REPL_PULL || (*i4).type==REPL_PUSHPULL)) {
                                    c_chan_def_to_pull ch;

                                    ch.last_changed=s_cmd->command_data.cmd_repl_chdef_01_1.last_changed;
                                    (*i1)->adjust_timestamp(ch.last_changed);

                                    ch.botname=(*i1)->botname;
                                    ch.chan_name=(*i3).channel_name;
                                    (*i1)->pulling_chans.push_back(ch);
                                    got=true;
                                    break;
                                }
                            }
                            if(got)
                                break;
                        }
                    }
                    if(!got) {
                        c_chan_def_to_pull ch;
                        ch.botname=(*i1)->botname;
                        ch.chan_name=name;

                        ch.last_changed=s_cmd->command_data.cmd_repl_chdef_01_1.last_changed;
                        (*i1)->adjust_timestamp(ch.last_changed);

                        // we got a new channel definition, so set them replication flags
                        c_replication r;
                        r.partner=(*i1)->botname;
                        r.type=REPL_PULL;
                        ch.chd.replication.push_back(r);

                        (*i1)->pulling_chans.push_back(ch);
                    }
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !cmp_strings_case_insensitive((*i2).chan_name,name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    (*i2).last_changed=s_cmd->command_data.cmd_repl_chdef_01_1.last_changed;
                    (*i1)->adjust_timestamp((*i2).last_changed);

                    (*i2).chd.last_changed=(*i2).last_changed;

                    (*i2).chd.channel_name=name;

                    c_channel_def old_chd;
                    logic_botnet_get_channel_def((*i2).chd.channel_name,old_chd);

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    (*i2).chd.on_mode=old_chd.on_mode;
                    if(botnet_has_grant(bot,old_chd.on_mode) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_mode))
                        (*i2).chd.on_mode=s_cmd->command_data.cmd_repl_chdef_01_1.on_mode;

                    (*i2).chd.on_key=old_chd.on_key;
                    if(botnet_has_grant(bot,old_chd.on_key) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_key))
                        (*i2).chd.on_key=s_cmd->command_data.cmd_repl_chdef_01_1.on_key;

                    (*i2).chd.on_limit=old_chd.on_limit;
                    if(botnet_has_grant(bot,old_chd.on_limit) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_limit))
                        (*i2).chd.on_limit=s_cmd->command_data.cmd_repl_chdef_01_1.on_limit;

                    (*i2).chd.on_topic=old_chd.on_topic;
                    if(botnet_has_grant(bot,old_chd.on_topic) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_topic))
                        (*i2).chd.on_topic=s_cmd->command_data.cmd_repl_chdef_01_1.on_topic;

                    (*i2).chd.on_ircop=old_chd.on_ircop;
                    if(botnet_has_grant(bot,old_chd.on_ircop) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_ircop))
                        (*i2).chd.on_ircop=s_cmd->command_data.cmd_repl_chdef_01_1.on_ircop;

                    (*i2).chd.on_ctcp=old_chd.on_ctcp;
                    if(botnet_has_grant(bot,old_chd.on_ctcp) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_ctcp))
                        (*i2).chd.on_ctcp=s_cmd->command_data.cmd_repl_chdef_01_1.on_ctcp;

                    (*i2).chd.on_privmsg=old_chd.on_privmsg;
                    if(botnet_has_grant(bot,old_chd.on_privmsg) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_privmsg))
                        (*i2).chd.on_privmsg=s_cmd->command_data.cmd_repl_chdef_01_1.on_privmsg;

                    (*i2).chd.on_notice=old_chd.on_notice;
                    if(botnet_has_grant(bot,old_chd.on_notice) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_notice))
                        (*i2).chd.on_notice=s_cmd->command_data.cmd_repl_chdef_01_1.on_notice;

                    (*i2).chd.on_part=old_chd.on_part;
                    if(botnet_has_grant(bot,old_chd.on_part) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_part))
                        (*i2).chd.on_part=s_cmd->command_data.cmd_repl_chdef_01_1.on_part;

                    (*i2).chd.on_dynamic_ban=old_chd.on_dynamic_ban;
                    if(botnet_has_grant(bot,old_chd.on_dynamic_ban) && botnet_has_grant(bot,s_cmd->command_data.cmd_repl_chdef_01_1.on_dynamic_ban))
                        (*i2).chd.on_dynamic_ban=s_cmd->command_data.cmd_repl_chdef_01_1.on_dynamic_ban;

                    (*i2).chd.allow_dynamic.clear();
                    (*i2).chd.dynamic_plus_modes=s_cmd->command_data.cmd_repl_chdef_01_1.dynamic_plus_modes;
                    (*i2).chd.dynamic_minus_modes=s_cmd->command_data.cmd_repl_chdef_01_1.dynamic_minus_modes;
                    (*i2).chd.groups.clear();
                    (*i2).chd.replication.clear();
                    (*i2).chd.dynamic_bans.clear();
                    (*i2).chd.dynbans_editors.clear();
                }
            }
            return true;
        case CMD_REPL_CHDEF_02_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_02_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_02_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).chan_name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_chdef_02_1.group); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_chdef_02_1.group,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    {
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                    }

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    if(botnet_has_access_usage_group(data,bot,(string)"PULLing channel definition \""+(*i2).chan_name+"\""))
                        (*i2).chd.groups.push_back(data);
                }
            }
            return true;
        case CMD_REPL_CHDEF_03_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_03_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_03_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !(*i2).chan_name.compare(name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_chdef_03_1.group); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_chdef_03_1.group,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    c_dynamic_rule dr;
                    dr.group=data;
                    dr.plus_modes=s_cmd->command_data.cmd_repl_chdef_03_1.plus_modes;
                    dr.minus_modes=s_cmd->command_data.cmd_repl_chdef_03_1.minus_modes;

                    {
                        string data=dr.group;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        dr.group=data;
                    }
                    {
                        string data=dr.plus_modes;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        dr.plus_modes=data;
                    }
                    {
                        string data=dr.minus_modes;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        dr.minus_modes=data;
                    }

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    if(botnet_has_access_usage_group(dr.group,bot,((string)"PULLing channel definition \"")+(*i2).chan_name+"\""))
                        (*i2).chd.allow_dynamic.push_back(dr);
                }
            }
            return true;
    }
    return false;
}

MY_STATIC bool botnet_cmd_switch_8(vector<c_bot*>::iterator& i1, c_bot_command* s_cmd)
{
    switch(s_cmd->command) {
        case CMD_REPL_CHDEF_04_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_04_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_04_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !cmp_strings_case_insensitive((*i2).chan_name,name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_chdef_04_1.mask); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_chdef_04_1.mask,d_size); // !!!
                    string mask=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    d_size=sizeof(s_cmd->command_data.cmd_repl_chdef_04_1.reason); // !!!
                    d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_chdef_04_1.reason,d_size); // !!!
                    string reason=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    pair<string,string> p;
                    p.first=mask;
                    p.second=reason;

                    {
                        string data=p.first;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        p.first=data;
                    }
                    {
                        string data=p.second;
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                        p.second=data;
                    }

                    (*i2).chd.dynamic_bans.insert(p);
                }
            }
            return true;
        case CMD_REPL_CHDEF_05_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_05_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_05_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !cmp_strings_case_insensitive((*i2).chan_name,name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_chdef_05_1.group); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_chdef_05_1.group,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    {
                        if(data.length() && data[0]=='"')
                            data.erase(0,1);
                        if(data.length() && data[data.length()-1]=='"')
                            data.erase(data.length()-1,1);
                    }

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    if(botnet_has_access_usage_group(data,bot,((string)"PULLing channel definition \"")+(*i2).chan_name+"\""))
                        (*i2).chd.dynbans_editors.push_back(data);
                }
            }
            return true;
        case CMD_REPL_CHDEF_06_8:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_06_8.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_06_8.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !cmp_strings_case_insensitive((*i2).chan_name,name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    int d_size=sizeof(s_cmd->command_data.cmd_repl_chdef_06_8.on_server_msg); // !!!
                    char* d=MY_NEW char[d_size+1];
                    memset(d,0,d_size+1);
                    memcpy(d,s_cmd->command_data.cmd_repl_chdef_06_8.on_server_msg,d_size); // !!!
                    string data=d;
                    MY_DELETE_A(d);
                    d=NULL;

                    c_channel_def old_chd;
                    logic_botnet_get_channel_def((*i2).chd.channel_name,old_chd);

                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    (*i2).chd.on_server_msg=old_chd.on_server_msg;
                    if(botnet_has_grant(bot,old_chd.on_server_msg) && botnet_has_grant(bot,data))
                        (*i2).chd.on_server_msg=data;
                }
            }
            return true;
        case CMD_REPL_CHDEF_99_1:
            {
                int n_size=sizeof(s_cmd->command_data.cmd_repl_chdef_99_1.name); // !!!
                char* n=MY_NEW char[n_size+1];
                memset(n,0,n_size+1);
                memcpy(n,s_cmd->command_data.cmd_repl_chdef_99_1.name,n_size); // !!!
                string name=n;
                MY_DELETE_A(n);
                n=NULL;

                {
                    string data=name;
                    if(data.length() && data[0]=='"')
                        data.erase(0,1);
                    if(data.length() && data[data.length()-1]=='"')
                        data.erase(data.length()-1,1);
                    name=data;
                }

                {
                    auto_ptr<c_bot_control> cp(MY_NEW c_bot_control);
                    c_bot_control* c=cp.get();
                    c->hard_clear();
                    c->packet_type=PACKET_TYPE_CONTROL;
                    c->supported_proto_version=SUPPORTED_PROTO_VERSION;
                    c->control=CTRL_PING;
                    botnet_send_control(*i1,c);
                    (*i1)->next_ping=my_time(NULL)+BOTNET_KEEPALIVE_PING_PERIOD+BOTNET_KEEPALIVE_PING_DRIFT;
                    (*i1)->start_awaiting_pong=my_time(NULL);

                    string obj=(string)"CHAN "+name;
                    vector<c_bot*>::iterator i2;
                again_3:
                    for(i2=bots->begin(); i2!=bots->end(); ++i2) {
                        vector<string>::iterator i3;
                        for(i3=(*i2)->rejected_objects.begin(); i3!=(*i2)->rejected_objects.end(); ++i3) {
                            if(!cmp_strings_case_insensitive((*i3),obj)) {
                                (*i2)->rejected_objects.erase(i3);
                                goto again_3;
                            }
                        }
                    }
                }

                bool got=false;
                vector<c_chan_def_to_pull>::iterator i2;
                for(i2=(*i1)->pulling_chans.begin(); i2!=(*i1)->pulling_chans.end(); ++i2) {
                    if(!(*i2).botname.compare((*i1)->botname) && !cmp_strings_case_insensitive((*i2).chan_name,name)) {
                        got=true;
                        break;
                    }
                }
                if(got) {
                    c_user bot;
                    logic_botnet_get_user((*i1)->botname,bot);

                    {
                        c_channel_def chd;
                        logic_botnet_get_channel_def((*i2).chan_name,chd);
                        c_replication r;
                        r.partner=(*i1)->botname;
                        r.type=REPL_PULL;
                        (*i2).chd.replication.clear();
                        vector<c_replication>::iterator i3;
                        bool got_this_repl=false;
                        for(i3=chd.replication.begin(); i3!=chd.replication.end(); ++i3) {
                            (*i2).chd.replication.push_back(*i3);
                            if(!(*i3).partner.compare(r.partner))
                                got_this_repl=true;
                        }
                        if(!got_this_repl)
                            (*i2).chd.replication.push_back(r);
                    }

                    c_replication r;
                    r.partner=bot.name;
                    r.type=REPL_PULL;
                    (*i2).chd.replication.push_back(r);

                    logic_botnet_remove_channel_def((*i2).chan_name);
                    r_channel_defs.push_back((*i2).chd);

                    if(bot.access_to_apply) {
                        botnet_apply(*i1,(*i1)->botname);
                    }

                    if(bot.access_to_backup) {
                        botnet_backup((*i1)->botname);

                        if(bot.access_to_rehash && !bot.access_to_apply)
                            botnet_rehash(*i1,(*i1)->botname);
                    }

                    string d="pulling of object ";
                    d+="(channel) \"";
                    d+=(*i2).chan_name;
                    d+="\" successful";
                    log_botnet_debug(botnet_botname,(*i1)->botname,s_cmd->packet_type,s_cmd->command,d);
                    log_botnet(botnet_botname,(*i1)->botname,d);

                    stats_botnet_chandef_pulled();

                    {
                        string obj_type="channel";
                        string reason="OK";
                        string obj=(*i2).chan_name;

                        logic_on_internal_event("@botnet_replication@",(*i1)->botname,obj_type,obj,reason,PRIVATE_EVENT_SEVERITY_CODE_INFORMATIONAL,d,"PULL");
                    }

                    (*i1)->pulling_chans.erase(i2);
                }
            }
            return true;
        case CMD_UPDATE_1004:
            (*i1)->users_already_updated=false;
            (*i1)->procs_already_updated=false;
            (*i1)->chandefs_already_updated=false;
            (*i1)->prv_already_updated=false;
            return true;
    }
    return false;
}

MY_STATIC void botnet_regenerate_vector()
{
#if defined(BOTNET_BOTS_VECTOR_RECREATION) && BOTNET_BOTS_VECTOR_RECREATION != 0
    vector<c_bot*>* bots_new=MY_NEW vector<c_bot*>;
    vector<c_bot*>::iterator i1;
    for(i1=bots->begin(); i1!=bots->end(); ++i1) {
        bots_new->push_back(MY_NEW c_bot(**i1));
        MY_DELETE(*i1);
    }
    MY_DELETE(bots);
    bots=bots_new;
#endif
}

MY_STATIC bool botnet_has_access_usage_group(const string& group, const c_user& bot, const string& debug)
{
    if(group.empty() || !group.compare("*")) {
        string log="OOPS: Bogus name of the group: '";
        log+=group;
        log+="' - parts of object were rejected from PULLing; ";
        log+=debug;
        log=GET_STR_DEBUG_INFO_EX(log);
        log_botnet(botnet_botname,bot.name,log);
        log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        return false;
    }

    bool wildcard=false;

    vector<string> access_grant_group=bot.access_grant_group;
    {
        vector<string>::iterator ii;

        sort(access_grant_group.begin(),access_grant_group.end());
        ii=unique(access_grant_group.begin(),access_grant_group.end());
        access_grant_group.erase(ii,access_grant_group.end());

        for(ii=access_grant_group.begin(); ii!=access_grant_group.end(); ++ii) {
            if(!(*ii).compare("*")) {
                wildcard=true;
                break;
            }
        }
    }

    if(wildcard)
        return true;

    vector<string>::iterator i3;

    bool got=false;
    for(i3=access_grant_group.begin(); i3!=access_grant_group.end(); ++i3) {
        if(!(*i3).compare(group)) {
            got=true;
            break;
        }
    }
    if(!got) {
        string log="OOPS: Warning: Remote bot has not right 'access_grant_group' for this group: '";
        log+=group;
        log+="' - parts of object were rejected from PULLing; ";
        log+=debug;
        log=GET_STR_DEBUG_INFO_EX(log);
        log_botnet(botnet_botname,bot.name,log);
        log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        return false;
    }
    return true;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_to_group(c_user& user, const c_user& bot)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    for(i_1=user.access_to_group.begin(); i_1!=user.access_to_group.end(); ++i_1) {
        for(i_2=bot.access_grant_group.begin(); i_2!=bot.access_grant_group.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_grant_group' for this group: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_to_group=new_right;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_group(c_user& user, const c_user& bot)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    for(i_1=user.access_grant_group.begin(); i_1!=user.access_grant_group.end(); ++i_1) {
        for(i_2=bot.access_grant_group.begin(); i_2!=bot.access_grant_group.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_grant_group' for this group: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_grant_group=new_right;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_usage_procedure(c_user& user, const c_user& bot)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    new_right.clear();
    for(i_1=user.access_to_proc.begin(); i_1!=user.access_to_proc.end(); ++i_1) {
        for(i_2=bot.access_usage_procedure.begin(); i_2!=bot.access_usage_procedure.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_to_procedure' for this group: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_to_proc=new_right;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_usage_procedure2(c_user& user, const c_user& bot)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    for(i_1=user.access_usage_procedure.begin(); i_1!=user.access_usage_procedure.end(); ++i_1) {
        for(i_2=bot.access_usage_procedure.begin(); i_2!=bot.access_usage_procedure.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_usage_procedure' for this group: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_usage_procedure=new_right;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_channel(c_user& user, const c_user& bot, const string& debug)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    for(i_1=user.access_to_channel.begin(); i_1!=user.access_to_channel.end(); ++i_1) {
        for(i_2=bot.access_grant_channel.begin(); i_2!=bot.access_grant_channel.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_usage_group' for this channel: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'; ";
            log+=debug;
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_to_channel=new_right;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_procedure(c_user& user, const c_user& bot)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    for(i_1=user.access_grant_procedure.begin(); i_1!=user.access_grant_procedure.end(); ++i_1) {
        for(i_2=bot.access_usage_procedure.begin(); i_2!=bot.access_usage_procedure.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_usage_procedure' for this group: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_grant_procedure=new_right;
}

MY_STATIC void botnet_user_remove_groups_remote_bot_dont_have_access_grant_channel2(c_user& user, const c_user& bot)
{
    vector<string> new_right;

    vector<string>::iterator i_1;
    vector<string>::const_iterator i_2;

    bool got_access=false;
    for(i_1=user.access_grant_channel.begin(); i_1!=user.access_grant_channel.end(); ++i_1) {
        for(i_2=bot.access_grant_channel.begin(); i_2!=bot.access_grant_channel.end(); ++i_2) {
            if(!(*i_2).compare("*") || !(*i_2).compare(*i_1)) {
                new_right.push_back(*i_1);
                got_access=true;
                break;
            }
        }
        if(!got_access) {
            string log="OOPS: Warning: Remote bot has not right 'access_usage_group' for this channel: '";
            log+=*i_1;
            log+="' - parts of object were rejected from PULLing (PULLing of user '";
            log+=user.name;
            log+="'";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        }
    }
    sort(new_right.begin(),new_right.end());
    i_1=unique(new_right.begin(),new_right.end());
    new_right.erase(i_1,new_right.end());
    user.access_grant_channel=new_right;
}

MY_STATIC void botnet_remove_groups_remote_bot_dont_have_access_to(vector<string>& quoted_new_groups, vector<string>& new_groups, const c_user& bot, const string& debug)
{
again_1:
    for(vector<string>::iterator i1=quoted_new_groups.begin(); i1!=quoted_new_groups.end(); ++i1) {
        if((*i1).length()<3 || '"'!=(*i1)[0] || '"'!=(*i1)[(*i1).length()-1]) {
            string log="OOPS: Bogus name of the group: '";
            log+=*i1;
            log+="' - parts of object were rejected from PULLing; ";
            log+=debug;
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);

            quoted_new_groups.erase(i1);
            goto again_1;
        }
        (*i1).erase(0,1);
        (*i1).erase((*i1).length()-1,1);
    }

    bool wildcard=false;

    vector<string> access_grant_group=bot.access_grant_group;
    {
        vector<string>::iterator ii;
        sort(access_grant_group.begin(),access_grant_group.end());
        ii=unique(access_grant_group.begin(),access_grant_group.end());
        access_grant_group.erase(ii,access_grant_group.end());
        for(ii=access_grant_group.begin(); ii!=access_grant_group.end(); ++ii) {
            if(!(*ii).compare("*")) {
                wildcard=true;
                break;
            }
        }
    }

    {
        sort(quoted_new_groups.begin(),quoted_new_groups.end());
        vector<string>::iterator ii2=unique(quoted_new_groups.begin(),quoted_new_groups.end());
        quoted_new_groups.erase(ii2,quoted_new_groups.end());
    }

    new_groups.clear();

    vector<string>::iterator i2, i3;
    for(i2=quoted_new_groups.begin(); i2!=quoted_new_groups.end(); ++i2) {
        if((*i2).empty() || !(*i2).compare("*")) {
            string log="OOPS: Bogus name of the group: '";
            log+=*i2;
            log+="' - parts of object were rejected from PULLing";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
            continue;
        }
        if(wildcard) {
            new_groups.push_back(*i2);
            continue;
        }
        bool got=false;
        for(i3=access_grant_group.begin(); i3!=access_grant_group.end(); ++i3) {
            if(!(*i3).compare(*i2)) {
                got=true;
                break;
            }
        }
        if(!got) {
            string log="OOPS: Warning: Remote bot has not right 'access_grant_group' for this group: '";
            log+=*i2;
            log+="' - parts of object were rejected from PULLing";
            log=GET_STR_DEBUG_INFO_EX(log);
            log_botnet(botnet_botname,bot.name,log);
            log_botnet_debug(botnet_botname,bot.name,-1,-1,log);
        } else {
            new_groups.push_back(*i2);
        }
    }
}

MY_STATIC void botnet_func_proc_remove_groups_remote_bot_dont_have_access_to(bool its_function, const string& name, list<string>& lines, vector<string>& new_groups, const c_user& bot, const string& debug)
{
    vector<string> orig_groups;

    if(!its_function) {
        c_procedure p;
        if(logic_botnet_get_proc(name,p))
            orig_groups=p.groups;
    } else {
        c_function p;
        if(logic_botnet_get_func(name,p))
            orig_groups=p.groups;
    }

    vector<string> quoted_groups_to_check;

    list<string>::iterator i1;
    for(i1=lines.begin(); i1!=lines.end(); ++i1) {
        if((*i1).empty())
            continue;
        string line=*i1;
        while(!line.empty() && (' '==line[0] || '\t'==line[0]))
            line.erase(0,1);
        if(line.empty())
            continue;

        string member_of_group;

        if(!its_function) {
            if(line.find("member_of_group ")==0)
                member_of_group=line;
        } else {
            if(line.find("#member_of_group ")==0)
                member_of_group=line;
        }

        if(member_of_group.empty())
            continue;
        if(its_function && '#'==member_of_group[0])
            member_of_group.erase(0,1);

        member_of_group.erase(0,sizeof("member_of_group ")-1);

        quoted_groups_to_check.push_back(member_of_group);
    }

    botnet_remove_groups_remote_bot_dont_have_access_to(quoted_groups_to_check,new_groups,bot,debug);

    new_groups.insert(new_groups.end(),orig_groups.begin(),orig_groups.end());

    vector<string>::iterator i2;

    sort(new_groups.begin(),new_groups.end());
    i2=unique(new_groups.begin(),new_groups.end());
    new_groups.erase(i2,new_groups.end());

    list<string> new_member_of_group;

    if(!its_function) {
        for(i2=new_groups.begin(); i2!=new_groups.end(); ++i2)
            new_member_of_group.push_back(((string)"member_of_group ")+"\""+(*i2)+"\"");
    } else {
        for(i2=new_groups.begin(); i2!=new_groups.end(); ++i2)
            new_member_of_group.push_back(((string)"#member_of_group ")+"\""+(*i2)+"\"");
    }

    lines.insert(lines.begin(),new_member_of_group.begin(),new_member_of_group.end());
}

