/***************************************************************************
                          c_replication.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_replication.h,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_replication'
    \version $Id: c_replication.h,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $
*/

#ifndef C_REPLICATION_H__
#define C_REPLICATION_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Stores replication list
    \author VooDooMan
    \version 1
    \date 2004
*/
class c_replication
{
public:
    string partner;                                 //!< Name of replication partner
/*!
    \def REPL_INVALID
    \brief Invalid replication parameter/mode
*/
#define REPL_INVALID    0
/*!
    \def REPL_PUSH
    \brief Push replication
*/
#define REPL_PUSH       1
/*!
    \def REPL_PULL
    \brief Pull replication
*/
#define REPL_PULL       2
/*!
    \def REPL_PUSHPULL
    \brief Push/pull replication
*/
#define REPL_PUSHPULL   3

    int type;                                       //!< Type of replication

    c_replication();

    MY_FORCE_INLINE friend bool operator==(const c_replication& left, const c_replication& right)
    {
        return left.type==right.type && !left.partner.compare(right.partner);
    }

    MY_FORCE_INLINE friend bool operator<(const c_replication& left, const c_replication& right)
    {
        if(left.type!=right.type)
            return left.type<right.type;
        return (left.partner.compare(right.partner)) < 0;
    }
};

#endif

